/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

/*
	This is a compiled version of Dojo, built for deployment and not for
	development. To get an editable version, please visit:

		http://dojotoolkit.org

	for documentation and information on getting the source.
*/

if(!dojo._hasResource['epages.template']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.template'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.template $Revision: 1.20 $

*/
dojo.provide('epages.template');




$TMPL = /*epages.Template*/function (/*string*/template,/*hash*/ vars, /*boolean?*/ encodeVars, /*boolean?*/ enableRegExVars) {
	if(encodeVars === undefined){
		encodeVars=true;
	}
	if(enableRegExVars === undefined){	// default reg ex vars are allowed
		enableRegExVars=true;
	}

	return new epages.Template({
		template: template,
		vars: vars,
		encodeVars: encodeVars,
		enableRegExVars : enableRegExVars
	});
};

epages.Template = function(options) {
	this.setOptions(options);

	// get Template from DOM
	if (this.options.template === undefined && this.options.templateDom != undefined) {
		if (typeof this.options.templateDom != 'object'){
			this.options.templateDom = $(this.options.templateDom);
		}
		this.options.template = $E(this.options.templateDom).firstComment();
	}
};

epages.Template.prototype = {
	options : undefined,

	setOptions: function(options) {
		this.options = {
			encodeVars  : true,
			enableRegExVars: false,
			templateDom : undefined,
			template    : undefined,
			vars        : undefined,
			addTemplate : true
		};
		dojo.mixin(this.options, options);
	},

	setTemplate: function (template) {
		this.options.template = template;
	},

	encodeXml: function(string) {
		if (string !== undefined) {
			if (typeof string == "number"){
				string = string.toString();
			}
			string = string
				.replace(/&/g,"&amp;")     // qoute &
				.replace(/"/g,"&quot;")    // qoute "
				.replace(/>/g,"&gt;")      // qoute >
				.replace(/</g,"&lt;");     // qoute <
		}
		return string;
	},

	maskRegExVars: function(string) {
		if (string !== undefined) {
			if (typeof string == "number"){
				string = string.toString();
			}
			if (typeof string == "string"){
				string = string.replace(/\$/g, "\\$");     // mask $
			}
		}
		return string;
	},

	unmaskRegExVars: function(string) {
		if (string !== undefined) {
			if (typeof string == "number"){
				string = string.toString();
			}
			if (typeof string == "string"){
				string = string.replace(/\\\$/g, "$");     // unmask $
			}
		}
		return string;
	},

	processHash: function(vars) {
		// declare some vars for iterator function
		if (vars.each === undefined){
			vars = $H(vars);
		}
		var template=this.options.template;
		if (template === undefined) {
			console.warn('epages.Template: template is empty');
			return '';
		}

		var me=this;
		// insert hash vars into template
		var iterator= function(pair) {
			var tempValue = pair.value;
			var encValue = me.options.encodeVars ? me.encodeXml(tempValue) : tempValue;
			// insert string
			encValue = me.options.enableRegExVars ? encValue : me.maskRegExVars(encValue);

			var templateRegExp = new RegExp('\\(%' + pair.key + '%\\)', "g" );
			template = template.replace( templateRegExp, encValue );
			template = me.options.enableRegExVars ? template : me.unmaskRegExVars(template);
		};
		// call iterator for each key/value pair
		vars.each(iterator);
		return template;
	},

	processLoop: function(loop) {
		var content = '';
		var me=this;
		loop.each(function (el) {
			content += me.processHash(el);
		});
		return content;
	},

	generateOutput: function () {
		return this.processHash(this.options.vars);
	},

	insertTemplate: function (element) {
		if (!this.options.addTemplate){
			return;
		}
		var comment = document.createElement("COMMENT");
		comment.data = this.options.template;
		// element.insertAdjacentElement("afterBegin",comment);
		if (element.firstChild === undefined){
			element.insertChild(comment);
		}else{
			element.insertBefore(comment, element.firstChild);
		}
		return;
	},

	insertLoop: function (loop, targetDom) {
		if (targetDom === undefined){
			targetDom = this.options.templateDom;
		}
		if (typeof this.options.targetDom != 'object'){
			targetDom = $(targetDom);
		}
		targetDom.innerHTML = this.processLoop(loop);
		this.insertTemplate(targetDom);
	},

	insert: function(targetDom) {
		if (targetDom === undefined){
			targetDom = this.options.templateDom;
		}
		if (typeof this.options.targetDom != 'object'){
			targetDom = $(targetDom);
		}
		targetDom.innerHTML = this.generateOutput();
		this.processTemplate(targetDom);
	}
};

}

if(!dojo._hasResource['epages.event.adjustonresize']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.event.adjustonresize'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.event.adjustonresize $Revision: 1.17 $

*/

dojo.provide('epages.event.adjustonresize');



epages.event.AdjustOnResize = function(/*DOMObject*/scrollbarElement, /* Object */ options) {
// summary: constructor for adjustonresize
// scrollbarElement  - dom node
// options 				   - object
// 		deltaWindowWidth  - integer or null
// 		deltaWindowHeight - integer or null
// 		callback 					- callback function

	// set element with scrollbar
	this.scrollbarElement=scrollbarElement;
	// set options
	this.setOptions(options);

	this.appendEvent();
};

epages.event.AdjustOnResize.prototype = {
	options						: undefined,
	scrollbarElement  : undefined,

	setOptions: function(/*Object*/ options) {
		if(this.options === undefined){
			this.options={
				deltaWindowHeight : undefined,
				deltaWindowWidth  : undefined,
				callback          : undefined,
				topicname         : 'AdjustOnResize'
			};
			}
		dojo.mixin(this.options, options);
		// update display
		this.resizeElement();

		dojo.addClass(document.getElementsByTagName("html")[0], "AdjustOnResize");
	},

	appendEvent: function() {
		// dojo.connect sometimes has problems with "onresize" on the window object
		// dojo.connect(window, 'onresize', epages.lang.hitch(this, function() { this.resizeElement()}));

		if(epages.Browser.engine=="MSIE"){          // MSIE version
			window.attachEvent('onresize', epages.lang.hitch(this, function() { this.resizeElement();}));
		} else {                                  // W3C version
			window.addEventListener("resize",epages.lang.hitch(this, function() { this.resizeElement();}),false);
		}
	},

	resizeElement: function() {
		var elementHeight = null;
		var elementWidth = null;

		//adjust height
		if(this.options.deltaWindowHeight != null) {
			var windowHeight = (window.innerHeight !== undefined) ? window.innerHeight : document.documentElement.clientHeight;  // height of the visible area in the window
			elementHeight=windowHeight-this.options.deltaWindowHeight;
			if(elementHeight>0) {
				if(this.options.lastElementHeight && this.options.lastElementHeight == elementHeight){
					return false;
				}
				this.options.lastElementHeight = elementHeight;
				this.scrollbarElement.style.height = elementHeight+'px';
			}
		}

		// adjust width
		if(this.options.deltaWindowWidth != null) {
			var windowWidth = (window.innerWidth !== undefined) ? window.innerWidth : document.documentElement.clientWidth;  // width of the visible area in the window
			elementWidth=windowWidth-this.options.deltaWindowWidth;
			if(elementWidth>0) {
				if(this.options.lastElementWidth && this.options.lastElementWidth == elementWidth){
					return false;
				}
				this.options.lastElementWidth = elementWidth;
				this.scrollbarElement.style.width = elementWidth+'px';
			}
		}
		dojo.publish(this.options.topicname+"/resize", [elementWidth, elementHeight]);

		if(this.options.callback !== undefined){
			if(typeof this.options.callback == 'function'){
				this.options.callback();
			}else{
				console.warn('option "callback" is not a function in epages.event.adjustonresize');
	}
}
	}
};

}

if(!dojo._hasResource["epages.cartridges.de_epages.presentation.widget.Sidebarcontroller"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.presentation.widget.Sidebarcontroller"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.presentation.widget.Sidebarcontroller $Revision: 1.17.8.1 $

*/
dojo.provide("epages.cartridges.de_epages.presentation.widget.Sidebarcontroller");





dojo.declare("epages.cartridges.de_epages.presentation.widget.Sidebarcontroller",
	[dijit._Widget, dijit._Container],
	{
		contentPane             : "",
		_contentScrollBarHandler: undefined,
		_sideBarPaddings				: undefined,

		startup:	function() {
			this.inherited("startup", arguments);
			// get contentPane DomeNode
			if(this.contentPane!= ""){
				this.contentPane=$(this.contentPane);
			}

			this._sideBarPaddings = new epages.lang.Hash();

			// register sidebars
			var children = this.getChildren();

			for(var	i=0,l=children.length; i<l; i++)	{
				if(children[i].declaredClass=="epages.cartridges.de_epages.presentation.widget.Sidebar") {
						dojo.subscribe(children[i].id + '/afterShowSidebar',	this, '_setPadding');
						dojo.subscribe(children[i].id + '/afterShowSidebar',	this, '_resizeMinHeight');
						dojo.subscribe(children[i].id + '/afterHideSidebar',	this, '_setPadding');
						dojo.subscribe(children[i].id + '/afterSetWidth', 		this, '_setPadding');
						if(children[i].isVisible){
							children[i].show(children[i].isOverlay,true);
						}
				}
			}
			dojo.subscribe('Sidebar/changeHeight', this, '_checkHeight' );
			//dojo.subscribe('contentPane/resize',   this, '_resizeHeight');

			dojo.subscribe('Sidebar/changeHeight', this, '_resizeMinHeight');
			this._resizeMinHeight(); // sadly this is needed for Fx3 and IE
		},

		enableScrollMode: function(/*Object*/ options){
			options['topicname']="contentPane";
			// add scrollbar handler
			if(this._contentScrollBarHandler === undefined) {
				this._contentScrollBarHandler = new epages.event.AdjustOnResize(this.contentPane, options);
				this.domNode.style.minHeight = "";
			} else {
				this._contentScrollBarHandler.setOptions(options);
			}

			// remove document scrollbar
			// document.getElementsByTagName("html")[0].style.overflow="hidden";
		},

		_setPadding: function(/*Widget*/ options)  {
			// this._sideBarPaddings.set(options.side, options.width);

			// set mainlayout padding
			if(options.side.toLowerCase()=="left" && isNaN(options.width)==false) {
				$('Content').style.marginLeft=options.width+"px";
			}

			// this block causes a missaligned content-container in safari
			// it was removed with EPG-25495
			/*if(options.side.toLowerCase()=="right" && isNaN(options.width)==false) {
				$('Content').style.marginRight=options.width+"px";
			}*/

			// if scroll mode is enabled -> change values of scrollbar handler
			//if(this._contentScrollBarHandler !== undefined) {
				// var deltaWindowWidth=0;
				// this._sideBarPaddings.each(function(pair){
					// deltaWindowWidth+=pair.value;
				// });

				// var pageWidthSpace = (epages.vars.Layout.pageWidthSpace) ? epages.vars.Layout.pageWidthSpace : 0;

				// this._contentScrollBarHandler.setOptions({
				//	deltaWindowWidth: deltaWindowWidth + pageWidthSpace
				// });
			// }
			epages.event.fire(window,'resize');
		},

		_resizeHeight: function(width, height) {
			this.domNode.style.height=height+"px";
		},

		_resizeMinHeight: function() {
			// var scNode = $("SidebarContent");
			// if(scNode) {
				// scNode.parentNode.style.visibility = "hidden";
			// } else {
				// console.warn('SidebarContent node not found in '+this.declaredClass);
			// }
			// minimize jitter of .PropertyContainer on recalc
			// if($("EmbeddedStorefront")) {
				// this.domNode.style.minHeight = "0";
			// }else {
				// this.domNode.style.minHeight = (($("RightSidebarTabs") || dojo.body()).offsetHeight + ($("TrialShopBox") ? $("TrialShopBox").offsetHeight : 0)) + "px";
			// }
			// setTimeout(function() {
				// var scNode = $("SidebarContent");
				// if(scNode) {
					// scNode.parentNode.style.visibility = "visible";
					// dojo.addClass(scNode, "Opacity90");
					// dojo.removeClass(scNode, "Opacity90");
				// } else {
					// console.warn('SidebarContent node not found in '+this.declaredClass);
				// }
			// }, 1);
			// minimize jitter of .PropertyContainer on recalc
		},

		_checkHeight: function(/* widget */ sidebar) {
		// check height of all sidebar content elements and set minheight
			var child = sidebar.containerNode.firstChild;
			var height = 0;
			while (child != null) {
				if(child.nodeType == 1 && child.offsetHeight){
					height += child.offsetHeight;
				}
				child = child.nextSibling;
			}
			//if(height != 0) this._setMinHeight(height);
			//this causes height problems with the left sidebar when the windows gets to slim (EPG-9594) - do we really need this?
		},

		_setMinHeight: function(/* integer */ height) {

		}

	});

}

if(!dojo._hasResource["epages.cartridges.de_epages.presentation.widget.Sidebar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.presentation.widget.Sidebar"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.presentation.widget.Sidebar $Revision: 1.22 $

*/

dojo.provide("epages.cartridges.de_epages.presentation.widget.Sidebar");




dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.Sidebar",
	[epages.widget.LocalizedWidget, dijit._Contained], {
		side              : "",
		width             : "",
		isVisible         : '',
		isOverlay         : false,
		title             : "",
		displayTitlebar   : true,
		minimizeOnHide    : false,
		url               : '?',
		userId            : '',
		pageTypeId        : '',

		WIDTH_OFFSET      : 1, // Integer; width offset (borders, margins, paddings)

		templateString:"<div class=\"Sidebar ${side}\">\n  <div class=\"MinimizeNode\"dojoAttachPoint=\"minimizeNode\">\n    <i class=\"Sprite ico_s_sidebar\" title=\"{DoShowSidebar}\"></i>\n  </div>\n  <div class=\"PropertyContainer\">\n    <div class=\"SidebarTitlebar\"\n         dojoAttachPoint=\"titlebarNode\">\n      <span class=\"SidebarTitle\" dojoAttachPoint=\"titleNode\">${title}</span>\n      <div class=\"CloseButton EnableHover\" dojoAttachPoint=\"closeButtonNode\" title=\"{DoHideSidebar}\"></div>\n    </div>\n    <div id=\"SidebarContent\" class=\"SidebarContent\" dojoAttachPoint=\"containerNode\"></div>\n  </div>\n</div>\n",
		translationName : dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', "templates/translation"),
		imagePath       :epages.themeUrl('images'),

		postCreate: function() {
			this.inherited("postCreate", arguments);

			this.isVisible=epages.string.toBoolean(this.isVisible);
			this.minimizeOnHide=epages.string.toBoolean(this.minimizeOnHide);
			this.displayTitlebar=epages.string.toBoolean(this.displayTitlebar);
			this.setTitlebar(this.displayTitlebar);

			// stretch to page length
			this.domNode.style.height="100%";
			this.setWidth(parseInt(this.width));
			this._appendEvents();
			if(this.minimizeOnHide) {
				dojo.addClass(this.domNode, "Minimize");
			} else {
				this.domNode.style.display="none";
			}
		},

		setTitlebar: function(displayTitlebar) {
			if(displayTitlebar) {
				dojo.addClass(this.domNode, "WithTitlebar");
				this.displayTitlebar=true;
			} else {
				dojo.removeClass(this.domNode, "WithTitlebar");
				this.displayTitlebar=false;
			}
		},

		_appendEvents: function() {
			this.connect(this.closeButtonNode, 'onclick', 'hide');
			this.connect(this.minimizeNode,    'onclick', 'showLastOverlayState');
		},

		setWidth: function(width) {
			if(isNaN(width)){
				console.warn('Attribute "width" is not a number in '+this.declaredClass+'. Couldn\'t calculate new width');
			}else {
				this.width=width;
				this.domNode.style.width=this.width+"px";

				if(!this.isOverlay && this.isVisible){
					dojo.publish(this.id+"/afterSetWidth", [{
						width    : this.width+this.WIDTH_OFFSET,
						side     : this.side
					}]);
				}
			}
		},

		setTitle: function(title) {
				this.title=title;
				this.titleNode.innerHTML=title;
		},

		sendShow: function () {
			if(this.userId != '') {
				var json = new epages.io.Json;
				var options = {
					'ViewAction':     'JSONViewResponse',
					'ChangeAction':   'Save',
					'ObjectID':       this.userId,
					'ShowSidebar':    this.isVisible ? 1 : 0
				};
				if (!this.isVisible && this.pageTypeId != '') {
					options.ChangeAction = 'SaveSidebar';
					options.PageTypeID = this.pageTypeId;
				}
				json.loadAsync(this.url, function (result) {},options);
			}
		},

		show: function(/*Boolean?*/ overlay, startUp) {
			this.isOverlay = (overlay==true) ? true : false;
			this.isVisible = true;
			// display changes
			this.domNode.style.display="";
			dojo.removeClass(this.domNode, "Minimize");
			if(!startUp){ 
				this.sendShow();
			}
			this._toggleOverlayDisplay();
			dojo.publish(this.id+"/afterShowSidebar", [{
				width    : (this.isOverlay) ? 0 : this.width+this.WIDTH_OFFSET,
				side     : this.side
			}]);
		},

		hide: function() {
			this.isVisible=false;
			if(this.minimizeOnHide) {
				dojo.addClass(this.domNode, "Minimize");
			} else {
				this.domNode.style.display="none";
			}
			this.sendShow();
			dojo.publish(this.id+"/afterShowSidebar", [{
				width    : 0,
				side     : this.side
			}]);
		},

		toggleView: function() {
			if(this.isVisible){
				this.hide();
			}else{
				this.show(this.isOverlay);
			}
		},

		_toggleOverlayDisplay: function() {
			this.domNode.style.height=(this.isOverlay) ? "auto" : "100%";
			if(this.isOverlay) {
				dojo.addClass(this.domNode,"Unpinned");
				dojo.removeClass(this.domNode,"Pinned");
			} else {
				dojo.addClass(this.domNode,"Pinned");
				dojo.removeClass(this.domNode,"Unpinned");
			}
		},

		showLastOverlayState: function() {
				this.show(this.isOverlay);
		}
	});

}

if(!dojo._hasResource["epages.cartridges.de_epages.presentation.widget.SidebarTabs"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.presentation.widget.SidebarTabs"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.presentation.widget.SidebarTabs $Revision: 1.18 $

*/
dojo.provide("epages.cartridges.de_epages.presentation.widget.SidebarTabs");




dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.SidebarTabs",
	[epages.widget.LocalizedWidget],
	{
		menu: '',
		forceHelp: '',
		url: '?',
		userId: '',
		pagetypeId: '',
		sideBarMenu: '',
		sideBarId: '',

		_sidebar: undefined,
		_tabs: undefined,
		_lastTab: undefined,
		_tabSelectedByClick: false,

		templateString:"<div class=\"SidebarTabs\">\n  <div class=\"Tabs\"  dojoAttachPoint=\"tabNode\">\n    <div class=\"CloseButton EnableHover\" style=\"display:none\" dojoAttachPoint=\"closeSidebarNode\" title=\"{DoHideSidebar}\"></div>\n  </div>\n  <div class=\"Block\" dojoAttachPoint=\"blockNode\"></div>\n</div>\n",
		translationName : dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', "templates/translation"),

		postMixInProperties: function() {
			this.inherited("postMixInProperties", arguments);
			this._tabs = [];
			this.forceHelp = epages.string.toBoolean(this.forceHelp);
			this._sidebar = $$(this.sideBarId);
		},

		postCreate  : function() {
			this.inherited("postCreate", arguments);
			// make a copy of childNodes
			var children = [];
			dojo.forEach(this.srcNodeRef.childNodes, function (el) { children.push(el); });

			var tab = true, cTab = -1, enableFirst = true;

			for( var i=0,l=children.length ; i<l ; i++ ) {
				var node = children[i];
				if (node.tagName == 'DIV') {
					if (tab) {
						cTab++;
						this.tabNode.appendChild(node);
						this._tabs[cTab] = { tab : node, menu : node.getAttribute('ep_menu')};
						this.connect(node,'click', '_clickTab');
						if ($$(this.sideBarMenu) && node.getAttribute('ep_menulabel')) {
							var caller = function (me, node) {
								return function () {
									me._clickTab({currentTarget:node});
									if(me._sidebar && !me._sidebar.isVisible){
										me._sidebar.show();
									}
								};
							};
							var menuItem  = new dijit.MenuItem({
								label: node.getAttribute('ep_menulabel'),
								onClick: caller(this, node)
							});
							$$(this.sideBarMenu).addChild(menuItem);
							if (node.getAttribute('ep_menuicon')){
								menuItem.iconNode.style.background = 'url('+node.getAttribute('ep_menuicon')+') no-repeat top left';
							}
						}
					} else {
						this._tabs[cTab].block = node;
						if(this.forceHelp && this._tabs[cTab].menu == 'help' ||
							 !this.forceHelp  && this.menu == this._tabs[cTab].menu
						) {
							this._selectTab(this._tabs[cTab].tab, node);
							enableFirst = false;
						} else {
							node.style.display = 'none';
						}
						this.blockNode.appendChild(node);
					}
					tab = !tab;
				}
			}
			if (enableFirst){
				this._selectTab(this._tabs[0].tab, this._tabs[0].block);
			}

			this.connect(window, "onbeforeunload", "_saveTab");
			if(this._sidebar !== undefined) {
				this.closeSidebarNode.style.display="";
				this.connect(this.closeSidebarNode, "onclick", "_closeSidebar");
			}
		},

		_closeSidebar: function() {
			if(this._sidebar){
				this._sidebar.hide();
			}
		},

		_clickTab: function (evt) {
			this._tabSelectedByClick=true;
			var tab = evt.currentTarget, block = undefined;
			for( var i=0,l=this._tabs.length ; i<l ; i++ )
				if (this._tabs[i].tab == tab){
					block = this._tabs[i].block;
				}
			this._selectTab(tab, block);
		},

		_selectTab: function(/* domnode */ tab, /* domnode */ block) {
			if(this._lastTab !== undefined && tab !== this._lastTab.tab) {
				// hide last selected
				dojo.removeClass(this._lastTab.tab, "Selected");
				if(this._lastTab.tab.children.length){
					var iconNode = this._lastTab.tab.children[0];
					if(dojo.attr(iconNode,'data-active-icon') && dojo.attr(iconNode,'data-icon')){
						dojo.removeClass(iconNode,dojo.attr(iconNode,'data-active-icon'));
						dojo.addClass(iconNode,dojo.attr(iconNode,'data-icon'));
					}
				}
				this._lastTab.block.style.display = 'none';
			}
			// show new selected
			if(tab.children.length){
				var iconNode = tab.children[0];
				if(dojo.attr(iconNode,'data-active-icon') && dojo.attr(iconNode,'data-icon')){
					dojo.addClass(iconNode,dojo.attr(iconNode,'data-active-icon'));
					dojo.removeClass(iconNode,dojo.attr(iconNode,'data-icon'));
				}
			}
			dojo.addClass(tab, "Selected");

			block.style.display = '';
			this._lastTab= {
				tab: tab,
				block: block,
				menu : tab.getAttribute('ep_menu')
			};

			var _this=this;
			window.setTimeout(function() {
				dojo.publish('Sidebar/changeHeight', [$$(_this.sideBarId)]);	// sidebarcontroller subscribes
			}, 10); // need a short time to display inital tab
			dojo.publish('Sidebar/selectTab',[this._lastTab]);
		},

		_saveTab: function() {
			if(this.userId != '' && this._lastTab !== undefined && this._tabSelectedByClick) {
				var json = new epages.io.Json;
				json.loadSync(this.url, {
					'ViewAction':     'JSONViewResponse',
					'ChangeAction':   'SaveSidebar',
					'ObjectID':       this.userId,
					'PageTypeID':     this.pagetypeId,
					'SidebarMenuName': this._lastTab.menu
				});
			}
		},
		selectTab: function(/*ep_menu string*/ ep_menu){
			var tab = undefined;
			var block = undefined;
			for( var i=0,iLength=this._tabs.length ; i<iLength ; i++ ){
				if(this._tabs[i].menu == ep_menu){
					tab = this._tabs[i].tab;
					block = this._tabs[i].block;
				}
			}
			if(tab != undefined){
				this._selectTab(tab, block);
				if(this._sidebar !== undefined){
					this._sidebar.show();
				}
			}
		},


		currentTab: function(){
			if(this._lastTab !== undefined){
				return this._lastTab;
			}
			return false;
		}
});


}

if(!dojo._hasResource["epages.cartridges.de_epages.presentation.widget.Tray"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.presentation.widget.Tray"] = true;
/*
	Copyright (c) 2006-2008, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.presentation.widget.Tray $Revision: 1.9 $

*/
dojo.provide("epages.cartridges.de_epages.presentation.widget.Tray");






dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.Tray",
	[epages.widget.LocalizedWidget],
	{
		objectId          : '',
		url               : '?',
		sidebarTabsId     : 'RightSidebarTabs',
		sidebarId         : 'RightSidebar',

		_groups           : undefined,
		_addObject        : undefined,
		_sidebarTabs      : undefined,
		_sidebar          : undefined,

		templateString:"<div class=\"Tray\">\n  <h4>{Tray}</h4>\n  <ul class=\"List\" dojoAttachPoint=\"containerNode\"></ul>\n  <div class=\"MessageItem\" dojoAttachPoint=\"emptyNode\" style=\"display:none;\">{TrayEmpty}</div>\n  <div dojoAttachPoint=\"addNode\" style=\"display:none;\">\n    <hr />\n    <ul class=\"List\">\n      <li>\n        <div class=\"Item ElementAddToTray ClickCursor\" dojoAttachEvent=\"onclick:_addToTray\">\n          <i class=\"Sprite ico_s_tray_addto\" title=\"{ElementAddToTray}\"></i>\n          <a dojoAttachPoint=\"addNodeTitle\" title=\"{ElementAddToTray}\"></a>\n        </div>\n      </li>\n    <ul>\n  </div>\n  <div dojoAttachPoint=\"existsNode\" style=\"display:none;\">\n    <hr />\n    <ul class=\"List\">\n      <li>\n        <div class=\"Item\">\n          <i class=\"Sprite ico_s_tray\" title=\"{ElementExistsInTray}\"></i>\n          <span dojoAttachPoint=\"existsNodeTitle\" title=\"{ElementExistsInTray}\"></span>\n        </div>\n      </li>\n    <ul>\n  </div>\n  <div dojoAttachPoint=\"deleteTrayNode\">\n    <hr />\n    <ul class=\"List\">\n      <li>\n        <div class=\"Item ClickCursor\" dojoAttachEvent=\"onclick:_deleteTray\">\n          <i class=\"Sprite ico_s_delete\"></i>\n          <a>{DeleteTray}</a>\n        </div>\n      </li>\n    </ul>\n  </div>\n  <div dojoAttachPoint=\"itemNode\" style=\"display:none;\">\n    <li>\n      <div class=\"Item\">\n        <span class=\"ItemTitle FloatLeft\" title=\"\"></span>\n        <i class=\"ItemDeleteNode FloatRight ClickCursor Sprite ico_s_remove\" title=\"{RemoveTrayGroup}\"></i>\n        <div class=\"ClearBoth\"></div>\n      </div>\n    </li>\n  </div>\n  <hr />\n</div>\n",
		imagePath       : epages.themeUrl('images'),
		translationName : dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', 'templates/translation'),

		postCreate  : function() {
			this.inherited("postCreate", arguments);
			dojo.subscribe('Sidebar/selectTab', this, '_onTabSelect');
			if($$(this.sidebarId)){
				this._sidebar = $$(this.sidebarId);
			}
			if($$(this.sidebarTabsId)){
				this._sidebarTabs = $$(this.sidebarTabsId);
				var tab = this._sidebarTabs.currentTab();
				//check if tab is selected and sidebar is visible before loading
				if(tab && this._sidebar.isVisible){
					this._onTabSelect(tab);
				}
			}else{
				this._loadTray();
				this._updateLayout();
			}
		},

		_onTabSelect:function(tab){
			if(tab && tab.menu == 'tray' && this._groups == undefined){
				this._loadTray();
				this._updateLayout();
			}
		},

		_loadTray: function(){
			var currentTray = this._sendRequest('JSONGetTray');
			if(currentTray){
				this._groups = currentTray.data;
				this._groups.sort(function(a, b) {
					if (a.Name < b.Name){
						return -1;
					}
					if (a.Name > b.Name){ 
						return  1;
					}
					return 0; 
				});
				this.containerNode.innerHTML = '';
				for( var i=0,iLength=this._groups.length ; i<iLength ; i++ ){
					var item = this.itemNode.cloneNode(true);
					item.style.display = '';
					var titleNode = epages.html.getElementsByClassName('ItemTitle',item)[0];
					titleNode.innerHTML = epages.format.slice(this._groups[i].Name,30)+" ("+this._groups[i].CountElements+")";
					titleNode.title = this._groups[i].Name;
					var deleteNode = epages.html.getElementsByClassName('ItemDeleteNode',item)[0];
					this.connect(deleteNode, 'onclick', 'deleteItem');
					this._groups[i].itemNode = item;
					this._groups[i].deleteNode = deleteNode;
					this.containerNode.appendChild(item);
				}
			}
		},

		_updateLayout: function(){
			if(this._groups.length == 0){
				this.emptyNode.style.display = '';
				this.deleteTrayNode.style.display = 'none';
				this.containerNode.style.display = 'none';
			}
			else{
				this.emptyNode.style.display = 'none';
				this.deleteTrayNode.style.display = '';
				this.containerNode.style.display = '';
			}
			if(this._addObject){
				this.showAddToTray(this._addObject);
			}
			else{
				this.existsNode.style.display = 'none';
				this.addNode.style.display = 'none';
			}
		},

		showAddToTray: function(addObject){
			this._addObject = addObject;
			if(this._groups){
				var exists = false;
				for( var i=0,iLength=this._groups.length ; i<iLength ; i++ ){
					for( var j=0,jLength=this._groups[i].Objects.length ; j<jLength ; j++ ){
						if(this._groups[i].Objects[j].ObjectID == addObject.objectId){
							exists = true;
						}
					}
				}
				if(exists){
					this.existsNode.style.display = '';
					this.existsNodeTitle.innerHTML = addObject.name;
					this.addNode.style.display = 'none';
				}
				else{
					this.addNode.style.display = '';
					this.addNodeTitle.innerHTML = addObject.name;
					this.existsNode.style.display = 'none';
				}
			}
		},

		deleteItem: function(evt){
			originalTarget = evt.originalTarget || evt.srcElement;
			var group = undefined;
			var index = undefined;
			for( var i=0,iLength=this._groups.length ; i<iLength ; i++ ){
				if(this._groups[i].deleteNode == originalTarget){
					group = this._groups[i];
					index = i;
				}
			}
			if(group){
				if(this._sendRequest('DeleteTrayGroup',{TrayGroupID:group.TrayGroupID})){
					this.containerNode.removeChild(group.itemNode);
					$A(this._groups).remove(index);
					this._updateLayout();
				}
			}
		},

		_deleteTray: function(){
			if(this._sendRequest('DeleteTray')){
				this._groups = [];
				this.containerNode.innerHTML = "";
				this._updateLayout();
			}
		},

		_sendRequest: function(changeAction,opt){
			var json = new epages.io.Json;
				var options = {
					'ViewAction':     'JSONViewResponse',
					'ChangeAction':   changeAction,
					'ObjectID':       this.objectId
				};
				if(opt){
					dojo.mixin(options,opt);
				}
				var result = json.loadSync(this.url,options);
				if(result.error){
					return false;
				}
				return result;
		},

		_addToTray: function(){
			if(this._addObject){
				if(this._sendRequest('AddListToTray',{ListObjectID:this._addObject.objectId})){
					var groupexists = false;
					for( var i=0,iLength=this._groups.length ; i<iLength ; i++ ){
						if(this._groups[i].Name == this._addObject.className){
							groupexists = true;
							this._groups[i].Objects.push({
								Alias: this._addObject.alias,
								Name: this._addObject.name,
								ObjectID: this._addObject.objectId
							});
							this._groups[i].CountElements++;
							var item = this._groups[i].itemNode;
							var titleNode = epages.html.getElementsByClassName('ItemTitle',item)[0];
							titleNode.innerHTML = this._groups[i].Name+" ("+this._groups[i].CountElements+")";
						}
					}
					if(!groupexists){
						this._loadTray();
					}
					this._updateLayout();
				}
			}
		}
});


}

if(!dojo._hasResource["epages.cartridges.de_epages.presentation.widget.Favorites"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.presentation.widget.Favorites"] = true;
/*
	Copyright (c) 2006-2008, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.presentation.widget.Favorites $Revision: 1.10 $

*/
dojo.provide("epages.cartridges.de_epages.presentation.widget.Favorites");






dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.Favorites",
	[epages.widget.LocalizedWidget],
	{
		objectId          : '',
		url               : '?',
		sidebarTabsId     : 'RightSidebarTabs',
		sidebarId         : 'RightSidebar',
		currentName       : '',
		currentURI        : '',

		_favorites        : undefined,
		_sidebarTabs      : undefined,
		_sidebar          : undefined,

		templateString:"<div class=\"Favorites\">\n  <h4>{Favorites}</h4>\n  <div class=\"MessageItem\" dojoAttachPoint=\"emptyNode\" style=\"display:none;\">{FavoritesEmpty}</div>\n  <div dojoAttachPoint=\"addNode\" style=\"display:none;\">\n    <ul class=\"List\">\n      <li>\n        <div class=\"Item ElementAddToTray ClickCursor\" dojoAttachEvent=\"onclick:_onClickAddNode\">\n          <i class=\"Sprite ico_s_favorite_add\" title=\"{ElementAddToFavorites}\"></i>\n          <a dojoAttachPoint=\"addNodeTitle\">{ElementAddToFavorites}</a>\n        </div>\n      </li>\n    </ul>\n    <hr/>\n  </div>\n  <div dojoAttachPoint=\"existsNode\" style=\"display:none;\">\n    <ul class=\"List\">\n      <li>\n        <div class=\"Item\">\n          <span dojoAttachPoint=\"existsNodeTitle\" title=\"{ElementExistsInFavorites}\"></span>\n        </div>\n      </li>\n    <ul>\n    <hr />\n  </div>\n  <ul class=\"List\" dojoAttachPoint=\"containerNode\"></ul>\n  <div dojoAttachPoint=\"deleteNode\">\n    <hr />\n    <ul class=\"List\">\n      <li>\n        <div class=\"Item ClickCursor\" dojoAttachEvent=\"onclick:_deleteFavorites\">\n          <i class=\"Sprite ico_s_delete\"></i>\n          <a>{DeleteAllFavorites}</a>\n        </div>\n      </li>\n    </ul>\n  </div>\n  <div dojoAttachPoint=\"itemNode\" style=\"display:none;\">\n    <li>\n      <div class=\"Item\">\n        <a class=\"ItemLink FloatLeft\" href=\"\" title=\"\"></a>\n        <i class=\"ItemDeleteNode FloatRight ClickCursor Sprite ico_s_remove\" title=\"{DeleteFavorite}\"></i>\n        <div class=\"ClearBoth\"></div>\n      </div>\n    </li>\n  </div>\n</div>\n",
		imagePath       : epages.themeUrl('images'),
		translationName : dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', 'templates/translation'),

		postCreate  : function() {
			this.inherited("postCreate", arguments);
			dojo.subscribe('Sidebar/selectTab', this, '_onTabSelect');
			if($$(this.sidebarId)){
				this._sidebar = $$(this.sidebarId);
			}
			if($$(this.sidebarTabsId)){
				this._sidebarTabs = $$(this.sidebarTabsId);
				var tab = this._sidebarTabs.currentTab();
				//check if tab is selected and sidebar is visible before loading
				if(tab && this._sidebar.isVisible){
					this._onTabSelect(tab);
				}
			}else{
				this._loadFavorites();
				this._updateLayout();
			}
		},

		_onTabSelect:function(tab){
			if(tab && tab.menu == 'favorites' && this._favorites == undefined){
				this._loadFavorites();
				this._updateLayout();
			}
		},

		_loadFavorites: function(){
			var currentFavorites = this._sendRequest('JSONGetFavorites');
			if(currentFavorites){
				this._favorites = currentFavorites.data;
				this._favorites.sort(function(a, b) {
					if (a.Name < b.Name){
						return -1;
					}
					if (a.Name > b.Name){
						return  1;
					}
					return 0; 
				});
				this.containerNode.innerHTML = '';
				for( var i=0,iLength=this._favorites.length ; i<iLength ; i++ ){
					var item = this.itemNode.cloneNode(true);
					item.style.display = '';
					var linkNode = epages.html.getElementsByClassName('ItemLink',item)[0];
					linkNode.innerHTML += epages.format.scrunch(this._favorites[i].Name,30,0.4);
					linkNode.title = this._favorites[i].Name;
					linkNode.href = this._favorites[i].URI;
					var deleteNode = epages.html.getElementsByClassName('ItemDeleteNode',item)[0];
					this.connect(deleteNode, 'onclick', 'deleteItem');
					this._favorites[i].itemNode = item;
					this._favorites[i].deleteNode = deleteNode;
					this.containerNode.appendChild(item);
				}
			}
		},

		_updateLayout: function(){
			if(this._favorites.length == 0){
				this.emptyNode.style.display = '';
				this.deleteNode.style.display = 'none';
				this.containerNode.style.display = 'none';
			}
			else{
				this.emptyNode.style.display = 'none';
				this.deleteNode.style.display = '';
				this.containerNode.style.display = '';
			}
			this.showAddToFavorites();
		},

		showAddToFavorites: function(){
			if(this._favorites){
				var exists = false;
				var existName="";
				for( var i=0,iLength=this._favorites.length ; i<iLength ; i++ ){
						if(this._favorites[i].Name == this.currentName){
							exists = true;
							existsName = this._favorites[i].Name;
					}
				}
				if(exists){
					this.existsNode.style.display = '';
					this.existsNodeTitle.innerHTML = epages.format.scrunch(existsName,30,0.4);
					this.addNode.style.display = 'none';
				}
				else{
					this.addNode.style.display = '';
					this.addNodeTitle.title = this.currentName;
					this.existsNode.style.display = 'none';
				}
			}
		},

		deleteItem: function(evt){
			originalTarget = evt.originalTarget || evt.srcElement;
			var favorite = undefined;
			var index = undefined;
			for( var i=0,iLength=this._favorites.length ; i<iLength ; i++ ){
				if(this._favorites[i].deleteNode == originalTarget){
					favorite = this._favorites[i];
					index = i;
				}
			}
			if(favorite){
				if(this._sendRequest('RemoveFavorite',{EventFavoriteID:favorite.EventFavoriteID})){
					this.containerNode.removeChild(favorite.itemNode);
					$A(this._favorites).remove(index);
					this._updateLayout();
				}
			}
		},

		_deleteFavorites: function(){
			if(this._sendRequest('DeleteFavorites')){
				this._favorites = [];
				this.containerNode.innerHTML = "";
				this._updateLayout();
			}
		},

		_sendRequest: function(changeAction,opt){
			var json = new epages.io.Json;
				var options = {
					'ViewAction':     'JSONViewResponse',
					'ChangeAction':   changeAction,
					'ObjectID':       this.objectId
				};
				if(opt){
					dojo.mixin(options,opt);
				}
				var result = json.loadSync(this.url,options);
				if(result.error){
					return false;
				}
				return result;
		},

		_addToFavorites:function(obj){
			var item = this.itemNode.cloneNode(true);
				item.style.display = '';
				var linkNode = epages.html.getElementsByClassName('ItemLink',item)[0];
				linkNode.innerHTML += epages.format.scrunch(obj.Name,30,0.4);
				linkNode.title = obj.Name;
				linkNode.href = obj.URI;
				var deleteNode = epages.html.getElementsByClassName('ItemDeleteNode',item)[0];
				this.connect(deleteNode, 'onclick', 'deleteItem');
				this.containerNode.appendChild(item);
				this._favorites.push({
					URI: obj.URI,
					Name: obj.Name,
					ObjectID: this.objectId,
					EventFavoriteID: obj.EventFavoriteID,
					itemNode: item,
					deleteNode: deleteNode
				});
				this._updateLayout();
		},

		_onClickAddNode: function(){
			var favoriteId = this._sendRequest('JSONAddFavorite',{URI: this.currentURI,Name: this.currentName});
			if(favoriteId != false){
				this._addToFavorites({
					URI  : this.currentURI,
					Name : this.currentName,
					EventFavoriteID : favoriteId.data.EventFavoriteID
				});
			}
		},

		addHistoryToFavorites: function(obj){
			var exists = false;
			if(this._favorites){
				for( var i=0,iLength=this._favorites.length ; i<iLength ; i++ ){
					if(this._favorites[i].URI == obj.URI){ 
						exists = true;
					}
				}
			}
			if(exists == false){
				var favoriteId = this._sendRequest('JSONAddFavorite',{URI: obj.URI,Name: obj.Name});
				if(favoriteId != false){
					if(this._favorites){
						this._addToFavorites({
							URI  : obj.URI,
							Name : obj.Name,
							EventFavoriteID : favoriteId.data.EventFavoriteID
						});
					}
					return true;
				}
			}
			return false;
		}
});


}

if(!dojo._hasResource["dojox.fx._base"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.fx._base"] = true;
dojo.provide("dojox.fx._base");
// summary: Experimental and extended Animations beyond Dojo Core / Base functionality. 
//	Provides advanced Lines, Animations, and convenience aliases.
 

dojo.mixin(dojox.fx, {

	// anim: Function
	//	Alias of `dojo.anim` - the shorthand `dojo.animateProperty` with auto-play
	anim: dojo.anim,

	// animateProperty: Function
	//	Alias of `dojo.animateProperty` - animate any CSS property
	animateProperty: dojo.animateProperty,

	// fadeTo: Function 
	//		Fade an element from an opacity to an opacity.
	//		Omit `start:` property to detect. `end:` property is required.
	//		Ultimately an alias to `dojo._fade`
	fadeTo: dojo._fade,

	// fadeIn: Function
	//	Alias of `dojo.fadeIn` - Fade a node in.
	fadeIn: dojo.fadeIn,
	
	// fadeOut: Function
	//	Alias of `dojo.fadeOut` - Fades a node out.
	fadeOut: dojo.fadeOut,

	// combine: Function
	//	Alias of `dojo.fx.combine` - Run an array of animations in parallel
	combine: dojo.fx.combine,

	// chain: Function
	//	Alias of `dojo.fx.chain` - Run an array of animations in sequence
	chain: dojo.fx.chain,

	// slideTo: Function
	//	Alias of `dojo.fx.slideTo` - Slide a node to a defined top/left coordinate
	slideTo: dojo.fx.slideTo,

	// wipeIn: Function
	//	Alias of `dojo.fx.wipeIn` - Wipe a node to visible
	wipeIn: dojo.fx.wipeIn,

	// wipeOut: Function
	//	Alias of `dojo.fx.wipeOut` - Wipe a node to non-visible
	wipeOut: dojo.fx.wipeOut

});

dojox.fx.sizeTo = function(/* Object */args){
	// summary: 
	//		Creates an animation that will size a node
	//
	// description:
	//		Returns an animation that will size the target node
	//		defined in args Object about it's center to
	//		a width and height defined by (args.width, args.height), 
	//		supporting an optional method: chain||combine mixin
	//		(defaults to chain).	
	//
	//	- works best on absolutely or relatively positioned elements
	//	
	// example:
	//	|	// size #myNode to 400px x 200px over 1 second
	//	|	dojo.fx.sizeTo({
	//	|		node:'myNode',
	//	|		duration: 1000,
	//	|		width: 400,
	//	|		height: 200,
	//	|		method: "combine"
	//	|	}).play();
	//

	var node = args.node = dojo.byId(args.node),
		abs = "absolute";

	var method = args.method || "chain"; 
	if(!args.duration){ args.duration = 500; } // default duration needed
	if(method == "chain"){ args.duration = Math.floor(args.duration / 2); } 
	
	var top, newTop, left, newLeft, width, height = null;

	var init = (function(n){
		return function(){
			var cs = dojo.getComputedStyle(n),
				pos = cs.position,
				w = cs.width,
				h = cs.height
			;
			
			top = (pos == abs ? n.offsetTop : parseInt(cs.top) || 0);
			left = (pos == abs ? n.offsetLeft : parseInt(cs.left) || 0);
			width = (w == "auto" ? 0 : parseInt(w));
			height = (h == "auto" ? 0 : parseInt(h));
			
			newLeft = left - Math.floor((args.width - width) / 2); 
			newTop = top - Math.floor((args.height - height) / 2); 

			if(pos != abs && pos != 'relative'){
				var ret = dojo.coords(n, true);
				top = ret.y;
				left = ret.x;
				n.style.position = abs;
				n.style.top = top + "px";
				n.style.left = left + "px";
			}
		}
	})(node);

	var anim1 = dojo.animateProperty(dojo.mixin({
		properties: {
			height: function(){
				init();
				return { end: args.height || 0, start: height };
			},
			top: function(){
				return { start: top, end: newTop };
			}
		}
	}, args));
	var anim2 = dojo.animateProperty(dojo.mixin({
		properties: {
			width: function(){
				return { start: width, end: args.width || 0 }
			},
			left: function(){
				return { start: left, end: newLeft }
			}
		}
	}, args));

	var anim = dojo.fx[(args.method == "combine" ? "combine" : "chain")]([anim1, anim2]);
	return anim; // dojo.Animation

};

dojox.fx.slideBy = function(/* Object */args){
	// summary: 
	//		Returns an animation to slide a node by a defined offset.
	//
	// description:
	//		Returns an animation that will slide a node (args.node) from it's
	//		current position to it's current posision plus the numbers defined
	//		in args.top and args.left. standard dojo.fx mixin's apply. 
	//	
	// example:
	//	|	// slide domNode 50px down, and 22px left
	//	|	dojox.fx.slideBy({ 
	//	|		node: domNode, duration:400, 
	//	|		top: 50, left: -22 
	//	|	}).play();

	var node = args.node = dojo.byId(args.node),
		top, left;

	var init = (function(n){
		return function(){
			var cs = dojo.getComputedStyle(n);
			var pos = cs.position;
			top = (pos == 'absolute' ? n.offsetTop : parseInt(cs.top) || 0);
			left = (pos == 'absolute' ? n.offsetLeft : parseInt(cs.left) || 0);
			if(pos != 'absolute' && pos != 'relative'){
				var ret = dojo.coords(n, true);
				top = ret.y;
				left = ret.x;
				n.style.position = "absolute";
				n.style.top = top + "px";
				n.style.left = left + "px";
			}
		}
	})(node);
	init();
	
	var _anim = dojo.animateProperty(dojo.mixin({
		properties: {
			// FIXME: is there a way to update the _Line after creation?
			// null start values allow chaining to work, animateProperty will
			// determine them for us (except in ie6? -- ugh)
			top: top + (args.top || 0),
			left: left + (args.left || 0) 
		}
	}, args));
	dojo.connect(_anim, "beforeBegin", _anim, init);
	return _anim; // dojo.Animation
};

dojox.fx.crossFade = function(/* Object */args){
	// summary: 
	//		Returns an animation cross fading two element simultaneously
	// 
	// args:
	//	args.nodes: Array - two element array of domNodes, or id's
	//
	//	all other standard animation args mixins apply. args.node ignored.
	//

	// simple check for which node is visible, maybe too simple?
	var node1 = args.nodes[0] = dojo.byId(args.nodes[0]),
		op1 = dojo.style(node1,"opacity"),
		node2 = args.nodes[1] = dojo.byId(args.nodes[1]),
		op2 = dojo.style(node2, "opacity")
	;
	
	var _anim = dojo.fx.combine([
		dojo[(op1 == 0 ? "fadeIn" : "fadeOut")](dojo.mixin({
			node: node1
		},args)),
		dojo[(op1 == 0 ? "fadeOut" : "fadeIn")](dojo.mixin({
			node: node2
		},args))
	]);
	return _anim; // dojo.Animation
};

dojox.fx.highlight = function(/*Object*/ args){
	// summary: 
	//		Highlight a node
	//
	// description:
	//		Returns an animation that sets the node background to args.color
	//		then gradually fades back the original node background color
	//	
	// example:
	//	|	dojox.fx.highlight({ node:"foo" }).play(); 

	var node = args.node = dojo.byId(args.node);

	args.duration = args.duration || 400;
	
	// Assign default color light yellow
	var startColor = args.color || '#ffff99',
		endColor = dojo.style(node, "backgroundColor")
	;

	// safari "fix"
	// safari reports rgba(0, 0, 0, 0) (black) as transparent color, while
	// other browsers return "transparent", rendered as white by default by
	// dojo.Color; now dojo.Color maps "transparent" to
	// djConfig.transparentColor ([r, g, b]), if present; so we can use
	// the color behind the effect node
	if(endColor == "rgba(0, 0, 0, 0)"){
		endColor = "transparent";
	}

	var anim = dojo.animateProperty(dojo.mixin({
		properties: {
			backgroundColor: { start: startColor, end: endColor }
		}
	}, args));

	if(endColor == "transparent"){
		dojo.connect(anim, "onEnd", anim, function(){
			node.style.backgroundColor = endColor;
		});
	}

	return anim; // dojo.Animation
};

 
dojox.fx.wipeTo = function(/*Object*/ args){
	// summary:
	//		Animate a node wiping to a specific width or height
	//	
	// description:
	//		Returns an animation that will expand the
	//		node defined in 'args' object from it's current to
	//		the height or width value given by the args object.
	//
	//		default to height:, so leave height null and specify width:
	//		to wipeTo a width. note: this may be deprecated by a 
	//
	//		Note that the final value should not include
	//		units and should be an integer.  Thus a valid args object
	//		would look something like this:
	//
	//		|	dojox.fx.wipeTo({ node: "nodeId", height: 200 }).play();
	//
	//		Node must have no margin/border/padding, so put another
	//		node inside your target node for additional styling.

	args.node = dojo.byId(args.node);
	var node = args.node, s = node.style;

	var dir = (args.width ? "width" : "height"),
		endVal = args[dir],
		props = {}
	;

	props[dir] = {
		// wrapped in functions so we wait till the last second to query (in case value has changed)
		start: function(){
			// start at current [computed] height, but use 1px rather than 0
			// because 0 causes IE to display the whole panel
			s.overflow = "hidden";
			if(s.visibility == "hidden" || s.display == "none"){
				s[dir] = "1px";
				s.display = "";
				s.visibility = "";
				return 1;
			}else{
				var now = dojo.style(node,dir);
				return Math.max(now, 1);
			}
		},
		end: endVal
	};

	var anim = dojo.animateProperty(dojo.mixin({ properties: props }, args));
	return anim; // dojo.Animation
};

}

if(!dojo._hasResource["dojox.fx"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.fx"] = true;
dojo.provide("dojox.fx");

 

}

if(!dojo._hasResource["epages.cartridges.de_epages.presentation.SearchBar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.presentation.SearchBar"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.presentation.widget.searchbar $Revision: 1.42 $

*/


dojo.provide("epages.cartridges.de_epages.presentation.SearchBar");






(function(){

var replMap = {
		'<':	'&lt;',
		'>':	'&gt;',
		'"':	'&quot;',
		"'":	"\&#039;"
	},
	htmlEscape = function( value ){
		return (value+'').replace( /(<|>|"|')/g, function( all, $1 ){
			return replMap[ $1 ];
		});
	};

epages.cartridges.de_epages.presentation.SearchBar = {

	_ELEMENT_DOJOTYPE: " dojoType='epages.widget.FormElement' ",				// FormElement widget dojotype attribute
	_SEARCH_INPUT_PREFIX: "searchInput_",																// prefix on which all inputs ids are extended on
	_SEARCHBAR_ANI_DURATION: 350,																				// default animation duration / delay

	_STORAGE_ID: "Presentation::SearchBar.Status",	// namespace of this module inside of epages.Storage
	_STORAGE_EXTENDED_KEYWORD: "max",															// value for the extended SearchBar stored in epages.Storage
	_STORAGE_MINIMIZED_KEYWORD: "min",														// value for the minimized SearchBar stored in epages.Storage

	searchBarContainer: null,																						// parent node of the SearchBar
	searchBarHTMLArray: [],																							// collection of html snipplets which is parsed and merged on init

	searchBarId: null,																									// id of the SearchBar

	searchBarNodes: {																										// collection of important node references for easy access
		searchBarPlaceHolder: null,
		searchBar:null,

		wildSearch:null,
		wildSearchInput:null,
		wildSearchButton:null,
		extender:null,

		detailedSearch:null,
		detailedSearchPrimary:null,
		detailedSearchSecondary:null,

		searchBarButton:null,
		minimizer:null,

		widthContainer:null
	},

	_searchInputCounter: 0,																							// length of all inputs inside of a SearchBar
	_searchBarFormAction: "",																						// merged action of the SearchBar <form>

	_forcedDetailedSearch: false,																				// is there a wild search on this page?
	_isExtended: false,																									// is the detailed search form about to be expanded?
	_isExtendedToEnd: false,																						// is the detailed serach form expanded?
	_allowHardRecalc: true,																							// is it allowed to update all dimension properties of the SearchBar?

	_detailedSearchBarHeight: 0,																				// height of the detailed search form in px

	_mainDetailInputNode: null,																					// main input of the detail search

	_secondaryFieldsHighlightBeacon: null,															// timer reference for the opacity animation delay of the secondary search fields

	_getStoredSearchBarStatus: function() {
		var hash = epages.localStorage.getItem(this._STORAGE_ID) || {};
		return hash[this.searchBarId] || null;
	},
	_setStoredSearchBarStatus: function(keyword /* String */) {
		var hash = epages.localStorage.getItem(this._STORAGE_ID) || {};
			hash[this.searchBarId] = keyword;

		epages.localStorage.setItem(this._STORAGE_ID, hash);
	},

	createSearchBar: function(searchBarId /* String */, extendAtStartup /* Boolean */, action /* Object */, generalTranslations /* Object */, fields /* Object */) {
		// summary:
		//		Creates a new SearchBar instance
		// description:
		//		Calling this method will cause an injection of a new SearchBar node in the page at the point where the script is declared.
		// searchBarId:
		//		A unique ID for the SearchBar.
		// extendAtStartup:
		//		States whether the detailed search or the wild search form is visible on startup.
		// action:
		//		ViewAction and ObjectID for the SearchBar form.
		// generalTranslations:
		//		Collection of page specific translation string for the SearchBar.
		// fields:
		//		Collection of input fields.
		// example:
		//	// Have a look at "MBO*.Toolbar.html"

		// no need to proceed if there is no id given
		if(!searchBarId) {
			return;
		}

		this.searchBarId = searchBarId;

		if(!fields.primary.length) {
			// no primary fields > no detailed search
			this._forcedDetailedSearch = extendAtStartup = this._isExtendedToEnd = false;
		}

    this._isExtended = this._forcedDetailedSearch = extendAtStartup;

		// merge the form action
		this._searchBarFormAction = "?ViewAction=" + action.viewAction + "&ObjectID=" + action.objectId;

		// inject the container nodes
		var container = dojo.create('div', {
    'class' : 'SearchBarRoot'

    }, $('RightSidebar'), 'before');

		var searchBarNode = dojo.create(
			'div', {
				'id' : 'SearchBar',
				'class' : 'SearchBar HideElementSoft'
			},
			container,
			'last');

		this.searchBarContainer = searchBarNode;

		// convert the object to a html collection
		var formString =			"<form action='" + this._searchBarFormAction + "' method='post' id='WildSearch' class='WildSearch'><div>" +
														"<div id='Extender' class='" + (fields.primary.length ? "" : "HideElementSoft ") + "Extender EnableHover' title='" + generalTranslations.extendButtonTitle + "'></div>";
														// "<label unselectable='unselectable' for='WildSearchInput'>" + generalTranslations.wildSearchLabel+ "</label>";
		if(generalTranslations.wildSearchString){
			generalTranslations.wildSearchString = htmlEscape(generalTranslations.wildSearchString);
		}
		if(generalTranslations.wildSearchLabel == undefined){
			generalTranslations.wildSearchLabel = '';
		}
		if(generalTranslations.wildSearchCustomInput) {
			var inp = generalTranslations.wildSearchCustomInput;
			formString +=						"<input placeholder='" + generalTranslations.wildSearchLabel+ "' value='" + (generalTranslations.wildSearchString || "") + "' type='" + inp.type + "' name='WildSearchInput_JSONTagEditor' inputName='"+ inp.inputName +"' id='WildSearchInput' class='WildSearchInput' dojoType='"+inp.dojotype+"' inputStyle='"+inp.inputStyle+"' />";
		} else {
			formString += 					"<input placeholder='" + generalTranslations.wildSearchLabel+ "' value='" + (generalTranslations.wildSearchString || "") + "' " + this._ELEMENT_DOJOTYPE + " type='text' name='WildSearchString' id='WildSearchInput' class='WildSearchInput'/>";
		}
		formString += 					"<i id='WildSearchButton' class='SearchBarMiniButton Sprite dialog_ico_s_loupe CursorPointer' title='" + generalTranslations.searchButtonTitle + "'></i>" +
														"<input type='submit' class='HideElementSoft'/>";
		this.searchBarHTMLArray.push(formString);
		for( var i=0,iLength=fields.hidden.length ; i<iLength ; i++ ) {
			this.searchBarHTMLArray.push("<input type='hidden' name='" + fields.hidden[i].name + "' value='" + fields.hidden[i].value + "'/>");
		}

		this.searchBarHTMLArray.push("</div></form>");

		this.searchBarHTMLArray.push("<form action='" + this._searchBarFormAction + "' method='post' id='DetailedSearch' class='DetailedSearch" + " HideElementSoft" + "'><div>");

		for( var i=0,iLength=fields.hidden.length ; i<iLength ; i++ ) {
			this.searchBarHTMLArray.push("<input type='hidden' name='" + fields.hidden[i].name + "' value='" + fields.hidden[i].value + "'/>");
		}

		this.searchBarHTMLArray.push("<div id='DetailedSearchPrimary' class='Primary'>");
		this._buildFormElements(fields.primary);

		this.searchBarHTMLArray.push("</div><div id='DetailedSearchSecondary' class='Secondary'>");

		if(fields.secondary.length) {
			this._buildFormElements(fields.secondary);
		}

		this.searchBarHTMLArray.push("</div><div id='Minimizer' class='Minimizer EnableHover' title='" + generalTranslations.minimizeButtonTitle + "'></div>");

		this.searchBarHTMLArray.push("<div class='SearchBarButtonContainer'><div><input dojoType='epages.widget.Button' type='submit' id='SearchBarButton' class='SearchBarButton Button' value='" + generalTranslations.searchButtonTitle + "' iconSrc='dialog_ico_s_loupe'/></div><div class='RoundCornerPatch'></div></div></form>");

		this._initSearchBar();
	},

	_getFieldCount: function(fieldArray) {
		var fieldArrayFiltered = [];
		var isGroupOpened = false;
		for( var i=0,iLength=fieldArray.length ; i<iLength ; i++ ) {
			if(isGroupOpened) {
				if(fieldArray[i].type == "endgroup") {
					isGroupOpened = false;
				}
			}else {
				if(fieldArray[i].type == "startgroup") {
					isGroupOpened = true;
				}
				fieldArrayFiltered.push(fieldArray[i]);
				fieldArrayFiltered.push(fieldArray[i]);
			}
		}
		return fieldArrayFiltered;
	},

	_buildFormElements: function(elementArray) {
		// traverse the element array and build up the specific html code for every entry
		for( var i=0,iLength=elementArray.length ; i<iLength ; i++ ) {
			if( elementArray[i].defaultValue ){
				elementArray[i].defaultValue = htmlEscape( elementArray[i].defaultValue );
			}

			switch(elementArray[i].type) {
				case "select": this._formElements.getSelect(elementArray[i], this._getInputId(), this);break;
				case "checkbox": this._formElements.getCheckbox(elementArray[i], this._getInputId(), this);break;
				case "date": this._formElements.getDateInput(elementArray[i], this._getInputId(), this);break;
				case "datetime": this._formElements.getDateTimeInput(elementArray[i], this._getInputId(), this);break;
				case "multioptions": this._formElements.getMultiOptionsInput(elementArray[i], this._getInputId(), this);break;
				case "tag": this._formElements.getTagInput(elementArray[i], this._getInputId(), this);break;
				case "startgroup": this._formElements.getGroupStart(elementArray[i], this);break;
				case "endgroup": this._formElements.getGroupEnd(this);break;
				case "custom": this._formElements.getCustom(elementArray[i],this);break;
				default: this._formElements.getInput(elementArray[i], this._getInputId(), this);break;
			}
		}
	},

	_formElements: {
		// collection of all available input types inside of a SearchBar (called via "_buildFormElements")
		_getLabel: function(label, id, adjacentText) {
			return "<label unselectable='unselectable' for='" + id + "'>" + label + this._getAdjacentText(adjacentText) + "</label>";
		},
		_getAdjacentText: function(text) {
			return (text ? " " + text + "" : "");
		},
		getSelect: function(arrayEntry, id, scope) {
			scope.searchBarHTMLArray.push("<span class='EnableHover SearchGroup SelectGroup " + (arrayEntry.cssClass || "") + "'>" + this._getLabel(arrayEntry.label, id, arrayEntry.adjacentText) +
																		"<select " + scope._ELEMENT_DOJOTYPE + " id='" + id + "' name='" + arrayEntry.name + "'>");
			for( var i=0,iLength=arrayEntry.options.length ; i<iLength ; i++ ) {
				scope.searchBarHTMLArray.push("<option value='" + arrayEntry.options[i].value + "' " + (arrayEntry.options[i].selected ? "selected='selected'" : "") + ">" + arrayEntry.options[i].label + "</option>");
			}
			scope.searchBarHTMLArray.push("</select></span>");
		},
		getCheckbox: function(arrayEntry, id, scope) {
			scope.searchBarHTMLArray.push("<span class='EnableHover SearchGroup CheckboxGroup " + (arrayEntry.cssClass || "") + "'>" + this._getLabel(arrayEntry.label, id, arrayEntry.adjacentText) +
																		"<input value='" + arrayEntry.defaultValue + "' id='" + id + "' " + scope._ELEMENT_DOJOTYPE + " type='text' class='Checkbox' name='" + arrayEntry.name + "' " + (arrayEntry.checked ? "checked='checked'" : "") + "/>" +
																		"</span>");
		},
		getDateInput: function(arrayEntry, id, scope) {
			scope.searchBarHTMLArray.push("<span class='EnableHover SearchGroup DateGroup " + (arrayEntry.cssClass || "") + "'>" + this._getLabel(arrayEntry.label, id, arrayEntry.adjacentText) +
																		"<input onchange='epages.cartridges.de_epages.presentation.SearchBar._checkErrorState()' dojoType='epages.widget.Datetimeinput' empty='true' selector='date' class='SearchDate' id='" + id + "' type='text' name='" + arrayEntry.name + "' value='" + (arrayEntry.defaultValue || "") + "'/></span>");
		},
		getDateTimeInput: function(arrayEntry, id, scope) {
			scope.searchBarHTMLArray.push("<span class='EnableHover SearchGroup DateTimeGroup " + (arrayEntry.cssClass || "") + "'>" + this._getLabel(arrayEntry.label, id, arrayEntry.adjacentText) +
																		"<input onchange='epages.cartridges.de_epages.presentation.SearchBar._checkErrorState()' dojoType='epages.widget.Datetimeinput' selector='datetime' class='SearchDate' id='" + id + "' type='text' empty='true' name='" + arrayEntry.name + "' value='" + (arrayEntry.defaultValue || "") + "'/></span>");
		},
		getMultiOptionsInput: function(arrayEntry, id, scope) {
			scope.searchBarHTMLArray.push("<span class='EnableHover SearchGroup SelectGroup MultiOptionsGroup " + (arrayEntry.cssClass || "") + "'>" + this._getLabel(arrayEntry.label, id, arrayEntry.adjacentText));

			var optionCollection = [];
			var preSelectedValueCollection = [];
			for( var i=0,iLength=arrayEntry.options.length ; i<iLength ; i++ ) {
				optionCollection.push("<option ep_name='" + arrayEntry.options[i].name + "'>" + arrayEntry.options[i].label + "</option>");
				if(arrayEntry.options[i].defaultValue) {
					preSelectedValueCollection.push(scope._getMultipleOptionsPreSelected(arrayEntry.options[i].name, arrayEntry.options[i].label, arrayEntry.translations[3], arrayEntry.translations[0], arrayEntry.translations[1], (arrayEntry.options[i].defaultValue == 2 ? true : false)));
				}
			}

			scope.searchBarHTMLArray.push("<span class='MultiOptionsGroupSelectContainer'><span class='SelectedEntries'>" + preSelectedValueCollection.join("") + "</span>" +
																		"<select onchange='epages.cartridges.de_epages.presentation.SearchBar._addMultipleOptionsOption(this)' " + scope._ELEMENT_DOJOTYPE + " id='" + id + "' ep_nottranslation='" + arrayEntry.translations[3] + "' ep_removetranslation='" + arrayEntry.translations[4] + "'>");

			scope.searchBarHTMLArray = scope.searchBarHTMLArray.concat(optionCollection);

			var insertHiddenStyle = (scope.searchBarId.match(/SearchOrders/))? " style=\"display:none;\"" : "";
			scope.searchBarHTMLArray.push("</select><span class='DetailSelector LeftPadding'" + insertHiddenStyle + ">" +
																		"<input id='radio_" + id + "_true' name='radio_" + id + "_true' type='text' disabled='disabled' class='Disabled Checked Radio' checked='checked'/><label class='RightPadding' for='radio_" + id + "_true'>" + arrayEntry.translations[0] + "</label>" +
																		"<input id='radio_" + id + "_false' name='radio_" + id + "_false' type='text' disabled='disabled' class='Disabled Radio' /><label for='radio_" + id + "_false'>" + arrayEntry.translations[1] + "</label>" +
																		"</span></span></span>");
		},
		getTagInput: function(arrayEntry, id, scope) {
			scope.searchBarHTMLArray.push("<span class='EnableHover SearchGroup TagGroup " + (arrayEntry.cssClass || "") + "'>" + this._getLabel(arrayEntry.label, id, arrayEntry.adjacentText) +
																		"<input dojoType='epages.cartridges.de_epages.content.widget.TagEditor' class='SearchDate' id='" + id + "' type='text' empty='true' name='" + arrayEntry.name + "' value='" + (arrayEntry.defaultValue || "") +
																		"' availableTags='" + (arrayEntry.availableTags || "") + "'/></span>");
		},
		getInput: function(arrayEntry, id, scope) {
			scope.searchBarHTMLArray.push("<span class='EnableHover SearchGroup InputGroup " + (arrayEntry.cssClass || "") + "'>" + this._getLabel(arrayEntry.label, id, arrayEntry.adjacentText) +
																		"<input " + scope._ELEMENT_DOJOTYPE + " id='" + id + "' type='text' name='" + arrayEntry.name + "' value='" + (arrayEntry.defaultValue || "") + "'/></span>");
		},
		getGroupStart: function(arrayEntry, scope) {
			scope.searchBarHTMLArray.push("<span class='EnableHover Group " + (arrayEntry.cssClass || "") + "'>");
		},
		getGroupEnd: function(scope) {
			scope.searchBarHTMLArray.push("</span>");
		},
		getCustom: function(arrayEntry, scope) {
			scope.searchBarHTMLArray.push(arrayEntry.html);
		}
	},

	_getMultipleOptionsPreSelected: function(inputName, selectValue, removeTranslation, yesTranslation, noTranslation, selectReverse) {
		if($(inputName + "_true")) {
			return "";
		}
		return "<span class='SelectedEntry'>" +
						"<span class='SelectedEntryLabel'>" + selectValue + "</span>" +
						"<input id='" + inputName + "_true' value='1' name='" + inputName + "' type='text' class='Radio' dojoType='epages.widget.FormElement' " + (selectReverse ? "" : "checked='checked'") + "/><label class='RightPadding' for='" + inputName + "_true'>" + yesTranslation + "</label>" +
						"<input id='" + inputName + "_false' value='2' name='" + inputName + "' type='text' class='Radio' dojoType='epages.widget.FormElement' " + (selectReverse ? "checked='checked'" : "") + "/><label for='" + inputName + "_false'>" + noTranslation + "</label>" +
						"<i title='" + removeTranslation + "' class='RemoveButton Sprite ico_s_remove' onclick='epages.cartridges.de_epages.presentation.SearchBar._removeMultipleOptionsSelector(this)'></i>" +
						"</span>";
	},

	_addMultipleOptionsOption: function(selectNode) {

		if(selectNode.selectedIndex === 0) {
			return;
		}

		var selectContainer = selectNode.parentNode.parentNode;
		selectContainer = epages.Browser.engine == "MSIE" ? selectContainer.parentNode : selectContainer;

		var entriesContainer = dojo.query(".SelectedEntries", selectContainer)[0];
		var selectLabels = dojo.query("label", selectContainer);
		var inputName = selectNode.options[selectNode.selectedIndex].getAttribute("ep_name");

		var removeTranslation = selectNode.getAttribute("ep_removetranslation");
		var selectValue = selectNode.value || selectNode.options[selectNode.selectedIndex].innerHTML;

		var labelsLength = selectLabels.length;

		var newSelectedEntryHTML = this._getMultipleOptionsPreSelected(inputName, selectValue, removeTranslation, selectLabels[labelsLength-2].innerHTML, selectLabels[labelsLength-1].innerHTML, false);
		var tempContainer = document.createElement("div");

		if(newSelectedEntryHTML.length > 2) {
			tempContainer.innerHTML = newSelectedEntryHTML;
			entriesContainer.appendChild(tempContainer.firstChild);
			dojo.parser.parse(entriesContainer.lastChild);
		}

		selectNode.selectedIndex = 0;
		this._hardRecalcSearchBarHeight();
	},

	_removeMultipleOptionsSelector: function(iconNode) {
		var entry = iconNode.parentNode;
		var entriesContainer = entry.parentNode;

		dojo.query("input.Radio", entry).forEach(function(radioWidget) {
			$$(radioWidget.id).destroy();
		});

		entriesContainer.removeChild(entry);

		this._hardRecalcSearchBarHeight();
	},

	_getInputId: function() {
		// returns the ID for a new SearchBar element
		this._searchInputCounter++;
		return this._SEARCH_INPUT_PREFIX + this._searchInputCounter;
	},

	_injectSearchBarCode: function() {
		// merge the html snipplets
		//this.searchBarContainer.innerHTML = this.searchBarHTMLArray.join("");

		// parse the merged html
		//dojo.parser.parse(this.searchBarContainer);

		// workaround parseOnLoad <> dojo.parser conflict
		var temp = document.createElement('div');
			temp.innerHTML = this.searchBarHTMLArray.join("");
			dojo.parser.parse(temp);
			dojo.query('*[dojoType]',temp).forEach(function( node, i ) {
				dojo.removeAttr( node, 'dojoType' );
			});
		this.searchBarContainer.appendChild( temp );


		// link the node references
		this.searchBarNodes.searchBarPlaceHolder = $("SearchBarPlaceHolder");
		this.searchBarNodes.searchBar = $("SearchBar");

		this.searchBarNodes.wildSearch = $("WildSearch");
		this.searchBarNodes.wildSearchInput = $("WildSearchInput");
		this.searchBarNodes.wildSearchButton = $("WildSearchButton");
		this.searchBarNodes.extender = $("Extender");

		this.searchBarNodes.detailedSearch = $("DetailedSearch");
		this.searchBarNodes.detailedSearchPrimary = $("DetailedSearchPrimary");
		this.searchBarNodes.detailedSearchSecondary = $("DetailedSearchSecondary");

		this.searchBarNodes.searchBarButton = $("SearchBarButton");
		this.searchBarNodes.minimizer = $("Minimizer");

		this.searchBarNodes.widthContainer = $("DetailedSearchWidthContainer") || document.createElement("div");

		// is there an equivalent wild search input element inside of the detail search mask?
		this._mainDetailInputNode = dojo.query(".MainDetailInputNode input", this.searchBarNodes.detailedSearchPrimary)[0];
	},

	_appendSearchBarEvents: function() {
		dojo.connect(this.searchBarNodes.wildSearchButton, "click", this, "_searchBarMiniButtonClick");
		dojo.connect(this.searchBarNodes.extender, "click", this, "_extenderClick");

		dojo.connect(this.searchBarNodes.searchBarButton, "click", this, "_searchBarButtonClick");
		dojo.connect(this.searchBarNodes.searchBar, "keyup", this, "_checkErrorState");
		dojo.connect(this.searchBarNodes.minimizer, "click", this, "_minimizerClick");
	},

	showSearchBar: function(soft /* Boolean */) {
		this.searchBarNodes.detailedSearch.style.height = '0';
		dojo.removeClass(this.searchBarNodes.detailedSearch,'HideElementSoft');
		dojo.addClass(this.searchBarNodes.wildSearch,'HideElementSoft');
		dojo.fx.wipeIn({
			node: this.searchBarNodes.detailedSearch
		}).play();
		this._setStoredSearchBarStatus(this._STORAGE_EXTENDED_KEYWORD);
		this._isExtended = true;
	},

	hideSearchBar: function(/* Boolean */soft) {
		dojo.fx.wipeOut({
			node: this.searchBarNodes.detailedSearch,
			onEnd: dojo.hitch(this,function(){
				dojo.removeClass(this.searchBarNodes.wildSearch,'HideElementSoft');
			})
		}).play();
		this._setStoredSearchBarStatus(this._STORAGE_MINIMIZED_KEYWORD);
		this._isExtended = false;
	},

	_minimizerClick: function(evt) {
		this.hideSearchBar(true);
	},

	_extenderClick: function(evt) {
		this.showSearchBar(true);
	},

	_searchBarButtonClick: function(evt) {
		this.submitForm(this.searchBarNodes.detailedSearch);
	},

	_checkErrorState: function() {
		var searchBarButtonWidget = $$(this.searchBarNodes.searchBarButton.id);
		if(dojo.query("input.DialogError", this.searchBarNodes.detailedSearch).length) {
			searchBarButtonWidget.disable();
		}else {
			searchBarButtonWidget.enable();
			dojo.removeClass(this.searchBarNodes.searchBarButton.parentNode, "Active");
		}
	},

	_searchBarMiniButtonClick: function(evt) {
		this.submitForm(this.searchBarNodes.wildSearch);
	},

	submitForm: function(formNode) {
		if(!dojo.query("input.DialogError", formNode).length) {
			formNode.submit();
		}
	},

	_hardRecalcSearchBarHeight: function() {
		this._detailedSearchBarHeight = this.searchBarNodes.detailedSearch.offsetHeight - 10;
		setTimeout(dojo.hitch(this, function() {
			this._detailedSearchBarHeight = this.searchBarNodes.detailedSearch.offsetHeight - 10;
			if(this._isExtended) {
				if(!(epages.Browser.engine == "MSIE" && (epages.Browser.version == "7" || epages.Browser.version == "8"))) {
					//this.searchBarNodes.searchBarPlaceHolder.style.height = "auto";
				}
				//this.searchBarNodes.searchBarPlaceHolder.style.height = this._detailedSearchBarHeight + "px";
			}
		}), 1);
	},

	_hardRecalcDimensions: function() {
		if(!this._allowHardRecalc) {
			return;
		}
		var limitNode = this.searchBarNodes.detailedSearchSecondary.parentNode;
		//this.searchBarNodes.searchBar.style.visibility = "hidden";
		//limitNode.style.width = "auto";
		limitNode.style.filter = "alpha()";
		this.searchBarNodes.widthContainer.style.display = "inline";
		setTimeout(dojo.hitch(this, function() {
			var hiddenClassSet = dojo.hasClass(this.searchBarNodes.detailedSearch, "HideElementSoft");
			dojo.removeClass(this.searchBarNodes.detailedSearch, "HideElementSoft");

			//limitNode.style.width = (epages.Browser.engine == "MSIE" ? this.searchBarNodes.detailedSearchSecondary : this.searchBarNodes.widthContainer).offsetWidth + "px";
			this.searchBarNodes.widthContainer.style.display = "block";
			if(hiddenClassSet) {
				dojo.addClass(this.searchBarNodes.detailedSearch, "HideElementSoft");
			}
			limitNode.style.filter = "none";
			this.searchBarNodes.searchBar.style.visibility = "visible";
		}), 1);
		this._hardRecalcSearchBarHeight();
	},

	_initSearchBar: function() {
		this._injectSearchBarCode();
		this._appendSearchBarEvents();

		if(!this._forcedDetailedSearch) {
			var searchBarStatus = this._getStoredSearchBarStatus();
			if(searchBarStatus == this._STORAGE_EXTENDED_KEYWORD) {
				this.showSearchBar(false);
			}else {
				this.hideSearchBar(false);
			}
		}
		this.searchBarNodes.searchBar.style.visibility = "hidden";
		dojo.removeClass(this.searchBarContainer, "HideElementSoft");
		if($$('RightSidebar')){
			this._checkWildSearchBarPadding({width: $$('RightSidebar').isVisible});
		}
		this._hardRecalcDimensions();

		setTimeout(dojo.hitch(this, function() {

			this._hardRecalcDimensions();
			if(!this._isExtended) {
				this._allowHardRecalc = false;
			}

			dojo.connect(window, "resize", this, "_hardRecalcDimensions");

			// only IE fires the resize event when the sidebar status changed
			if(epages.Browser.engine != "MSIE") {
				var sideBarController = $("Sidebarcontroller");
				if(sideBarController) {
					dojo.addOnLoad( dojo.hitch( this, function(){

						dojo.subscribe(dojo.query("[id*=Sidebar]", sideBarController)[0].id + "/afterShowSidebar", dojo.hitch(this, function() {
							setTimeout(dojo.hitch(this, function() {
								this._hardRecalcDimensions();
							}), 1);
						}));

					}));
				}
			}

			// sometimes it is necessary to update the dimension styles after all surrounding elements are rendered
			setTimeout(dojo.hitch(this, function() {
				var temp_allowHardRecalc = this._allowHardRecalc;
				this._allowHardRecalc = true;
				this._hardRecalcDimensions();
				this._allowHardRecalc = temp_allowHardRecalc;

				this._checkErrorState();
				if(this._isExtended){
					this.showSearchBar();
				}
				dojo.publish("SearchBar/ready", [this.searchBarNodes.searchBar]);
			}), 1);

		}), 10);

			dojo.subscribe('RightSidebar/afterShowSidebar',	this, '_checkWildSearchBarPadding');
			dojo.subscribe('RightSidebar/afterHideSidebar',	this, '_checkWildSearchBarPadding');

	},

	_checkWildSearchBarPadding: function(options){
		if(options.width){
			this.searchBarNodes.wildSearch.style.marginRight = '230px';
		}
		else{
			this.searchBarNodes.wildSearch.style.marginRight = '10px';
		}

	}

};

})();

}

if(!dojo._hasResource["dojo.html"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.html"] = true;
dojo.provide("dojo.html");

// the parser might be needed..
 

(function(){ // private scope, sort of a namespace

	// idCounter is incremented with each instantiation to allow asignment of a unique id for tracking, logging purposes
	var idCounter = 0, 
		d = dojo;
	
	dojo.html._secureForInnerHtml = function(/*String*/ cont){
		// summary:
		//		removes !DOCTYPE and title elements from the html string.
		// 
		//		khtml is picky about dom faults, you can't attach a style or <title> node as child of body
		//		must go into head, so we need to cut out those tags
		//	cont:
		//		An html string for insertion into the dom
		//	
		return cont.replace(/(?:\s*<!DOCTYPE\s[^>]+>|<title[^>]*>[\s\S]*?<\/title>)/ig, ""); // String
	};

/*====
	dojo.html._emptyNode = function(node){
		// summary:
		//		removes all child nodes from the given node
		//	node: DOMNode
		//		the parent element
	};
=====*/
	dojo.html._emptyNode = dojo.empty;

	dojo.html._setNodeContent = function(/* DomNode */ node, /* String|DomNode|NodeList */ cont){
		// summary:
		//		inserts the given content into the given node
		//	node:
		//		the parent element
		//	content:
		//		the content to be set on the parent element. 
		//		This can be an html string, a node reference or a NodeList, dojo.NodeList, Array or other enumerable list of nodes
		
		// always empty
		d.empty(node);

		if(cont) {
			if(typeof cont == "string") {
				cont = d._toDom(cont, node.ownerDocument);
			}
			if(!cont.nodeType && d.isArrayLike(cont)) {
				// handle as enumerable, but it may shrink as we enumerate it
				for(var startlen=cont.length, i=0; i<cont.length; i=startlen==cont.length ? i+1 : 0) {
					d.place( cont[i], node, "last");
				}
			} else {
				// pass nodes, documentFragments and unknowns through to dojo.place
				d.place(cont, node, "last");
			}
		}

		// return DomNode
		return node;
	};

	// we wrap up the content-setting operation in a object
	dojo.declare("dojo.html._ContentSetter", null, 
		{
			// node: DomNode|String
			//		An node which will be the parent element that we set content into
			node: "",

			// content: String|DomNode|DomNode[]
			//		The content to be placed in the node. Can be an HTML string, a node reference, or a enumerable list of nodes
			content: "",
			
			// id: String?
			//		Usually only used internally, and auto-generated with each instance 
			id: "",

			// cleanContent: Boolean
			//		Should the content be treated as a full html document, 
			//		and the real content stripped of <html>, <body> wrapper before injection
			cleanContent: false,
			
			// extractContent: Boolean
			//		Should the content be treated as a full html document, and the real content stripped of <html>, <body> wrapper before injection
			extractContent: false,

			// parseContent: Boolean
			//		Should the node by passed to the parser after the new content is set
			parseContent: false,
			
			// lifecyle methods
			constructor: function(/* Object */params, /* String|DomNode */node){
				//	summary:
				//		Provides a configurable, extensible object to wrap the setting on content on a node
				//		call the set() method to actually set the content..
 
				// the original params are mixed directly into the instance "this"
				dojo.mixin(this, params || {});

				// give precedence to params.node vs. the node argument
				// and ensure its a node, not an id string
				node = this.node = dojo.byId( this.node || node );
	
				if(!this.id){
					this.id = [
						"Setter",
						(node) ? node.id || node.tagName : "", 
						idCounter++
					].join("_");
				}

				if(! (this.node || node)){
					new Error(this.declaredClass + ": no node provided to " + this.id);
				}
			},
			set: function(/* String|DomNode|NodeList? */ cont, /* Object? */ params){
				// summary:
				//		front-end to the set-content sequence 
				//	cont:
				//		An html string, node or enumerable list of nodes for insertion into the dom
				//		If not provided, the object's content property will be used
				if(undefined !== cont){
					this.content = cont;
				}
				// in the re-use scenario, set needs to be able to mixin new configuration
				if(params){
					this._mixin(params);
				}

				this.onBegin();
				this.setContent();
				this.onEnd();

				return this.node;
			},
			setContent: function(){
				// summary:
				//		sets the content on the node 

				var node = this.node; 
				if(!node) {
					console.error("setContent given no node");
				}
				try{
					node = dojo.html._setNodeContent(node, this.content);
				}catch(e){
					// check if a domfault occurs when we are appending this.errorMessage
					// like for instance if domNode is a UL and we try append a DIV
	
					// FIXME: need to allow the user to provide a content error message string
					var errMess = this.onContentError(e); 
					try{
						node.innerHTML = errMess;
					}catch(e){
						console.error('Fatal ' + this.declaredClass + '.setContent could not change content due to '+e.message, e);
					}
				}
				// always put back the node for the next method
				this.node = node; // DomNode
			},
			
			empty: function() {
				// summary
				//	cleanly empty out existing content

				// destroy any widgets from a previous run
				// NOTE: if you dont want this you'll need to empty 
				// the parseResults array property yourself to avoid bad things happenning
				if(this.parseResults && this.parseResults.length) {
					dojo.forEach(this.parseResults, function(w) {
						if(w.destroy){
							w.destroy();
						}
					});
					delete this.parseResults;
				}
				// this is fast, but if you know its already empty or safe, you could 
				// override empty to skip this step
				dojo.html._emptyNode(this.node);
			},
	
			onBegin: function(){
				// summary
				//		Called after instantiation, but before set(); 
				//		It allows modification of any of the object properties 
				//		- including the node and content provided - before the set operation actually takes place
				//		This default implementation checks for cleanContent and extractContent flags to 
				//		optionally pre-process html string content
				var cont = this.content;
	
				if(dojo.isString(cont)){
					if(this.cleanContent){
						cont = dojo.html._secureForInnerHtml(cont);
					}
  
					if(this.extractContent){
						var match = cont.match(/<body[^>]*>\s*([\s\S]+)\s*<\/body>/im);
						if(match){ cont = match[1]; }
					}
				}

				// clean out the node and any cruft associated with it - like widgets
				this.empty();
				
				this.content = cont;
				return this.node; /* DomNode */
			},
	
			onEnd: function(){
				// summary
				//		Called after set(), when the new content has been pushed into the node
				//		It provides an opportunity for post-processing before handing back the node to the caller
				//		This default implementation checks a parseContent flag to optionally run the dojo parser over the new content
				if(this.parseContent){
					// populates this.parseResults if you need those..
					this._parse();
				}
				return this.node; /* DomNode */
			},
	
			tearDown: function(){
				// summary
				//		manually reset the Setter instance if its being re-used for example for another set()
				// description
				//		tearDown() is not called automatically. 
				//		In normal use, the Setter instance properties are simply allowed to fall out of scope
				//		but the tearDown method can be called to explicitly reset this instance.
				delete this.parseResults; 
				delete this.node; 
				delete this.content; 
			},
  
			onContentError: function(err){
				return "Error occured setting content: " + err; 
			},
			
			_mixin: function(params){
				// mix properties/methods into the instance
				// TODO: the intention with tearDown is to put the Setter's state 
				// back to that of the original constructor (vs. deleting/resetting everything regardless of ctor params)
				// so we could do something here to move the original properties aside for later restoration
				var empty = {}, key;
				for(key in params){
					if(key in empty){ continue; }
					// TODO: here's our opportunity to mask the properties we dont consider configurable/overridable
					// .. but history shows we'll almost always guess wrong
					this[key] = params[key]; 
				}
			},
			_parse: function(){
				// summary: 
				//		runs the dojo parser over the node contents, storing any results in this.parseResults
				//		Any errors resulting from parsing are passed to _onError for handling

				var rootNode = this.node;
				try{
					// store the results (widgets, whatever) for potential retrieval
					this.parseResults = dojo.parser.parse(rootNode, true);
				}catch(e){
					this._onError('Content', e, "Error parsing in _ContentSetter#"+this.id);
				}
			},
  
			_onError: function(type, err, consoleText){
				// summary:
				//		shows user the string that is returned by on[type]Error
				//		overide/implement on[type]Error and return your own string to customize
				var errText = this['on' + type + 'Error'].call(this, err);
				if(consoleText){
					console.error(consoleText, err);
				}else if(errText){ // a empty string won't change current content
					dojo.html._setNodeContent(this.node, errText, true);
				}
			}
	}); // end dojo.declare()

	dojo.html.set = function(/* DomNode */ node, /* String|DomNode|NodeList */ cont, /* Object? */ params){
			// summary:
			//		inserts (replaces) the given content into the given node. dojo.place(cont, node, "only")
			//		may be a better choice for simple HTML insertion.
			// description:
			//		Unless you need to use the params capabilities of this method, you should use
			//		dojo.place(cont, node, "only"). dojo.place() has more robust support for injecting
			//		an HTML string into the DOM, but it only handles inserting an HTML string as DOM
			//		elements, or inserting a DOM node. dojo.place does not handle NodeList insertions
			//		or the other capabilities as defined by the params object for this method.
			//	node:
			//		the parent element that will receive the content
			//	cont:
			//		the content to be set on the parent element. 
			//		This can be an html string, a node reference or a NodeList, dojo.NodeList, Array or other enumerable list of nodes
			//	params: 
			//		Optional flags/properties to configure the content-setting. See dojo.html._ContentSetter
			//	example:
			//		A safe string/node/nodelist content replacement/injection with hooks for extension
			//		Example Usage: 
			//		dojo.html.set(node, "some string"); 
			//		dojo.html.set(node, contentNode, {options}); 
			//		dojo.html.set(node, myNode.childNodes, {options}); 
		if(undefined == cont){
			console.warn("dojo.html.set: no cont argument provided, using empty string");
			cont = "";
		}	
		if(!params){
			// simple and fast
			return dojo.html._setNodeContent(node, cont, true);
		}else{ 
			// more options but slower
			// note the arguments are reversed in order, to match the convention for instantiation via the parser
			var op = new dojo.html._ContentSetter(dojo.mixin( 
					params, 
					{ content: cont, node: node } 
			));
			return op.set();
		}
	};
})();

}

if(!dojo._hasResource["dijit.layout.ContentPane"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.layout.ContentPane"] = true;
dojo.provide("dijit.layout.ContentPane");



	// for dijit.layout.marginBox2contentBox()






dojo.declare(
	"dijit.layout.ContentPane", dijit._Widget,
{
	// summary:
	//		A widget that acts as a container for mixed HTML and widgets, and includes an Ajax interface
	// description:
	//		A widget that can be used as a stand alone widget
	//		or as a base class for other widgets.
	//
	//		Handles replacement of document fragment using either external uri or javascript
	//		generated markup or DOM content, instantiating widgets within that content.
	//		Don't confuse it with an iframe, it only needs/wants document fragments.
	//		It's useful as a child of LayoutContainer, SplitContainer, or TabContainer.
	//		But note that those classes can contain any widget as a child.
	// example:
	//		Some quick samples:
	//		To change the innerHTML use .attr('content', '<b>new content</b>')
	//
	//		Or you can send it a NodeList, .attr('content', dojo.query('div [class=selected]', userSelection))
	//		please note that the nodes in NodeList will copied, not moved
	//
	//		To do a ajax update use .attr('href', url)

	// href: String
	//		The href of the content that displays now.
	//		Set this at construction if you want to load data externally when the
	//		pane is shown.  (Set preload=true to load it immediately.)
	//		Changing href after creation doesn't have any effect; use attr('href', ...);
	href: "",

/*=====
	// content: String || DomNode || NodeList || dijit._Widget
	//		The innerHTML of the ContentPane.
	//		Note that the initialization parameter / argument to attr("content", ...)
	//		can be a String, DomNode, Nodelist, or _Widget.
	content: "",
=====*/

	// extractContent: Boolean
	//		Extract visible content from inside of <body> .... </body>.
	//		I.e., strip <html> and <head> (and it's contents) from the href
	extractContent: false,

	// parseOnLoad: Boolean
	//		Parse content and create the widgets, if any.
	parseOnLoad: true,

	// preventCache: Boolean
	//		Prevent caching of data from href's by appending a timestamp to the href.
	preventCache: false,

	// preload: Boolean
	//		Force load of data on initialization even if pane is hidden.
	preload: false,

	// refreshOnShow: Boolean
	//		Refresh (re-download) content when pane goes from hidden to shown
	refreshOnShow: false,

	// loadingMessage: String
	//		Message that shows while downloading
	loadingMessage: "<span class='dijitContentPaneLoading'>${loadingState}</span>",

	// errorMessage: String
	//		Message that shows if an error occurs
	errorMessage: "<span class='dijitContentPaneError'>${errorState}</span>",

	// isLoaded: [readonly] Boolean
	//		True if the ContentPane has data in it, either specified
	//		during initialization (via href or inline content), or set
	//		via attr('content', ...) / attr('href', ...)
	//
	//		False if it doesn't have any content, or if ContentPane is
	//		still in the process of downloading href.
	isLoaded: false,

	baseClass: "dijitContentPane",

	// doLayout: Boolean
	//		- false - don't adjust size of children
	//		- true - if there is a single visible child widget, set it's size to
	//				however big the ContentPane is
	doLayout: true,

	// ioArgs: Object
	//		Parameters to pass to xhrGet() request, for example:
	// |	<div dojoType="dijit.layout.ContentPane" href="./bar" ioArgs="{timeout: 500}">
	ioArgs: {},

	// isContainer: [protected] Boolean
	//		Indicates that this widget acts as a "parent" to the descendant widgets.
	//		When the parent is started it will call startup() on the child widgets.
	//		See also `isLayoutContainer`.
	isContainer: true,

	// isLayoutContainer: [protected] Boolean
	//		Indicates that this widget will call resize() on it's child widgets
	//		when they become visible.
	isLayoutContainer: true,

	// onLoadDeferred: [readonly] dojo.Deferred
	//		This is the `dojo.Deferred` returned by attr('href', ...) and refresh().
	//		Calling onLoadDeferred.addCallback() or addErrback() registers your
	//		callback to be called only once, when the prior attr('href', ...) call or
	//		the initial href parameter to the constructor finishes loading.
	//
	//		This is different than an onLoad() handler which gets called any time any href is loaded.
	onLoadDeferred: null,

	// Override _Widget's attributeMap because we don't want the title attribute (used to specify
	// tab labels) to be copied to ContentPane.domNode... otherwise a tooltip shows up over the
	// entire pane.
	attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
		title: []
	}),

	postMixInProperties: function(){
		this.inherited(arguments);
		var messages = dojo.i18n.getLocalization("dijit", "loading", this.lang);
		this.loadingMessage = dojo.string.substitute(this.loadingMessage, messages);
		this.errorMessage = dojo.string.substitute(this.errorMessage, messages);

		// Detect if we were initialized with data
		if(!this.href && this.srcNodeRef && this.srcNodeRef.innerHTML){
			this.isLoaded = true;
		}
	},

	buildRendering: function(){
		// Overrides Widget.buildRendering().
		// Since we have no template we need to set this.containerNode ourselves.
		// For subclasses of ContentPane do have a template, does nothing.
		this.inherited(arguments);
		if(!this.containerNode){
			// make getDescendants() work
			this.containerNode = this.domNode;
		}
	},

	postCreate: function(){
		// remove the title attribute so it doesn't show up when hovering
		// over a node
		this.domNode.title = "";

		if(!dojo.attr(this.domNode,"role")){
			dijit.setWaiRole(this.domNode, "group");
		}

		dojo.addClass(this.domNode, this.baseClass);
	},

	startup: function(){
		// summary:
		//		See `dijit.layout._LayoutWidget.startup` for description.
		//		Although ContentPane doesn't extend _LayoutWidget, it does implement
		//		the same API.
		if(this._started){ return; }

		var parent = dijit._Contained.prototype.getParent.call(this);
		this._childOfLayoutWidget = parent && parent.isLayoutContainer;

		// I need to call resize() on my child/children (when I become visible), unless
		// I'm the child of a layout widget in which case my parent will call resize() on me and I'll do it then.
		this._needLayout = !this._childOfLayoutWidget;

		if(this.isLoaded){
			dojo.forEach(this.getChildren(), function(child){
				child.startup();
			});
		}

		if(this._isShown() || this.preload){
			this._onShow();
		}

		this.inherited(arguments);
	},

	_checkIfSingleChild: function(){
		// summary:
		//		Test if we have exactly one visible widget as a child,
		//		and if so assume that we are a container for that widget,
		//		and should propogate startup() and resize() calls to it.
		//		Skips over things like data stores since they aren't visible.

		var childNodes = dojo.query("> *", this.containerNode).filter(function(node){
				return node.tagName !== "SCRIPT"; // or a regexp for hidden elements like script|area|map|etc..
			}),
			childWidgetNodes = childNodes.filter(function(node){
				return dojo.hasAttr(node, "dojoType") || dojo.hasAttr(node, "widgetId");
			}),
			candidateWidgets = dojo.filter(childWidgetNodes.map(dijit.byNode), function(widget){
				return widget && widget.domNode && widget.resize;
			});

		if(
			// all child nodes are widgets
			childNodes.length == childWidgetNodes.length &&

			// all but one are invisible (like dojo.data)
			candidateWidgets.length == 1
		){
			this._singleChild = candidateWidgets[0];
		}else{
			delete this._singleChild;
		}

		// So we can set overflow: hidden to avoid a safari bug w/scrollbars showing up (#9449)
		dojo.toggleClass(this.containerNode, this.baseClass + "SingleChild", !!this._singleChild);
	},

	setHref: function(/*String|Uri*/ href){
		// summary:
		//		Deprecated.   Use attr('href', ...) instead.
		dojo.deprecated("dijit.layout.ContentPane.setHref() is deprecated. Use attr('href', ...) instead.", "", "2.0");
		return this.attr("href", href);
	},
	_setHrefAttr: function(/*String|Uri*/ href){
		// summary:
		//		Hook so attr("href", ...) works.
		// description:
		//		Reset the (external defined) content of this pane and replace with new url
		//		Note: It delays the download until widget is shown if preload is false.
		//	href:
		//		url to the page you want to get, must be within the same domain as your mainpage

		// Cancel any in-flight requests (an attr('href') will cancel any in-flight attr('href', ...))
		this.cancel();

		this.onLoadDeferred = new dojo.Deferred(dojo.hitch(this, "cancel"));

		this.href = href;

		// _setHrefAttr() is called during creation and by the user, after creation.
		// only in the second case do we actually load the URL; otherwise it's done in startup()
		if(this._created && (this.preload || this._isShown())){
			this._load();
		}else{
			// Set flag to indicate that href needs to be loaded the next time the
			// ContentPane is made visible
			this._hrefChanged = true;
		}

		return this.onLoadDeferred;		// dojo.Deferred
	},

	setContent: function(/*String|DomNode|Nodelist*/data){
		// summary:
		//		Deprecated.   Use attr('content', ...) instead.
		dojo.deprecated("dijit.layout.ContentPane.setContent() is deprecated.  Use attr('content', ...) instead.", "", "2.0");
		this.attr("content", data);
	},
	_setContentAttr: function(/*String|DomNode|Nodelist*/data){
		// summary:
		//		Hook to make attr("content", ...) work.
		//		Replaces old content with data content, include style classes from old content
		//	data:
		//		the new Content may be String, DomNode or NodeList
		//
		//		if data is a NodeList (or an array of nodes) nodes are copied
		//		so you can import nodes from another document implicitly

		// clear href so we can't run refresh and clear content
		// refresh should only work if we downloaded the content
		this.href = "";

		// Cancel any in-flight requests (an attr('content') will cancel any in-flight attr('href', ...))
		this.cancel();

		// Even though user is just setting content directly, still need to define an onLoadDeferred
		// because the _onLoadHandler() handler is still getting called from setContent()
		this.onLoadDeferred = new dojo.Deferred(dojo.hitch(this, "cancel"));

		this._setContent(data || "");

		this._isDownloaded = false; // mark that content is from a attr('content') not an attr('href')

		return this.onLoadDeferred; 	// dojo.Deferred
	},
	_getContentAttr: function(){
		// summary:
		//		Hook to make attr("content") work
		return this.containerNode.innerHTML;
	},

	cancel: function(){
		// summary:
		//		Cancels an in-flight download of content
		if(this._xhrDfd && (this._xhrDfd.fired == -1)){
			this._xhrDfd.cancel();
		}
		delete this._xhrDfd; // garbage collect

		this.onLoadDeferred = null;
	},

	uninitialize: function(){
		if(this._beingDestroyed){
			this.cancel();
		}
		this.inherited(arguments);
	},

	destroyRecursive: function(/*Boolean*/ preserveDom){
		// summary:
		//		Destroy the ContentPane and its contents

		// if we have multiple controllers destroying us, bail after the first
		if(this._beingDestroyed){
			return;
		}
		this.inherited(arguments);
	},

	resize: function(changeSize, resultSize){
		// summary:
		//		See `dijit.layout._LayoutWidget.resize` for description.
		//		Although ContentPane doesn't extend _LayoutWidget, it does implement
		//		the same API.

		// For the TabContainer --> BorderContainer --> ContentPane case, _onShow() is
		// never called, so resize() is our trigger to do the initial href download.
		if(!this._wasShown){
			this._onShow();
		}

		this._resizeCalled = true;

		// Set margin box size, unless it wasn't specified, in which case use current size.
		if(changeSize){
			dojo.marginBox(this.domNode, changeSize);
		}

		// Compute content box size of containerNode in case we [later] need to size our single child.
		var cn = this.containerNode;
		if(cn === this.domNode){
			// If changeSize or resultSize was passed to this method and this.containerNode ==
			// this.domNode then we can compute the content-box size without querying the node,
			// which is more reliable (similar to LayoutWidget.resize) (see for example #9449).
			var mb = resultSize || {};
			dojo.mixin(mb, changeSize || {}); // changeSize overrides resultSize
			if(!("h" in mb) || !("w" in mb)){
				mb = dojo.mixin(dojo.marginBox(cn), mb); // just use dojo.marginBox() to fill in missing values
			}
			this._contentBox = dijit.layout.marginBox2contentBox(cn, mb);
		}else{
			this._contentBox = dojo.contentBox(cn);
		}

		// Make my children layout, or size my single child widget
		this._layoutChildren();
	},

	_isShown: function(){
		// summary:
		//		Returns true if the content is currently shown.
		// description:
		//		If I am a child of a layout widget then it actually returns true if I've ever been visible,
		//		not whether I'm currently visible, since that's much faster than tracing up the DOM/widget
		//		tree every call, and at least solves the performance problem on page load by deferring loading
		//		hidden ContentPanes until they are first shown

		if(this._childOfLayoutWidget){
			// If we are TitlePane, etc - we return that only *IF* we've been resized
			if(this._resizeCalled && "open" in this){
				return this.open;
			}
			return this._resizeCalled;
		}else if("open" in this){
			return this.open;		// for TitlePane, etc.
		}else{
			// TODO: with _childOfLayoutWidget check maybe this branch no longer necessary?
			var node = this.domNode;
			return (node.style.display != 'none') && (node.style.visibility != 'hidden') && !dojo.hasClass(node, "dijitHidden");
		}
	},

	_onShow: function(){
		// summary:
		//		Called when the ContentPane is made visible
		// description:
		//		For a plain ContentPane, this is called on initialization, from startup().
		//		If the ContentPane is a hidden pane of a TabContainer etc., then it's
		//		called whenever the pane is made visible.
		//
		//		Does necessary processing, including href download and layout/resize of
		//		child widget(s)

		if(this.href){
			if(!this._xhrDfd && // if there's an href that isn't already being loaded
				(!this.isLoaded || this._hrefChanged || this.refreshOnShow)
			){
				this.refresh();
			}
		}else{
			// If we are the child of a layout widget then the layout widget will call resize() on
			// us, and then we will size our child/children.   Otherwise, we need to do it now.
			if(!this._childOfLayoutWidget && this._needLayout){
				// If a layout has been scheduled for when we become visible, do it now
				this._layoutChildren();
			}
		}

		this.inherited(arguments);

		// Need to keep track of whether ContentPane has been shown (which is different than
		// whether or not it's currently visible).
		this._wasShown = true;
	},

	refresh: function(){
		// summary:
		//		[Re]download contents of href and display
		// description:
		//		1. cancels any currently in-flight requests
		//		2. posts "loading..." message
		//		3. sends XHR to download new data

		// Cancel possible prior in-flight request
		this.cancel();

		this.onLoadDeferred = new dojo.Deferred(dojo.hitch(this, "cancel"));
		this._load();
		return this.onLoadDeferred;
	},

	_load: function(){
		// summary:
		//		Load/reload the href specified in this.href

		// display loading message
		this._setContent(this.onDownloadStart(), true);

		var self = this;
		var getArgs = {
			preventCache: (this.preventCache || this.refreshOnShow),
			url: this.href,
			handleAs: "text"
		};
		if(dojo.isObject(this.ioArgs)){
			dojo.mixin(getArgs, this.ioArgs);
		}

		var hand = (this._xhrDfd = (this.ioMethod || dojo.xhrGet)(getArgs));

		hand.addCallback(function(html){
			try{
				self._isDownloaded = true;
				self._setContent(html, false);
				self.onDownloadEnd();
			}catch(err){
				self._onError('Content', err); // onContentError
			}
			delete self._xhrDfd;
			return html;
		});

		hand.addErrback(function(err){
			if(!hand.canceled){
				// show error message in the pane
				self._onError('Download', err); // onDownloadError
			}
			delete self._xhrDfd;
			return err;
		});

		// Remove flag saying that a load is needed
		delete this._hrefChanged;
	},

	_onLoadHandler: function(data){
		// summary:
		//		This is called whenever new content is being loaded
		this.isLoaded = true;
		try{
			this.onLoadDeferred.callback(data);
			this.onLoad(data);
		}catch(e){
			console.error('Error '+this.widgetId+' running custom onLoad code: ' + e.message);
		}
	},

	_onUnloadHandler: function(){
		// summary:
		//		This is called whenever the content is being unloaded
		this.isLoaded = false;
		try{
			this.onUnload();
		}catch(e){
			console.error('Error '+this.widgetId+' running custom onUnload code: ' + e.message);
		}
	},

	destroyDescendants: function(){
		// summary:
		//		Destroy all the widgets inside the ContentPane and empty containerNode

		// Make sure we call onUnload (but only when the ContentPane has real content)
		if(this.isLoaded){
			this._onUnloadHandler();
		}

		// Even if this.isLoaded == false there might still be a "Loading..." message
		// to erase, so continue...

		// For historical reasons we need to delete all widgets under this.containerNode,
		// even ones that the user has created manually.
		var setter = this._contentSetter;
		dojo.forEach(this.getChildren(), function(widget){
			if(widget.destroyRecursive){
				widget.destroyRecursive();
			}
		});
		if(setter){
			// Most of the widgets in setter.parseResults have already been destroyed, but
			// things like Menu that have been moved to <body> haven't yet
			dojo.forEach(setter.parseResults, function(widget){
				if(widget.destroyRecursive && widget.domNode && widget.domNode.parentNode == dojo.body()){
					widget.destroyRecursive();
				}
			});
			delete setter.parseResults;
		}

		// And then clear away all the DOM nodes
		dojo.html._emptyNode(this.containerNode);

		// Delete any state information we have about current contents
		delete this._singleChild;
	},

	_setContent: function(cont, isFakeContent){
		// summary:
		//		Insert the content into the container node

		// first get rid of child widgets
		this.destroyDescendants();

		// dojo.html.set will take care of the rest of the details
		// we provide an override for the error handling to ensure the widget gets the errors
		// configure the setter instance with only the relevant widget instance properties
		// NOTE: unless we hook into attr, or provide property setters for each property,
		// we need to re-configure the ContentSetter with each use
		var setter = this._contentSetter;
		if(! (setter && setter instanceof dojo.html._ContentSetter)){
			setter = this._contentSetter = new dojo.html._ContentSetter({
				node: this.containerNode,
				_onError: dojo.hitch(this, this._onError),
				onContentError: dojo.hitch(this, function(e){
					// fires if a domfault occurs when we are appending this.errorMessage
					// like for instance if domNode is a UL and we try append a DIV
					var errMess = this.onContentError(e);
					try{
						this.containerNode.innerHTML = errMess;
					}catch(e){
						console.error('Fatal '+this.id+' could not change content due to '+e.message, e);
					}
				})/*,
				_onError */
			});
		};

		var setterParams = dojo.mixin({
			cleanContent: this.cleanContent,
			extractContent: this.extractContent,
			parseContent: this.parseOnLoad
		}, this._contentSetterParams || {});

		dojo.mixin(setter, setterParams);

		setter.set( (dojo.isObject(cont) && cont.domNode) ? cont.domNode : cont );

		// setter params must be pulled afresh from the ContentPane each time
		delete this._contentSetterParams;

		if(!isFakeContent){
			// Startup each top level child widget (and they will start their children, recursively)
			dojo.forEach(this.getChildren(), function(child){
				// The parser has already called startup on all widgets *without* a getParent() method
				if(!this.parseOnLoad || child.getParent){
					child.startup();
				}
			}, this);

			// Call resize() on each of my child layout widgets,
			// or resize() on my single child layout widget...
			// either now (if I'm currently visible)
			// or when I become visible
			this._scheduleLayout();

			this._onLoadHandler(cont);
		}
	},

	_onError: function(type, err, consoleText){
		this.onLoadDeferred.errback(err);

		// shows user the string that is returned by on[type]Error
		// overide on[type]Error and return your own string to customize
		var errText = this['on' + type + 'Error'].call(this, err);
		if(consoleText){
			console.error(consoleText, err);
		}else if(errText){// a empty string won't change current content
			this._setContent(errText, true);
		}
	},

	_scheduleLayout: function(){
		// summary:
		//		Call resize() on each of my child layout widgets, either now
		//		(if I'm currently visible) or when I become visible
		if(this._isShown()){
			this._layoutChildren();
		}else{
			this._needLayout = true;
		}
	},

	_layoutChildren: function(){
		// summary:
		//		Since I am a Container widget, each of my children expects me to
		//		call resize() or layout() on them.
		// description:
		//		Should be called on initialization and also whenever we get new content
		//		(from an href, or from attr('content', ...))... but deferred until
		//		the ContentPane is visible

		if(this.doLayout){
			this._checkIfSingleChild();
		}

		if(this._singleChild && this._singleChild.resize){
			var cb = this._contentBox || dojo.contentBox(this.containerNode);

			// note: if widget has padding this._contentBox will have l and t set,
			// but don't pass them to resize() or it will doubly-offset the child
			this._singleChild.resize({w: cb.w, h: cb.h});
		}else{
			// All my child widgets are independently sized (rather than matching my size),
			// but I still need to call resize() on each child to make it layout.
			dojo.forEach(this.getChildren(), function(widget){
				if(widget.resize){
					widget.resize();
				}
			});
		}
		delete this._needLayout;
	},

	// EVENT's, should be overide-able
	onLoad: function(data){
		// summary:
		//		Event hook, is called after everything is loaded and widgetified
		// tags:
		//		callback
	},

	onUnload: function(){
		// summary:
		//		Event hook, is called before old content is cleared
		// tags:
		//		callback
	},

	onDownloadStart: function(){
		// summary:
		//		Called before download starts.
		// description:
		//		The string returned by this function will be the html
		//		that tells the user we are loading something.
		//		Override with your own function if you want to change text.
		// tags:
		//		extension
		return this.loadingMessage;
	},

	onContentError: function(/*Error*/ error){
		// summary:
		//		Called on DOM faults, require faults etc. in content.
		//
		//		In order to display an error message in the pane, return
		//		the error message from this method, as an HTML string.
		//
		//		By default (if this method is not overriden), it returns
		//		nothing, so the error message is just printed to the console.
		// tags:
		//		extension
	},

	onDownloadError: function(/*Error*/ error){
		// summary:
		//		Called when download error occurs.
		//
		//		In order to display an error message in the pane, return
		//		the error message from this method, as an HTML string.
		//
		//		Default behavior (if this method is not overriden) is to display
		//		the error message inside the pane.
		// tags:
		//		extension
		return this.errorMessage;
	},

	onDownloadEnd: function(){
		// summary:
		//		Called when download is finished.
		// tags:
		//		callback
	}
});

}

if(!dojo._hasResource["dojox.html._base"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.html._base"] = true;
/*
	Status: dont know where this will all live exactly
	Need to pull in the implementation of the various helper methods
	Some can be static method, others maybe methods of the ContentSetter (?)
	
	Gut the ContentPane, replace its _setContent with our own call to dojox.html.set()
	

*/

dojo.provide("dojox.html._base");

 

(function() {

	if(dojo.isIE){
		var alphaImageLoader = /(AlphaImageLoader\([^)]*?src=(['"]))(?![a-z]+:|\/)([^\r\n;}]+?)(\2[^)]*\)\s*[;}]?)/g;
	}

	// css at-rules must be set before any css declarations according to CSS spec
	// match:
	// @import 'http://dojotoolkit.org/dojo.css';
	// @import 'you/never/thought/' print;
	// @import url("it/would/work") tv, screen;
	// @import url(/did/you/now.css);
	// but not:
	// @namespace dojo "http://dojotoolkit.org/dojo.css"; /* namespace URL should always be a absolute URI */
	// @charset 'utf-8';
	// @media print{ #menuRoot {display:none;} }
		
	// we adjust all paths that dont start on '/' or contains ':'
	//(?![a-z]+:|\/)

	var cssPaths = /(?:(?:@import\s*(['"])(?![a-z]+:|\/)([^\r\n;{]+?)\1)|url\(\s*(['"]?)(?![a-z]+:|\/)([^\r\n;]+?)\3\s*\))([a-z, \s]*[;}]?)/g;

	var adjustCssPaths = dojox.html._adjustCssPaths = function(cssUrl, cssText){
		//	summary:
		//		adjusts relative paths in cssText to be relative to cssUrl
		//		a path is considered relative if it doesn't start with '/' and not contains ':'
		//	description:
		//		Say we fetch a HTML page from level1/page.html
		//		It has some inline CSS:
		//			@import "css/page.css" tv, screen;
		//			...
		//			background-image: url(images/aplhaimage.png);
		//
		//		as we fetched this HTML and therefore this CSS
		//		from level1/page.html, these paths needs to be adjusted to:
		//			@import 'level1/css/page.css' tv, screen;
		//			...
		//			background-image: url(level1/images/alphaimage.png);
		//		
		//		In IE it will also adjust relative paths in AlphaImageLoader()
		//			filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='images/alphaimage.png');
		//		will be adjusted to:
		//			filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='level1/images/alphaimage.png');
		//
		//		Please note that any relative paths in AlphaImageLoader in external css files wont work, as
		//		the paths in AlphaImageLoader is MUST be declared relative to the HTML page,
		//		not relative to the CSS file that declares it

		if(!cssText || !cssUrl){ return; }

		// support the ImageAlphaFilter if it exists, most people use it in IE 6 for transparent PNGs
		// We are NOT going to kill it in IE 7 just because the PNGs work there. Somebody might have
		// other uses for it.
		// If user want to disable css filter in IE6  he/she should
		// unset filter in a declaration that just IE 6 doesn't understands
		// like * > .myselector { filter:none; }
		if(alphaImageLoader){
			cssText = cssText.replace(alphaImageLoader, function(ignore, pre, delim, url, post){
				return pre + (new dojo._Url(cssUrl, './'+url).toString()) + post;
			});
		}

		return cssText.replace(cssPaths, function(ignore, delimStr, strUrl, delimUrl, urlUrl, media){
			if(strUrl){
				return '@import "' + (new dojo._Url(cssUrl, './'+strUrl).toString()) + '"' + media;
			}else{
				return 'url(' + (new dojo._Url(cssUrl, './'+urlUrl).toString()) + ')' + media;
			}
		});
	};

	// attributepaths one tag can have multiple paths, example:
	// <input src="..." style="url(..)"/> or <a style="url(..)" href="..">
	// <img style='filter:progid...AlphaImageLoader(src="noticeTheSrcHereRunsThroughHtmlSrc")' src="img">
	var htmlAttrPaths = /(<[a-z][a-z0-9]*\s[^>]*)(?:(href|src)=(['"]?)([^>]*?)\3|style=(['"]?)([^>]*?)\5)([^>]*>)/gi;

	var adjustHtmlPaths = dojox.html._adjustHtmlPaths = function(htmlUrl, cont){
		var url = htmlUrl || "./";

		return cont.replace(htmlAttrPaths,
			function(tag, start, name, delim, relUrl, delim2, cssText, end){
				return start + (name ?
							(name + '=' + delim + (new dojo._Url(url, relUrl).toString()) + delim)
						: ('style=' + delim2 + adjustCssPaths(url, cssText) + delim2)
				) + end;
			}
		);
	};
	
	var snarfStyles = dojox.html._snarfStyles = function	(/*String*/cssUrl, /*String*/cont, /*Array*/styles){
		/****************  cut out all <style> and <link rel="stylesheet" href=".."> **************/
		// also return any attributes from this tag (might be a media attribute)
		// if cssUrl is set it will adjust paths accordingly
		styles.attributes = [];

		return cont.replace(/(?:<style([^>]*)>([\s\S]*?)<\/style>|<link\s+(?=[^>]*rel=['"]?stylesheet)([^>]*?href=(['"])([^>]*?)\4[^>\/]*)\/?>)/gi,
			function(ignore, styleAttr, cssText, linkAttr, delim, href){
				// trim attribute
				var i, attr = (styleAttr||linkAttr||"").replace(/^\s*([\s\S]*?)\s*$/i, "$1"); 
				if(cssText){
					i = styles.push(cssUrl ? adjustCssPaths(cssUrl, cssText) : cssText);
				}else{
					i = styles.push('@import "' + href + '";');
					attr = attr.replace(/\s*(?:rel|href)=(['"])?[^\s]*\1\s*/gi, ""); // remove rel=... and href=...
				}
				if(attr){
					attr = attr.split(/\s+/);// split on both "\n", "\t", " " etc
					var atObj = {}, tmp;
					for(var j = 0, e = attr.length; j < e; j++){
						tmp = attr[j].split('='); // split name='value'
						atObj[tmp[0]] = tmp[1].replace(/^\s*['"]?([\s\S]*?)['"]?\s*$/, "$1"); // trim and remove ''
					}
					styles.attributes[i - 1] = atObj;
				}
				return ""; // squelsh the <style> or <link>
			}
		);
	};

	var snarfScripts = dojox.html._snarfScripts = function(cont, byRef){
		// summary
		//		strips out script tags from cont
		// invoke with 
		//	byRef = {errBack:function(){/*add your download error code here*/, downloadRemote: true(default false)}}
		//	byRef will have {code: 'jscode'} when this scope leaves
		byRef.code = "";

		//Update script tags nested in comments so that the script tag collector doesn't pick
		//them up.
		cont = cont.replace(/<[!][-][-](.|\s){5,}?[-][-]>/g,
			function(comment){
				return comment.replace(/<(\/?)script\b([^>]|\s)*\>/ig,"&lt;$1Script$2&gt;");
			}
		);

		function download(src){
			if(byRef.downloadRemote){
				// console.debug('downloading',src);
				//Fix up src, in case there were entity character encodings in it.
				//Probably only need to worry about a subset.
				src = src.replace(/&([a-z0-9#]+);/g, function(m, name) {
					switch(name) {
						case "amp"	: return "&";
						case "gt"	: return ">";
						case "lt"	: return "<";
						default:
							return name.charAt(0)=="#" ? String.fromCharCode(name.substring(1)) : "&"+name+";";
					}
				});
				dojo.xhrGet({
					url: src,
					sync: true,
					load: function(code){
						byRef.code += code+";";
					},
					error: byRef.errBack
				});
			}
		}
		
		// match <script>, <script type="text/..., but not <script type="dojo(/method)...
		return cont.replace(/<script\s*(?![^>]*type=['"]?(?:dojo\/|text\/html\b))(?:[^>]*?(?:src=(['"]?)([^>]*?)\1[^>]*)?)*>([\s\S]*?)<\/script>/gi,
			function(ignore, delim, src, code){
				if(src){
					download(src);
				}else{
					byRef.code += code;
				}
				return "";
			}
		);
	}; 
	
	var evalInGlobal = dojox.html.evalInGlobal = function(code, appendNode){
		// we do our own eval here as dojo.eval doesn't eval in global crossbrowser
		// This work X browser but but it relies on a DOM
		// plus it doesn't return anything, thats unrelevant here but not for dojo core
		appendNode = appendNode || dojo.doc.body;
		var n = appendNode.ownerDocument.createElement('script');
		n.type = "text/javascript";
		appendNode.appendChild(n);
		n.text = code; // DOM 1 says this should work
	};

	dojo.declare("dojox.html._ContentSetter", [dojo.html._ContentSetter], {
		// adjustPaths: Boolean
		//		Adjust relative paths in html string content to point to this page
		//		Only useful if you grab content from a another folder than the current one
		adjustPaths: false,
		referencePath: ".",
		renderStyles: false, 

		executeScripts: false,
		scriptHasHooks: false,
		scriptHookReplacement: null,
		
		_renderStyles: function(styles){
			// insert css from content into document head
			this._styleNodes = [];
			var st, att, cssText, doc = this.node.ownerDocument;
			var head = doc.getElementsByTagName('head')[0];

			for(var i = 0, e = styles.length; i < e; i++){
				cssText = styles[i]; att = styles.attributes[i];
				st = doc.createElement('style');
				st.setAttribute("type", "text/css"); // this is required in CSS spec!

				for(var x in att){
					st.setAttribute(x, att[x]);
				}

				this._styleNodes.push(st);
				head.appendChild(st); // must insert into DOM before setting cssText

				if(st.styleSheet){ // IE
					st.styleSheet.cssText = cssText;
				}else{ // w3c
					st.appendChild(doc.createTextNode(cssText));
				}
			}
		}, 

		empty: function() {
			this.inherited("empty", arguments);
			
			// empty out the styles array from any previous use
			this._styles = [];
		}, 
		
		onBegin: function() {
			// summary
			//		Called after instantiation, but before set(); 
			//		It allows modification of any of the object properties - including the node and content 
			//		provided - before the set operation actually takes place
			//		This implementation extends that of dojo.html._ContentSetter 
			//		to add handling for adjustPaths, renderStyles on the html string content before it is set
			this.inherited("onBegin", arguments);
			
			var cont = this.content, 
				node = this.node; 
				
			var styles = this._styles;// init vars

			if(dojo.isString(cont)){
				if(this.adjustPaths && this.referencePath){
					cont = adjustHtmlPaths(this.referencePath, cont);
				}

				if(this.renderStyles || this.cleanContent){
					cont = snarfStyles(this.referencePath, cont, styles);
				}

				// because of a bug in IE, script tags that is first in html hierarchy doesnt make it into the DOM 
				//	when content is innerHTML'ed, so we can't use dojo.query to retrieve scripts from DOM
				if(this.executeScripts){
					var _t = this; 
					var byRef = {
						downloadRemote: true,
						errBack:function(e){
							_t._onError.call(_t, 'Exec', 'Error downloading remote script in "'+_t.id+'"', e);
						}
					};
					cont = snarfScripts(cont, byRef);
					this._code = byRef.code;
				}
			}
			this.content = cont;
		},
		
		onEnd: function() {
			// summary
			//		Called after set(), when the new content has been pushed into the node
			//		It provides an opportunity for post-processing before handing back the node to the caller
			//		This implementation extends that of dojo.html._ContentSetter
			
			var code = this._code, 
				styles = this._styles;
				
			// clear old stylenodes from the DOM
			// these were added by the last set call
			// (in other words, if you dont keep and reuse the ContentSetter for a particular node
			// .. you'll have no practical way to do this)
			if(this._styleNodes && this._styleNodes.length){
				while(this._styleNodes.length){
					dojo.destroy(this._styleNodes.pop());
				}
			}
			// render new style nodes
			if(this.renderStyles && styles && styles.length){
				this._renderStyles(styles);
			}

			if(this.executeScripts && code){
				if(this.cleanContent){
					// clean JS from html comments and other crap that browser
					// parser takes care of in a normal page load
					code = code.replace(/(<!--|(?:\/\/)?-->|<!\[CDATA\[|\]\]>)/g, '');
				}
				if(this.scriptHasHooks){
					// replace _container_ with this.scriptHookReplace()
					// the scriptHookReplacement can be a string 
					// or a function, which when invoked returns the string you want to substitute in
					code = code.replace(/_container_(?!\s*=[^=])/g, this.scriptHookReplacement);
				}
				try{
					evalInGlobal(code, this.node);
				}catch(e){
					this._onError('Exec', 'Error eval script in '+this.id+', '+e.message, e);
				}
			}
			this.inherited("onEnd", arguments);
		},
		tearDown: function() {
			this.inherited(arguments);
			delete this._styles;
			// only tear down -or another set() - will explicitly throw away the
			// references to the style nodes we added
			if(this._styleNodes && this._styleNodes.length){
				while(this._styleNodes.length){
					dojo.destroy(this._styleNodes.pop());
				}
			}
			delete this._styleNodes; 
			// reset the defaults from the prototype
			dojo.mixin(this, dojo.getObject(this.declaredClass).prototype);
		}
		
	});
	
	dojox.html.set = function(/* DomNode */ node, /* String|DomNode|NodeList */ cont, /* Object? */ params){
		// TODO: add all the other options
			// summary:
			//		inserts (replaces) the given content into the given node
			//	node:
			//		the parent element that will receive the content
			//	cont:
			//		the content to be set on the parent element. 
			//		This can be an html string, a node reference or a NodeList, dojo.NodeList, Array or other enumerable list of nodes
			//	params: 
			//		Optional flags/properties to configure the content-setting. See dojo.html._ContentSetter
			//	example:
			//		A safe string/node/nodelist content replacement/injection with hooks for extension
			//		Example Usage: 
			//		dojo.html.set(node, "some string"); 
			//		dojo.html.set(node, contentNode, {options}); 
			//		dojo.html.set(node, myNode.childNodes, {options}); 
	 
		if(!params){
			// simple and fast
			return dojo.html._setNodeContent(node, cont, true);
		}else{ 
			// more options but slower
			var op = new dojox.html._ContentSetter(dojo.mixin( 
					params, 
					{ content: cont, node: node } 
			));
			return op.set();
		}
	};
	
})();

}

if(!dojo._hasResource["dojox.layout.ContentPane"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.layout.ContentPane"] = true;
dojo.provide("dojox.layout.ContentPane");


 

dojo.declare("dojox.layout.ContentPane", dijit.layout.ContentPane, {
	// summary:
	//		An extended version of dijit.layout.ContentPane.
	//		Supports infile scripts and external ones declared by <script src=''
	//		relative path adjustments (content fetched from a different folder)
	//		<style> and <link rel='stylesheet' href='..'> tags,
	//		css paths inside cssText is adjusted (if you set adjustPaths = true)
	//
	//		NOTE that dojo.require in script in the fetched file isn't recommended
	//		Many widgets need to be required at page load to work properly

	// adjustPaths: Boolean
	//		Adjust relative paths in html string content to point to this page.
	//		Only useful if you grab content from a another folder then the current one
	adjustPaths: false,

	// cleanContent: Boolean
	//	summary:
	//		cleans content to make it less likely to generate DOM/JS errors.
	//	description:
	//		useful if you send ContentPane a complete page, instead of a html fragment
	//		scans for 
	//
	//			* title Node, remove
	//			* DOCTYPE tag, remove
	cleanContent: false,

	// renderStyles: Boolean
	//		trigger/load styles in the content
	renderStyles: false,

	// executeScripts: Boolean
	//		Execute (eval) scripts that is found in the content
	executeScripts: true,

	// scriptHasHooks: Boolean
	//		replace keyword '_container_' in scripts with 'dijit.byId(this.id)'
	// NOTE this name might change in the near future
	scriptHasHooks: false,

	/*======
	// ioMethod: dojo.xhrGet|dojo.xhrPost
	//		reference to the method that should grab the content
	ioMethod: dojo.xhrGet,
	
	// ioArgs: Object
	//		makes it possible to add custom args to xhrGet, like ioArgs.headers['X-myHeader'] = 'true'
	ioArgs: {},
	======*/

	constructor: function(){
		// init per instance properties, initializer doesn't work here because how things is hooked up in dijit._Widget
		this.ioArgs = {};
		this.ioMethod = dojo.xhrGet;
	},

	onExecError: function(e){
		// summary:
		//		event callback, called on script error or on java handler error
		//		overide and return your own html string if you want a some text 
		//		displayed within the ContentPane
	},

	_setContent: function(cont){
		// override dijit.layout.ContentPane._setContent, to enable path adjustments
		
		var setter = this._contentSetter; 
		if(! (setter && setter instanceof dojox.html._ContentSetter)) {
			setter = this._contentSetter = new dojox.html._ContentSetter({
				node: this.containerNode,
				_onError: dojo.hitch(this, this._onError),
				onContentError: dojo.hitch(this, function(e){
					// fires if a domfault occurs when we are appending this.errorMessage
					// like for instance if domNode is a UL and we try append a DIV
					var errMess = this.onContentError(e);
					try{
						this.containerNode.innerHTML = errMess;
					}catch(e){
						console.error('Fatal '+this.id+' could not change content due to '+e.message, e);
					}
				})/*,
				_onError */
			});
		};

		// stash the params for the contentSetter to allow inheritance to work for _setContent
		this._contentSetterParams = {
			adjustPaths: Boolean(this.adjustPaths && (this.href||this.referencePath)),
			referencePath: this.href || this.referencePath,
			renderStyles: this.renderStyles,
			executeScripts: this.executeScripts,
			scriptHasHooks: this.scriptHasHooks,
			scriptHookReplacement: "dijit.byId('"+this.id+"')"
		};

		this.inherited("_setContent", arguments);
	}
	// could put back _renderStyles by wrapping/aliasing dojox.html._ContentSetter.prototype._renderStyles
});

}

if(!dojo._hasResource["dijit.form._FormMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form._FormMixin"] = true;
dojo.provide("dijit.form._FormMixin");

dojo.declare("dijit.form._FormMixin", null,
	{
	// summary:
	//		Mixin for containers of form widgets (i.e. widgets that represent a single value
	//		and can be children of a <form> node or dijit.form.Form widget)
	// description:
	//		Can extract all the form widgets
	//		values and combine them into a single javascript object, or alternately
	//		take such an object and set the values for all the contained
	//		form widgets

/*=====
    // value: Object
	//		Name/value hash for each form element.
	//		If there are multiple elements w/the same name, value is an array,
	//		unless they are radio buttons in which case value is a scalar since only
	//		one can be checked at a time.
	//
	//		If the name is a dot separated list (like a.b.c.d), it's a nested structure.
	//		Only works on widget form elements.
	// example:
	//	| { name: "John Smith", interests: ["sports", "movies"] }
=====*/

	//	TODO:
	//	* Repeater
	//	* better handling for arrays.  Often form elements have names with [] like
	//	* people[3].sex (for a list of people [{name: Bill, sex: M}, ...])
	//
	//

		reset: function(){
			dojo.forEach(this.getDescendants(), function(widget){
				if(widget.reset){
					widget.reset();
				}
			});
		},

		validate: function(){
			// summary:
			//		returns if the form is valid - same as isValid - but
			//			provides a few additional (ui-specific) features.
			//			1 - it will highlight any sub-widgets that are not
			//				valid
			//			2 - it will call focus() on the first invalid
			//				sub-widget
			var didFocus = false;
			return dojo.every(dojo.map(this.getDescendants(), function(widget){
				// Need to set this so that "required" widgets get their
				// state set.
				widget._hasBeenBlurred = true;
				var valid = widget.disabled || !widget.validate || widget.validate();
				if(!valid && !didFocus){
					// Set focus of the first non-valid widget
					dijit.scrollIntoView(widget.containerNode || widget.domNode);
					widget.focus();
					didFocus = true;
				}
	 			return valid;
	 		}), function(item){ return item; });
		},

		setValues: function(val){
			dojo.deprecated(this.declaredClass+"::setValues() is deprecated. Use attr('value', val) instead.", "", "2.0");
			return this.attr('value', val);
		},
		_setValueAttr: function(/*object*/obj){
			// summary:
			//		Fill in form values from according to an Object (in the format returned by attr('value'))

			// generate map from name --> [list of widgets with that name]
			var map = { };
			dojo.forEach(this.getDescendants(), function(widget){
				if(!widget.name){ return; }
				var entry = map[widget.name] || (map[widget.name] = [] );
				entry.push(widget);
			});

			for(var name in map){
				if(!map.hasOwnProperty(name)){
					continue;
				}
				var widgets = map[name],						// array of widgets w/this name
					values = dojo.getObject(name, false, obj);	// list of values for those widgets

				if(values === undefined){
					continue;
				}
				if(!dojo.isArray(values)){
					values = [ values ];
				}
				if(typeof widgets[0].checked == 'boolean'){
					// for checkbox/radio, values is a list of which widgets should be checked
					dojo.forEach(widgets, function(w, i){
						w.attr('value', dojo.indexOf(values, w.value) != -1);
					});
				}else if(widgets[0].multiple){
					// it takes an array (e.g. multi-select)
					widgets[0].attr('value', values);
				}else{
					// otherwise, values is a list of values to be assigned sequentially to each widget
					dojo.forEach(widgets, function(w, i){
						w.attr('value', values[i]);
					});
				}
			}

			/***
			 * 	TODO: code for plain input boxes (this shouldn't run for inputs that are part of widgets)

			dojo.forEach(this.containerNode.elements, function(element){
				if(element.name == ''){return};	// like "continue"
				var namePath = element.name.split(".");
				var myObj=obj;
				var name=namePath[namePath.length-1];
				for(var j=1,len2=namePath.length;j<len2;++j){
					var p=namePath[j - 1];
					// repeater support block
					var nameA=p.split("[");
					if(nameA.length > 1){
						if(typeof(myObj[nameA[0]]) == "undefined"){
							myObj[nameA[0]]=[ ];
						} // if

						nameIndex=parseInt(nameA[1]);
						if(typeof(myObj[nameA[0]][nameIndex]) == "undefined"){
							myObj[nameA[0]][nameIndex] = { };
						}
						myObj=myObj[nameA[0]][nameIndex];
						continue;
					} // repeater support ends

					if(typeof(myObj[p]) == "undefined"){
						myObj=undefined;
						break;
					};
					myObj=myObj[p];
				}

				if(typeof(myObj) == "undefined"){
					return;		// like "continue"
				}
				if(typeof(myObj[name]) == "undefined" && this.ignoreNullValues){
					return;		// like "continue"
				}

				// TODO: widget values (just call attr('value', ...) on the widget)

				// TODO: maybe should call dojo.getNodeProp() instead
				switch(element.type){
					case "checkbox":
						element.checked = (name in myObj) &&
							dojo.some(myObj[name], function(val){ return val == element.value; });
						break;
					case "radio":
						element.checked = (name in myObj) && myObj[name] == element.value;
						break;
					case "select-multiple":
						element.selectedIndex=-1;
						dojo.forEach(element.options, function(option){
							option.selected = dojo.some(myObj[name], function(val){ return option.value == val; });
						});
						break;
					case "select-one":
						element.selectedIndex="0";
						dojo.forEach(element.options, function(option){
							option.selected = option.value == myObj[name];
						});
						break;
					case "hidden":
					case "text":
					case "textarea":
					case "password":
						element.value = myObj[name] || "";
						break;
				}
	  		});
	  		*/
		},

		getValues: function(){
			dojo.deprecated(this.declaredClass+"::getValues() is deprecated. Use attr('value') instead.", "", "2.0");
			return this.attr('value');
		},
		_getValueAttr: function(){
			// summary:
			// 		Returns Object representing form values.
			// description:
			//		Returns name/value hash for each form element.
			//		If there are multiple elements w/the same name, value is an array,
			//		unless they are radio buttons in which case value is a scalar since only
			//		one can be checked at a time.
			//
			//		If the name is a dot separated list (like a.b.c.d), creates a nested structure.
			//		Only works on widget form elements.
			// example:
			//		| { name: "John Smith", interests: ["sports", "movies"] }

			// get widget values
			var obj = { };
			dojo.forEach(this.getDescendants(), function(widget){
				var name = widget.name;
				if(!name || widget.disabled){ return; }

				// Single value widget (checkbox, radio, or plain <input> type widget
				var value = widget.attr('value');

				// Store widget's value(s) as a scalar, except for checkboxes which are automatically arrays
				if(typeof widget.checked == 'boolean'){
					if(/Radio/.test(widget.declaredClass)){
						// radio button
						if(value !== false){
							dojo.setObject(name, value, obj);
						}else{
							// give radio widgets a default of null
							value = dojo.getObject(name, false, obj);
							if(value === undefined){
								dojo.setObject(name, null, obj);
							}
						}
					}else{
						// checkbox/toggle button
						var ary=dojo.getObject(name, false, obj);
						if(!ary){
							ary=[];
							dojo.setObject(name, ary, obj);
						}
						if(value !== false){
							ary.push(value);
						}
					}
				}else{
					var prev=dojo.getObject(name, false, obj);
					if(typeof prev != "undefined"){
						if(dojo.isArray(prev)){
							prev.push(value);
						}else{
							dojo.setObject(name, [prev, value], obj);
						}
					}else{
						// unique name
						dojo.setObject(name, value, obj);
					}
				}
			});

			/***
			 * code for plain input boxes (see also dojo.formToObject, can we use that instead of this code?
			 * but it doesn't understand [] notation, presumably)
			var obj = { };
			dojo.forEach(this.containerNode.elements, function(elm){
				if(!elm.name)	{
					return;		// like "continue"
				}
				var namePath = elm.name.split(".");
				var myObj=obj;
				var name=namePath[namePath.length-1];
				for(var j=1,len2=namePath.length;j<len2;++j){
					var nameIndex = null;
					var p=namePath[j - 1];
					var nameA=p.split("[");
					if(nameA.length > 1){
						if(typeof(myObj[nameA[0]]) == "undefined"){
							myObj[nameA[0]]=[ ];
						} // if
						nameIndex=parseInt(nameA[1]);
						if(typeof(myObj[nameA[0]][nameIndex]) == "undefined"){
							myObj[nameA[0]][nameIndex] = { };
						}
					} else if(typeof(myObj[nameA[0]]) == "undefined"){
						myObj[nameA[0]] = { }
					} // if

					if(nameA.length == 1){
						myObj=myObj[nameA[0]];
					} else{
						myObj=myObj[nameA[0]][nameIndex];
					} // if
				} // for

				if((elm.type != "select-multiple" && elm.type != "checkbox" && elm.type != "radio") || (elm.type == "radio" && elm.checked)){
					if(name == name.split("[")[0]){
						myObj[name]=elm.value;
					} else{
						// can not set value when there is no name
					}
				} else if(elm.type == "checkbox" && elm.checked){
					if(typeof(myObj[name]) == 'undefined'){
						myObj[name]=[ ];
					}
					myObj[name].push(elm.value);
				} else if(elm.type == "select-multiple"){
					if(typeof(myObj[name]) == 'undefined'){
						myObj[name]=[ ];
					}
					for(var jdx=0,len3=elm.options.length; jdx<len3; ++jdx){
						if(elm.options[jdx].selected){
							myObj[name].push(elm.options[jdx].value);
						}
					}
				} // if
				name=undefined;
			}); // forEach
			***/
			return obj;
		},

		// TODO: ComboBox might need time to process a recently input value.  This should be async?
	 	isValid: function(){
	 		// summary:
	 		//		Returns true if all of the widgets are valid

	 		// This also populate this._invalidWidgets[] array with list of invalid widgets...
	 		// TODO: put that into separate function?   It's confusing to have that as a side effect
	 		// of a method named isValid().

			this._invalidWidgets = dojo.filter(this.getDescendants(), function(widget){
				return !widget.disabled && widget.isValid && !widget.isValid();
	 		});
			return !this._invalidWidgets.length;
		},


		onValidStateChange: function(isValid){
			// summary:
			//		Stub function to connect to if you want to do something
			//		(like disable/enable a submit button) when the valid
			//		state changes on the form as a whole.
		},

		_widgetChange: function(widget){
			// summary:
			//		Connected to a widget's onChange function - update our
			//		valid state, if needed.
			var isValid = this._lastValidState;
			if(!widget || this._lastValidState === undefined){
				// We have passed a null widget, or we haven't been validated
				// yet - let's re-check all our children
				// This happens when we connect (or reconnect) our children
				isValid = this.isValid();
				if(this._lastValidState === undefined){
					// Set this so that we don't fire an onValidStateChange
					// the first time
					this._lastValidState = isValid;
				}
			}else if(widget.isValid){
				this._invalidWidgets = dojo.filter(this._invalidWidgets || [], function(w){
					return (w != widget);
				}, this);
				if(!widget.isValid() && !widget.attr("disabled")){
					this._invalidWidgets.push(widget);
				}
				isValid = (this._invalidWidgets.length === 0);
			}
			if(isValid !== this._lastValidState){
				this._lastValidState = isValid;
				this.onValidStateChange(isValid);
			}
		},

		connectChildren: function(){
			// summary:
			//		Connects to the onChange function of all children to
			//		track valid state changes.  You can call this function
			//		directly, ex. in the event that you programmatically
			//		add a widget to the form *after* the form has been
			//		initialized.
			dojo.forEach(this._changeConnections, dojo.hitch(this, "disconnect"));
			var _this = this;

			// we connect to validate - so that it better reflects the states
			// of the widgets - also, we only connect if it has a validate
			// function (to avoid too many unneeded connections)
			var conns = this._changeConnections = [];
			dojo.forEach(dojo.filter(this.getDescendants(),
				function(item){ return item.validate; }
			),
			function(widget){
				// We are interested in whenever the widget is validated - or
				// whenever the disabled attribute on that widget is changed
				conns.push(_this.connect(widget, "validate",
									dojo.hitch(_this, "_widgetChange", widget)));
				conns.push(_this.connect(widget, "_setDisabledAttr",
									dojo.hitch(_this, "_widgetChange", widget)));
			});

			// Call the widget change function to update the valid state, in
			// case something is different now.
			this._widgetChange(null);
		},

		startup: function(){
			this.inherited(arguments);
			// Initialize our valid state tracking.  Needs to be done in startup
			// because it's not guaranteed that our children are initialized
			// yet.
			this._changeConnections = [];
			this.connectChildren();
		}
	});

}

if(!dojo._hasResource["dijit.form.Form"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form.Form"] = true;
dojo.provide("dijit.form.Form");





dojo.declare(
	"dijit.form.Form",
	[dijit._Widget, dijit._Templated, dijit.form._FormMixin],
	{
		// summary:
		//		Widget corresponding to HTML form tag, for validation and serialization
		//
		// example:
		//	|	<form dojoType="dijit.form.Form" id="myForm">
		//	|		Name: <input type="text" name="name" />
		//	|	</form>
		//	|	myObj = {name: "John Doe"};
		//	|	dijit.byId('myForm').attr('value', myObj);
		//	|
		//	|	myObj=dijit.byId('myForm').attr('value');

		// HTML <FORM> attributes

		// name: String?
		//		Name of form for scripting.
		name: "",

		// action: String?
		//		Server-side form handler.
		action: "",

		// method: String?
		//		HTTP method used to submit the form, either "GET" or "POST".
		method: "",

		// encType: String?
		//		Encoding type for the form, ex: application/x-www-form-urlencoded.
		encType: "",

		// accept-charset: String?
		//		List of supported charsets.
		"accept-charset": "",

		// accept: String?
		//		List of MIME types for file upload.
		accept: "",

		// target: String?
		//		Target frame for the document to be opened in.
		target: "",

		templateString: "<form dojoAttachPoint='containerNode' dojoAttachEvent='onreset:_onReset,onsubmit:_onSubmit' ${nameAttrSetting}></form>",

		attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
			action: "",
			method: "",
			encType: "",
			"accept-charset": "",
			accept: "",
			target: ""
		}),

		postMixInProperties: function(){
			// Setup name=foo string to be referenced from the template (but only if a name has been specified)
			// Unfortunately we can't use attributeMap to set the name due to IE limitations, see #8660
			this.nameAttrSetting = this.name ? ("name='" + this.name + "'") : "";
			this.inherited(arguments);
		},

		execute: function(/*Object*/ formContents){
			// summary:
			//		Deprecated: use submit()
			// tags:
			//		deprecated
		},

		onExecute: function(){
			// summary:
			//		Deprecated: use onSubmit()
			// tags:
			//		deprecated
		},

		_setEncTypeAttr: function(/*String*/ value){
			this.encType = value;
			dojo.attr(this.domNode, "encType", value);
			if(dojo.isIE){ this.domNode.encoding = value; }
		},

		postCreate: function(){
			// IE tries to hide encType
			// TODO: this code should be in parser, not here.
			if(dojo.isIE && this.srcNodeRef && this.srcNodeRef.attributes){
				var item = this.srcNodeRef.attributes.getNamedItem('encType');
				if(item && !item.specified && (typeof item.value == "string")){
					this.attr('encType', item.value);
				}
			}
			this.inherited(arguments);
		},

		onReset: function(/*Event?*/ e){
			// summary:
			//		Callback when user resets the form. This method is intended
			//		to be over-ridden. When the `reset` method is called
			//		programmatically, the return value from `onReset` is used
			//		to compute whether or not resetting should proceed
			// tags:
			//		callback
			return true; // Boolean
		},

		_onReset: function(e){
			// create fake event so we can know if preventDefault() is called
			var faux = {
				returnValue: true, // the IE way
				preventDefault: function(){ // not IE
							this.returnValue = false;
						},
				stopPropagation: function(){}, currentTarget: e.currentTarget, target: e.target
			};
			// if return value is not exactly false, and haven't called preventDefault(), then reset
			if(!(this.onReset(faux) === false) && faux.returnValue){
				this.reset();
			}
			dojo.stopEvent(e);
			return false;
		},

		_onSubmit: function(e){
			var fp = dijit.form.Form.prototype;
			// TODO: remove this if statement beginning with 2.0
			if(this.execute != fp.execute || this.onExecute != fp.onExecute){
				dojo.deprecated("dijit.form.Form:execute()/onExecute() are deprecated. Use onSubmit() instead.", "", "2.0");
				this.onExecute();
				this.execute(this.getValues());
			}
			if(this.onSubmit(e) === false){ // only exactly false stops submit
				dojo.stopEvent(e);
			}
		},

		onSubmit: function(/*Event?*/e){
			// summary:
			//		Callback when user submits the form.
			// description:
			//		This method is intended to be over-ridden, but by default it checks and
			//		returns the validity of form elements. When the `submit`
			//		method is called programmatically, the return value from
			//		`onSubmit` is used to compute whether or not submission
			//		should proceed
			// tags:
			//		extension

			return this.isValid(); // Boolean
		},

		submit: function(){
			// summary:
			//		programmatically submit form if and only if the `onSubmit` returns true
			if(!(this.onSubmit() === false)){
				this.containerNode.submit();
			}
		}
	}
);

}

if(!dojo._hasResource["dijit._DialogMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._DialogMixin"] = true;
dojo.provide("dijit._DialogMixin");

dojo.declare("dijit._DialogMixin", null,
	{
		// summary:
		//		This provides functions useful to Dialog and TooltipDialog

		attributeMap: dijit._Widget.prototype.attributeMap,

		execute: function(/*Object*/ formContents){
			// summary:
			//		Callback when the user hits the submit button.
			//		Override this method to handle Dialog execution.
			// description:
			//		After the user has pressed the submit button, the Dialog
			//		first calls onExecute() to notify the container to hide the
			//		dialog and restore focus to wherever it used to be.
			//
			//		*Then* this method is called.
			// type:
			//		callback
		},

		onCancel: function(){
			// summary:
			//	    Called when user has pressed the Dialog's cancel button, to notify container.
			// description:
			//	    Developer shouldn't override or connect to this method;
			//		it's a private communication device between the TooltipDialog
			//		and the thing that opened it (ex: `dijit.form.DropDownButton`)
			// type:
			//		protected
		},

		onExecute: function(){
			// summary:
			//	    Called when user has pressed the dialog's OK button, to notify container.
			// description:
			//	    Developer shouldn't override or connect to this method;
			//		it's a private communication device between the TooltipDialog
			//		and the thing that opened it (ex: `dijit.form.DropDownButton`)
			// type:
			//		protected
		},

		_onSubmit: function(){
			// summary:
			//		Callback when user hits submit button
			// type:
			//		protected
			this.onExecute();	// notify container that we are about to execute
			this.execute(this.attr('value'));
		},

		_getFocusItems: function(/*Node*/ dialogNode){
			// summary:
			//		Find focusable Items each time a dialog is opened,
			//		setting _firstFocusItem and _lastFocusItem
			// tags:
			//		protected

			var elems = dijit._getTabNavigable(dojo.byId(dialogNode));
			this._firstFocusItem = elems.lowest || elems.first || dialogNode;
			this._lastFocusItem = elems.last || elems.highest || this._firstFocusItem;
			if(dojo.isMoz && this._firstFocusItem.tagName.toLowerCase() == "input" &&
					dojo.getNodeProp(this._firstFocusItem, "type").toLowerCase() == "file"){
				// FF doesn't behave well when first element is input type=file, set first focusable to dialog container
				dojo.attr(dialogNode, "tabIndex", "0");
				this._firstFocusItem = dialogNode;
			}
		}
	}
);

}

if(!dojo._hasResource["dijit.DialogUnderlay"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.DialogUnderlay"] = true;
dojo.provide("dijit.DialogUnderlay");




dojo.declare(
	"dijit.DialogUnderlay",
	[dijit._Widget, dijit._Templated],
	{
		// summary:
		//		The component that blocks the screen behind a `dijit.Dialog`
		//
		// description:
		// 		A component used to block input behind a `dijit.Dialog`. Only a single
		//		instance of this widget is created by `dijit.Dialog`, and saved as
		//		a reference to be shared between all Dialogs as `dijit._underlay`
		//
		//		The underlay itself can be styled based on and id:
		//	|	#myDialog_underlay { background-color:red; }
		//
		//		In the case of `dijit.Dialog`, this id is based on the id of the Dialog,
		//		suffixed with _underlay.

		// Template has two divs; outer div is used for fade-in/fade-out, and also to hold background iframe.
		// Inner div has opacity specified in CSS file.
		templateString: "<div class='dijitDialogUnderlayWrapper'><div class='dijitDialogUnderlay' dojoAttachPoint='node'></div></div>",

		// Parameters on creation or updatable later

		// dialogId: String
		//		Id of the dialog.... DialogUnderlay's id is based on this id
		dialogId: "",

		// class: String
		//		This class name is used on the DialogUnderlay node, in addition to dijitDialogUnderlay
		"class": "",

		attributeMap: { id: "domNode" },

		_setDialogIdAttr: function(id){
			dojo.attr(this.node, "id", id + "_underlay");
		},

		_setClassAttr: function(clazz){
			this.node.className = "dijitDialogUnderlay " + clazz;
		},

		postCreate: function(){
			// summary:
			//		Append the underlay to the body
			dojo.body().appendChild(this.domNode);
		},

		layout: function(){
			// summary:
			//		Sets the background to the size of the viewport
			//
			// description:
			//		Sets the background to the size of the viewport (rather than the size
			//		of the document) since we need to cover the whole browser window, even
			//		if the document is only a few lines long.
			// tags:
			//		private

			var is = this.node.style,
				os = this.domNode.style;

			// hide the background temporarily, so that the background itself isn't
			// causing scrollbars to appear (might happen when user shrinks browser
			// window and then we are called to resize)
			os.display = "none";

			// then resize and show
			var viewport = dijit.getViewport();
			os.top = viewport.t + "px";
			os.left = viewport.l + "px";
			is.width = viewport.w + "px";
			is.height = viewport.h + "px";
			os.display = "block";
		},

		show: function(){
			// summary:
			//		Show the dialog underlay
			this.domNode.style.display = "block";
			this.layout();
			this.bgIframe = new dijit.BackgroundIframe(this.domNode);
		},

		hide: function(){
			// summary:
			//		Hides the dialog underlay
			this.bgIframe.destroy();
			this.domNode.style.display = "none";
		},

		uninitialize: function(){
			if(this.bgIframe){
				this.bgIframe.destroy();
			}
			this.inherited(arguments);
		}
	}
);

}

if(!dojo._hasResource["dijit.TooltipDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.TooltipDialog"] = true;
dojo.provide("dijit.TooltipDialog");






dojo.declare(
		"dijit.TooltipDialog",
		[dijit.layout.ContentPane, dijit._Templated, dijit.form._FormMixin, dijit._DialogMixin],
		{
			// summary:
			//		Pops up a dialog that appears like a Tooltip

			// title: String
			// 		Description of tooltip dialog (required for a11y)
			title: "",

			// doLayout: [protected] Boolean
			//		Don't change this parameter from the default value.
			//		This ContentPane parameter doesn't make sense for TooltipDialog, since TooltipDialog
			//		is never a child of a layout container, nor can you specify the size of
			//		TooltipDialog in order to control the size of an inner widget.
			doLayout: false,

			// autofocus: Boolean
			// 		A Toggle to modify the default focus behavior of a Dialog, which
			// 		is to focus on the first dialog element after opening the dialog.
			//		False will disable autofocusing. Default: true
			autofocus: true,

			// baseClass: [protected] String
			//		The root className to use for the various states of this widget
			baseClass: "dijitTooltipDialog",

			// _firstFocusItem: [private] [readonly] DomNode
			//		The pointer to the first focusable node in the dialog.
			//		Set by `dijit._DialogMixin._getFocusItems`.
			_firstFocusItem: null,

			// _lastFocusItem: [private] [readonly] DomNode
			//		The pointer to which node has focus prior to our dialog.
			//		Set by `dijit._DialogMixin._getFocusItems`.
			_lastFocusItem: null,

			templateString: dojo.cache("dijit", "templates/TooltipDialog.html", "<div waiRole=\"presentation\">\n\t<div class=\"dijitTooltipContainer\" waiRole=\"presentation\">\n\t\t<div class =\"dijitTooltipContents dijitTooltipFocusNode\" dojoAttachPoint=\"containerNode\" tabindex=\"-1\" waiRole=\"dialog\"></div>\n\t</div>\n\t<div class=\"dijitTooltipConnector\" waiRole=\"presentation\"></div>\n</div>\n"),

			postCreate: function(){
				this.inherited(arguments);
				this.connect(this.containerNode, "onkeypress", "_onKey");
				this.containerNode.title = this.title;
			},

			orient: function(/*DomNode*/ node, /*String*/ aroundCorner, /*String*/ corner){
				// summary:
				//		Configure widget to be displayed in given position relative to the button.
				//		This is called from the dijit.popup code, and should not be called
				//		directly.
				// tags:
				//		protected
				var c = this._currentOrientClass;
				if(c){
					dojo.removeClass(this.domNode, c);
				}
				c = "dijitTooltipAB"+(corner.charAt(1) == 'L'?"Left":"Right")+" dijitTooltip"+(corner.charAt(0) == 'T' ? "Below" : "Above");
				dojo.addClass(this.domNode, c);
				this._currentOrientClass = c;
			},

			onOpen: function(/*Object*/ pos){
				// summary:
				//		Called when dialog is displayed.
				//		This is called from the dijit.popup code, and should not be called directly.
				// tags:
				//		protected

				this.orient(this.domNode,pos.aroundCorner, pos.corner);
				this._onShow(); // lazy load trigger

				if(this.autofocus){
					this._getFocusItems(this.containerNode);
					dijit.focus(this._firstFocusItem);
				}
			},

			onClose: function(){
				// summary:
				//		Called when dialog is hidden.
				//		This is called from the dijit.popup code, and should not be called directly.
				// tags:
				//		protected
				this.onHide();
			},

			_onKey: function(/*Event*/ evt){
				// summary:
				//		Handler for keyboard events
				// description:
				//		Keep keyboard focus in dialog; close dialog on escape key
				// tags:
				//		private

				var node = evt.target;
				var dk = dojo.keys;
				if(evt.charOrCode === dk.TAB){
					this._getFocusItems(this.containerNode);
				}
				var singleFocusItem = (this._firstFocusItem == this._lastFocusItem);
				if(evt.charOrCode == dk.ESCAPE){
					// Use setTimeout to avoid crash on IE, see #10396.
					setTimeout(dojo.hitch(this, "onCancel"), 0);
					dojo.stopEvent(evt);
				}else if(node == this._firstFocusItem && evt.shiftKey && evt.charOrCode === dk.TAB){
					if(!singleFocusItem){
						dijit.focus(this._lastFocusItem); // send focus to last item in dialog
					}
					dojo.stopEvent(evt);
				}else if(node == this._lastFocusItem && evt.charOrCode === dk.TAB && !evt.shiftKey){
					if(!singleFocusItem){
						dijit.focus(this._firstFocusItem); // send focus to first item in dialog
					}
					dojo.stopEvent(evt);
				}else if(evt.charOrCode === dk.TAB){
					// we want the browser's default tab handling to move focus
					// but we don't want the tab to propagate upwards
					evt.stopPropagation();
				}
			}
		}
	);

}

if(!dojo._hasResource["dijit.Dialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.Dialog"] = true;
dojo.provide("dijit.Dialog");













/*=====
dijit._underlay = function(kwArgs){
	// summary:
	//		A shared instance of a `dijit.DialogUnderlay`
	//
	// description:
	//		A shared instance of a `dijit.DialogUnderlay` created and
	//		used by `dijit.Dialog`, though never created until some Dialog
	//		or subclass thereof is shown.
};
=====*/

dojo.declare(
	"dijit._DialogBase",
	[dijit._Templated, dijit.form._FormMixin, dijit._DialogMixin],
	{
		// summary:
		//		A modal dialog Widget
		//
		// description:
		//		Pops up a modal dialog window, blocking access to the screen
		//		and also graying out the screen Dialog is extended from
		//		ContentPane so it supports all the same parameters (href, etc.)
		//
		// example:
		// |	<div dojoType="dijit.Dialog" href="test.html"></div>
		//
		// example:
		// |	var foo = new dijit.Dialog({ title: "test dialog", content: "test content" };
		// |	dojo.body().appendChild(foo.domNode);
		// |	foo.startup();

		templateString: dojo.cache("dijit", "templates/Dialog.html", "<div class=\"dijitDialog\" tabindex=\"-1\" waiRole=\"dialog\" waiState=\"labelledby-${id}_title\">\n\t<div dojoAttachPoint=\"titleBar\" class=\"dijitDialogTitleBar\">\n\t<span dojoAttachPoint=\"titleNode\" class=\"dijitDialogTitle\" id=\"${id}_title\"></span>\n\t<span dojoAttachPoint=\"closeButtonNode\" class=\"dijitDialogCloseIcon\" dojoAttachEvent=\"onclick: onCancel, onmouseenter: _onCloseEnter, onmouseleave: _onCloseLeave\" title=\"${buttonCancel}\">\n\t\t<span dojoAttachPoint=\"closeText\" class=\"closeText\" title=\"${buttonCancel}\">x</span>\n\t</span>\n\t</div>\n\t\t<div dojoAttachPoint=\"containerNode\" class=\"dijitDialogPaneContent\"></div>\n</div>\n"),

		attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
			title: [
				{ node: "titleNode", type: "innerHTML" },
				{ node: "titleBar", type: "attribute" }
			],
			"aria-describedby":""
		}),

		// open: Boolean
		//		True if Dialog is currently displayed on screen.
		open: false,

		// duration: Integer
		//		The time in milliseconds it takes the dialog to fade in and out
		duration: dijit.defaultDuration,

		// refocus: Boolean
		// 		A Toggle to modify the default focus behavior of a Dialog, which
		// 		is to re-focus the element which had focus before being opened.
		//		False will disable refocusing. Default: true
		refocus: true,

		// autofocus: Boolean
		// 		A Toggle to modify the default focus behavior of a Dialog, which
		// 		is to focus on the first dialog element after opening the dialog.
		//		False will disable autofocusing. Default: true
		autofocus: true,

		// _firstFocusItem: [private] [readonly] DomNode
		//		The pointer to the first focusable node in the dialog.
		//		Set by `dijit._DialogMixin._getFocusItems`.
		_firstFocusItem: null,

		// _lastFocusItem: [private] [readonly] DomNode
		//		The pointer to which node has focus prior to our dialog.
		//		Set by `dijit._DialogMixin._getFocusItems`.
		_lastFocusItem: null,

		// doLayout: [protected] Boolean
		//		Don't change this parameter from the default value.
		//		This ContentPane parameter doesn't make sense for Dialog, since Dialog
		//		is never a child of a layout container, nor can you specify the size of
		//		Dialog in order to control the size of an inner widget.
		doLayout: false,

		// draggable: Boolean
		//		Toggles the moveable aspect of the Dialog. If true, Dialog
		//		can be dragged by it's title. If false it will remain centered
		//		in the viewport.
		draggable: true,

		//aria-describedby: String
		//		Allows the user to add an aria-describedby attribute onto the dialog.   The value should
		//		be the id of the container element of text that describes the dialog purpose (usually
		//		the first text in the dialog).
		//		<div dojoType="dijit.Dialog" aria-describedby="intro" .....>
		//			<div id="intro">Introductory text</div>
		//			<div>rest of dialog contents</div>
		//		</div>
		"aria-describedby":"",

		postMixInProperties: function(){
			var _nlsResources = dojo.i18n.getLocalization("dijit", "common");
			dojo.mixin(this, _nlsResources);
			this.inherited(arguments);
		},

		postCreate: function(){
			dojo.style(this.domNode, {
				display: "none",
				position:"absolute"
			});
			dojo.body().appendChild(this.domNode);

			this.inherited(arguments);

			this.connect(this, "onExecute", "hide");
			this.connect(this, "onCancel", "hide");
			this._modalconnects = [];
		},

		onLoad: function(){
			// summary:
			//		Called when data has been loaded from an href.
			//		Unlike most other callbacks, this function can be connected to (via `dojo.connect`)
			//		but should *not* be overriden.
			// tags:
			//		callback

			// when href is specified we need to reposition the dialog after the data is loaded
			this._position();
			this.inherited(arguments);
		},

		_endDrag: function(e){
			// summary:
			//		Called after dragging the Dialog. Saves the position of the dialog in the viewport.
			// tags:
			//		private
			if(e && e.node && e.node === this.domNode){
				this._relativePosition = dojo.position(e.node);
			}
		},

		_setup: function(){
			// summary:
			//		Stuff we need to do before showing the Dialog for the first
			//		time (but we defer it until right beforehand, for
			//		performance reasons).
			// tags:
			//		private

			var node = this.domNode;

			if(this.titleBar && this.draggable){
				this._moveable = (dojo.isIE == 6) ?
					new dojo.dnd.TimedMoveable(node, { handle: this.titleBar }) :	// prevent overload, see #5285
					new dojo.dnd.Moveable(node, { handle: this.titleBar, timeout: 0 });
				dojo.subscribe("/dnd/move/stop",this,"_endDrag");
			}else{
				dojo.addClass(node,"dijitDialogFixed");
			}

			this.underlayAttrs = {
				dialogId: this.id,
				"class": dojo.map(this["class"].split(/\s/), function(s){ return s+"_underlay"; }).join(" ")
			};

			this._fadeIn = dojo.fadeIn({
				node: node,
				duration: this.duration,
				beforeBegin: dojo.hitch(this, function(){
					var underlay = dijit._underlay;
					if(!underlay){
						underlay = dijit._underlay = new dijit.DialogUnderlay(this.underlayAttrs);
					}else{
						underlay.attr(this.underlayAttrs);
					}

					var zIndex = 400 + dijit._dialogStack.length*2;
					dojo.style(dijit._underlay.domNode, 'zIndex', zIndex);
					dojo.style(this.domNode, 'zIndex', zIndex + 1);
					underlay.show();
				}),
				onEnd: dojo.hitch(this, function(){
					if(this.autofocus){
						// find focusable Items each time dialog is shown since if dialog contains a widget the
						// first focusable items can change
						this._getFocusItems(this.domNode);
						dijit.focus(this._firstFocusItem);
					}
				})
			 });

			this._fadeOut = dojo.fadeOut({
				node: node,
				duration: this.duration,
				onEnd: dojo.hitch(this, function(){
					node.style.display = "none";

					// Restore the previous dialog in the stack, or if this is the only dialog
					// then restore to original page
					var ds = dijit._dialogStack;
					if(ds.length == 0){
						dijit._underlay.hide();
					}else{
						dojo.style(dijit._underlay.domNode, 'zIndex', 400 + ds.length*2);
						dijit._underlay.attr(ds[ds.length-1].underlayAttrs);
					}

					// Restore focus to wherever it was before this dialog was displayed
					if(this.refocus){
						var focus = this._savedFocus;

						// If we are returning control to a previous dialog but for some reason
						// that dialog didn't have a focused field, set focus to first focusable item.
						// This situation could happen if two dialogs appeared at nearly the same time,
						// since a dialog doesn't set it's focus until the fade-in is finished.
						if(ds.length > 0){
							var pd = ds[ds.length-1];
							if(!dojo.isDescendant(focus.node, pd.domNode)){
								pd._getFocusItems(pd.domNode);
								focus = pd._firstFocusItem;
							}
						}

						dijit.focus(focus);
					}
				})
			 });
		},

		uninitialize: function(){
			var wasPlaying = false;
			if(this._fadeIn && this._fadeIn.status() == "playing"){
				wasPlaying = true;
				this._fadeIn.stop();
			}
			if(this._fadeOut && this._fadeOut.status() == "playing"){
				wasPlaying = true;
				this._fadeOut.stop();
			}
			if(this.open || wasPlaying){
				dijit._underlay.hide();
			}
			if(this._moveable){
				this._moveable.destroy();
			}
			this.inherited(arguments);
		},

		_size: function(){
			// summary:
			// 		If necessary, shrink dialog contents so dialog fits in viewport
			// tags:
			//		private

			this._checkIfSingleChild();

			// If we resized the dialog contents earlier, reset them back to original size, so
			// that if the user later increases the viewport size, the dialog can display w/out a scrollbar.
			// Need to do this before the dojo.marginBox(this.domNode) call below.
			if(this._singleChild){
				if(this._singleChildOriginalStyle){
					this._singleChild.domNode.style.cssText = this._singleChildOriginalStyle;
				}
				delete this._singleChildOriginalStyle;
			}else{
				dojo.style(this.containerNode, {
					width:"auto",
					height:"auto"
				});
			}

			var mb = dojo.marginBox(this.domNode);
			var viewport = dijit.getViewport();
			if(mb.w >= viewport.w || mb.h >= viewport.h){
				// Reduce size of dialog contents so that dialog fits in viewport

				var w = Math.min(mb.w, Math.floor(viewport.w * 0.75)),
					h = Math.min(mb.h, Math.floor(viewport.h * 0.75));

				if(this._singleChild && this._singleChild.resize){
					this._singleChildOriginalStyle = this._singleChild.domNode.style.cssText;
					this._singleChild.resize({w: w, h: h});
				}else{
					dojo.style(this.containerNode, {
						width: w + "px",
						height: h + "px",
						overflow: "auto",
						position: "relative"	// workaround IE bug moving scrollbar or dragging dialog
					});
				}
			}else{
				if(this._singleChild && this._singleChild.resize){
					this._singleChild.resize();
				}
			}
		},

		_position: function(){
			// summary:
			//		Position modal dialog in the viewport. If no relative offset
			//		in the viewport has been determined (by dragging, for instance),
			//		center the node. Otherwise, use the Dialog's stored relative offset,
			//		and position the node to top: left: values based on the viewport.
			// tags:
			//		private
			if(!dojo.hasClass(dojo.body(),"dojoMove")){
				var node = this.domNode,
					viewport = dijit.getViewport(),
					p = this._relativePosition,
					bb = p ? null : dojo._getBorderBox(node),
					l = Math.floor(viewport.l + (p ? p.x : (viewport.w - bb.w) / 2)),
					t = Math.floor(viewport.t + (p ? p.y : (viewport.h - bb.h) / 2))
				;
				dojo.style(node,{
					left: l + "px",
					top: t + "px"
				});
			}
		},

		_onKey: function(/*Event*/ evt){
			// return if a jQuery or a CKE dialog is open
			// otherwise it is impossible to type something
			if(jQuery(evt.target).is(".ui-dialog *") || jQuery(evt.target).is('div[aria-labelledby^=cke_dialog] *')){
				return;
			}

			// summary:
			//		Handles the keyboard events for accessibility reasons
			// tags:
			//		private

			var ds = dijit._dialogStack;
			if(ds[ds.length-1] != this){
				// console.debug(this.id + ': skipping because', this, 'is not the active dialog');
				return;
			}

			if(evt.charOrCode){
				var dk = dojo.keys;
				var node = evt.target;
				if(evt.charOrCode === dk.TAB){
					this._getFocusItems(this.domNode);
				}
				var singleFocusItem = (this._firstFocusItem == this._lastFocusItem);
				// see if we are shift-tabbing from first focusable item on dialog
				if(node == this._firstFocusItem && evt.shiftKey && evt.charOrCode === dk.TAB){
					if(!singleFocusItem){
						dijit.focus(this._lastFocusItem); // send focus to last item in dialog
					}
					dojo.stopEvent(evt);
				}else if(node == this._lastFocusItem && evt.charOrCode === dk.TAB && !evt.shiftKey){
					if(!singleFocusItem){
						dijit.focus(this._firstFocusItem); // send focus to first item in dialog
					}
					dojo.stopEvent(evt);
				}else{
					// see if the key is for the dialog
					while(node){
					//	if(node == this.domNode || dojo.hasClass(node, "dijitPopup"))){
						if(node == this.domNode || dojo.hasClass(node, "dijitPopup") || dojo.hasClass(node, "ep-uiColorpicker-dialog")){ // enable interaction in ePages jQuery Colorpicker also
							if(evt.charOrCode == dk.ESCAPE){
								this.onCancel();
							}else{
								return; // just let it go
							}
						}
						node = node.parentNode;
					}
					// this key is for the disabled document window
					if(evt.charOrCode !== dk.TAB){ // allow tabbing into the dialog for a11y
						dojo.stopEvent(evt);
					// opera won't tab to a div
					}else if(!dojo.isOpera){
						try{
							this._firstFocusItem.focus();
						}catch(e){ /*squelch*/ }
					}
				}
			}
		},

		show: function(){
			// summary:
			//		Display the dialog
			if(this.open){ return; }

			// first time we show the dialog, there's some initialization stuff to do
			if(!this._alreadyInitialized){
				this._setup();
				this._alreadyInitialized=true;
			}

			if(this._fadeOut.status() == "playing"){
				this._fadeOut.stop();
			}

			this._modalconnects.push(dojo.connect(window, "onscroll", this, "layout"));
			this._modalconnects.push(dojo.connect(window, "onresize", this, function(){
				// IE gives spurious resize events and can actually get stuck
				// in an infinite loop if we don't ignore them
				var viewport = dijit.getViewport();
				if(!this._oldViewport ||
						viewport.h != this._oldViewport.h ||
						viewport.w != this._oldViewport.w){
					this.layout();
					this._oldViewport = viewport;
				}
			}));
			this._modalconnects.push(dojo.connect(dojo.doc.documentElement, "onkeypress", this, "_onKey"));

			dojo.style(this.domNode, {
				opacity:0,
				display:""
			});

			this.open = true;
			this._onShow(); // lazy load trigger

			this._size();
			this._position();
			dijit._dialogStack.push(this);
			this._fadeIn.play();

			this._savedFocus = dijit.getFocus(this);
		},

		hide: function(){
			// summary:
			//		Hide the dialog

			// if we haven't been initialized yet then we aren't showing and we can just return
			// or if we aren't the active dialog, don't allow us to close yet
			var ds = dijit._dialogStack;
			if(!this._alreadyInitialized || this != ds[ds.length-1]){
				return;
			}

			if(this._fadeIn.status() == "playing"){
				this._fadeIn.stop();
			}

			// throw away current active dialog from stack -- making the previous dialog or the node on the original page active
			ds.pop();

			this._fadeOut.play();

			if(this._scrollConnected){
				this._scrollConnected = false;
			}
			dojo.forEach(this._modalconnects, dojo.disconnect);
			this._modalconnects = [];

			if(this._relativePosition){
				delete this._relativePosition;
			}
			this.open = false;

			this.onHide();
		},

		layout: function(){
			// summary:
			//		Position the Dialog and the underlay
			// tags:
			//		private
			if(this.domNode.style.display != "none"){
				if(dijit._underlay){	// avoid race condition during show()
					dijit._underlay.layout();
				}
				this._position();
			}
		},

		destroy: function(){
			dojo.forEach(this._modalconnects, dojo.disconnect);
			if(this.refocus && this.open){
				setTimeout(dojo.hitch(dijit,"focus",this._savedFocus), 25);
			}
			this.inherited(arguments);
		},

		_onCloseEnter: function(){
			// summary:
			//		Called when user hovers over close icon
			// tags:
			//		private
			dojo.addClass(this.closeButtonNode, "dijitDialogCloseIcon-hover");
		},

		_onCloseLeave: function(){
			// summary:
			//		Called when user stops hovering over close icon
			// tags:
			//		private
			dojo.removeClass(this.closeButtonNode, "dijitDialogCloseIcon-hover");
		}
	}
);

dojo.declare(
	"dijit.Dialog",
	[dijit.layout.ContentPane, dijit._DialogBase],
	{}
);

// Stack of currenctly displayed dialogs, layered on top of each other
dijit._dialogStack = [];

// For back-compat.  TODO: remove in 2.0


}

if(!dojo._hasResource['epages.io.text']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.io.text'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

  epages.io.Text $Revision: 1.7 $

*/
dojo.provide('epages.io.text');

epages.io.Text = function (/*String*/url) {
	// summary:
	//		Loads text data from url and set the received text data to the target object.
	// example:
	// 	  epages.io.Text('http://www.mydomain.de/header.text', $(header));
	if (url === undefined){
		return;
	}
	return this.load(url);
};

epages.io.Text.prototype = {
	load: function (/*String*/url) {
		// summary:
		//		Loads text data from url and set the received text data to the target object.
		// example:
		// 	  textLoader = new epages.io.Text();
		//		textLoader.load('http://www.mydomain.de/header.text', $(header));
		var targetObject = {};
	  dojo.xhrGet({
	    url:  url,
	    sync: true,
	    load: function(data, evt){
	      targetObject.text = data;
	    },
	    handleAs: "text"
	  });
	  return targetObject.text; //String
	},

	test: function(/*epages.Test*/eTest) {
		// summary:
		//		test this package
		// example:
		// 	  var package = new epages.io.Text();
		//		boolean = package.test(eTest);
		//		// returns true if all test are successfully
		eTest.setPlanned(2);
		eTest.ok(1, 'loaded');

		var text = this.load('htmlTest.inc');
		eTest.ok(text == 'Header loaded successfully.', 'load header');

		// closing async test
		return eTest.planned == eTest.correct ? true : false; //Boolean
	}
};

}

if(!dojo._hasResource["epages.widget.Button"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Button"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.widget.Button $Revision: 1.47 $

*/
dojo.provide("epages.widget.Button");




epages.widget.ButtonChangeForms = []; // global array of all buttons

dojo.declare(
	"epages.widget.Button",
	[dijit._Widget], {


		name:    '', // String - name of button
		button:  '', // String - execute|batch|confirm|submit
		'class': '', // String - additional class parameter for outer div element
		onclick: '', // function - execute this string on click
		value:   '', // String - label of button
		disabled:'', // String - disable button like submit
		active:  '', // String - enable active class on startup
		iconSrc: '', // String - path to any icon image
		submit:  '', // String - do submit on click
		triggerClass: '',
		disableOnClick: '',
		buttonContainerNode: undefined,// DomNode - always the original input element wich is wrapped by buttonContainerNode

		_returnFalse: "", // return false handle container

		_removeEventList: undefined,
		_onClickEvents: undefined,

		postCreate: function() {
			this.inherited('postCreate', arguments);

			var el = this.domNode;

			var type;
			var triggerClass = '';
			if (dojo.hasClass(el, 'RunButton')) {
				type = 'batch';
			}else if (dojo.hasClass(el, 'SaveButton')){
				type = 'submit';
			}else if (dojo.hasClass(el, 'DeleteButton')){
				type = 'confirm';
			}else if (dojo.hasClass(el, 'CancelButton')){
				type = 'confirm';
			}else if (dojo.hasClass(el, 'ExtraButton')){
				type = 'execute';
				triggerClass="ExtraButtonTrigger";
			}else if (dojo.hasClass(el, 'SearchButton')){
				type = 'execute';
			}else {
				type = 'confirm';
			}
			this.button = type;

			var submit = '';
			if (el.type == 'image' ||el.type == 'submit') {
				submit = 'true';
			}

			var disabled = '';
			/*if (el.disabled) {
				disabled = 'true';
			}*/
			if (el.getAttribute("triggerClass") != null && el.getAttribute("triggerClass") != '') {
				triggerClass = el.getAttribute("triggerClass");
			}

			this.triggerClass = triggerClass;
			this.disabled = disabled;
			this.submit = submit;

			//create outer element
			var buttonContainerNode = document.createElement("span");

			//export all classes to new button tag
			buttonContainerNode.setAttribute((document.all ? "className" : "class"), this["class"]);
			if (!dojo.hasClass(buttonContainerNode, 'Button')) {
				dojo.addClass(buttonContainerNode, 'Button');
			}
			dojo.addClass(buttonContainerNode, 'EnableHover');

			//insert button at the right place
			this.domNode.parentNode.insertBefore(buttonContainerNode, this.domNode);

			//transform old input into new button
			this.domNode.setAttribute((document.all ? "className" : "class"), "ButtonContainer");
			buttonContainerNode.appendChild(this.domNode);

			// is a submit button ?
			this.submit = this.submit != '' || this.button == 'submit';

			// disableOnClick - default settings for undefined
			if(this.disableOnClick == "" && (this.domNode.type == "submit" || this.domNode.href)){
				this.disableOnClick = true;
			}

			// disableOnClick - to bool
			this.disableOnClick = epages.string.toBoolean(this.disableOnClick);

			// is disabled ?
			//this.disabled = this.disabled != '' || this.button == 'submit';
			if (this.disabled) {
				this.domNode.disabled = true;
				this._returnFalse = dojo.connect(this.domNode, "click", this, function(){ return false; });
				dojo.addClass(buttonContainerNode, 'Disabled');
			}

			// is active on startup
			if (this.active!='') {
				dojo.addClass(buttonContainerNode, 'Active');
			}

			// insert icon if an image url exists
			if (this.iconSrc) {
				var buttonIconContainer = document.createElement("span");

				if(this.onclick) {
					buttonIconContainer.onclick = this.onclick;
				}
				if(this.onmousedown) {
					buttonIconContainer.onmousedown = this.onmousedown;
				}
				if(this.onmouseup) {
					buttonIconContainer.onmouseup = this.onmouseup;
				}
				if(this.onmouseover) {
					buttonIconContainer.onmouseover = this.onmouseover;
				}

				buttonIconContainer.form = this.domNode.form;
				buttonIconContainer.className = "ButtonIconContainer";
				//buttonIconContainer.style.background = "url(" + this.iconSrc + ") no-repeat center";

				buttonIconContainer.innerHTML = "<i class='Sprite " + this.iconSrc + "'></i>";

				buttonContainerNode.insertBefore(buttonIconContainer, this.domNode);
				dojo.addClass(this.domNode, "ButtonIconPadding");
			}

			// add events to trigger activation of buttons
			this.form = this.domNode.form;
			this._removeEventList = []; // remove events later if button is enabled
			this._onClickEvents = []; // event list for click, enable or disable

			if (this.button == 'execute' || this.button == 'submit' || this.button == 'batch' ) {
				var inputs = this.form.elements;
				// filter triggerClass or remove NoButtonTrigger
				if (this.triggerClass != '') {
					inputs = dojo.filter(inputs, function (el) { return dojo.hasClass(el, this.triggerClass); }, this);
				} else {
					inputs = dojo.filter(inputs, function (el) { return ( !dojo.hasClass(el, 'NoButtonTrigger') && !dojo.attr( el, 'formnovalidate' ) ) ? true : false; });
				}
				// filter BatchTrigger
				if (this.button == 'batch') {
					inputs = dojo.filter(inputs, function (el) { return dojo.hasClass(el, 'RunButtonTrigger'); });
				} else {
					inputs = dojo.filter(inputs, function (el) { return !dojo.hasClass(el, 'RunButtonTrigger'); });
				}

				// add change events to enable buttons
				this.registerInputs(inputs);
			}
			// buttonContainerNode as widget property
			this.buttonContainerNode = buttonContainerNode;

			// register on click
			if (!this.disabled) {
				this._registerEvents();
			}

			this.enable();
		},

		registerInput: function(el) {
			var it=el.type;
			if (it == "hidden" || it == "text" || it == "password" || it == "file" || it == "textarea") {
				this._removeEventList.push(dojo.connect(el, 'keydown', this, '_OnKeyPressInput')); // fastest activation
				this._removeEventList.push(dojo.connect(el, 'change', this, '_OnKeyPressInput')); // need for other javascripts
				this._removeEventList.push(dojo.connect(el, 'paste',  this, '_OnKeyPressInput')); // need for paste with mouse (right context menu)
				this._removeEventList.push(dojo.connect(el, 'blur', this, '_OnKeyPressInput')); // need for select old entry from browser history
			} else if (it == "checkbox" || it == "radio") {
				this._removeEventList.push(dojo.connect(el, 'click', this, '_OnKeyPressInput'));
				this._removeEventList.push(dojo.connect(el, 'keypress', this, '_OnKeyPressInput'));
				this._removeEventList.push(dojo.connect(el, 'change', this, '_OnKeyPressInput'));
			} else if (el.tagName == "SELECT") {
				this._removeEventList.push(dojo.connect(el, 'change', this, '_OnKeyPressInput'));
			}
		},

		registerInputs: function(inputs){
			dojo.forEach(inputs, function (el) {
				this.registerInput(el);
			}, this);
		},

		_OnKeyPressInput: function (evt) {
			if(!this.domNode.parentNode.className.match("Active")) {
				var t = evt.target;
				if(t.className.match("DialogError") || (evt.type =='blur' && (t.type == 'text' || t.type == 'textarea') && t.defaultValue === t.value)){
					return;
				}

				if(epages.vars.activeButton) {
					dojo.removeClass(epages.vars.activeButton, "Active");
				}
				epages.vars.activeButton = this.domNode.parentNode;

				dojo.addClass(this.domNode.parentNode, 'Active');
				dojo.removeClass(this.domNode.parentNode, 'Disabled');

				if (this.disabled){
					this.enable();
				}

				if (this.button == 'submit') {
					if (!document.title.match(/\*$/)){
						document.title+="*";
					}
					epages.widget.ButtonChangeForms.push(this.form);
				}
			}
		},

		_OnClick: function (evt) {
			if(!this.disabled && this.disableOnClick) {
				dojo.publish("interactionRestrictor/suspend", ["interactionRestrictorFor_" + this.id, this.domNode.parentNode, true]);
				/* prevent double click */
				setTimeout(dojo.hitch(this, function(){ this.disable(); }), 20);

/*				if( this.button != 'submit' && this.button != 'confirm' ){ */
					setTimeout(dojo.hitch(this, function() {
						this.enable();
						dojo.removeClass(this.domNode.parentNode, 'Active');
						dojo.publish("interactionRestrictor/permit", ["interactionRestrictorFor_" + this.id]);
					}), 2000);
/*				} */
			}
			if (this.button == 'confirm' || this.button == 'submit') {
				epages.widget.ButtonChangeForms = [];
			} else if (this.button != 'batch'){
				var formNode = this.form;
				epages.widget.ButtonChangeForms = dojo.filter(epages.widget.ButtonChangeForms, function (el) {
					return el != formNode;
				});
			}
		},


		_OnMouseDown: function() {
		  //summary: emulates the ":active" pseudoclass in the MSIE
			dojo.addClass(this.domNode.parentNode, 'ButtonClicked');
			dojo.addClass(this.domNode, 'ButtonContainerClicked');
		},

		_OnMouseUp: function() {
			dojo.removeClass(this.domNode.parentNode, 'ButtonClicked');
			dojo.removeClass(this.domNode, 'ButtonContainerClicked');
		},

		_registerEvents: function () {
			this._onClickEvents.push(dojo.connect(this.domNode,'click', this, '_OnClick'));
			this._onClickEvents.push(dojo.connect(this.domNode,'mousedown', this, '_OnMouseDown'));
			this._onClickEvents.push(dojo.connect(this.domNode,'mouseup', this, '_OnMouseUp'));
			this._onClickEvents.push(dojo.connect(this.domNode,'mouseout', this, '_OnMouseUp'));
		},

		enable: function () {
				this.disabled = false;
				this.domNode.disabled = false;
				dojo.disconnect(this._returnFalse);

				// switch classes
				dojo.addClass(this.domNode.parentNode, 'Active');
				dojo.removeClass(this.domNode.parentNode, 'Disabled');
				if(this._onClickEvents.length == 0) {
					this._registerEvents();
				}
		},

		disable: function () {
			this.disabled = true;
			this.domNode.disabled = true;

			dojo.disconnect(this._returnFalse);
			this._returnFalse = dojo.connect(this.domNode, "click", this, function(){ return false; });

			// switch classes
			dojo.removeClass(this.domNode.parentNode, 'Active');
			dojo.addClass(this.domNode.parentNode, 'Disabled');

			// unregister events
			dojo.forEach(this._onClickEvents, dojo.disconnect);
			this._onClickEvents = [];
		},

		disableIfEmpty: function (value) {
			if (value == ""){
				this.disable();
			}else{
				this.enable();
			}
		},

		hide: function() {
			dojo.addClass(this.buttonContainerNode, "HideElement");
		},

		show: function() {
			dojo.removeClass(this.buttonContainerNode, "HideElement");
		}
	}
);

epages.onUnloadFunctions.push(function() {
	return epages.widget.ButtonChangeForms.length > 0;
});

epages.widget.TransformButtons = function (domNode) {
	dojo.forEach(dojo.query('.Button', domNode), function (el) {
		if (el.tagName != 'INPUT' || el.type == 'hidden'){
			return;
		}

		var type;
		var triggerClass = '';
		if (dojo.hasClass(el, 'RunButton')) {
			type = 'batch';
		}else if (dojo.hasClass(el, 'SaveButton')){
			type = 'submit';
		}else if (dojo.hasClass(el, 'DeleteButton')){
			type = 'confirm';
		}else if (dojo.hasClass(el, 'CancelButton')){
			type = 'confirm';
		}else if (dojo.hasClass(el, 'ExtraButton')){
			type = 'execute';
			triggerClass="ExtraButtonTrigger";
		}else if (dojo.hasClass(el, 'SearchButton')){
			type = 'execute';
		}else {
			type = 'confirm';
		}


		var submit = '';
		if (el.type == 'image' ||el.type == 'submit') {
			submit = 'true';
		}
		var disabled = '';
		if (el.disabled) {
			disabled = 'true';
		}
		if (el.getAttribute("triggerClass") != null && el.getAttribute("triggerClass") != '') {
			triggerClass = el.getAttribute("triggerClass");
		}
		new epages.widget.Button({
			button:  type,
			name:    el.name,
			value:   el.value,
			'class': el.className,
			onclick: el.onclick,
			iconSrc: el.getAttribute("iconsrc"),
			submit:  submit,
			disabled: disabled,
			triggerClass: triggerClass
			 }, el);
	});
};

// convert old buttons
dojo.addOnLoad(function () {
	//epages.widget.TransformButtons(dojo.body());
});

}

if(!dojo._hasResource["epages.widget.Modaldialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Modaldialog"] = true;
dojo.provide("epages.widget.Modaldialog");





dojo["require"]('dijit.Dialog'); //change require syntax to keep it here after shrinksafe





dojo.declare(
	"epages.widget.Modaldialog",
	[dijit.Dialog, epages.widget.LocalizedWidget],
	{

		/**
		 * public properties
		 */
		buttons: undefined,
		options: undefined,
		duration: epages.Browser.engine=="MSIE" ? 10 : 150,
		title: '',
		'class' : '',
		/**
		 * private properties
		 */
		_contentWidget: null,
		_contentPane: null,
		_events: null,
		_tabEvents: null,
		_tabs: undefined,
		_currentTab: undefined,
		_iframe: null,
		_doc: null,

		/**
		 * dojo widget properties
		 */
		translationName       : dojo.moduleUrl('epages.widget', "templates/translation"),
		imagePath             : epages.themeUrl('images'),
		buttonTemplateString  : '<span class="Button EnableHover (%Class%)" (%buttonId%)><span class="ButtonContainer">(%Label%)</span></span>',
		tabTemplateString     : '<div class="Tab"><div>(%Label%)</div></div>',
		innerTemplatePath     : null,
		widgetsInTemplate     : true,
		templateString: dojo.cache("epages.widget", "templates/Modaldialog.html", "<div class=\"dijitDialog ModalDialog\" style=\"display:none\">\n  <div dojoAttachPoint=\"titleBar\" class=\"dijitDialogTitleBar\" tabindex=\"0\" waiRole=\"dialog\">\n    <span dojoAttachPoint=\"titleNode\" class=\"dijitDialogTitle\">${title}</span>\n    <span dojoAttachPoint=\"closeButtonNode\" class=\"dijitDialogCloseIcon EnableHover\" dojoAttachEvent=\"onclick: onCancel\">\n      <span dojoAttachPoint=\"closeText\" class=\"closeText\">x</span>\n    </span>\n  </div>\n  <div dojoAttachPoint=\"tabBarNode\" class=\"TabBar\" style=\"display:none\"></div>\n  <div dojoAttachPoint=\"layerContentNode\" class=\"LayerContent Border White\">\n    <div dojoAttachPoint=\"containerNode\" class=\"dijitDialogPaneContent ${options.containerClass}\"><!-- //innerTemplate// --></div>\n  </div>\n  <div dojoAttachPoint=\"innerButtonBarNode\" class=\"LayerInnerButtonBar\" style=\"display:none\"></div>\n  <div dojoAttachPoint=\"buttonBarNode\" class=\"LayerButtonBar\" style=\"display:none\"></div>\n</div>\n"),

		clearFloatNode        : undefined,

		buildRendering: function() {
			// summary:
			//    replaces the placeholder in the base template with the template from innerTemplateString,
			//    so this works like an include and you don't have to rewrite the whole template in sub-
			//    classes.
			if (this.innerTemplatePath != null) {
				this.templateString = dijit._Templated.getCachedTemplate(this.templatePath, this.templateString, true);
				var innerTemplateString = dijit._Templated.getCachedTemplate(this.innerTemplatePath, null, true);
				this.templateString = this.templateString.replace('<!-- //innerTemplate// -->', innerTemplateString);
				this.templatePath = '';
			}
			this.inherited("buildRendering", arguments);
		},

		postMixInProperties: function() {
			var options = {containerClass: ''};
			dojo.mixin(options, this.options);
			this.options = options;
			dijit.Dialog.prototype.postMixInProperties.apply(this, arguments);
			this.inherited("postMixInProperties", arguments);
		},

		postCreate: function() {
			this._doc = this.domNode.ownerDocument;
			//call postCreate of dijit.dialog because this.inherited only references to the last parent class
			dijit.Dialog.prototype.postCreate.apply(this, arguments);
			this.inherited("postCreate", arguments);
			if(this.buttons===undefined){
				this.buttons=[];
			}
			if(this.tabs===undefined){
				this.tabs=[];
			}
			if(this.options===undefined){
				this.options={};
			}
			this._createContent(this.options);
			this._createButtons(this.buttons);
			this._createTabs();
			dojo.addClass(this.domNode, this['class']);
			dojo.subscribe(this.id+"/executeAction",dojo.hitch(this,this.executeAction));
		},
		executeAction : function(/*String*/ functionName,/*anything...*/additionalParams){
			// summary: executes the specified function with the passed arguments
			// example: dojo.publish(id/executeAction,[disableButton,startButton])
			// functionName: function name to call and every following
			// additionalParams: parameters will be pushed as parameter to the called function
			if(this[functionName] && dojo.isFunction(this[functionName])){
				var params = [];
				dojo.forEach(arguments,function(el,i){
					if(i!=0){
						params.push(el);
					}
				});
				epages.lang.hitch(this,functionName,params)();
			}
		},

		destroyRendering: function() {
			this.hide();
			this.inherited("destroyRendering", arguments);
		},

		hide: function() {
			this.inherited("hide", arguments);
			if(epages.Browser.engine=="MSIE") { // layer display corrections
				this.domNode.style.width="auto";
			}
			dojo.publish(this.id+'/hide',[{dialog: this}]);
		},

		show: function() {
			this.inherited("show", arguments);
			if(epages.Browser.engine=="MSIE") { // layer display corrections
				this.domNode.style.width=this.domNode.offsetWidth+"px";
			}
			//set zIndex to epages.vars.ZIndex
			if(this.domNode && epages.zIndex){
				this.domNode.style.zIndex = epages.zIndex;
			}
			if(this._underlay){
				this._underlay.domNode.style.zIndex = this.domNode.style.zIndex-1;
			}
			if(epages.zIndex){
				epages.zIndex+=2;
			}
			//disconnect scrollevent from dialog, because there is no parameter in dojo dialog to achive this
			for(var i = 0, iLength = this._modalconnects.length; i < iLength; i++){
				var currentEventHandle = this._modalconnects[i];
				if( currentEventHandle.length && currentEventHandle[1] &&  currentEventHandle[1] == 'onscroll'){
					dojo.disconnect(currentEventHandle);
				}
			}
			//check if there is enough space to see the close button
			var popupTop = parseInt(this.domNode.style.top);
			var popupLeft = parseInt(this.domNode.style.left);
			if(popupTop < 0){
				this.domNode.style.top = "0px";
			}
			if(popupLeft < 0){
				this.domNode.style.left = "";
				this.domNode.style.right = "0px";
			}
			else {
				this.domNode.style.right = "";
			}
			//remove dragging
			if(this._moveable){
				this._moveable.destroy();
			}
			// manual focus handling : focus first input
			if(!this.autofocus) {
				var inputs = dojo.query('input', this.containerNode);
				if(inputs && inputs.length > 0) {
					inputs[0].focus();
				}
			}
			// trigger resize to adjust CKEditor dimensions
			jq(window).trigger('resize');

			dojo.publish(this.id+'/show',[{dialog: this}]);
		},

		close: function() {
			this.hide();
			window.setTimeout(dojo.hitch(this,function(){
				this._destroyContent();
				this._destroyButtons();
			}),this.duration);
		},

		setupContent: function(/*Object*/ opt) {
		// summary: setup new content (destorys old content contentarea, tabs, buttons)
		// opt: {
		//  content - string / domNode / widget object (strings may contain widgets e.g. <div dojoType="epages.widget.Tooltip"></div>)
		//  buttons - array with buttons e.g. [{label: 'Cancel',onclick: function() {this._modalDialogWidget.hide();}]}
		//  width - integer or string - width of content area
		//  height - integer or string - height of content area
		//  scroll - string - possible values: 'y', 'x', 'scroll', 'hidden'
		//  title - string - text in titlebar
		//  translationName - string (url) specify translation file to translate language tags in title attribute
		//  url - load content via url
		//  destroyWidgetOnClose - boolean - option to destroy widgets after closing the content widget (also after setting up new content)
		// }
			this._destroyTabs();
			this._destroyContent();
			this._destroyButtons();

			if (opt.buttons){
				this.setupButtons(opt.buttons);
			}
			this._createContent(opt);
			this._createTabs();
		},

		setupButtons: function (buttons) {
			this._destroyButtons();
			this._createButtons(buttons);
		},


		setTitle: function(title) {
			this.titleNode.innerHTML = title;
		},

/**
* widget button/ display functions
*/

		hideInnerButtonBar : function() {
			this.innerButtonBarNode.style.display ='none';
		},

		showInnerButtonBar : function() {
			this.innerButtonBarNode.style.display ='';
		},

		disableButton : function(/* string|DomNode*/ but) {
		// summary: disables specified button
			if(dojo.isString(but)){
				var buttons = dojo.query("[buttonid="+but+"]", this.domNode );
				if(buttons){
					buttons = buttons[0];
				}
			} else {
				var buttons = but;
			}
			if(buttons) {
				dojo.removeClass(buttons, "Active");
				dojo.addClass(buttons, "Disabled");
				buttons.disabled=true;
			}

			dojo.forEach(this._events, function(evtmap) {
				if(evtmap.button.domNode == buttons) {
					dojo.disconnect(evtmap.event);
				}
			});

		},

		enableButton : function(/* string */ buttonId) {
		// summary: enables specified button
			var buttonData = undefined;
			dojo.forEach(this.buttons, function (button) {
				if(button.buttonId == buttonId) {
					buttonData = button;
				}
			});

			if(buttonData && buttonData.domNode.disabled == true) {
				buttonData.domNode.disabled=false;
				if(buttonData.cssClass) {
					dojo.addClass(buttonData.domNode, buttonData.cssClass );
				}
				dojo.removeClass(buttonData.domNode, "Disabled");
				dojo.forEach(this._events, function(evtmap) {
					if(evtmap.button.buttonId == buttonId) {
						evtmap.event = dojo.connect(buttonData.domNode, "onclick", buttonData, "onclick");
					}
				});
			}
		},

		_createContent: function(/*Object*/ opt) {
			if(opt){
				dojo.mixin(this.options, opt);
			}

			var translation = undefined;
			if(this.options.translationName) {
				translation = new epages.io.Translation(this.options.translationName,"auto");
				if(this.options.title){
					this.options.title = translation.replaceLanguageTags(this.options.title);
				}
			}
			if (this.options.title){
				this.setTitle(this.options.title);
			}
			// set Layout
			switch(this.options.scroll){
				case "y":
					this.containerNode.style.overflowY='scroll';
					break;
				case "x":
					this.containerNode.style.overflowX='scroll';
					break;
				case "scroll":
					this.containerNode.style.overflow='scroll';
					break;
				case "hidden":
					this.containerNode.style.overflow='hidden';
					break;
				default:
					this.containerNode.style.overflow='auto';
					break;
			}
			if (this.options.width) {
				if (typeof this.options.width == 'number') {
					this.layerContentNode.style.width=this.options.width+"px";
				} else {
					this.layerContentNode.style.width=this.options.width;
				}
			} else {
				this.containerNode.style.width="auto";
				this.layerContentNode.style.width="auto";
			}
			if (this.options.height) {
				if (typeof this.options.height == 'number') {
					this.containerNode.style.height=this.options.height+"px";
				} else {
					this.containerNode.style.height=this.options.height;
				}
			} else {
				this.containerNode.style.height="auto";
			}
			if (this.options.url != null) {
				// url, use contentPane
				if (this._contentPane == null) {
					// contentPane does not exist -> create it
					this._contentPane = new dojox.layout.ContentPane({
						// url of content
						href: this.options.url,
						// wait for download to finish
						preload: true,
						// extract content from body tag
						extractContent: false,
						// adjust relative paths
						adjustPaths: true,
						// set content on download end to avoid resizing problem <-- does not work
						ioMethod: function(args) {
							var result = dojo.xhrGet(args);
							if(translation){
								result.addCallback(function(html){
										return translation.replaceLanguageTags(html);
								});
							}
							return result;
						},
						onLoad: dojo.hitch(this, function() {
							//Timeout necessary for IE
							window.setTimeout(dojo.hitch(this,function(){
							this.containerNode.appendChild(this._contentPane.domNode);
							// call event function
							if (this.options && this.options.onLoad && typeof this.options.onLoad == 'function'){
								this.options.onLoad();
							}
							this.layout();
							this.show();
							this._createTabs();
							dojo.publish(this.id+'/onLoadContentPane',[{dialog: this}]);
						}),10);
						})
					});
					this._contentPane.refresh();
				} else {
					this._contentPane.setHref(this.options.url);
				}
			} else {
				if(typeof this.options.content == "object") {
					// content, string, nodes or widgets
					if(this.options.content.domNode) { // widget
						this.containerNode.appendChild(this.options.content.domNode);
						this._contentWidget=this.options.content;
					} else {                           // dom node
						this.containerNode.appendChild(this.options.content);
					}
				} else if(typeof this.options.content == "string") {
					this.containerNode.innerHTML=this.options.content;  // html string
					var scripts = this.containerNode.getElementsByTagName('script');
					var win = this._doc.parentWindow ? this._doc.parentWindow : this._doc.defaultView;
					for( var i=0,iLength=scripts.length ; i<iLength ; i++ ) {
						if (scripts[i].childNodes.length > 0) {
							// Mozilla
							// Fix for bug https://bugzilla.mozilla.org/show_bug.cgi?id=194231: only 4K string in array element
							var evalString = "";
							for( var j=0,jLength=scripts[i].childNodes.length ; j<jLength ; j++ ) {
								evalString += scripts[i].childNodes[j].nodeValue;
							}
							win.eval(evalString);
						} else {
							// IE
							win.eval(scripts[i].innerHTML);
						}
					}
					win.dojo.parser.parse(this.containerNode); // build widgets
					//epages.widget.TransformButtons(this.containerNode);
				}
			}
			dojo.publish(this.id+'/change',[{dialog: this}]);
		},

		_destroyContent: function() {
			this.options.scroll=undefined;
			this.options.width=undefined;
			this.options.height=undefined;
			this.options.title=undefined;
			this.options.url=undefined;

			if(this.titleNode.firstChild){
				this.titleNode.firstChild.data=" ";
			}
			this.containerNode.style.overflow='auto';
			this.containerNode.style.overflowX='auto';
			this.containerNode.style.overflowY='auto';
			this.containerNode.style.width="auto";
			this.layerContentNode.style.width="auto";
			this.containerNode.style.height="auto";
			this.innerButtonBarNode.style.display="none";
			this.tabBarNode.style.display="none";

			// remove containerNode children

			epages.html.removeChildren(this.containerNode);

			if(typeof this.options.content == "object" && this.options.destroyWidgetOnClose){
				this.options.content.destroy();   // destroy widget
			}
			this._contentWidget = null;
			this.options.content = "";
		},

		_createButtons: function(/* Object[] */ buttons) {
		// summary: create modal dialog buttons
		// buttons:
		// [{
		//   label: '{Delete}',
		//   cssClass: 'Active',
		//   buttonId: 'delete',
		//   hideOnShow: 'false',
		//   isDisabled: 'false',
		//   onclick: function() {
		//     me.deleteNavigationElement();
		//     this._modalDialogWidget.hide();
		//   }
		//  },{
		//    label: '{Cancel}',
		//    onclick: function() { this._modalDialogWidget.hide(); }
		// }]
			if(buttons.length){
				this.innerButtonBarNode.style.display="";
			}
			this.buttons = [];
			this._events = [];
			dojo.forEach(buttons, function (button) {
				button.domNode=[];
				var tmplProcessor=new epages.Template({
					template: this.buttonTemplateString,
					vars    : {
						'Label': button.label,
						'Class': button.cssClass ? button.cssClass : '',
						'buttonId': (button.buttonId) ? 'buttonid='+button.buttonId+' ' : ''
					}
				});
				var buttonNode= this.createNodesFromText(tmplProcessor.generateOutput());
				this.innerButtonBarNode.appendChild(buttonNode);
				button.domNode=buttonNode;
				dojo.mixin(button, {_modalDialogWidget: this, _contentWidget: this._contentWidget});
				this._events.push({ event: dojo.connect(button.domNode, "onclick", button, "onclick"), button : button});
				this.buttons.push(button);
				if(button.isDisabled == 'true'){
					this.disableButton(buttonNode);
				}
			}, this);
			this.clearFloatNode = document.createElement("div");
			this.clearFloatNode.className="ClearBoth";
			this.innerButtonBarNode.appendChild(this.clearFloatNode);
		},

		_destroyButtons: function () {
			dojo.forEach(this._events, function(evtmap) {
				dojo.disconnect(evtmap.event);
			});
			dojo.forEach(this.buttons, function (button) {
				button.domNode.parentNode.removeChild(button.domNode);
				button.domNode = undefined;
			});
			this._events = null;
			delete this._events;			// delete var
			this.buttons=[];
			if(this.clearFloatNode !== undefined && this.clearFloatNode.parentNode != null) {
				this.clearFloatNode.parentNode.removeChild(this.clearFloatNode);
				this.clearFloatNode = undefined;
			}
		},

		_createTabs: function() {
		// summary: creates tabs by looking for dom nodes with css class "TabPage"
		// description: tab labels ar specified by attribute ep_label of the dom node
			var tabs = epages.html.getElementsByClassName('TabPage',this.containerNode);
			if(tabs.length && tabs.length > 1){
				this.tabBarNode.style.display="";
				dojo.addClass(this.tabBarNode, "Visible");
				this._tabs = [];
				this._tabEvents = [];
				dojo.forEach(tabs, function (domNode) {
					var tab = {
						domNode : [],
						changeNode: domNode
					};
					var tmplProcessor = new epages.Template({
						template: this.tabTemplateString,
						vars    : {
							'Label': domNode.getAttribute('ep_label')
						}
					});
					var tabNode = this.createNodesFromText(tmplProcessor.generateOutput());
					this.tabBarNode.appendChild(tabNode);
					tab.domNode = tabNode;
					//dojo.mixin(tab, {_modalDialogWidget: this, _contentWidget: this._contentWidget});
					this._tabEvents.push(dojo.connect(tab.domNode, "onclick", this, "_onTabClick"));
					tab.changeNode.style.display = 'none';
					this._tabs.push(tab);
				}, this);
				//activate first tab
				this._tabs[0].changeNode.style.display = '';
				dojo.addClass(this._tabs[0].domNode, 'Active');
				this._currentTab = this._tabs[0];
			} else {
				dojo.removeClass(this.tabBarNode, "Visible");
			}
		},

		_destroyTabs: function () {
			dojo.forEach(this._tabEvents, dojo.disconnect);
			dojo.forEach(this._tabs, function (tab) {
				tab.domNode.parentNode.removeChild(tab.domNode);
				tab.domNode = undefined;
				tab.changeNode = undefined;
			});
			this._tabs=[];
			this._currentTab = undefined;
		},

		_onTabClick: function(evt){
			var targetTab = evt.currentTarget;
			var tab = undefined;
			for( var i=0,iLength=this._tabs.length ; i<iLength ; i++ ){
				if(targetTab == this._tabs[i].domNode){
					tab = this._tabs[i];
				}
			}
			if(tab){
				if(this._currentTab){
					dojo.removeClass(this._currentTab.domNode,'Active');
					this._currentTab.changeNode.style.display = 'none';
				}
				tab.changeNode.style.display = '';
				dojo.addClass(tab.domNode, 'Active');
				this._currentTab = tab;
				dojo.publish(this.id+"/tabChange",[tab.changeNode]);
			}
		}
	}
);

}

if(!dojo._hasResource["epages.widget.Tooltip"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Tooltip"] = true;
/*
	Copyright (c) 2006-2010, ePages GmbH
	All Rights Reserved.

	epages.widget.tooltip $Revision: 1.29 $
*/
dojo.provide("epages.widget.Tooltip");


dojo.declare("epages.widget.Tooltip", [dijit._Widget, dijit._Templated], {

		/**
		 * public properties
		 */
		disabledBodyClickHide : false,
		tooltipLayerFrame     : undefined,
		tooltipAreaId         : '',
		tooltipArea           : undefined,
		tooltipNode           : undefined,
		interactive           : '',	// String - Is the user able to use the content of the tooltip? i.e. if there's links in the tooltip text
		tooltipShowDelay      : 0,
		tooltipHideDelay      : 0,
		currentYPosition      : 0,
		currentXPosition      : 0,
		hideDelay             : null,
		fadeDelay             : null,
		showDelay             : null,
		bgcolor               : '',
		forceOrientation      : '',	// String - B - bottom, T - top , L - left, R - right (combinations are possible e.g BR)
		target                : "default",
		findAreaMethod        : "",

		/**
		 * private properties
		 */
		_findAreaMethodMapping: {
			'default'           : 'parentNode',
			'previous'          : 'previousSibling',
			'next'              : 'nextSibling'
		},													// Object - which node should be used to connect to the tooltip activation events (mouseover-area)
		_doc                  :	null,				// DomNode - owner document, i.e. to calculate the widget position
		_bodyConnect          : undefined,	// to store event connect to document's body, i.e. for hiding the tooltip when clicked somewhere else on the page
		_windowConnect        : undefined,	// to store event connect to the window for capturing keypress events

		/**
		 * dojo widget properties
		 */
		templateString        : '<div class="Tooltip"><div dojoAttachPoint="containerNode"></div></div>',


		/**
		 * dojo lifecycle methods
		 */
		postCreate: function() {
			// summary: widget lifecycle postCreate handler
			// description:
			//		Initializes widget parameters and find dom element for displaying the tooltip widget
			//		(see _findAreaMethodMapping values). Then create dom elements for the tooltip bubble
			//		and connect the keyboard/mouse event handlers.
			this.inherited("postCreate", arguments);
			this.tooltipNode = this.domNode;
			// catch tooltip area node
			var tooltipArea = undefined;
			if(this.tooltipArea) {
				tooltipArea = this.tooltipArea;
			}
			else if(this.tooltipAreaId!="") {
				tooltipArea= $(this.tooltipAreaId);
			}
			else {
				var findAreaMethod = this._findAreaMethodMapping[this.findAreaMethod || this.target];
				tooltipArea = this.domNode[findAreaMethod];
				if(tooltipArea.nodeType!= 1) {
					if(findAreaMethod == 'previousSibling') {
						tooltipArea=tooltipArea.previousSibling; // skip spaces
					}
					if(findAreaMethod == 'nextSibling') {
						tooltipArea=tooltipArea.nextSibling;     // skip spaces
					}
				}
			}

			if(this.bgcolor !=''){
				this.domNode.style.backgroundColor = this.bgcolor;
			}

			if(!tooltipArea || tooltipArea.nodeType!=1 ){
				console.warn('TooltipArea not found by using find method "'+this.findAreaMethod+'" in '+this.declaredClass);
			} else {
				this.tooltipArea = tooltipArea;
				this._doc = this.tooltipArea.ownerDocument;
				this.tooltipIsInteractive = epages.string.toBoolean(this.interactive);
				this.tooltipShowDelay = 600;
				this.tooltipHideDelay = this.tooltipIsInteractive ? 1400 : 400;
				this.tooltipLayerFrame = this._doc.createElement("div");
				this.tooltipShadow = this._doc.createElement("div");
				dojo.style(this.tooltipNode, "opacity", 0);

				this._bodyConnect = dojo.connect(dojo.body(),"onmouseup",this, "onBodyClick");
				this._windowConnect = dojo.connect(window,"onkeypress", this,"onKeypress");
				this.connect(this.tooltipArea, "onmousemove", "onElementMove");
				this.connect(this.tooltipArea, "onmouseover", "onElementOver");
				this.connect(this.tooltipArea, "onmouseout", "onElementOut");
				this.connect(this.tooltipArea, "onmousedown", "onElementClick");
				if(this.tooltipIsInteractive) {
					this.connect(this.tooltipNode, "onmouseover", "onTooltipOver");
					this.connect(this.tooltipNode, "onmouseout", "onTooltipOut");
				}
			}
		},

		destroy: function(){
			// summary: widget lifecycle destroy handler
			// description:
			//		Disconnect event handlers to body and window of the widget-containing document.
			this.inherited("destroy", arguments);
			dojo.disconnect(this._bodyConnect);
			dojo.disconnect(this._windowConnect);
		},


		/**
		 * public methods
		 */
		setContent: function(/* string */ html) {
			this.containerNode.innerHTML=html;
			this.setPosition();
		},

		isActive: function() {
			// summary: Is the tooltip dom node visible?
			// returns:  false if zero opacity, otherwise true
			return dojo.style(this.tooltipNode, "opacity") == 0? false : true;
		},

		setPosition: function() {
			// summary: Move the tooltip
			// description:
			//		Depending on the orientation mode set by the forceOrientation variable move the tooltip
			//		domNode to the position determined by currentYPosition and currentXPosition. This depends
			//		on the document parenting the tooltip node as well as possible window scroll bars.
			var forceRight  = (this.forceOrientation.match('R')) ? true : false;
			var forceLeft   = (this.forceOrientation.match('L')) ? true : false;
			var forceBottom = (this.forceOrientation.match('B')) ? true : false;
			var forceTop    = (this.forceOrientation.match('T')) ? true : false;

			// horizontal position
			var docWidth = epages.Browser.engine == "WebKit" ? this._doc.body.clientWidth : this._doc.documentElement.clientWidth;
			var rightSideX = this.tooltipNode.offsetWidth + this.currentXPosition + 16 + 3 - (this._doc.documentElement.scrollLeft || this._doc.body.scrollLeft);	// 16px = dist. from mouse ; 3px = shadow iframe
			if((rightSideX > docWidth && ! forceRight) || forceLeft) {
				var x = this.currentXPosition - this.tooltipNode.offsetWidth;
				if(forceLeft){
					x-=16;
				}
				if(x < 0){
					x=0;
				}
				this.tooltipNode.style.left = x + "px";			// layer > left align
			} else {
				var x = this.currentXPosition;
				if(forceRight){
					x+=16;
				}
				this.tooltipNode.style.left = x + "px";			// layer > right align
			}

			// vertical position
			var docHeight = epages.Browser.engine == "WebKit" ? this._doc.body.clientHeight : this._doc.documentElement.clientHeight;
			var bottomSideX = this.tooltipNode.offsetHeight + this.currentYPosition + 16 + 3 - (this._doc.documentElement.scrollTop || this._doc.body.scrollTop);
			if((bottomSideX > docHeight && ! forceBottom) || forceTop) { // 16px = dist. from mouse ; 3px = shadow iframe
				var y = this.currentYPosition - this.tooltipNode.offsetHeight - 16;
				if(y < 0){
					y=0;
				}
				this.tooltipNode.style.top =  y + "px";														// layer > top align
			}else{
				this.tooltipNode.style.top = this.currentYPosition + 16 + "px";		// layer > bottom align
			}
			this.tooltipLayerFrame.style.width = this.tooltipNode.offsetWidth + 2 + "px";
			this.tooltipLayerFrame.style.height = this.tooltipNode.offsetHeight + 2 + "px";
		},

		show: function(/* int */ x, /* int */ y) {
			// summary: Set position & display the Tooltip
			// description:
			//		Update the tooltip position and triggers the display of the tooltip.
			this.currentXPosition = x;
			this.currentYPosition = y;
			this.showTooltip();
		},

		showTooltip: function() {
			// summary: Display the Tooltip
			// description:
			//		Hide the tooltip dom node before changing it. Then attach the layout classes and move the
			//		tooltip frame to front. Finally attach the tooltip node to the dom tree and display it.
			dojo.addClass(this.tooltipNode, "HideElement");
			if(!this.rendered){
				dojo.addClass(this.tooltipNode, "Tooltip");
				dojo.addClass(this.tooltipShadow, "TooltipShadow");
				dojo.addClass(this.tooltipLayerFrame, "LayerIframe");
				if(!this.tooltipIsInteractive) {
					this.tooltipLayerFrame.style.zIndex = "1";
					this.tooltipNode.style.MozUserSelect = 'none';
				}
				this.tooltipNode.appendChild(this.tooltipLayerFrame); // overlay
				this.tooltipNode.appendChild(this.tooltipShadow);
				this._doc.getElementsByTagName("body")[0].appendChild(this.tooltipNode);
				this.rendered = true;
			}

			var _this = this;

			if( this.fadeAction ) {
				this.fadeAction.stop();
			}

			this.fadeAction = dojo.fadeIn({
				node: this.tooltipNode,
				duration:200,
				beforeBegin: function() {
					_this.tooltipNode.style.display = "block";
					_this.setPosition();
					dojo.removeClass(_this.tooltipNode, "HideElement");
				}
			});
			this.fadeAction.play();
		},

		hide: function() {
			// summary: Hide the Tooltip
			// description:
			//		After a fade, hide the tooltip.
			var _this = this;
			if( this.fadeAction ) {
				this.fadeAction.stop();
			}

			this.fadeAction = dojo.fadeOut({
				node:this.tooltipNode,
				duration: 200,
				onEnd: function() {
					_this.tooltipNode.style.display = "none";
				}
			});
			this.fadeAction.play();
		},


		/**
		 * Event handlers
		 */
		onElementMove: function(mouseEvent) {
			if(!mouseEvent){
				var mouseEvent = window.event;
			}
			this.currentYPosition = mouseEvent.clientY + (this._doc.documentElement.scrollTop || this._doc.body.scrollTop);
			this.currentXPosition = mouseEvent.clientX + (this._doc.documentElement.scrollLeft || this._doc.body.scrollLeft);
		},
		onElementOver: function() {
			this.disabledBodyClickHide = true;
			this._resetTimeouts();
			if(!this.isActive()) {
				this.showDelay = this._delayExec(this.showTooltip, this.tooltipShowDelay);
			}
		},
		onElementOut: function() {
			this._resetTimeouts();
			this.fadeDelay = this._delayExec(this.hide, this.tooltipHideDelay);
			this.disabledBodyClickHide = false;
		},
		onElementClick: function() {
			this.disabledBodyClickHide = true;
			if(!this.isActive()) {
				this._resetTimeouts();
				this.showTooltip();
			}
		},
		onTooltipOver: function() {
			this.disabledBodyClickHide = true;
			this._resetTimeouts();
		},
		onTooltipOut: function() {
			this.disabledBodyClickHide = false;
			this.onElementOut();
		},
		onBodyClick: function() {
			if(!this.disabledBodyClickHide && this.isActive()) {
				this._resetTimeouts();
				this.hide();
			}
		},
		onKeypress: function(evt) {
			if(evt.keyCode == dojo.keys.ESCAPE) {
				this._resetTimeouts();
				this.hide();
			}
		},


		/**
		 * private methods
		 */
		_delayExec: function(task, delay) {
			return setTimeout(dojo.hitch(this, task), delay);
		},
		_resetTimeouts: function() {
			clearTimeout(this.hideDelay);
			clearTimeout(this.fadeDelay);
			clearTimeout(this.showDelay);
		}

	}
);

}

if(!dojo._hasResource["epages.widget.Message"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Message"] = true;
dojo.provide("epages.widget.Message");




dojo.declare("epages.widget.Message",
	[dijit._Widget,dijit._Templated],
	{
		/**
		 * public properties
		 */
		headline: "",
		message: "",
		sizeClass: "Small",
		typeClass: "Info",
		borderClass: "",
		loderAniNode : undefined,

		/**
		 * dojo widget properties
		 */
		templateString:"<div class=\"Message ${sizeClass} ${typeClass} ${borderClass}\">\n  <div class=\"Headline\" dojoAttachPoint=\"headlineNode\">${headline}</div>\n  <div class=\"MessageDetails\" dojoAttachPoint=\"messageNode\">${message}</div>\n</div>\n",

		show: function() {
			this.domNode.style.display="block";
		},

		hide: function() {
			this.domNode.style.display="none";
		},

		postCreate: function() {
			this.inherited("postCreate", arguments);
			this.setupContent({
				headline: this.headline,
				message: this.message,
				sizeClass: this.sizeClass,
				typeClass: this.typeClass,
				borderClass: this.borderClass
			});
		},

		setupContent: function(/*Object*/opt) {
		// summary: set up new content / change content
		// opt: {
		//        headline - sting
		//        message - string
		//        sizeClass - string: Small, Medium, Large
		//        typeClass - string: Error, Warning, Notification, Question, Tip, Confirmation
		//        borderClass - string -> your css class
		//      }

			if(opt.headline !== undefined && opt.headline!="") {
				this.headline=opt.headline;
				this.headlineNode.innerHTML=opt.headline;
				this.headlineNode.style.display="";
			} else
				this.headlineNode.style.display="none";

			if(opt.message !== undefined && opt.message!="") {
				this.message=opt.message;
				this.messageNode.innerHTML=opt.message;
				this.messageNode.style.display="";
				dojo.parser.parse(this.messageNode);
			} else
				this.messageNode.style.display="none";

			if(opt.sizeClass !== undefined) {
				epages.html.replaceClass(this.domNode, opt.sizeClass, this.sizeClass);
				this.sizeClass = opt.sizeClass;
			}
			if(opt.typeClass !== undefined) {
				epages.html.replaceClass(this.domNode, opt.typeClass, this.typeClass);
				this.typeClass = opt.typeClass;

				if(this.loderAniNode !== undefined && opt.typeClass != "Loader") {
					epages.loaderani.destroy(this.loderAniNode);
				}
				if(opt.typeClass == "Loader") {
					var lani_options = {
						top: 14,
						left: 14,
						width: 24,
						height: 24
					}
					this.domNode.style.position="relative";
					this.loderAniNode = epages.loaderani.create(lani_options, this.domNode);
				}
			}

			if(opt.borderClass !== undefined) {
				epages.html.replaceClass(this.domNode, opt.borderClass, this.borderClass);
				this.borderClass = opt.borderClass;
			}
		}
	}
);

}

if(!dojo._hasResource["epages.widget.Bubble"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Bubble"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.
*/
dojo.provide("epages.widget.Bubble");



dojo.declare("epages.widget.Bubble", [dijit._Widget, dijit._Templated],	{
		optionsstring   : "",              // string - setup options as string
		options         : undefined,       // object - setup options (see setupContent for more)
		typeClass       : "",              // string - (Additional css class e.g. Wide)

		/* widget properties */
		templateString:"<div class=\"Bubble ${typeClass}\">\n  <div class=\"LayerOverIframe\" dojoAttachPoint=\"layerOverIframeNode\">\n    <div class=\"BubbleLayer\">\n      <div class=\"BubbleClose\" dojoAttachPoint=\"closeNode\"></div>\n      <div dojoAttachPoint=\"containerNode\"></div>\n    </div>\n    <div class=\"BubbleFoot\"></div>\n  </div>\n</div>\n",

		/* widget life cycle */
		postMixInProperties: function() {
			this.inherited("postMixInProperties", arguments);
			// prepare settings
			if(this.options===undefined){
				this.options = { content: '' };
			}

			var optFromString = (this.optionsstring != "" ) ? dojo.fromJson(this.optionsstring) : undefined;
			if(optFromString) {
				dojo.mixin(this.options, optFromString);
			}
		},

		postCreate: function() {
			this.inherited("postCreate", arguments);
			this.setupContent(this.options);
			// events
			this.connect(this.closeNode, 'onclick', 'hide');
			this.connect(window, "onkeypress", "onKeypress");
			this.connect(window, "onresize", "hide");
			this.connect(document.body, "onkeypress", "onKeypress");
		},

		/* public methods */

		setupContent: function(/*Object*/opt) {
			// summary: setup bubble content
			// opt:{
			//       content     - widget, string
			//       x           - integer
			//       y           - integer
			//       typeClass   - string (Additional css class e.g. Wide)
			//       orientation - string -> specifies the location of the bubble arrow (left right bottom top-right)
			//     }

			// mix in options
			if(opt) {
				dojo.mixin(this.options, opt);
			}

			// remove old nodes
			while(this.containerNode.firstChild){
				this.containerNode.removeChild(this.containerNode.firstChild);
			}

			// set content
			if(this.options.content) {
				if(typeof this.options.content == "object" && this.options.content.domNode != undefined) {
					// is widget
					this.containerNode.appendChild(this.options.content.domNode);
				} else if(typeof this.options.content == "string") {
					// is string
					this.containerNode.innerHTML = this.options.content;
				} else if (typeof this.options.content == "object" && this.options.content.nodeType){
					this.containerNode.appendChild(this.options.content);
				} else {
					console.warn('Bubble.setupContent needs a domnode a widget or a string as content.');
				}
			}

			var xOffset = 0;
			var yOffset = 0;

			if(this.options.orientation=="" || this.options.orientation=="top") {
				dojo.removeClass(this.domNode, "Left");
				dojo.removeClass(this.domNode, "Right");
				dojo.removeClass(this.domNode, "TopRight");
				dojo.removeClass(this.domNode, "Bottom");
			}

			if(this.options.orientation == "top-right") {
				var typeClass = this.options.typeClass;

				if(typeClass && typeClass.match("Wide")) {
					xOffset = -330;
				} else {
					xOffset = -230;
				}

				dojo.addClass(this.domNode, "TopRight");
				dojo.removeClass(this.domNode, "Left");
				dojo.removeClass(this.domNode, "Bottom");
				dojo.removeClass(this.domNode, "Right");
			}

			if(this.options.orientation == "right") {
				var typeClass = this.options.typeClass;

				if(typeClass && typeClass.match("Wide")) {
					xOffset = -380;
				} else {
					xOffset = -280;
				}

				yOffset = -24;
				dojo.addClass(this.domNode, "Right");
				dojo.removeClass(this.domNode, "Left");
				dojo.removeClass(this.domNode, "Bottom");
				dojo.removeClass(this.domNode, "TopRight");
			}

			if(this.options.orientation == "left") {
				yOffset = -24;
				dojo.addClass(this.domNode, "Left");
				dojo.removeClass(this.domNode, "Right");
				dojo.removeClass(this.domNode, "Bottom");
				dojo.removeClass(this.domNode, "TopRight");
			}

			if(this.options.orientation == "bottom" ) {
				dojo.addClass(this.domNode, "Bottom");
				dojo.removeClass(this.domNode, "Left");
				dojo.removeClass(this.domNode, "Right");
				dojo.removeClass(this.domNode, "TopRight");
			}

			// set position
			if(this.options.x !== undefined && this.options.y !== undefined) {
				$E(this.domNode).setCss({
					'left': 		(this.options.x + xOffset) + 'px',
					'top': 			(this.options.y + yOffset) + 'px',
					'zIndex': 	99998
				});
			}
			// replace css class
			if(this.options.typeClass !== undefined) {
				dojo.removeClass(this.domNode, this.typeClass);
				dojo.addClass(this.domNode, this.options.typeClass);
				this.typeClass = this.options.typeClass;
			}
		},

		show: function() {
		// summary: function to show the bubble
			if(this.options.orientation == "bottom") {
				this.domNode.style.visibility = 'hidden';
				this.domNode.style.display = 'block';
					var curHeight = this.layerOverIframeNode.offsetHeight || this.layerOverIframe.clientHeight;
					$E(this.domNode).setCss({
						'top': (this.options.y - curHeight) + 'px',
						visibility: 'visible'
					});
			} else {
				this.domNode.style.display = 'block';
			}
		},

		hide: function() {
		// summary: function to hide the bubble
			this.domNode.style.display = 'none';
		},

		/* events */
		onKeypress: function(evt) {
		// summary: keypress event controller
			if(evt.keyCode == dojo.keys.ESCAPE) {
				this.hide();
			}
		}
	}
);

}

if(!dojo._hasResource["epages.uimessagehandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.uimessagehandler"] = true;
dojo.provide("epages.uimessagehandler");








dojo.mixin( epages.uimessagehandler, {
	template :'<div id="busyMessageLayer" style="position: absolute; left:0px; top:0px; height: 100%; width: 100%; z-index: 100000; overflow: auto; display: none;">' +
						'<div id="busyMessageUnderlay" class="ui-widget-overlay"  style="position: absolute; left:0px; top:0px; height: 100%; width: 100%; z-index: 99999;" ></div>' +
						'<div id="busyMessageBox" style="position: relative; left:0px; top:300px; z-index: 100000; max-width: 200px; overflow: visible; margin: auto;">' +
						'<div class="Layer"><div id="busyMessagePropertyContainer" class="PropertyContainer" style="height:45px;padding-top:1px;"><div id="busyMessage"></div>' +
						'</div></div><div class="LayerFooter"><div class="PropertyContainer"></div></div></div></div>',
	fadeOutBusyLayer: function(duration) {

		dojo.fx.combine([
			dojo.fadeOut({
				node:$('busyMessageLayer'),
				onEnd: function() {
					$('busyMessageLayer').style.display='none';
					if(document.all) {
						dojo.body().parentNode.style.overflow = "auto";
					}
				},
				duration: duration ? duration : 1000
			})
		]).play();
	},
	rePositionBusy: function() {
		if($("busyMessageLayer")) {
			$("busyMessageLayer").style.top = (window.pageYOffset || document.getElementsByTagName("html")[0].scrollTop) + "px";
		}
	},
	errorsToString : function(errors) {
		var errorMessage = '';
		for(var el in errors) {
			if(errors[el].Message != "") {
				errorMessage += errors[el].Message+"<br />";
			} else {
				var t = epages.io.dictionary.get(errors[el].Reason);
				if(t === undefined){
					t=errors[el].Reason;
				}
				errorMessage += t+"<br />";
			}
		}
		return errorMessage;
	}
});

dojo.subscribe("uimessage/show", function(/* String */headline, /* String */message, /* String */ type, /* Object */ opt) {
/*
	headline -> string
	message  -> string
	type     -> string: Bubble, Dialog, Insert
	options  -> object

options type: Bubble
	* x          -> number
	* y	  	     -> number
	* typeClass  -> string: Error, Warning, Notification, Question, Tip
	* sizeClass  -> string: Large, Medium, Small
	* attachNode -> dom node (bubble will be attached as childnode) (optional)

options type: Insert
	* targetNode -> DOM object
	* typeClass  -> string: Error, Warning, Notification, Question, Tip, Confirmation
	* sizeClass  -> string: Large, Medium, Small

options type: Dialog
	* titleBar   -> string
	* typeClass  -> string: Error, Warning, Notification, Question, Tip, Confirmation
	* sizeClass  -> string: Large, Medium, Small
	* buttons    -> array: see ModalDialog widget
	* width      -> number: width of dialog
*/

	var sizeClass = (opt.sizeClass !== undefined) ? opt.sizeClass : "Large";
	var typeClass = (opt.typeClass !== undefined) ? opt.typeClass : "Warning";

	// hide old dialog / bubble
	if($$('uimessage_dialog')){ $$('uimessage_dialog').hide(); }
	if($$('uimessage_bubble')){ $$('uimessage_bubble').hide(); }

	var messageWidget = $$('uimessage_insert');

	if(messageWidget === undefined) {
		messageWidget = new epages.widget.Message({
			id: "uimessage_insert",
			headline: (headline !== undefined) ? headline : "",
			message:   message,
			sizeClass: sizeClass,
			typeClass: typeClass,
			borderClass: (type=='Insert') ? "WithBorder" : ""
		});
	} else {
		messageWidget.hide();
		messageWidget.setupContent({
			headline: headline,
			message: message,
			sizeClass: sizeClass,
			typeClass: typeClass,
			borderClass: (type=='Insert') ? "WithBorder" : ""
		});
	}
	messageWidget.show();
	switch(type) {
		case "Bubble":
			var bubbleWidget = $$('uimessage_bubble');
			var attachNode = opt.attachNode || document.body;
			// if not given, determine x and y by element
			if ((opt.x == null || opt.y == null) && opt.element != null) {
				var absPos = $E(opt.element).getAbsolutePosition(opt.baseNode);
				opt.x = opt.x || (absPos.x + opt.element.offsetWidth / 2);
				opt.y = opt.y || (absPos.y + opt.element.offsetHeight);
			}
			if(bubbleWidget === undefined) {
				
				bubbleWidget = new epages.widget.Bubble({
					id: "uimessage_bubble",
					options:{
						x : opt.x,
						y : opt.y,
						typeClass: typeClass,
						content: messageWidget,
						orientation: opt.orientation
					}
				});
				attachNode.appendChild(bubbleWidget.domNode);
			} else {
				bubbleWidget.setupContent({
					x : opt.x,
					y : opt.y,
					typeClass: typeClass,
					content: messageWidget,
					orientation: opt.orientation
				});
				attachNode.appendChild(bubbleWidget.domNode);
			}
			bubbleWidget.show();
			break;
		case "Insert":
			if(opt.targetNode !== undefined) {
				opt.targetNode.appendChild($$('uimessage_insert').domNode);
			} else {
				console.warn("uimessage/show: opt.targetNode is undefined");
			}
			break;
		default:
			var buttons = opt.buttons;
			if (buttons === undefined) {
					var translation = epages.io.dictionary.translation;
					buttons = typeClass == 'Confirmation' ?
					[{
						label: translation.get('Yes'),
						onclick: function() {
							this._modalDialogWidget.hide();
							if (typeof opt.onYes == 'function'){
								opt.onYes();
							}
						}
					},{
						label: translation.get('No'),
						onclick: function() {
							this._modalDialogWidget.hide();
							if (typeof opt.onNo == 'function'){
								opt.onNo();
							}
						}
					}] :
					[{
						label: translation.get('Close'),
						onclick: function() { this._modalDialogWidget.hide(); }
					}];
			}
			var title= opt.titleBar;
			if (title === undefined) {
				title = epages.io.dictionary.translation.get(typeClass);
			}

			var uid = $$('uimessage_dialog');
			if(uid === undefined) {
				
				uid = new epages.widget.Modaldialog({
					id: "uimessage_dialog",
					options:{
						title : title,
						width : (opt.width) ? opt.width : 450,
						content: messageWidget
					},
					buttons: buttons
				});
				document.body.appendChild(uid.domNode);
			} else {
				uid.containerNode.appendChild(messageWidget.domNode);
				uid.setupContent({
					title: title,
					width : 450,
					content: messageWidget,
					buttons: buttons
				});
			}
			uid.show();
			break;
	}
});

dojo.subscribe("uimessage/hide", function(opt) {
	if($$('uimessage_dialog')){ $$('uimessage_dialog').hide(); }
	if($$('uimessage_bubble')){ $$('uimessage_bubble').hide(); }
	if($$('uimessage_insert')){ $$('uimessage_insert').hide(); }
});

dojo.subscribe("uimessage/startBusy", function(/* * */ owner, /* ?HTML String */ message, /* ?url */ iconUrl) {

	epages.uimessagehandler.busyLayerOwner = owner;
	epages.vars.BusyLayerActive = true;
	if(message === undefined){
		var translation = epages.io.dictionary.translation;
		message = translation.get('PleaseWait');
	}

	var bodyNode = document.getElementsByTagName("body")[0];

	if(document.all) {
		bodyNode.parentNode.style.overflow = "hidden";
	}

	var busyUnderlay=$('busyMessageLayer');
	if(busyUnderlay == null) {
		busyUnderlay= document.createElement("div");
		busyUnderlay.innerHTML = epages.uimessagehandler.template;
		bodyNode.appendChild(busyUnderlay.firstChild);
		busyUnderlay=busyUnderlay.firstChild;
	}
	$('busyMessageLayer').style.display='';
	dojo.style($('busyMessageLayer'), "opacity", 1);

	if($('busyMessage').getElementsByTagName("div")[0]) {
		$('busyMessage').removeChild($('busyMessage').getElementsByTagName("div")[0]);
	}
	var container = document.createElement("div");
	container.innerHTML = message;
	$('busyMessage').appendChild(container);

	if(iconUrl) {
		$('busyMessage').style.backgroundImage="url(" + iconUrl + ")";
		if($('busyMessage').style.filter) {
		}
		$('busyMessage').style.backgroundRepeat="no-repeat";
		$('busyMessage').style.minHeight="40px";
		$("busyMessagePropertyContainer").style.height = "58px";
	}else {
		$("busyMessagePropertyContainer").style.height = "48px";
	}

	epages.uimessagehandler.rePositionBusy();


});

dojo.subscribe("uimessage/showErrors", function(/* String */headline, /* String */titlebar, /* Object */ errors) {
	var errorMessage = epages.uimessagehandler.errorsToString(errors);

	dojo.publish("uimessage/show", [headline, errorMessage, "Dialog" , {
		titleBar  : titlebar,
		typeClass : "Error"
	}]);
});

dojo.subscribe("uimessage/showErrorBubble", function(/* String */headline, /* String */attachNode, /* Object */ errors, /* string ?*/ typeClass) {
	var tc = (typeClass) ? typeClass : "Error";
	var errorMessage = epages.uimessagehandler.errorsToString(errors);
	var pos = $E(attachNode).getAbsolutePosition();
	dojo.publish("uimessage/show", [headline, errorMessage, "Bubble" , {
		typeClass : tc,
		sizeClass : "Small",
		x: pos.x,
		y: pos.y + attachNode.clientHeight + 4
	}]);
});

dojo.subscribe("uimessage/changeBusy", function(owner, message) {
	if(epages.uimessagehandler.busyLayerOwner == owner && top.$("busyMessage")) {
		if(epages.Browser.engine == "MSIE") {
			$('busyMessage').style.display = "inline-block";
		}
		if($('busyMessage').getElementsByTagName("div")[0]) {
			$('busyMessage').removeChild($('busyMessage').getElementsByTagName("div")[0]);
		}
		var container = document.createElement("div");
		container.innerHTML = message;
		$('busyMessage').appendChild(container);
		if(epages.Browser.engine == "MSIE") {
			$('busyMessage').style.display = "block";
		}
	}
});

dojo.subscribe("uimessage/stopBusy", function(owner, timeout, duration) {
	if(epages.uimessagehandler.busyLayerOwner == owner) {
		if(timeout) {
			window.setTimeout(function() {
				epages.vars.BusyLayerActive = false;
				epages.uimessagehandler.fadeOutBusyLayer(duration);
				}, timeout);
		}else {
			epages.vars.BusyLayerActive = false;
			epages.uimessagehandler.fadeOutBusyLayer(duration);
		}
	}
});

dojo.connect(window, "scroll", this, epages.uimessagehandler.rePositionBusy);

}

if(!dojo._hasResource["epages.cartridges.de_epages.presentation.richtext"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.presentation.richtext"] = true;
dojo.provide("epages.cartridges.de_epages.presentation.richtext");




epages.cartridges.de_epages.presentation.richtext = {

	// reference to opened editor
	_editor: null,
	_translation: new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.presentation', "templates/translation"), "auto"),

	_HEIGHT : 480,
	_WIDTH : 900,

	// stub for overloading
	getValue: function(value) {
		return value;
	},

	setValue: function(value){
		return value;
	},

	cleanUp: function(value, insertCompleteUrl) {
		if (insertCompleteUrl) {
			value = value.replace(/((?:src|href)\s*=\s*[\'\"])(.*?)([\'\"])/ig, function(match, beforeUrl, url, afterUrl) {
				if(url.match(/^mailto\:/i)){
					//ignore mailto:
					return beforeUrl + url + afterUrl;
				}
				// ignore attachments
				if (!url.match(/^cid\:/i)) {
					url = epages.lang.uri.parts(url);
					if (!url.host && !url.path && !url.query && url.anchor){
						return match;
					}
					var baseUrl = epages.lang.uri.parts(epages.vars.StoreFrontUrl);
					if (!url.host) {
						if (url.path.match(/^\//)) {
							return beforeUrl + baseUrl.protocol + '://' + baseUrl.host + url.href + afterUrl;
						} else {
							return beforeUrl + baseUrl.protocol + '://' + baseUrl.host + url.href + afterUrl;
						}
					}
					return beforeUrl + url.href + afterUrl;
				}
				return beforeUrl + url + afterUrl;
			});
		}
		return value;
	},

	openDialog: function(options){
		epages.require('ep_shop_tree','dijit.Tree');
		epages.require('ep_shop_preview','epages.cartridges.de_epages.presentation.objectupdater');
		if (options.value == null){
			options.value = $(options.name).value;
		}
		// value is a callback
		if (typeof value == 'function'){
			options.value = options.value($(options.name).value);
		}
		if (options.siteId == null){
			options.siteId = epages.vars.SiteID;
		}
		if (options.title == null){
			options.title = $E(options.name).getLabel();
		}
		if (options.title == undefined){
			options.title = '';
		}
		options.title = this._translation.get('EditText')+': '+options.title;
		if (options.getValueCallback == null){
			options.getValueCallback = dojo.hitch(epages.cartridges.de_epages.presentation.richtext,"getValue");
		}
		if (options.setValueCallback == null){
			options.setValueCallback = dojo.hitch(epages.cartridges.de_epages.presentation.richtext,"setValue");
		}
		var modalDialog = $$('epages.cartridges.de_epages.presentation.richtext.modalDialog');
		var buttons = [{
			label: '{Apply}',
			cssClass: 'Active',
			onclick: function() {
				var rt = epages.cartridges.de_epages.presentation.richtext;
				var input = $(options.name);
				input.value = rt.cleanUp(options.getValueCallback(rt._editor.getContent()), options.insertCompleteUrl);
				if(options.savePage) {
					if (input.form.onsubmit){
						input.form.onsubmit();
					}
					input.form.submit();
				} else {
					epages.event.fire(input, "change");
				}
				this._modalDialogWidget.hide();
			}
		},{
			label: '{Cancel}',
			onclick: function() { this._modalDialogWidget.hide(); }
		}];
		if (modalDialog == null) {
			var div = document.createElement('div');
			document.getElementsByTagName('body')[0].appendChild(div);
			
			var json = new epages.io.Json();
			var openerId = epages.vars.currentSelectedObjectID ? epages.vars.currentSelectedObjectID : new Date().getTime();
			try {
				var snippet = json.loadSync('?', {
					'ObjectID':           parent.epages.vars.ObjectID,
					'TemplateAction':     parent.epages.vars.ViewAction,
					'TemplateLanguageID': parent.epages.vars.Locale.languageId,
					'TemplateName':       'INC-RichTextEditor',
					'ViewAction':         'JSONSnippet',
					'UseAbsolutePath':		options.useAbsolutePath ? '1' : '0',
					'OpenerID' : openerId
				}).data.snippet;
			} catch (e) {
				throw new Error('Could not load richtext snippet. Reason: ' + e.message);
			}
			
			modalDialog = new epages.widget.Modaldialog({
				id:             'epages.cartridges.de_epages.presentation.richtext.modalDialog',
				options: {
					content:        snippet,
					width:          this._WIDTH,
					height:         this._HEIGHT,
					containerClass: 'NoPadding',
					title:					options.title
				},
				buttons:          buttons
			}, div);
			if(epages.TinyMCELicenceText !== undefined) {
				var copyRightDiv = document.createElement("div");
				copyRightDiv.className="TinyMCELicenceText";
				copyRightDiv.innerHTML = epages.TinyMCELicenceText;
				var innerButtonBarNode = modalDialog.innerButtonBarNode;
				innerButtonBarNode.insertBefore(copyRightDiv, innerButtonBarNode.firstChild);
			}
			var tinyToolBar = $('TinyMCETools'+openerId);
			if(tinyToolBar !== undefined) {
				dojo.removeClass(tinyToolBar, 'NavBarInvisible');
			}

			var rte = $('RichTextEditor');
			rte.value = options.setValueCallback(options.value);
			var settings = dojo.mixin(tinyMCE.settings, {
				width: "100%",//this._WIDTH,
				height: (this._HEIGHT - epages.vars.Layout && epages.vars.Layout.toolBarHeight ? epages.vars.Layout.toolBarHeight : 0),
				body_class: 'ShowVisualAid mceShowContent'
			});

			var editor = new tinymce.Editor('RichTextEditor', settings);
			editor.render();
			epages.cartridges.de_epages.presentation.richtext._editor = editor;
		} else {
			epages.cartridges.de_epages.presentation.richtext._editor.setContent(options.setValueCallback(options.value));
			modalDialog.setupButtons(buttons);
			modalDialog.setTitle(options.title);
		}

		if(options.initCallback) {
			options.initCallback(modalDialog);
		}

		modalDialog.show();

	}

};

}

if(!dojo._hasResource['epages.widget.ContentList']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.widget.ContentList'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.widget.ContentList $Revision: 1.13 $

*/

dojo.provide('epages.widget.ContentList');





/*
 add the class "NoRowSelector" to your element if you do not want to trigger the row selection for that specific element
 add the class "RowSelector" to your element if you explicitly want to trigger the row selection (even the element is an image / form element / whatever)
 add the class "NoSmallTableMode" to your table if the table is not meant to be displayed in this mode
*/
(function(dojo,undefined){

dojo.declare("epages.widget.ContentList", [dijit._Widget], {

	_getRelevantInputCell: function(tableRow) {
		var cellsInRow = tableRow.cells;
		for( var i=0,iLength=cellsInRow.length ; i<iLength ; i++ ) {
			var inputsInCell = cellsInRow[i].getElementsByTagName("input");
			for( var j=0,jLength=inputsInCell.length ; j<jLength ; j++ ) {
				if(inputsInCell[j] && inputsInCell[j].type != "hidden") {
					return cellsInRow[i];
				}
			}
		}
	},

	_calcCellWidth: function(cell) {
		if(cell.parentNode.parentNode.parentNode.className.match("ContentListForcedWidth")) {
			var tableHead = cell.parentNode.parentNode.parentNode.tHead.rows[0];
			var tableHeadCell = tableHead.cells[cell.cellIndex];
			if(!(tableHeadCell.className || "").match("Checkbox") && !(tableHeadCell.className || "").match("NoPadding") && tableHead.currentCellIndex != cell.cellIndex) {
				tableHead.currentCellIndex = cell.cellIndex;
				var parentWidth = tableHead.parentNode.parentNode.parentNode.offsetWidth;
				var tableWidth = tableHead.parentNode.parentNode.offsetWidth;
				tableWidth = ((parentWidth < tableWidth) ? parentWidth : tableWidth);
				var tableColumns = tableHead.cells.length;
				for(var i = 0; i < tableColumns; i++) {
					if(!(tableHead.cells[i].className || "").match("Checkbox")) {
						tableHead.cells[i].style.width = (tableWidth / tableColumns / 1.25) + "px";
					}
				}
				tableHeadCell.style.width = (tableWidth / tableColumns * 2) + "px";
			}
		}
	},

	_enableSmallTableMode: function(tableRows) {
		for( var i=0,iLength=tableRows.length ; i<iLength ; i++ ) {
			for( var j=0,jLength=tableRows[i].cells.length ; j<jLength ; j++ ) {
				this.connect(tableRows[i].cells[j], "mouseenter", function(evt) {
					this._calcCellWidth(evt.currentTarget);
				});
				this.connect(tableRows[i].cells[j], "mouseleave", function(evt) {
					var cell = evt.currentTarget;
					if(cell.parentNode.parentNode.parentNode.className.match("ContentListForcedWidth")) {
						var tableHead = cell.parentNode.parentNode.parentNode.tHead.rows[0];
						var tableHeadCell = tableHead.cells[cell.cellIndex];
						if(!(tableHeadCell.className || "").match("Checkbox") && !(tableHeadCell.className || "").match("NoPadding") && tableHead.currentCellIndex != cell.cellIndex) {
							tableHead.currentCellIndex = cell.cellIndex;
							for( var i=0,iLength=tableHead.cells.length ; i<iLength ; i++ ) {
								if(!(tableHead.cells[i].className || "").match("Checkbox")) {
									tableHead.cells[i].style.width = "auto";
								}
							}
						}
					}
				});
			}
		}
	},

	_setCheckTableMode: function() {
		var tRows = this.domNode.tBodies[0].rows;
		if(!this.domNode.className.match("NoSmallTableMode") && this.domNode.offsetWidth > this.domNode.parentNode.offsetWidth + 2) { //2px tolerance for the table border
			setTimeout(dojo.hitch(this, function() {
				if(!this.domNode.className.match("ContentListForcedWidth")) {
					this._enableSmallTableMode(this.domNode.rows);
					dojo.addClass(this.domNode, "ContentListForcedWidth");
				}
				if(tRows[1]) {
					var firstContentCell = tRows[1].cells[0].className.match("Checkbox") ? tRows[1].cells[1] : tRows[1].cells[0];
					this._calcCellWidth(firstContentCell);
				}
			}), 1);
		}
	},

	postCreate: function() {

		this.inherited("postCreate", arguments);

		this.domNode.className += " RowSelection" + (epages.Browser.engine == "MSIE" ? "" : " HideElement");

		this.connect(window, "resize", "_setCheckTableMode");
		dojo.subscribe("RightSidebar/afterShowSidebar", dojo.hitch(this, function() {
			setTimeout(dojo.hitch(this, function() {
				this._setCheckTableMode();
			}), 1);
		}));

		var tRows = this.domNode.tBodies[0].rows;

		for( var i=0,iLength=tRows.length ; i<iLength ; i++ ) {

			var relevantInputCell = this._getRelevantInputCell(tRows[i]);

			if(relevantInputCell) {
				// the listener does not know where to find the relevant inputs unless we mark the parent cell
				relevantInputCell.className += " RowSelectionInputCell";
				this.connect(tRows[i], "click", function(evt) {
					var currentTargetNode = evt.currentTarget;  // tr node
					var someThingSelected;
					if(document.selection && document.all) {
						someThingSelected = document.selection.createRange().text;
					}else {
						someThingSelected = window.getSelection.rangeCount;
					}
					var realTargetTag = evt.target.tagName.toLowerCase();
					// be sure that we don't override existing functionality
					if((evt.target.className.match("RowSelector") && !evt.target.className.match("NoRowSelector")) || (
							!someThingSelected &&
							realTargetTag != "a" &&
							realTargetTag != "input" &&
							realTargetTag != "select" &&
							realTargetTag != "option" &&
							realTargetTag != "textarea" &&
							realTargetTag != "img" &&
							realTargetTag != "label" &&
							!evt.target.className.match("NoRowSelector") &&
							!evt.target.className.match("Sprite"))
					) {
						var inputCell = null;
						if(realTargetTag == "td" && evt.target.getElementsByTagName("input").length > 0) {
							// the clicked element is a table cell and contains inputs
							// (although it is not our declarated cell)
							inputCell = evt.target;
						}else {
							// get the previous declarated cell (by class)
							var cells = currentTargetNode.getElementsByTagName("td");
							for( var i=0,iLength=cells.length ; i<iLength ; i++ ) {
								if(cells[i].className.match("RowSelectionInputCell")) {
									inputCell = cells[i];
									break;
								}
							}
						}
						var inputs = inputCell.getElementsByTagName("input");
						var radioInputs = 0;
						// precheck how many radio inputs given (for handling yes/no inputs)
						for( var i=0,iLength=inputs.length ; i<iLength ; i++ ) {
							if(inputs[i].className.match("Radio")) {
								radioInputs++;
							}
						}
						// now it's getting serious
						for( var i=0,iLength=inputs.length ; i<iLength ; i++ ) {
							if(!inputs[i].disabled && inputs[i].type != "hidden") {
								if(inputs[i].className.match("Radio")) {
									if(radioInputs > 1 && inputs[i].checked == false) {
										// it is a double radio input (yes/no)
										// (therefore we only activate the unchecked input)
										epages.event.fire(inputs[i], "click");
										break;
									}else {
										// it is a single radio input (content list selector)
										epages.event.fire(inputs[i], "click");
									}
								}else if(inputs[i].className.match("Checkbox")) {
									// it is a checkbox
									epages.event.fire(inputs[i], "click");
									if(!inputs[i].rowSelectEventSet) {
										inputs[i].rowSelectEventSet = true;
										this.connect(inputs[i], "click", function(evt) {
											if(evt.currentTarget.checked && epages.parentByTagName(evt.currentTarget,'td').cellIndex == 0) {
												dojo.addClass( epages.parentByTagName(evt.currentTarget,'tr'), "RowSelected");
											}else {
												dojo.removeClass( epages.parentByTagName(evt.currentTarget,'tr'), "RowSelected");
											}
										});
									}
								}else {
									// it is something else
									try {
										inputs[i].focus();
										inputs[i].select();
									}catch(e){}
									break;
								}
							}
						}
					}else if(!evt.target.rowSelectEventSet && realTargetTag == "input" && evt.target.className && evt.target.className.match("Checkbox")) {
						// we have to handle checkboxes even if the row never has been clicked before
						if(evt.target.checked && !epages.parentByTagName(evt.currentTarget,'td').cellIndex) {
							dojo.addClass( epages.parentByTagName(evt.currentTarget,'tr'), "RowSelected");
						}else {
							dojo.removeClass( epages.parentByTagName(evt.currentTarget,'tr'), "RowSelected");
						}
					}
				});
			}
		}
		setTimeout(dojo.hitch(this, function() {
			dojo.removeClass(this.domNode, "HideElement");
			this._setCheckTableMode();
		}), 1);
	}
});

})(dojo);

}

if(!dojo._hasResource['epages.validate.date']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.validate.date'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.validate.date $Revision: 1.10 $

*/

dojo.provide('epages.validate.date');




epages.validate.date.isTime = function(/*String*/timeString, /*String*/epagesPattern) {
	if (timeString == ''){
		return 'NO_VALUE';
	}
	var date;
	try {
		date = epages.string.toTime(timeString, epagesPattern);
	} catch (ex) {
		console.dir(ex);
		return 'INVALID_TIME';
	}
	// comment.translate:INVALID_TIME
	if (date === null){
		return 'INVALID_TIME';
	}
	return true;
};

epages.validate.date.isDate = function(/*String*/dateString, /*String*/epagesPattern) {
	if (dateString == ''){
		return 'NO_VALUE';
	}
	if (epagesPattern == null || epagesPattern.length == 0){
		epagesPattern = epages.vars.Locale.dateFormat;
	}
	var pattern = epages.localize.getDojoDateTimePattern(epagesPattern);
	try {
		var date = dojo.date.locale.parse(dateString, { selector: 'date', datePattern: pattern, timePattern: '' });
	} catch (ex) {
		return 'INVALID_DATE';
	}
	if (date === null){
		return 'INVALID_DATE';
	}
	return true;
};

epages.validate.date.isDateTime = function(/*String*/datetimeString, /*String*/epagesPattern) {
	if (datetimeString == ''){
		return 'NO_VALUE';
	}
	if (epagesPattern == null || epagesPattern.length == 0){
		epagesPattern = epages.vars.Locale.datetimeFormat;
	}
	var pattern = epages.localize.getDojoDateTimePattern(epagesPattern);
	try {
		var date = dojo.date.locale.parse(datetimeString, { selector: 'date', datePattern: pattern, timePattern: '' });
	} catch (ex) {
		return 'INVALID_DATETIME';
	}
	if (date === null){
		return 'INVALID_DATETIME';
	}
	return true;
};

}

if(!dojo._hasResource["epages.widget.Timespinner"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Timespinner"] = true;
dojo.provide("epages.widget.Timespinner");








dojo.declare(
	"epages.widget.Timespinner",
	[epages.widget.LocalizedWidget],
	{

		/**
		 * public properties
		 */
		templateString:"<span class=\"TimeSpinner EnableHover\">\n  <span class=\"Time\">\n    ${label} <input name=\"${name}\" type=\"text\" dojoAttachPoint=\"timeNode\" dojoAttachEvent=\"onkeyup:_onKeyUp, onchange:_onChange\" value=\"${value}\" />\n  </span>\n  <span class=\"ButtonWrapper\"><span class=\"TimeSpinnerButton\">\n      <span dojoAttachPoint=\"upNode\"   class=\"TimeSpinnerUpArrow EnableHover\"></span>\n      <span dojoAttachPoint=\"downNode\" class=\"TimeSpinnerDownArrow EnableHover\"></span>\n  </span></span>\n</span>\n",
		translationName : dojo.moduleUrl('epages', "translation"),

		delta:          5, // Integer - increment is 5 minutes by default
		value:          "",
		label:          "",
		name:           "",
		displayPattern: epages.vars.Locale.timeFormat     || "%H:%M", // String - epages time pattern
		emptyValueAllowed: true,
		initId: '',

		/**
		 * private
		 */
		_spinTimeout:           null, // timeout that holds the spinning function repetition (hold-down mouse key)
		_spinCounter:           0,    // counts the spins by the held-down mouse key to determine spinning speed
		_delta:                 0,    // this.delta in millisecs
		_spinIntervalFunction:  null, // function reference of the spinning function

		postMixInProperties: function() {
			if (typeof this.delta == 'string'){
				this.delta = new Number(this.delta);
			}
			if (this.delta<=0){
				this.delta = this.prototype.delta;
			}
			this._delta = this.delta * 60000; // calculate private delta, from mins to millisec
			this.emptyValueAllowed = epages.string.toBoolean(this.emptyValueAllowed);
		},

		postCreate: function() {
			// set initial value
			if (this.value != '') {
				var date = this.value;
				this.value = null;
				this.setValue(date);
			} else if (! this.emptyValueAllowed){
				// default is noon
				var date = new Date();
				date.setTime(43200000 + date.getTimezoneOffset() * 60000);
				this.value = null;
				this.setValue(date);
			} else {
				this.value = null;
			}

			this.connect(this.timeNode,   'focus', 'onFocus');
			this.connect(this.timeNode,   'blur', 'onBlur');

			// round time to closest possible position
			this.connect(this.upNode,   'mouseup', 'onMouseUp');
			this.connect(this.downNode, 'mouseup', 'onMouseUp');
			this.connect(this.upNode,   'mouseout', 'onMouseUp');
			this.connect(this.downNode, 'mouseout', 'onMouseUp');
			this.connect(this.upNode,   'mousedown', 'onMouseDown');
			this.connect(this.downNode, 'mousedown', 'onMouseDown');
		},

		onFocus: function() {
			dojo.addClass(this.domNode, "Focus");
		},

		onBlur: function() {
			dojo.removeClass(this.domNode, "Focus");
		},

		getValue: function() {
			// summary:
			//    returns the value as a date object, day is 1970-01-01
			return this.value;
		},

		setValue: function(/*Date*/date, /* booleab */ skipDisplay) {
			// summary:
			//    sets the time of Date into inputNode value and the internal property

			if (date === undefined){
				date = new Date();
			}
			else if (typeof date == "string") {
				date = epages.string.toTime(date, this.displayPattern);
				if(this.value) {	// fill up year, month, day
					date.setFullYear(this.value.getFullYear());
					date.setMonth(this.value.getMonth());
					date.setDate(this.value.getDate());
				}
			}
			if(!this.value || dojo.date.compare(date, this.value)){
				this.value = new Date(date);
				if(! skipDisplay){
					this.timeNode.value = epages.localize.formatDateTime(date, this.displayPattern);
				}
			}
			dojo.removeClass(this.timeNode, "DialogError");
			dojo.publish("uimessage/hide", []);
			dojo.publish(this.id + '/onChange', [date]);
		},

		onMouseDown: function(evt) {
			// summary:
			//    handle mousedowns on the spinner arrows
			var direction;
			if (evt.target == this.upNode) {
				direction = 1;
			} else if(evt.target == this.downNode) {
				direction = -1;
			} else {
				return;
			}
			this._spinIntervalFunction = dojo.hitch(this, function() {
				var speed = this._spinCounter > 5 ? this._spinCounter > 25 ? 25 : 55 : 200;
				this.spin(direction);
				this._spinCounter++;
				window.clearTimeout(this._spinTimeout);
				this._spinTimeout = undefined;
				this._spinTimeout = window.setTimeout(this._spinIntervalFunction, speed);
			});
			this._spinIntervalFunction();
		},

		onMouseUp: function() {
			// summary:
			//    stop spinning
			if(this._spinCounter){
				epages.event.fire(this.timeNode, 'change');
			}
			this._spinCounter = 0;
			window.clearTimeout(this._spinTimeout);
		},

		spin: function(direction) {
			// summary:
			//    spin the value by delta
			// direction: 
			//   | if > 0, spin up
			//   | if < 0, spin down
			//   | if = 0, do nothing

			// only spin, if date and direction are valid
			if (direction == 0){
				return;
			}
			var isValueChanged = false;

			if (this.value == null && this.timeNode.value != '') {
				var w = $$(this.initId);
				if (w) {
					this.value = w.value;
					isValueChanged = true;
				}
			}
			if (this.value == null && this.initId != '') {
				var w = $$(this.initId);
				if (w) {
					this.value = w.value;
					isValueChanged = true;
				}
			}
			if (this.value == null) {
				this.value = dojo.date.locale.parse('0', { selector: 'date', datePattern: 'HH', timePattern: '' });
				isValueChanged = true;
			}
			var date = new Date(this.value);
			if (isValueChanged){
				this.value=null;
			}else{ // set time via UTC in millisec - ensure that direction is either 1 or -1
				date.setTime(this.value.getTime() + this._delta * (direction / Math.abs(direction)));
			}

			this.setValue(date);
		},

		_onKeyUp: function(evt) {
			var newValue = evt.target.value;
			var isValid = epages.validate.date.isTime(newValue, this.displayPattern);
			if(isValid === true) {
				this.setValue(newValue, true);
			} else if(isValid == "NO_VALUE" && this.emptyValueAllowed) {
				dojo.removeClass(this.timeNode, "DialogError");
				dojo.publish("uimessage/hide", []);
				this.value = null;
			} else {
				dojo.addClass(this.timeNode, "DialogError");
			}
		},

		_onChange: function(evt) {
			//set 'px' as default-unit
			var newValue = evt.target.value;
			var isValid = epages.validate.date.isTime(newValue, this.displayPattern);

			var position=$E(this.timeNode).getRelativePosition();

			if(isValid != true && ! (isValid == "NO_VALUE" && this.emptyValueAllowed)) {
				//display Error-Box-Widget
				dojo.publish("uimessage/show", ["", this.translation.get(isValid), "Bubble", {
					typeClass: "Warning",
					sizeClass: "Small",
					x: position.x,
					y: position.y + this.timeNode.clientHeight + 4,
					attachNode: this.domNode.parentNode
				}]);
			}
		}
	}
);

}

if(!dojo._hasResource["dijit.Calendar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.Calendar"] = true;
dojo.provide("dijit.Calendar");








dojo.declare(
	"dijit.Calendar",
	[dijit._Widget, dijit._Templated],
	{
		// summary:
		//		A simple GUI for choosing a date in the context of a monthly calendar.
		//
		// description:
		//		A simple GUI for choosing a date in the context of a monthly calendar.
		//		This widget can't be used in a form because it doesn't serialize the date to an
		//		`<input>` field.  For a form element, use dijit.form.DateTextBox instead.
		//
		//		Note that the parser takes all dates attributes passed in the
		//		[RFC 3339 format](http://www.faqs.org/rfcs/rfc3339.html), e.g. `2005-06-30T08:05:00-07:00`
		//		so that they are serializable and locale-independent.
		//
		// example:
		//	|	var calendar = new dijit.Calendar({}, dojo.byId("calendarNode"));
		//
		// example:
		//	|	<div dojoType="dijit.Calendar"></div>

		templateString: dojo.cache("dijit", "templates/Calendar.html", "<table cellspacing=\"0\" cellpadding=\"0\" class=\"dijitCalendarContainer\" role=\"grid\" dojoAttachEvent=\"onkeypress: _onKeyPress\">\n\t<thead>\n\t\t<tr class=\"dijitReset dijitCalendarMonthContainer\" valign=\"top\">\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"decrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarDecrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"decreaseArrowNode\" class=\"dijitA11ySideArrow\">-</span>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' colspan=\"5\">\n\t\t\t\t<div class=\"dijitVisible\">\n\t\t\t\t\t<div class=\"dijitPopup dijitMenu dijitMenuPassive dijitHidden\" dojoAttachPoint=\"monthDropDown\" dojoAttachEvent=\"onmouseup: _onMonthSelect, onmouseover: _onMenuHover, onmouseout: _onMenuHover\">\n\t\t\t\t\t\t<div class=\"dijitCalendarMonthLabelTemplate dijitCalendarMonthLabel\"></div>\n\t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelSpacer\" class=\"dijitSpacer\"></div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelNode\" class=\"dijitCalendarMonthLabel dijitInline dijitVisible\" dojoAttachEvent=\"onmousedown: _onMonthToggle\"></div>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"incrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarIncrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"increaseArrowNode\" class=\"dijitA11ySideArrow\">+</span>\n\t\t\t</th>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<th class=\"dijitReset dijitCalendarDayLabelTemplate\" role=\"columnheader\"><span class=\"dijitCalendarDayLabel\"></span></th>\n\t\t</tr>\n\t</thead>\n\t<tbody dojoAttachEvent=\"onclick: _onDayClick, onmouseover: _onDayMouseOver, onmouseout: _onDayMouseOut\" class=\"dijitReset dijitCalendarBodyContainer\">\n\t\t<tr class=\"dijitReset dijitCalendarWeekTemplate\" role=\"row\">\n\t\t\t<td class=\"dijitReset dijitCalendarDateTemplate\" role=\"gridcell\"><span class=\"dijitCalendarDateLabel\"></span></td>\n\t\t</tr>\n\t</tbody>\n\t<tfoot class=\"dijitReset dijitCalendarYearContainer\">\n\t\t<tr>\n\t\t\t<td class='dijitReset' valign=\"top\" colspan=\"7\">\n\t\t\t\t<h3 class=\"dijitCalendarYearLabel\">\n\t\t\t\t\t<span dojoAttachPoint=\"previousYearLabelNode\" class=\"dijitInline dijitCalendarPreviousYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"currentYearLabelNode\" class=\"dijitInline dijitCalendarSelectedYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"nextYearLabelNode\" class=\"dijitInline dijitCalendarNextYear\"></span>\n\t\t\t\t</h3>\n\t\t\t</td>\n\t\t</tr>\n\t</tfoot>\n</table>\n"),

		// value: Date
		//		The currently selected Date
		value: new Date(),

		// datePackage: String
		//		JavaScript namespace to find Calendar routines.  Uses Gregorian Calendar routines
		//		at dojo.date by default.
		datePackage: "dojo.date",

		// dayWidth: String
		//		How to represent the days of the week in the calendar header. See dojo.date.locale
		dayWidth: "narrow",

		// tabIndex: Integer
		//		Order fields are traversed when user hits the tab key
		tabIndex: "0",

		attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
			tabIndex: "domNode"
 		}),

		setValue: function(/*Date*/ value){
			// summary:
			//      Deprecated.   Used attr('value', ...) instead.
			// tags:
			//      deprecated
			dojo.deprecated("dijit.Calendar:setValue() is deprecated.  Use attr('value', ...) instead.", "", "2.0");
			this.attr('value', value);
		},

		_getValueAttr: function(){
			// summary:
			//		Support getter attr('value')
			var value = new this.dateClassObj(this.value);
			value.setHours(0, 0, 0, 0); // return midnight, local time for back-compat

			// If daylight savings pushes midnight to the previous date, fix the Date
			// object to point at 1am so it will represent the correct day. See #9366
			if(value.getDate() < this.value.getDate()){
				value = this.dateFuncObj.add(value, "hour", 1);
			}
			return value;
		},

		_setValueAttr: function(/*Date*/ value){
			// summary:
			//		Support setter attr("value", ...)
			// description:
			// 		Set the current date and update the UI.  If the date is disabled, the value will
			//		not change, but the display will change to the corresponding month.
			// tags:
			//      protected
			if(!this.value || this.dateFuncObj.compare(value, this.value)){
				value = new this.dateClassObj(value);
				value.setHours(1); // to avoid issues when DST shift occurs at midnight, see #8521, #9366
				this.displayMonth = new this.dateClassObj(value);
				if(!this.isDisabledDate(value, this.lang)){
					this.value = value;
					this.onChange(this.attr('value'));
				}
				dojo.attr(this.domNode, "aria-label",
					this.dateLocaleModule.format(value,
						{selector:"date", formatLength:"full"}));
				this._populateGrid();
			}
		},

		_setText: function(node, text){
			// summary:
			//		This just sets the content of node to the specified text.
			//		Can't do "node.innerHTML=text" because of an IE bug w/tables, see #3434.
			// tags:
			//      private
			while(node.firstChild){
				node.removeChild(node.firstChild);
			}
			node.appendChild(dojo.doc.createTextNode(text));
		},

		_populateGrid: function(){
			// summary:
			//      Fills in the calendar grid with each day (1-31)
			// tags:
			//      private
			var month = this.displayMonth;
			month.setDate(1);
			var firstDay = month.getDay(),
				daysInMonth = this.dateFuncObj.getDaysInMonth(month),
				daysInPreviousMonth = this.dateFuncObj.getDaysInMonth(this.dateFuncObj.add(month, "month", -1)),
				today = new this.dateClassObj(),
				dayOffset = dojo.cldr.supplemental.getFirstDayOfWeek(this.lang);
			if(dayOffset > firstDay){ dayOffset -= 7; }

			// Iterate through dates in the calendar and fill in date numbers and style info
			dojo.query(".dijitCalendarDateTemplate", this.domNode).forEach(function(template, i){
				i += dayOffset;
				var date = new this.dateClassObj(month),
					number, clazz = "dijitCalendar", adj = 0;

				if(i < firstDay){
					number = daysInPreviousMonth - firstDay + i + 1;
					adj = -1;
					clazz += "Previous";
				}else if(i >= (firstDay + daysInMonth)){
					number = i - firstDay - daysInMonth + 1;
					adj = 1;
					clazz += "Next";
				}else{
					number = i - firstDay + 1;
					clazz += "Current";
				}

				if(adj){
					date = this.dateFuncObj.add(date, "month", adj);
				}
				date.setDate(number);

				if(!this.dateFuncObj.compare(date, today, "date")){
					clazz = "dijitCalendarCurrentDate " + clazz;
				}

				if(this._isSelectedDate(date, this.lang)){
					clazz = "dijitCalendarSelectedDate " + clazz;
				}

				if(this.isDisabledDate(date, this.lang)){
					clazz = "dijitCalendarDisabledDate " + clazz;
				}

				var clazz2 = this.getClassForDate(date, this.lang);
				if(clazz2){
					clazz = clazz2 + " " + clazz;
				}

				template.className = clazz + "Month dijitCalendarDateTemplate";
				template.dijitDateValue = date.valueOf();
				var label = dojo.query(".dijitCalendarDateLabel", template)[0],
					text = date.getDateLocalized ? date.getDateLocalized(this.lang) : date.getDate();
				this._setText(label, text);
			}, this);

			// Fill in localized month name
			var monthNames = this.dateLocaleModule.getNames('months', 'wide', 'standAlone', this.lang);
			this._setText(this.monthLabelNode, monthNames[month.getMonth()]);

			// Fill in localized prev/current/next years
			var y = month.getFullYear() - 1;
			var d = new this.dateClassObj();
			dojo.forEach(["previous", "current", "next"], function(name){
				d.setFullYear(y++);
				this._setText(this[name+"YearLabelNode"],
					this.dateLocaleModule.format(d, {selector:'year', locale:this.lang}));
			}, this);

			// Set up repeating mouse behavior
			var _this = this;
			var typematic = function(nodeProp, dateProp, adj){
//FIXME: leaks (collects) listeners if populateGrid is called multiple times.  Do this once?
				_this._connects.push(
					dijit.typematic.addMouseListener(_this[nodeProp], _this, function(count){
						if(count >= 0){ _this._adjustDisplay(dateProp, adj); }
					}, 0.8, 500)
				);
			};
			typematic("incrementMonth", "month", 1);
			typematic("decrementMonth", "month", -1);
			typematic("nextYearLabelNode", "year", 1);
			typematic("previousYearLabelNode", "year", -1);
		},

		goToToday: function(){
			// summary:
			//      Sets calendar's value to today's date
			this.attr('value', this.dateClassObj());
		},

		constructor: function(/*Object*/args){
			var dateClass = (args.datePackage && (args.datePackage != "dojo.date"))? args.datePackage + ".Date" : "Date";
			this.dateClassObj = dojo.getObject(dateClass, false);
			this.datePackage = args.datePackage || this.datePackage;
			this.dateFuncObj = dojo.getObject(this.datePackage, false);
			this.dateLocaleModule = dojo.getObject(this.datePackage + ".locale", false);
		},

		postMixInProperties: function(){
			// parser.instantiate sometimes passes in NaN for IE.  Use default value in prototype instead.
			if(isNaN(this.value)){ delete this.value; }
			this.inherited(arguments);
		},

		postCreate: function(){
			this.inherited(arguments);
			dojo.setSelectable(this.domNode, false);

			var cloneClass = dojo.hitch(this, function(clazz, n){
				var template = dojo.query(clazz, this.domNode)[0];
	 			for(var i=0; i<n; i++){
					template.parentNode.appendChild(template.cloneNode(true));
				}
			});

			// clone the day label and calendar day templates 6 times to make 7 columns
			cloneClass(".dijitCalendarDayLabelTemplate", 6);
			cloneClass(".dijitCalendarDateTemplate", 6);

			// now make 6 week rows
			cloneClass(".dijitCalendarWeekTemplate", 5);

			// insert localized day names in the header
			var dayNames = this.dateLocaleModule.getNames('days', this.dayWidth, 'standAlone', this.lang);
			var dayOffset = dojo.cldr.supplemental.getFirstDayOfWeek(this.lang);
			dojo.query(".dijitCalendarDayLabel", this.domNode).forEach(function(label, i){
				this._setText(label, dayNames[(i + dayOffset) % 7]);
			}, this);

			// Fill in spacer/month dropdown element with all the month names (invisible) so that the maximum width will affect layout
			var monthNames = this.dateLocaleModule.getNames('months', 'wide', 'standAlone', this.lang);
			cloneClass(".dijitCalendarMonthLabelTemplate", monthNames.length-1);
			dojo.query(".dijitCalendarMonthLabelTemplate", this.domNode).forEach(function(node, i){
				dojo.attr(node, "month", i);
				this._setText(node, monthNames[i]);
				dojo.place(node.cloneNode(true), this.monthLabelSpacer);
			}, this);

			var value = this.value;
			this.value = null;
			this.attr('value', new this.dateClassObj(value));
		},

		_onMenuHover: function(e){
			dojo.stopEvent(e);
			dojo.toggleClass(e.target, "dijitMenuItemHover");
		},

		_adjustDisplay: function(/*String*/ part, /*int*/ amount){
			// summary:
			//      Moves calendar forwards or backwards by months or years
			// part:
			//      "month" or "year"
			// amount:
			//      Number of months or years
			// tags:
			//      private
			this.displayMonth = this.dateFuncObj.add(this.displayMonth, part, amount);
			this._populateGrid();
		},

		_onMonthToggle: function(/*Event*/ evt){
			// summary:
			//      Handler for when user triggers or dismisses the month list
			// tags:
			//      protected
			dojo.stopEvent(evt);

			if(evt.type == "mousedown"){
				var coords = dojo.position(this.monthLabelNode);
//				coords.y -= dojo.position(this.domNode, true).y;
				// Size the dropdown's width to match the label in the widget
				// so that they are horizontally aligned
				var dim = {
					width: coords.w + "px",
					top: -this.displayMonth.getMonth() * coords.h + "px"
				};
				if((dojo.isIE && dojo.isQuirks) || dojo.isIE < 7){
					dim.left = -coords.w/2 + "px";
				}
				dojo.style(this.monthDropDown, dim);
				this._popupHandler = this.connect(document, "onmouseup", "_onMonthToggle");
			}else{
				this.disconnect(this._popupHandler);
				delete this._popupHandler;
			}

			dojo.toggleClass(this.monthDropDown, "dijitHidden");
			dojo.toggleClass(this.monthLabelNode, "dijitVisible");
		},

		_onMonthSelect: function(/*Event*/ evt){
			// summary:
			//      Handler for when user selects a month from a list
			// tags:
			//      protected
			this._onMonthToggle(evt);
			this.displayMonth.setMonth(dojo.attr(evt.target, "month"));
			this._populateGrid();
		},

		_onDayClick: function(/*Event*/ evt){
			// summary:
			//      Handler for day clicks, selects the date if appropriate
			// tags:
			//      protected
			dojo.stopEvent(evt);
			for(var node = evt.target; node && !node.dijitDateValue; node = node.parentNode);
			if(node && !dojo.hasClass(node, "dijitCalendarDisabledDate")){
				this.attr('value', node.dijitDateValue);
				this.onValueSelected(this.attr('value'));
			}
		},

		_onDayMouseOver: function(/*Event*/ evt){
			// summary:
			//      Handler for mouse over events on days, sets up hovered style
			// tags:
			//      protected
			var node = evt.target;
			if(node && (node.dijitDateValue || node == this.previousYearLabelNode || node == this.nextYearLabelNode) ){
				dojo.addClass(node, "dijitCalendarHoveredDate");
				this._currentNode = node;
			}
		},

		_onDayMouseOut: function(/*Event*/ evt){
			// summary:
			//      Handler for mouse out events on days, clears hovered style
			// tags:
			//      protected
			if(!this._currentNode){ return; }
			for(var node = evt.relatedTarget; node;){
				if(node == this._currentNode){ return; }
				try{
					node = node.parentNode;
				}catch(x){
					node = null;
				}
			}
			dojo.removeClass(this._currentNode, "dijitCalendarHoveredDate");
			this._currentNode = null;
		},

//TODO: use typematic
//TODO: skip disabled dates without ending up in a loop
//TODO: could optimize by avoiding populate grid when month does not change
		_onKeyPress: function(/*Event*/evt){
			// summary:
			//		Provides keyboard navigation of calendar
			// tags:
			//		protected
			var dk = dojo.keys,
				increment = -1,
				interval,
				newValue = this.value;
			switch(evt.keyCode){
				case dk.RIGHT_ARROW:
					increment = 1;
					//fallthrough...
				case dk.LEFT_ARROW:
					interval = "day";
					if(!this.isLeftToRight()){ increment *= -1; }
					break;
				case dk.DOWN_ARROW:
					increment = 1;
					//fallthrough...
				case dk.UP_ARROW:
					interval = "week";
					break;
				case dk.PAGE_DOWN:
					increment = 1;
					//fallthrough...
				case dk.PAGE_UP:
					interval = evt.ctrlKey ? "year" : "month";
					break;
				case dk.END:
					// go to the next month
					newValue = this.dateFuncObj.add(newValue, "month", 1);
					// subtract a day from the result when we're done
					interval = "day";
					//fallthrough...
				case dk.HOME:
					newValue = new Date(newValue).setDate(1);
					break;
				case dk.ENTER:
					this.onValueSelected(this.attr('value'));
					break;
				case dk.ESCAPE:
					//TODO
				default:
					return;
			}
			dojo.stopEvent(evt);

			if(interval){
				newValue = this.dateFuncObj.add(newValue, interval, increment);
			}

			this.attr("value", newValue);
		},

		onValueSelected: function(/*Date*/ date){
			// summary:
			//		Notification that a date cell was selected.  It may be the same as the previous value.
			// description:
			//      Used by `dijit.form._DateTimeTextBox` (and thus `dijit.form.DateTextBox`)
			//      to get notification when the user has clicked a date.
			// tags:
			//      protected
		},

		onChange: function(/*Date*/ date){
			// summary:
			//		Called only when the selected date has changed
		},

		_isSelectedDate: function(/*Date*/ dateObject, /*String?*/ locale){
			// summary:
			//		Extension point so developers can subclass Calendar to
			//		support multiple (concurrently) selected dates
			// tags:
			//		protected extension
			return !this.dateFuncObj.compare(dateObject, this.value, "date")
		},

		isDisabledDate: function(/*Date*/ dateObject, /*String?*/ locale){
			// summary:
			//		May be overridden to disable certain dates in the calendar e.g. `isDisabledDate=dojo.date.locale.isWeekend`
			// tags:
			//      extension
/*=====
			return false; // Boolean
=====*/
		},

		getClassForDate: function(/*Date*/ dateObject, /*String?*/ locale){
			// summary:
			//		May be overridden to return CSS classes to associate with the date entry for the given dateObject,
			//		for example to indicate a holiday in specified locale.
			// tags:
			//      extension

/*=====
			return ""; // String
=====*/
		}
	}
);

}

if(!dojo._hasResource["dijit._Calendar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._Calendar"] = true;
dojo.provide("dijit._Calendar");


dojo.deprecated("dijit._Calendar is deprecated", "dijit._Calendar moved to dijit.Calendar", 1.5);

// dijit._Calendar had an underscore all this time merely because it did
// not satisfy dijit's a11y policy.
dijit._Calendar = dijit.Calendar;

}

if(!dojo._hasResource['epages.lang.date']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.lang.date'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

  epages.lang.date $Revision: 1.6 $

*/
dojo.provide('epages.lang.date');



epages.lang.date.getWeekOfYear = function(/*Date*/dateObject, /*Number*/firstDayOfWeek, /*Number*/minDaysFirstWeek){
	if(firstDayOfWeek   === undefined){ firstDayOfWeek   = epages.vars.Locale.firstDayOfWeek;   }
	if(minDaysFirstWeek === undefined){ minDaysFirstWeek = epages.vars.Locale.minDaysFirstWeek; }

	var calc = function(date) {
		var c = new Date(date.getFullYear(), 0, 1).getDay();
		if(c==0 && firstDayOfWeek == 1){
			c = 7;
		}

		// need number 7 on monday or sunday for first full week
		var week = Math.floor((dojo.date.locale._getDayOfYear(date) + c - 1 - firstDayOfWeek) / 7);
		if (minDaysFirstWeek == 1 || minDaysFirstWeek == 7 && c == firstDayOfWeek) {
			week++;
		}
		else if (minDaysFirstWeek == 4) {
			var g = c - firstDayOfWeek;
			if (g < 4) { week++; }
		}
		return week;
	};
	var result = calc(dateObject);
	if(result < 1) { // is last week of last year
		result = calc(new Date(dateObject.getFullYear() - 1, 11,31));
	}
	if(result >= 53) { // may be first week of next year
		var newyear = calc(new Date(dateObject.getFullYear() + 1, 0, 1));
		result = newyear == 0 ? result : newyear;
	}
	return result; // Number
};

}

if(!dojo._hasResource["epages.widget.Calendar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Calendar"] = true;
dojo.provide("epages.widget.Calendar");






dojo.declare("epages.widget.Calendar", [dijit.Calendar], {
		/**
		 * public properties
		 */
		firstAvailableDate : null,
		lastAvailableDate  : null,

		/**
		 * private properties
		 */
		templateType       : "default",
		defaultTemplateType: "default", // read-only!
		templateString:"<table cellspacing=\"0\" cellpadding=\"0\" class=\"dijitCalendarContainer\" role=\"grid\" dojoAttachEvent=\"onkeypress: _onKeyPress\">\n\t<thead>\n\t\t<tr class=\"dijitReset dijitCalendarMonthContainer\" valign=\"top\">\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"decrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarDecrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"decreaseArrowNode\" class=\"dijitA11ySideArrow\">-</span>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' colspan=\"5\">\n\t\t\t\t<div class=\"dijitVisible\">\n\t\t\t\t\t<div class=\"dijitPopup dijitMenu dijitMenuPassive dijitHidden\" dojoAttachPoint=\"monthDropDown\" dojoAttachEvent=\"onmouseup: _onMonthSelect, onmouseover: _onMenuHover, onmouseout: _onMenuHover\">\n\t\t\t\t\t\t<div class=\"dijitCalendarMonthLabelTemplate dijitCalendarMonthLabel\"></div>\n\t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelSpacer\" class=\"dijitSpacer\"></div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelNode\" class=\"dijitCalendarMonthLabel dijitInline dijitVisible\" dojoAttachEvent=\"onmousedown: _onMonthToggle\"></div>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"incrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarIncrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"increaseArrowNode\" class=\"dijitA11ySideArrow\">+</span>\n\t\t\t</th>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<th class=\"dijitReset dijitCalendarDayLabelTemplate\" role=\"columnheader\"><span class=\"dijitCalendarDayLabel\"></span></th>\n\t\t</tr>\n\t</thead>\n\t<tbody dojoAttachEvent=\"onclick: _onDayClick, onmouseover: _onDayMouseOver, onmouseout: _onDayMouseOut\" class=\"dijitReset dijitCalendarBodyContainer\">\n\t\t<tr class=\"dijitReset dijitCalendarWeekTemplate\" role=\"row\">\n\t\t\t<td class=\"dijitReset dijitCalendarDateTemplate\" role=\"gridcell\"><span class=\"dijitCalendarDateLabel\"></span></td>\n\t\t</tr>\n\t</tbody>\n\t<tfoot class=\"dijitReset dijitCalendarYearContainer\">\n\t\t<tr>\n\t\t\t<td class='dijitReset' valign=\"top\" colspan=\"7\">\n\t\t\t\t<h3 class=\"dijitCalendarYearLabel\">\n\t\t\t\t\t<span dojoAttachPoint=\"previousYearLabelNode\" class=\"dijitInline dijitCalendarPreviousYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"currentYearLabelNode\" class=\"dijitInline dijitCalendarSelectedYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"nextYearLabelNode\" class=\"dijitInline dijitCalendarNextYear\"></span>\n\t\t\t\t</h3>\n\t\t\t</td>\n\t\t</tr>\n\t</tfoot>\n</table>\n", // need template for weeknumber
		_templateDirectory : dojo.moduleUrl("epages.widget", "templates"),
		widgetsInTemplate : true,
		_templateMapping : {
			'default' : {templateString:"<table cellspacing=\"0\" cellpadding=\"0\" class=\"dijitCalendarContainer\" role=\"grid\" dojoAttachEvent=\"onkeypress: _onKeyPress\">\n\t<thead>\n\t\t<tr class=\"dijitReset dijitCalendarMonthContainer\" valign=\"top\">\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"decrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarDecrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"decreaseArrowNode\" class=\"dijitA11ySideArrow\">-</span>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' colspan=\"5\">\n\t\t\t\t<div class=\"dijitVisible\">\n\t\t\t\t\t<div class=\"dijitPopup dijitMenu dijitMenuPassive dijitHidden\" dojoAttachPoint=\"monthDropDown\" dojoAttachEvent=\"onmouseup: _onMonthSelect, onmouseover: _onMenuHover, onmouseout: _onMenuHover\">\n\t\t\t\t\t\t<div class=\"dijitCalendarMonthLabelTemplate dijitCalendarMonthLabel\"></div>\n\t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelSpacer\" class=\"dijitSpacer\"></div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelNode\" class=\"dijitCalendarMonthLabel dijitInline dijitVisible\" dojoAttachEvent=\"onmousedown: _onMonthToggle\"></div>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"incrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarIncrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"increaseArrowNode\" class=\"dijitA11ySideArrow\">+</span>\n\t\t\t</th>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<th class=\"dijitReset dijitCalendarDayLabelTemplate\" role=\"columnheader\"><span class=\"dijitCalendarDayLabel\"></span></th>\n\t\t</tr>\n\t</thead>\n\t<tbody dojoAttachEvent=\"onclick: _onDayClick, onmouseover: _onDayMouseOver, onmouseout: _onDayMouseOut\" class=\"dijitReset dijitCalendarBodyContainer\">\n\t\t<tr class=\"dijitReset dijitCalendarWeekTemplate\" role=\"row\">\n\t\t\t<td class=\"dijitReset dijitCalendarDateTemplate\" role=\"gridcell\"><span class=\"dijitCalendarDateLabel\"></span></td>\n\t\t</tr>\n\t</tbody>\n\t<tfoot class=\"dijitReset dijitCalendarYearContainer\">\n\t\t<tr>\n\t\t\t<td class='dijitReset' valign=\"top\" colspan=\"7\">\n\t\t\t\t<h3 class=\"dijitCalendarYearLabel\">\n\t\t\t\t\t<span dojoAttachPoint=\"previousYearLabelNode\" class=\"dijitInline dijitCalendarPreviousYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"currentYearLabelNode\" class=\"dijitInline dijitCalendarSelectedYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"nextYearLabelNode\" class=\"dijitInline dijitCalendarNextYear\"></span>\n\t\t\t\t</h3>\n\t\t\t</td>\n\t\t</tr>\n\t</tfoot>\n</table>\n"},
			'flat'    : {templateString:"<div class=\"Calendar Flat dijitCalendarContainer\"><div class=\"InnerContainer\">\n\t<div>\n\t\t<div class=\"dijitReset dijitCalendarMonthContainer\"><div class=\"MonthSelection\">\n\t\t\t<div class='dijitReset' dojoAttachPoint=\"decrementMonth\">\n\t\t\t\t<span class=\"dijitInline dijitCalendarIncrementControl dijitCalendarDecrease\"><span dojoAttachPoint=\"decreaseArrowNode\" class=\"dijitA11ySideArrow dijitCalendarIncrementControl dijitCalendarDecreaseInner\">-</span></span>\n\t\t\t</div>\n\t\t\t<div class='dijitReset'>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelSpacer\" class=\"dijitCalendarMonthLabelSpacer\"></div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelNode\" class=\"dijitCalendarMonth\"></div>\n\t\t\t</div>\n\t\t\t<div class='dijitReset' dojoAttachPoint=\"incrementMonth\">\n\t\t\t\t<div class=\"dijitInline dijitCalendarIncrementControl dijitCalendarIncrease\"><span dojoAttachPoint=\"increaseArrowNode\" class=\"dijitA11ySideArrow dijitCalendarIncrementControl dijitCalendarIncreaseInner\">+</span></div>\n\t\t\t</div>\n\t\t</div></div>\n\t\t<div class=\"DayLabelHead\">\n\t\t\t<div class=\"dijitReset dijitCalendarWeekLabelTemplate\"><span class=\"dijitCalendarWeekLabel\"></span></div>\n\t\t\t<div class=\"dijitReset dijitCalendarDayLabelTemplate\"><span class=\"dijitCalendarDayLabel\"></span></div>\n\t\t</div>\n\t</div>\n\t<div dojoAttachEvent=\"onclick: _onDayClick\" class=\"dijitReset dijitCalendarBodyContainer\">\n\t\t<div class=\"dijitReset dijitCalendarWeekTemplate\">\n\t\t\t<div class=\"dijitReset dijitCalendarWeekTemplate\"><span class=\"dijitCalendarWeekLabel\"></span></div>\n\t\t\t<div class=\"dijitReset dijitCalendarDateTemplate\"><span class=\"dijitCalendarDateLabel\"></span></div>\n\t\t</div>\n\t</div>\n\t<div class=\"dijitReset dijitCalendarYearContainer\">\n\t\t<div>\n\t\t\t<div class='dijitReset' >\n\t\t\t\t<h3 class=\"dijitCalendarYearLabel\">\n\t\t\t\t\t<span dojoAttachPoint=\"previousYearLabelNode\" class=\"dijitInline dijitCalendarPreviousYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"currentYearLabelNode\" class=\"dijitInline dijitCalendarSelectedYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"nextYearLabelNode\" class=\"dijitInline dijitCalendarNextYear\"></span>\n\t\t\t\t</h3>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t<div class=\"HideElement dijitCalendarMonthLabelTemplate\"></div>\n\t<div class=\"Bottom\"></div>\n</div></div>\n\n"}
		},
		_yearTip: '',

		postMixInProperties: function() {
			this.inherited("postMixInProperties", arguments);
			if (this._templateMapping !== undefined &&  this.templateType !== undefined &&  this._templateDirectory !== undefined) {
				if(this._templateMapping[this.templateType]!==undefined) {
					// check if set to widget's default using its prototype value
					if(this.templateType != this.defaultTemplateType) {
						var tempPath = '';

							// load templates from json object..
							if(typeof this._templateMapping[this.templateType] == 'object'){
								var TempObj = this._templateMapping[this.templateType];

								// ..from shrinksafed packages
								if(TempObj.templateString){
										this.templatePath   = null;
										this.templateString = TempObj.templateString;
								}

								// ..from sources
								else if(TempObj.templatePath){
									var TempTemplateString;
									dojo.xhrGet({
										url: TempObj.templatePath,
										sync: true,
										load: function(data){
											TempTemplateString = data;
										}
									});
									this.templatePath   = null;
									this.templateString = TempTemplateString;
								} else {
										console.warn('Template type: "'+ this.templateType +'" could not be loaded from json object! Use properties templatePath or templateString to declare its template file!');
								}
							}

					}
				} else {
					console.warn('Template type: "'+ this.templateType +'" does not exist in this widget - use default. ('+this.declaredClass+')');
				}
			}
			this._dictionary = new epages.io.Translation(dojo.moduleUrl('epages.widget', "templates/translation"), "auto");
			this._yearTip = this._dictionary.get('YearTip');


		},

		postCreate: function() {
			var d = this.value;
			this.inherited("postCreate", arguments);
			this.attr('value',null);
			this.attr('value',d);

		},

		_populateGrid: function(){
			epages.widget.Calendar.superclass._populateGrid.apply(this);
			dojo.query(".dijitCalendarWeekLabel", this.domNode).forEach(function(label, i) {
				if (i) {
					var node = label.parentNode.nextSibling;
					while (node != null && node.nodeName == '#text'){
						node = node.nextSibling;
					}
					this._setText(label, epages.lang.date.getWeekOfYear(new Date(node.dijitDateValue), dojo.cldr.supplemental.getFirstDayOfWeek(this.lang)));
				}
			}, this);
		},

		_dateNode: function (node) {
			while(node && !node.dijitDateValue){ node = node.parentNode; }
			return node;
		},

		// disallow clicks on calendar weeks
		_onDayClick: function(/*Event*/evt){
			var node = evt.target;
			if(dojo.hasClass(node, "dijitCalendarDateLabel")) {
				epages.widget.Calendar.superclass._onDayClick.apply(this, arguments);
			} else {
				dojo.stopEvent(evt);
			}
		},

		isDisabledDate: function(/*Date*/ date, /*String?*/ locale) {
			date.setHours(0,0,0,0);
			// check if a date is between a the available period
			return (this.lastAvailableDate && date > this.lastAvailableDate) ||
						 (this.firstAvailableDate && date < this.firstAvailableDate);
		}
});

}

if(!dojo._hasResource["epages.widget.Datetimeinput"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Datetimeinput"] = true;
dojo.provide("epages.widget.Datetimeinput");








dojo.declare(
	"epages.widget.Datetimeinput",
	[dijit._Widget, dijit._Templated],
	{
		templateString:"<span style=\"white-space:nowrap\" class=\"Datetimeinput\" >\n  <input type=\"text\" dojoAttachPoint=\"textBoxNode\" class=\"${class}\" style=\"${style}\" name=\"${name}\" autocomplete=\"off\" />\n  <img class=\"ButtonNode\" dojoAttachPoint=\"buttonNode\"\n        alt=\"${title}\" title=\"${title}\"\n        src=\"${image}\" />\n  <div style=\"display:none\" dojoAttachPoint=\"popupNode\" class=\"CalendarAndTimer\">\n    <div class=\"Layer\">\n      <div class=\"LayerTitleBar\">\n        <div class=\"LayerCloseButton EnableHover\" dojoAttachEvent=\"onclick: closePopup\"></div>\n      </div>\n      <div class=\"ContentContainer\">\n        <div class=\"CalendarNode\" dojoAttachPoint=\"calendarNode\"></div>\n        <div class=\"TimerWrapper\" dojoAttachPoint=\"timerNode\"></div>\n        <div style=\"clear:both\"></div>\n      </div>\n    </div>\n  </div>\n </span>\n",
		dojoPattern:        '',
		pattern:            '',
		popupclass:         '',
		'style':            '',
		name:               '',
		textId:             '', // String - id for text node
		value:              '',
		selector:           'date',// String - can be: "date", "time" or "datetime"
		calendar:           null, // dojo._Widjet - insert other calender as parameter
		timer:              null, // dojo._Widjet - insert other time selector as parameter
		hideOnBlur:         true, // Boolean - hide calendar/time on cick outside
		imagePath:          epages.themeUrl('images'),
		image:              '',
		title:              '',
		onchange:           'void(0)',
		firstAvailableDate: '',
		lastAvailableDate:  '',
		disabled:           '',
		textBoxWidget:      undefined, // epages.widget.FormElement -
		textBoxNode:        undefined, // DomNode - dom node of textBoxWidget

		_isChangeInput: 		false, // Boolean - dont not change input field if user makes on input
		// assign selectors to formats
		_formats: {
			'date':     			'dateFormat',
			'time':     			'timeFormat',
			'datetime': 			'datetimeFormat',
			'iso':						'iso'
		},
		_titles: {
			'date':     			'SelectDate',
			'time':     			'SelectTime',
			'datetime': 			'SelectDatetime'
		},
		_formatError: false,
		_ep_connects: undefined, // [] - saved connections


		/* widget life cycle */

		postMixInProperties: function() {
			this.inherited("postMixInProperties", arguments);

			this._ep_connects =[];
			
			// save the original value
			this.originalValue = this.value;

			if(this._formats[this.selector] == 'iso'){
				this.value = epages.localize.parseDateTime(this.value, '%y-%m-%d');
				this.pattern = this.pattern || epages.vars.Locale[this._formats['dateFormat']];
			}
			else{
				this.pattern = this.pattern || epages.vars.Locale[this._formats[this.selector]];
			}
			
			var parsedValue = null;
			if (typeof(this.value) == "string" && this.value != ''){
				parsedValue = epages.localize.parseDateTime(this.value, this.pattern);
			}
			else{
				this.value = null;
			}
			if( parsedValue==null && this.originalValue ){
				this._formatError = true;
			}
			else{
				this.value = parsedValue;
			}
			//if (typeof(this.value) == "string") this.value = this.value == '' ? null : epages.localize.parseDateTime(this.value, this.pattern);
			var fileType = (epages.Browser.engine == "MSIE" && epages.Browser.version=="6" ) ? "gif" : "png";
			if (this.image == ''){
				this.image = this.imagePath + (this.selector == 'time' ? '/ico_s_clock.'+fileType : '/ico_s_calendar.'+fileType);
			}
			if (this.title == ''){
				this.title = epages.io.dictionary.get(this._titles[this.selector]);
			}
			if (this.firstAvailableDate){
				this.firstAvailableDate = epages.localize.parseDateTime(this.firstAvailableDate, this.pattern);
			}
			if (this.lastAvailableDate){
				this.lastAvailableDate = epages.localize.parseDateTime(this.lastAvailableDate, this.pattern);
			}

			this.disabled = this.disabled.toLowerCase();
			this.disabled = (this.disabled =="true" || this.disabled =="disabled" || this.disabled == "1") ? true : false;

		},

		postCreate: function() {
			this.inherited("postCreate", arguments);

			// parse date value and provide to text box and calendar

			this.textBoxWidget = new epages.widget.FormElement({}, this.textBoxNode);
			this.textBoxWidget.attr('pattern', epages.localize.getPattern(this.selector||'datetime'));
			this.textBoxNode = this.textBoxWidget.elementNode;
			if(this.disabled) {
				this.disable();
			}

			this.textBoxNode.value = this.textBoxNode.defaultValue = this.originalValue;
			
			if( this._formatError ){
				// turn red if not empty and formaterror
				dojo.addClass(this.textBoxNode, 'DialogError');
			}
			if (this.textId != ''){
				this.textBoxNode.id = this.textId;
			}
			this._ep_connects.push(dojo.connect(this.buttonNode,  "click",  this, 'toggleCalendar'));
			this._ep_connects.push(dojo.connect(this.textBoxNode, "keyup",  this, "onValueInput"));
			this._ep_connects.push(dojo.connect(this.textBoxNode, "change", this, "onValueInput"));
			this.textBoxNode.onchange = dojo.hitch(this, function() { eval(this.onchange); });
		},

		destroy : function() {
			// detach events
			var connects = this._ep_connects;
			for(var c in connects) {
				dojo.disconnect(connects[c]);
				delete this._ep_connects[c];
			}

			// destroy inner widgets
			if(this.timer) {
				this.timer.destroy();
			}
			if(this.calendar) {
				this.calendar.destroy();
			}
			if(this.popup) {
				this.popup.destroy();
			}
			if(this.textBoxWidget) {
				this.textBoxWidget.destroy();
			}
			this.inherited("destroy", arguments);
		},

		/* public: setter / getter */

		setValueInBox: function(date, startupUpdate) {
			if (date) {
				this.value = new Date(date);
				if (!this._isChangeInput) {
					this.textBoxNode.value = epages.localize.formatDateTime(date, this.pattern);
					if(startupUpdate) {
						this.textBoxNode.startupValue = this.textBoxNode.value;
					}
					dojo.removeClass(this.textBoxNode, 'DialogError');
				}
			} else {
				this.value = undefined;
				this.textBoxNode.value = '';
			}
			dojo.publish(this.id + '/change', [this.value, this.textBoxNode.value]);
			// inform search/submit button
			if(!this._isChangeInput){
				epages.event.fire(this.textBoxNode,'change');
			}
		},

		setValue: function(date) {
			if(date === undefined || date === null || date == ''){
				this.setValueInBox(undefined);
			}else{
				this.value = typeof(date) == 'string' ? epages.localize.parseDateTime(date, this.pattern) :  new Date(date);
				this.onTimeChange(this.value);
			}
		},

		disable: function() {
		// summary: disable inputfield and button
			this.textBoxNode.disabled="disabled";
			dojo.addClass(this.buttonNode , "Opacity30");
			this.disabled = true;
		},

		enable: function() {
		// summary: enable inputfield and button
			this.textBoxNode.disabled="";
			dojo.removeClass(this.buttonNode , "Opacity30");
			this.disabled = false;
		},

		/* private */

		_createCalendar: function() {
			// summary: create calendar widget
			if( this.value == null ){
				this.value = this.firstStartDate ? this.firstStartDate : new Date();
				if(this.calendar && this.calendar.value && dojo.date.compare(this.calendar.value, this.value, "date")){
					this.value = this.calendar.value;
				}
			}
			if(this.selector != 'date') {
				if (this.timer == null) {
					
					this.timer = new epages.widget.Timespinner({ value: this.value }, this.timerNode);
					if(this.selector != "datetime") {
						this.timer.domNode.style.border = "0";
					}
				} else {
					this.timer.setValue(this.value);
					this.timerNode.parentNode.replaceChild(this.timer.domNode, this.timerNode);
				}
				dojo.subscribe(this.timer.id + '/onChange', this, 'onTimeChange');
			}
			if(this.selector != 'time') {
				if (this.calendar == null) {
					
					this.calendar = new epages.widget.Calendar({
						value: this.value,
						timer: this.timer,
						firstAvailableDate: this.firstAvailableDate,
						lastAvailableDate: this.lastAvailableDate
					}, this.calendarNode);
				} else {
					if (this.calendar.setValue === undefined && typeof this.calendar == 'function') {
						this.calendar = this.calendar();
					}
					this.calendar.attr('value',this.value);
					this.calendarNode.parentNode.replaceChild(this.calendar.domNode, this.calendarNode);
				}
				this.calendar.onValueSelected = dojo.hitch(this, 'onCalendarChange');
			}
			this.popup = new epages.widget.Popup({
				parent:     this.buttonNode,
				around:     this.buttonNode,
				hideOnBlur: this.hideOnBlur,
				'class':    this['popupclass']
			}, this.popupNode);
			this.attr('value',this.value);
		},

		/* event functions */

		toggleCalendar: function() {
			if(!this.disabled) {
				if (this.popup == null){
					this._createCalendar();
				}
				if (this.value === undefined) {
					// set calendar to current date, but dont change input field
					this._isChangeInput = true;
					var newDate = this.firstStartDate ? this.firstStartDate : new Date();
					this.calendar.attr('value',newDate);
					this._isChangeInput = false;
				}
				this.popup.toggle();
			}
		},

		onCalendarChange: function(date) {
			if(this.value === undefined){
				var newDate = this.firstStartDate ? this.firstStartDate : new Date();
				this.value = newDate;
			}
			date.setHours(this.value.getHours(),this.value.getMinutes(),this.value.getSeconds());
			if (this.timer != null){
				this.timer.attr('value',date);
				this.setValueInBox(this.timer.getValue());
			}
			else{
				this.setValueInBox(date);
			}
			if (this.selector == 'date'){
				this.popup.hide();
			}
			this.textBoxWidget.validate();
		},

		onTimeChange: function(date) {
			//var date = new Date(this.value.getFullYear(), this.value.getMonth(), this.value.getDate(), date.getHours(),date.getMinutes(),date.getSeconds());
			if (this.calendar != null) {
				this.value = new Date(date); // set time for onCalendarChange
				if (typeof this.calendar.setValue == 'function') { // calendar loaded
					this.onCalendarChange(date);
					//this.calendar.attr('value',date); // calls onCalendarChange
				} else {
						this.setValueInBox(date);
				}
			} else {
				this.setValueInBox(date);
			}
		},

		onValueInput: function(evt) {
			this._isChangeInput = true;
			var value = this.textBoxNode.value;
			var date = value =='' ? null : epages.localize.parseDateTime(value, this.pattern);
			if (value =='' ||  date != null ) {
				this.attr('value',date);
				dojo.removeClass(this.textBoxNode, 'DialogError');
			} else {
				dojo.addClass(this.textBoxNode, 'DialogError');
			}
			this._isChangeInput = false;
		},

		closePopup: function() {
			this.popup.hide();
		}
	}
);

}

if(!dojo._hasResource["dijit._KeyNavContainer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._KeyNavContainer"] = true;
dojo.provide("dijit._KeyNavContainer");


dojo.declare("dijit._KeyNavContainer",
	dijit._Container,
	{

		// summary:
		//		A _Container with keyboard navigation of its children.
		// description:
		//		To use this mixin, call connectKeyNavHandlers() in
		//		postCreate() and call startupKeyNavChildren() in startup().
		//		It provides normalized keyboard and focusing code for Container
		//		widgets.
/*=====
		// focusedChild: [protected] Widget
		//		The currently focused child widget, or null if there isn't one
		focusedChild: null,
=====*/

		// tabIndex: Integer
		//		Tab index of the container; same as HTML tabIndex attribute.
		//		Note then when user tabs into the container, focus is immediately
		//		moved to the first item in the container.
		tabIndex: "0",

		_keyNavCodes: {},

		connectKeyNavHandlers: function(/*dojo.keys[]*/ prevKeyCodes, /*dojo.keys[]*/ nextKeyCodes){
			// summary:
			//		Call in postCreate() to attach the keyboard handlers
			//		to the container.
			// preKeyCodes: dojo.keys[]
			//		Key codes for navigating to the previous child.
			// nextKeyCodes: dojo.keys[]
			//		Key codes for navigating to the next child.
			// tags:
			//		protected

			var keyCodes = (this._keyNavCodes = {});
			var prev = dojo.hitch(this, this.focusPrev);
			var next = dojo.hitch(this, this.focusNext);
			dojo.forEach(prevKeyCodes, function(code){ keyCodes[code] = prev; });
			dojo.forEach(nextKeyCodes, function(code){ keyCodes[code] = next; });
			this.connect(this.domNode, "onkeypress", "_onContainerKeypress");
			this.connect(this.domNode, "onfocus", "_onContainerFocus");
		},

		startupKeyNavChildren: function(){
			// summary:
			//		Call in startup() to set child tabindexes to -1
			// tags:
			//		protected
			dojo.forEach(this.getChildren(), dojo.hitch(this, "_startupChild"));
		},

		addChild: function(/*dijit._Widget*/ widget, /*int?*/ insertIndex){
			// summary:
			//		Add a child to our _Container
			dijit._KeyNavContainer.superclass.addChild.apply(this, arguments);
			this._startupChild(widget);
		},

		focus: function(){
			// summary:
			//		Default focus() implementation: focus the first child.
			this.focusFirstChild();
		},

		focusFirstChild: function(){
			// summary:
			//		Focus the first focusable child in the container.
			// tags:
			//		protected
			var child = this._getFirstFocusableChild();
			this.focusChild(child);
		},

		focusNext: function(){
			// summary:
			//		Focus the next widget
			// tags:
			//		protected
			var child = this._getNextFocusableChild(this.focusedChild, 1);
			this.focusChild(child);
		},

		focusPrev: function(){
			// summary:
			//		Focus the last focusable node in the previous widget
			//		(ex: go to the ComboButton icon section rather than button section)
			// tags:
			//		protected
			var child = this._getNextFocusableChild(this.focusedChild, -1);
			this.focusChild(child, true);
		},

		focusChild: function(/*dijit._Widget*/ widget, /*Boolean*/ last){
			// summary:
			//		Focus widget.
			// widget:
			//		Reference to container's child widget
			// last:
			//		If true and if widget has multiple focusable nodes, focus the
			//		last one instead of the first one
			// tags:
			//		protected
			
			if(this.focusedChild && widget !== this.focusedChild){
				this._onChildBlur(this.focusedChild);
			}
			widget.focus(last ? "end" : "start");
			this.focusedChild = widget;
		},

		_startupChild: function(/*dijit._Widget*/ widget){
			// summary:
			//		Setup for each child widget
			// description:
			//		Sets tabIndex=-1 on each child, so that the tab key will 
			//		leave the container rather than visiting each child.
			// tags:
			//		private
			
			widget.attr("tabIndex", "-1");
			
			this.connect(widget, "_onFocus", function(){
				// Set valid tabIndex so tabbing away from widget goes to right place, see #10272
				widget.attr("tabIndex", this.tabIndex);
			});
			this.connect(widget, "_onBlur", function(){
				widget.attr("tabIndex", "-1");
			});
		},

		_onContainerFocus: function(evt){
			// summary:
			//		Handler for when the container gets focus
			// description:
			//		Initially the container itself has a tabIndex, but when it gets
			//		focus, switch focus to first child...
			// tags:
			//		private

			// Note that we can't use _onFocus() because switching focus from the
			// _onFocus() handler confuses the focus.js code
			// (because it causes _onFocusNode() to be called recursively)

			// focus bubbles on Firefox,
			// so just make sure that focus has really gone to the container
			if(evt.target !== this.domNode){ return; }

			this.focusFirstChild();

			// and then set the container's tabIndex to -1,
			// (don't remove as that breaks Safari 4)
			// so that tab or shift-tab will go to the fields after/before
			// the container, rather than the container itself
			dojo.attr(this.domNode, "tabIndex", "-1");
		},

		_onBlur: function(evt){
			// When focus is moved away the container, and it's descendant (popup) widgets,
			// then restore the container's tabIndex so that user can tab to it again.
			// Note that using _onBlur() so that this doesn't happen when focus is shifted
			// to one of my child widgets (typically a popup)
			if(this.tabIndex){
				dojo.attr(this.domNode, "tabIndex", this.tabIndex);
			}
			this.inherited(arguments);
		},

		_onContainerKeypress: function(evt){
			// summary:
			//		When a key is pressed, if it's an arrow key etc. then
			//		it's handled here.
			// tags:
			//		private
			if(evt.ctrlKey || evt.altKey){ return; }
			var func = this._keyNavCodes[evt.charOrCode];
			if(func){
				func();
				dojo.stopEvent(evt);
			}
		},

		_onChildBlur: function(/*dijit._Widget*/ widget){
			// summary:
			//		Called when focus leaves a child widget to go
			//		to a sibling widget.
			// tags:
			//		protected
		},

		_getFirstFocusableChild: function(){
			// summary:
			//		Returns first child that can be focused
			return this._getNextFocusableChild(null, 1);	// dijit._Widget
		},

		_getNextFocusableChild: function(child, dir){
			// summary:
			//		Returns the next or previous focusable child, compared
			//		to "child"
			// child: Widget
			//		The current widget
			// dir: Integer
			//		* 1 = after
			//		* -1 = before
			if(child){
				child = this._getSiblingOfChild(child, dir);
			}
			var children = this.getChildren();
			for(var i=0; i < children.length; i++){
				if(!child){
					child = children[(dir>0) ? 0 : (children.length-1)];
				}
				if(child.isFocusable()){
					return child;	// dijit._Widget
				}
				child = this._getSiblingOfChild(child, dir);
			}
			// no focusable child found
			return null;	// dijit._Widget
		}
	}
);

}

if(!dojo._hasResource["dijit.MenuItem"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.MenuItem"] = true;
dojo.provide("dijit.MenuItem");





dojo.declare("dijit.MenuItem",
		[dijit._Widget, dijit._Templated, dijit._Contained],
		{
		// summary:
		//		A line item in a Menu Widget

		// Make 3 columns
		// icon, label, and expand arrow (BiDi-dependent) indicating sub-menu
		templateString: dojo.cache("dijit", "templates/MenuItem.html", "<tr class=\"dijitReset dijitMenuItem\" dojoAttachPoint=\"focusNode\" waiRole=\"menuitem\" tabIndex=\"-1\"\n\t\tdojoAttachEvent=\"onmouseenter:_onHover,onmouseleave:_onUnhover,ondijitclick:_onClick\">\n\t<td class=\"dijitReset\" waiRole=\"presentation\">\n\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitMenuItemIcon\" dojoAttachPoint=\"iconNode\">\n\t</td>\n\t<td class=\"dijitReset dijitMenuItemLabel\" colspan=\"2\" dojoAttachPoint=\"containerNode\"></td>\n\t<td class=\"dijitReset dijitMenuItemAccelKey\" style=\"display: none\" dojoAttachPoint=\"accelKeyNode\"></td>\n\t<td class=\"dijitReset dijitMenuArrowCell\" waiRole=\"presentation\">\n\t\t<div dojoAttachPoint=\"arrowWrapper\" style=\"visibility: hidden\">\n\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitMenuExpand\">\n\t\t\t<span class=\"dijitMenuExpandA11y\">+</span>\n\t\t</div>\n\t</td>\n</tr>\n"),

		attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
			label: { node: "containerNode", type: "innerHTML" },
			iconClass: { node: "iconNode", type: "class" }
		}),

		// label: String
		//		Menu text
		label: '',

		// iconClass: String
		//		Class to apply to DOMNode to make it display an icon.
		iconClass: "",

		// accelKey: String
		//		Text for the accelerator (shortcut) key combination.
		//		Note that although Menu can display accelerator keys there
		//		is no infrastructure to actually catch and execute these
		//		accelerators.
		accelKey: "",

		// disabled: Boolean
		//		If true, the menu item is disabled.
		//		If false, the menu item is enabled.
		disabled: false,

		_fillContent: function(/*DomNode*/ source){
			// If button label is specified as srcNodeRef.innerHTML rather than
			// this.params.label, handle it here.
			if(source && !("label" in this.params)){
				this.attr('label', source.innerHTML);
			}
		},

		postCreate: function(){
			dojo.setSelectable(this.domNode, false);
			var label = this.id+"_text";
			dojo.attr(this.containerNode, "id", label);
			if(this.accelKeyNode){
				dojo.attr(this.accelKeyNode, "id", this.id + "_accel");
				label += " " + this.id + "_accel";
			}
			dijit.setWaiState(this.domNode, "labelledby", label);
		},

		_onHover: function(){
			// summary:
			//		Handler when mouse is moved onto menu item
			// tags:
			//		protected
			dojo.addClass(this.domNode, 'dijitMenuItemHover');
			this.getParent().onItemHover(this);
		},

		_onUnhover: function(){
			// summary:
			//		Handler when mouse is moved off of menu item,
			//		possibly to a child menu, or maybe to a sibling
			//		menuitem or somewhere else entirely.
			// tags:
			//		protected

			// if we are unhovering the currently selected item
			// then unselect it
			dojo.removeClass(this.domNode, 'dijitMenuItemHover');
			this.getParent().onItemUnhover(this);
		},

		_onClick: function(evt){
			// summary:
			//		Internal handler for click events on MenuItem.
			// tags:
			//		private
			this.getParent().onItemClick(this, evt);
			dojo.stopEvent(evt);
		},

		onClick: function(/*Event*/ evt){
			// summary:
			//		User defined function to handle clicks
			// tags:
			//		callback
		},

		focus: function(){
			// summary:
			//		Focus on this MenuItem
			try{
				if(dojo.isIE == 8){
					// needed for IE8 which won't scroll TR tags into view on focus yet calling scrollIntoView creates flicker (#10275)
					this.containerNode.focus();
				}
				dijit.focus(this.focusNode);
			}catch(e){
				// this throws on IE (at least) in some scenarios
			}
		},

		_onFocus: function(){
			// summary:
			//		This is called by the focus manager when focus
			//		goes to this MenuItem or a child menu.
			// tags:
			//		protected
			this._setSelected(true);
			this.getParent()._onItemFocus(this);

			this.inherited(arguments);
		},

		_setSelected: function(selected){
			// summary:
			//		Indicate that this node is the currently selected one
			// tags:
			//		private

			/***
			 * TODO: remove this method and calls to it, when _onBlur() is working for MenuItem.
			 * Currently _onBlur() gets called when focus is moved from the MenuItem to a child menu.
			 * That's not supposed to happen, but the problem is:
			 * In order to allow dijit.popup's getTopPopup() to work,a sub menu's popupParent
			 * points to the parent Menu, bypassing the parent MenuItem... thus the
			 * MenuItem is not in the chain of active widgets and gets a premature call to
			 * _onBlur()
			 */

			dojo.toggleClass(this.domNode, "dijitMenuItemSelected", selected);
		},

		setLabel: function(/*String*/ content){
			// summary:
			//		Deprecated.   Use attr('label', ...) instead.
			// tags:
			//		deprecated
			dojo.deprecated("dijit.MenuItem.setLabel() is deprecated.  Use attr('label', ...) instead.", "", "2.0");
			this.attr("label", content);
		},

		setDisabled: function(/*Boolean*/ disabled){
			// summary:
			//		Deprecated.   Use attr('disabled', bool) instead.
			// tags:
			//		deprecated
			dojo.deprecated("dijit.Menu.setDisabled() is deprecated.  Use attr('disabled', bool) instead.", "", "2.0");
			this.attr('disabled', disabled);
		},
		_setDisabledAttr: function(/*Boolean*/ value){
			// summary:
			//		Hook for attr('disabled', ...) to work.
			//		Enable or disable this menu item.
			this.disabled = value;
			dojo[value ? "addClass" : "removeClass"](this.domNode, 'dijitMenuItemDisabled');
			dijit.setWaiState(this.focusNode, 'disabled', value ? 'true' : 'false');
		},
		_setAccelKeyAttr: function(/*String*/ value){
			// summary:
			//		Hook for attr('accelKey', ...) to work.
			//		Set accelKey on this menu item.
			this.accelKey=value;

			this.accelKeyNode.style.display=value?"":"none";
			this.accelKeyNode.innerHTML=value;
			//have to use colSpan to make it work in IE
			dojo.attr(this.containerNode,'colSpan',value?"1":"2");
		}
	});

}

if(!dojo._hasResource["dijit.PopupMenuItem"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.PopupMenuItem"] = true;
dojo.provide("dijit.PopupMenuItem");



dojo.declare("dijit.PopupMenuItem",
		dijit.MenuItem,
		{
		_fillContent: function(){
			// summary:
			//		When Menu is declared in markup, this code gets the menu label and
			//		the popup widget from the srcNodeRef.
			// description:
			//		srcNodeRefinnerHTML contains both the menu item text and a popup widget
			//		The first part holds the menu item text and the second part is the popup
			// example:
			// |	<div dojoType="dijit.PopupMenuItem">
			// |		<span>pick me</span>
			// |		<popup> ... </popup>
			// |	</div>
			// tags:
			//		protected

			if(this.srcNodeRef){
				var nodes = dojo.query("*", this.srcNodeRef);
				dijit.PopupMenuItem.superclass._fillContent.call(this, nodes[0]);

				// save pointer to srcNode so we can grab the drop down widget after it's instantiated
				this.dropDownContainer = this.srcNodeRef;
			}
		},

		startup: function(){
			if(this._started){ return; }
			this.inherited(arguments);

			// we didn't copy the dropdown widget from the this.srcNodeRef, so it's in no-man's
			// land now.  move it to dojo.doc.body.
			if(!this.popup){
				var node = dojo.query("[widgetId]", this.dropDownContainer)[0];
				this.popup = dijit.byNode(node);
			}
			dojo.body().appendChild(this.popup.domNode);

			this.popup.domNode.style.display="none";
			if(this.arrowWrapper){
				dojo.style(this.arrowWrapper, "visibility", "");
			}
			dijit.setWaiState(this.focusNode, "haspopup", "true");
		},

		destroyDescendants: function(){
			if(this.popup){
				// Destroy the popup, unless it's already been destroyed.  This can happen because
				// the popup is a direct child of <body> even though it's logically my child.
				if(!this.popup._destroyed){
					this.popup.destroyRecursive();
				}
				delete this.popup;
			}
			this.inherited(arguments);
		}
	});


}

if(!dojo._hasResource["dijit.CheckedMenuItem"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.CheckedMenuItem"] = true;
dojo.provide("dijit.CheckedMenuItem");



dojo.declare("dijit.CheckedMenuItem",
		dijit.MenuItem,
		{
		// summary:
		//		A checkbox-like menu item for toggling on and off

		templateString: dojo.cache("dijit", "templates/CheckedMenuItem.html", "<tr class=\"dijitReset dijitMenuItem\" dojoAttachPoint=\"focusNode\" waiRole=\"menuitemcheckbox\" tabIndex=\"-1\"\n\t\tdojoAttachEvent=\"onmouseenter:_onHover,onmouseleave:_onUnhover,ondijitclick:_onClick\">\n\t<td class=\"dijitReset\" waiRole=\"presentation\">\n\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitMenuItemIcon dijitCheckedMenuItemIcon\" dojoAttachPoint=\"iconNode\">\n\t\t<span class=\"dijitCheckedMenuItemIconChar\">&#10003;</span>\n\t</td>\n\t<td class=\"dijitReset dijitMenuItemLabel\" colspan=\"2\" dojoAttachPoint=\"containerNode,labelNode\"></td>\n\t<td class=\"dijitReset dijitMenuItemAccelKey\" style=\"display: none\" dojoAttachPoint=\"accelKeyNode\"></td>\n\t<td class=\"dijitReset dijitMenuArrowCell\" waiRole=\"presentation\">\n\t</td>\n</tr>\n"),

		// checked: Boolean
		//		Our checked state
		checked: false,
		_setCheckedAttr: function(/*Boolean*/ checked){
			// summary:
			//		Hook so attr('checked', bool) works.
			//		Sets the class and state for the check box.
			dojo.toggleClass(this.domNode, "dijitCheckedMenuItemChecked", checked);
			dijit.setWaiState(this.domNode, "checked", checked);
			this.checked = checked;
		},

		onChange: function(/*Boolean*/ checked){
			// summary:
			//		User defined function to handle check/uncheck events
			// tags:
			//		callback
		},

		_onClick: function(/*Event*/ e){
			// summary:
			//		Clicking this item just toggles its state
			// tags:
			//		private
			if(!this.disabled){
				this.attr("checked", !this.checked);
				this.onChange(this.checked);
			}
			this.inherited(arguments);
		}
	});

}

if(!dojo._hasResource["dijit.MenuSeparator"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.MenuSeparator"] = true;
dojo.provide("dijit.MenuSeparator");





dojo.declare("dijit.MenuSeparator",
		[dijit._Widget, dijit._Templated, dijit._Contained],
		{
		// summary:
		//		A line between two menu items

		templateString: dojo.cache("dijit", "templates/MenuSeparator.html", "<tr class=\"dijitMenuSeparator\">\n\t<td colspan=\"4\">\n\t\t<div class=\"dijitMenuSeparatorTop\"></div>\n\t\t<div class=\"dijitMenuSeparatorBottom\"></div>\n\t</td>\n</tr>\n"),

		postCreate: function(){
			dojo.setSelectable(this.domNode, false);
		},

		isFocusable: function(){
			// summary:
			//		Override to always return false
			// tags:
			//		protected

			return false; // Boolean
		}
	});


}

if(!dojo._hasResource["dijit.Menu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.Menu"] = true;
dojo.provide("dijit.Menu");





dojo.declare("dijit._MenuBase",
	[dijit._Widget, dijit._Templated, dijit._KeyNavContainer],
{
	// summary:
	//		Base class for Menu and MenuBar

	// parentMenu: [readonly] Widget
	//		pointer to menu that displayed me
	parentMenu: null,

	// popupDelay: Integer
	//		number of milliseconds before hovering (without clicking) causes the popup to automatically open.
	popupDelay: 500,

	startup: function(){
		if(this._started){ return; }

		dojo.forEach(this.getChildren(), function(child){ child.startup(); });
		this.startupKeyNavChildren();

		this.inherited(arguments);
	},

	onExecute: function(){
		// summary:
		//		Attach point for notification about when a menu item has been executed.
		//		This is an internal mechanism used for Menus to signal to their parent to
		//		close them, because they are about to execute the onClick handler.   In
		//		general developers should not attach to or override this method.
		// tags:
		//		protected
	},

	onCancel: function(/*Boolean*/ closeAll){
		// summary:
		//		Attach point for notification about when the user cancels the current menu
		//		This is an internal mechanism used for Menus to signal to their parent to
		//		close them.  In general developers should not attach to or override this method.
		// tags:
		//		protected
	},

	_moveToPopup: function(/*Event*/ evt){
		// summary:
		//		This handles the right arrow key (left arrow key on RTL systems),
		//		which will either open a submenu, or move to the next item in the
		//		ancestor MenuBar
		// tags:
		//		private

		if(this.focusedChild && this.focusedChild.popup && !this.focusedChild.disabled){
			this.focusedChild._onClick(evt);
		}else{
			var topMenu = this._getTopMenu();
			if(topMenu && topMenu._isMenuBar){
				topMenu.focusNext();
			}
		}
	},

	_onPopupHover: function(/*Event*/ evt){
		// summary:
		//		This handler is called when the mouse moves over the popup.
		// tags:
		//		private

		// if the mouse hovers over a menu popup that is in pending-close state,
		// then stop the close operation.
		// This can't be done in onItemHover since some popup targets don't have MenuItems (e.g. ColorPicker)
		if(this.currentPopup && this.currentPopup._pendingClose_timer){
			var parentMenu = this.currentPopup.parentMenu;
			// highlight the parent menu item pointing to this popup
			if(parentMenu.focusedChild){
				parentMenu.focusedChild._setSelected(false);
			}
			parentMenu.focusedChild = this.currentPopup.from_item;
			parentMenu.focusedChild._setSelected(true);
			// cancel the pending close
			this._stopPendingCloseTimer(this.currentPopup);
		}
	},

	onItemHover: function(/*MenuItem*/ item){
		// summary:
		//		Called when cursor is over a MenuItem.
		// tags:
		//		protected

		// Don't do anything unless user has "activated" the menu by:
		//		1) clicking it
		//		2) opening it from a parent menu (which automatically focuses it)
		if(this.isActive){
			this.focusChild(item);
			if(this.focusedChild.popup && !this.focusedChild.disabled && !this.hover_timer){
				this.hover_timer = setTimeout(dojo.hitch(this, "_openPopup"), this.popupDelay);
			}
		}
		// if the user is mixing mouse and keyboard navigation,
		// then the menu may not be active but a menu item has focus,
		// but it's not the item that the mouse just hovered over.
		// To avoid both keyboard and mouse selections, use the latest.
		if(this.focusedChild){
			this.focusChild(item);
		}
		this._hoveredChild = item;
	},

	_onChildBlur: function(item){
		// summary:
		//		Called when a child MenuItem becomes inactive because focus
		//		has been removed from the MenuItem *and* it's descendant menus.
		// tags:
		//		private
		this._stopPopupTimer();
		item._setSelected(false);
		// Close all popups that are open and descendants of this menu
		var itemPopup = item.popup;
		if(itemPopup){
			this._stopPendingCloseTimer(itemPopup);
			itemPopup._pendingClose_timer = setTimeout(function(){
				itemPopup._pendingClose_timer = null;
				if(itemPopup.parentMenu){
					itemPopup.parentMenu.currentPopup = null;
				}
				dijit.popup.close(itemPopup); // this calls onClose
			}, this.popupDelay);
		}
	},

	onItemUnhover: function(/*MenuItem*/ item){
		// summary:
		//		Callback fires when mouse exits a MenuItem
		// tags:
		//		protected

		if(this.isActive){
			this._stopPopupTimer();
		}
		if(this._hoveredChild == item){ this._hoveredChild = null; }
	},

	_stopPopupTimer: function(){
		// summary:
		//		Cancels the popup timer because the user has stop hovering
		//		on the MenuItem, etc.
		// tags:
		//		private
		if(this.hover_timer){
			clearTimeout(this.hover_timer);
			this.hover_timer = null;
		}
	},

	_stopPendingCloseTimer: function(/*dijit._Widget*/ popup){
		// summary:
		//		Cancels the pending-close timer because the close has been preempted
		// tags:
		//		private
		if(popup._pendingClose_timer){
			clearTimeout(popup._pendingClose_timer);
			popup._pendingClose_timer = null;
		}
	},

	_stopFocusTimer: function(){
		// summary:
		//		Cancels the pending-focus timer because the menu was closed before focus occured
		// tags:
		//		private
		if(this._focus_timer){
			clearTimeout(this._focus_timer);
			this._focus_timer = null;
		}
	},

	_getTopMenu: function(){
		// summary:
		//		Returns the top menu in this chain of Menus
		// tags:
		//		private
		for(var top=this; top.parentMenu; top=top.parentMenu);
		return top;
	},

	onItemClick: function(/*dijit._Widget*/ item, /*Event*/ evt){
		// summary:
		//		Handle clicks on an item.
		// tags:
		//		private
		if(item.disabled){ return false; }

		// this can't be done in _onFocus since the _onFocus events occurs asynchronously
		if(typeof this.isShowingNow == 'undefined'){ // non-popup menu
			this._markActive();
		}

		this.focusChild(item);

		if(item.popup){
			this._openPopup();
		}else{
			// before calling user defined handler, close hierarchy of menus
			// and restore focus to place it was when menu was opened
			this.onExecute();

			// user defined handler for click
			item.onClick(evt);
		}
	},

	_openPopup: function(){
		// summary:
		//		Open the popup to the side of/underneath the current menu item
		// tags:
		//		protected

		this._stopPopupTimer();
		var from_item = this.focusedChild;
		if(!from_item){ return; } // the focused child lost focus since the timer was started
		var popup = from_item.popup;
		if(popup.isShowingNow){ return; }
		if(this.currentPopup){
			this._stopPendingCloseTimer(this.currentPopup);
			dijit.popup.close(this.currentPopup);
		}
		popup.parentMenu = this;
		popup.from_item = from_item; // helps finding the parent item that should be focused for this popup
		var self = this;
		dijit.popup.open({
			parent: this,
			popup: popup,
			around: from_item.domNode,
			orient: this._orient || (this.isLeftToRight() ?
									{'TR': 'TL', 'TL': 'TR', 'BR': 'BL', 'BL': 'BR'} :
									{'TL': 'TR', 'TR': 'TL', 'BL': 'BR', 'BR': 'BL'}),
			onCancel: function(){ // called when the child menu is canceled
				// set isActive=false (_closeChild vs _cleanUp) so that subsequent hovering will NOT open child menus
				// which seems aligned with the UX of most applications (e.g. notepad, wordpad, paint shop pro)
				self.focusChild(from_item);	// put focus back on my node
				self._cleanUp();			// close the submenu (be sure this is done _after_ focus is moved)
				from_item._setSelected(true); // oops, _cleanUp() deselected the item
				self.focusedChild = from_item;	// and unset focusedChild
			},
			onExecute: dojo.hitch(this, "_cleanUp")
		});

		this.currentPopup = popup;
		// detect mouseovers to handle lazy mouse movements that temporarily focus other menu items
		popup.connect(popup.domNode, "onmouseenter", dojo.hitch(self, "_onPopupHover")); // cleaned up when the popped-up widget is destroyed on close

		if(popup.focus){
			// If user is opening the popup via keyboard (right arrow, or down arrow for MenuBar),
			// if the cursor happens to collide with the popup, it will generate an onmouseover event
			// even though the mouse wasn't moved.   Use a setTimeout() to call popup.focus so that
			// our focus() call overrides the onmouseover event, rather than vice-versa.  (#8742)
			popup._focus_timer = setTimeout(dojo.hitch(popup, function(){
				this._focus_timer = null;
				this.focus();
			}), 0);
		}
	},

	_markActive: function(){
		// summary:
		//              Mark this menu's state as active.
		//		Called when this Menu gets focus from:
		//			1) clicking it (mouse or via space/arrow key)
		//			2) being opened by a parent menu.
		//		This is not called just from mouse hover.
		//		Focusing a menu via TAB does NOT automatically set isActive
		//		since TAB is a navigation operation and not a selection one.
		//		For Windows apps, pressing the ALT key focuses the menubar
		//		menus (similar to TAB navigation) but the menu is not active
		//		(ie no dropdown) until an item is clicked.
		this.isActive = true;
		dojo.addClass(this.domNode, "dijitMenuActive");
		dojo.removeClass(this.domNode, "dijitMenuPassive");
	},

	onOpen: function(/*Event*/ e){
		// summary:
		//		Callback when this menu is opened.
		//		This is called by the popup manager as notification that the menu
		//		was opened.
		// tags:
		//		private

		this.isShowingNow = true;
		this._markActive();
	},

	_markInactive: function(){
		// summary:
		//		Mark this menu's state as inactive.
		this.isActive = false; // don't do this in _onBlur since the state is pending-close until we get here
		dojo.removeClass(this.domNode, "dijitMenuActive");
		dojo.addClass(this.domNode, "dijitMenuPassive");
	},

	onClose: function(){
		// summary:
		//		Callback when this menu is closed.
		//		This is called by the popup manager as notification that the menu
		//		was closed.
		// tags:
		//		private

		this._stopFocusTimer();
		this._markInactive();
		this.isShowingNow = false;
		this.parentMenu = null;
	},

	_closeChild: function(){
		// summary:
		//		Called when submenu is clicked or focus is lost.  Close hierarchy of menus.
		// tags:
		//		private
		this._stopPopupTimer();
		if(this.focusedChild){ // unhighlight the focused item
			this.focusedChild._setSelected(false);
			this.focusedChild._onUnhover();
			this.focusedChild = null;
		}
		if(this.currentPopup){
			// Close all popups that are open and descendants of this menu
			dijit.popup.close(this.currentPopup);
			this.currentPopup = null;
		}
	},

	_onItemFocus: function(/*MenuItem*/ item){
		// summary:
		//		Called when child of this Menu gets focus from:
		//			1) clicking it
		//			2) tabbing into it
		//			3) being opened by a parent menu.
		//		This is not called just from mouse hover.
		if(this._hoveredChild && this._hoveredChild != item){
			this._hoveredChild._onUnhover(); // any previous mouse movement is trumped by focus selection
		}
	},

	_onBlur: function(){
		// summary:
		//		Called when focus is moved away from this Menu and it's submenus.
		// tags:
		//		protected
		this._cleanUp();
		this.inherited(arguments);
	},

	_cleanUp: function(){
		// summary:
		//		Called when the user is done with this menu.  Closes hierarchy of menus.
		// tags:
		//		private

		this._closeChild(); // don't call this.onClose since that's incorrect for MenuBar's that never close
		if(typeof this.isShowingNow == 'undefined'){ // non-popup menu doesn't call onClose
			this._markInactive();
		}
	}
});

dojo.declare("dijit.Menu",
	dijit._MenuBase,
	{
	// summary
	//		A context menu you can assign to multiple elements

	// TODO: most of the code in here is just for context menu (right-click menu)
	// support.  In retrospect that should have been a separate class (dijit.ContextMenu).
	// Split them for 2.0

	constructor: function(){
		this._bindings = [];
	},

	templateString: dojo.cache("dijit", "templates/Menu.html", "<table class=\"dijit dijitMenu dijitMenuPassive dijitReset dijitMenuTable\" waiRole=\"menu\" tabIndex=\"${tabIndex}\" dojoAttachEvent=\"onkeypress:_onKeyPress\">\n\t<tbody class=\"dijitReset\" dojoAttachPoint=\"containerNode\"></tbody>\n</table>\n"),

	// targetNodeIds: [const] String[]
	//		Array of dom node ids of nodes to attach to.
	//		Fill this with nodeIds upon widget creation and it becomes context menu for those nodes.
	targetNodeIds: [],

	// contextMenuForWindow: [const] Boolean
	//		If true, right clicking anywhere on the window will cause this context menu to open.
	//		If false, must specify targetNodeIds.
	contextMenuForWindow: false,

	// leftClickToOpen: [const] Boolean
	//		If true, menu will open on left click instead of right click, similiar to a file menu.
	leftClickToOpen: false,

	// refocus: Boolean
	// 		When this menu closes, re-focus the element which had focus before it was opened.
	refocus: true,

	// _contextMenuWithMouse: [private] Boolean
	//		Used to record mouse and keyboard events to determine if a context
	//		menu is being opened with the keyboard or the mouse.
	_contextMenuWithMouse: false,

	postCreate: function(){
		if(this.contextMenuForWindow){
			this.bindDomNode(dojo.body());
		}else{
			// TODO: should have _setTargetNodeIds() method to handle initialization and a possible
			// later attr('targetNodeIds', ...) call.   There's also a problem that targetNodeIds[]
			// gets stale after calls to bindDomNode()/unBindDomNode() as it still is just the original list (see #9610)
			dojo.forEach(this.targetNodeIds, this.bindDomNode, this);
		}
		var k = dojo.keys, l = this.isLeftToRight();
		this._openSubMenuKey = l ? k.RIGHT_ARROW : k.LEFT_ARROW;
		this._closeSubMenuKey = l ? k.LEFT_ARROW : k.RIGHT_ARROW;
		this.connectKeyNavHandlers([k.UP_ARROW], [k.DOWN_ARROW]);
	},

	_onKeyPress: function(/*Event*/ evt){
		// summary:
		//		Handle keyboard based menu navigation.
		// tags:
		//		protected

		if(evt.ctrlKey || evt.altKey){ return; }

		switch(evt.charOrCode){
			case this._openSubMenuKey:
				this._moveToPopup(evt);
				dojo.stopEvent(evt);
				break;
			case this._closeSubMenuKey:
				if(this.parentMenu){
					if(this.parentMenu._isMenuBar){
						this.parentMenu.focusPrev();
					}else{
						this.onCancel(false);
					}
				}else{
					dojo.stopEvent(evt);
				}
				break;
		}
	},

	// thanks burstlib!
	_iframeContentWindow: function(/* HTMLIFrameElement */iframe_el){
		// summary:
		//		Returns the window reference of the passed iframe
		// tags:
		//		private
		var win = dijit.getDocumentWindow(this._iframeContentDocument(iframe_el)) ||
			// Moz. TODO: is this available when defaultView isn't?
			this._iframeContentDocument(iframe_el)['__parent__'] ||
			(iframe_el.name && dojo.doc.frames[iframe_el.name]) || null;
		return win;	//	Window
	},

	_iframeContentDocument: function(/* HTMLIFrameElement */iframe_el){
		// summary:
		//		Returns a reference to the document object inside iframe_el
		// tags:
		//		protected
		var doc = iframe_el.contentDocument // W3
			|| (iframe_el.contentWindow && iframe_el.contentWindow.document) // IE
			|| (iframe_el.name && dojo.doc.frames[iframe_el.name] && dojo.doc.frames[iframe_el.name].document)
			|| null;
		return doc;	//	HTMLDocument
	},

	bindDomNode: function(/*String|DomNode*/ node){
		// summary:
		//		Attach menu to given node
		node = dojo.byId(node);

		var cn;	// Connect node

		// Support context menus on iframes.   Rather than binding to the iframe itself we need
		// to bind to the <body> node inside the iframe.
		if(node.tagName.toLowerCase() == "iframe"){
			var iframe = node,
				win = this._iframeContentWindow(iframe);
			cn = dojo.withGlobal(win, dojo.body);
		}else{
			
			// To capture these events at the top level, attach to <html>, not <body>.
			// Otherwise right-click context menu just doesn't work.
			cn = (node == dojo.body() ? dojo.doc.documentElement : node);
		}


		// "binding" is the object to track our connection to the node (ie, the parameter to bindDomNode())
		var binding = {
			node: node,
			iframe: iframe
		};

		// Save info about binding in _bindings[], and make node itself record index(+1) into
		// _bindings[] array.   Prefix w/_dijitMenu to avoid setting an attribute that may
		// start with a number, which fails on FF/safari.
		dojo.attr(node, "_dijitMenu" + this.id, this._bindings.push(binding));

		// Setup the connections to monitor click etc., unless we are connecting to an iframe which hasn't finished
		// loading yet, in which case we need to wait for the onload event first, and then connect
		var doConnects = dojo.hitch(this, function(cn){
			return [
				dojo.connect(cn, (this.leftClickToOpen)?"onclick":"oncontextmenu", this, function(evt){
					this._openMyself(evt, cn, iframe);
				}),
				dojo.connect(cn, "onkeydown", this, "_contextKey"),
				dojo.connect(cn, "onmousedown", this, "_contextMouse")
			];
		});
		binding.connects = cn ? doConnects(cn) : [];

		if(iframe){
			// Setup handler to [re]bind to the iframe when the contents are initially loaded,
			// and every time the contents change.
			// Need to do this b/c we are actually binding to the iframe's <body> node.
			// Note: can't use dojo.connect(), see #9609.

			binding.onloadHandler = dojo.hitch(this, function(){
				// want to remove old connections, but IE throws exceptions when trying to
				// access the <body> node because it's already gone, or at least in a state of limbo

				var win = this._iframeContentWindow(iframe);
					cn = dojo.withGlobal(win, dojo.body);
				binding.connects = doConnects(cn);
			});
			if(iframe.addEventListener){
				iframe.addEventListener("load", binding.onloadHandler, false);
			}else{
				iframe.attachEvent("onload", binding.onloadHandler);
			}
		}
	},

	unBindDomNode: function(/*String|DomNode*/ nodeName){
		// summary:
		//		Detach menu from given node

		var node;
		try{
			node = dojo.byId(nodeName);
		}catch(e){
			// On IE the dojo.byId() call will get an exception if the attach point was
			// the <body> node of an <iframe> that has since been reloaded (and thus the
			// <body> node is in a limbo state of destruction.
			return;
		}

		// node["_dijitMenu" + this.id] contains index(+1) into my _bindings[] array
		var attrName = "_dijitMenu" + this.id;
		if(node && dojo.hasAttr(node, attrName)){
			var bid = dojo.attr(node, attrName)-1, b = this._bindings[bid];
			dojo.forEach(b.connects, dojo.disconnect);

			// Remove listener for iframe onload events
			var iframe = b.iframe;
			if(iframe){
				if(iframe.removeEventListener){
					iframe.removeEventListener("load", b.onloadHandler, false);
				}else{
					iframe.detachEvent("onload", b.onloadHandler);
				}
			}

			dojo.removeAttr(node, attrName);
			delete this._bindings[bid];
		}
	},

	_contextKey: function(e){
		// summary:
		//		Code to handle popping up editor using F10 key rather than mouse
		// tags:
		//		private
		this._contextMenuWithMouse = false;
		if(e.keyCode == dojo.keys.F10){
			dojo.stopEvent(e);
			if(e.shiftKey && e.type == "keydown"){
				// FF: copying the wrong property from e will cause the system
				// context menu to appear in spite of stopEvent. Don't know
				// exactly which properties cause this effect.
				var _e = { target: e.target, pageX: e.pageX, pageY: e.pageY };
				_e.preventDefault = _e.stopPropagation = function(){};
				// IE: without the delay, focus work in "open" causes the system
				// context menu to appear in spite of stopEvent.
				window.setTimeout(dojo.hitch(this, function(){ this._openMyself(_e); }), 1);
			}
		}
	},

	_contextMouse: function(e){
		// summary:
		//		Helper to remember when we opened the context menu with the mouse instead
		//		of with the keyboard
		// tags:
		//		private
		this._contextMenuWithMouse = true;
	},

	_openMyself: function(/*Event*/ e, /*DomNode?*/ node, /*DomNode?*/ iframe){
		// summary:
		//		Internal function for opening myself when the user
		//		does a right-click or something similar.
		// node:
		//		The node that is being clicked
		// iframe:
		//		If an <iframe> is being clicked, iframe points to that iframe and node
		//		points to the iframe's body.
		// tags:
		//		private

		if(this.leftClickToOpen && e.button>0){
			return;
		}
		dojo.stopEvent(e);

		// Get coordinates.
		// If we are opening the menu with the mouse or on safari open
		// the menu at the mouse cursor
		// (Safari does not have a keyboard command to open the context menu
		// and we don't currently have a reliable way to determine
		// _contextMenuWithMouse on Safari)
		var x,y;
		if(dojo.isSafari || this._contextMenuWithMouse){
			x=e.pageX;
			y=e.pageY;

			if(iframe){
				// Event is on <body> node of an <iframe>, convert coordinates to match main document
				var od = e.target.ownerDocument,
					ifc = dojo.position(iframe, true),
					win = this._iframeContentWindow(iframe),
					scroll = dojo.withGlobal(win, "_docScroll", dojo);

				var cs = dojo.getComputedStyle(iframe),
					tp = dojo._toPixelValue,
					left = (dojo.isIE && dojo.isQuirks ? 0 : tp(iframe, cs.paddingLeft)) + (dojo.isIE && dojo.isQuirks ? tp(iframe, cs.borderLeftWidth) : 0),
					top = (dojo.isIE && dojo.isQuirks ? 0 : tp(iframe, cs.paddingTop)) + (dojo.isIE && dojo.isQuirks ? tp(iframe, cs.borderTopWidth) : 0);

				x += ifc.x + left - scroll.x;
				y += ifc.y + top - scroll.y;
			}
		}else{
			// otherwise open near e.target
			var coords = dojo.position(e.target, true);
			x = coords.x + 10;
			y = coords.y + 10;
		}

		var self=this;
		var savedFocus = dijit.getFocus(this);
		function closeAndRestoreFocus(){
			// user has clicked on a menu or popup
			if(self.refocus){
				dijit.focus(savedFocus);
			}
			dijit.popup.close(self);
		}
		dijit.popup.open({
			popup: this,
			x: x,
			y: y,
			onExecute: closeAndRestoreFocus,
			onCancel: closeAndRestoreFocus,
			orient: this.isLeftToRight() ? 'L' : 'R'
		});
		this.focus();

		this._onBlur = function(){
			this.inherited('_onBlur', arguments);
			// Usually the parent closes the child widget but if this is a context
			// menu then there is no parent
			dijit.popup.close(this);
			// don't try to restore focus; user has clicked another part of the screen
			// and set focus there
		};
	},

	uninitialize: function(){
 		dojo.forEach(this._bindings, function(b){ if(b){ this.unBindDomNode(b.node); } }, this);
 		this.inherited(arguments);
	}
}
);

// Back-compat (TODO: remove in 2.0)






}

if(!dojo._hasResource["epages.widget.Menu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Menu"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.widget.Menu $Revision: 1.8 $

*/
dojo.provide("epages.widget.Menu");



dojo.declare(
	"epages.widget.Menu",
	[dijit.Menu], {
		templateString:
			'<div class="Menu" ><div class="Layer"><div class="PropertyContainer">' +
				'<table class="dijit dijitMenu dijitReset dijitMenuTable" waiRole="menu" dojoAttachEvent="onkeypress:_onKeyPress" cellspacing="0">' +
					'<tbody class="dijitReset" dojoAttachPoint="containerNode"></tbody>'+
				'</table>'+
			'</div></div>' +
			'<div class="LayerFooter"><div class="PropertyContainer"></div></div></div>'
	}
);

}

if(!dojo._hasResource["epages.widget.Elementlistitem"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Elementlistitem"] = true;
dojo.provide("epages.widget.Elementlistitem");



dojo.declare("epages.widget.Elementlistitem", [epages.widget.LocalizedWidget, dijit._Contained],  {
		/**
		 * public properties
		 */
		templateString:     '<div class="${itemClassName}">${title}</div>',
		itemClassName:      'ElementListItem',
		hoverClassName:     'Hover',
		selectClassName:    'Selected',
		isSelected:         false,
		objectId:           '',
		title:              'item',
		parent:             undefined,
		translationName:    dojo.moduleUrl('epages','translation'),
		selectOn:           'onclick',
		disabled:           false,
		/**
		 * public methods
		 */
		postCreate: function() {
			epages.widget.Elementlistitem.superclass.postCreate.apply(this, arguments);

			// connect events
			this.connect(this.domNode, "onmouseover", '_onMouseOver');
			this.connect(this.domNode, "onmouseout",  '_onMouseOut');
			this.connect(this.domNode, this.selectOn, '_onClick');
			this.parent = this.getParent();
		},

		select: function () {
			this.isSelected = true;
			dojo.addClass(this.domNode, this.selectClassName);
		},

		deselect: function () {
			this.isSelected = false;
			dojo.removeClass(this.domNode, this.selectClassName);
		},

		/**
		 * private methods
		 */
		_onMouseOver: function() {
			dojo.addClass(this.domNode, this.hoverClassName);
		},

		_onMouseOut: function() {
			dojo.removeClass(this.domNode, this.hoverClassName);
		},

		_onClick: function(evt) {
			if (this.getParent()) {
				this.getParent().doSelectItem(this, this.isSelected, evt);
			} else {
				this.isSelected ? this.deselect() : this.select();
				dojo.publish(this.id+'/onClick', [{ widget: this, node: this.domNode, objectId: this.objectId }]);
			}
		}
	}
);

}

if(!dojo._hasResource["epages.widget.Elementlist"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Elementlist"] = true;
dojo.provide("epages.widget.Elementlist");




dojo.declare("epages.widget.Elementlist", [dijit._Widget,dijit._Templated,dijit._Container], {

		/**
		 * public properties
		 */
		templateString:"<div>\n\t<div class=\"${listClassName}\" dojoAttachPoint=\"containerNode\"></div>\n\t<div dojoAttachPoint=\"PaggerButtons\" class=\"HideElement AlignCenter LinkImage ClearBoth\">\n\t\t<i dojoAttachPoint=\"PageDownNode\" class=\"\" title=\"\">&lt;</i>\n\t\t<span dojoAttachPoint=\"PageButtonsContainer\"></span>\n\t\t<i dojoAttachPoint=\"PageUpNode\" class=\"\" title=\"\">&gt;</i>\n\t</div>\n\t<span dojoAttachPoint=\"PageButtonNode\">\n  </span>\n</div>\n",
		listClassName:      'ElementList',
		widgetElementType:  "epages.widget.Elementlistitem",
		multiSelect:        'false',
		objectId:           '',
		onselect:           '',
		children:           [],
		store:              undefined,
		pagging:            false,
		paggingQuantity:    20,

		eventNames:         undefined,
		eventNamesDefault: {
			afterListCreate:  'afterListCreate',
			afterSetChildren: 'afterSetChildren',
			select:           'select',
			deselect:         'deselect'
		},

		selectTypes:{
			SINGLE: 'SINGLE', // no modification key
			ADD:    'ADD',    // CTRL key
			LIST:   'LIST'    // SHIFT key
		},

		/**
		 * private properties
		 */
		_lastSelectedItem:   undefined,
		_allChildren: [],
		_pagger: {
			currentVisibleChildren : [],
			currentPage : 0,
			maxPage: 0
		},

		postMixInProperties: function(){
			this.pagging = epages.string.toBoolean(this.pagging);
		},

		adjustEventNames: function() {
			// summary: add id of widget to event names
			this.eventNames = {};
			for(var name in this.eventNamesDefault) {
				if (this.eventNames[name] === undefined) {
					this.eventNames[name] = this.id + "/" + this.eventNamesDefault[name];
				}
			}
		},

		initialize: function () {
			// summary: clear last selected item, when the list gets new content
			this._lastSelectedItem = undefined;
		},

		postCreate: function() {
			// summary: only add pagging events is pagging is activated
			this.inherited("postCreate", arguments);
			this.adjustEventNames();
			if(this.pagging){
				this.connect(this.PageDownNode, "onclick", 'pageDown');
				this.connect(this.PageUpNode, "onclick", 'pageUp');
			}

		},

		startup: function(){
			// summary: collect children that are inside the main dom node and put them inside array for later use
			this.children = this.getChildren();
			dojo.publish(this.eventNames.afterListCreate, [this]);
		},

		pageUp:function(){
			// summary: changes the visible elemnts by pagging one page down
			if(this._pagger.currentPage+1 != this._pagger.maxPage){
				var page = this._pagger.currentPage + 1;
				this._createVisibleChildren(this._allChildren,page);
			}
		},

		pageDown:function(){
			// summary: changes the visible elemnts by pagging one page up
			if(this._pagger.currentPage > 0){
				var page = this._pagger.currentPage - 1;
				this._createVisibleChildren(this._allChildren,page);
			}
		},

		pageTo: function(page){
			// summary: changes the visible elemnts by pagging to given page
			if(page >= 0 && page < this._pagger.maxPage){
				this._createVisibleChildren(this._allChildren,page);
			}
		},

		_setPagerButtons: function(startId, endId){
			// summary: creates pager buttons if needed and sets status of page up / down node
			dojo.removeClass(this.PaggerButtons,'HideElement');
			if(endId > this._allChildren.length){
				dojo.addClass(this.PageUpNode,'Disabled');
			}
			else{
				dojo.removeClass(this.PageUpNode,'Disabled');
			}
			if(startId == 0){
				dojo.addClass(this.PageDownNode,'Disabled');
			}
			else{
				dojo.removeClass(this.PageDownNode,'Disabled');
			}
			//create array of pages and fill them until current page is inside
			//remove first element if array is larger than 10 and current page are not inside
			//end if all pages are in or current page is at right position
			var pageIdArray = [];
			for(var i = 0; i < this._pagger.maxPage; i++){
				var pageId = i;
				pageIdArray.push(pageId);
				if(pageIdArray.length == 10){
					if($A(pageIdArray).exists(this._pagger.currentPage)){
						if($A(pageIdArray).find(this._pagger.currentPage) <= 5){
							break;
						}
						else{
							pageIdArray.shift();
						}
					}
					else{
						pageIdArray.shift();
					}
				}
			}
			//create spans for pager entrys, attach page events and highlight current page
			this.PageButtonsContainer.innerHTML = '';
			for( var j=0,jLength=pageIdArray.length ; j<jLength ; j++ ){
				currentPage = pageIdArray[j];
				//use PageButtonNode as prototype for page buttons
				var newPageButtonNode = this.PageButtonNode.cloneNode(true);
				this.PageButtonsContainer.appendChild(newPageButtonNode);
				this.connect(newPageButtonNode, 'onclick', epages.lang.hitch(this,this.pageTo, [currentPage]));
				if(currentPage == this._pagger.currentPage){
					dojo.addClass(newPageButtonNode,'Selected');
					newPageButtonNode.innerHTML = '<b> '+(currentPage+1)+' </b>';
				}
				else{
					newPageButtonNode.innerHTML = ' '+(currentPage+1)+' ';
				}
			}
		},

		_createVisibleChildren: function(elements,page){
			// summary: creates widgets for the current on this page of list visible children
			// creates all children if there is only one page
			//save Children and destroy old visible Children

			//remove old content
			this._allChildren = elements;
			this.destroyDescendants();
			this.initialize();
			//check pagger and display buttons if needed
			this._pagger.currentPage = page;
			if(this.pagging && this._pagger.maxPage > 1){
				var startId = page * this.paggingQuantity;
				var endId = startId + this.paggingQuantity;
				this._setPagerButtons(startId, endId);
			}
			else{
				var startId = 0;
				var endId = elements.length;
				dojo.addClass(this.PaggerButtons,'HideElement');
			}

			//createVisible Children
			for (var i = startId; i < endId; i++) {
				//could be possible that endId is greater than number of children
				if(i > this._allChildren.length){
					break;
				}
				var elm = this._allChildren[i];
				if(elm){
					elm.parentId = this.id;
					elm.store = this.store;
					var item = new (eval(this.widgetElementType))(elm);
					item.data = elm;
					this.addChild(item);
					item.startup();
					this._pagger.currentVisibleChildren.push(item);
				}
			}
			this.children = this.getChildren();
			dojo.publish(this.eventNames.afterSetChildren, [{ source: this, length: this.children.length }] );
		},

		setChildren: function(/*array*/ elements) {
			// summary: set children elements for list and show first page
			this._pagger.maxPage = Math.ceil(elements.length / this.paggingQuantity);
			this._createVisibleChildren(elements,0);
		},

		selectedNodes: function () {
			// summary: return current selected nodes of list can be more than one if multiSelect is enabled
			if (this.multiSelect != 'true') {
				if (this._lastSelectedItem === undefined){
					return []; // Array
				}
				return [this._lastSelectedItem]; // Array
			}
			// get selected widgets
			var nodes = dojo.filter(this.getChildren(), function (el) {
				return (typeof (el.isSelected) == 'boolean' && el.isSelected);
			});
			return nodes; // Array
		},

		selectedItems: function () {
			// summary: returns array of objectIds of current selected items
			var nodes = this.selectedNodes();
			var objectIds = dojo.map(nodes, function (el) {
				return el.objectId;
			});
			return objectIds; // Array
		},

		select: function(/*Elementlistitem*/ item) {
			if (this._lastSelectedItem !== undefined && this.multiSelect != 'true') {
				// deselect old selected item
				this._lastSelectedItem.deselect();
			}
			item.select();
			this._lastSelectedItem = item;
			// fire events
			dojo.publish(this.eventNames.select, [item]);
			if (this.onselect != ''){
				eval(this.onselect);
			}
		},

		deselect: function(/*Elementlistitem*/ item) {
			this._lastSelectedItem = undefined;
			item.deselect();
			// fire events
			dojo.publish(this.eventNames.deselect, [item]);
			if (this.ondeselect != ''){
				eval(this.ondeselect);
			}
		},

		deselectAll: function() {
			var items = this.selectedNodes();
			for( var i=0,iLength=items.length ; i<iLength ; i++ ) {
				var item = items[i];
				this.deselect(item);
			}
		},

		_childById: function (objectId) {
			for( var i=0,iLength=this.children.length ; i<iLength ; i++ ) {
				if (this.children[i].objectId == objectId){
					return this.children[i];
				}
			}
			return;
		},

		doSelectItem: function(/*Elementlistitem*/item, /*boolean?*/isSelected, evt) {
			// cannot select item if it's disabled
			if(item.disabled) {
				return;
			}

			if (typeof(item) == 'string' || typeof(item) == 'number') {
				item = this._childById(item);
			}
			var type = this.selectTypes.SINGLE;
			if (this.multiSelect == 'true' && evt != undefined) {
				if (evt.ctrlKey) {
					type = this.selectTypes.ADD;
				} else if (evt.shiftKey) {
					type = this.selectTypes.LIST;
				}
			}
			switch (type) {
				case this.selectTypes.LIST:
					var select = false;
					var lastSelectedItem = this._lastSelectedItem;
					// use first selected item in list, if exists
					if (lastSelectedItem == undefined && this.selectedNodes().length > 0) {
						lastSelectedItem = (this.selectedNodes())[0];
					}
					for( var i=0,iLength=this.children.length ; i<iLength ; i++ ) {
						var child = this.children[i];
						if (!select &&
								(child.objectId == item.objectId ||
								 (lastSelectedItem == undefined || child.objectId == lastSelectedItem.objectId))) {
							select = true;
						}
						else if (select &&
										 (child.objectId == item.objectId ||
											(lastSelectedItem != undefined && child.objectId == lastSelectedItem.objectId))) {
							this.select(child);
							break;
						}
						if (select){
							this.select(child);
						}
					}
					break;
				case this.selectTypes.ADD:
					if (isSelected) {
						this.deselect(item);
					} else {
						this.select(item);
					}
					break;
				default:
				case this.selectTypes.SINGLE:
					this.deselectAll();
					this.select(item);
					break;
			}
			// set focus to avoid text selection
			this.domNode.focus();
		},

		getItemByIdentity : function(/* String */identifierName, identity) {
			for(var el in this.children) {
				if(this.children[el][identifierName] == identity){
					return this.children[el];
				}
			}
		}
	}
);

}

if(!dojo._hasResource["dijit._HasDropDown"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._HasDropDown"] = true;
dojo.provide("dijit._HasDropDown");




dojo.declare("dijit._HasDropDown",
	null,
	{
		// summary:
		//		Mixin for widgets that need drop down ability.

		// _buttonNode: [protected] DomNode
		//		The button/icon/node to click to display the drop down.
		//		Can be set via a dojoAttachPoint assignment.
		//		If missing, then either focusNode or domNode (if focusNode is also missing) will be used.
		_buttonNode: null,

		// _arrowWrapperNode: [protected] DomNode
		//		Will set CSS class dijitUpArrow, dijitDownArrow, dijitRightArrow etc. on this node depending
		//		on where the drop down is set to be positioned.
		//		Can be set via a dojoAttachPoint assignment.
		//		If missing, then _buttonNode will be used.
		_arrowWrapperNode: null,

		// _popupStateNode: [protected] DomNode
		//		The node to set the popupActive class on.
		//		Can be set via a dojoAttachPoint assignment.
		//		If missing, then focusNode or _buttonNode (if focusNode is missing) will be used.
		_popupStateNode: null,

		// _aroundNode: [protected] DomNode
		//		The node to display the popup around.
		//		Can be set via a dojoAttachPoint assignment.
		//		If missing, then domNode will be used.
		_aroundNode: null,

		// dropDown: [protected] Widget
		//		The widget to display as a popup.  This widget *must* be
		//		defined before the startup function is called.
		dropDown: null,

		// autoWidth: [protected] Boolean
		//		Set to true to make the drop down at least as wide as this
		//		widget.  Set to false if the drop down should just be its
		//		default width
		autoWidth: true,

		// forceWidth: [protected] Boolean
		//		Set to true to make the drop down exactly as wide as this
		//		widget.  Overrides autoWidth.
		forceWidth: false,

		// maxHeight: [protected] Integer
		//		The max height for our dropdown.  Set to 0 for no max height.
		//		any dropdown taller than this will have scrollbars
		maxHeight: 0,

		// dropDownPosition: [const] String[]
		//		This variable controls the position of the drop down.
		//		It's an array of strings with the following values:
		//
		//			* before: places drop down to the left of the target node/widget, or to the right in
		//			  the case of RTL scripts like Hebrew and Arabic
		//			* after: places drop down to the right of the target node/widget, or to the left in
		//			  the case of RTL scripts like Hebrew and Arabic
		//			* above: drop down goes above target node
		//			* below: drop down goes below target node
		//
		//		The list is positions is tried, in order, until a position is found where the drop down fits
		//		within the viewport.
		//
		dropDownPosition: ["below","above"],

		// _stopClickEvents: Boolean
		//		When set to false, the click events will not be stopped, in
		//		case you want to use them in your subwidget
		_stopClickEvents: true,

		_onDropDownMouse: function(/*Event*/ e){
			// summary:
			//		Callback when the user mouse clicks on the arrow icon, or presses the down
			//		arrow key, to open the drop down.

			// We handle mouse events using onmousedown in order to allow for selecting via
			// a mouseDown --> mouseMove --> mouseUp.  So, our click is already handled, unless
			// we are executed via keypress - in which case, this._seenKeydown
			// will be set to true.
			if(e.type == "click" && !this._seenKeydown){ return; }
			this._seenKeydown = false;

			// If we are a mouse event, set up the mouseup handler.  See _onDropDownMouse() for
			// details on this handler.
			if(e.type == "mousedown"){
				this._docHandler = this.connect(dojo.doc, "onmouseup", "_onDropDownMouseup");
			}
			if(this.disabled || this.readOnly){ return; }
			if(this._stopClickEvents){
				dojo.stopEvent(e);
			}
			this.toggleDropDown();

			// If we are a click, then we'll pretend we did a mouse up
			if(e.type == "click" || e.type == "keypress"){
				this._onDropDownMouseup();
			}
		},

		_onDropDownMouseup: function(/*Event?*/ e){
			// summary:
			//		Callback when the user lifts their mouse after mouse down on the arrow icon.
			//		If the drop is a simple menu and the mouse is over the menu, we execute it, otherwise, we focus our
			//		dropDown node.  If the event is missing, then we are not
			//		a mouseup event.
			//
			//		This is useful for the common mouse movement pattern
			//		with native browser <select> nodes:
			//			1. mouse down on the select node (probably on the arrow)
			//			2. move mouse to a menu item while holding down the mouse button
			//			3. mouse up.  this selects the menu item as though the user had clicked it.

			if(e && this._docHandler){
				this.disconnect(this._docHandler);
			}
			var dropDown = this.dropDown, overMenu = false;

			if(e && this._opened){
				// This code deals with the corner-case when the drop down covers the original widget,
				// because it's so large.  In that case mouse-up shouldn't select a value from the menu.
				// Find out if our target is somewhere in our dropdown widget,
				// but not over our _buttonNode (the clickable node)
				var c = dojo.position(this._buttonNode, true);
				if(!(e.pageX >= c.x && e.pageX <= c.x + c.w) ||
					!(e.pageY >= c.y && e.pageY <= c.y + c.h)){
					var t = e.target;
					while(t && !overMenu){
						if(dojo.hasClass(t, "dijitPopup")){
							overMenu = true;
						}else{
							t = t.parentNode;
						}
					}
					if(overMenu){
						t = e.target;
						if(dropDown.onItemClick){
							var menuItem;
							while(t && !(menuItem = dijit.byNode(t))){
								t = t.parentNode;
							}
							if(menuItem && menuItem.onClick && menuItem.getParent){
								menuItem.getParent().onItemClick(menuItem, e);
							}
						}
						return;
					}
				}
			}
			if(this._opened && dropDown.focus){
				// Focus the dropdown widget - do it on a delay so that we
				// don't steal our own focus.
				window.setTimeout(dojo.hitch(dropDown, "focus"), 1);
			}
		},

		_setupDropdown: function(){
			// summary:
			//		set up nodes and connect our mouse and keypress events
			this._buttonNode = this._buttonNode || this.focusNode || this.domNode;
			this._popupStateNode = this._popupStateNode || this.focusNode || this._buttonNode;
			this._aroundNode = this._aroundNode || this.domNode;
			this.connect(this._buttonNode, "onmousedown", "_onDropDownMouse");
			this.connect(this._buttonNode, "onclick", "_onDropDownMouse");
			this.connect(this._buttonNode, "onkeydown", "_onDropDownKeydown");
			this.connect(this._buttonNode, "onblur", "_onDropDownBlur");
			this.connect(this._buttonNode, "onkeypress", "_onKey");

			// If we have a _setStateClass function (which happens when
			// we are a form widget), then we need to connect our open/close
			// functions to it
			if(this._setStateClass){
				this.connect(this, "openDropDown", "_setStateClass");
				this.connect(this, "closeDropDown", "_setStateClass");
			}

			// Add a class to the "dijitDownArrowButton" type class to _buttonNode so theme can set direction of arrow
			// based on where drop down will normally appear
			var defaultPos = {
					"after" : this.isLeftToRight() ? "Right" : "Left",
					"before" : this.isLeftToRight() ? "Left" : "Right",
					"above" : "Up",
					"below" : "Down",
					"left" : "Left",
					"right" : "Right"
			}[this.dropDownPosition[0]] || this.dropDownPosition[0] || "Down";
			dojo.addClass(this._arrowWrapperNode || this._buttonNode, "dijit" + defaultPos + "ArrowButton");
		},

		postCreate: function(){
			this._setupDropdown();
			this.inherited(arguments);
		},

		destroyDescendants: function(){
			if(this.dropDown){
				// Destroy the drop down, unless it's already been destroyed.  This can happen because
				// the drop down is a direct child of <body> even though it's logically my child.
				if(!this.dropDown._destroyed){
					this.dropDown.destroyRecursive();
				}
				delete this.dropDown;
			}
			this.inherited(arguments);
		},

		_onDropDownKeydown: function(/*Event*/ e){
			this._seenKeydown = true;
		},

		_onKeyPress: function(/*Event*/ e){
			if(this._opened && e.charOrCode == dojo.keys.ESCAPE && !e.shiftKey && !e.ctrlKey && !e.altKey){
				this.toggleDropDown();
				dojo.stopEvent(e);
				return;
			}
			this.inherited(arguments);
		},

		_onDropDownBlur: function(/*Event*/ e){
			this._seenKeydown = false;
		},

		_onKey: function(/*Event*/ e){
			// summary:
			//		Callback when the user presses a key on menu popup node

			if(this.disabled || this.readOnly){ return; }
			var d = this.dropDown;
			if(d && this._opened && d.handleKey){
				if(d.handleKey(e) === false){ return; }
			}
			if(d && this._opened && e.keyCode == dojo.keys.ESCAPE){
				this.toggleDropDown();
				return;
			}
			if(e.keyCode == dojo.keys.DOWN_ARROW || e.keyCode == dojo.keys.ENTER || e.charOrCode == " "){
				this._onDropDownMouse(e);
			}
		},

		_onBlur: function(){
			// summary:
			//		Called magically when focus has shifted away from this widget and it's dropdown

			this.closeDropDown();
			// don't focus on button.  the user has explicitly focused on something else.
			this.inherited(arguments);
		},

		isLoaded: function(){
			// summary:
			//		Returns whether or not the dropdown is loaded.  This can
			//		be overridden in order to force a call to loadDropDown().
			// tags:
			//		protected

			return true;
		},

		loadDropDown: function(/* Function */ loadCallback){
			// summary:
			//		Loads the data for the dropdown, and at some point, calls
			//		the given callback
			// tags:
			//		protected

			loadCallback();
		},

		toggleDropDown: function(){
			// summary:
			//		Toggle the drop-down widget; if it is up, close it, if not, open it
			// tags:
			//		protected

			if(this.disabled || this.readOnly){ return; }
			this.focus();
			var dropDown = this.dropDown;
			if(!dropDown){ return; }
			if(!this._opened){
				// If we aren't loaded, load it first so there isn't a flicker
				if(!this.isLoaded()){
					this.loadDropDown(dojo.hitch(this, "openDropDown"));
					return;
				}else{
					this.openDropDown();
				}
			}else{
				this.closeDropDown();
			}
		},

		openDropDown: function(){
			// summary:
			//		Opens the dropdown for this widget - it returns the
			//		return value of dijit.popup.open
			// tags:
			//		protected

			var dropDown = this.dropDown;
			var ddNode = dropDown.domNode;
			var self = this;

			// Prepare our popup's height and honor maxHeight if it exists.

			// TODO: isn't maxHeight dependent on the return value from dijit.popup.open(),
			// ie, dependent on how much space is available (BK)

			if(!this._preparedNode){
				dijit.popup.moveOffScreen(ddNode);
				this._preparedNode = true;			
				// Check if we have explicitly set width and height on the dropdown widget dom node
				if(ddNode.style.width){
					this._explicitDDWidth = true;
				}
				if(ddNode.style.height){
					this._explicitDDHeight = true;
				}
			}
			if(this.maxHeight || this.forceWidth || this.autoWidth){
				var myStyle = {
					display: "",
					visibility: "hidden"
				};
				if(!this._explicitDDWidth){
					myStyle.width = "";
				}
				if(!this._explicitDDHeight){
					myStyle.height = "";
				}
				dojo.style(ddNode, myStyle);
				var mb = dojo.marginBox(ddNode);
				var overHeight = (this.maxHeight && mb.h > this.maxHeight);
				dojo.style(ddNode, {overflow: overHeight ? "auto" : "hidden"});
				if(this.forceWidth){
					mb.w = this.domNode.offsetWidth;
				}else if(this.autoWidth){
					mb.w = Math.max(mb.w, this.domNode.offsetWidth);
				}else{
					delete mb.w;
				}
				if(overHeight){
					mb.h = this.maxHeight;
					if("w" in mb){
						mb.w += 16;
					}
				}else{
					delete mb.h;
				}
				delete mb.t;
				delete mb.l;
				if(dojo.isFunction(dropDown.resize)){
					dropDown.resize(mb);
				}else{
					dojo.marginBox(ddNode, mb);
				}
			}
			var retVal = dijit.popup.open({
				parent: this,
				popup: dropDown,
				around: this._aroundNode,
				orient: dijit.getPopupAroundAlignment((this.dropDownPosition && this.dropDownPosition.length) ? this.dropDownPosition : ["below"],this.isLeftToRight()),
				onExecute: function(){
					self.closeDropDown(true);
				},
				onCancel: function(){
					self.closeDropDown(true);
				},
				onClose: function(){
					dojo.attr(self._popupStateNode, "popupActive", false);
					dojo.removeClass(self._popupStateNode, "dijitHasDropDownOpen");
					self._opened = false;
					self.state = "";
				}
			});
			dojo.attr(this._popupStateNode, "popupActive", "true");
			dojo.addClass(self._popupStateNode, "dijitHasDropDownOpen");
			this._opened=true;
			this.state="Opened";
			// TODO: set this.checked and call setStateClass(), to affect button look while drop down is shown
			return retVal;
		},

		closeDropDown: function(/*Boolean*/ focus){
			// summary:
			//		Closes the drop down on this widget
			// tags:
			//		protected

			if(this._opened){
				dijit.popup.close(this.dropDown);
				if(focus){ this.focus(); }
				this._opened = false;
				this.state = "";
			}
		}

	}
);

}

if(!dojo._hasResource["dojo.data.util.sorter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.data.util.sorter"] = true;
dojo.provide("dojo.data.util.sorter");

dojo.data.util.sorter.basicComparator = function(	/*anything*/ a, 
													/*anything*/ b){
	//	summary:  
	//		Basic comparision function that compares if an item is greater or less than another item
	//	description:  
	//		returns 1 if a > b, -1 if a < b, 0 if equal.
	//		'null' values (null, undefined) are treated as larger values so that they're pushed to the end of the list.
	//		And compared to each other, null is equivalent to undefined.
	
	//null is a problematic compare, so if null, we set to undefined.
	//Makes the check logic simple, compact, and consistent
	//And (null == undefined) === true, so the check later against null
	//works for undefined and is less bytes.
	var r = -1;
	if(a === null){
		a = undefined;
	}
	if(b === null){
		b = undefined;
	}
	if(a == b){
		r = 0; 
	}else if(a > b || a == null){
		r = 1; 
	}
	return r; //int {-1,0,1}
};

dojo.data.util.sorter.createSortFunction = function(	/* attributes array */sortSpec,
														/*dojo.data.core.Read*/ store){
	//	summary:  
	//		Helper function to generate the sorting function based off the list of sort attributes.
	//	description:  
	//		The sort function creation will look for a property on the store called 'comparatorMap'.  If it exists
	//		it will look in the mapping for comparisons function for the attributes.  If one is found, it will
	//		use it instead of the basic comparator, which is typically used for strings, ints, booleans, and dates.
	//		Returns the sorting function for this particular list of attributes and sorting directions.
	//
	//	sortSpec: array
	//		A JS object that array that defines out what attribute names to sort on and whether it should be descenting or asending.
	//		The objects should be formatted as follows:
	//		{
	//			attribute: "attributeName-string" || attribute,
	//			descending: true|false;   // Default is false.
	//		}
	//	store: object
	//		The datastore object to look up item values from.
	//
	var sortFunctions=[];

	function createSortFunction(attr, dir, comp, s){
		//Passing in comp and s (comparator and store), makes this
		//function much faster.
		return function(itemA, itemB){
			var a = s.getValue(itemA, attr);
			var b = s.getValue(itemB, attr);
			return dir * comp(a,b); //int
		};
	}
	var sortAttribute;
	var map = store.comparatorMap;
	var bc = dojo.data.util.sorter.basicComparator;
	for(var i = 0; i < sortSpec.length; i++){
		sortAttribute = sortSpec[i];
		var attr = sortAttribute.attribute;
		if(attr){
			var dir = (sortAttribute.descending) ? -1 : 1;
			var comp = bc;
			if(map){
				if(typeof attr !== "string" && ("toString" in attr)){
					 attr = attr.toString();
				}
				comp = map[attr] || bc;
			}
			sortFunctions.push(createSortFunction(attr, 
				dir, comp, store));
		}
	}
	return function(rowA, rowB){
		var i=0;
		while(i < sortFunctions.length){
			var ret = sortFunctions[i++](rowA, rowB);
			if(ret !== 0){
				return ret;//int
			}
		}
		return 0; //int  
	}; // Function
};

}

if(!dojo._hasResource["dojo.data.util.simpleFetch"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.data.util.simpleFetch"] = true;
dojo.provide("dojo.data.util.simpleFetch");


dojo.data.util.simpleFetch.fetch = function(/* Object? */ request){
	//	summary:
	//		The simpleFetch mixin is designed to serve as a set of function(s) that can
	//		be mixed into other datastore implementations to accelerate their development.  
	//		The simpleFetch mixin should work well for any datastore that can respond to a _fetchItems() 
	//		call by returning an array of all the found items that matched the query.  The simpleFetch mixin
	//		is not designed to work for datastores that respond to a fetch() call by incrementally
	//		loading items, or sequentially loading partial batches of the result
	//		set.  For datastores that mixin simpleFetch, simpleFetch 
	//		implements a fetch method that automatically handles eight of the fetch()
	//		arguments -- onBegin, onItem, onComplete, onError, start, count, sort and scope
	//		The class mixing in simpleFetch should not implement fetch(),
	//		but should instead implement a _fetchItems() method.  The _fetchItems() 
	//		method takes three arguments, the keywordArgs object that was passed 
	//		to fetch(), a callback function to be called when the result array is
	//		available, and an error callback to be called if something goes wrong.
	//		The _fetchItems() method should ignore any keywordArgs parameters for
	//		start, count, onBegin, onItem, onComplete, onError, sort, and scope.  
	//		The _fetchItems() method needs to correctly handle any other keywordArgs
	//		parameters, including the query parameter and any optional parameters 
	//		(such as includeChildren).  The _fetchItems() method should create an array of 
	//		result items and pass it to the fetchHandler along with the original request object 
	//		-- or, the _fetchItems() method may, if it wants to, create an new request object 
	//		with other specifics about the request that are specific to the datastore and pass 
	//		that as the request object to the handler.
	//
	//		For more information on this specific function, see dojo.data.api.Read.fetch()
	request = request || {};
	if(!request.store){
		request.store = this;
	}
	var self = this;

	var _errorHandler = function(errorData, requestObject){
		if(requestObject.onError){
			var scope = requestObject.scope || dojo.global;
			requestObject.onError.call(scope, errorData, requestObject);
		}
	};

	var _fetchHandler = function(items, requestObject){
		var oldAbortFunction = requestObject.abort || null;
		var aborted = false;

		var startIndex = requestObject.start?requestObject.start:0;
		var endIndex = (requestObject.count && (requestObject.count !== Infinity))?(startIndex + requestObject.count):items.length;

		requestObject.abort = function(){
			aborted = true;
			if(oldAbortFunction){
				oldAbortFunction.call(requestObject);
			}
		};

		var scope = requestObject.scope || dojo.global;
		if(!requestObject.store){
			requestObject.store = self;
		}
		if(requestObject.onBegin){
			requestObject.onBegin.call(scope, items.length, requestObject);
		}
		if(requestObject.sort){
			items.sort(dojo.data.util.sorter.createSortFunction(requestObject.sort, self));
		}
		if(requestObject.onItem){
			for(var i = startIndex; (i < items.length) && (i < endIndex); ++i){
				var item = items[i];
				if(!aborted){
					requestObject.onItem.call(scope, item, requestObject);
				}
			}
		}
		if(requestObject.onComplete && !aborted){
			var subset = null;
			if(!requestObject.onItem){
				subset = items.slice(startIndex, endIndex);
			}
			requestObject.onComplete.call(scope, subset, requestObject);
		}
	};
	this._fetchItems(request, _fetchHandler, _errorHandler);
	return request;	// Object
};

}

if(!dojo._hasResource["epages.widget.BingMapsWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.BingMapsWidget"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.
*/
dojo.provide("epages.widget.BingMapsWidget");


dojo.declare("epages.widget.BingMapsWidget", [epages.widget.LocalizedWidget],	{
		templateString:"<span style=\"white-space:nowrap\">\n  <span dojoAttachPoint=\"buttonNode\" class=\"AlignMiddle\">\n    <i class=\"Sprite ico_l_map_location ClickIcon\"></i>\n    <a href=\"#\" onclick=\"return false;\">{BingMapsHead}</a>\n  </span>\n  <div style=\"display:none;z-index:99999\" dojoAttachPoint=\"popupNode\">\n    <div class=\"Layer\"><div class=\"PropertyContainer\">\n      <div class=\"LayerTitleBar\" style=\"height: 28px\">\n        <div class=\"LayerCloseButton EnableHover\" dojoAttachEvent=\"onclick: closePopup\"></div>\n      </div>\n      <div class=\"ContentContainer\" dojoAttachPoint=\"contentNode\">\n      </div>\n    </div></div>\n    <div class=\"LayerFooter\"><div class=\"PropertyContainer\"></div></div>\n  </div>\n </span>\n",
		translationName	: dojo.moduleUrl('epages.widget', "templates/BingMaps"),
		popup						:	null,
		hideOnBlur			: false,
		disabled				: '',
		popupclass			:	'',
		// class variable which may be changed when including the widget on a page
		// specifys the IDs of the input/select fields the widget extracts the bing map find parameters from
		inputMapping		:	'{"streetID":"Street","zipID":"Zipcode","cityID":"City","countryID":"CountryID","useAsValues":false}',
		searchNodeIds		:	undefined,
		
		postMixInProperties : function(){
			// summary: check if widget is disabled / check for parameters supplied for the widget
			
			this.inherited("postMixInProperties", arguments);
			this.disabled = this.disabled.toLowerCase();
			this.disabled = (this.disabled =="true" || this.disabled =="disabled" || this.disabled == "1") ? true : false;
			this.searchNodeIds = dojo.fromJson(this.inputMapping);
		},
		
		postCreate  : function() {
			// summary: connect widget to clock event
			
			this.inherited("postCreate", arguments);
			//attach click event
			this.connect(this.buttonNode, 'onclick', 'toggleMap');
		},		
									
		_encode : function (/*String*/string) {
			// summary: 
			//     prepare a string to use it with HTTP/Get
			// description: 
			//     Transfer chars which can't be used in a GET string to ones which can
			//		 e.q. �,�,�,...
			// example: 
			//     | var result = _encode("���");
			// returns: 
			//     encoded string
			string = string.replace(/\r\n/g,"\n");
			var utftext = "";

			for (var n = 0,l=string.length; n < l; n++) {

				var c = string.charCodeAt(n);

				if (c < 128) {
					utftext += String.fromCharCode(c);
				}
				else if((c > 127) && (c < 2048)) {
					utftext += String.fromCharCode((c >> 6) | 192);
					utftext += String.fromCharCode((c & 63) | 128);
				}
				else {
					utftext += String.fromCharCode((c >> 12) | 224);
					utftext += String.fromCharCode(((c >> 6) & 63) | 128);
					utftext += String.fromCharCode((c & 63) | 128);
				}
			}
			return utftext;
		},
		disable: function() {
			// summary: disable button
			this.disabled = true;
		},

		enable: function() {
			// summary: enable button
			this.disabled = false;
		},
				
		_createMapPopup: function() {
			// summary: Create popup
			this.popup = new epages.widget.Popup({
				parent:     this.buttonNode,
				around:     this.buttonNode,
				hideOnBlur: this.hideOnBlur,
				o :					{orient:{'TL':'BL'}},
				'class':    this['popupclass']
			}, this.popupNode);
			this.attr('value',this.value);
		},
		
		toggleMap: function() {
			// summary: 
			//    prepare and show the popup
			// description: 
			//    extract the search parameters for the bing maps find and add an 
			//    iframe containing the map to the popup
			if(!this.disabled) {
				if (this.popup == null){ 
					this._createMapPopup();
				}
				var searchString = "";
				if(this.searchNodeIds.useAsValues){
					searchString = "s="+this.searchNodeIds.streetID+"&"+
												 "z="+this.searchNodeIds.zipID+"&"+
												 "c="+this.searchNodeIds.cityID+"&"+
												 "i="+this.searchNodeIds.countryID;					
				}else{
					searchString = "s="+dojo.byId(this.searchNodeIds.streetID).value+"&"+
												 "z="+dojo.byId(this.searchNodeIds.zipID).value+"&"+
												 "c="+dojo.byId(this.searchNodeIds.cityID).value;
				
					var obj = dojo.byId(this.searchNodeIds.countryID);
					var country =obj.options[obj.selectedIndex].text.split(" ")[0];									 
					searchString += "&i="+country;
				}
				
				searchString = escape(this._encode(searchString));

				this.contentNode.innerHTML = '<iframe  src="'+dojo.moduleUrl('epages.widget')+'/BingMapiFrame.html?'+searchString+'" height="420" width="420" style="border:1px solid #999;">Alternativtext</iframe>';
				this.popup.toggle();
			}
		},
		closePopup: function() {
			// summary: remove the iframe and the bing map
			this.popup.hide();
			this.contentNode.innerHTML = '';
		}
	}
);

}

if(!dojo._hasResource["epages.widget.DeleteFileOnServer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.DeleteFileOnServer"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.
*/
dojo.provide("epages.widget.DeleteFileOnServer");





dojo.declare(
	"epages.widget.DeleteFileOnServer",
	[ dijit._Widget, dijit._Templated ],
	{
		_fileSizeText: '',
		
		fileName:  '',
		fileSize:  '',
		filePath :  '',
		confirm :  'true',
		url:       '?',
		newWindowFeature: 'PopUp',
		displayfileName: '',
		headlineConfirm: epages.io.dictionary.get('HeadLineDeleteFile'), // 'Moechten Sie diese Datei wirklich loeschen?',
		messageConfirm:  epages.io.dictionary.get('File')+(':'), // 'Datei',
		titleConfirm:    epages.io.dictionary.get('TitleDeleteFile'), // 'Datei loeschen',
		altDelete:   epages.io.dictionary.get('TitleDeleteFile'), //'Datei loeschen',
		altView:     epages.io.dictionary.get('TitleViewFile'), //'Datei anzeigen',

		objectId:      epages.vars.ObjectID || '',
		changeAction:  'DeleteFile',
		fileAttribute: '',
		languageId:    '',
		onSuccess:     '',
		onPreview:     '',

		imagePath: epages.themeUrl('images'),
		templateString: '<span><i dojoAttachEvent="onclick:onConfirm" class="ClickIcon ico_s_delete Sprite" title="${altDelete}"></i> <a dojoAttachEvent="onclick:onConfirm" href="#">${altDelete}</a>${_fileSizeText}</span>',

		postMixInProperties: function () {
			this.inherited("postMixInProperties", arguments);
			this.confirm = epages.string.toBoolean(this.confirm);
			if (this.fileSize != ''){
				this._fileSizeText = ' (' + this.fileSize +')';
			}
			this.displayfileName=epages.format.scrunch(this.fileName,35);
			
			if( !this.altDelete ){
				this.altDelete = epages.io.dictionary.get('TitleDeleteFile');
			}
		},

		onExecution: function (response) {
			if (response.error == null) {
				// EPG-10737 dirty cache
				if(typeof(window.pc_active) != "undefined" && window.pc_active == true) {
					pageCache_SetStatus(true);
				}
				if (typeof this.onSuccess == 'function') {
					this.onSuccess();
				} else {
					eval(this.onSuccess);
				}
			}
			this.domNode.style.display = 'none';
		},

		onExecute: function () {
			
			var json = new epages.io.Json();
			json.loadAsync(this.url, dojo.hitch(this, 'onExecution'), {
				'ObjectID': this.objectId,
				'ChangeAction': this.changeAction,
				'File': this.fileAttribute,
				'DeleteLanguageID': this.languageId,
				'ACCEPT': this.confirm ? 1 : 0
			});
		},

		onConfirm: function (evt) {
			dojo.stopEvent(evt);
			if(this.confirm) {
				
				dojo.publish("uimessage/show", [
					this.headlineConfirm,
					this.messageConfirm + ' ' + this.fileName, 'Dialog', {
						titleBar:  this.titleConfirm,
						sizeClass: 'Large',
						typeClass: 'Confirmation',
						onYes:     dojo.hitch(this, 'onExecute')
					}]);
			} else {
				this.onExecute();
			}
		}
	}
);

}

if(!dojo._hasResource["epages.widget.DeleteFileAttributesOnServer"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.DeleteFileAttributesOnServer"] = true;
/*
	Copyright (c) 2006-2010, ePages GmbH
	All Rights Reserved.
*/
dojo.provide("epages.widget.DeleteFileAttributesOnServer");


dojo.declare(
	"epages.widget.DeleteFileAttributesOnServer",
	[ epages.widget.DeleteFileOnServer ],
	{
		onExecute: function () {
			

			var params = {
				'ObjectID': this.objectId,
				'DeleteLanguageID': this.languageId,
				'ACCEPT': this.confirm ? 1 : 0,
				'ChangeAction' : this.changeAction,
				'Files' : this.fileAttribute		// comma seperated list
			};
			var json = new epages.io.Json();
			json.loadAsync(this.url, dojo.hitch(this, 'onExecution'), params);
		}
	}
);

}

if(!dojo._hasResource["dojo.number"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.number"] = true;
dojo.provide("dojo.number");







/*=====
dojo.number = {
	// summary: localized formatting and parsing routines for Number
}

dojo.number.__FormatOptions = function(){
	//	pattern: String?
	//		override [formatting pattern](http://www.unicode.org/reports/tr35/#Number_Format_Patterns)
	//		with this string.  Default value is based on locale.  Overriding this property will defeat
	//		localization.
	//	type: String?
	//		choose a format type based on the locale from the following:
	//		decimal, scientific (not yet supported), percent, currency. decimal by default.
	//	places: Number?
	//		fixed number of decimal places to show.  This overrides any
	//		information in the provided pattern.
	//	round: Number?
	//		5 rounds to nearest .5; 0 rounds to nearest whole (default). -1
	//		means do not round.
	//	locale: String?
	//		override the locale used to determine formatting rules
	this.pattern = pattern;
	this.type = type;
	this.places = places;
	this.round = round;
	this.locale = locale;
}
=====*/

dojo.number.format = function(/*Number*/value, /*dojo.number.__FormatOptions?*/options){
	// summary:
	//		Format a Number as a String, using locale-specific settings
	// description:
	//		Create a string from a Number using a known localized pattern.
	//		Formatting patterns appropriate to the locale are chosen from the
	//		[CLDR](http://unicode.org/cldr) as well as the appropriate symbols and
	//		delimiters.  See <http://www.unicode.org/reports/tr35/#Number_Elements>
	//		If value is Infinity, -Infinity, or is not a valid JavaScript number, return null.
	// value:
	//		the number to be formatted

	options = dojo.mixin({}, options || {});
	var locale = dojo.i18n.normalizeLocale(options.locale);
	var bundle = dojo.i18n.getLocalization("dojo.cldr", "number", locale);
	options.customs = bundle;
	var pattern = options.pattern || bundle[(options.type || "decimal") + "Format"];
	if(isNaN(value) || Math.abs(value) == Infinity){ return null; } // null
	return dojo.number._applyPattern(value, pattern, options); // String
};

//dojo.number._numberPatternRE = /(?:[#0]*,?)*[#0](?:\.0*#*)?/; // not precise, but good enough
dojo.number._numberPatternRE = /[#0,]*[#0](?:\.0*#*)?/; // not precise, but good enough

dojo.number._applyPattern = function(/*Number*/value, /*String*/pattern, /*dojo.number.__FormatOptions?*/options){
	// summary:
	//		Apply pattern to format value as a string using options. Gives no
	//		consideration to local customs.
	// value:
	//		the number to be formatted.
	// pattern:
	//		a pattern string as described by
	//		[unicode.org TR35](http://www.unicode.org/reports/tr35/#Number_Format_Patterns)
	// options: dojo.number.__FormatOptions?
	//		_applyPattern is usually called via `dojo.number.format()` which
	//		populates an extra property in the options parameter, "customs".
	//		The customs object specifies group and decimal parameters if set.

	//TODO: support escapes
	options = options || {};
	var group = options.customs.group;
	var decimal = options.customs.decimal;

	var patternList = pattern.split(';');
	var positivePattern = patternList[0];
	pattern = patternList[(value < 0) ? 1 : 0] || ("-" + positivePattern);

	//TODO: only test against unescaped
	if(pattern.indexOf('%') != -1){
		value *= 100;
	}else if(pattern.indexOf('\u2030') != -1){
		value *= 1000; // per mille
	}else if(pattern.indexOf('\u00a4') != -1){
		group = options.customs.currencyGroup || group;//mixins instead?
		decimal = options.customs.currencyDecimal || decimal;// Should these be mixins instead?
		pattern = pattern.replace(/\u00a4{1,3}/, function(match){
			var prop = ["symbol", "currency", "displayName"][match.length-1];
			return options[prop] || options.currency || "";
		});
	}else if(pattern.indexOf('E') != -1){
		throw new Error("exponential notation not supported");
	}
	
	//TODO: support @ sig figs?
	var numberPatternRE = dojo.number._numberPatternRE;
	var numberPattern = positivePattern.match(numberPatternRE);
	if(!numberPattern){
		throw new Error("unable to find a number expression in pattern: "+pattern);
	}
	if(options.fractional === false){ options.places = 0; }
	return pattern.replace(numberPatternRE,
		dojo.number._formatAbsolute(value, numberPattern[0], {decimal: decimal, group: group, places: options.places, round: options.round}));
}

dojo.number.round = function(/*Number*/value, /*Number?*/places, /*Number?*/increment){
	//	summary:
	//		Rounds to the nearest value with the given number of decimal places, away from zero
	//	description:
	//		Rounds to the nearest value with the given number of decimal places, away from zero if equal.
	//		Similar to Number.toFixed(), but compensates for browser quirks. Rounding can be done by
	//		fractional increments also, such as the nearest quarter.
	//		NOTE: Subject to floating point errors.  See dojox.math.round for experimental workaround.
	//	value:
	//		The number to round
	//	places:
	//		The number of decimal places where rounding takes place.  Defaults to 0 for whole rounding.
	//		Must be non-negative.
	//	increment:
	//		Rounds next place to nearest value of increment/10.  10 by default.
	//	example:
	//		>>> dojo.number.round(-0.5)
	//		-1
	//		>>> dojo.number.round(162.295, 2)
	//		162.29  // note floating point error.  Should be 162.3
	//		>>> dojo.number.round(10.71, 0, 2.5)
	//		10.75
	var factor = 10 / (increment || 10);
	return (factor * +value).toFixed(places) / factor; // Number
}

if((0.9).toFixed() == 0){
	// (isIE) toFixed() bug workaround: Rounding fails on IE when most significant digit
	// is just after the rounding place and is >=5
	(function(){
		var round = dojo.number.round;
		dojo.number.round = function(v, p, m){
			var d = Math.pow(10, -p || 0), a = Math.abs(v);
			if(!v || a >= d || a * Math.pow(10, p + 1) < 5){
				d = 0;
			}
			return round(v, p, m) + (v > 0 ? d : -d);
		}
	})();
}

/*=====
dojo.number.__FormatAbsoluteOptions = function(){
	//	decimal: String?
	//		the decimal separator
	//	group: String?
	//		the group separator
	//	places: Number?|String?
	//		number of decimal places.  the range "n,m" will format to m places.
	//	round: Number?
	//		5 rounds to nearest .5; 0 rounds to nearest whole (default). -1
	//		means don't round.
	this.decimal = decimal;
	this.group = group;
	this.places = places;
	this.round = round;
}
=====*/

dojo.number._formatAbsolute = function(/*Number*/value, /*String*/pattern, /*dojo.number.__FormatAbsoluteOptions?*/options){
	// summary: 
	//		Apply numeric pattern to absolute value using options. Gives no
	//		consideration to local customs.
	// value:
	//		the number to be formatted, ignores sign
	// pattern:
	//		the number portion of a pattern (e.g. `#,##0.00`)
	options = options || {};
	if(options.places === true){options.places=0;}
	if(options.places === Infinity){options.places=6;} // avoid a loop; pick a limit

	var patternParts = pattern.split(".");
	var maxPlaces = (options.places >= 0) ? options.places : (patternParts[1] && patternParts[1].length) || 0;
	if(!(options.round < 0)){
		value = dojo.number.round(value, maxPlaces, options.round);
	}

	var valueParts = String(Math.abs(value)).split(".");
	var fractional = valueParts[1] || "";
	if(options.places){
		var comma = dojo.isString(options.places) && options.places.indexOf(",");
		if(comma){
			options.places = options.places.substring(comma+1);
		}
		valueParts[1] = dojo.string.pad(fractional.substr(0, options.places), options.places, '0', true);
	}else if(patternParts[1] && options.places !== 0){
		// Pad fractional with trailing zeros
		var pad = patternParts[1].lastIndexOf("0") + 1;
		if(pad > fractional.length){
			valueParts[1] = dojo.string.pad(fractional, pad, '0', true);
		}

		// Truncate fractional
		var places = patternParts[1].length;
		if(places < fractional.length){
			valueParts[1] = fractional.substr(0, places);
		}
	}else{
		if(valueParts[1]){ valueParts.pop(); }
	}

	// Pad whole with leading zeros
	var patternDigits = patternParts[0].replace(',', '');
	pad = patternDigits.indexOf("0");
	if(pad != -1){
		pad = patternDigits.length - pad;
		if(pad > valueParts[0].length){
			valueParts[0] = dojo.string.pad(valueParts[0], pad);
		}

		// Truncate whole
		if(patternDigits.indexOf("#") == -1){
			valueParts[0] = valueParts[0].substr(valueParts[0].length - pad);
		}
	}

	// Add group separators
	var index = patternParts[0].lastIndexOf(',');
	var groupSize, groupSize2;
	if(index != -1){
		groupSize = patternParts[0].length - index - 1;
		var remainder = patternParts[0].substr(0, index);
		index = remainder.lastIndexOf(',');
		if(index != -1){
			groupSize2 = remainder.length - index - 1;
		}
	}
	var pieces = [];
	for(var whole = valueParts[0]; whole;){
		var off = whole.length - groupSize;
		pieces.push((off > 0) ? whole.substr(off) : whole);
		whole = (off > 0) ? whole.slice(0, off) : "";
		if(groupSize2){
			groupSize = groupSize2;
			delete groupSize2;
		}
	}
	valueParts[0] = pieces.reverse().join(options.group || ",");

	return valueParts.join(options.decimal || ".");
};

/*=====
dojo.number.__RegexpOptions = function(){
	//	pattern: String?
	//		override [formatting pattern](http://www.unicode.org/reports/tr35/#Number_Format_Patterns)
	//		with this string.  Default value is based on locale.  Overriding this property will defeat
	//		localization.
	//	type: String?
	//		choose a format type based on the locale from the following:
	//		decimal, scientific (not yet supported), percent, currency. decimal by default.
	//	locale: String?
	//		override the locale used to determine formatting rules
	//	strict: Boolean?
	//		strict parsing, false by default.  Strict parsing requires input as produced by the format() method.
	//		Non-strict is more permissive, e.g. flexible on white space, omitting thousands separators
	//	places: Number|String?
	//		number of decimal places to accept: Infinity, a positive number, or
	//		a range "n,m".  Defined by pattern or Infinity if pattern not provided.
	this.pattern = pattern;
	this.type = type;
	this.locale = locale;
	this.strict = strict;
	this.places = places;
}
=====*/
dojo.number.regexp = function(/*dojo.number.__RegexpOptions?*/options){
	//	summary:
	//		Builds the regular needed to parse a number
	//	description:
	//		Returns regular expression with positive and negative match, group
	//		and decimal separators
	return dojo.number._parseInfo(options).regexp; // String
}

dojo.number._parseInfo = function(/*Object?*/options){
	options = options || {};
	var locale = dojo.i18n.normalizeLocale(options.locale);
	var bundle = dojo.i18n.getLocalization("dojo.cldr", "number", locale);
	var pattern = options.pattern || bundle[(options.type || "decimal") + "Format"];
//TODO: memoize?
	var group = bundle.group;
	var decimal = bundle.decimal;
	var factor = 1;

	if(pattern.indexOf('%') != -1){
		factor /= 100;
	}else if(pattern.indexOf('\u2030') != -1){
		factor /= 1000; // per mille
	}else{
		var isCurrency = pattern.indexOf('\u00a4') != -1;
		if(isCurrency){
			group = bundle.currencyGroup || group;
			decimal = bundle.currencyDecimal || decimal;
		}
	}

	//TODO: handle quoted escapes
	var patternList = pattern.split(';');
	if(patternList.length == 1){
		patternList.push("-" + patternList[0]);
	}

	var re = dojo.regexp.buildGroupRE(patternList, function(pattern){
		pattern = "(?:"+dojo.regexp.escapeString(pattern, '.')+")";
		return pattern.replace(dojo.number._numberPatternRE, function(format){
			var flags = {
				signed: false,
				separator: options.strict ? group : [group,""],
				fractional: options.fractional,
				decimal: decimal,
				exponent: false};
			var parts = format.split('.');
			var places = options.places;
			if(parts.length == 1 || places === 0){flags.fractional = false;}
			else{
				if(places === undefined){ places = options.pattern ? parts[1].lastIndexOf('0')+1 : Infinity; }
				if(places && options.fractional == undefined){flags.fractional = true;} // required fractional, unless otherwise specified
				if(!options.places && (places < parts[1].length)){ places += "," + parts[1].length; }
				flags.places = places;
			}
			var groups = parts[0].split(',');
			if(groups.length>1){
				flags.groupSize = groups.pop().length;
				if(groups.length>1){
					flags.groupSize2 = groups.pop().length;
				}
			}
			return "("+dojo.number._realNumberRegexp(flags)+")";
		});
	}, true);

	if(isCurrency){
		// substitute the currency symbol for the placeholder in the pattern
		re = re.replace(/([\s\xa0]*)(\u00a4{1,3})([\s\xa0]*)/g, function(match, before, target, after){
			var prop = ["symbol", "currency", "displayName"][target.length-1];
			var symbol = dojo.regexp.escapeString(options[prop] || options.currency || "");
			before = before ? "[\\s\\xa0]" : "";
			after = after ? "[\\s\\xa0]" : "";
			if(!options.strict){
				if(before){before += "*";}
				if(after){after += "*";}
				return "(?:"+before+symbol+after+")?";
			}
			return before+symbol+after;
		});
	}

//TODO: substitute localized sign/percent/permille/etc.?

	// normalize whitespace and return
	return {regexp: re.replace(/[\xa0 ]/g, "[\\s\\xa0]"), group: group, decimal: decimal, factor: factor}; // Object
}

/*=====
dojo.number.__ParseOptions = function(){
	//	pattern: String?
	//		override [formatting pattern](http://www.unicode.org/reports/tr35/#Number_Format_Patterns)
	//		with this string.  Default value is based on locale.  Overriding this property will defeat
	//		localization.
	//	type: String?
	//		choose a format type based on the locale from the following:
	//		decimal, scientific (not yet supported), percent, currency. decimal by default.
	//	locale: String?
	//		override the locale used to determine formatting rules
	//	strict: Boolean?
	//		strict parsing, false by default.  Strict parsing requires input as produced by the format() method.
	//		Non-strict is more permissive, e.g. flexible on white space, omitting thousands separators
	this.pattern = pattern;
	this.type = type;
	this.locale = locale;
	this.strict = strict;
}
=====*/
dojo.number.parse = function(/*String*/expression, /*dojo.number.__ParseOptions?*/options){
	// summary:
	//		Convert a properly formatted string to a primitive Number, using
	//		locale-specific settings.
	// description:
	//		Create a Number from a string using a known localized pattern.
	//		Formatting patterns are chosen appropriate to the locale
	//		and follow the syntax described by
	//		[unicode.org TR35](http://www.unicode.org/reports/tr35/#Number_Format_Patterns)
	// expression:
	//		A string representation of a Number
	var info = dojo.number._parseInfo(options);
	var results = (new RegExp("^"+info.regexp+"$")).exec(expression);
	if(!results){
		return NaN; //NaN
	}
	var absoluteMatch = results[1]; // match for the positive expression
	if(!results[1]){
		if(!results[2]){
			return NaN; //NaN
		}
		// matched the negative pattern
		absoluteMatch =results[2];
		info.factor *= -1;
	}

	// Transform it to something Javascript can parse as a number.  Normalize
	// decimal point and strip out group separators or alternate forms of whitespace
	absoluteMatch = absoluteMatch.
		replace(new RegExp("["+info.group + "\\s\\xa0"+"]", "g"), "").
		replace(info.decimal, ".");
	// Adjust for negative sign, percent, etc. as necessary
	return absoluteMatch * info.factor; //Number
};

/*=====
dojo.number.__RealNumberRegexpFlags = function(){
	//	places: Number?
	//		The integer number of decimal places or a range given as "n,m".  If
	//		not given, the decimal part is optional and the number of places is
	//		unlimited.
	//	decimal: String?
	//		A string for the character used as the decimal point.  Default
	//		is ".".
	//	fractional: Boolean?|Array?
	//		Whether decimal places are used.  Can be true, false, or [true,
	//		false].  Default is [true, false] which means optional.
	//	exponent: Boolean?|Array?
	//		Express in exponential notation.  Can be true, false, or [true,
	//		false]. Default is [true, false], (i.e. will match if the
	//		exponential part is present are not).
	//	eSigned: Boolean?|Array?
	//		The leading plus-or-minus sign on the exponent.  Can be true,
	//		false, or [true, false].  Default is [true, false], (i.e. will
	//		match if it is signed or unsigned).  flags in regexp.integer can be
	//		applied.
	this.places = places;
	this.decimal = decimal;
	this.fractional = fractional;
	this.exponent = exponent;
	this.eSigned = eSigned;
}
=====*/

dojo.number._realNumberRegexp = function(/*dojo.number.__RealNumberRegexpFlags?*/flags){
	// summary:
	//		Builds a regular expression to match a real number in exponential
	//		notation

	// assign default values to missing paramters
	flags = flags || {};
	//TODO: use mixin instead?
	if(!("places" in flags)){ flags.places = Infinity; }
	if(typeof flags.decimal != "string"){ flags.decimal = "."; }
	if(!("fractional" in flags) || /^0/.test(flags.places)){ flags.fractional = [true, false]; }
	if(!("exponent" in flags)){ flags.exponent = [true, false]; }
	if(!("eSigned" in flags)){ flags.eSigned = [true, false]; }

	// integer RE
	var integerRE = dojo.number._integerRegexp(flags);

	// decimal RE
	var decimalRE = dojo.regexp.buildGroupRE(flags.fractional,
		function(q){
			var re = "";
			if(q && (flags.places!==0)){
				re = "\\" + flags.decimal;
				if(flags.places == Infinity){ 
					re = "(?:" + re + "\\d+)?"; 
				}else{
					re += "\\d{" + flags.places + "}"; 
				}
			}
			return re;
		},
		true
	);

	// exponent RE
	var exponentRE = dojo.regexp.buildGroupRE(flags.exponent,
		function(q){ 
			if(q){ return "([eE]" + dojo.number._integerRegexp({ signed: flags.eSigned}) + ")"; }
			return ""; 
		}
	);

	// real number RE
	var realRE = integerRE + decimalRE;
	// allow for decimals without integers, e.g. .25
	if(decimalRE){realRE = "(?:(?:"+ realRE + ")|(?:" + decimalRE + "))";}
	return realRE + exponentRE; // String
};

/*=====
dojo.number.__IntegerRegexpFlags = function(){
	//	signed: Boolean?
	//		The leading plus-or-minus sign. Can be true, false, or `[true,false]`.
	//		Default is `[true, false]`, (i.e. will match if it is signed
	//		or unsigned).
	//	separator: String?
	//		The character used as the thousands separator. Default is no
	//		separator. For more than one symbol use an array, e.g. `[",", ""]`,
	//		makes ',' optional.
	//	groupSize: Number?
	//		group size between separators
	//	groupSize2: Number?
	//		second grouping, where separators 2..n have a different interval than the first separator (for India)
	this.signed = signed;
	this.separator = separator;
	this.groupSize = groupSize;
	this.groupSize2 = groupSize2;
}
=====*/

dojo.number._integerRegexp = function(/*dojo.number.__IntegerRegexpFlags?*/flags){
	// summary: 
	//		Builds a regular expression that matches an integer

	// assign default values to missing paramters
	flags = flags || {};
	if(!("signed" in flags)){ flags.signed = [true, false]; }
	if(!("separator" in flags)){
		flags.separator = "";
	}else if(!("groupSize" in flags)){
		flags.groupSize = 3;
	}
	// build sign RE
	var signRE = dojo.regexp.buildGroupRE(flags.signed,
		function(q){ return q ? "[-+]" : ""; },
		true
	);

	// number RE
	var numberRE = dojo.regexp.buildGroupRE(flags.separator,
		function(sep){
			if(!sep){
				return "(?:\\d+)";
			}

			sep = dojo.regexp.escapeString(sep);
			if(sep == " "){ sep = "\\s"; }
			else if(sep == "\xa0"){ sep = "\\s\\xa0"; }

			var grp = flags.groupSize, grp2 = flags.groupSize2;
			//TODO: should we continue to enforce that numbers with separators begin with 1-9?  See #6933
			if(grp2){
				var grp2RE = "(?:0|[1-9]\\d{0," + (grp2-1) + "}(?:[" + sep + "]\\d{" + grp2 + "})*[" + sep + "]\\d{" + grp + "})";
				return ((grp-grp2) > 0) ? "(?:" + grp2RE + "|(?:0|[1-9]\\d{0," + (grp-1) + "}))" : grp2RE;
			}
			return "(?:0|[1-9]\\d{0," + (grp-1) + "}(?:[" + sep + "]\\d{" + grp + "})*)";
		},
		true
	);

	// integer RE
	return signRE + numberRE; // String
}

}

if(!dojo._hasResource["epages.widget.ProgressBar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.ProgressBar"] = true;
/*
	Copyright (c) 2006-2010, ePages GmbH
	All Rights Reserved.

	 *	+---------------------------------------+
	 *	|@@@@@@@@@@@@@@@@@@@                    |
	 *	+---------------------------------------+
	 *	{preStatusString}: {progress} / {maximum}

*/
dojo.provide("epages.widget.ProgressBar");



dojo.declare(
	"epages.widget.ProgressBar",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 *
		 */
		maximum 						: 0.0,
		progress 						: 0.0,
		preStatusString 		: "",
		disableStatusString : false,

		/**
		 * widget properties
		 */
		percentageClass        : 'PercentageNormal',
		templateString:"<span>\n  <div class=\"ProgressBar\">\n     <div class=\"InnerProgressBar\" dojoAttachPoint=\"innerProgressBar\">\n        <div dojoAttachPoint=\"progressBar\" style=\"width: 0%;\" class=\"PercentageNormal\" title=\"0%\"></div>\n     </div>\n  </div>\n  <div dojoAttachPoint=\"progressText\"><br /></div>\n</span>\n",
		translationName        : dojo.moduleUrl('epages.widget','templates/translation'),

		postCreate: function() {
			this.inherited("postCreate", arguments);
			dojo.subscribe(this.id+'/updateProgress', this, 'updateProgress');
			dojo.subscribe(this.id+'/setMaximum', this, 'setMaximum');
		},

		updateData : function(/* Object */ usageData) {
		 // summary: Write current data to class members and update widget.
		 	dojo.mixin(this,usageData);
			this._updateWidget();
		},

		setMaximum : function(/* Integer */ maximum) {
		 // summary: Write current data to class members and update widget.
			this.maximum = parseFloat(maximum);
			this._updateWidget();
		},

		updateProgress : function (/* Integer */ progress) {
		 // summary: Change the current progress and update the widget.
			this.progress = parseFloat(progress);
			this._updateWidget();
		},

		_updateWidget : function() {
		 // summary: Compose strings with usage percentage, maximum and progress
		 //   and update the widget's template attach points.
			var percentage = 100 * parseFloat(this.progress) / parseFloat(this.maximum);
			var displayPercentageTwoDec = dojo.number.round(percentage, 2).toString() + '%';
			var displayPercentageNoDec = dojo.number.round(percentage, 0).toString() + '%';
			dojo.attr(this.progressBar, 'style', 'width:' + displayPercentageNoDec);
			this.progressBar.title = displayPercentageTwoDec + ' : '+ this.progress + ' ' + this.translate('of') + ' ' + this.maximum;

			if(!this.disableStatusString){
					// Display format: "preStatusString : progress of maximum"
					this.progressText.style.display = "";
					if(this.preStatusString!=""){
						this.progressText.innerHTML = this.preStatusString + ": ";
					} else {
						this.progressText.innerHTML = "";
					}
					this.progressText.innerHTML += this.progress + ' / ' + this.maximum;
			} else {
					this.progressText.style.display = "none";
			}
		}
});

}

if(!dojo._hasResource["dojo.data.util.filter"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.data.util.filter"] = true;
dojo.provide("dojo.data.util.filter");

dojo.data.util.filter.patternToRegExp = function(/*String*/pattern, /*boolean?*/ ignoreCase){
	//	summary:  
	//		Helper function to convert a simple pattern to a regular expression for matching.
	//	description:
	//		Returns a regular expression object that conforms to the defined conversion rules.
	//		For example:  
	//			ca*   -> /^ca.*$/
	//			*ca*  -> /^.*ca.*$/
	//			*c\*a*  -> /^.*c\*a.*$/
	//			*c\*a?*  -> /^.*c\*a..*$/
	//			and so on.
	//
	//	pattern: string
	//		A simple matching pattern to convert that follows basic rules:
	//			* Means match anything, so ca* means match anything starting with ca
	//			? Means match single character.  So, b?b will match to bob and bab, and so on.
	//      	\ is an escape character.  So for example, \* means do not treat * as a match, but literal character *.
	//				To use a \ as a character in the string, it must be escaped.  So in the pattern it should be 
	//				represented by \\ to be treated as an ordinary \ character instead of an escape.
	//
	//	ignoreCase:
	//		An optional flag to indicate if the pattern matching should be treated as case-sensitive or not when comparing
	//		By default, it is assumed case sensitive.

	var rxp = "^";
	var c = null;
	for(var i = 0; i < pattern.length; i++){
		c = pattern.charAt(i);
		switch(c){
			case '\\':
				rxp += c;
				i++;
				rxp += pattern.charAt(i);
				break;
			case '*':
				rxp += ".*"; break;
			case '?':
				rxp += "."; break;
			case '$':
			case '^':
			case '/':
			case '+':
			case '.':
			case '|':
			case '(':
			case ')':
			case '{':
			case '}':
			case '[':
			case ']':
				rxp += "\\"; //fallthrough
			default:
				rxp += c;
		}
	}
	rxp += "$";
	if(ignoreCase){
		return new RegExp(rxp,"mi"); //RegExp
	}else{
		return new RegExp(rxp,"m"); //RegExp
	}
	
};

}

if(!dojo._hasResource["dijit.form.TextBox"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form.TextBox"] = true;
dojo.provide("dijit.form.TextBox");



dojo.declare(
	"dijit.form.TextBox",
	dijit.form._FormValueWidget,
	{
		// summary:
		//		A base class for textbox form inputs

		// trim: Boolean
		//		Removes leading and trailing whitespace if true.  Default is false.
		trim: false,

		// uppercase: Boolean
		//		Converts all characters to uppercase if true.  Default is false.
		uppercase: false,

		// lowercase: Boolean
		//		Converts all characters to lowercase if true.  Default is false.
		lowercase: false,

		// propercase: Boolean
		//		Converts the first character of each word to uppercase if true.
		propercase: false,

		//	maxLength: String
		//		HTML INPUT tag maxLength declaration.
		maxLength: "",

		//	selectOnClick: [const] Boolean
		//		If true, all text will be selected when focused with mouse
		selectOnClick: false,

		templateString: dojo.cache("dijit.form", "templates/TextBox.html", "<input class=\"dijit dijitReset dijitLeft\" dojoAttachPoint='textbox,focusNode'\n\tdojoAttachEvent='onmouseenter:_onMouse,onmouseleave:_onMouse'\n\tautocomplete=\"off\" type=\"${type}\" ${nameAttrSetting}\n\t/>\n"),
		baseClass: "dijitTextBox",

		attributeMap: dojo.delegate(dijit.form._FormValueWidget.prototype.attributeMap, {
			maxLength: "focusNode"
		}),

		_getValueAttr: function(){
			// summary:
			//		Hook so attr('value') works as we like.
			// description:
			//		For `dijit.form.TextBox` this basically returns the value of the <input>.
			//
			//		For `dijit.form.MappedTextBox` subclasses, which have both
			//		a "displayed value" and a separate "submit value",
			//		This treats the "displayed value" as the master value, computing the
			//		submit value from it via this.parse().
			return this.parse(this.attr('displayedValue'), this.constraints);
		},

		_setValueAttr: function(value, /*Boolean?*/ priorityChange, /*String?*/ formattedValue){
			// summary:
			//		Hook so attr('value', ...) works.
			//
			// description:
			//		Sets the value of the widget to "value" which can be of
			//		any type as determined by the widget.
			//
			// value:
			//		The visual element value is also set to a corresponding,
			//		but not necessarily the same, value.
			//
			// formattedValue:
			//		If specified, used to set the visual element value,
			//		otherwise a computed visual value is used.
			//
			// priorityChange:
			//		If true, an onChange event is fired immediately instead of
			//		waiting for the next blur event.

			var filteredValue;
			if(value !== undefined){
				// TODO: this is calling filter() on both the display value and the actual value.
				// I added a comment to the filter() definition about this, but it should be changed.
				filteredValue = this.filter(value);
				if(typeof formattedValue != "string"){
					if(filteredValue !== null && ((typeof filteredValue != "number") || !isNaN(filteredValue))){
						formattedValue = this.filter(this.format(filteredValue, this.constraints));
					}else{ formattedValue = ''; }
				}
			}
			if(formattedValue != null && formattedValue != undefined && ((typeof formattedValue) != "number" || !isNaN(formattedValue)) && this.textbox.value != formattedValue){
				this.textbox.value = formattedValue;
			}
			this.inherited(arguments, [filteredValue, priorityChange]);
		},

		// displayedValue: String
		//		For subclasses like ComboBox where the displayed value
		//		(ex: Kentucky) and the serialized value (ex: KY) are different,
		//		this represents the displayed value.
		//
		//		Setting 'displayedValue' through attr('displayedValue', ...)
		//		updates 'value', and vice-versa.  Othewise 'value' is updated
		//		from 'displayedValue' periodically, like onBlur etc.
		//
		//		TODO: move declaration to MappedTextBox?
		//		Problem is that ComboBox references displayedValue,
		//		for benefit of FilteringSelect.
		displayedValue: "",

		getDisplayedValue: function(){
			// summary:
			//		Deprecated.   Use attr('displayedValue') instead.
			// tags:
			//		deprecated
			dojo.deprecated(this.declaredClass+"::getDisplayedValue() is deprecated. Use attr('displayedValue') instead.", "", "2.0");
			return this.attr('displayedValue');
		},

		_getDisplayedValueAttr: function(){
			// summary:
			//		Hook so attr('displayedValue') works.
			// description:
			//		Returns the displayed value (what the user sees on the screen),
			// 		after filtering (ie, trimming spaces etc.).
			//
			//		For some subclasses of TextBox (like ComboBox), the displayed value
			//		is different from the serialized value that's actually
			//		sent to the server (see dijit.form.ValidationTextBox.serialize)

			return this.filter(this.textbox.value);
		},

		setDisplayedValue: function(/*String*/value){
			// summary:
			//		Deprecated.   Use attr('displayedValue', ...) instead.
			// tags:
			//		deprecated
			dojo.deprecated(this.declaredClass+"::setDisplayedValue() is deprecated. Use attr('displayedValue', ...) instead.", "", "2.0");
			this.attr('displayedValue', value);
		},

		_setDisplayedValueAttr: function(/*String*/value){
			// summary:
			//		Hook so attr('displayedValue', ...) works.
			// description:
			//		Sets the value of the visual element to the string "value".
			//		The widget value is also set to a corresponding,
			//		but not necessarily the same, value.

			if(value === null || value === undefined){ value = '' }
			else if(typeof value != "string"){ value = String(value) }
			this.textbox.value = value;
			this._setValueAttr(this.attr('value'), undefined, value);
		},

		format: function(/* String */ value, /* Object */ constraints){
			// summary:
			//		Replacable function to convert a value to a properly formatted string.
			// tags:
			//		protected extension
			return ((value == null || value == undefined) ? "" : (value.toString ? value.toString() : value));
		},

		parse: function(/* String */ value, /* Object */ constraints){
			// summary:
			//		Replacable function to convert a formatted string to a value
			// tags:
			//		protected extension

			return value;	// String
		},

		_refreshState: function(){
			// summary:
			//		After the user types some characters, etc., this method is
			//		called to check the field for validity etc.  The base method
			//		in `dijit.form.TextBox` does nothing, but subclasses override.
			// tags:
			//		protected
		},

		_onInput: function(e){
			if(e && e.type && /key/i.test(e.type) && e.keyCode){
				switch(e.keyCode){
					case dojo.keys.SHIFT:
					case dojo.keys.ALT:
					case dojo.keys.CTRL:
					case dojo.keys.TAB:
						return;
				}
			}
			if(this.intermediateChanges){
				var _this = this;
				// the setTimeout allows the key to post to the widget input box
				setTimeout(function(){ _this._handleOnChange(_this.attr('value'), false); }, 0);
			}
			this._refreshState();
		},

		postCreate: function(){
			// setting the value here is needed since value="" in the template causes "undefined"
			// and setting in the DOM (instead of the JS object) helps with form reset actions
			this.textbox.setAttribute("value", this.textbox.value); // DOM and JS values shuld be the same
			this.inherited(arguments);
			if(dojo.isMoz || dojo.isOpera){
				this.connect(this.textbox, "oninput", this._onInput);
			}else{
				this.connect(this.textbox, "onkeydown", this._onInput);
				this.connect(this.textbox, "onkeyup", this._onInput);
				this.connect(this.textbox, "onpaste", this._onInput);
				this.connect(this.textbox, "oncut", this._onInput);
			}
		},

		_blankValue: '', // if the textbox is blank, what value should be reported
		filter: function(val){
			// summary:
			//		Auto-corrections (such as trimming) that are applied to textbox
			//		value on blur or form submit.
			// description:
			//		For MappedTextBox subclasses, this is called twice
			// 			- once with the display value
			//			- once the value as set/returned by attr('value', ...)
			//		and attr('value'), ex: a Number for NumberTextBox.
			//
			//		In the latter case it does corrections like converting null to NaN.  In
			//		the former case the NumberTextBox.filter() method calls this.inherited()
			//		to execute standard trimming code in TextBox.filter().
			//
			//		TODO: break this into two methods in 2.0
			//
			// tags:
			//		protected extension
			if(val === null){ return this._blankValue; }
			if(typeof val != "string"){ return val; }
			if(this.trim){
				val = dojo.trim(val);
			}
			if(this.uppercase){
				val = val.toUpperCase();
			}
			if(this.lowercase){
				val = val.toLowerCase();
			}
			if(this.propercase){
				val = val.replace(/[^\s]+/g, function(word){
					return word.substring(0,1).toUpperCase() + word.substring(1);
				});
			}
			return val;
		},

		_setBlurValue: function(){
			this._setValueAttr(this.attr('value'), true);
		},

		_onBlur: function(e){
			if(this.disabled){ return; }
			this._setBlurValue();
			this.inherited(arguments);

			if(this._selectOnClickHandle){
				this.disconnect(this._selectOnClickHandle);
			}
			if(this.selectOnClick && dojo.isMoz){
				this.textbox.selectionStart = this.textbox.selectionEnd = undefined; // clear selection so that the next mouse click doesn't reselect
			}
		},

		_onFocus: function(/*String*/ by){
			if(this.disabled || this.readOnly){ return; }

			// Select all text on focus via click if nothing already selected.
			// Since mouse-up will clear the selection need to defer selection until after mouse-up.
			// Don't do anything on focus by tabbing into the widgetm since there's no associated mouse-up event.
			if(this.selectOnClick && by == "mouse"){
				this._selectOnClickHandle = this.connect(this.domNode, "onmouseup", function(){
					// Only select all text on first click; otherwise users would have no way to clear
					// the selection.
					this.disconnect(this._selectOnClickHandle);

					// Check if the user selected some text manually (mouse-down, mouse-move, mouse-up)
					// and if not, then select all the text
					var textIsNotSelected;
					if(dojo.isIE){
						var range = dojo.doc.selection.createRange();
						var parent = range.parentElement();
						textIsNotSelected = parent == this.textbox && range.text.length == 0;
					}else{
						textIsNotSelected = this.textbox.selectionStart == this.textbox.selectionEnd;
					}
					if(textIsNotSelected){
						dijit.selectInputText(this.textbox);
					}
				});
			}

			this._refreshState();
			this.inherited(arguments);
		},

		reset: function(){
			// Overrides dijit._FormWidget.reset().
			// Additionally resets the displayed textbox value to ''
			this.textbox.value = '';
			this.inherited(arguments);
		}
	}
);

dijit.selectInputText = function(/*DomNode*/element, /*Number?*/ start, /*Number?*/ stop){
	// summary:
	//		Select text in the input element argument, from start (default 0), to stop (default end).

	// TODO: use functions in _editor/selection.js?
	var _window = dojo.global;
	var _document = dojo.doc;
	element = dojo.byId(element);
	if(isNaN(start)){ start = 0; }
	if(isNaN(stop)){ stop = element.value ? element.value.length : 0; }
	dijit.focus(element);
	if(_document["selection"] && dojo.body()["createTextRange"]){ // IE
		if(element.createTextRange){
			var range = element.createTextRange();
			with(range){
				collapse(true);
				moveStart("character", -99999); // move to 0
				moveStart("character", start); // delta from 0 is the correct position
				moveEnd("character", stop-start);
				select();
			}
		}
	}else if(_window["getSelection"]){
		if(element.setSelectionRange){
			element.setSelectionRange(start, stop);
		}
	}
};

}

if(!dojo._hasResource["dijit.Tooltip"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.Tooltip"] = true;
dojo.provide("dijit.Tooltip");




dojo.declare(
	"dijit._MasterTooltip",
	[dijit._Widget, dijit._Templated],
	{
		// summary:
		//		Internal widget that holds the actual tooltip markup,
		//		which occurs once per page.
		//		Called by Tooltip widgets which are just containers to hold
		//		the markup
		// tags:
		//		protected

		// duration: Integer
		//		Milliseconds to fade in/fade out
		duration: dijit.defaultDuration,

		templateString: dojo.cache("dijit", "templates/Tooltip.html", "<div class=\"dijitTooltip dijitTooltipLeft\" id=\"dojoTooltip\">\n\t<div class=\"dijitTooltipContainer dijitTooltipContents\" dojoAttachPoint=\"containerNode\" waiRole='alert'></div>\n\t<div class=\"dijitTooltipConnector\"></div>\n</div>\n"),

		postCreate: function(){
			dojo.body().appendChild(this.domNode);

			this.bgIframe = new dijit.BackgroundIframe(this.domNode);

			// Setup fade-in and fade-out functions.
			this.fadeIn = dojo.fadeIn({ node: this.domNode, duration: this.duration, onEnd: dojo.hitch(this, "_onShow") });
			this.fadeOut = dojo.fadeOut({ node: this.domNode, duration: this.duration, onEnd: dojo.hitch(this, "_onHide") });

		},

		show: function(/*String*/ innerHTML, /*DomNode*/ aroundNode, /*String[]?*/ position){
			// summary:
			//		Display tooltip w/specified contents to right of specified node
			//		(To left if there's no space on the right, or if LTR==right)

			if(this.aroundNode && this.aroundNode === aroundNode){
				return;
			}

			if(this.fadeOut.status() == "playing"){
				// previous tooltip is being hidden; wait until the hide completes then show new one
				this._onDeck=arguments;
				return;
			}
			this.containerNode.innerHTML=innerHTML;

			// Firefox bug. when innerHTML changes to be shorter than previous
			// one, the node size will not be updated until it moves.
			this.domNode.style.top = (this.domNode.offsetTop + 1) + "px";

			var pos = dijit.placeOnScreenAroundElement(this.domNode, aroundNode, dijit.getPopupAroundAlignment((position && position.length) ? position : dijit.Tooltip.defaultPosition, this.isLeftToRight()), dojo.hitch(this, "orient"));

			// show it
			dojo.style(this.domNode, "opacity", 0);
			this.fadeIn.play();
			this.isShowingNow = true;
			this.aroundNode = aroundNode;
		},

		orient: function(/* DomNode */ node, /* String */ aroundCorner, /* String */ tooltipCorner){
			// summary:
			//		Private function to set CSS for tooltip node based on which position it's in.
			//		This is called by the dijit popup code.
			// tags:
			//		protected

			node.className = "dijitTooltip " +
				{
					"BL-TL": "dijitTooltipBelow dijitTooltipABLeft",
					"TL-BL": "dijitTooltipAbove dijitTooltipABLeft",
					"BR-TR": "dijitTooltipBelow dijitTooltipABRight",
					"TR-BR": "dijitTooltipAbove dijitTooltipABRight",
					"BR-BL": "dijitTooltipRight",
					"BL-BR": "dijitTooltipLeft"
				}[aroundCorner + "-" + tooltipCorner];
		},

		_onShow: function(){
			// summary:
			//		Called at end of fade-in operation
			// tags:
			//		protected
			if(dojo.isIE){
				// the arrow won't show up on a node w/an opacity filter
				this.domNode.style.filter="";
			}
		},

		hide: function(aroundNode){
			// summary:
			//		Hide the tooltip
			if(this._onDeck && this._onDeck[1] == aroundNode){
				// this hide request is for a show() that hasn't even started yet;
				// just cancel the pending show()
				this._onDeck=null;
			}else if(this.aroundNode === aroundNode){
				// this hide request is for the currently displayed tooltip
				this.fadeIn.stop();
				this.isShowingNow = false;
				this.aroundNode = null;
				this.fadeOut.play();
			}else{
				// just ignore the call, it's for a tooltip that has already been erased
			}
		},

		_onHide: function(){
			// summary:
			//		Called at end of fade-out operation
			// tags:
			//		protected

			this.domNode.style.cssText="";	// to position offscreen again
			if(this._onDeck){
				// a show request has been queued up; do it now
				this.show.apply(this, this._onDeck);
				this._onDeck=null;
			}
		}

	}
);

dijit.showTooltip = function(/*String*/ innerHTML, /*DomNode*/ aroundNode, /*String[]?*/ position){
	// summary:
	//		Display tooltip w/specified contents in specified position.
	//		See description of dijit.Tooltip.defaultPosition for details on position parameter.
	//		If position is not specified then dijit.Tooltip.defaultPosition is used.
	if(!dijit._masterTT){ dijit._masterTT = new dijit._MasterTooltip(); }
	return dijit._masterTT.show(innerHTML, aroundNode, position);
};

dijit.hideTooltip = function(aroundNode){
	// summary:
	//		Hide the tooltip
	if(!dijit._masterTT){ dijit._masterTT = new dijit._MasterTooltip(); }
	return dijit._masterTT.hide(aroundNode);
};

dojo.declare(
	"dijit.Tooltip",
	dijit._Widget,
	{
		// summary:
		//		Pops up a tooltip (a help message) when you hover over a node.

		// label: String
		//		Text to display in the tooltip.
		//		Specified as innerHTML when creating the widget from markup.
		label: "",

		// showDelay: Integer
		//		Number of milliseconds to wait after hovering over/focusing on the object, before
		//		the tooltip is displayed.
		showDelay: 400,

		// connectId: [const] String[]
		//		Id's of domNodes to attach the tooltip to.
		//		When user hovers over any of the specified dom nodes, the tooltip will appear.
		//
		//		Note: Currently connectId can only be specified on initialization, it cannot
		//		be changed via attr('connectId', ...)
		//
		//		Note: in 2.0 this will be renamed to connectIds for less confusion.
		connectId: [],

		// position: String[]
		//		See description of `dijit.Tooltip.defaultPosition` for details on position parameter.
		position: [],

		constructor: function(){
			// Map id's of nodes I'm connected to to a list of the this.connect() handles
			this._nodeConnectionsById = {};
		},

		_setConnectIdAttr: function(newIds){
			for(var oldId in this._nodeConnectionsById){
				this.removeTarget(oldId);
			}
			dojo.forEach(dojo.isArrayLike(newIds) ? newIds : [newIds], this.addTarget, this);
		},

		_getConnectIdAttr: function(){
			var ary = [];
			for(var id in this._nodeConnectionsById){
				ary.push(id);
			}
			return ary;
		},

		addTarget: function(/*DOMNODE || String*/ id){
			// summary:
			//		Attach tooltip to specified node, if it's not already connected
			var node = dojo.byId(id);
			if(!node){ return; }
			if(node.id in this._nodeConnectionsById){ return; }//Already connected

			this._nodeConnectionsById[node.id] = [
				this.connect(node, "onmouseenter", "_onTargetMouseEnter"),
				this.connect(node, "onmouseleave", "_onTargetMouseLeave"),
				this.connect(node, "onfocus", "_onTargetFocus"),
				this.connect(node, "onblur", "_onTargetBlur")
			];
			if(dojo.isIE && !node.style.zoom){//preserve zoom
				// BiDi workaround
				node.style.zoom = 1;
			}
		},

		removeTarget: function(/*DOMNODE || String*/ node){
			// summary:
			//		Detach tooltip from specified node

			// map from DOMNode back to plain id string
			var id = node.id || node;

			if(id in this._nodeConnectionsById){
				dojo.forEach(this._nodeConnectionsById[id], this.disconnect, this);
				delete this._nodeConnectionsById[id];
			}
		},

		postCreate: function(){
			dojo.addClass(this.domNode,"dijitTooltipData");
		},

		startup: function(){
			this.inherited(arguments);

			// If this tooltip was created in a template, or for some other reason the specified connectId[s]
			// didn't exist during the widget's initialization, then connect now.
			var ids = this.connectId;
			dojo.forEach(dojo.isArrayLike(ids) ? ids : [ids], this.addTarget, this);
		},

		_onTargetMouseEnter: function(/*Event*/ e){
			// summary:
			//		Handler for mouseenter event on the target node
			// tags:
			//		private
			this._onHover(e);
		},

		_onTargetMouseLeave: function(/*Event*/ e){
			// summary:
			//		Handler for mouseleave event on the target node
			// tags:
			//		private
			this._onUnHover(e);
		},

		_onTargetFocus: function(/*Event*/ e){
			// summary:
			//		Handler for focus event on the target node
			// tags:
			//		private

			this._focus = true;
			this._onHover(e);
		},

		_onTargetBlur: function(/*Event*/ e){
			// summary:
			//		Handler for blur event on the target node
			// tags:
			//		private

			this._focus = false;
			this._onUnHover(e);
		},

		_onHover: function(/*Event*/ e){
			// summary:
			//		Despite the name of this method, it actually handles both hover and focus
			//		events on the target node, setting a timer to show the tooltip.
			// tags:
			//		private
			if(!this._showTimer){
				var target = e.target;
				this._showTimer = setTimeout(dojo.hitch(this, function(){this.open(target)}), this.showDelay);
			}
		},

		_onUnHover: function(/*Event*/ e){
			// summary:
			//		Despite the name of this method, it actually handles both mouseleave and blur
			//		events on the target node, hiding the tooltip.
			// tags:
			//		private

			// keep a tooltip open if the associated element still has focus (even though the
			// mouse moved away)
			if(this._focus){ return; }

			if(this._showTimer){
				clearTimeout(this._showTimer);
				delete this._showTimer;
			}
			this.close();
		},

		open: function(/*DomNode*/ target){
 			// summary:
			//		Display the tooltip; usually not called directly.
			// tags:
			//		private

			if(this._showTimer){
				clearTimeout(this._showTimer);
				delete this._showTimer;
			}
			dijit.showTooltip(this.label || this.domNode.innerHTML, target, this.position);

			this._connectNode = target;
			this.onShow(target, this.position);
		},

		close: function(){
			// summary:
			//		Hide the tooltip or cancel timer for show of tooltip
			// tags:
			//		private

			if(this._connectNode){
				// if tooltip is currently shown
				dijit.hideTooltip(this._connectNode);
				delete this._connectNode;
				this.onHide();
			}
			if(this._showTimer){
				// if tooltip is scheduled to be shown (after a brief delay)
				clearTimeout(this._showTimer);
				delete this._showTimer;
			}
		},

		onShow: function(target, position){
			// summary:
			//		Called when the tooltip is shown
			// tags:
			//		callback
		},

		onHide: function(){
			// summary:
			//		Called when the tooltip is hidden
			// tags:
			//		callback
		},

		uninitialize: function(){
			this.close();
			this.inherited(arguments);
		}
	}
);

// dijit.Tooltip.defaultPosition: String[]
//		This variable controls the position of tooltips, if the position is not specified to
//		the Tooltip widget or *TextBox widget itself.  It's an array of strings with the following values:
//
//			* before: places tooltip to the left of the target node/widget, or to the right in
//			  the case of RTL scripts like Hebrew and Arabic
//			* after: places tooltip to the right of the target node/widget, or to the left in
//			  the case of RTL scripts like Hebrew and Arabic
//			* above: tooltip goes above target node
//			* below: tooltip goes below target node
//
//		The list is positions is tried, in order, until a position is found where the tooltip fits
//		within the viewport.
//
//		Be careful setting this parameter.  A value of "above" may work fine until the user scrolls
//		the screen so that there's no room above the target node.   Nodes with drop downs, like
//		DropDownButton or FilteringSelect, are especially problematic, in that you need to be sure
//		that the drop down and tooltip don't overlap, even when the viewport is scrolled so that there
//		is only room below (or above) the target node, but not both.
dijit.Tooltip.defaultPosition = ["after", "before"];

}

if(!dojo._hasResource["dijit.form.ValidationTextBox"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form.ValidationTextBox"] = true;
dojo.provide("dijit.form.ValidationTextBox");








/*=====
	dijit.form.ValidationTextBox.__Constraints = function(){
		// locale: String
		//		locale used for validation, picks up value from this widget's lang attribute
		// _flags_: anything
		//		various flags passed to regExpGen function
		this.locale = "";
		this._flags_ = "";
	}
=====*/

dojo.declare(
	"dijit.form.ValidationTextBox",
	dijit.form.TextBox,
	{
		// summary:
		//		Base class for textbox widgets with the ability to validate content of various types and provide user feedback.
		// tags:
		//		protected

		templateString: dojo.cache("dijit.form", "templates/ValidationTextBox.html", "<div class=\"dijit dijitReset dijitInlineTable dijitLeft\"\n\tid=\"widget_${id}\"\n\tdojoAttachEvent=\"onmouseenter:_onMouse,onmouseleave:_onMouse,onmousedown:_onMouse\" waiRole=\"presentation\"\n\t><div style=\"overflow:hidden;\"\n\t\t><div class=\"dijitReset dijitValidationIcon\"><br></div\n\t\t><div class=\"dijitReset dijitValidationIconText\">&Chi;</div\n\t\t><div class=\"dijitReset dijitInputField\"\n\t\t\t><input class=\"dijitReset\" dojoAttachPoint='textbox,focusNode' autocomplete=\"off\"\n\t\t\t${nameAttrSetting} type='${type}'\n\t\t/></div\n\t></div\n></div>\n"),
		baseClass: "dijitTextBox",

		// required: Boolean
		//		User is required to enter data into this field.
		required: false,

		// promptMessage: String
		//		If defined, display this hint string immediately on focus to the textbox, if empty.
		//		Think of this like a tooltip that tells the user what to do, not an error message
		//		that tells the user what they've done wrong.
		//
		//		Message disappears when user starts typing.
		promptMessage: "",

		// invalidMessage: String
		// 		The message to display if value is invalid.
		invalidMessage: "$_unset_$", // read from the message file if not overridden

		// constraints: dijit.form.ValidationTextBox.__Constraints
		//		user-defined object needed to pass parameters to the validator functions
		constraints: {},

		// regExp: [extension protected] String
		//		regular expression string used to validate the input
		//		Do not specify both regExp and regExpGen
		regExp: ".*",

		regExpGen: function(/*dijit.form.ValidationTextBox.__Constraints*/constraints){
			// summary:
			//		Overridable function used to generate regExp when dependent on constraints.
			//		Do not specify both regExp and regExpGen.
			// tags:
			//		extension protected
			return this.regExp; // String
		},

		// state: [readonly] String
		//		Shows current state (ie, validation result) of input (Normal, Warning, or Error)
		state: "",

		// tooltipPosition: String[]
		//		See description of `dijit.Tooltip.defaultPosition` for details on this parameter.
		tooltipPosition: [],

		_setValueAttr: function(){
			// summary:
			//		Hook so attr('value', ...) works.
			this.inherited(arguments);
			this.validate(this._focused);
		},

		validator: function(/*anything*/value, /*dijit.form.ValidationTextBox.__Constraints*/constraints){
			// summary:
			//		Overridable function used to validate the text input against the regular expression.
			// tags:
			//		protected
			return (new RegExp("^(?:" + this.regExpGen(constraints) + ")"+(this.required?"":"?")+"$")).test(value) &&
				(!this.required || !this._isEmpty(value)) &&
				(this._isEmpty(value) || this.parse(value, constraints) !== undefined); // Boolean
		},

		_isValidSubset: function(){
			// summary:
			//		Returns true if the value is either already valid or could be made valid by appending characters.
			//		This is used for validation while the user [may be] still typing.
			return this.textbox.value.search(this._partialre) == 0;
		},

		isValid: function(/*Boolean*/ isFocused){
			// summary:
			//		Tests if value is valid.
			//		Can override with your own routine in a subclass.
			// tags:
			//		protected
			return this.validator(this.textbox.value, this.constraints);
		},

		_isEmpty: function(value){
			// summary:
			//		Checks for whitespace
			return /^\s*$/.test(value); // Boolean
		},

		getErrorMessage: function(/*Boolean*/ isFocused){
			// summary:
			//		Return an error message to show if appropriate
			// tags:
			//		protected
			return this.invalidMessage; // String
		},

		getPromptMessage: function(/*Boolean*/ isFocused){
			// summary:
			//		Return a hint message to show when widget is first focused
			// tags:
			//		protected
			return this.promptMessage; // String
		},

		_maskValidSubsetError: true,
		validate: function(/*Boolean*/ isFocused){
			// summary:
			//		Called by oninit, onblur, and onkeypress.
			// description:
			//		Show missing or invalid messages if appropriate, and highlight textbox field.
			// tags:
			//		protected
			var message = "";
			var isValid = this.disabled || this.isValid(isFocused);
			if(isValid){ this._maskValidSubsetError = true; }
			var isValidSubset = !isValid && isFocused && this._isValidSubset();
			var isEmpty = this._isEmpty(this.textbox.value);
			if(isEmpty){ this._maskValidSubsetError = true; }
			this.state = (isValid || (!this._hasBeenBlurred && isEmpty) || isValidSubset) ? "" : "Error";
			if(this.state == "Error"){ this._maskValidSubsetError = false; }
			this._setStateClass();
			dijit.setWaiState(this.focusNode, "invalid", isValid ? "false" : "true");
			if(isFocused){
				if(isEmpty){
					message = this.getPromptMessage(true);
				}
				if(!message && (this.state == "Error" || (isValidSubset && !this._maskValidSubsetError))){
					message = this.getErrorMessage(true);
				}
			}
			this.displayMessage(message);
			return isValid;
		},

		// _message: String
		//		Currently displayed message
		_message: "",

		displayMessage: function(/*String*/ message){
			// summary:
			//		Overridable method to display validation errors/hints.
			//		By default uses a tooltip.
			// tags:
			//		extension
			if(this._message == message){ return; }
			this._message = message;
			dijit.hideTooltip(this.domNode);
			if(message){
				dijit.showTooltip(message, this.domNode, this.tooltipPosition);
			}
		},

		_refreshState: function(){
			// Overrides TextBox._refreshState()
			this.validate(this._focused);
			this.inherited(arguments);
		},

		//////////// INITIALIZATION METHODS ///////////////////////////////////////

		constructor: function(){
			this.constraints = {};
		},

		postMixInProperties: function(){
			this.inherited(arguments);
			this.constraints.locale = this.lang;
			this.messages = dojo.i18n.getLocalization("dijit.form", "validate", this.lang);
			if(this.invalidMessage == "$_unset_$"){ this.invalidMessage = this.messages.invalidMessage; }
			var p = this.regExpGen(this.constraints);
			this.regExp = p;
			var partialre = "";
			// parse the regexp and produce a new regexp that matches valid subsets
			// if the regexp is .* then there's no use in matching subsets since everything is valid
			if(p != ".*"){ this.regExp.replace(/\\.|\[\]|\[.*?[^\\]{1}\]|\{.*?\}|\(\?[=:!]|./g,
				function (re){
					switch(re.charAt(0)){
						case '{':
						case '+':
						case '?':
						case '*':
						case '^':
						case '$':
						case '|':
						case '(':
							partialre += re;
							break;
						case ")":
							partialre += "|$)";
							break;
						 default:
							partialre += "(?:"+re+"|$)";
							break;
					}
				}
			);}
			try{ // this is needed for now since the above regexp parsing needs more test verification
				"".search(partialre);
			}catch(e){ // should never be here unless the original RE is bad or the parsing is bad
				partialre = this.regExp;
				console.warn('RegExp error in ' + this.declaredClass + ': ' + this.regExp);
			} // should never be here unless the original RE is bad or the parsing is bad
			this._partialre = "^(?:" + partialre + ")$";
		},

		_setDisabledAttr: function(/*Boolean*/ value){
			this.inherited(arguments);	// call FormValueWidget._setDisabledAttr()
			this._refreshState();
		},

		_setRequiredAttr: function(/*Boolean*/ value){
			this.required = value;
			dijit.setWaiState(this.focusNode,"required", value);
			this._refreshState();
		},

		postCreate: function(){
			if(dojo.isIE){ // IE INPUT tag fontFamily has to be set directly using STYLE
				var s = dojo.getComputedStyle(this.focusNode);
				if(s){
					var ff = s.fontFamily;
					if(ff){
						this.focusNode.style.fontFamily = ff;
					}
				}
			}
			this.inherited(arguments);
		},

		reset:function(){
			// Overrides dijit.form.TextBox.reset() by also
			// hiding errors about partial matches
			this._maskValidSubsetError = true;
			this.inherited(arguments);
		},

		_onBlur: function(){
			this.displayMessage('');
			this.inherited(arguments);
		}
	}
);

dojo.declare(
	"dijit.form.MappedTextBox",
	dijit.form.ValidationTextBox,
	{
		// summary:
		//		A dijit.form.ValidationTextBox subclass which provides a base class for widgets that have
		//		a visible formatted display value, and a serializable
		//		value in a hidden input field which is actually sent to the server.
		// description:
		//		The visible display may
		//		be locale-dependent and interactive.  The value sent to the server is stored in a hidden
		//		input field which uses the `name` attribute declared by the original widget.  That value sent
		//		to the server is defined by the dijit.form.MappedTextBox.serialize method and is typically
		//		locale-neutral.
		// tags:
		//		protected

		postMixInProperties: function(){
			this.inherited(arguments);

			// we want the name attribute to go to the hidden <input>, not the displayed <input>,
			// so override _FormWidget.postMixInProperties() setting of nameAttrSetting
			this.nameAttrSetting = "";
		},

		serialize: function(/*anything*/val, /*Object?*/options){
			// summary:
			//		Overridable function used to convert the attr('value') result to a canonical
			//		(non-localized) string.  For example, will print dates in ISO format, and
			//		numbers the same way as they are represented in javascript.
			// tags:
			//		protected extension
			return val.toString ? val.toString() : ""; // String
		},

		toString: function(){
			// summary:
			//		Returns widget as a printable string using the widget's value
			// tags:
			//		protected
			var val = this.filter(this.attr('value')); // call filter in case value is nonstring and filter has been customized
			return val != null ? (typeof val == "string" ? val : this.serialize(val, this.constraints)) : ""; // String
		},

		validate: function(){
			// Overrides `dijit.form.TextBox.validate`
			this.valueNode.value = this.toString();
			return this.inherited(arguments);
		},

		buildRendering: function(){
			// Overrides `dijit._Templated.buildRendering`

			this.inherited(arguments);

			// Create a hidden <input> node with the serialized value used for submit
			// (as opposed to the displayed value).
			// Passing in name as markup rather than calling dojo.create() with an attrs argument
			// to make dojo.query(input[name=...]) work on IE. (see #8660)
			this.valueNode = dojo.place("<input type='hidden'" + (this.name ? " name='" + this.name + "'" : "") + ">", this.textbox, "after");
		},

		reset:function(){
			// Overrides `dijit.form.ValidationTextBox.reset` to
			// reset the hidden textbox value to ''
			this.valueNode.value = '';
			this.inherited(arguments);
		}
	}
);

/*=====
	dijit.form.RangeBoundTextBox.__Constraints = function(){
		// min: Number
		//		Minimum signed value.  Default is -Infinity
		// max: Number
		//		Maximum signed value.  Default is +Infinity
		this.min = min;
		this.max = max;
	}
=====*/

dojo.declare(
	"dijit.form.RangeBoundTextBox",
	dijit.form.MappedTextBox,
	{
		// summary:
		//		Base class for textbox form widgets which defines a range of valid values.

		// rangeMessage: String
		//		The message to display if value is out-of-range
		rangeMessage: "",

		/*=====
		// constraints: dijit.form.RangeBoundTextBox.__Constraints
		constraints: {},
		======*/

		rangeCheck: function(/*Number*/ primitive, /*dijit.form.RangeBoundTextBox.__Constraints*/ constraints){
			// summary:
			//		Overridable function used to validate the range of the numeric input value.
			// tags:
			//		protected
			return	("min" in constraints? (this.compare(primitive,constraints.min) >= 0) : true) &&
				("max" in constraints? (this.compare(primitive,constraints.max) <= 0) : true); // Boolean
		},

		isInRange: function(/*Boolean*/ isFocused){
			// summary:
			//		Tests if the value is in the min/max range specified in constraints
			// tags:
			//		protected
			return this.rangeCheck(this.attr('value'), this.constraints);
		},

		_isDefinitelyOutOfRange: function(){
			// summary:
			//		Returns true if the value is out of range and will remain
			//		out of range even if the user types more characters
			var val = this.attr('value');
			var isTooLittle = false;
			var isTooMuch = false;
			if("min" in this.constraints){
				var min = this.constraints.min;
				min = this.compare(val, ((typeof min == "number") && min >= 0 && val !=0) ? 0 : min);
				isTooLittle = (typeof min == "number") && min < 0;
			}
			if("max" in this.constraints){
				var max = this.constraints.max;
				max = this.compare(val, ((typeof max != "number") || max > 0) ? max : 0);
				isTooMuch = (typeof max == "number") && max > 0;
			}
			return isTooLittle || isTooMuch;
		},

		_isValidSubset: function(){
			// summary:
			//		Overrides `dijit.form.ValidationTextBox._isValidSubset`.
			//		Returns true if the input is syntactically valid, and either within
			//		range or could be made in range by more typing.
			return this.inherited(arguments) && !this._isDefinitelyOutOfRange();
		},

		isValid: function(/*Boolean*/ isFocused){
			// Overrides dijit.form.ValidationTextBox.isValid to check that the value is also in range.
			return this.inherited(arguments) &&
				((this._isEmpty(this.textbox.value) && !this.required) || this.isInRange(isFocused)); // Boolean
		},

		getErrorMessage: function(/*Boolean*/ isFocused){
			// Overrides dijit.form.ValidationTextBox.getErrorMessage to print "out of range" message if appropriate
			var v = this.attr('value');
			if(v !== null && v !== '' && v !== undefined && !this.isInRange(isFocused)){ // don't check isInRange w/o a real value
				return this.rangeMessage; // String
			}
			return this.inherited(arguments);
		},

		postMixInProperties: function(){
			this.inherited(arguments);
			if(!this.rangeMessage){
				this.messages = dojo.i18n.getLocalization("dijit.form", "validate", this.lang);
				this.rangeMessage = this.messages.rangeMessage;
			}
		},

		postCreate: function(){
			this.inherited(arguments);
			if(this.constraints.min !== undefined){
				dijit.setWaiState(this.focusNode, "valuemin", this.constraints.min);
			}
			if(this.constraints.max !== undefined){
				dijit.setWaiState(this.focusNode, "valuemax", this.constraints.max);
			}
		},

		_setValueAttr: function(/*Number*/ value, /*Boolean?*/ priorityChange){
			// summary:
			//		Hook so attr('value', ...) works.

			dijit.setWaiState(this.focusNode, "valuenow", value);
			this.inherited(arguments);
		}
	}
);

}

if(!dojo._hasResource["dijit.form.ComboBox"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form.ComboBox"] = true;
dojo.provide("dijit.form.ComboBox");









dojo.declare(
	"dijit.form.ComboBoxMixin",
	null,
	{
		// summary:
		//		Implements the base functionality for `dijit.form.ComboBox`/`dijit.form.FilteringSelect`
		// description:
		//		All widgets that mix in dijit.form.ComboBoxMixin must extend `dijit.form._FormValueWidget`.
		// tags:
		//		protected

		// item: Object
		//		This is the item returned by the dojo.data.store implementation that
		//		provides the data for this ComboBox, it's the currently selected item.
		item: null,

		// pageSize: Integer
		//		Argument to data provider.
		//		Specifies number of search results per page (before hitting "next" button)
		pageSize: Infinity,

		// store: Object
		//		Reference to data provider object used by this ComboBox
		store: null,

		// fetchProperties: Object
		//		Mixin to the dojo.data store's fetch.
		//		For example, to set the sort order of the ComboBox menu, pass:
		//	|	{ sort: {attribute:"name",descending: true} }
		//		To override the default queryOptions so that deep=false, do:
		//	|	{ queryOptions: {ignoreCase: true, deep: false} }
		fetchProperties:{},

		// query: Object
		//		A query that can be passed to 'store' to initially filter the items,
		//		before doing further filtering based on `searchAttr` and the key.
		//		Any reference to the `searchAttr` is ignored.
		query: {},

		// autoComplete: Boolean
		//		If user types in a partial string, and then tab out of the `<input>` box,
		//		automatically copy the first entry displayed in the drop down list to
		//		the `<input>` field
		autoComplete: true,

		// highlightMatch: String
		// 		One of: "first", "all" or "none".
		//
		//		If the ComboBox/FilteringSelect opens with the search results and the searched
		//		string can be found, it will be highlighted.  If set to "all"
		//		then will probably want to change `queryExpr` parameter to '*${0}*'
		//
		//		Highlighting is only performed when `labelType` is "text", so as to not
		//		interfere with any HTML markup an HTML label might contain.
		highlightMatch: "first",

		// searchDelay: Integer
		//		Delay in milliseconds between when user types something and we start
		//		searching based on that value
		searchDelay: 100,

		// searchAttr: String
		//		Search for items in the data store where this attribute (in the item)
		//		matches what the user typed
		searchAttr: "name",

		// labelAttr: String?
		//		The entries in the drop down list come from this attribute in the
		//		dojo.data items.
		//		If not specified, the searchAttr attribute is used instead.
		labelAttr: "",

		// labelType: String
		//		Specifies how to interpret the labelAttr in the data store items.
		//		Can be "html" or "text".
		labelType: "text",

		// queryExpr: String
		//		This specifies what query ComboBox/FilteringSelect sends to the data store,
		//		based on what the user has typed.  Changing this expression will modify
		//		whether the drop down shows only exact matches, a "starting with" match,
		//		etc.   Use it in conjunction with highlightMatch.
		//		dojo.data query expression pattern.
		//		`${0}` will be substituted for the user text.
		//		`*` is used for wildcards.
		//		`${0}*` means "starts with", `*${0}*` means "contains", `${0}` means "is"
		queryExpr: "${0}*",

		// ignoreCase: Boolean
		//		Set true if the ComboBox/FilteringSelect should ignore case when matching possible items
		ignoreCase: true,

		// hasDownArrow: [const] Boolean
		//		Set this textbox to have a down arrow button, to display the drop down list.
		//		Defaults to true.
		hasDownArrow: true,

		templateString: dojo.cache("dijit.form", "templates/ComboBox.html", "<div class=\"dijit dijitReset dijitInlineTable dijitLeft\"\n\tid=\"widget_${id}\"\n\tdojoAttachEvent=\"onmouseenter:_onMouse,onmouseleave:_onMouse,onmousedown:_onMouse\" dojoAttachPoint=\"comboNode\" waiRole=\"combobox\" tabIndex=\"-1\"\n\t><div style=\"overflow:hidden;\"\n\t\t><div class='dijitReset dijitRight dijitButtonNode dijitArrowButton dijitDownArrowButton'\n\t\t\tdojoAttachPoint=\"downArrowNode\" waiRole=\"presentation\"\n\t\t\tdojoAttachEvent=\"onmousedown:_onArrowMouseDown,onmouseup:_onMouse,onmouseenter:_onMouse,onmouseleave:_onMouse\"\n\t\t\t><div class=\"dijitArrowButtonInner\">&thinsp;</div\n\t\t\t><div class=\"dijitArrowButtonChar\">&#9660;</div\n\t\t></div\n\t\t><div class=\"dijitReset dijitValidationIcon\"><br></div\n\t\t><div class=\"dijitReset dijitValidationIconText\">&Chi;</div\n\t\t><div class=\"dijitReset dijitInputField\"\n\t\t\t><input ${nameAttrSetting} type=\"text\" autocomplete=\"off\" class='dijitReset'\n\t\t\tdojoAttachEvent=\"onkeypress:_onKeyPress,compositionend\"\n\t\t\tdojoAttachPoint=\"textbox,focusNode\" waiRole=\"textbox\" waiState=\"haspopup-true,autocomplete-list\"\n\t\t/></div\n\t></div\n></div>\n"),

		baseClass:"dijitComboBox",

		_getCaretPos: function(/*DomNode*/ element){
			// khtml 3.5.2 has selection* methods as does webkit nightlies from 2005-06-22
			var pos = 0;
			if(typeof(element.selectionStart) == "number"){
				// FIXME: this is totally borked on Moz < 1.3. Any recourse?
				pos = element.selectionStart;
			}else if(dojo.isIE){
				// in the case of a mouse click in a popup being handled,
				// then the dojo.doc.selection is not the textarea, but the popup
				// var r = dojo.doc.selection.createRange();
				// hack to get IE 6 to play nice. What a POS browser.
				var tr = dojo.doc.selection.createRange().duplicate();
				var ntr = element.createTextRange();
				tr.move("character",0);
				ntr.move("character",0);
				try{
					// If control doesnt have focus, you get an exception.
					// Seems to happen on reverse-tab, but can also happen on tab (seems to be a race condition - only happens sometimes).
					// There appears to be no workaround for this - googled for quite a while.
					ntr.setEndPoint("EndToEnd", tr);
					pos = String(ntr.text).replace(/\r/g,"").length;
				}catch(e){
					// If focus has shifted, 0 is fine for caret pos.
				}
			}
			return pos;
		},

		_setCaretPos: function(/*DomNode*/ element, /*Number*/ location){
			location = parseInt(location);
			dijit.selectInputText(element, location, location);
		},

		_setDisabledAttr: function(/*Boolean*/ value){
			// Additional code to set disabled state of ComboBox node.
			// Overrides _FormValueWidget._setDisabledAttr() or ValidationTextBox._setDisabledAttr().
			this.inherited(arguments);
			dijit.setWaiState(this.comboNode, "disabled", value);
		},

		_abortQuery: function(){
			// stop in-progress query
			if(this.searchTimer){
				clearTimeout(this.searchTimer);
				this.searchTimer = null;
			}
			if(this._fetchHandle){
				if(this._fetchHandle.abort){ this._fetchHandle.abort(); }
				this._fetchHandle = null;
			}
		},

		_onKeyPress: function(/*Event*/ evt){
			// summary:
			//		Handles keyboard events
			var key = evt.charOrCode;
			// except for cutting/pasting case - ctrl + x/v
			if(evt.altKey || ((evt.ctrlKey || evt.metaKey) && (key != 'x' && key != 'v')) || key == dojo.keys.SHIFT){
				return; // throw out weird key combinations and spurious events
			}
			var doSearch = false;
			var searchFunction = "_startSearchFromInput";
			var pw = this._popupWidget;
			var dk = dojo.keys;
			var highlighted = null;
			this._prev_key_backspace = false;
			this._abortQuery();
			if(this._isShowingNow){
				pw.handleKey(key);
				highlighted = pw.getHighlightedOption();
			}
			switch(key){
				case dk.PAGE_DOWN:
				case dk.DOWN_ARROW:
				case dk.PAGE_UP:
				case dk.UP_ARROW:
					if(!this._isShowingNow){
						this._arrowPressed();
						doSearch = true;
						searchFunction = "_startSearchAll";
					}else{
						this._announceOption(highlighted);
					}
					dojo.stopEvent(evt);
					break;

				case dk.ENTER:
					// prevent submitting form if user presses enter. Also
					// prevent accepting the value if either Next or Previous
					// are selected
					if(highlighted){
						// only stop event on prev/next
						if(highlighted == pw.nextButton){
							this._nextSearch(1);
							dojo.stopEvent(evt);
							break;
						}else if(highlighted == pw.previousButton){
							this._nextSearch(-1);
							dojo.stopEvent(evt);
							break;
						}
					}else{
						// Update 'value' (ex: KY) according to currently displayed text
						this._setBlurValue(); // set value if needed
						this._setCaretPos(this.focusNode, this.focusNode.value.length); // move cursor to end and cancel highlighting
					}
					// default case:
					// prevent submit, but allow event to bubble
					evt.preventDefault();
					// fall through

				case dk.TAB:
					var newvalue = this.attr('displayedValue');
					//	if the user had More Choices selected fall into the
					//	_onBlur handler
					if(pw && (
						newvalue == pw._messages["previousMessage"] ||
						newvalue == pw._messages["nextMessage"])
					){
						break;
					}
					if(highlighted){
						this._selectOption();
					}
					if(this._isShowingNow){
						this._lastQuery = null; // in case results come back later
						this._hideResultList();
					}
					break;

				case ' ':
					if(highlighted){
						dojo.stopEvent(evt);
						this._selectOption();
						this._hideResultList();
					}else{
						doSearch = true;
					}
					break;

				case dk.ESCAPE:
					if(this._isShowingNow){
						dojo.stopEvent(evt);
						this._hideResultList();
					}
					break;

				case dk.DELETE:
				case dk.BACKSPACE:
					this._prev_key_backspace = true;
					doSearch = true;
					break;

				default:
					// Non char keys (F1-F12 etc..)  shouldn't open list.
					// Ascii characters and IME input (Chinese, Japanese etc.) should.
					// On IE and safari, IME input produces keycode == 229, and we simulate
					// it on firefox by attaching to compositionend event (see compositionend method)
					doSearch = typeof key == 'string' || key == 229;
			}
			if(doSearch){
				// need to wait a tad before start search so that the event
				// bubbles through DOM and we have value visible
				this.item = undefined; // undefined means item needs to be set
				this.searchTimer = setTimeout(dojo.hitch(this, searchFunction),1);
			}
		},

		_autoCompleteText: function(/*String*/ text){
			// summary:
			// 		Fill in the textbox with the first item from the drop down
			// 		list, and highlight the characters that were
			// 		auto-completed. For example, if user typed "CA" and the
			// 		drop down list appeared, the textbox would be changed to
			// 		"California" and "ifornia" would be highlighted.

			var fn = this.focusNode;

			// IE7: clear selection so next highlight works all the time
			dijit.selectInputText(fn, fn.value.length);
			// does text autoComplete the value in the textbox?
			var caseFilter = this.ignoreCase? 'toLowerCase' : 'substr';
			if(text[caseFilter](0).indexOf(this.focusNode.value[caseFilter](0)) == 0){
				var cpos = this._getCaretPos(fn);
				// only try to extend if we added the last character at the end of the input
				if((cpos+1) > fn.value.length){
					// only add to input node as we would overwrite Capitalisation of chars
					// actually, that is ok
					fn.value = text;//.substr(cpos);
					// visually highlight the autocompleted characters
					dijit.selectInputText(fn, cpos);
				}
			}else{
				// text does not autoComplete; replace the whole value and highlight
				fn.value = text;
				dijit.selectInputText(fn);
			}
		},

		_openResultList: function(/*Object*/ results, /*Object*/ dataObject){
			this._fetchHandle = null;
			if(	this.disabled ||
				this.readOnly ||
				(dataObject.query[this.searchAttr] != this._lastQuery)
			){
				return;
			}
			this._popupWidget.clearResultList();
			if(!results.length){
				this._hideResultList();
				return;
			}


			// Fill in the textbox with the first item from the drop down list,
			// and highlight the characters that were auto-completed. For
			// example, if user typed "CA" and the drop down list appeared, the
			// textbox would be changed to "California" and "ifornia" would be
			// highlighted.

			dataObject._maxOptions = this._maxOptions;
			var nodes = this._popupWidget.createOptions(
				results,
				dataObject,
				dojo.hitch(this, "_getMenuLabelFromItem")
			);

			// show our list (only if we have content, else nothing)
			this._showResultList();

			// #4091:
			//		tell the screen reader that the paging callback finished by
			//		shouting the next choice
			if(dataObject.direction){
				if(1 == dataObject.direction){
					this._popupWidget.highlightFirstOption();
				}else if(-1 == dataObject.direction){
					this._popupWidget.highlightLastOption();
				}
				this._announceOption(this._popupWidget.getHighlightedOption());
			}else if(this.autoComplete && !this._prev_key_backspace /*&& !dataObject.direction*/
				// when the user clicks the arrow button to show the full list,
				// startSearch looks for "*".
				// it does not make sense to autocomplete
				// if they are just previewing the options available.
				&& !/^[*]+$/.test(dataObject.query[this.searchAttr])){
					this._announceOption(nodes[1]); // 1st real item
			}
		},

		_showResultList: function(){
			this._hideResultList();
			this._arrowPressed();
			// hide the tooltip
			this.displayMessage("");

			// Position the list and if it's too big to fit on the screen then
			// size it to the maximum possible height
			// Our dear friend IE doesnt take max-height so we need to
			// calculate that on our own every time

			// TODO: want to redo this, see
			//		http://trac.dojotoolkit.org/ticket/3272
			//	and
			//		http://trac.dojotoolkit.org/ticket/4108


			// natural size of the list has changed, so erase old
			// width/height settings, which were hardcoded in a previous
			// call to this function (via dojo.marginBox() call)
			dojo.style(this._popupWidget.domNode, {width: "", height: ""});

			var best = this.open();
			// #3212:
			//		only set auto scroll bars if necessary prevents issues with
			//		scroll bars appearing when they shouldn't when node is made
			//		wider (fractional pixels cause this)
			var popupbox = dojo.marginBox(this._popupWidget.domNode);
			this._popupWidget.domNode.style.overflow =
				((best.h == popupbox.h) && (best.w == popupbox.w)) ? "hidden" : "auto";
			// #4134:
			//		borrow TextArea scrollbar test so content isn't covered by
			//		scrollbar and horizontal scrollbar doesn't appear
			var newwidth = best.w;
			if(best.h < this._popupWidget.domNode.scrollHeight){
				newwidth += 16;
			}
			dojo.marginBox(this._popupWidget.domNode, {
				h: best.h,
				w: Math.max(newwidth, this.domNode.offsetWidth)
			});
			dijit.setWaiState(this.comboNode, "expanded", "true");
		},

		_hideResultList: function(){
			this._abortQuery();
			if(this._isShowingNow){
				dijit.popup.close(this._popupWidget);
				this._arrowIdle();
				this._isShowingNow=false;
				dijit.setWaiState(this.comboNode, "expanded", "false");
				dijit.removeWaiState(this.focusNode,"activedescendant");
			}
		},

		_setBlurValue: function(){
			// if the user clicks away from the textbox OR tabs away, set the
			// value to the textbox value
			// #4617:
			//		if value is now more choices or previous choices, revert
			//		the value
			var newvalue=this.attr('displayedValue');
			var pw = this._popupWidget;
			if(pw && (
				newvalue == pw._messages["previousMessage"] ||
				newvalue == pw._messages["nextMessage"]
				)
			){
				this._setValueAttr(this._lastValueReported, true);
			}else if(typeof this.item == "undefined"){
				// Update 'value' (ex: KY) according to currently displayed text
				this.item = null;
				this.attr('displayedValue', newvalue);
			}else{
				if(this.value != this._lastValueReported){
					dijit.form._FormValueWidget.prototype._setValueAttr.call(this, this.value, true);
				}
				this._refreshState();
			}
		},

		_onBlur: function(){
			// summary:
			//		Called magically when focus has shifted away from this widget and it's drop down
			this._hideResultList();
			this._arrowIdle();
			this.inherited(arguments);
		},

		_setItemAttr: function(/*item*/ item, /*Boolean?*/ priorityChange, /*String?*/ displayedValue){
			// summary:
			//              Set the displayed valued in the input box, and the hidden value
			//              that gets submitted, based on a dojo.data store item.
			// description:
			//              Users shouldn't call this function; they should be calling
			//              attr('item', value)
			// tags:
			//              private
			if(!displayedValue){ displayedValue = this.labelFunc(item, this.store); }
			this.value = this._getValueField() != this.searchAttr? this.store.getIdentity(item) : displayedValue;
			this.item = item;
			dijit.form.ComboBox.superclass._setValueAttr.call(this, this.value, priorityChange, displayedValue);
		},

		_announceOption: function(/*Node*/ node){
			// summary:
			//		a11y code that puts the highlighted option in the textbox.
			//		This way screen readers will know what is happening in the
			//		menu.

			if(!node){
				return;
			}
			// pull the text value from the item attached to the DOM node
			var newValue;
			if( node == this._popupWidget.nextButton ||
				node == this._popupWidget.previousButton){
				newValue = node.innerHTML;
				this.item = undefined;
				this.value = '';
			}else{
				newValue = this.labelFunc(node.item, this.store);
				this.attr('item', node.item, false, newValue);
			}
			// get the text that the user manually entered (cut off autocompleted text)
			this.focusNode.value = this.focusNode.value.substring(0, this._lastInput.length);
			// set up ARIA activedescendant
			dijit.setWaiState(this.focusNode, "activedescendant", dojo.attr(node, "id"));
			// autocomplete the rest of the option to announce change
			this._autoCompleteText(newValue);
		},

		_selectOption: function(/*Event*/ evt){
			// summary:
			//		Menu callback function, called when an item in the menu is selected.
			if(evt){
				this._announceOption(evt.target);
			}
			this._hideResultList();
			this._setCaretPos(this.focusNode, this.focusNode.value.length);
			dijit.form._FormValueWidget.prototype._setValueAttr.call(this, this.value, true); // set this.value and fire onChange
		},

		_onArrowMouseDown: function(evt){
			// summary:
			//		Callback when arrow is clicked
			if(this.disabled || this.readOnly){
				return;
			}
			dojo.stopEvent(evt);
			this.focus();
			if(this._isShowingNow){
				this._hideResultList();
			}else{
				// forces full population of results, if they click
				// on the arrow it means they want to see more options
				this._startSearchAll();
			}
		},

		_startSearchAll: function(){
			this._startSearch('');
		},

		_startSearchFromInput: function(){
			this._startSearch(this.focusNode.value.replace(/([\\\*\?])/g, "\\$1"));
		},

		_getQueryString: function(/*String*/ text){
			return dojo.string.substitute(this.queryExpr, [text]);
		},

		_startSearch: function(/*String*/ key){
			if(!this._popupWidget){
				var popupId = this.id + "_popup";
				this._popupWidget = new dijit.form._ComboBoxMenu({
					onChange: dojo.hitch(this, this._selectOption),
					id: popupId
				});
				dijit.removeWaiState(this.focusNode,"activedescendant");
				dijit.setWaiState(this.textbox,"owns",popupId); // associate popup with textbox
			}
			// create a new query to prevent accidentally querying for a hidden
			// value from FilteringSelect's keyField
			var query = dojo.clone(this.query); // #5970
			this._lastInput = key; // Store exactly what was entered by the user.
			this._lastQuery = query[this.searchAttr] = this._getQueryString(key);
			// #5970: set _lastQuery, *then* start the timeout
			// otherwise, if the user types and the last query returns before the timeout,
			// _lastQuery won't be set and their input gets rewritten
			this.searchTimer=setTimeout(dojo.hitch(this, function(query, _this){
				this.searchTimer = null;
				var fetch = {
					queryOptions: {
						ignoreCase: this.ignoreCase,
						deep: true
					},
					query: query,
					onBegin: dojo.hitch(this, "_setMaxOptions"),
					onComplete: dojo.hitch(this, "_openResultList"),
					onError: function(errText){
						_this._fetchHandle = null;
						console.error('dijit.form.ComboBox: ' + errText);
						dojo.hitch(_this, "_hideResultList")();
					},
					start: 0,
					count: this.pageSize
				};
				dojo.mixin(fetch, _this.fetchProperties);
				this._fetchHandle = _this.store.fetch(fetch);

				var nextSearch = function(dataObject, direction){
					dataObject.start += dataObject.count*direction;
					// #4091:
					//		tell callback the direction of the paging so the screen
					//		reader knows which menu option to shout
					dataObject.direction = direction;
					this._fetchHandle = this.store.fetch(dataObject);
				};
				this._nextSearch = this._popupWidget.onPage = dojo.hitch(this, nextSearch, this._fetchHandle);
			}, query, this), this.searchDelay);
		},

		_setMaxOptions: function(size, request){
			 this._maxOptions = size;
		},

		_getValueField: function(){
			// summmary:
			//		Helper for postMixInProperties() to set this.value based on data inlined into the markup.
			//		Returns the attribute name in the item (in dijit.form._ComboBoxDataStore) to use as the value.
			return this.searchAttr;
		},

		/////////////// Event handlers /////////////////////

		_arrowPressed: function(){
			if(!this.disabled && !this.readOnly && this.hasDownArrow){
				dojo.addClass(this.downArrowNode, "dijitArrowButtonActive");
			}
		},

		_arrowIdle: function(){
			if(!this.disabled && !this.readOnly && this.hasDownArrow){
				dojo.removeClass(this.downArrowNode, "dojoArrowButtonPushed");
			}
		},

		// FIXME: For 2.0, rename to "_compositionEnd"
		compositionend: function(/*Event*/ evt){
			// summary:
			//		When inputting characters using an input method, such as
			//		Asian languages, it will generate this event instead of
			//		onKeyDown event.
			//		Note: this event is only triggered in FF (not in IE/safari)
			// tags:
			//		private

			// 229 is the code produced by IE and safari while pressing keys during
			// IME input mode
			this._onKeyPress({charOrCode: 229});
		},

		//////////// INITIALIZATION METHODS ///////////////////////////////////////

		constructor: function(){
			this.query={};
			this.fetchProperties={};
		},

		postMixInProperties: function(){
			if(!this.hasDownArrow){
				this.baseClass = "dijitTextBox";
			}
			if(!this.store){
				var srcNodeRef = this.srcNodeRef;

				// if user didn't specify store, then assume there are option tags
				this.store = new dijit.form._ComboBoxDataStore(srcNodeRef);

				// if there is no value set and there is an option list, set
				// the value to the first value to be consistent with native
				// Select

				// Firefox and Safari set value
				// IE6 and Opera set selectedIndex, which is automatically set
				// by the selected attribute of an option tag
				// IE6 does not set value, Opera sets value = selectedIndex
				if(	!this.value || (
						(typeof srcNodeRef.selectedIndex == "number") &&
						srcNodeRef.selectedIndex.toString() === this.value)
				){
					var item = this.store.fetchSelectedItem();
					if(item){
						var valueField = this._getValueField();
						this.value = valueField != this.searchAttr? this.store.getValue(item, valueField) : this.labelFunc(item, this.store);
					}
				}
			}
			this.inherited(arguments);
		},

		postCreate: function(){
			// summary:
			//		Subclasses must call this method from their postCreate() methods
			// tags:
			//		protected

			// find any associated label element and add to ComboBox node.
			var label=dojo.query('label[for="'+this.id+'"]');
			if(label.length){
				label[0].id = (this.id+"_label");
				var cn=this.comboNode;
				dijit.setWaiState(cn, "labelledby", label[0].id);

			}
			this.inherited(arguments);
		},

		uninitialize: function(){
			if(this._popupWidget && !this._popupWidget._destroyed){
				this._hideResultList();
				this._popupWidget.destroy();
			}
			this.inherited(arguments);
		},

		_getMenuLabelFromItem: function(/*Item*/ item){
			var label = this.labelAttr? this.store.getValue(item, this.labelAttr) : this.labelFunc(item, this.store);
			var labelType = this.labelType;
			// If labelType is not "text" we don't want to screw any markup ot whatever.
			if(this.highlightMatch != "none" && this.labelType == "text" && this._lastInput){
				label = this.doHighlight(label, this._escapeHtml(this._lastInput));
				labelType = "html";
			}
			return {html: labelType == "html", label: label};
		},

		doHighlight: function(/*String*/label, /*String*/find){
			// summary:
			//		Highlights the string entered by the user in the menu.  By default this
			//		highlights the first occurence found. Override this method
			//		to implement your custom highlighing.
			// tags:
			//		protected

			// Add greedy when this.highlightMatch == "all"
			var modifiers = "i"+(this.highlightMatch == "all"?"g":"");
			var escapedLabel = this._escapeHtml(label);
			find = dojo.regexp.escapeString(find); // escape regexp special chars
			var ret = escapedLabel.replace(new RegExp("(^|\\s)("+ find +")", modifiers),
					'$1<span class="dijitComboBoxHighlightMatch">$2</span>');
			return ret;// returns String, (almost) valid HTML (entities encoded)
		},

		_escapeHtml: function(/*string*/str){
			// TODO Should become dojo.html.entities(), when exists use instead
			// summary:
			//		Adds escape sequences for special characters in XML: &<>"'
			str = String(str).replace(/&/gm, "&amp;").replace(/</gm, "&lt;")
				.replace(/>/gm, "&gt;").replace(/"/gm, "&quot;");
			return str; // string
		},

		open: function(){
			// summary:
			//		Opens the drop down menu.  TODO: rename to _open.
			// tags:
			//		private
			this._isShowingNow=true;
			return dijit.popup.open({
				popup: this._popupWidget,
				around: this.domNode,
				parent: this
			});
		},

		reset: function(){
			// Overrides the _FormWidget.reset().
			// Additionally reset the .item (to clean up).
			this.item = null;
			this.inherited(arguments);
		},

		labelFunc: function(/*item*/ item, /*dojo.data.store*/ store){
			// summary:
			//              Computes the label to display based on the dojo.data store item.
			// returns:
			//              The label that the ComboBox should display
			// tags:
			//              private

			// Use toString() because XMLStore returns an XMLItem whereas this
			// method is expected to return a String (#9354)
			return store.getValue(item, this.searchAttr).toString(); // String
		}
	}
);

dojo.declare(
	"dijit.form._ComboBoxMenu",
	[dijit._Widget, dijit._Templated],
	{
		// summary:
		//		Focus-less menu for internal use in `dijit.form.ComboBox`
		// tags:
		//		private

		templateString: "<ul class='dijitReset dijitMenu' dojoAttachEvent='onmousedown:_onMouseDown,onmouseup:_onMouseUp,onmouseover:_onMouseOver,onmouseout:_onMouseOut' tabIndex='-1' style='overflow: \"auto\"; overflow-x: \"hidden\";'>"
				+"<li class='dijitMenuItem dijitMenuPreviousButton' dojoAttachPoint='previousButton' waiRole='option'></li>"
				+"<li class='dijitMenuItem dijitMenuNextButton' dojoAttachPoint='nextButton' waiRole='option'></li>"
			+"</ul>",

		// _messages: Object
		//		Holds "next" and "previous" text for paging buttons on drop down
		_messages: null,

		postMixInProperties: function(){
			this._messages = dojo.i18n.getLocalization("dijit.form", "ComboBox", this.lang);
			this.inherited(arguments);
		},

		_setValueAttr: function(/*Object*/ value){
			this.value = value;
			this.onChange(value);
		},

		// stubs
		onChange: function(/*Object*/ value){
			// summary:
			//		Notifies ComboBox/FilteringSelect that user clicked an option in the drop down menu.
			//		Probably should be called onSelect.
			// tags:
			//		callback
		},
		onPage: function(/*Number*/ direction){
			// summary:
			//		Notifies ComboBox/FilteringSelect that user clicked to advance to next/previous page.
			// tags:
			//		callback
		},

		postCreate: function(){
			// fill in template with i18n messages
			this.previousButton.innerHTML = this._messages["previousMessage"];
			this.nextButton.innerHTML = this._messages["nextMessage"];
			this.inherited(arguments);
		},

		onClose: function(){
			// summary:
			//		Callback from dijit.popup code to this widget, notifying it that it closed
			// tags:
			//		private
			this._blurOptionNode();
		},

		_createOption: function(/*Object*/ item, labelFunc){
			// summary:
			//		Creates an option to appear on the popup menu subclassed by
			//		`dijit.form.FilteringSelect`.

			var labelObject = labelFunc(item);
			var menuitem = dojo.doc.createElement("li");
			dijit.setWaiRole(menuitem, "option");
			if(labelObject.html){
				menuitem.innerHTML = labelObject.label;
			}else{
				menuitem.appendChild(
					dojo.doc.createTextNode(labelObject.label)
				);
			}
			// #3250: in blank options, assign a normal height
			if(menuitem.innerHTML == ""){
				menuitem.innerHTML = "&nbsp;";
			}
			menuitem.item=item;
			return menuitem;
		},

		createOptions: function(results, dataObject, labelFunc){
			// summary:
			//		Fills in the items in the drop down list
			// results:
			//		Array of dojo.data items
			// dataObject:
			//		dojo.data store
			// labelFunc:
			//		Function to produce a label in the drop down list from a dojo.data item

			//this._dataObject=dataObject;
			//this._dataObject.onComplete=dojo.hitch(comboBox, comboBox._openResultList);
			// display "Previous . . ." button
			this.previousButton.style.display = (dataObject.start == 0) ? "none" : "";
			dojo.attr(this.previousButton, "id", this.id + "_prev");
			// create options using _createOption function defined by parent
			// ComboBox (or FilteringSelect) class
			// #2309:
			//		iterate over cache nondestructively
			dojo.forEach(results, function(item, i){
				var menuitem = this._createOption(item, labelFunc);
				menuitem.className = "dijitReset dijitMenuItem";
				dojo.attr(menuitem, "id", this.id + i);
				this.domNode.insertBefore(menuitem, this.nextButton);
			}, this);
			// display "Next . . ." button
			var displayMore = false;
			//Try to determine if we should show 'more'...
			if(dataObject._maxOptions && dataObject._maxOptions != -1){
				if((dataObject.start + dataObject.count) < dataObject._maxOptions){
					displayMore = true;
				}else if((dataObject.start + dataObject.count) > (dataObject._maxOptions - 1)){
					//Weird return from a datastore, where a start + count > maxOptions
					// implies maxOptions isn't really valid and we have to go into faking it.
					//And more or less assume more if count == results.length
					if(dataObject.count == results.length){
						displayMore = true;
					}
				}
			}else if(dataObject.count == results.length){
				//Don't know the size, so we do the best we can based off count alone.
				//So, if we have an exact match to count, assume more.
				displayMore = true;
			}

			this.nextButton.style.display = displayMore ? "" : "none";
			dojo.attr(this.nextButton,"id", this.id + "_next");
			return this.domNode.childNodes;
		},

		clearResultList: function(){
			// summary:
			//		Clears the entries in the drop down list, but of course keeps the previous and next buttons.
			while(this.domNode.childNodes.length>2){
				this.domNode.removeChild(this.domNode.childNodes[this.domNode.childNodes.length-2]);
			}
		},

		_onMouseDown: function(/*Event*/ evt){
			dojo.stopEvent(evt);
		},

		_onMouseUp: function(/*Event*/ evt){
			if(evt.target === this.domNode){
				return;
			}else if(evt.target == this.previousButton){
				this.onPage(-1);
			}else if(evt.target == this.nextButton){
				this.onPage(1);
			}else{
				var tgt = evt.target;
				// while the clicked node is inside the div
				while(!tgt.item){
					// recurse to the top
					tgt = tgt.parentNode;
				}
				this._setValueAttr({ target: tgt }, true);
			}
		},

		_onMouseOver: function(/*Event*/ evt){
			if(evt.target === this.domNode){ return; }
			var tgt = evt.target;
			if(!(tgt == this.previousButton || tgt == this.nextButton)){
				// while the clicked node is inside the div
				while(!tgt.item){
					// recurse to the top
					tgt = tgt.parentNode;
				}
			}
			this._focusOptionNode(tgt);
		},

		_onMouseOut: function(/*Event*/ evt){
			if(evt.target === this.domNode){ return; }
			this._blurOptionNode();
		},

		_focusOptionNode: function(/*DomNode*/ node){
			// summary:
			//		Does the actual highlight.
			if(this._highlighted_option != node){
				this._blurOptionNode();
				this._highlighted_option = node;
				dojo.addClass(this._highlighted_option, "dijitMenuItemSelected");
			}
		},

		_blurOptionNode: function(){
			// summary:
			//		Removes highlight on highlighted option.
			if(this._highlighted_option){
				dojo.removeClass(this._highlighted_option, "dijitMenuItemSelected");
				this._highlighted_option = null;
			}
		},

		_highlightNextOption: function(){
			// summary:
			// 		Highlight the item just below the current selection.
			// 		If nothing selected, highlight first option.

			// because each press of a button clears the menu,
			// the highlighted option sometimes becomes detached from the menu!
			// test to see if the option has a parent to see if this is the case.
			var fc = this.domNode.firstChild;
			if(!this.getHighlightedOption()){
				this._focusOptionNode(fc.style.display == "none" ? fc.nextSibling : fc);
			}else{
				var ns = this._highlighted_option.nextSibling;
				if(ns && ns.style.display != "none"){
					this._focusOptionNode(ns);
				}
			}
			// scrollIntoView is called outside of _focusOptionNode because in IE putting it inside causes the menu to scroll up on mouseover
			dijit.scrollIntoView(this._highlighted_option);
		},

		highlightFirstOption: function(){
			// summary:
			// 		Highlight the first real item in the list (not Previous Choices).
			this._focusOptionNode(this.domNode.firstChild.nextSibling);
			dijit.scrollIntoView(this._highlighted_option);
		},

		highlightLastOption: function(){
			// summary:
			// 		Highlight the last real item in the list (not More Choices).
			this._focusOptionNode(this.domNode.lastChild.previousSibling);
			dijit.scrollIntoView(this._highlighted_option);
		},

		_highlightPrevOption: function(){
			// summary:
			// 		Highlight the item just above the current selection.
			// 		If nothing selected, highlight last option (if
			// 		you select Previous and try to keep scrolling up the list).
			var lc = this.domNode.lastChild;
			if(!this.getHighlightedOption()){
				this._focusOptionNode(lc.style.display == "none" ? lc.previousSibling : lc);
			}else{
				var ps = this._highlighted_option.previousSibling;
				if(ps && ps.style.display != "none"){
					this._focusOptionNode(ps);
				}
			}
			dijit.scrollIntoView(this._highlighted_option);
		},

		_page: function(/*Boolean*/ up){
			// summary:
			//		Handles page-up and page-down keypresses

			var scrollamount = 0;
			var oldscroll = this.domNode.scrollTop;
			var height = dojo.style(this.domNode, "height");
			// if no item is highlighted, highlight the first option
			if(!this.getHighlightedOption()){
				this._highlightNextOption();
			}
			while(scrollamount<height){
				if(up){
					// stop at option 1
					if(!this.getHighlightedOption().previousSibling ||
						this._highlighted_option.previousSibling.style.display == "none"){
						break;
					}
					this._highlightPrevOption();
				}else{
					// stop at last option
					if(!this.getHighlightedOption().nextSibling ||
						this._highlighted_option.nextSibling.style.display == "none"){
						break;
					}
					this._highlightNextOption();
				}
				// going backwards
				var newscroll=this.domNode.scrollTop;
				scrollamount+=(newscroll-oldscroll)*(up ? -1:1);
				oldscroll=newscroll;
			}
		},

		pageUp: function(){
			// summary:
			//		Handles pageup keypress.
			//		TODO: just call _page directly from handleKey().
			// tags:
			//		private
			this._page(true);
		},

		pageDown: function(){
			// summary:
			//		Handles pagedown keypress.
			//		TODO: just call _page directly from handleKey().
			// tags:
			//		private
			this._page(false);
		},

		getHighlightedOption: function(){
			// summary:
			//		Returns the highlighted option.
			var ho = this._highlighted_option;
			return (ho && ho.parentNode) ? ho : null;
		},

		handleKey: function(key){
			switch(key){
				case dojo.keys.DOWN_ARROW:
					this._highlightNextOption();
					break;
				case dojo.keys.PAGE_DOWN:
					this.pageDown();
					break;
				case dojo.keys.UP_ARROW:
					this._highlightPrevOption();
					break;
				case dojo.keys.PAGE_UP:
					this.pageUp();
					break;
			}
		}
	}
);

dojo.declare(
	"dijit.form.ComboBox",
	[dijit.form.ValidationTextBox, dijit.form.ComboBoxMixin],
	{
		// summary:
		//		Auto-completing text box, and base class for dijit.form.FilteringSelect.
		//
		// description:
		//		The drop down box's values are populated from an class called
		//		a data provider, which returns a list of values based on the characters
		//		that the user has typed into the input box.
		//		If OPTION tags are used as the data provider via markup,
		//		then the OPTION tag's child text node is used as the widget value
		//		when selected.  The OPTION tag's value attribute is ignored.
		//		To set the default value when using OPTION tags, specify the selected
		//		attribute on 1 of the child OPTION tags.
		//
		//		Some of the options to the ComboBox are actually arguments to the data
		//		provider.

		_setValueAttr: function(/*String*/ value, /*Boolean?*/ priorityChange, /*String?*/ displayedValue){
			// summary:
			//		Hook so attr('value', value) works.
			// description:
			//		Sets the value of the select.
			this.item = null; // value not looked up in store
			if(!value){ value = ''; } // null translates to blank
			dijit.form.ValidationTextBox.prototype._setValueAttr.call(this, value, priorityChange, displayedValue);
		}
	}
);

dojo.declare("dijit.form._ComboBoxDataStore", null, {
	// summary:
	//		Inefficient but small data store specialized for inlined `dijit.form.ComboBox` data
	//
	// description:
	//		Provides a store for inlined data like:
	//
	//	|	<select>
	//	|		<option value="AL">Alabama</option>
	//	|		...
	//
	//		Actually. just implements the subset of dojo.data.Read/Notification
	//		needed for ComboBox and FilteringSelect to work.
	//
	//		Note that an item is just a pointer to the <option> DomNode.

	constructor: function( /*DomNode*/ root){
		this.root = root;

		dojo.query("> option", root).forEach(function(node){
			//	TODO: this was added in #3858 but unclear why/if it's needed;  doesn't seem to be.
			//	If it is needed then can we just hide the select itself instead?
			//node.style.display="none";
			node.innerHTML = dojo.trim(node.innerHTML);
		});

	},

	getValue: function(	/* item */ item,
						/* attribute-name-string */ attribute,
						/* value? */ defaultValue){
		return (attribute == "value") ? item.value : (item.innerText || item.textContent || '');
	},

	isItemLoaded: function(/* anything */ something){
		return true;
	},

	getFeatures: function(){
		return {"dojo.data.api.Read": true, "dojo.data.api.Identity": true};
	},

	_fetchItems: function(	/* Object */ args,
							/* Function */ findCallback,
							/* Function */ errorCallback){
		// summary:
		//		See dojo.data.util.simpleFetch.fetch()
		if(!args.query){ args.query = {}; }
		if(!args.query.name){ args.query.name = ""; }
		if(!args.queryOptions){ args.queryOptions = {}; }
		var matcher = dojo.data.util.filter.patternToRegExp(args.query.name, args.queryOptions.ignoreCase),
			items = dojo.query("> option", this.root).filter(function(option){
				return (option.innerText || option.textContent || '').match(matcher);
			} );
		if(args.sort){
			items.sort(dojo.data.util.sorter.createSortFunction(args.sort, this));
		}
		findCallback(items, args);
	},

	close: function(/*dojo.data.api.Request || args || null */ request){
		return;
	},

	getLabel: function(/* item */ item){
		return item.innerHTML;
	},

	getIdentity: function(/* item */ item){
		return dojo.attr(item, "value");
	},

	fetchItemByIdentity: function(/* Object */ args){
		// summary:
		//		Given the identity of an item, this method returns the item that has
		//		that identity through the onItem callback.
		//		Refer to dojo.data.api.Identity.fetchItemByIdentity() for more details.
		//
		// description:
		//		Given arguments like:
		//
		//	|		{identity: "CA", onItem: function(item){...}
		//
		//		Call `onItem()` with the DOM node `<option value="CA">California</option>`
		var item = dojo.query("option[value='" + args.identity + "']", this.root)[0];
		args.onItem(item);
	},

	fetchSelectedItem: function(){
		// summary:
		//		Get the option marked as selected, like `<option selected>`.
		//		Not part of dojo.data API.
		var root = this.root,
			si = root.selectedIndex;
		return dojo.query("> option:nth-child(" +
			(si != -1 ? si+1 : 1) + ")",
			root)[0];	// dojo.data.Item
	}
});
//Mix in the simple fetch implementation to this class.
dojo.extend(dijit.form._ComboBoxDataStore,dojo.data.util.simpleFetch);

}

if(!dojo._hasResource["epages.widget.ComboBox"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.ComboBox"] = true;
dojo.provide("epages.widget.ComboBox");


dojo.declare(
	"epages.widget._ComboBoxMenu",
	dijit.form._ComboBoxMenu,
	{
		templateString: "<ul class='dijitReset dijitMenu dijitTagEditor' style='background-color:#FFF;' dojoAttachEvent='onmousedown:_onMouseDown,onmouseup:_onMouseUp,onmouseover:_onMouseOver,onmouseout:_onMouseOut' tabIndex='-1' style='overflow: \"auto\"; overflow-x: \"hidden\";z-index:200000000;'>"
			+"<li class='dijitMenuPreviousButton' dojoAttachPoint='previousButton' waiRole='option'></li>"
			+"<li class='dijitMenuNextButton' dojoAttachPoint='nextButton' waiRole='option'></li>"
		+"</ul>"
	}
);
dojo.declare(
	"epages.widget.ComboBox",
	[dijit.form.ComboBox],
	{
    // summary:
		//		Auto-completing text box, and base class for dijit.form.FilteringSelect.
		//
		// description:
		//		The drop down box's values are populated from an class called
		//		a data provider, which returns a list of values based on the characters
		//		that the user has typed into the input box.
		//		If OPTION tags are used as the data provider via markup,
		//		then the OPTION tag's child text node is used as the widget value
		//		when selected.  The OPTION tag's value attribute is ignored.
		//		To set the default value when using OPTION tags, specify the selected
		//		attribute on 1 of the child OPTION tags.
		//
		//		Some of the options to the ComboBox are actually arguments to the data
		//		provider.

		// autoComplete: Boolean
		//		If user types in a partial string, and then tab out of the `<input>` box,
		//		automatically copy the first entry displayed in the drop down list to
		//		the `<input>` field
		autoComplete: true,

		// highlightMatch: String
		// 		One of: "first", "all" or "none".
		//
		//		If the ComboBox/FilteringSelect opens with the search results and the searched
		//		string can be found, it will be highlighted.  If set to "all"
		//		then will probably want to change `queryExpr` parameter to '*${0}*'
		//
		//		Highlighting is only performed when `labelType` is "text", so as to not
		//		interfere with any HTML markup an HTML label might contain.
		highlightMatch: "none",

		// ignoreCase: Boolean
		//		Set true if the ComboBox/FilteringSelect should ignore case when matching possible items
		ignoreCase: true,

		// hasDownArrow: [const] Boolean
		//		Set this textbox to have a down arrow button, to display the drop down list.
		//		Defaults to true.
		hasDownArrow: true,

		templateString: dojo.cache("epages.widget", "templates/ComboBox.html", "<div id=\"widget_${id}\" style=\"${style};\"\n\tdojoAttachEvent=\"onmouseenter:_onMouse,onmouseleave:_onMouse,onmousedown:_onMouse\" dojoAttachPoint=\"comboNode\" waiRole=\"combobox\" tabIndex=\"-1\"\n\t><div style=\"overflow:hidden;\"\n\t\t><div class='dijitReset dijitRight dijitButtonNode dijitArrowButton dijitDownArrowButton'\n\t\t\tdojoAttachPoint=\"downArrowNode\" waiRole=\"presentation\"\n\t\t\tdojoAttachEvent=\"onmousedown:_onArrowMouseDown,onmouseup:_onMouse,onmouseenter:_onMouse,onmouseleave:_onMouse\"\n\t\t\t><div class=\"dijitButtonCombobox\">&#9660;</div\n\t\t></div\n\t\t><div class=\"dijitReset dijitInputField\"\n\t\t\t><input ${nameAttrSetting} dojoType=\"epages.widget.FormElement\"  type=\"text\" autocomplete=\"off\" class='dijitReset'\n\t\t\tdojoAttachEvent=\"onkeypress:_onKeyPress,compositionend\"\n\t\t\tdojoAttachPoint=\"textbox,focusNode\" waiRole=\"textbox\" waiState=\"haspopup-true,autocomplete-list\"\n\t\t/></div\n\t></div\n></div>\n"),
	
		baseClass : "",

		_setValueAttr: function(/*String*/ value, /*Boolean?*/ priorityChange, /*String?*/ displayedValue){
			// summary:
			//		Hook so attr('value', value) works.
			// description:
			//		Sets the value of the select.
			this.item = null; // value not looked up in store
			if(!value){ value = ''; } // null translates to blank
			dijit.form.ValidationTextBox.prototype._setValueAttr.call(this, value, priorityChange, displayedValue);
		},
		
		_startSearch: function(/*String*/ key){
			if(!this._popupWidget){
				var popupId = this.id + "_popup";
				this._popupWidget = new epages.widget._ComboBoxMenu({
					onChange: dojo.hitch(this, this._selectOption),
					id: popupId
				});
				dijit.removeWaiState(this.focusNode,"activedescendant");
				dijit.setWaiState(this.textbox,"owns",popupId); // associate popup with textbox
			}
			this.inherited("_startSearch", arguments);
		},
		open: function(){
			// summary:
			//		Opens the drop down menu.  TODO: rename to _open.
			// tags:
			//		private
			this._isShowingNow=true;
			var best = dijit.popup.open({
				popup: this._popupWidget,
				around: this.domNode,
				parent: this
			});
			if(epages.zIndex) {
				this._popupWidget.domNode.parentNode.style.zIndex=epages.zIndex;	// set z-index of wrapper div
				epages.zIndex+=1;
			}
			return best;
		}
	}
);

}

if(!dojo._hasResource["epages.widget.InfoText"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.InfoText"] = true;
dojo.provide("epages.widget.InfoText");



dojo.declare("epages.widget.InfoText",
	[dijit._Widget],
	{
		/**
		 * public properties
		 */
		readMoreText  : "",							// read more link text
		length        : "",							// number of chars to be displayed as widget param

		/**
		 * nodes
		 */
		 readMoreNode : undefined,

		/**
		 * private properties
		 */
		_textContent   : undefined,			// original text content
		_htmlContent   : undefined,			// original html Content
		_DEFAULT_LENGTH: 130,						// max number of chars to be displayed

		/**
		 * widget life cycle
		 */
		postCreate: function() {
			var length = parseInt(this.length) || this._DEFAULT_LENGTH;

			// save original text content
			this._htmlContent = this.domNode.innerHTML;
			this._textContent = (this.domNode.textContent) ? this.domNode.textContent : this.domNode.innerText;
			this.domNode.className = "InfoText";
			if(this._textContent.length - Math.round(length / 4) < length) {
				// we don't need the "read more" link if there are only some chars about to be sliced
				this.expand();
			}else {
				this.domNode.innerHTML = epages.format.slice(this._textContent, length, false)+"<br />";
				this.readMoreNode = document.createElement("A");
				this.readMoreNode.innerHTML = this.readMoreText;
				this.readMoreNode.className="NormalFontWeight";
				this.domNode.appendChild(this.readMoreNode);

				this.connect(this.readMoreNode, "click" , "expand");
			}
		},

		expand: function() {
		//summary: show the complete text
			this.domNode.innerHTML = this._htmlContent;
		}
});

}

if(!dojo._hasResource["epages.widget.WizardController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.WizardController"] = true;
/*
	Copyright (c) 2006-2010, ePages GmbH
	All Rights Reserved.

	epages.widget.LocalizedWidget $Revision: 1.37 $
*/
dojo.provide("epages.widget.WizardController");









dojo.declare("epages.widget.WizardController",[epages.widget.LocalizedWidget],{
		/**
		* public properties
		*/
		currentLanguageId : undefined,   // integer - id of current language
		controllerName    : '',          // string - name of controller
		url               : '?',         // string - request url
		saveOnNext        : false,       // boolean - flag that indicates weather the wizards saves after every step or not
		showQuickFinish   : false,       // boolean - flag that indicates weather the show link to finish page will be displayed or not
		debugMode         : false,       // boolean - flag to run the wizard in debug mode
		finishButtonLabel : "",          // string - label of finish button node
		finishRedirectURL : "",          // string - this url is called after the finish step
		cancelRedirectURL : "",          // string - this url is called after clicking the cancel button

		/**
		* private properties
		*/
		_steps                  : undefined,  // array - array with step data objects
		_objects                : undefined,  // hash - contains epages objects: <objectId> : { saveValues: [], saveNames: [], changeActions: []) }
		_jsonHandler            : undefined,  // epages.io.Json - communication
		_initialized            : undefined,  // boolean - you can not add steps after the wizard is initialized
		_activeStep             : undefined,  // integer - index of current step
		_stepNavigation         : undefined,  // array - array with navigation  { node : stepNode, bubbleNode : bubbleNode, stepNumber : i }
		_defaultChangeAction    : 'Save',     // string - default save action for objects (_objects)
		_stepStates             : [
			'Active','Disabled','Done'
		],                                    // array - navigation states (css classes)
		_hideBubbleTimeout      : undefined,  // timeout reference
		HIDEBUBBLE_TIMEOUT      : 800,        // integer - navigation bubble timeout value in ms

		/**
		* dojo widget properties
		*/
		templateString:"<div class=\"WizardController\">\n  <div class=\"Overlay\"></div>\n  <div class=\"SpaceContainer\">\n    <div>\n      <div class=\"BorderRadius12Box\">\n        <div class=\"Assistant\">\n          <form name=\"WizzardControllerForm\">\n              <div class=\"dijitDialog ModalDialog\">\n                <div class=\"dijitDialogTitleBar\">\n                  <span dojoAttachPoint=\"closeButtonNode\" dojoAttachEvent=\"onclick: _onCancel\"style=\"display:none\"class=\"dijitDialogCloseIcon\">\n                    <span class=\"closeText\">close</span>\n                  </span>\n                  <div class=\"StepNavigation EnableHover\" dojoAttachPoint=\"StepNavigationNode\">\n                    <a dojoAttachPoint=\"QuickFinish\" class=\"DialogAction Bold\">{QuickFinish}</a> | <span>{Step}</span>\n                  </div>\n                  <div dojoAttachPoint=\"StepNavigationBubble\"  dojoType=\"epages.widget.Bubble\"></div>\n                </div>\n                <div dojoAttachPoint=\"ContainerNode\" class=\"AssistantContainer ShowAllSteps\">\n                  <div dojoAttachPoint=\"ContentPlaceHolder\" style=\"height:450px;\"></div>\n                </div>\n                <div dojoAttachPoint=\"ButtonBarNode\" class=\"ButtonBar LayerButtonBar\">\n                  <div dojoAttachPoint=\"BackButton\" dojotype=\"epages.widget.Button\" name=\"Back\" class=\"FloatLeft HideElement\">{Back}</div>\n                  <div dojoAttachPoint=\"NextButton\" dojotype=\"epages.widget.Button\" name=\"Next\" class=\"FloatRight\">{Next}</div>\n                  <div dojoAttachPoint=\"SaveButton\" dojotype=\"epages.widget.Button\" name=\"Save\" class=\"FloatRight HideElement\">${finishButtonLabel}</div>\n                  <div class=\"ClearBoth\"></div>\n                </div>\n              </div>\n          </form>\n        </div>\n        <div class=\"HideElement\" dojoAttachPoint=\"BubbleContentNode\"></div>\n      </div>\n    </div>\n  </div>\n</div>\n",
		translationName  : dojo.moduleUrl('epages.widget','templates/translation'),
		widgetsInTemplate:true,

		postMixInProperties: function(){
			//summary: initialize all necessary objects and arrays, convert flags to real boolean
			this.inherited("postMixInProperties", arguments);
			if(this.finishButtonLabel == "") {
				this.finishButtonLabel = this.translate("Finish");
			}
			this._jsonHandler = new epages.io.Json();
			this._steps = [];
			this._objects = undefined;
			this._stepNavigation = [];
			this._initialized = false;
			this.showQuickFinish = epages.string.toBoolean(this.showQuickFinish);
			this.saveOnNext = epages.string.toBoolean(this.saveOnNext);
			//if(epages.vars.DebugLevel && epages.vars.DebugLevel != 0){
				this.debugMode = true;
			//}
			if(epages.Browser.engine == "MSIE") {
				var htmlTag = document.getElementsByTagName("html")[0];
				htmlTag.style.overflow="visible";
			}
		},

		postCreate: function(){
			this.inherited("postCreate", arguments);
			if(this.cancelRedirectURL) {
				this.closeButtonNode.style.display="";
			}
		},

		startup: function(){
			//summary: make all event connects and connect to Switch to Edit Mode topic
			this.inherited("startup", arguments);

			dojo.body().appendChild(this.domNode);

			//attach events
			//catch all events that happen inside the domNode
			this.connect(this.domNode,'onclick', '_onDomNodeEvent');
			this.connect(this.domNode,'onkeyup', '_onDomNodeEvent');
			this.connect(this.domNode,'onchange', '_onDomNodeEvent');
			//connect all buttons
			this.connect(this.NextButton.domNode,'onclick', '_onNextButtonClick');
			this.connect(this.BackButton.domNode,'onclick', '_onBackButtonClick');
			this.connect(this.SaveButton.domNode,'onclick', '_onSaveButtonClick');

			// bubble events
			this.connect(this.StepNavigationBubble.domNode,'onmouseleave', '_hideStepNavigationBubble');      //hide stepNavigationBubble on mouse leave of the bubble
			this.connect(this.StepNavigationNode, 'onmouseleave', '_hideStepNavigationBubble');               //hide stepNavigationBubble on mouse leave of the bubble
			this.connect(this.StepNavigationBubble.domNode,'onmouseenter', '_dontHideStepNavigationBubble');  //clear timeout

			if(this.showQuickFinish){
				this.connect(this.QuickFinish,'onclick', '_onQuickFinishClick');
			}
			else{
				dojo.addClass(this.QuickFinish,'HideElement');
			}
			//do subscribes
			dojo.subscribe(this.id+'/SwitchToEditMode',this,'_onSwitchToEditMode');
			dojo.subscribe(this.id+'/switchToStep',this,'_onSwitchToStep');


		},

		start: function(){
			//summary: this function has to be called when all steps are added with publishthe add steps method
			//this function starts the wizard and shows the first step
			//steps inside the _steps Array are processed in there normal order
			this._toggleLoaderOverlay(true);
			this._initialized = true;
			this._activeStep = 0;
			this._initialize();
			//load template of fist step
			this._loadStep(0);
		},

		addStep: function(stepData){
			//summary: add step to wizard with this function is only working before wizard is started
			//example:
			//	|myWizard.addStep({
			//	|		Name            : '{Video}',     - required
			//	|		ViewAction      : 'JSONSnippet', - required
			//	|		TemplateAction  : 'MBO-ViewBookingsystemWizardSteps', - required
			//	|		TemplateName    : 'Content-Video', - required
			//	|		ObjectID        : '#Shop.ID', - required
			//	|		NotInNavigation : true, - optional
			//	|		NoPreload       : true - optional
			//	|		NoButtons       : true, - optional
			//	|		ShowAllStepsOnFinish : true, - optional
			//	|		IsFinishStep    : false - optional
			//	|});
			if(stepData){
				if(this._initialized){
					console.warn(this.id,'unable to add step wizard is already started');
					return;
				}
				//every step is disabled on start
				stepData.state = "Disabled";
				this._steps.push(stepData);
			}
		},

		_preloadSteps:function(){
			//summary: load template of every defined step only loads one step at the same time no multiple simultan loading
			//checks if step is loaded, step is loaded when template is set
			//load next step where template is not defined
			for( var i=0,iLength=this._steps.length ; i<iLength ; i++ ){
				var stepData = this._steps[i];
				if(stepData.template == undefined && !stepData.errorOnLoad){
					this._loadStep(i);
					break;
				}
			}
		},

		_loadStep: function(stepNumber){
			//summary: load data of step defined by given stepNumber with async json request
			//when step is loaded call redStepResponse with given data
			//loads given step asynchronous from server
			var stepData = this._steps[stepNumber];
			stepData.TemplateLanguageID = this.currentLanguageId;
			if(epages.vars[this.id+'TemplateObjectID']) {
				stepData.TemplateObjectID = epages.vars[this.id+'TemplateObjectID'];
			}
			if(stepData && stepData.ObjectID) {
				this._jsonHandler.loadAsync(this.url,dojo.hitch(this,function(response){
					this._readStepResponse(response,stepNumber);
				}),stepData);
			} else {
				this._showErrorMessage(this.translate('WizardStepError'),this.translate('WizardStepErrorDesciption'));
			}
		},

		_loadStepSync: function(stepNumber){
			//summary: loads given step synchronous from server
			//is needed when preloading is disabled and next step has to be loaded on next Button click
			//checks if epages.vars[this.id+'TemplateObjectID'] is defined and adds it to request is
			//neccassary if steps are influenced by each other
			var stepData = this._steps[stepNumber];
			stepData.TemplateLanguageID = this.currentLanguageId;
			if(epages.vars[this.id+'TemplateObjectID']) {
				stepData.TemplateObjectID = epages.vars[this.id+'TemplateObjectID'];
			}
			if(stepData && stepData.ObjectID) {
				var response = this._jsonHandler.loadSync(this.url,stepData);
				this._readStepResponse(response,stepNumber);
			}
		},

		_readStepResponse: function(response,stepNumber){
			//summary: read response from server and load next step if preloading is enabled
			var stepData = this._steps[stepNumber];
			//check if step response is okay
			if(response && response.data && response.data.snippet){
				stepData.template = response.data.snippet;

				if(stepNumber == this._activeStep){
					//build step and step navigation if activeStep was loaded, happens on first step
					stepData.state = 'Active';
					this._changeNavigationNodeState(stepNumber,'Active');
					this._buildStep(stepNumber);
				}
			}
			else{
				//set step on error to avoid preload step from loading it again and again
				stepData.errorOnLoad = true;
			}
			if(stepData){
				//is preload is enabled load next step
				if(!stepData.NoPreload){
					this._preloadSteps();
				}
			}
		},

		_buildStep: function(stepNumber){
			//summary: build template of given step and add it to the container
			//step with flag IsFinishStep is added as first element on container for summary mode of this step
			var stepData = this._steps[stepNumber];
			//check if template ist loaded if not load template
			if(stepData.template && stepData.templateNode == undefined){
				//dojo.addClass(this.ContainerNode, "HideElement");
				//create step node and insert loaded template
				var stepNode = document.createElement('div');
				dojo.addClass(stepNode,"Step");
				dojo.addClass(stepNode,"HideElement");
				stepNode.id = stepData.TemplateName;

				stepData.template = stepData.template.replace(/<!--.*-->/g, "");		// remove comments from pagetype
				stepNode.innerHTML = stepData.template;
				
				//finish step has to be first step in container for design reasons
				if(stepData.IsFinishStep){
					this.ContainerNode.insertBefore(stepNode,this.ContainerNode.firstChild);
				}
				else{
					this.ContainerNode.appendChild(stepNode);
				}
				// no need for extra eval of the script tags on Fx, but on all other browsers
				if(epages.Browser.engine != "Gecko" || (epages.Browser.engine == "Gecko" && epages.Browser.version >= 4)) {
					//evalute script-tags inside content
					var scripts = stepNode.getElementsByTagName('script');
					for( var i=0,iLength=scripts.length ; i<iLength ; i++ ) {
						window.eval(scripts[i].innerHTML);
					}
				}
				
				//start dojo parser to parse all dojo widgets inside the template
				dojo.parser.parse(stepNode);
				stepData.templateNode = stepNode;
				//dojo.removeClass(this.ContainerNode, "HideElement");
			}
			//show all steps in SummaryMode if FinishStep is shown
			dojo.addClass(this.ContentPlaceHolder,"HideElement");
			// unshow any visible loader overlay
			this._toggleLoaderOverlay(false);
			for( var i=0,iLength=this._steps.length ; i<iLength ; i++ ){
				var currentStep = this._steps[i];
				if(stepData.IsFinishStep && (stepData.ShowAllStepsOnFinish === undefined || stepData.ShowAllStepsOnFinish)){
					if(currentStep && currentStep.templateNode && currentStep != stepData){
						dojo.addClass(currentStep.templateNode,'SummaryMode');
						dojo.removeClass(currentStep.templateNode,"HideElement");
					}
				}
				else{
					if(currentStep.templateNode){
						dojo.removeClass(currentStep.templateNode,'SummaryMode');
						dojo.addClass(currentStep.templateNode,"HideElement");
					}
				}
			}
			if(stepData.template && stepData.templateNode){
				dojo.removeClass(stepData.templateNode,"HideElement");
			}
		},

		_closeLastInlineTinyMCE:function(){
			//summary: close last instance of inline tinyMCE
			//Inline tinyMCE is still not working correct
			//TODO: still in progress
			if(epages.vars.currentInlineTinyMCE){
				tinyMCE.execCommand('mceRemoveControl', true,epages.vars.currentInlineTinyMCE);
			}
		},

		_getSaveData:function(stepNumber){
			//summary: this function collects all data from the given step template which has to be send to the server
			//input for saving must have a name attribute like name="ObjectId:attributeAlias:LanguageId"
			//languageId ist optional
			//this function although collects hidden inputs with ChangeActions they must have name="ObjectId:ChangeAction"
			var node;
			if(typeof stepNumber != "undefined"){
				if(!this._steps[stepNumber] && !this._steps[stepNumber].templateNode){
					return;
				}
				node = this._steps[stepNumber].templateNode;

				// possibility to add a hidden input to the step template which tells the wizard NOT to perform a save action for the step
				var doNotSaveOnNextNode = $("DoNotSaveOnNext_" + this._steps[stepNumber].TemplateName);
				if(doNotSaveOnNextNode && doNotSaveOnNextNode.value == "true") {
					return;
				}
			}
			else{
				node = this.ContainerNode;
			}
			//get all named elemnts with name like ObjectId:attributeAlias:LanguageId or ObjectId:attributeAlias
			var allNamedElements = dojo.query("[name*=':']", node);
			if(!this._objects) {
				this._objects = {};
			}
			for( var i=0,iLength=allNamedElements.length ; i<iLength ; i++ ){
				var elm = allNamedElements[i];
				//ignore disabled inputs
				if(elm.disabled && elm.disabled == true){
					continue;
				}
				//special treatment for radio buttons
				if(dojo.hasClass(elm,'Radio') && elm.checked == false){
					continue;
				}
				//split name into objectId, atrributeAlias and LanguageID - optional
				if(elm.name){
					var nameValues = elm.name.split(':');
				}
				else if(elm.id){
					var nameValues = elm.id.split(':');
				}
				else{
					return;
				}

				var objectId = nameValues[0];
				if(isNaN(objectId)) {
					// only perform object ids ..
					continue;
				}

				var attributeAlias = nameValues[1];
				var languageId = nameValues[2];
				var languageFieldName = nameValues[3];

				var currentValue = this._objects[objectId] ? this._objects[objectId] : {};
				if(!currentValue.saveNames){
					currentValue.saveNames = [];
				}
				if(!currentValue.saveValues){
					currentValue.saveValues = [];
				}
				if(objectId && attributeAlias){
					// hack for multiple select: if elm is a widget of class type dijit.form.MultiSelect
					if(dijit.registry.byId(elm.id) && $$(elm.id).declaredClass == "dijit.form.MultiSelect") {
						var multiSelectValues = $$(elm.id).attr('value');
						// add all selected values seperately
						if(multiSelectValues && multiSelectValues.length > 0) {
							for( var j=0,jLength=multiSelectValues.length ; j<jLength ; j++ ) {
								currentValue.saveNames.push(attributeAlias);
								currentValue.saveValues.push(multiSelectValues[j]);
							}
						}
					}
					else if(elm.innerHTML && !elm.value){
						currentValue.saveNames.push(attributeAlias);
						currentValue.saveValues.push(elm.innerHTML);
						if(languageId){
							//if object has languages we need other methode to write them
							currentValue.saveNames.push(languageFieldName ? languageFieldName : 'LanguageID');
							currentValue.saveValues.push(languageId);
						}
					}
					else {
						currentValue.saveNames.push(attributeAlias);
						currentValue.saveValues.push(elm.value);
						if(languageId){
							//if object has languages we need other methode to write them
							currentValue.saveNames.push(languageFieldName ? languageFieldName : 'LanguageID');
							currentValue.saveValues.push(languageId);
						}
					}
				}
				this._objects[objectId] = currentValue;
			}
			//get all inputs with name ChangeAction, they must have objectId in name and changeAction name in value
			var allChangeActions = dojo.query("[name='ChangeAction']", node);
			for( var j=0,jLength=allChangeActions.length ; j<jLength ; j++ ){
				var currentAction = allChangeActions[j];
				var splitValues = currentAction.value.split(':');
				if(splitValues.length > 0){
					objectId = splitValues[0];
					var actionName = splitValues[1];
					currentValue = this._objects[objectId] ? this._objects[objectId] : {};
					if(!currentValue.changeActions){
						currentValue.changeActions = [];
					}
					currentValue.changeActions.push(actionName);
				}
				this._objects[objectId] = currentValue;
			}
		},

		saveData:function(){
			//summary: save all data that is inside _objects to the server
			//after successfull save _objects get cleared to allow override of data if user goes back to an already saved step
			//when debugMode is true than saveData sends every object in a own request to the server
			if(!this._objects) {
				return true;
			}
			var result;
			if(!this.debugMode){
				var params = {};
				params['ViewAction'] = 'JSONViewResponse';
				params['ObjectID'] = [];
				params['Value'] = [];
				params['ChangeAction'] = [];
			}
			//add parameters of every object to json request
			for(var key in this._objects){
				if(isNaN(dojo.number.parse(key))) {
					// only valid objectids..
					continue;
				}
				if(this.debugMode){
					var params = {};
					params['ViewAction'] = 'JSONViewResponse';
					params['ObjectID'] = [];
					params['Value'] = [];
					params['ChangeAction'] = [];
				}
				var currentObject = this._objects[key];
				if(!currentObject.saveNames){
					continue;
				}
				for( var j=0,jLength=currentObject.saveNames.length ; j<jLength ; j++ ){
					if(!params[currentObject.saveNames[j]]){
						params[currentObject.saveNames[j]] = [];
					}
					params[currentObject.saveNames[j]].push(currentObject.saveValues[j]);
				}
				//add changeActions for Object
				if(currentObject.changeActions){
					for( var i=0,iLength=currentObject.changeActions.length ; i<iLength ; i++ ){
						params['ObjectID'].push(key);
						params['ChangeAction'].push(currentObject.changeActions[i]);
					}
				}
				else{
					params['ObjectID'].push(key);
					params['ChangeAction'].push(this._defaultChangeAction);
				}
				if(this.debugMode){
					result = this._jsonHandler.loadSync(this.url,params);
				}
			}
			if(!this.debugMode){
				result = this._jsonHandler.loadSync(this.url,params);
			}
			//clear _objects on error to but show error to customer so that he can correct it and save again
			if(result && result.error && result.error.data){
				console.warn("error in wizardcontroller saveData, result=", result);
				this._showErrors(result.error.data.Errors);
				this._objects = undefined;
				return false;
			}
			else{
				//if everything was saved we can clear the saveData object
				if(result && result.data){
					dojo.publish(this.id+'/saveFinished', [ result.data ]);
				}
				else{
					dojo.publish(this.id+'/saveFinished', []);
				}
				this._objects = undefined;
				return true;
			}
		},

		_showErrors:function(errors){
			//summary: show given errors to customer with an error message
			for( var i=0,iLength=errors.length ; i<iLength ; i++ ){
				var currentError = errors[i];
				if(currentError.LoopName && currentError.Index && currentError.Name){
					var errorClass = currentError.LoopName + currentError.Index;
					for( var j=0,jLength=this._steps.length ; j<jLength ; j++ ){
						var stepData = this._steps[j];
						if(stepData.templateNode){
							var errorNodeContainer = dojo.query("."+errorClass, stepData.templateNode);
							if(errorNodeContainer && errorNodeContainer.length == 1){
								errorNodeContainer = errorNodeContainer[0];
								var errorNode = dojo.query("[name*="+currentError.Name+"]", errorNodeContainer);
								if(errorNode && errorNode.length == 1){
									dojo.addClass(errorNode[0],'DialogError');
									if(this._steps[this._activeStep].IsFinishStep){
										dojo.removeClass(stepData.templateNode, "SummaryMode");
										dojo.addClass(stepData.templateNode, "EditMode");
									}
									this._showErrorMessage(this.translate('WizardSaveError'),this.translate('WizardSaveErrorDesciption'));
								}
							}
						}
					}
				}
				else if(currentError.Reason && currentError.Reason == 'FeatureMaxValueReached'){
					var me = this;
					dojo.publish("uimessage/show", [ "", 'The maximum number of services for this website type has been reached.', 'Dialog', {
					titleBar: this._steps[this._activeStep].Name,
					typeClass: 'Warning',
					buttons: [{
						label: '{Close}',
						cssClass: 'Active',
						onclick: function() {
							me._closeWizard();
							this._modalDialogWidget.hide();
						}
					}]
				}
				]);
				}
				else if(currentError.Reason && currentError.Reason == 'OBJECT_EXISTS'){
					dojo.publish("uimessage/show", [ "", this.translate('ServiceNoExists'), 'Dialog', {
						titleBar: this._steps[this._activeStep].Name,
						typeClass: 'Warning'
					}]);
				}
				else if(currentError.Reason && currentError.Message){
					dojo.publish("uimessage/show", [ "", currentError.Message, 'Dialog', {
						titleBar: this._steps[this._activeStep].Name,
						typeClass: 'Warning'
					}]);
				}
				else if(currentError.Name){
					for( var j=0,jLength=this._steps.length ; j<jLength ; j++ ){
						var stepData = this._steps[j];
						if(stepData.templateNode){
								var errorNode = dojo.query("[name*="+currentError.Name+"]", stepData.templateNode);
								if(errorNode && errorNode.length == 1){
									dojo.addClass(errorNode[0],'DialogError');
									if(this._steps[this._activeStep].IsFinishStep){
										dojo.removeClass(stepData.templateNode, "SummaryMode");
										dojo.addClass(stepData.templateNode, "EditMode");
									}
								}
							}
						}
				}
			}
			// remove any loader overlays
			this._toggleLoaderOverlay(false);
		},

		activateStep: function(nextStepNumber){
			//summary: activate given step
			//change to next step is only possible if next step is already loaded
			var nextStepData = this._steps[nextStepNumber];
			if(nextStepData){
				//check if next step is loaded, if not load it sync to avoid error while user have to wait
				if(!nextStepData.template){
					this._loadStepSync(nextStepNumber);
				}
				//update stepNavigation
				this._changeNavigationNodeState(this._activeStep,'Done');
				this._changeNavigationNodeState(nextStepNumber,'Active');
				nextStepData.state = 'Active';
				this._activeStep = nextStepNumber;
				//check if there is a step before the step we now want to activeate
				//disable all buttons if NoButtons flag is set used for last step
				if(nextStepData.NoButtons){
					dojo.addClass(this.ButtonBarNode,'HideElement');
					dojo.addClass(this.StepNavigationNode,'HideElement');
					dojo.addClass(this.QuickFinish,'HideElement');
				}
				else{
					dojo.removeClass(this.ButtonBarNode,'HideElement');
					dojo.removeClass(this.StepNavigationNode,'HideElement');
					if(this.showQuickFinish){
						dojo.removeClass(this.QuickFinish,'HideElement');
					}
				}
				//on IsFinishStep we need the save button not the next button
				if(nextStepData.IsFinishStep){
					this.NextButton.hide();
					this.SaveButton.show();
					dojo.addClass(this.QuickFinish,'HideElement');
				}
				else{
					this.NextButton.show();
					this.SaveButton.hide();
					if(this.showQuickFinish){
						dojo.removeClass(this.QuickFinish,'HideElement');
					}
				}
				//hide BackButton if next step is first step
				if(nextStepNumber == 0){
					this.BackButton.hide();
				}
				else{
					this.BackButton.show();
				}

				var stepdata = this._steps[this._activeStep];
				var templateName= stepdata['TemplateName'];

				//start building next step
				this._buildStep(nextStepNumber);

				// publish step message by templateName
				dojo.publish(this.id+'/stepActivated/'+templateName, []);

				//publish general step change message
				dojo.publish(this.id+'/activateStep', [ {
						'stepNumber' : this._activeStep,
						'stepData' : this._steps[this._activeStep]
				}]);

				if(epages.Browser.engine == "MSIE") {
					var domNode = this.domNode;
					dojo.removeClass(domNode, "WizardController");
					window.setTimeout(function() {
						dojo.addClass(domNode, "WizardController");
					}, 1);
				}

			}
			else{
				//show error to user if we had problems
				this._showErrorMessage(this.translate('WizardStepError'),this.translate('WizardStepErrorDesciption'));
			}
		},

		_calculateRestrictorOverlay : function(){
			var suspendPosition = new epages.html.Element(this.ContainerNode).getAbsolutePosition(dojo.body());
			var aw  = dojo.style(this.ContainerNode,"marginLeft");
					aw += dojo.style(this.ContainerNode,"paddingLeft");
			var l = suspendPosition.x - aw;
					aw += dojo.style(this.ContainerNode,"marginRight");
					aw += dojo.style(this.ContainerNode,"paddingRight");
			var w = this.ContainerNode.offsetWidth + aw;

			var ah = dojo.style(this.ContainerNode,"marginTop");
					ah += dojo.style(this.ContainerNode,"paddingTop");
			var t = suspendPosition.y - ah;
					ah += dojo.style(this.ContainerNode,"marginBottom");
					ah += dojo.style(this.ContainerNode,"paddingBottom");
			var h = this.ContainerNode.offsetHeight + ah;

			return {
				Width  : w,
				Height : h,
				Left   : l,
				Top    : t
			};
		},
		_toggleLoaderOverlay : function(/*boolean*/toggleState){
			if(toggleState){
				dojo.publish("interactionRestrictor/suspend", ["ContainerNodeLoading", this.ContainerNode,false,this._calculateRestrictorOverlay()]);
			} else {
				dojo.publish("interactionRestrictor/permit", ["ContainerNodeLoading"]);
			}
		},
		_onNextButtonClick: function(){
			//summary: got to next step and save if saveOnNext is defined
			dojo.publish(this.id+'/nextButtonClick', []);
			this._toggleLoaderOverlay(true);
			this._closeLastInlineTinyMCE();
			if(this.saveOnNext){
			this._getSaveData(this._activeStep);
				if(!this.saveData()) {
					return;
				}
			}
			this.activateStep(this._activeStep + 1);
		},

		_onBackButtonClick: function(){
			//summary: go to prevoius step
			this._toggleLoaderOverlay(true);
			this.activateStep(this._activeStep - 1);
		},

		_onSaveButtonClick:function(){
			//summary: collect save data and send it to the server
			//go to last step this is always the quickStart step
			this._closeLastInlineTinyMCE();
			if(this.saveOnNext) {
				this._getSaveData(this._activeStep);
			} else {
				this._getSaveData();
			}
			if(this.saveData()){
				var stepdata = this._steps[this._activeStep];
				if(this.finishRedirectURL && stepdata.IsFinishStep) {
					epages.locationHref(this.finishRedirectURL);
				} else {
					this.activateStep(this._steps.length - 1);
				}
			}
		},
		_onQuickFinishClick:function(){
			//summary: save data and go to last step
			this._toggleLoaderOverlay(true);
			this._closeLastInlineTinyMCE();
			this._getSaveData();
			if(this.saveData()){
				this.activateStep(this._steps.length - 1);
			}
		},

		_activateNextButton: function(){
			//summary: activate the next Button
			dojo.addClass(this.NextButton, 'Active');
		},

		_disableNextButton: function(){
			//summary: disable the next Button
			dojo.addClass(this.NextButton, 'Disabled');
		},

		_closeWizard:function(){
			//summary: activates the last step without saving necessary for errors
			location.href = epages.vars.BaseUrl;
		},

		_changeNavigationNodeState: function(stepNumber,state){
			//summary: change states of nextNavigationNodes
			//only steps with state done can be clicked
			var stepNavigationNode;
			for( var j=0,jLength=this._stepNavigation.length ; j<jLength ; j++ ){
				var currentNode = this._stepNavigation[j];
				if(stepNumber == currentNode.stepNumber){
					stepNavigationNode = currentNode;
				}
			}
			//change stepNavigationNode to active and remove all other states on this step only no multiple states possible
			if(stepNavigationNode){
				for( var i=0,iLength=this._stepStates.length ; i<iLength ; i++ ){
					var currentState = this._stepStates[i];
					if(state == currentState){
						dojo.addClass(stepNavigationNode.node,currentState);
						dojo.addClass(stepNavigationNode.bubbleNode,currentState);
					}
					else{
						dojo.removeClass(stepNavigationNode.node,currentState);
						dojo.removeClass(stepNavigationNode.bubbleNode,currentState);
					}
				}
			}
		},

		checkChanges:function(){
			//TODO: diese funktion soll �berpr�fen, ob es noch ungespeicherte �nderungen gibt und bei Bedarf warnen
			/*this._getSaveData();
			console.debug('check changes',this._objects);
			var unsavedData = false;
			for(var key in this._objects){
				if(this._objects[key]){
					unsavedData = true;
					break;
				}
			}
			if(unsavedData){
				return true;
			}
			else{
				return false;
			}*/
			return false;
		},

		_initialize: function(){
			//summary:make necessary first values to start wizard
			//show step jump list
			//register on onbeforeunload
			epages.onUnloadFunctions.push(dojo.hitch(this,function() {
				return this.checkChanges();
			}));
			this._buildStepNavigation();
			this.BackButton.hide();
			this.SaveButton.hide();
		},

		_buildStepNavigation: function(){
			//summary: build step navigation and stepNavigation Bubble
			this.BubbleContentNode.innerHTML='<div class="Headline">'+this.controllerName+'</div>';

			var visibleStepNumber = 1;
			for( var i=0,iLength=this._steps.length ; i<iLength ; i++ ){
				var stepData = this._steps[i];
				if(stepData.NotInNavigation){
					continue;
				}

				// create step node
				var stepNode = document.createElement('a');
				stepNode.innerHTML = visibleStepNumber;
				dojo.addClass(stepNode, "Step");
				dojo.addClass(stepNode, stepData.state);
				this.connect(stepNode,'onclick', '_onStepNumberClick');
				this.connect(stepNode,'onmouseover', '_onStepNumberHover');
				this.StepNavigationNode.appendChild(stepNode);

				// create step node in bubble
				var bubbleNode = document.createElement('div');
				bubbleNode.innerHTML = visibleStepNumber+'. '+stepData.Name;
				dojo.addClass(bubbleNode, stepData.state);
				dojo.addClass(bubbleNode, "Step");
				this.connect(bubbleNode,'onclick', '_onStepNumberClick');
				this.BubbleContentNode.appendChild(bubbleNode);

				// register nodes
				var stepNavigationNode = {
					node : stepNode,
					bubbleNode : bubbleNode,
					stepNumber : i
				};
				this._stepNavigation.push(stepNavigationNode);

				visibleStepNumber++;
			}

			// fill in bubble
			this.StepNavigationBubble.setupContent({
				content: this.BubbleContentNode,
				orientation : 'top-right'
			});
			// show bubble
			dojo.removeClass(this.BubbleContentNode,'HideElement');
		},

		_onStepNumberClick: function(evt){
			//summary: change to clicked step
			currentNode = evt.currentTarget;
			for( var i=0,iLength=this._stepNavigation.length ; i<iLength ; i++ ){
				var stepNavigationNode = this._stepNavigation[i];
				if(currentNode == stepNavigationNode.node ||currentNode == stepNavigationNode.bubbleNode){
					var stepData = this._steps[stepNavigationNode.stepNumber];
					if(stepData.state != 'Disabled'){
						this._toggleLoaderOverlay(true);
						this.activateStep(stepNavigationNode.stepNumber);
					}
				}
			}
		},

		_onStepNumberHover: function(evt){
			//summary: show stepBubble on hover of stepNumbers
			var currentNode = evt.currentTarget;
			var absPos = $E(currentNode).getRelativePosition();
			this.StepNavigationBubble.setupContent({
				x           : absPos.x - 15,
				y           : absPos.y + 20,
				orientation : 'top-right'
			});
			this.StepNavigationBubble.show();
		},

		_hideStepNavigationBubble: function(evt){
			//summary: hide step navigation bubble
			var _this = this;
			window.clearTimeout(this._hideBubbleTimeout);
			this._hideBubbleTimeout = window.setTimeout(function() {
				_this.StepNavigationBubble.hide();
			}, this.HIDEBUBBLE_TIMEOUT);
		},

		_dontHideStepNavigationBubble: function(evt){
			//summary: clear hide bubble
			window.clearTimeout(this._hideBubbleTimeout);
		},

		_showErrorMessage: function(messageTitle,messageText){
			//summary: show given error message
			dojo.publish("uimessage/show", [messageTitle, messageText, 'Dialog',{
				titleBar: this._steps[this._activeStep].Name,
				typeClass: 'Warning'
			}]);
		},

		//Eventhandling for changes and updates to Previews
		_onDomNodeEvent:function(evt){
			//summary: collect all events that happen on the domNode of this widget to update preview nodes if input nodes were changed
			if(evt.target.nodeName == "INPUT" || evt.target.nodeName == "SELECT" || evt.target.nodeName == "TEXTAREA") {
				var sourceNode = evt.target;
				var epUpdateName = (sourceNode.getAttribute('ep_updatename')) ?  sourceNode.getAttribute('ep_updatename') : sourceNode.name;
				// update known elements
				var updateNodes = dojo.query("[ep_updatesource="+epUpdateName+"]", this.ContainerNode);
				var updateValue = sourceNode.value;

				if(sourceNode.nodeName == "SELECT") {
					updateValue = sourceNode[sourceNode.selectedIndex].innerHTML;
				}
				else if(sourceNode.type == "radio" || sourceNode.className.match("Radio")) {
					var aRadioLabel = dojo.query('[for='+sourceNode.id+']', sourceNode.parentNode.parentNode);
					if(aRadioLabel[0]) {
						updateValue = aRadioLabel[0].innerHTML;
					}
				}
				for( var i=0,iLength=updateNodes.length ; i<iLength ; i++ ){
					var currentNode = updateNodes[i];
					var updateTask = currentNode.getAttribute("ep_updatetask");
					var emptyDefault = currentNode.getAttribute("ep_emptyDefault");
					if(updateValue == "" && emptyDefault) {
						updateValue = emptyDefault;
					}
					this._updatePreview(currentNode, updateTask, updateValue);
				}
			}
		},

		_updatePreview: function(/* dom node*/updateNode, /* string */ updateTask, /* string */ updateValue ) {
			//summary: insert new value to preview dom node
			if(!updateTask){
				return;
			}
			if(updateTask.match("setHTML")) {
				if(updateValue == "") {
					updateValue= "&nbsp;";    // avoid empty tags which are not displayed (e.g. business hours table)
				}
				if(updateNode.innerHTML == updateValue) {
					return;
				}
				updateNode.innerHTML = updateValue;
			}

			if(updateTask.match("setText")) {
				updateValue = epages.string.escapeXml(updateValue);

				if(updateNode.innerHTML == updateValue) {
					return;
				}
				updateNode.innerHTML = updateValue;
			}

			if(updateTask.match("setValue")) {
				if(updateNode.value == updateValue) {
					return;
				}
				updateNode.value = updateValue;
			}

			if(updateTask.match("emphasize")) {
				updateNode.style.fontWeight = "bold";
			}
		},

		_onSwitchToEditMode: function(templateName){
			//summary: switch given step to editmode find step with given templateName
			if(!templateName){
				return;
			}
			for( var i=0,iLength=this._steps.length ; i<iLength ; i++ ){
				var currentStep = this._steps[i];
				if(currentStep.TemplateName == templateName){
					dojo.addClass(currentStep.templateNode, "EditMode");
					dojo.removeClass(currentStep.templateNode, "SummaryMode");
					break;
				}
			}
		},

		_onSwitchToStep: function(templateName) {
			// summary: message function
			var foundTemplate = false;
			for( var i=0,iLength=this._steps.length ; i<iLength ; i++ ){
				var currentStep = this._steps[i];
				if(currentStep.TemplateName == templateName){
					this._toggleLoaderOverlay(true);
					this.activateStep(i);
					foundTemplate= true;
					break;
				}
			}
			if(!foundTemplate) {
				console.warn('Template '+templateName+' not found in _onSwitchToStep() / '+this.declaredClass);
			}
		},

		_onCancel : function() {
			// summary: event function - redirect to cancel page
			if(this.cancelRedirectURL != "") {
				epages.locationHref(this.cancelRedirectURL );
			}
		}
	}
);

}

if(!dojo._hasResource["epages.event.domdispatcher"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.event.domdispatcher"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.html $Revision: 1.10 $

*/
dojo.provide("epages.event.domdispatcher");



dojo.declare("epages.event.DomDispatcher",
	function() {
		this._events = {};
	},
	{

		_monitoredEvents: $A(),
		_events: null,

		add: function(/* String */eventType, /*function|DOMNode|Array.DOMNode*/nodeList, /*function*/callback, /*Boolean*/outside, /*Document|Document[]*/docs) {
			// description:
			//		add an event to be monitored and dispatched
			//	eventType:
			//		name of an event, like "click"
			//	nodeList:
			//		a single DOM node or an array of DOM nodes to be monitored
			//	outside:
			//		dispatch event if it occurs outside or inside the monitored nodes
			if (outside == null){
				outside = false;
			}
			if (this._events[eventType] === undefined){
				this._events[eventType] = [];
			}
			this._events[eventType].push({
				'outside': outside,
				'nodes': nodeList,
				'callback': callback
			});
			if (!this._monitoredEvents.exists(eventType)){
				this._registerEventHandler(eventType, docs);
			}
		},

		_registerEventHandler: function(eventType, docs) {
			if (docs == null){
				docs = [document];
			}
			if (!dojo.isArrayLike(docs)){
				docs = [docs];
			}
			for( var i=0,iLength=docs.length ; i<iLength ; i++ ) {
				$E(docs[i]).addEventListener(eventType, dojo.hitch(this, 'handleEvent'), true);
			}
			// avoid double entries and recursion
			if (!this._monitoredEvents.exists(eventType)){
				this._monitoredEvents.push(eventType);
			}
		},

		_unregisterEventHandler: function(eventType, docs) {
			if (docs == null){
				docs = [document];
			}
			if (!dojo.isArrayLike(docs)){
				docs = [docs];
			}
			for( var i=0,iLength=docs.length ; i<iLength ; i++ ) {
				$E(docs[i]).removeEventListener(eventType, dojo.hitch(this, 'handleEvent'), true);
			}
			// update monitor list
			var EventIndex = this._monitoredEvents.find(eventType);
			if (EventIndex != null) {
				this._monitoredEvents.remove(EventIndex);
			}
		},

		handleEvent: function(DomEvent) {
			// summary: if this happens, the window is probably not longer member of the dom
			if (window.epages == null){
				return;
			}
			var events = this._events[DomEvent.type];
			if (events.length === undefined){
				return;
			}
			for( var i=0,iLength=events.length ; i<iLength ; i++ ) {
				var event = events[i];
				var nodes = event.nodes;
				if (typeof nodes == 'function'){
					nodes = nodes();
				}
				// dispatch event
				if (event.nodes != null && epages.html.isInnerEvent(DomEvent, nodes) != event.outside) {
					event.callback(DomEvent);
				}
			}
		}

	}
);

dojo.publish('epages/addGlobalSymbol', ['$D', window]);
if ($D === undefined){
	$D = new epages.event.DomDispatcher();
}

epages.onIframeStart.push(function(parentWin, iframeWin) {
	$D._monitoredEvents.each(function(el) {
		$D._registerEventHandler(el, iframeWin.document);
	});
});

}

if(!dojo._hasResource["epages.html.undo"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.html.undo"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.html.undo $Revision: 1.27 $

*/
dojo.provide("epages.html.undo");



epages.html.UnDo = function(container) {
	this.errorStack    = [];
	this.historyStack  = [];
	this.forwardStack  = [];
	this.currentValues = $H();
	this.defaultValues = $H();

	if (container === undefined){
		container = document;
	}

	this.registerContainerInputs(container);
};

epages.html.UnDo.prototype = {
	POS_OBJECT:  0,
	POS_NEW   :  1,
	POS_OLD   :  2,
	historyStack:   undefined,
	forwardStack:   undefined,
	currentValues:  undefined,
	defaultValues:  undefined,
	isUndoCall:     false,
	lastSavePoint:  0,
	isTyping:		false,
	undoNavigationElementWidgetStack: [],

	registerContainerInputs: function(container) {
		var iterator = this.registerInput;
		dojo.forEach(container.getElementsByTagName("select"),   iterator, this);
		dojo.forEach(container.getElementsByTagName("input"),    iterator, this);
		dojo.forEach(container.getElementsByTagName("textarea"), iterator, this);
	},

	registerInput: function(el) {
		// ignore all inputs with ep_noundo = 1 and without name
		if (el.name != '' & el.getAttribute("ep_noundo")!='1') {
			this.setDefaultValue(el);
			var me = this;
			$E(el).connectChangeEvent(function () { me.addInput(el); });
		}
	},

	setDefaultValue: function (/*HTMLObject*/object) {
		// summary: set default value
		this.defaultValues.set(object.name, $E(object).get());
	},

	_lastValue: function(identifier) {
		// returns: last Value
		var entry = this.currentValues.get(identifier);
		if (entry !== undefined){
			return entry;
		}

		entry = this.defaultValues.get(identifier);

		return entry;
	},

	addInput: function(object, currentValue) {
			// alert('addInput:' + object.name);
		if (! this.isUndoCall) { // ignore self fired events
			var lastValue = this._lastValue(object.name);
			if (currentValue == null){
				currentValue = $E(object).get();
			}
			this.currentValues.set(object.name, currentValue);
			if (lastValue !== null && currentValue != lastValue) {
				if (this.forwardStack.length > 0 && this.historyStack.length < this.lastSavePoint){
					this.lastSavePoint = -1; // save is always false
				}
				this.historyStack.push([ object, currentValue, lastValue ]);
				this.forwardStack = [];
			}
		}
		this.validateInput(object);
	},

	validateInput: function(object) {
		if (typeof(object.getAttribute) !== 'function'){
			return;
		}

		var isError=object.getAttribute("ep_error");
		var inputPosition=$A(this.errorStack).find(object);
		if (isError == "1" && inputPosition == null){
			this.errorStack.push(object);
		}else if (isError == "0" && inputPosition != null){
			this.errorStack.splice([inputPosition],1);
		}
	},

	show: function(object) {
		object.innerHTML  = '<p>history: '       + this.historyStack.flatten()  + '</p>';
		object.innerHTML += '<p>forward: '       + this.forwardStack.flatten()  + '</p>';
		object.innerHTML += '<p>currentValues: ' + this.currentValues.flatten() + '</p>';
		object.innerHTML += '<p>defaultValues: ' + this.defaultValues.flatten() + '</p>';
	},

	_setValue: function (object, value) {
		this.currentValues.set(object.name, value);
		var htmlElement = $E(object);
		htmlElement.set(value);
		this.isUndoCall = true;
		epages.isUndoCall = true;
		htmlElement.callOnChange();
		this.isUndoCall = false;
		epages.isUndoCall = false;
	},

	undo: function() {
		if (this.historyStack.length == 0){
			return;
		}
		var entry = this.historyStack.pop();
		this.forwardStack.push(entry);
		this._setValue(entry[this.POS_OBJECT], entry[this.POS_OLD]);

		// undo stack for dialogs
		for(var i=0, iLength=this.undoNavigationElementWidgetStack.length; i<iLength; i++){
			this.undoNavigationElementWidgetStack[i].resetEditDialogInputValues();
		}
	},

	redo: function() {
		if (this.forwardStack.length == 0){
			return;
		}
		var entry = this.forwardStack.pop();
		this.historyStack.push(entry);
		this._setValue(entry[this.POS_OBJECT], entry[this.POS_NEW]);

		// undo stack for dialogs
		for(var i=0, iLength=this.undoNavigationElementWidgetStack.length; i<iLength; i++){
			this.undoNavigationElementWidgetStack[i].resetEditDialogInputValues();
		}
	},

	existsChanges: function () {
		return this.historyStack.length != this.lastSavePoint;
	},

	clear: function() {
		this.historyStack = [];
		this.forwardStack = [];
		this.lastSavePoint = 0;
		this.defaultValues = this.currentValues;
		this.currentValues = $H();
	},

	getChanged: function () {
		return $H(this.currentValues);
	},

	setLastSavePoint: function(){
		this.lastSavePoint = this.historyStack.length;
	},

	checkTyping: function(isTyping) {
		if (this.isTyping != isTyping) {
			this.isTyping = isTyping;
			this.onChangeTyping();
		}
	},


	onChangeTyping: function() {
		// summary: gets called, when the user starts or stops typing
		// description: callback stub
		// tags: extendable
	}

};

// this class is an adapter to epages.html.UnDo to be used by tinymce instead of its custom undomanager
epages.html.TinymceUndoManagerAdapter = function(undoObject, input, onChangeCallback) {
	this.__undoObject = undoObject;
	this.__input = input;
	this.__onChange = onChangeCallback;
};

epages.html.TinymceUndoManagerAdapter.prototype = {
	typing : 0, // Integer - is user currently typing

	__undoObject: null, // Object - reference to epages.html.UnDo object
	__input: null,

	__onChange: null, // function - callback for onChange events

	add : function(info) {
		if (info && info.initial) {
			this.__undoObject.setDefaultValue(this.__input);
		} else {
			//this.__undoObject.addInput(this.__input);
			this.__onChange();
		}
	},

	undo : function() {
		if (this.typing){
			this.add();
		}
		this.__undoObject.undo();
		this.typing = 0;
	},

	redo : function() {
		this.__undoObject.redo();
	},

	clear : function() { this.__undoObject.clear(); },

	hasUndo : function() {
		return this.typing || this.__undoObject.historyStack.length > 0;
	},

	hasRedo : function() {
		return this.__undoObject.forwardStack.length > 0;
	}

};

}

if(!dojo._hasResource['epages.cartridges.de_epages.presentation.widget.InlineEditor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.cartridges.de_epages.presentation.widget.InlineEditor'] = true;
dojo.provide('epages.cartridges.de_epages.presentation.widget.InlineEditor');
//
//






// wrapper widget for all inline editors
dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.InlineEditor",
	//[dijit._Widget, dijit._Templated],
	epages.widget.LocalizedWidget,
	{
		// from fragment
		value:          '',		// insert in displayNode
		valueFormatted:	'',		// insert in contentNode (textarea)
		inputName:      '',
		undoWidget:     '',
		title:          '',

		// public properties
		// widget or tinymce instance
		object:         null,
		templateString: '<div class="InlineEditor"><div dojoAttachPoint="displayNode" dojoAttachEvent="onclick:onClick,onmouseover:onMouseOver,onmouseout:onMouseOut">${!value}</div><textarea style="display: none" dojoAttachPoint="contentNode" id="InlineEditor_${id}" name="${inputName}">${!valueFormatted}</textarea></div>',
		translationName: dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget','templates/translation'),
		objectId:       null,
		attribute:      null,
		languageId:     null,
		undoObject:     null,
		isTyping:       false,
		isInited:       false,
		allowedNodes:   {},
		widgetsInTemplate: true,
		navbar:         '', // parent navbar eg. Content, Left, Top

		// is this widget always visible? (no show/hide switching)
		permanent:      false,

		// private properties
		_jsonIo:        null,
		_computedStyle: null,
		_relevantStyleAttributes: [
			"fontWeight",
			"fontFamily",
			"fontSize",
			"fontStyle",
			"color",
			"backgroundImage",
			"backgroundRepeat",
			"backgroundColor",
			"backgroundPosition",
			"marginTop",
			"marginBottom",
			"marginLeft",
			"marginRight",
			"paddingTop",
			"paddingBottom",
			"paddingLeft",
			"paddingRight",
			"maxHeight",
			"maxWidth"
			],
		// dimensions of the original source node
		_height:        null,
		_width:         null,
		_titleNode:     null,
		_resizeClone:   null,
		_placeHolderText: '...',

		postMixInProperties: function() {
			this.valueFormatted = this.value;	// default -> no formatting
			this.inherited("postMixInProperties", arguments);
		},

		create: function(params, srcNodeRef) {
			switch (srcNodeRef.nodeName.toLowerCase()) {
				case "input":
				case "textarea":
				case "select":
					this.value = srcNodeRef.value;
					break;
				case "img":
					this.value = srcNodeRef.src;
					break;
				default:
					this.value = srcNodeRef.innerHTML;
					break;
			}

			// copy style
			var tmpStyle = dojo.getComputedStyle(srcNodeRef);
			this._computedStyle = {};
			if(tmpStyle){
				dojo.forEach(this._relevantStyleAttributes, function(prop) {
					var t = typeof tmpStyle[prop];
					if ((t == 'number' || t == 'string') && tmpStyle[prop] != "normal") {
						//alert(prop + ": " + tmpStyle[prop]);
						this._computedStyle[prop] = tmpStyle[prop];
					}
				}, this);
			}

			// insert inputfield
			this.inputName = srcNodeRef.getAttribute('ep_input');
			if (this.inputName == null) {
				throw new Error("missing attribute ep_input for InlineEditor " + this.id);
			}
			this._height = srcNodeRef.scrollHeight;
			this._width = srcNodeRef.scrollWidth;
			var inputNameParts = this.inputName.split(':');
			this.objectId = inputNameParts[0];
			this.attribute = inputNameParts[1];
			this.languageId = inputNameParts[2];

			// call parent create method
			this.inherited('create', arguments);

			// insert title node to DOM
			this._titleNode = this.domNode.ownerDocument.createElement('span');
			if (this.title != '') {
				this._titleNode.innerHTML = this.title;
				dojo.addClass(this._titleNode, "TitleDiv");
				this._titleNode.style.display = 'none';
				srcNodeRef.title = '';
			}
			//this.domNode.insertBefore(this._titleNode, this.domNode.firstChild);
			this.domNode.parentNode.insertBefore(this._titleNode, this.domNode);
		},

		postCreate: function() {
			this._copyStyle(this.displayNode, this._computedStyle);
			this.inherited('postCreate', arguments);

			this.domNode.title = this.translate('InsertContentHere');

			if (this.permanent){
				this.show();
			}
			if (this.undoWidget != ''){
				this.undoObject = $$(this.undoWidget).getUndoObject();
			}
			//add content to a helper div to remove html tags for a correct empty check
			var testDiv = document.createElement('div');
			testDiv.innerHTML = this.contentNode.value;
			if (testDiv.textContent.length == 0 && this.displayNode){
				this.displayNode.innerHTML = this._placeHolderText;
			}
		},

		onClick: function(evt) {
			epages.topDojo.publish('InlineEditor/click', [{ instance: this, event: evt }]);
			this.show();
			dojo.stopEvent(evt);
		},

		onBlur: function(/*DOMEvent*/evt) {
			// description:
			//  method to override, called when editor may blur
			//  evt:
			//    event that triggered the blur
			// returns:
			//    whether to blur the editor or not
			return true; //Boolean
		},

		onMouseOver: function(evt) {
			$E(this.displayNode).addClassName('Highlighted');
		},

		onMouseOut: function(evt) {
			$E(this.displayNode).removeClassName('Highlighted');
		},

		show: function() {
			if (epages.cartridges.de_epages.presentation.widget.InlineEditor.selectedEditor != null &&
					epages.cartridges.de_epages.presentation.widget.InlineEditor.selectedEditor != this) {
				// close another opened editor
				epages.cartridges.de_epages.presentation.widget.InlineEditor.selectedEditor.hide();
			}

			this._titleNode.style.display = '';
			this.connect(this.contentNode, 'onchange', 'onChangeContentNode');
			// manage global InlineEditor instance
			epages.cartridges.de_epages.presentation.widget.InlineEditor.selectedEditor = this;
			epages.topDojo.publish('InlineEditor/show', [this]);
			if(this.domNode.clientWidth == 0) {
				this.domNode.style.minWidth = Math.max(0, this._width - this.domNode.offsetWidth) + "px";		// set content minwidth
			}
		},

		_copyStyle: function(node, style) {
			// summary: Copy the style from the source
			// description: -- taken from dijit.InlineEditBox --
			//              Don't copy ALL properties though, just the necessary/applicable ones

			dojo.forEach(this._relevantStyleAttributes, function(prop) {
				node.style[prop] = (style[prop] || "");
			}, this);

		},

		_resizeToContent: function() {
			// this timeout avoids some flickering
			window.setTimeout(dojo.hitch(this, function() {
				var node = this.contentNode;
				var clone = this._resizeClone;
				if (clone == null) {
					var clone = node.ownerDocument.createElement('div');
					var cs = dojo.getComputedStyle(node);
					var s = clone.style;
					for (var p in cs) {
						try {
							s[p] = cs[p];
						} catch(e) {
						}
					}
					// insert it into dom but dont show it
					clone.style.width = '100%';
					clone.style.height = 'auto';
					clone.style.overflow = 'visible';
					clone.style.position = 'absolute';
					clone.style.top = '-9999px';
					clone.style.whiteSpace = 'normal';
					node.parentNode.insertBefore(clone, node);
					this._resizeClone = clone;
				}
				if (node.value != '') {
					clone.innerHTML = epages.html.encodeEntity(node.value, true);
				} else {
					clone.innerHTML = '&nbsp;';
				}
				if (node.value.match(/[\r\n]$/)){
					clone.innerHTML += '&nbsp;';
				}
				var innerHeight = clone.scrollHeight;
				var offsetHeight = 0;
				node.style.height = (innerHeight + offsetHeight) + 'px';

				// callback for height correction in text fields
				if(this.correctCallback !== undefined){
					this.correctCallback(node);
				}
			}), 1);
		},

		hide: function(evt) {
			this._titleNode.style.display = 'none';
			epages.cartridges.de_epages.presentation.widget.InlineEditor.selectedEditor = null;
			if (this.contentNode.value == ''){
				this.displayNode.innerHTML = this._placeHolderText;
			}
			epages.topDojo.publish('InlineEditor/hide', [this]);
		},

		onChange: function() {
			// summary: write contents back to hidden input
			if(this.object){
				this.contentNode.value = this.object.getContent();
			}
			this.onChangeContentNode();
		},

		onChangeContentNode: function() {
			//summary: gets called, when data is changed (from outside)
			if(this.undoObject){
				this.undoObject.addInput(this.contentNode);
			}
		},

		getRemoteValue: function(/*Array.string*/additionalAttributes) {
		  // summary: get the correct value from the server, the content may be manipulated by the browser

			// create new json instance
			if (this._jsonIo == null){
				this._jsonIo = new epages.io.Json();
			}
			var attributes = [ this.attribute ];

			// add additional needed attributes
			if (additionalAttributes != null) {
				attributes = attributes.merge(additionalAttributes);
			}

			// get correct content from server, content may be modified by browser
			var value = this._jsonIo.loadSync('?', {
				'ViewObjectID': this.objectId,
				'ViewAction': 'JSONGet',
				'Attributes': attributes.join(',')
			});

			return value;
		}

	}
);

epages.cartridges.de_epages.presentation.widget.InlineEditor.selectedEditor = null;
$D.add( 'click',
	// summary: adds click event handler to document of editor and topWindow document
	// description: we need to check on click if we are still inside the editor
	//    or ouside. if the click was outside the hide methode of the current editor is called

	function() {
		//summary: return selected editor if available
		if (epages.cartridges.de_epages.presentation.widget.InlineEditor.selectedEditor != null){
			return epages.cartridges.de_epages.presentation.widget.InlineEditor.selectedEditor.domNode;
		}
		else{
			return null;
		}
	},
	function(evt) {
		var ed = epages.cartridges.de_epages.presentation.widget.InlineEditor.selectedEditor;
		if((ed && ed.contentNode == evt.target) //check if editor was clicked for Gecko and WebKit
		|| (ed && ed.contentNode == evt.srcElement)){ // check if editor was clicked for MSIE
			return;
		}

		if (ed != null && ed.onBlur(evt)){ //if blur event of editor was
			ed.hide();
		}
	},
	// outside
	true,
	[document, epages.topWindow.document]
);

}


dojo.i18n._preloadLocalizations("epages.nls.ep_shop", ["ROOT","ca","da","de","en","es","fi","fr","it","nl","no","pt","ro","ru","sv","xx"]);
