/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

/*
	This is a compiled version of Dojo, built for deployment and not for
	development. To get an editable version, please visit:

		http://dojotoolkit.org

	for documentation and information on getting the source.
*/

if(!dojo._hasResource["dojo.dnd.common"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.common"] = true;
dojo.provide("dojo.dnd.common");

dojo.dnd._uniqueId = 0;
dojo.dnd.getUniqueId = function(){
	// summary:
	//		returns a unique string for use with any DOM element
	var id;
	do{
		id = dojo._scopeName + "Unique" + (++dojo.dnd._uniqueId);
	}while(dojo.byId(id));
	return id;
};

dojo.dnd._empty = {};

dojo.dnd.isFormElement = function(/*Event*/ e){
	// summary:
	//		returns true if user clicked on a form element
	var t = e.target;
	if(t.nodeType == 3 /*TEXT_NODE*/){
		t = t.parentNode;
	}
	return " button textarea input select option ".indexOf(" " + t.tagName.toLowerCase() + " ") >= 0;	// Boolean
};

}

if(!dojo._hasResource["dojo.dnd.autoscroll"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.autoscroll"] = true;
dojo.provide("dojo.dnd.autoscroll");

dojo.dnd.getViewport = function(){
	// summary:
	//		Returns a viewport size (visible part of the window)

	// TODO: remove this when getViewport() moved to dojo core, see #7028

	// FIXME: need more docs!!
	var d = dojo.doc, dd = d.documentElement, w = window, b = dojo.body();
	if(dojo.isMozilla){
		return {w: dd.clientWidth, h: w.innerHeight};	// Object
	}else if(!dojo.isOpera && w.innerWidth){
		return {w: w.innerWidth, h: w.innerHeight};		// Object
	}else if (!dojo.isOpera && dd && dd.clientWidth){
		return {w: dd.clientWidth, h: dd.clientHeight};	// Object
	}else if (b.clientWidth){
		return {w: b.clientWidth, h: b.clientHeight};	// Object
	}
	return null;	// Object
};

dojo.dnd.V_TRIGGER_AUTOSCROLL = 32;
dojo.dnd.H_TRIGGER_AUTOSCROLL = 32;

dojo.dnd.V_AUTOSCROLL_VALUE = 16;
dojo.dnd.H_AUTOSCROLL_VALUE = 16;

dojo.dnd.autoScroll = function(e){
	// summary:
	//		a handler for onmousemove event, which scrolls the window, if
	//		necesary
	// e: Event
	//		onmousemove event

	// FIXME: needs more docs!
	var v = dojo.dnd.getViewport(), dx = 0, dy = 0;
	if(e.clientX < dojo.dnd.H_TRIGGER_AUTOSCROLL){
		dx = -dojo.dnd.H_AUTOSCROLL_VALUE;
	}else if(e.clientX > v.w - dojo.dnd.H_TRIGGER_AUTOSCROLL){
		dx = dojo.dnd.H_AUTOSCROLL_VALUE;
	}
	if(e.clientY < dojo.dnd.V_TRIGGER_AUTOSCROLL){
		dy = -dojo.dnd.V_AUTOSCROLL_VALUE;
	}else if(e.clientY > v.h - dojo.dnd.V_TRIGGER_AUTOSCROLL){
		dy = dojo.dnd.V_AUTOSCROLL_VALUE;
	}
	window.scrollBy(dx, dy);
};

dojo.dnd._validNodes = {"div": 1, "p": 1, "td": 1};
dojo.dnd._validOverflow = {"auto": 1, "scroll": 1};

dojo.dnd.autoScrollNodes = function(e){
	// summary:
	//		a handler for onmousemove event, which scrolls the first avaialble
	//		Dom element, it falls back to dojo.dnd.autoScroll()
	// e: Event
	//		onmousemove event

	// FIXME: needs more docs!
	for(var n = e.target; n;){
		if(n.nodeType == 1 && (n.tagName.toLowerCase() in dojo.dnd._validNodes)){
			var s = dojo.getComputedStyle(n);
			if(s.overflow.toLowerCase() in dojo.dnd._validOverflow){
				var b = dojo._getContentBox(n, s), t = dojo.position(n, true);
				//console.log(b.l, b.t, t.x, t.y, n.scrollLeft, n.scrollTop);
				var w = Math.min(dojo.dnd.H_TRIGGER_AUTOSCROLL, b.w / 2), 
					h = Math.min(dojo.dnd.V_TRIGGER_AUTOSCROLL, b.h / 2),
					rx = e.pageX - t.x, ry = e.pageY - t.y, dx = 0, dy = 0;
				if(dojo.isWebKit || dojo.isOpera){
					// FIXME: this code should not be here, it should be taken into account 
					// either by the event fixing code, or the dojo.position()
					// FIXME: this code doesn't work on Opera 9.5 Beta
					rx += dojo.body().scrollLeft, ry += dojo.body().scrollTop;
				}
				if(rx > 0 && rx < b.w){
					if(rx < w){
						dx = -w;
					}else if(rx > b.w - w){
						dx = w;
					}
				}
				//console.log("ry =", ry, "b.h =", b.h, "h =", h);
				if(ry > 0 && ry < b.h){
					if(ry < h){
						dy = -h;
					}else if(ry > b.h - h){
						dy = h;
					}
				}
				var oldLeft = n.scrollLeft, oldTop = n.scrollTop;
				n.scrollLeft = n.scrollLeft + dx;
				n.scrollTop  = n.scrollTop  + dy;
				if(oldLeft != n.scrollLeft || oldTop != n.scrollTop){ return; }
			}
		}
		try{
			n = n.parentNode;
		}catch(x){
			n = null;
		}
	}
	dojo.dnd.autoScroll(e);
};

}

if(!dojo._hasResource["dojo.dnd.Mover"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.Mover"] = true;
dojo.provide("dojo.dnd.Mover");




dojo.declare("dojo.dnd.Mover", null, {
	constructor: function(node, e, host){
		// summary:
		//		an object, which makes a node follow the mouse. 
		//		Used as a default mover, and as a base class for custom movers.
		// node: Node
		//		a node (or node's id) to be moved
		// e: Event
		//		a mouse event, which started the move;
		//		only pageX and pageY properties are used
		// host: Object?
		//		object which implements the functionality of the move,
		//	 	and defines proper events (onMoveStart and onMoveStop)
		this.node = dojo.byId(node);
		this.marginBox = {l: e.pageX, t: e.pageY};
		this.mouseButton = e.button;
		var h = this.host = host, d = node.ownerDocument, 
			firstEvent = dojo.connect(d, "onmousemove", this, "onFirstMove");
		this.events = [
			dojo.connect(d, "onmousemove", this, "onMouseMove"),
			dojo.connect(d, "onmouseup",   this, "onMouseUp"),
			// cancel text selection and text dragging
			dojo.connect(d, "ondragstart",   dojo.stopEvent),
			dojo.connect(d.body, "onselectstart", dojo.stopEvent),
			firstEvent
		];
		// notify that the move has started
		if(h && h.onMoveStart){
			h.onMoveStart(this);
		}
	},
	// mouse event processors
	onMouseMove: function(e){
		// summary:
		//		event processor for onmousemove
		// e: Event
		//		mouse event
		dojo.dnd.autoScroll(e);
		var m = this.marginBox;
		this.host.onMove(this, {l: m.l + e.pageX, t: m.t + e.pageY});
		dojo.stopEvent(e);
	},
	onMouseUp: function(e){
		if(dojo.isWebKit && dojo.isMac && this.mouseButton == 2 ? 
				e.button == 0 : this.mouseButton == e.button){
			this.destroy();
		}
		dojo.stopEvent(e);
	},
	// utilities
	onFirstMove: function(){
		// summary:
		//		makes the node absolute; it is meant to be called only once. 
		// 		relative and absolutely positioned nodes are assumed to use pixel units
		var s = this.node.style, l, t, h = this.host;
		switch(s.position){
			case "relative":
			case "absolute":
				// assume that left and top values are in pixels already
				l = Math.round(parseFloat(s.left));
				t = Math.round(parseFloat(s.top));
				break;
			default:
				s.position = "absolute";	// enforcing the absolute mode
				var m = dojo.marginBox(this.node);
				// event.pageX/pageY (which we used to generate the initial
				// margin box) includes padding and margin set on the body.
				// However, setting the node's position to absolute and then
				// doing dojo.marginBox on it *doesn't* take that additional
				// space into account - so we need to subtract the combined
				// padding and margin.  We use getComputedStyle and
				// _getMarginBox/_getContentBox to avoid the extra lookup of
				// the computed style. 
				var b = dojo.doc.body;
				var bs = dojo.getComputedStyle(b);
				var bm = dojo._getMarginBox(b, bs);
				var bc = dojo._getContentBox(b, bs);
				l = m.l - (bc.l - bm.l);
				t = m.t - (bc.t - bm.t);
				break;
		}
		this.marginBox.l = l - this.marginBox.l;
		this.marginBox.t = t - this.marginBox.t;
		if(h && h.onFirstMove){
			h.onFirstMove(this);
		}
		dojo.disconnect(this.events.pop());
	},
	destroy: function(){
		// summary:
		//		stops the move, deletes all references, so the object can be garbage-collected
		dojo.forEach(this.events, dojo.disconnect);
		// undo global settings
		var h = this.host;
		if(h && h.onMoveStop){
			h.onMoveStop(this);
		}
		// destroy objects
		this.events = this.node = this.host = null;
	}
});

}

if(!dojo._hasResource["dojo.dnd.Moveable"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.Moveable"] = true;
dojo.provide("dojo.dnd.Moveable");



/*=====
dojo.declare("dojo.dnd.__MoveableArgs", [], {
	// handle: Node||String
	//		A node (or node's id), which is used as a mouse handle.
	//		If omitted, the node itself is used as a handle.
	handle: null,

	// delay: Number
	//		delay move by this number of pixels
	delay: 0,

	// skip: Boolean
	//		skip move of form elements
	skip: false,

	// mover: Object
	//		a constructor of custom Mover
	mover: dojo.dnd.Mover
});
=====*/

dojo.declare("dojo.dnd.Moveable", null, {
	// object attributes (for markup)
	handle: "",
	delay: 0,
	skip: false,
	
	constructor: function(node, params){
		// summary:
		//		an object, which makes a node moveable
		// node: Node
		//		a node (or node's id) to be moved
		// params: dojo.dnd.__MoveableArgs?
		//		optional parameters
		this.node = dojo.byId(node);
		if(!params){ params = {}; }
		this.handle = params.handle ? dojo.byId(params.handle) : null;
		if(!this.handle){ this.handle = this.node; }
		this.delay = params.delay > 0 ? params.delay : 0;
		this.skip  = params.skip;
		this.mover = params.mover ? params.mover : dojo.dnd.Mover;
		this.events = [
			dojo.connect(this.handle, "onmousedown", this, "onMouseDown"),
			// cancel text selection and text dragging
			dojo.connect(this.handle, "ondragstart",   this, "onSelectStart"),
			dojo.connect(this.handle, "onselectstart", this, "onSelectStart")
		];
	},

	// markup methods
	markupFactory: function(params, node){
		return new dojo.dnd.Moveable(node, params);
	},

	// methods
	destroy: function(){
		// summary:
		//		stops watching for possible move, deletes all references, so the object can be garbage-collected
		dojo.forEach(this.events, dojo.disconnect);
		this.events = this.node = this.handle = null;
	},
	
	// mouse event processors
	onMouseDown: function(e){
		// summary:
		//		event processor for onmousedown, creates a Mover for the node
		// e: Event
		//		mouse event
		if(this.skip && dojo.dnd.isFormElement(e)){ return; }
		if(this.delay){
			this.events.push(
				dojo.connect(this.handle, "onmousemove", this, "onMouseMove"),
				dojo.connect(this.handle, "onmouseup", this, "onMouseUp")
			);
			this._lastX = e.pageX;
			this._lastY = e.pageY;
		}else{
			this.onDragDetected(e);
		}
		dojo.stopEvent(e);
	},
	onMouseMove: function(e){
		// summary:
		//		event processor for onmousemove, used only for delayed drags
		// e: Event
		//		mouse event
		if(Math.abs(e.pageX - this._lastX) > this.delay || Math.abs(e.pageY - this._lastY) > this.delay){
			this.onMouseUp(e);
			this.onDragDetected(e);
		}
		dojo.stopEvent(e);
	},
	onMouseUp: function(e){
		// summary:
		//		event processor for onmouseup, used only for delayed drags
		// e: Event
		//		mouse event
		for(var i = 0; i < 2; ++i){
			dojo.disconnect(this.events.pop());
		}
		dojo.stopEvent(e);
	},
	onSelectStart: function(e){
		// summary:
		//		event processor for onselectevent and ondragevent
		// e: Event
		//		mouse event
		if(!this.skip || !dojo.dnd.isFormElement(e)){
			dojo.stopEvent(e);
		}
	},
	
	// local events
	onDragDetected: function(/* Event */ e){
		// summary:
		//		called when the drag is detected;
		//		responsible for creation of the mover
		new this.mover(this.node, e, this);
	},
	onMoveStart: function(/* dojo.dnd.Mover */ mover){
		// summary:
		//		called before every move operation
		dojo.publish("/dnd/move/start", [mover]);
		dojo.addClass(dojo.body(), "dojoMove"); 
		dojo.addClass(this.node, "dojoMoveItem"); 
	},
	onMoveStop: function(/* dojo.dnd.Mover */ mover){
		// summary:
		//		called after every move operation
		dojo.publish("/dnd/move/stop", [mover]);
		dojo.removeClass(dojo.body(), "dojoMove");
		dojo.removeClass(this.node, "dojoMoveItem");
	},
	onFirstMove: function(/* dojo.dnd.Mover */ mover){
		// summary:
		//		called during the very first move notification;
		//		can be used to initialize coordinates, can be overwritten.
		
		// default implementation does nothing
	},
	onMove: function(/* dojo.dnd.Mover */ mover, /* Object */ leftTop){
		// summary:
		//		called during every move notification;
		//		should actually move the node; can be overwritten.
		this.onMoving(mover, leftTop);
		var s = mover.node.style;
		s.left = leftTop.l + "px";
		s.top  = leftTop.t + "px";
		this.onMoved(mover, leftTop);
	},
	onMoving: function(/* dojo.dnd.Mover */ mover, /* Object */ leftTop){
		// summary:
		//		called before every incremental move; can be overwritten.
		
		// default implementation does nothing
	},
	onMoved: function(/* dojo.dnd.Mover */ mover, /* Object */ leftTop){
		// summary:
		//		called after every incremental move; can be overwritten.
		
		// default implementation does nothing
	}
});

}

if(!dojo._hasResource["dojo.dnd.move"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.move"] = true;
dojo.provide("dojo.dnd.move");




/*=====
dojo.declare("dojo.dnd.move.__constrainedMoveableArgs", [dojo.dnd.__MoveableArgs], {
	// constraints: Function
	//		Calculates a constraint box.
	//		It is called in a context of the moveable object.
	constraints: function(){},

	// within: Boolean
	//		restrict move within boundaries.
	within: false
});
=====*/

dojo.declare("dojo.dnd.move.constrainedMoveable", dojo.dnd.Moveable, {
	// object attributes (for markup)
	constraints: function(){},
	within: false,
	
	// markup methods
	markupFactory: function(params, node){
		return new dojo.dnd.move.constrainedMoveable(node, params);
	},

	constructor: function(node, params){
		// summary:
		//		an object that makes a node moveable
		// node: Node
		//		a node (or node's id) to be moved
		// params: dojo.dnd.move.__constrainedMoveableArgs?
		//		an optional object with additional parameters;
		//		the rest is passed to the base class
		if(!params){ params = {}; }
		this.constraints = params.constraints;
		this.within = params.within;
	},
	onFirstMove: function(/* dojo.dnd.Mover */ mover){
		// summary:
		//		called during the very first move notification;
		//		can be used to initialize coordinates, can be overwritten.
		var c = this.constraintBox = this.constraints.call(this, mover);
		c.r = c.l + c.w;
		c.b = c.t + c.h;
		if(this.within){
			var mb = dojo.marginBox(mover.node);
			c.r -= mb.w;
			c.b -= mb.h;
		}
	},
	onMove: function(/* dojo.dnd.Mover */ mover, /* Object */ leftTop){
		// summary:
		//		called during every move notification;
		//		should actually move the node; can be overwritten.
		var c = this.constraintBox, s = mover.node.style;
		s.left = (leftTop.l < c.l ? c.l : c.r < leftTop.l ? c.r : leftTop.l) + "px";
		s.top  = (leftTop.t < c.t ? c.t : c.b < leftTop.t ? c.b : leftTop.t) + "px";
	}
});

/*=====
dojo.declare("dojo.dnd.move.__boxConstrainedMoveableArgs", [dojo.dnd.move.__constrainedMoveableArgs], {
	// box: Object
	//		a constraint box
	box: {}
});
=====*/

dojo.declare("dojo.dnd.move.boxConstrainedMoveable", dojo.dnd.move.constrainedMoveable, {
	// box:
	//		object attributes (for markup)
	box: {},
	
	// markup methods
	markupFactory: function(params, node){
		return new dojo.dnd.move.boxConstrainedMoveable(node, params);
	},

	constructor: function(node, params){
		// summary:
		//		an object, which makes a node moveable
		// node: Node
		//		a node (or node's id) to be moved
		// params: dojo.dnd.move.__boxConstrainedMoveableArgs?
		//		an optional object with parameters
		var box = params && params.box;
		this.constraints = function(){ return box; };
	}
});

/*=====
dojo.declare("dojo.dnd.move.__parentConstrainedMoveableArgs", [dojo.dnd.move.__constrainedMoveableArgs], {
	// area: String
	//		A parent's area to restrict the move.
	//		Can be "margin", "border", "padding", or "content".
	area: ""
});
=====*/

dojo.declare("dojo.dnd.move.parentConstrainedMoveable", dojo.dnd.move.constrainedMoveable, {
	// area:
	//		object attributes (for markup)
	area: "content",

	// markup methods
	markupFactory: function(params, node){
		return new dojo.dnd.move.parentConstrainedMoveable(node, params);
	},

	constructor: function(node, params){
		// summary:
		//		an object, which makes a node moveable
		// node: Node
		//		a node (or node's id) to be moved
		// params: dojo.dnd.move.__parentConstrainedMoveableArgs?
		//		an optional object with parameters
		var area = params && params.area;
		this.constraints = function(){
			var n = this.node.parentNode, 
				s = dojo.getComputedStyle(n), 
				mb = dojo._getMarginBox(n, s);
			if(area == "margin"){
				return mb;	// Object
			}
			var t = dojo._getMarginExtents(n, s);
			mb.l += t.l, mb.t += t.t, mb.w -= t.w, mb.h -= t.h;
			if(area == "border"){
				return mb;	// Object
			}
			t = dojo._getBorderExtents(n, s);
			mb.l += t.l, mb.t += t.t, mb.w -= t.w, mb.h -= t.h;
			if(area == "padding"){
				return mb;	// Object
			}
			t = dojo._getPadExtents(n, s);
			mb.l += t.l, mb.t += t.t, mb.w -= t.w, mb.h -= t.h;
			return mb;	// Object
		};
	}
});

// WARNING: below are obsolete objects, instead of custom movers use custom moveables (above)

dojo.dnd.move.constrainedMover = function(fun, within){
	// summary:
	//		returns a constrained version of dojo.dnd.Mover
	// description:
	//		this function produces n object, which will put a constraint on 
	//		the margin box of dragged object in absolute coordinates
	// fun: Function
	//		called on drag, and returns a constraint box
	// within: Boolean
	//		if true, constraints the whole dragged object withtin the rectangle, 
	//		otherwise the constraint is applied to the left-top corner

	dojo.deprecated("dojo.dnd.move.constrainedMover, use dojo.dnd.move.constrainedMoveable instead");
	var mover = function(node, e, notifier){
		dojo.dnd.Mover.call(this, node, e, notifier);
	};
	dojo.extend(mover, dojo.dnd.Mover.prototype);
	dojo.extend(mover, {
		onMouseMove: function(e){
			// summary: event processor for onmousemove
			// e: Event: mouse event
			dojo.dnd.autoScroll(e);
			var m = this.marginBox, c = this.constraintBox,
				l = m.l + e.pageX, t = m.t + e.pageY;
			l = l < c.l ? c.l : c.r < l ? c.r : l;
			t = t < c.t ? c.t : c.b < t ? c.b : t;
			this.host.onMove(this, {l: l, t: t});
		},
		onFirstMove: function(){
			// summary: called once to initialize things; it is meant to be called only once
			dojo.dnd.Mover.prototype.onFirstMove.call(this);
			var c = this.constraintBox = fun.call(this);
			c.r = c.l + c.w;
			c.b = c.t + c.h;
			if(within){
				var mb = dojo.marginBox(this.node);
				c.r -= mb.w;
				c.b -= mb.h;
			}
		}
	});
	return mover;	// Object
};

dojo.dnd.move.boxConstrainedMover = function(box, within){
	// summary:
	//		a specialization of dojo.dnd.constrainedMover, which constrains to the specified box
	// box: Object
	//		a constraint box (l, t, w, h)
	// within: Boolean
	//		if true, constraints the whole dragged object withtin the rectangle, 
	//		otherwise the constraint is applied to the left-top corner

	dojo.deprecated("dojo.dnd.move.boxConstrainedMover, use dojo.dnd.move.boxConstrainedMoveable instead");
	return dojo.dnd.move.constrainedMover(function(){ return box; }, within);	// Object
};

dojo.dnd.move.parentConstrainedMover = function(area, within){
	// summary:
	//		a specialization of dojo.dnd.constrainedMover, which constrains to the parent node
	// area: String
	//		"margin" to constrain within the parent's margin box, "border" for the border box,
	//		"padding" for the padding box, and "content" for the content box; "content" is the default value.
	// within: Boolean
	//		if true, constraints the whole dragged object within the rectangle, 
	//		otherwise the constraint is applied to the left-top corner

	dojo.deprecated("dojo.dnd.move.parentConstrainedMover, use dojo.dnd.move.parentConstrainedMoveable instead");
	var fun = function(){
		var n = this.node.parentNode, 
			s = dojo.getComputedStyle(n), 
			mb = dojo._getMarginBox(n, s);
		if(area == "margin"){
			return mb;	// Object
		}
		var t = dojo._getMarginExtents(n, s);
		mb.l += t.l, mb.t += t.t, mb.w -= t.w, mb.h -= t.h;
		if(area == "border"){
			return mb;	// Object
		}
		t = dojo._getBorderExtents(n, s);
		mb.l += t.l, mb.t += t.t, mb.w -= t.w, mb.h -= t.h;
		if(area == "padding"){
			return mb;	// Object
		}
		t = dojo._getPadExtents(n, s);
		mb.l += t.l, mb.t += t.t, mb.w -= t.w, mb.h -= t.h;
		return mb;	// Object
	};
	return dojo.dnd.move.constrainedMover(fun, within);	// Object
};

// patching functions one level up for compatibility

dojo.dnd.constrainedMover = dojo.dnd.move.constrainedMover;
dojo.dnd.boxConstrainedMover = dojo.dnd.move.boxConstrainedMover;
dojo.dnd.parentConstrainedMover = dojo.dnd.move.parentConstrainedMover;

}

if(!dojo._hasResource["dojo.dnd.TimedMoveable"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.dnd.TimedMoveable"] = true;
dojo.provide("dojo.dnd.TimedMoveable");



/*=====
dojo.declare("dojo.dnd.__TimedMoveableArgs", [dojo.dnd.__MoveableArgs], {
	// timeout: Number
	//		delay move by this number of ms,
	//		accumulating position changes during the timeout
	timeout: 0
});
=====*/

(function(){
	// precalculate long expressions
	var oldOnMove = dojo.dnd.Moveable.prototype.onMove;
		
	dojo.declare("dojo.dnd.TimedMoveable", dojo.dnd.Moveable, {
		// summary:
		//		A specialized version of Moveable to support an FPS throttling.
		//		This class puts an upper restriction on FPS, which may reduce 
		//		the CPU load. The additional parameter "timeout" regulates
		//		the delay before actually moving the moveable object.
		
		// object attributes (for markup)
		timeout: 40,	// in ms, 40ms corresponds to 25 fps
	
		constructor: function(node, params){
			// summary:
			//		an object that makes a node moveable with a timer
			// node: Node||String
			//		a node (or node's id) to be moved
			// params: dojo.dnd.__TimedMoveableArgs
			//		object with additional parameters.
			
			// sanitize parameters
			if(!params){ params = {}; }
			if(params.timeout && typeof params.timeout == "number" && params.timeout >= 0){
				this.timeout = params.timeout;
			}
		},
	
		// markup methods
		markupFactory: function(params, node){
			return new dojo.dnd.TimedMoveable(node, params);
		},
	
		onMoveStop: function(/* dojo.dnd.Mover */ mover){
			if(mover._timer){
				// stop timer
				clearTimeout(mover._timer)
				// reflect the last received position
				oldOnMove.call(this, mover, mover._leftTop)
			}
			dojo.dnd.Moveable.prototype.onMoveStop.apply(this, arguments);
		},
		onMove: function(/* dojo.dnd.Mover */ mover, /* Object */ leftTop){
			mover._leftTop = leftTop;
			if(!mover._timer){
				var _t = this;	// to avoid using dojo.hitch()
				mover._timer = setTimeout(function(){
					// we don't have any pending requests
					mover._timer = null;
					// reflect the last received position
					oldOnMove.call(_t, mover, mover._leftTop);
				}, this.timeout);
			}
		}
	});
})();

}

if(!dojo._hasResource["dojo.i18n"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.i18n"] = true;
dojo.provide("dojo.i18n");

/*=====
dojo.i18n = {
	// summary: Utility classes to enable loading of resources for internationalization (i18n)
};
=====*/

dojo.i18n.getLocalization = function(/*String*/packageName, /*String*/bundleName, /*String?*/locale){
	//	summary:
	//		Returns an Object containing the localization for a given resource
	//		bundle in a package, matching the specified locale.
	//	description:
	//		Returns a hash containing name/value pairs in its prototypesuch
	//		that values can be easily overridden.  Throws an exception if the
	//		bundle is not found.  Bundle must have already been loaded by
	//		`dojo.requireLocalization()` or by a build optimization step.  NOTE:
	//		try not to call this method as part of an object property
	//		definition (`var foo = { bar: dojo.i18n.getLocalization() }`).  In
	//		some loading situations, the bundle may not be available in time
	//		for the object definition.  Instead, call this method inside a
	//		function that is run after all modules load or the page loads (like
	//		in `dojo.addOnLoad()`), or in a widget lifecycle method.
	//	packageName:
	//		package which is associated with this resource
	//	bundleName:
	//		the base filename of the resource bundle (without the ".js" suffix)
	//	locale:
	//		the variant to load (optional).  By default, the locale defined by
	//		the host environment: dojo.locale

	locale = dojo.i18n.normalizeLocale(locale);

	// look for nearest locale match
	var elements = locale.split('-');
	var module = [packageName,"nls",bundleName].join('.');
	var bundle = dojo._loadedModules[module];
	if(bundle){
		var localization;
		for(var i = elements.length; i > 0; i--){
			var loc = elements.slice(0, i).join('_');
			if(bundle[loc]){
				localization = bundle[loc];
				break;
			}
		}
		if(!localization){
			localization = bundle.ROOT;
		}

		// make a singleton prototype so that the caller won't accidentally change the values globally
		if(localization){
			var clazz = function(){};
			clazz.prototype = localization;
			return new clazz(); // Object
		}
	}

	throw new Error("Bundle not found: " + bundleName + " in " + packageName+" , locale=" + locale);
};

dojo.i18n.normalizeLocale = function(/*String?*/locale){
	//	summary:
	//		Returns canonical form of locale, as used by Dojo.
	//
	//  description:
	//		All variants are case-insensitive and are separated by '-' as specified in [RFC 3066](http://www.ietf.org/rfc/rfc3066.txt).
	//		If no locale is specified, the dojo.locale is returned.  dojo.locale is defined by
	//		the user agent's locale unless overridden by djConfig.

	var result = locale ? locale.toLowerCase() : dojo.locale;
	if(result == "root"){
		result = "ROOT";
	}
	return result; // String
};

dojo.i18n._requireLocalization = function(/*String*/moduleName, /*String*/bundleName, /*String?*/locale, /*String?*/availableFlatLocales){
	//	summary:
	//		See dojo.requireLocalization()
	//	description:
	// 		Called by the bootstrap, but factored out so that it is only
	// 		included in the build when needed.

	var targetLocale = dojo.i18n.normalizeLocale(locale);
 	var bundlePackage = [moduleName, "nls", bundleName].join(".");
	// NOTE: 
	//		When loading these resources, the packaging does not match what is
	//		on disk.  This is an implementation detail, as this is just a
	//		private data structure to hold the loaded resources.  e.g.
	//		`tests/hello/nls/en-us/salutations.js` is loaded as the object
	//		`tests.hello.nls.salutations.en_us={...}` The structure on disk is
	//		intended to be most convenient for developers and translators, but
	//		in memory it is more logical and efficient to store in a different
	//		order.  Locales cannot use dashes, since the resulting path will
	//		not evaluate as valid JS, so we translate them to underscores.
	
	//Find the best-match locale to load if we have available flat locales.
	var bestLocale = "";
	if(availableFlatLocales){
		var flatLocales = availableFlatLocales.split(",");
		for(var i = 0; i < flatLocales.length; i++){
			//Locale must match from start of string.
			//Using ["indexOf"] so customBase builds do not see
			//this as a dojo._base.array dependency.
			if(targetLocale["indexOf"](flatLocales[i]) == 0){
				if(flatLocales[i].length > bestLocale.length){
					bestLocale = flatLocales[i];
				}
			}
		}
		if(!bestLocale){
			bestLocale = "ROOT";
		}		
	}

	//See if the desired locale is already loaded.
	var tempLocale = availableFlatLocales ? bestLocale : targetLocale;
	var bundle = dojo._loadedModules[bundlePackage];
	var localizedBundle = null;
	if(bundle){
		if(dojo.config.localizationComplete && bundle._built){return;}
		var jsLoc = tempLocale.replace(/-/g, '_');
		var translationPackage = bundlePackage+"."+jsLoc;
		localizedBundle = dojo._loadedModules[translationPackage];
	}

	if(!localizedBundle){
		bundle = dojo["provide"](bundlePackage);
		var syms = dojo._getModuleSymbols(moduleName);
		var modpath = syms.concat("nls").join("/");
		var parent;

		dojo.i18n._searchLocalePath(tempLocale, availableFlatLocales, function(loc){
			var jsLoc = loc.replace(/-/g, '_');
			var translationPackage = bundlePackage + "." + jsLoc;
			var loaded = false;
			if(!dojo._loadedModules[translationPackage]){
				// Mark loaded whether it's found or not, so that further load attempts will not be made
				dojo["provide"](translationPackage);
				var module = [modpath];
				if(loc != "ROOT"){module.push(loc);}
				module.push(bundleName);
				var filespec = module.join("/") + '.js';
				loaded = dojo._loadPath(filespec, null, function(hash){
					// Use singleton with prototype to point to parent bundle, then mix-in result from loadPath
					var clazz = function(){};
					clazz.prototype = parent;
					bundle[jsLoc] = new clazz();
					for(var j in hash){ bundle[jsLoc][j] = hash[j]; }
				});
			}else{
				loaded = true;
			}
			if(loaded && bundle[jsLoc]){
				parent = bundle[jsLoc];
			}else{
				bundle[jsLoc] = parent;
			}
			
			if(availableFlatLocales){
				//Stop the locale path searching if we know the availableFlatLocales, since
				//the first call to this function will load the only bundle that is needed.
				return true;
			}
		});
	}

	//Save the best locale bundle as the target locale bundle when we know the
	//the available bundles.
	if(availableFlatLocales && targetLocale != bestLocale){
		bundle[targetLocale.replace(/-/g, '_')] = bundle[bestLocale.replace(/-/g, '_')];
	}
};

(function(){
	// If other locales are used, dojo.requireLocalization should load them as
	// well, by default. 
	// 
	// Override dojo.requireLocalization to do load the default bundle, then
	// iterate through the extraLocale list and load those translations as
	// well, unless a particular locale was requested.

	var extra = dojo.config.extraLocale;
	if(extra){
		if(!extra instanceof Array){
			extra = [extra];
		}

		var req = dojo.i18n._requireLocalization;
		dojo.i18n._requireLocalization = function(m, b, locale, availableFlatLocales){
			req(m,b,locale, availableFlatLocales);
			if(locale){return;}
			for(var i=0; i<extra.length; i++){
				req(m,b,extra[i], availableFlatLocales);
			}
		};
	}
})();

dojo.i18n._searchLocalePath = function(/*String*/locale, /*Boolean*/down, /*Function*/searchFunc){
	//	summary:
	//		A helper method to assist in searching for locale-based resources.
	//		Will iterate through the variants of a particular locale, either up
	//		or down, executing a callback function.  For example, "en-us" and
	//		true will try "en-us" followed by "en" and finally "ROOT".

	locale = dojo.i18n.normalizeLocale(locale);

	var elements = locale.split('-');
	var searchlist = [];
	for(var i = elements.length; i > 0; i--){
		searchlist.push(elements.slice(0, i).join('-'));
	}
	searchlist.push(false);
	if(down){searchlist.reverse();}

	for(var j = searchlist.length - 1; j >= 0; j--){
		var loc = searchlist[j] || "ROOT";
		var stop = searchFunc(loc);
		if(stop){ break; }
	}
};

dojo.i18n._preloadLocalizations = function(/*String*/bundlePrefix, /*Array*/localesGenerated){
	//	summary:
	//		Load built, flattened resource bundles, if available for all
	//		locales used in the page. Only called by built layer files.

	function preload(locale){
		locale = dojo.i18n.normalizeLocale(locale);
		dojo.i18n._searchLocalePath(locale, true, function(loc){
			for(var i=0; i<localesGenerated.length;i++){
				if(localesGenerated[i] == loc){
					dojo["require"](bundlePrefix+"_"+loc);
					return true; // Boolean
				}
			}
			return false; // Boolean
		});
	}
	preload();
	var extra = dojo.config.extraLocale||[];
	for(var i=0; i<extra.length; i++){
		preload(extra[i]);
	}
};

}

if(!dojo._hasResource["epages._workaround"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages._workaround"] = true;
dojo.provide("epages._workaround");

dojo['requireLocalization']("dojo.cldr", "gregorian");

epages._workaround.load = function(module) {
	if( module == 'dojo.parser' ){
		/* on run dojo parser run jQuery metaparse also */
		var parser = dojo.parser.parse;
		dojo.parser.parse = function( rootNode, args ){
			jQuery.ready( window.epkStack, function($){
				$(rootNode)
					.find('.ep-js')
					.metaparse();
			});
			return parser.call( dojo.parser, rootNode, args );
		};
		return;
	}

	if (module == 'epages.widget.Calendar' && dojo.version.revision == '0') {

		dijit._placeOnScreenAroundRect = function(
			/* DomNode */		node,
			/* Number */		x,
			/* Number */		y,
			/* Number */		width,
			/* Number */		height,
			/* Object */		aroundCorners,
			/* Function */		layoutNode){

			// summary:
			//		Like dijit.placeOnScreenAroundNode(), except it accepts coordinates
			//		of a rectangle to place node adjacent to.

			// TODO: combine with placeOnScreenAroundRectangle()

			// Generate list of possible positions for node
			var choices = [];
			for(var nodeCorner in aroundCorners){
				choices.push( {
					aroundCorner: nodeCorner,
					corner: aroundCorners[nodeCorner],
					pos: {
						x: x + (nodeCorner.charAt(1) == 'L' ? 0 : width),
						y: y + (nodeCorner.charAt(0) == 'T' ? 0 : height)
					}
				});
			}
		//Start of workaround
			// only correct popups (calendar) with {'BR':'TR','BL':'TL'}
			if (choices.length == 2 &&
				  choices[0].aroundCorner == 'BR' && choices[0].corner == 'TR' &&
					choices[1].aroundCorner == 'BL' && choices[1].corner == 'TL') {
						choices = choices.reverse();
			}
		//End of Workaround
			return dijit._place(node, choices, layoutNode);
		};

		return;
	}

	if (module == 'dijit.Tree' && dojo.version.revision == '20973') {

		//add publish to expand method of tree nodes
		dojo.connect(dijit._TreeNode.prototype, "expand", function() {
			dojo.publish(this.tree.id+'/nodeexpand',[this]);
		});

		return;
	}
	else if (module == 'dojo.cldr.supplemental') {
		dojo.cldr.supplemental.getFirstDayOfWeek = function(/*String?*/locale){
			if (dojo.i18n.normalizeLocale(locale) == djConfig.locale){
				return epages.vars.Locale.firstDayOfWeek;
			}
			// summary: Returns a zero-based index for first day of the week
			// description:
			//		Returns a zero-based index for first day of the week, as used by the local (Gregorian) calendar.
			//		e.g. Sunday (returns 0), or Monday (returns 1)

			// from http://www.unicode.org/cldr/data/common/supplemental/supplementalData.xml:supplementalData/weekData/firstDay
			var firstDay = {/*default is 1=Monday*/
				mv:5,
				ae:6,af:6,bh:6,dj:6,dz:6,eg:6,er:6,et:6,iq:6,ir:6,jo:6,ke:6,kw:6,lb:6,ly:6,ma:6,om:6,qa:6,sa:6,
				sd:6,so:6,tn:6,ye:6,
				as:0,au:0,az:0,bw:0,ca:0,cn:0,fo:0,ge:0,gl:0,gu:0,hk:0,ie:0,il:0,is:0,jm:0,jp:0,kg:0,kr:0,la:0,
				mh:0,mo:0,mp:0,mt:0,nz:0,ph:0,pk:0,sg:0,th:0,tt:0,tw:0,um:0,us:0,uz:0,vi:0,za:0,zw:0,
				et:0,mw:0,ng:0,tj:0,
				// variant. do not use?		gb:0,
				sy:4
			};

			var country = dojo.cldr.supplemental._region(locale);
			var dow = firstDay[country];
			return (dow === undefined) ? 1 : dow; /*Number*/
		};

		return;
	}

	if(module == 'dijit._Widget' && dojo.version.revision == '20973'){
		dijit._Widget.prototype._deferredConnects = {};

		return;
	}
};

dojo.connect(dojo, "require", epages._workaround, "load");




}

if(!dojo._hasResource["epages.epages"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.epages"] = true;
/*  EPages JavaScript module, $Revision: 1.88.20.1 $
 *  (c) 2006 ePages GmbH
 *--------------------------------------------------------------------------*/
dojo.provide("epages.epages");

(function() {
	// is this called in an iframe?
	// these vars are set, when epages is loaded in an iframe

	window.parentDojo = undefined;
	window.restrictedParent = undefined;

	try {
		window.parentDojo = parent.dojo ? parent.dojo : undefined;
		if(parent != self && !parent.dojo) {
			window.restrictedParent = true; // IE never throws an error inside of this try-catch statement
			dojo._global_omit_module_check = true; // dojo's module check would fail for IE in that case
		}
	}catch(ex) {
		window.restrictedParent = true;	// page embedded into cross site iframe -> resticted access
	}

	if(parent != self && window.parentDojo !== undefined) {
		parent.epages._windows.push(window);
		for( var i=0,iLength=parent.epages.onIframeStart.length ; i<iLength ; i++ ) {
			parent.epages.onIframeStart[i](parent, window);
		}
		// epages NavBars are globals
		if(epages.NavBars == undefined){
			epages.NavBars = {};
		}
		epages.NavBars = parent.epages.NavBars;
	}
})();

dojo.subscribe('epages/addGlobalSymbol', function(gvn, win) {
	if (win === undefined) {
		console.warn('no target window for addGlobalSymbol');
		return;
	}
	if (win[gvn] != null){
		return;
	}

	if(window.parentDojo){
		win[gvn] = parent[gvn];
	}
});

dojo.mixin( epages, {
	onIframeStart: [],
	onUnloadFunctions: [],
	topDojo: (parent != self && window.parentDojo !== undefined) ? window.parentDojo : dojo,
	topWindow: parent,
	constants: {
		preventCache: false,
		doFlashForward: true
	},
	theme: {
		name: 'epages',
		url:  dojo.moduleUrl('dijit.themes', 'epages')
	},
	// all known windows using epages
	_windows: [ window ],
	// all global vars
	_gvs: {},
	zIndex: 450,

	buildNode: function(attributeArray /* Array */, nodeOrTagRef /* String or DOM node */, content /* String - Optional */, containerNodeName /* String */) {
		// summary:
		//		Injects or expands a node in the current page source.
		// description:
		//		Since we're using attributes that are not valid XHTML syntax we have to cloak
		//		the instantiation of nodes with such attributes attached.
		//
		//		In the future this method could be used to increase the rendering performance.
		//		If the global configuration attribute "djConfig.parseOnLoad" is set to "false"
		//		we could take care of the parsing process in here (and therefore would save
		//		time which is now spent for the global dojo.query("[dojoType]") method).
		// attributeArray:
		//		An array with subarrays of the attributes to be attached to the node.
		// nodeOrTagRef:
		//		Can be a plain tag name > A new node with the specified tag will be created.
		//		Can be a node id as string > The specified node will be extended.
		//		Can be a node reference itself > The specified node will be extended.
		// content:
		//		The new content of the node.
		// example:
		//		epages.buildNode([
		//			["type", "text"],
		//			["dojoType", "epages.widget.NumberSpinner"],
		//			["name", "Quantity"],
		//			["class", "Quantity"],
		//			["value", "#MinOrder[float]"],
		//			["delta", "#IntervalOrder[float]"]
		//		], "input");

		if(attributeArray && attributeArray.length && nodeOrTagRef ) {

			var node;						// main node reference
			var containerNode;	// temporary parent node (never inserted to the DOM)

			if(typeof(nodeOrTagRef) === "string") {
				var nodeRef = $(nodeOrTagRef);
				if(nodeRef) {
					// an id string is passed
					node = nodeRef;
				}else {
					// a tag name is passed
					node = document.createElement(nodeOrTagRef);
					containerNode = document.createElement("div");
				}
			}else {
				// a node reference is passed
				node = nodeOrTagRef;
			}

			if(content) { // rewrites an existing node
				node.innerHTML = content;
			}

			for( var i=0,iLength=attributeArray.length ; i<iLength ; i++ ) {
				if(attributeArray[i][0] === "style") {
					node.style.cssText = attributeArray[i][1];
				}else if(attributeArray[i][0] === "name" && epages.Browser.engine === "MSIE") {
					// somehow the native attribute "name" is written uppercase in the MSIE. Hence we're attaching it separately for this browser.
					node.Name = attributeArray[i][1];
				}else {
					node.setAttribute(attributeArray[i][0], attributeArray[i][1]);
				}
			}

			if(containerNode) {
				if(!containerNodeName) {
					console.warn("error in buildNode method: no containerNodeName string given as container for creating new DOM nodes");
					return;
				}
				containerNode.appendChild(node);
				//document.write(containerNode.innerHTML);
				dojo.create('div', { 'innerHTML' : containerNode.innerHTML, 'style' : 'display:inline' }, containerNodeName, 'before');
			}
		}
	},

	flashForward: function () {
		return epages.constants.doFlashForward;
	},

	setTheme: function (/*String*/theme) {
		var body = dojo.body();
		var old = epages.theme.name;
		if (body){
			dojo.removeClass(body, epages.theme.name);
		} else {
			dojo.addOnLoad(function() {
				var body = dojo.body();
				if (body) {
					dojo.removeClass(body, epages.theme.name);
					dojo.addClass(body, theme);
				}
			});
		}
		epages.theme.name= theme;
		epages.theme.url = dojo.moduleUrl('dijit.themes', theme);
		if (body){
			dojo.addClass(body, theme);
		}
	},

	themeUrl: function (/*String*/path) {
		return epages.vars.IconsRoot;
	},

	reload: function() {
		window.location.hash += "0";
		var url = window.location.href;
		window.location.href = url.substring(0, url.indexOf('#'));
	},

	locationHref: function(uri) {
		window.location.href = uri.substr(0,1) == '?' ? epages.vars.BaseUrl + uri : uri;
	},

	setFormAction: function(formRef, newAction) {
		formRef.action = newAction.substr(0,1) == '?' ? epages.vars.BaseUrl + newAction : newAction;
	},

	locationWebRoot: function(uri) {
		return window.location.protocol + '//' + window.location.host + uri;
	},

	Class: function() {
		return function() {
			this.initialize.apply(this, arguments);
		};
	},

	changeSampleText: function(newdata,group) {
	// this function replaces the data in samp tags (newdata) which are specified
	// by their title attributes (group)
		if(!newdata){
			newdata="";
		}
		var sampletags = document.getElementsByTagName("samp");
		for( var i=0,iLength=sampletags.length ; i<iLength ; i++ ) {
			if(sampletags[i].getAttribute("title") == group) {
				if(sampletags[i].firstChild) {
					sampletags[i].firstChild.data = newdata;
				} else {
					var mydata = document.createTextNode(newdata);
					sampletags[i].appendChild(mydata);
				}
			}
		}
	},

	toggleNodes: function(className /* class of toggled elements */, clearSpace /* true = "display" else "visibility" */, classLimiter /* element that is been scanned for className */) {
		if(typeof className == "string") {
			if(typeof classLimiter == "undefined") {classLimiter = document;}
			if(typeof classLimiter == "string") {classLimiter = document.getElementById(classLimiter);}
			var domElements = classLimiter.getElementsByTagName("*");
			for( var i=0,iLength=domElements.length ; i<iLength ; i++ ) {
				if(domElements[i].attributes && domElements[i].attributes["class"] &&
						domElements[i].attributes["class"].nodeValue.indexOf(className) > -1) {
					if(clearSpace) {
						if(domElements[i].className.match(/HideNode/)) {
								domElements[i].className = domElements[i].className.replace(/HideNode/,'ShowNode');
						}else{
							if(domElements[i].className.match(/ShowNode/)) {
								domElements[i].className = domElements[i].className.replace(/ShowNode/,'HideNode');
							}else {
								if(domElements[i].style.display == "none"){
									domElements[i].style.display = "";
								}else if(domElements[i].style.display != "none"){
									domElements[i].style.display = "none";
								}
							}
						}
						if(domElements[i].className.match(/HideElement/)) {
								domElements[i].className = domElements[i].className.replace(/HideElement/,'ShowElement');
						}
					}else{
						if(domElements[i].style.visibility == "hidden") {
							domElements[i].style.visibility = "visible";
							if(domElements[i].style.display == "none"){
								domElements[i].style.display = "";
							}
							domElements[i].className = domElements[i].className.replace(/HideNode/,'ShowNode');
							domElements[i].className = domElements[i].className.replace(/HideElement/,'ShowElement');
						}else{
							domElements[i].style.visibility = "hidden";
						}
					}
				}
			}
		}
	},

	changeDelimiter: function(DelimiterSymbol, SelectId){
			switch(DelimiterSymbol) {
					case ',' :
					document.getElementById(SelectId).options[0].selected = 'selected';
					break;
					case ';' :
					document.getElementById(SelectId).options[1].selected = 'selected';
					break;
					default :
					document.getElementById(SelectId).options[2].selected = 'selected';
					break;
			}
	},

	toggleLink: function(LinkName){
		if(document.getElementsByName(LinkName)[0].className == 'ShowLink') {
			document.getElementsByName(LinkName)[0].className = 'HideLink';
		}
		else {
			document.getElementsByName(LinkName)[0].className = 'ShowLink';
		}
	},

	/* - MBO Search (Toolbar) -------------------------------------------------------------*/
	toggleExtender: function(object){
		// toggles between the image file names of the extend button
		// object => image node
		var splittedFilename = object.src.split("/");
		var lastItemNo = splittedFilename.length-1;
		var lastItem = splittedFilename[lastItemNo];

		if(lastItem=="toolbar_ico_s_extend.png") {
			splittedFilename[lastItemNo]="toolbar_ico_s_extend_open.png";
		} else {
			splittedFilename[lastItemNo]="toolbar_ico_s_extend.png";
		}
		object.src = splittedFilename.join("/");
	},

	getDocumentWindow: function(doc) {
		return (doc.parentWindow) ? doc.parentWindow : doc.defaultView;
	},

	// returns the url for the iframe wrapper
	// this is useful for external iframes to override/set the charset if it is missing
	getIframeWrapperUrl: function(/*string*/url, /*string?*/charset) {
		var src = '?iframeUrl=' + encodeURIComponent(url);
		if (charset){
			src += '&charset=' + encodeURIComponent(charset);
		}
		return dojo.moduleUrl('epages', 'iframe_wrapper.html') + src;
	},

	require: function(/*string*/packageName,/*modul*/modulName){
		//summary:
		//improve dojo.require to load shrinksafe packages
		//description:
		//check if modul is loaded
		//load package if it is not loaded
		//if package was not loaded correct do normal dojo.require

		// EPG-17181 : just do dojo.require
		if(modulName) {
			return dojo["require"](modulName);
		}
	},

	checkUnit: function(node,unitNode){
		//summary:
		//checks if unitNode has a value if node has a value
		//in error case DialogError class is added
		if(node && unitNode){
			if(unitNode.value === '' && node.value !== ''){
				dojo.addClass(unitNode, 'DialogError');
			}
			else{
				dojo.removeClass(unitNode, 'DialogError');
			}
		}
	}

});

// set default vars if not exists
if( !epages.vars ){
	epages.vars = { Locale: {} };
}

dojo.addOnLoad(function () { epages.setTheme(epages.theme.name); });

// load workarounds
dojo["require"]("epages._workaround");

$ = dojo.byId;

dojo.addOnLoad(function() {
	if(top == self){
		epages.vars.dojoUnloadStuff = window.onbeforeunload;
		window.onbeforeunload = function () {
			var l = false;
			var d = dojo;
			// for each registered epages.onUnloadFunctions element, exec the function and determine whether at least one function returned true
			d.forEach(epages.onUnloadFunctions, function (el) { l |= el(); });

			if (l) {
				d.require('epages.io.translation');
				return epages.io.dictionary.get("LoseChanges");
			}else {
				dojo["require"]("epages.browser");
				if(epages.Browser.engine == "MSIE" && epages.Browser.version > 6) {
					document.getElementsByTagName("body")[0].className += " SuspendUserInteraction";
					setTimeout(function() {
						dojo.removeClass(document.getElementsByTagName("body")[0], "SuspendUserInteraction");
					}, 2000);
					window.onunload = function() {
						if(epages.vars.dojoUnloadStuff) {epages.vars.dojoUnloadStuff();}
					};
				}
			}
			return;
		};
	}
});

epages.parentByTagName = function( node, tagName ){
	while( node.nodeName.toLocaleLowerCase()!=tagName ){
		node = node.parentNode;
		if( node.parentNode==document.body ){
			break;
		}
	}
	return node;
};

// set console (sometimes not set in time and hence throws an error)
try{
window.console = window.console || {};
window.console.debug = window.console.debug || function(){return;};
window.console.warn = window.console.warn || function(){return;};
}
catch(e){}

}

if(!dojo._hasResource['epages.preload']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.preload'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.preload $Revision: 1.8 $

*/
dojo.provide('epages.preload');


epages.Preload = {
	// summary:
	//  preloads the given sources
	// description:
	// |preloads given sources listed in the "files" array
	// |never call the _preloadFiles method directly - simply push the necessary file into the "files" array
	// |there are two required properties: "file" and "priority"
	// |  the "file" property is the path / src to your file
	// |  the "priority" property states the importance of that particular file (e. g. images usually have got a lower priority than js packages)
	// example:
	// | dojo.addOnLoad(function() {
	// |   epages.Preload.add({file:"ep_megapackage.js", priority: 9});
	// | });
	start: function() {
		// summary:
		//  starts / restarts the preloading
		this.stopped = false;
		this._preloadFiles();
	},
	stop: function() {
		// summary:
		//  stops the preload operation on the next queued element
		this.stopped = true;
	},
	add: function(fileObject) {
		// summary:
		//  adds a file to the "files" array
		if(fileObject.file && fileObject.priority) {
			var isAlreadyAdded = false;
			for( var i=0,iLength=this.files.length ; i<iLength ; i++ ) {
				if(this.files[i].file == fileObject.file) {
					isAlreadyAdded = true
					break;
				}
			}
			if(!isAlreadyAdded) {
				this.files.push(fileObject);
			}
		}
	},
	stopped: false,
	_preloadFiles: function() {
		if(!this.stopped && this.files.length > 0) {
			this.nextPreloadFile = this.files[0];
			for( var i=0,iLength=this.files.length ; i<iLength ; i++ ) {
				if(this.files[i].priority >= this.nextPreloadFile.priority) {
					this.nextPreloadFile = this.files[i];
				}
			}
			if(this.nextPreloadFile.priority != -1) {
				this.nextPreloadFile.priority = -1;
				dojo.xhrGet({
					url:  this.nextPreloadFile.file,
					sync: false,
					load: function(){
						epages.Preload._preloadFiles();
						if(djConfig.isDebug){
							console.log('epages.Preload loaded : ',epages.Preload.nextPreloadFile.file);
						}
					},
					error: function(){
						epages.Preload._preloadFiles();
						if(djConfig.isDebug){
							console.warn('epages.Preload could not load : ',epages.Preload.nextPreloadFile.file);
						}
					}
				});
			}
			// Since this is only used once on page load, we do not need to watch for changes in the *files* array,
			// and even if we had to, we should use some sort of event handling instead of timeout monitoring.
			/*else {
				// since we are through we can be a bit lazy - but we surely have to monitor the "files" array for realtime changes
				setTimeout(function() {epages.Preload._preloadFiles()}, 500);
			}*/
		}
	},
	files: [],
	nextPreloadFile: undefined
};

dojo.addOnLoad(function() {
	if(epages.vars.BusyLayerActive){
		dojo.subscribe("uimessage/stopBusy",function(owner, timeout, duration){
			setTimeout(function(){
				epages.Preload.start();
			},timeout);
		});
	}
	else{
		setTimeout(function() {
			epages.Preload.start();
		}, 100);
	}
})

}

if(!dojo._hasResource["dijit._base.manager"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.manager"] = true;
dojo.provide("dijit._base.manager");

dojo.declare("dijit.WidgetSet", null, {
	// summary:
	//		A set of widgets indexed by id. A default instance of this class is
	//		available as `dijit.registry`
	//
	// example:
	//		Create a small list of widgets:
	//		|	var ws = new dijit.WidgetSet();
	//		|	ws.add(dijit.byId("one"));
	//		| 	ws.add(dijit.byId("two"));
	//		|	// destroy both:
	//		|	ws.forEach(function(w){ w.destroy(); });
	//
	// example:
	//		Using dijit.registry:
	//		|	dijit.registry.forEach(function(w){ /* do something */ });

	constructor: function(){
		this._hash = {};
		this.length = 0;
	},

	add: function(/*dijit._Widget*/ widget){
		// summary:
		//		Add a widget to this list. If a duplicate ID is detected, a error is thrown.
		//
		// widget: dijit._Widget
		//		Any dijit._Widget subclass.
		if(this._hash[widget.id]){
			throw new Error("Tried to register widget with id==" + widget.id + " but that id is already registered");
		}
		this._hash[widget.id] = widget;
		this.length++;
	},

	remove: function(/*String*/ id){
		// summary:
		//		Remove a widget from this WidgetSet. Does not destroy the widget; simply
		//		removes the reference.
		if(this._hash[id]){
			delete this._hash[id];
			this.length--;
		}
	},

	forEach: function(/*Function*/ func, /* Object? */thisObj){
		// summary:
		//		Call specified function for each widget in this set.
		//
		// func:
		//		A callback function to run for each item. Is passed the widget, the index
		//		in the iteration, and the full hash, similar to `dojo.forEach`.
		//
		// thisObj:
		//		An optional scope parameter
		//
		// example:
		//		Using the default `dijit.registry` instance:
		//		|	dijit.registry.forEach(function(widget){
		//		|		console.log(widget.declaredClass);
		//		|	});
		//
		// returns:
		//		Returns self, in order to allow for further chaining.

		thisObj = thisObj || dojo.global;
		var i = 0, id;
		for(id in this._hash){
			func.call(thisObj, this._hash[id], i++, this._hash);
		}
		return this;	// dijit.WidgetSet
	},

	filter: function(/*Function*/ filter, /* Object? */thisObj){
		// summary:
		//		Filter down this WidgetSet to a smaller new WidgetSet
		//		Works the same as `dojo.filter` and `dojo.NodeList.filter`
		//
		// filter:
		//		Callback function to test truthiness. Is passed the widget
		//		reference and the pseudo-index in the object.
		//
		// thisObj: Object?
		//		Option scope to use for the filter function.
		//
		// example:
		//		Arbitrary: select the odd widgets in this list
		//		|	dijit.registry.filter(function(w, i){
		//		|		return i % 2 == 0;
		//		|	}).forEach(function(w){ /* odd ones */ });

		thisObj = thisObj || dojo.global;
		var res = new dijit.WidgetSet(), i = 0, id;
		for(id in this._hash){
			var w = this._hash[id];
			if(filter.call(thisObj, w, i++, this._hash)){
				res.add(w);
			}
		}
		return res; // dijit.WidgetSet
	},

	byId: function(/*String*/ id){
		// summary:
		//		Find a widget in this list by it's id.
		// example:
		//		Test if an id is in a particular WidgetSet
		//		| var ws = new dijit.WidgetSet();
		//		| ws.add(dijit.byId("bar"));
		//		| var t = ws.byId("bar") // returns a widget
		//		| var x = ws.byId("foo"); // returns undefined

		return this._hash[id];	// dijit._Widget
	},

	byClass: function(/*String*/ cls){
		// summary:
		//		Reduce this widgetset to a new WidgetSet of a particular `declaredClass`
		//
		// cls: String
		//		The Class to scan for. Full dot-notated string.
		//
		// example:
		//		Find all `dijit.TitlePane`s in a page:
		//		|	dijit.registry.byClass("dijit.TitlePane").forEach(function(tp){ tp.close(); });

		var res = new dijit.WidgetSet(), id, widget;
		for(id in this._hash){
			widget = this._hash[id];
			if(widget.declaredClass == cls){
				res.add(widget);
			}
		 }
		 return res; // dijit.WidgetSet
},

	toArray: function(){
		// summary:
		//		Convert this WidgetSet into a true Array
		//
		// example:
		//		Work with the widget .domNodes in a real Array
		//		|	dojo.map(dijit.registry.toArray(), function(w){ return w.domNode; });

		var ar = [];
		for(var id in this._hash){
			ar.push(this._hash[id]);
		}
		return ar;	// dijit._Widget[]
},

	map: function(/* Function */func, /* Object? */thisObj){
		// summary:
		//		Create a new Array from this WidgetSet, following the same rules as `dojo.map`
		// example:
		//		|	var nodes = dijit.registry.map(function(w){ return w.domNode; });
		//
		// returns:
		//		A new array of the returned values.
		return dojo.map(this.toArray(), func, thisObj); // Array
	},

	every: function(func, thisObj){
		// summary:
		// 		A synthetic clone of `dojo.every` acting explictly on this WidgetSet
		//
		// func: Function
		//		A callback function run for every widget in this list. Exits loop
		//		when the first false return is encountered.
		//
		// thisObj: Object?
		//		Optional scope parameter to use for the callback

		thisObj = thisObj || dojo.global;
		var x = 0, i;
		for(i in this._hash){
			if(!func.call(thisObj, this._hash[i], x++, this._hash)){
				return false; // Boolean
			}
		}
		return true; // Boolean
	},

	some: function(func, thisObj){
		// summary:
		// 		A synthetic clone of `dojo.some` acting explictly on this WidgetSet
		//
		// func: Function
		//		A callback function run for every widget in this list. Exits loop
		//		when the first true return is encountered.
		//
		// thisObj: Object?
		//		Optional scope parameter to use for the callback

		thisObj = thisObj || dojo.global;
		var x = 0, i;
		for(i in this._hash){
			if(func.call(thisObj, this._hash[i], x++, this._hash)){
				return true; // Boolean
			}
		}
		return false; // Boolean
	}

});

/*=====
dijit.registry = {
	// summary:
	//		A list of widgets on a page.
	// description:
	//		Is an instance of `dijit.WidgetSet`
};
=====*/
dijit.registry= new dijit.WidgetSet();

dijit._widgetTypeCtr = {};

dijit.getUniqueId = function(/*String*/widgetType){
	// summary:
	//		Generates a unique id for a given widgetType

	var id;
	do{
		id = widgetType + "_" +
			(widgetType in dijit._widgetTypeCtr ?
				++dijit._widgetTypeCtr[widgetType] : dijit._widgetTypeCtr[widgetType] = 0);
	}while(dijit.byId(id));
	return id; // String
};

dijit.findWidgets = function(/*DomNode*/ root){
	// summary:
	//		Search subtree under root returning widgets found.
	//		Doesn't search for nested widgets (ie, widgets inside other widgets).

	var outAry = [];

	function getChildrenHelper(root){
		for(var node = root.firstChild; node; node = node.nextSibling){
			if(node.nodeType == 1){
				var widgetId = node.getAttribute("widgetId");
				if(widgetId){
					var widget = dijit.byId(widgetId);
					outAry.push(widget);
				}else{
					getChildrenHelper(node);
				}
			}
		}
	}

	getChildrenHelper(root);
	return outAry;
};

dijit._destroyAll = function(){
	// summary:
	//		Code to destroy all widgets and do other cleanup on page unload

	// Clean up focus manager lingering references to widgets and nodes
	dijit._curFocus = null;
	dijit._prevFocus = null;
	dijit._activeStack = [];

	// Destroy all the widgets, top down
	dojo.forEach(dijit.findWidgets(dojo.body()), function(widget){
		// Avoid double destroy of widgets like Menu that are attached to <body>
		// even though they are logically children of other widgets.
		if(!widget._destroyed){
			if(widget.destroyRecursive){
				widget.destroyRecursive();
			}else if(widget.destroy){
				widget.destroy();
			}
		}
	});
};

if(dojo.isIE){
	// Only run _destroyAll() for IE because we think it's only necessary in that case,
	// and because it causes problems on FF.  See bug #3531 for details.
	dojo.addOnWindowUnload(function(){
		dijit._destroyAll();
	});
}

dijit.byId = function(/*String|Widget*/id){
	// summary:
	//		Returns a widget by it's id, or if passed a widget, no-op (like dojo.byId())
	return typeof id == "string" ? dijit.registry._hash[id] : id; // dijit._Widget
};

dijit.byNode = function(/* DOMNode */ node){
	// summary:
	//		Returns the widget corresponding to the given DOMNode
	return dijit.registry.byId(node.getAttribute("widgetId")); // dijit._Widget
};

dijit.getEnclosingWidget = function(/* DOMNode */ node){
	// summary:
	//		Returns the widget whose DOM tree contains the specified DOMNode, or null if
	//		the node is not contained within the DOM tree of any widget
	while(node){
		var id = node.getAttribute && node.getAttribute("widgetId");
		if(id){
			return dijit.byId(id);
		}
		node = node.parentNode;
	}
	return null;
};

dijit._isElementShown = function(/*Element*/elem){
	var style = dojo.style(elem);
	return (style.visibility != "hidden")
		&& (style.visibility != "collapsed")
		&& (style.display != "none")
		&& (dojo.attr(elem, "type") != "hidden");
}

dijit.isTabNavigable = function(/*Element*/elem){
	// summary:
	//		Tests if an element is tab-navigable

	// TODO: convert (and rename method) to return effectivite tabIndex; will save time in _getTabNavigable()
	if(dojo.attr(elem, "disabled")){
		return false;
	}else if(dojo.hasAttr(elem, "tabIndex")){
		// Explicit tab index setting
		return dojo.attr(elem, "tabIndex") >= 0; // boolean
	}else{
		// No explicit tabIndex setting, need to investigate node type
		switch(elem.nodeName.toLowerCase()){
			case "a":
				// An <a> w/out a tabindex is only navigable if it has an href
				return dojo.hasAttr(elem, "href");
			case "area":
			case "button":
			case "input":
			case "object":
			case "select":
			case "textarea":
				// These are navigable by default
				return true;
			case "iframe":
				// If it's an editor <iframe> then it's tab navigable.
				if(dojo.isMoz){
					return elem.contentDocument.designMode == "on";
				}else if(dojo.isWebKit){
					var doc = elem.contentDocument,
						body = doc && doc.body;
					return body && body.contentEditable == 'true';
				}else{
					doc = elem.contentWindow.document;
					body = doc && doc.body;
					return body && body.firstChild && body.firstChild.contentEditable == 'true';
				}
			default:
				return elem.contentEditable == 'true';
		}
	}
};

dijit._getTabNavigable = function(/*DOMNode*/root){
	// summary:
	//		Finds descendants of the specified root node.
	//
	// description:
	//		Finds the following descendants of the specified root node:
	//		* the first tab-navigable element in document order
	//		  without a tabIndex or with tabIndex="0"
	//		* the last tab-navigable element in document order
	//		  without a tabIndex or with tabIndex="0"
	//		* the first element in document order with the lowest
	//		  positive tabIndex value
	//		* the last element in document order with the highest
	//		  positive tabIndex value
	var first, last, lowest, lowestTabindex, highest, highestTabindex;
	var walkTree = function(/*DOMNode*/parent){
		dojo.query("> *", parent).forEach(function(child){
			var isShown = dijit._isElementShown(child);
			if(isShown && dijit.isTabNavigable(child)){
				var tabindex = dojo.attr(child, "tabIndex");
				if(!dojo.hasAttr(child, "tabIndex") || tabindex == 0){
					if(!first){ first = child; }
					last = child;
				}else if(tabindex > 0){
					if(!lowest || tabindex < lowestTabindex){
						lowestTabindex = tabindex;
						lowest = child;
					}
					if(!highest || tabindex >= highestTabindex){
						highestTabindex = tabindex;
						highest = child;
					}
				}
			}
			if(isShown && child.nodeName.toUpperCase() != 'SELECT'){ walkTree(child) }
		});
	};
	if(dijit._isElementShown(root)){ walkTree(root) }
	return { first: first, last: last, lowest: lowest, highest: highest };
}
dijit.getFirstInTabbingOrder = function(/*String|DOMNode*/root){
	// summary:
	//		Finds the descendant of the specified root node
	//		that is first in the tabbing order
	var elems = dijit._getTabNavigable(dojo.byId(root));
	return elems.lowest ? elems.lowest : elems.first; // DomNode
};

dijit.getLastInTabbingOrder = function(/*String|DOMNode*/root){
	// summary:
	//		Finds the descendant of the specified root node
	//		that is last in the tabbing order
	var elems = dijit._getTabNavigable(dojo.byId(root));
	return elems.last ? elems.last : elems.highest; // DomNode
};

/*=====
dojo.mixin(dijit, {
	// defaultDuration: Integer
	//		The default animation speed (in ms) to use for all Dijit
	//		transitional animations, unless otherwise specified
	//		on a per-instance basis. Defaults to 200, overrided by
	//		`djConfig.defaultDuration`
	defaultDuration: 300
});
=====*/

dijit.defaultDuration = dojo.config["defaultDuration"] || 200;

}

if(!dojo._hasResource["dijit._base.focus"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.focus"] = true;
dojo.provide("dijit._base.focus");

	// for dijit.isTabNavigable()

// summary:
//		These functions are used to query or set the focus and selection.
//
//		Also, they trace when widgets become activated/deactivated,
//		so that the widget can fire _onFocus/_onBlur events.
//		"Active" here means something similar to "focused", but
//		"focus" isn't quite the right word because we keep track of
//		a whole stack of "active" widgets.  Example: ComboButton --> Menu -->
//		MenuItem.  The onBlur event for ComboButton doesn't fire due to focusing
//		on the Menu or a MenuItem, since they are considered part of the
//		ComboButton widget.  It only happens when focus is shifted
//		somewhere completely different.

dojo.mixin(dijit, {
	// _curFocus: DomNode
	//		Currently focused item on screen
	_curFocus: null,

	// _prevFocus: DomNode
	//		Previously focused item on screen
	_prevFocus: null,

	isCollapsed: function(){
		// summary:
		//		Returns true if there is no text selected
		return dijit.getBookmark().isCollapsed;
	},

	getBookmark: function(){
		// summary:
		//		Retrieves a bookmark that can be used with moveToBookmark to return to the same range
		var bm, rg, tg, sel = dojo.doc.selection, cf = dijit._curFocus;

		if(dojo.global.getSelection){
			//W3C Range API for selections.
			sel = dojo.global.getSelection();
			if(sel){
				if(sel.isCollapsed){
					tg = cf? cf.tagName : "";
					if(tg){
						//Create a fake rangelike item to restore selections.
						tg = tg.toLowerCase();
						if(tg == "textarea" ||
								(tg == "input" && (!cf.type || cf.type.toLowerCase() == "text"))){
							sel = {
								start: cf.selectionStart,
								end: cf.selectionEnd,
								node: cf,
								pRange: true
							};
							return {isCollapsed: (sel.end <= sel.start), mark: sel}; //Object.
						}
					}
					bm = {isCollapsed:true};
				}else{
					rg = sel.getRangeAt(0);
					bm = {isCollapsed: false, mark: rg.cloneRange()};
				}
			}
		}else if(sel){
			// If the current focus was a input of some sort and no selection, don't bother saving
			// a native bookmark.  This is because it causes issues with dialog/page selection restore.
			// So, we need to create psuedo bookmarks to work with.
			tg = cf ? cf.tagName : "";
			tg = tg.toLowerCase();
			if(cf && tg && (tg == "button" || tg == "textarea" || tg == "input")){
				if(sel.type && sel.type.toLowerCase() == "none"){
					return {
						isCollapsed: true,
						mark: null
					}
				}else{
					rg = sel.createRange();
					return {
						isCollapsed: rg.text && rg.text.length?false:true,
						mark: {
							range: rg,
							pRange: true
						}
					};
				}
			}
			bm = {};

			//'IE' way for selections.
			try{
				// createRange() throws exception when dojo in iframe
				//and nothing selected, see #9632
				rg = sel.createRange();
				bm.isCollapsed = !(sel.type == 'Text' ? rg.htmlText.length : rg.length);
			}catch(e){
				bm.isCollapsed = true;
				return bm;
			}
			if(sel.type.toUpperCase() == 'CONTROL'){
				if(rg.length){
					bm.mark=[];
					var i=0,len=rg.length;
					while(i<len){
						bm.mark.push(rg.item(i++));
					}
				}else{
					bm.isCollapsed = true;
					bm.mark = null;
				}
			}else{
				bm.mark = rg.getBookmark();
			}
		}else{
			console.warn("No idea how to store the current selection for this browser!");
		}
		return bm; // Object
	},

	moveToBookmark: function(/*Object*/bookmark){
		// summary:
		//		Moves current selection to a bookmark
		// bookmark:
		//		This should be a returned object from dijit.getBookmark()

		var _doc = dojo.doc,
			mark = bookmark.mark;
		if(mark){
			if(dojo.global.getSelection){
				//W3C Rangi API (FF, WebKit, Opera, etc)
				var sel = dojo.global.getSelection();
				if(sel && sel.removeAllRanges){
					if(mark.pRange){
						var r = mark;
						var n = r.node;
						n.selectionStart = r.start;
						n.selectionEnd = r.end;
					}else{
						sel.removeAllRanges();
						sel.addRange(mark);
					}
				}else{
					console.warn("No idea how to restore selection for this browser!");
				}
			}else if(_doc.selection && mark){
				//'IE' way.
				var rg;
				if(mark.pRange){
					rg = mark.range;
				}else if(dojo.isArray(mark)){
					rg = _doc.body.createControlRange();
					//rg.addElement does not have call/apply method, so can not call it directly
					//rg is not available in "range.addElement(item)", so can't use that either
					dojo.forEach(mark, function(n){
						rg.addElement(n);
					});
				}else{
					rg = _doc.body.createTextRange();
					rg.moveToBookmark(mark);
				}
				rg.select();
			}
		}
	},

	getFocus: function(/*Widget?*/ menu, /*Window?*/ openedForWindow){
		// summary:
		//		Called as getFocus(), this returns an Object showing the current focus
		//		and selected text.
		//
		//		Called as getFocus(widget), where widget is a (widget representing) a button
		//		that was just pressed, it returns where focus was before that button
		//		was pressed.   (Pressing the button may have either shifted focus to the button,
		//		or removed focus altogether.)   In this case the selected text is not returned,
		//		since it can't be accurately determined.
		//
		// menu: dijit._Widget or {domNode: DomNode} structure
		//		The button that was just pressed.  If focus has disappeared or moved
		//		to this button, returns the previous focus.  In this case the bookmark
		//		information is already lost, and null is returned.
		//
		// openedForWindow:
		//		iframe in which menu was opened
		//
		// returns:
		//		A handle to restore focus/selection, to be passed to `dijit.focus`
		var node = !dijit._curFocus || (menu && dojo.isDescendant(dijit._curFocus, menu.domNode)) ? dijit._prevFocus : dijit._curFocus;
		return {
			node: node,
			bookmark: (node == dijit._curFocus) && dojo.withGlobal(openedForWindow || dojo.global, dijit.getBookmark),
			openedForWindow: openedForWindow
		}; // Object
	},

	focus: function(/*Object || DomNode */ handle){
		// summary:
		//		Sets the focused node and the selection according to argument.
		//		To set focus to an iframe's content, pass in the iframe itself.
		// handle:
		//		object returned by get(), or a DomNode

		if(!handle){ return; }

		var node = "node" in handle ? handle.node : handle,		// because handle is either DomNode or a composite object
			bookmark = handle.bookmark,
			openedForWindow = handle.openedForWindow,
			collapsed = bookmark ? bookmark.isCollapsed : false;

		// Set the focus
		// Note that for iframe's we need to use the <iframe> to follow the parentNode chain,
		// but we need to set focus to iframe.contentWindow
		if(node){
			var focusNode = (node.tagName.toLowerCase() == "iframe") ? node.contentWindow : node;
			if(focusNode && focusNode.focus){
				try{
					// Gecko throws sometimes if setting focus is impossible,
					// node not displayed or something like that
					focusNode.focus();
				}catch(e){/*quiet*/}
			}
			dijit._onFocusNode(node);
		}

		// set the selection
		// do not need to restore if current selection is not empty
		// (use keyboard to select a menu item) or if previous selection was collapsed
		// as it may cause focus shift (Esp in IE).
		if(bookmark && dojo.withGlobal(openedForWindow || dojo.global, dijit.isCollapsed) && !collapsed){
			if(openedForWindow){
				openedForWindow.focus();
			}
			try{
				dojo.withGlobal(openedForWindow || dojo.global, dijit.moveToBookmark, null, [bookmark]);
			}catch(e2){
				/*squelch IE internal error, see http://trac.dojotoolkit.org/ticket/1984 */
			}
		}
	},

	// _activeStack: dijit._Widget[]
	//		List of currently active widgets (focused widget and it's ancestors)
	_activeStack: [],

	registerIframe: function(/*DomNode*/ iframe){
		// summary:
		//		Registers listeners on the specified iframe so that any click
		//		or focus event on that iframe (or anything in it) is reported
		//		as a focus/click event on the <iframe> itself.
		// description:
		//		Currently only used by editor.
		// returns:
		//		Handle to pass to unregisterIframe()
		return dijit.registerWin(iframe.contentWindow, iframe);
	},

	unregisterIframe: function(/*Object*/ handle){
		// summary:
		//		Unregisters listeners on the specified iframe created by registerIframe.
		//		After calling be sure to delete or null out the handle itself.
		// handle:
		//		Handle returned by registerIframe()

		dijit.unregisterWin(handle);
	},

	registerWin: function(/*Window?*/targetWindow, /*DomNode?*/ effectiveNode){
		// summary:
		//		Registers listeners on the specified window (either the main
		//		window or an iframe's window) to detect when the user has clicked somewhere
		//		or focused somewhere.
		// description:
		//		Users should call registerIframe() instead of this method.
		// targetWindow:
		//		If specified this is the window associated with the iframe,
		//		i.e. iframe.contentWindow.
		// effectiveNode:
		//		If specified, report any focus events inside targetWindow as
		//		an event on effectiveNode, rather than on evt.target.
		// returns:
		//		Handle to pass to unregisterWin()

		// TODO: make this function private in 2.0; Editor/users should call registerIframe(),

		var mousedownListener = function(evt){
			dijit._justMouseDowned = true;
			setTimeout(function(){ dijit._justMouseDowned = false; }, 0);
			dijit._onTouchNode(effectiveNode || evt.target || evt.srcElement, "mouse");
		};
		//dojo.connect(targetWindow, "onscroll", ???);

		// Listen for blur and focus events on targetWindow's document.
		// IIRC, I'm using attachEvent() rather than dojo.connect() because focus/blur events don't bubble
		// through dojo.connect(), and also maybe to catch the focus events early, before onfocus handlers
		// fire.
		// Connect to <html> (rather than document) on IE to avoid memory leaks, but document on other browsers because
		// (at least for FF) the focus event doesn't fire on <html> or <body>.
		var doc = dojo.isIE ? targetWindow.document.documentElement : targetWindow.document;
		if(doc){
			if(dojo.isIE){
				doc.attachEvent('onmousedown', mousedownListener);
				var activateListener = function(evt){
					// IE reports that nodes like <body> have gotten focus, even though they have tabIndex=-1,
					// Should consider those more like a mouse-click than a focus....
					if(evt.srcElement.tagName.toLowerCase() != "#document" &&
						dijit.isTabNavigable(evt.srcElement)){
						dijit._onFocusNode(effectiveNode || evt.srcElement);
					}else{
						dijit._onTouchNode(effectiveNode || evt.srcElement);
					}
				};
				doc.attachEvent('onactivate', activateListener);
				var deactivateListener =  function(evt){
					dijit._onBlurNode(effectiveNode || evt.srcElement);
				};
				doc.attachEvent('ondeactivate', deactivateListener);

				return function(){
					doc.detachEvent('onmousedown', mousedownListener);
					doc.detachEvent('onactivate', activateListener);
					doc.detachEvent('ondeactivate', deactivateListener);
					doc = null;	// prevent memory leak (apparent circular reference via closure)
				};
			}else{
				doc.addEventListener('mousedown', mousedownListener, true);
				var focusListener = function(evt){
					dijit._onFocusNode(effectiveNode || evt.target);
				};
				doc.addEventListener('focus', focusListener, true);
				var blurListener = function(evt){
					dijit._onBlurNode(effectiveNode || evt.target);
				};
				doc.addEventListener('blur', blurListener, true);

				return function(){
					doc.removeEventListener('mousedown', mousedownListener, true);
					doc.removeEventListener('focus', focusListener, true);
					doc.removeEventListener('blur', blurListener, true);
					doc = null;	// prevent memory leak (apparent circular reference via closure)
				};
			}
		}
	},

	unregisterWin: function(/*Handle*/ handle){
		// summary:
		//		Unregisters listeners on the specified window (either the main
		//		window or an iframe's window) according to handle returned from registerWin().
		//		After calling be sure to delete or null out the handle itself.

		// Currently our handle is actually a function
		handle && handle();
	},

	_onBlurNode: function(/*DomNode*/ node){
		// summary:
		// 		Called when focus leaves a node.
		//		Usually ignored, _unless_ it *isn't* follwed by touching another node,
		//		which indicates that we tabbed off the last field on the page,
		//		in which case every widget is marked inactive
		dijit._prevFocus = dijit._curFocus;
		dijit._curFocus = null;

		if(dijit._justMouseDowned){
			// the mouse down caused a new widget to be marked as active; this blur event
			// is coming late, so ignore it.
			return;
		}

		// if the blur event isn't followed by a focus event then mark all widgets as inactive.
		if(dijit._clearActiveWidgetsTimer){
			clearTimeout(dijit._clearActiveWidgetsTimer);
		}
		dijit._clearActiveWidgetsTimer = setTimeout(function(){
			delete dijit._clearActiveWidgetsTimer;
			dijit._setStack([]);
			dijit._prevFocus = null;
		}, 100);
	},

	_onTouchNode: function(/*DomNode*/ node, /*String*/ by){
		// summary:
		//		Callback when node is focused or mouse-downed
		// node:
		//		The node that was touched.
		// by:
		//		"mouse" if the focus/touch was caused by a mouse down event

		// ignore the recent blurNode event
		if(dijit._clearActiveWidgetsTimer){
			clearTimeout(dijit._clearActiveWidgetsTimer);
			delete dijit._clearActiveWidgetsTimer;
		}

		// compute stack of active widgets (ex: ComboButton --> Menu --> MenuItem)
		var newStack=[];
		try{
			while(node){
				var popupParent = dojo.attr(node, "dijitPopupParent");
				if(popupParent){
					node=dijit.byId(popupParent).domNode;
				}else if(node.tagName && node.tagName.toLowerCase() == "body"){
					// is this the root of the document or just the root of an iframe?
					if(node === dojo.body()){
						// node is the root of the main document
						break;
					}
					// otherwise, find the iframe this node refers to (can't access it via parentNode,
					// need to do this trick instead). window.frameElement is supported in IE/FF/Webkit
					node=dijit.getDocumentWindow(node.ownerDocument).frameElement;
				}else{
					var id = node.getAttribute && node.getAttribute("widgetId");
					if(id){
						newStack.unshift(id);
					}
					node=node.parentNode;
				}
			}
		}catch(e){ /* squelch */ }

		dijit._setStack(newStack, by);
	},

	_onFocusNode: function(/*DomNode*/ node){
		// summary:
		//		Callback when node is focused

		if(!node){
			return;
		}

		if(node.nodeType == 9){
			// Ignore focus events on the document itself.  This is here so that
			// (for example) clicking the up/down arrows of a spinner
			// (which don't get focus) won't cause that widget to blur. (FF issue)
			return;
		}

		dijit._onTouchNode(node);

		if(node == dijit._curFocus){ return; }
		if(dijit._curFocus){
			dijit._prevFocus = dijit._curFocus;
		}
		dijit._curFocus = node;
		dojo.publish("focusNode", [node]);
	},

	_setStack: function(/*String[]*/ newStack, /*String*/ by){
		// summary:
		//		The stack of active widgets has changed.  Send out appropriate events and records new stack.
		// newStack:
		//		array of widget id's, starting from the top (outermost) widget
		// by:
		//		"mouse" if the focus/touch was caused by a mouse down event

		var oldStack = dijit._activeStack;
		dijit._activeStack = newStack;

		// compare old stack to new stack to see how many elements they have in common
		for(var nCommon=0; nCommon<Math.min(oldStack.length, newStack.length); nCommon++){
			if(oldStack[nCommon] != newStack[nCommon]){
				break;
			}
		}

		var widget;
		// for all elements that have gone out of focus, send blur event
		for(var i=oldStack.length-1; i>=nCommon; i--){
			widget = dijit.byId(oldStack[i]);
			if(widget){
				widget._focused = false;
				widget._hasBeenBlurred = true;
				if(widget._onBlur){
					widget._onBlur(by);
				}
				if(widget._setStateClass){
					widget._setStateClass();
				}
				dojo.publish("widgetBlur", [widget, by]);
			}
		}

		// for all element that have come into focus, send focus event
		for(i=nCommon; i<newStack.length; i++){
			widget = dijit.byId(newStack[i]);
			if(widget){
				widget._focused = true;
				if(widget._onFocus){
					widget._onFocus(by);
				}
				if(widget._setStateClass){
					widget._setStateClass();
				}
				dojo.publish("widgetFocus", [widget, by]);
			}
		}
	}
});

// register top window and all the iframes it contains
dojo.addOnLoad(function(){
	var handle = dijit.registerWin(window);
	if(dojo.isIE){
		dojo.addOnWindowUnload(function(){
			dijit.unregisterWin(handle);
			handle = null;
		})
	}
});

}

if(!dojo._hasResource["dojo.AdapterRegistry"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.AdapterRegistry"] = true;
dojo.provide("dojo.AdapterRegistry");

dojo.AdapterRegistry = function(/*Boolean?*/ returnWrappers){
	//	summary:
	//		A registry to make contextual calling/searching easier.
	//	description:
	//		Objects of this class keep list of arrays in the form [name, check,
	//		wrap, directReturn] that are used to determine what the contextual
	//		result of a set of checked arguments is. All check/wrap functions
	//		in this registry should be of the same arity.
	//	example:
	//	|	// create a new registry
	//	|	var reg = new dojo.AdapterRegistry();
	//	|	reg.register("handleString",
	//	|		dojo.isString,
	//	|		function(str){
	//	|			// do something with the string here
	//	|		}
	//	|	);
	//	|	reg.register("handleArr",
	//	|		dojo.isArray,
	//	|		function(arr){
	//	|			// do something with the array here
	//	|		}
	//	|	);
	//	|
	//	|	// now we can pass reg.match() *either* an array or a string and
	//	|	// the value we pass will get handled by the right function
	//	|	reg.match("someValue"); // will call the first function
	//	|	reg.match(["someValue"]); // will call the second

	this.pairs = [];
	this.returnWrappers = returnWrappers || false; // Boolean
}

dojo.extend(dojo.AdapterRegistry, {
	register: function(/*String*/ name, /*Function*/ check, /*Function*/ wrap, /*Boolean?*/ directReturn, /*Boolean?*/ override){
		//	summary: 
		//		register a check function to determine if the wrap function or
		//		object gets selected
		//	name:
		//		a way to identify this matcher.
		//	check:
		//		a function that arguments are passed to from the adapter's
		//		match() function.  The check function should return true if the
		//		given arguments are appropriate for the wrap function.
		//	directReturn:
		//		If directReturn is true, the value passed in for wrap will be
		//		returned instead of being called. Alternately, the
		//		AdapterRegistry can be set globally to "return not call" using
		//		the returnWrappers property. Either way, this behavior allows
		//		the registry to act as a "search" function instead of a
		//		function interception library.
		//	override:
		//		If override is given and true, the check function will be given
		//		highest priority. Otherwise, it will be the lowest priority
		//		adapter.
		this.pairs[((override) ? "unshift" : "push")]([name, check, wrap, directReturn]);
	},

	match: function(/* ... */){
		// summary:
		//		Find an adapter for the given arguments. If no suitable adapter
		//		is found, throws an exception. match() accepts any number of
		//		arguments, all of which are passed to all matching functions
		//		from the registered pairs.
		for(var i = 0; i < this.pairs.length; i++){
			var pair = this.pairs[i];
			if(pair[1].apply(this, arguments)){
				if((pair[3])||(this.returnWrappers)){
					return pair[2];
				}else{
					return pair[2].apply(this, arguments);
				}
			}
		}
		throw new Error("No match found");
	},

	unregister: function(name){
		// summary: Remove a named adapter from the registry

		// FIXME: this is kind of a dumb way to handle this. On a large
		// registry this will be slow-ish and we can use the name as a lookup
		// should we choose to trade memory for speed.
		for(var i = 0; i < this.pairs.length; i++){
			var pair = this.pairs[i];
			if(pair[0] == name){
				this.pairs.splice(i, 1);
				return true;
			}
		}
		return false;
	}
});

}

if(!dojo._hasResource["dijit._base.place"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.place"] = true;
dojo.provide("dijit._base.place");



// ported from dojo.html.util

dijit.getViewport = function(){
	// summary:
	//		Returns the dimensions and scroll position of the viewable area of a browser window

	var scrollRoot = (dojo.doc.compatMode == 'BackCompat')? dojo.body() : dojo.doc.documentElement;

	// get scroll position
	var scroll = dojo._docScroll(); // scrollRoot.scrollTop/Left should work
	return { w: scrollRoot.clientWidth, h: scrollRoot.clientHeight, l: scroll.x, t: scroll.y };
};

/*=====
dijit.__Position = function(){
	// x: Integer
	//		horizontal coordinate in pixels, relative to document body
	// y: Integer
	//		vertical coordinate in pixels, relative to document body

	thix.x = x;
	this.y = y;
}
=====*/


dijit.placeOnScreen = function(
	/* DomNode */			node,
	/* dijit.__Position */	pos,
	/* String[] */			corners,
	/* dijit.__Position? */	padding){
	// summary:
	//		Positions one of the node's corners at specified position
	//		such that node is fully visible in viewport.
	// description:
	//		NOTE: node is assumed to be absolutely or relatively positioned.
	//	pos:
	//		Object like {x: 10, y: 20}
	//	corners:
	//		Array of Strings representing order to try corners in, like ["TR", "BL"].
	//		Possible values are:
	//			* "BL" - bottom left
	//			* "BR" - bottom right
	//			* "TL" - top left
	//			* "TR" - top right
	//	padding:
	//		set padding to put some buffer around the element you want to position.
	// example:
	//		Try to place node's top right corner at (10,20).
	//		If that makes node go (partially) off screen, then try placing
	//		bottom left corner at (10,20).
	//	|	placeOnScreen(node, {x: 10, y: 20}, ["TR", "BL"])

	var choices = dojo.map(corners, function(corner){
		var c = { corner: corner, pos: {x:pos.x,y:pos.y} };
		if(padding){
			c.pos.x += corner.charAt(1) == 'L' ? padding.x : -padding.x;
			c.pos.y += corner.charAt(0) == 'T' ? padding.y : -padding.y;
		}
		return c;
	});

	return dijit._place(node, choices);
}

dijit._place = function(/*DomNode*/ node, /* Array */ choices, /* Function */ layoutNode){
	// summary:
	//		Given a list of spots to put node, put it at the first spot where it fits,
	//		of if it doesn't fit anywhere then the place with the least overflow
	// choices: Array
	//		Array of elements like: {corner: 'TL', pos: {x: 10, y: 20} }
	//		Above example says to put the top-left corner of the node at (10,20)
	// layoutNode: Function(node, aroundNodeCorner, nodeCorner)
	//		for things like tooltip, they are displayed differently (and have different dimensions)
	//		based on their orientation relative to the parent.   This adjusts the popup based on orientation.

	// get {x: 10, y: 10, w: 100, h:100} type obj representing position of
	// viewport over document
	var view = dijit.getViewport();

	// This won't work if the node is inside a <div style="position: relative">,
	// so reattach it to dojo.doc.body.   (Otherwise, the positioning will be wrong
	// and also it might get cutoff)
	if(!node.parentNode || String(node.parentNode.tagName).toLowerCase() != "body"){
		dojo.body().appendChild(node);
	}

	var best = null;
	dojo.some(choices, function(choice){
		var corner = choice.corner;
		var pos = choice.pos;

		// configure node to be displayed in given position relative to button
		// (need to do this in order to get an accurate size for the node, because
		// a tooltips size changes based on position, due to triangle)
		if(layoutNode){
			layoutNode(node, choice.aroundCorner, corner);
		}

		// get node's size
		var style = node.style;
		var oldDisplay = style.display;
		var oldVis = style.visibility;
		style.visibility = "hidden";
		style.display = "";
		var mb = dojo.marginBox(node);
		style.display = oldDisplay;
		style.visibility = oldVis;

		// coordinates and size of node with specified corner placed at pos,
		// and clipped by viewport
		var startX = Math.max(view.l, corner.charAt(1) == 'L' ? pos.x : (pos.x - mb.w)),
			startY = Math.max(view.t, corner.charAt(0) == 'T' ? pos.y : (pos.y - mb.h)),
			endX = Math.min(view.l + view.w, corner.charAt(1) == 'L' ? (startX + mb.w) : pos.x),
			endY = Math.min(view.t + view.h, corner.charAt(0) == 'T' ? (startY + mb.h) : pos.y),
			width = endX - startX,
			height = endY - startY,
			overflow = (mb.w - width) + (mb.h - height);

		if(best == null || overflow < best.overflow){
			best = {
				corner: corner,
				aroundCorner: choice.aroundCorner,
				x: startX,
				y: startY,
				w: width,
				h: height,
				overflow: overflow
			};
		}
		return !overflow;
	});

	node.style.left = best.x + "px";
	node.style.top = best.y + "px";
	if(best.overflow && layoutNode){
		layoutNode(node, best.aroundCorner, best.corner);
	}
	return best;
}

dijit.placeOnScreenAroundNode = function(
	/* DomNode */		node,
	/* DomNode */		aroundNode,
	/* Object */		aroundCorners,
	/* Function? */		layoutNode){

	// summary:
	//		Position node adjacent or kitty-corner to aroundNode
	//		such that it's fully visible in viewport.
	//
	// description:
	//		Place node such that corner of node touches a corner of
	//		aroundNode, and that node is fully visible.
	//
	// aroundCorners:
	//		Ordered list of pairs of corners to try matching up.
	//		Each pair of corners is represented as a key/value in the hash,
	//		where the key corresponds to the aroundNode's corner, and
	//		the value corresponds to the node's corner:
	//
	//	|	{ aroundNodeCorner1: nodeCorner1, aroundNodeCorner2: nodeCorner2, ...}
	//
	//		The following strings are used to represent the four corners:
	//			* "BL" - bottom left
	//			* "BR" - bottom right
	//			* "TL" - top left
	//			* "TR" - top right
	//
	// layoutNode: Function(node, aroundNodeCorner, nodeCorner)
	//		For things like tooltip, they are displayed differently (and have different dimensions)
	//		based on their orientation relative to the parent.   This adjusts the popup based on orientation.
	//
	// example:
	//	|	dijit.placeOnScreenAroundNode(node, aroundNode, {'BL':'TL', 'TR':'BR'});
	//		This will try to position node such that node's top-left corner is at the same position
	//		as the bottom left corner of the aroundNode (ie, put node below
	//		aroundNode, with left edges aligned).  If that fails it will try to put
	// 		the bottom-right corner of node where the top right corner of aroundNode is
	//		(ie, put node above aroundNode, with right edges aligned)
	//

	// get coordinates of aroundNode
	aroundNode = dojo.byId(aroundNode);
	var oldDisplay = aroundNode.style.display;
	aroundNode.style.display="";
	// #3172: use the slightly tighter border box instead of marginBox
	var aroundNodePos = dojo.position(aroundNode, true);
	aroundNode.style.display=oldDisplay;

	// place the node around the calculated rectangle
	return dijit._placeOnScreenAroundRect(node,
		aroundNodePos.x, aroundNodePos.y, aroundNodePos.w, aroundNodePos.h,	// rectangle
		aroundCorners, layoutNode);
};

/*=====
dijit.__Rectangle = function(){
	// x: Integer
	//		horizontal offset in pixels, relative to document body
	// y: Integer
	//		vertical offset in pixels, relative to document body
	// width: Integer
	//		width in pixels
	// height: Integer
	//		height in pixels

	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
}
=====*/


dijit.placeOnScreenAroundRectangle = function(
	/* DomNode */			node,
	/* dijit.__Rectangle */	aroundRect,
	/* Object */			aroundCorners,
	/* Function */			layoutNode){

	// summary:
	//		Like dijit.placeOnScreenAroundNode(), except that the "around"
	//		parameter is an arbitrary rectangle on the screen (x, y, width, height)
	//		instead of a dom node.

	return dijit._placeOnScreenAroundRect(node,
		aroundRect.x, aroundRect.y, aroundRect.width, aroundRect.height,	// rectangle
		aroundCorners, layoutNode);
};

dijit._placeOnScreenAroundRect = function(
	/* DomNode */		node,
	/* Number */		x,
	/* Number */		y,
	/* Number */		width,
	/* Number */		height,
	/* Object */		aroundCorners,
	/* Function */		layoutNode){

	// summary:
	//		Like dijit.placeOnScreenAroundNode(), except it accepts coordinates
	//		of a rectangle to place node adjacent to.

	// TODO: combine with placeOnScreenAroundRectangle()

	// Generate list of possible positions for node
	var choices = [];
	for(var nodeCorner in aroundCorners){
		choices.push( {
			aroundCorner: nodeCorner,
			corner: aroundCorners[nodeCorner],
			pos: {
				x: x + (nodeCorner.charAt(1) == 'L' ? 0 : width),
				y: y + (nodeCorner.charAt(0) == 'T' ? 0 : height)
			}
		});
	}

	return dijit._place(node, choices, layoutNode);
};

dijit.placementRegistry= new dojo.AdapterRegistry();
dijit.placementRegistry.register("node",
	function(n, x){
		return typeof x == "object" &&
			typeof x.offsetWidth != "undefined" && typeof x.offsetHeight != "undefined";
	},
	dijit.placeOnScreenAroundNode);
dijit.placementRegistry.register("rect",
	function(n, x){
		return typeof x == "object" &&
			"x" in x && "y" in x && "width" in x && "height" in x;
	},
	dijit.placeOnScreenAroundRectangle);

dijit.placeOnScreenAroundElement = function(
	/* DomNode */		node,
	/* Object */		aroundElement,
	/* Object */		aroundCorners,
	/* Function */		layoutNode){

	// summary:
	//		Like dijit.placeOnScreenAroundNode(), except it accepts an arbitrary object
	//		for the "around" argument and finds a proper processor to place a node.

	return dijit.placementRegistry.match.apply(dijit.placementRegistry, arguments);
};

dijit.getPopupAlignment = function(/*Array*/ position, /*Boolean*/ leftToRight){
	// summary:
	//		Transforms the passed array of preferred positions into a format suitable for passing as the aroundCorners argument to dijit.placeOnScreenAroundElement.
	//
	// position: String[]
	//		This variable controls the position of the drop down.
	//		It's an array of strings with the following values:
	//
	//			* before: places drop down to the left of the target node/widget, or to the right in
	//			  the case of RTL scripts like Hebrew and Arabic
	//			* after: places drop down to the right of the target node/widget, or to the left in
	//			  the case of RTL scripts like Hebrew and Arabic
	//			* above: drop down goes above target node
	//			* below: drop down goes below target node
	//
	//		The list is positions is tried, in order, until a position is found where the drop down fits
	//		within the viewport.
	//
	// leftToRight: Boolean
	//		Whether the popup will be displaying in leftToRight mode.
	//
	var align = {};
	dojo.forEach(position, function(pos){
		switch(pos){
			case "after":
				align[leftToRight ? "BR" : "BL"] = leftToRight ? "BL" : "BR";
				break;
			case "before":
				align[leftToRight ? "BL" : "BR"] = leftToRight ? "BR" : "BL";
				break;
			case "below":
				// first try to align left borders, next try to align right borders (or reverse for RTL mode)
				align[leftToRight ? "BL" : "BR"] = leftToRight ? "TL" : "TR";
				align[leftToRight ? "BR" : "BL"] = leftToRight ? "TR" : "TL";
				break;
			case "above":
			default:
				// first try to align left borders, next try to align right borders (or reverse for RTL mode)
				align[leftToRight ? "TL" : "TR"] = leftToRight ? "BL" : "BR";
				align[leftToRight ? "TR" : "TL"] = leftToRight ? "BR" : "BL";
				break;
		}
	});
	return align;
};
dijit.getPopupAroundAlignment = function(/*Array*/ position, /*Boolean*/ leftToRight){
	// summary:
	//		Transforms the passed array of preferred positions into a format suitable for passing as the aroundCorners argument to dijit.placeOnScreenAroundElement.
	//
	// position: String[]
	//		This variable controls the position of the drop down.
	//		It's an array of strings with the following values:
	//
	//			* before: places drop down to the left of the target node/widget, or to the right in
	//			  the case of RTL scripts like Hebrew and Arabic
	//			* after: places drop down to the right of the target node/widget, or to the left in
	//			  the case of RTL scripts like Hebrew and Arabic
	//			* above: drop down goes above target node
	//			* below: drop down goes below target node
	//
	//		The list is positions is tried, in order, until a position is found where the drop down fits
	//		within the viewport.
	//
	// leftToRight: Boolean
	//		Whether the popup will be displaying in leftToRight mode.
	//
	var align = {};
	dojo.forEach(position, function(pos){
		switch(pos){
			case "after":
				align[leftToRight ? "BR" : "BL"] = leftToRight ? "BL" : "BR";
				break;
			case "before":
				align[leftToRight ? "BL" : "BR"] = leftToRight ? "BR" : "BL";
				break;
			case "below":
				// first try to align left borders, next try to align right borders (or reverse for RTL mode)
				align[leftToRight ? "BL" : "BR"] = leftToRight ? "TL" : "TR";
				align[leftToRight ? "BR" : "BL"] = leftToRight ? "TR" : "TL";
				break;
			case "above":
			default:
				// first try to align left borders, next try to align right borders (or reverse for RTL mode)
				align[leftToRight ? "TL" : "TR"] = leftToRight ? "BL" : "BR";
				align[leftToRight ? "TR" : "TL"] = leftToRight ? "BR" : "BL";
				break;
		}
	});
	return align;
};

}

if(!dojo._hasResource["dijit._base.window"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.window"] = true;
dojo.provide("dijit._base.window");

// TODO: remove this in 2.0, it's not used anymore, or at least not internally

dijit.getDocumentWindow = function(doc){
	// summary:
	// 		Get window object associated with document doc

	// In some IE versions (at least 6.0), document.parentWindow does not return a
	// reference to the real window object (maybe a copy), so we must fix it as well
	// We use IE specific execScript to attach the real window reference to
	// document._parentWindow for later use
	if(dojo.isIE && window !== document.parentWindow && !doc._parentWindow){
		/*
		In IE 6, only the variable "window" can be used to connect events (others
		may be only copies).
		*/
		doc.parentWindow.execScript("document._parentWindow = window;", "Javascript");
		//to prevent memory leak, unset it after use
		//another possibility is to add an onUnload handler which seems overkill to me (liucougar)
		var win = doc._parentWindow;
		doc._parentWindow = null;
		return win;	//	Window
	}

	return doc._parentWindow || doc.parentWindow || doc.defaultView;	//	Window
}

}

if(!dojo._hasResource["dijit._base.popup"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.popup"] = true;
dojo.provide("dijit._base.popup");





dijit.popup = new function(){
	// summary:
	//		This class is used to show/hide widgets as popups.

	var stack = [],
		beginZIndex=100000,
		idGen = 1;

	this.moveOffScreen = function(/*DomNode*/ node){
		// summary:
		//		Moves node offscreen without hiding it (so that all layout widgets included
		//		in this node can still layout properly)
		//
		// description:
		//		Attaches node to dojo.doc.body, and
		//		positions it off screen, but not display:none, so that
		//		the widget doesn't appear in the page flow and/or cause a blank
		//		area at the bottom of the viewport (making scrollbar longer), but
		//		initialization of contained widgets works correctly

		var s = node.style;
		s.visibility = "hidden";	// so TAB key doesn't navigate to hidden popup
		s.position = "absolute";
		s.top = "-9999px";
		if(s.display == "none"){
			s.display="";
		}
		dojo.body().appendChild(node);
	};

/*=====
dijit.popup.__OpenArgs = function(){
	// popup: Widget
	//		widget to display
	// parent: Widget
	//		the button etc. that is displaying this popup
	// around: DomNode
	//		DOM node (typically a button); place popup relative to this node.  (Specify this *or* "x" and "y" parameters.)
	// x: Integer
	//		Absolute horizontal position (in pixels) to place node at.  (Specify this *or* "around" parameter.)
	// y: Integer
	//		Absolute vertical position (in pixels) to place node at.  (Specity this *or* "around" parameter.)
	// orient: Object || String
	//		When the around parameter is specified, orient should be an
	//		ordered list of tuples of the form (around-node-corner, popup-node-corner).
	//		dijit.popup.open() tries to position the popup according to each tuple in the list, in order,
	//		until the popup appears fully within the viewport.
	//
	//		The default value is {BL:'TL', TL:'BL'}, which represents a list of two tuples:
	//			1. (BL, TL)
	//			2. (TL, BL)
	//		where BL means "bottom left" and "TL" means "top left".
	//		So by default, it first tries putting the popup below the around node, left-aligning them,
	//		and then tries to put it above the around node, still left-aligning them.   Note that the
	//		default is horizontally reversed when in RTL mode.
	//
	//		When an (x,y) position is specified rather than an around node, orient is either
	//		"R" or "L".  R (for right) means that it tries to put the popup to the right of the mouse,
	//		specifically positioning the popup's top-right corner at the mouse position, and if that doesn't
	//		fit in the viewport, then it tries, in order, the bottom-right corner, the top left corner,
	//		and the top-right corner.
	// onCancel: Function
	//		callback when user has canceled the popup by
	//			1. hitting ESC or
	//			2. by using the popup widget's proprietary cancel mechanism (like a cancel button in a dialog);
	//			   i.e. whenever popupWidget.onCancel() is called, args.onCancel is called
	// onClose: Function
	//		callback whenever this popup is closed
	// onExecute: Function
	//		callback when user "executed" on the popup/sub-popup by selecting a menu choice, etc. (top menu only)
	// padding: dijit.__Position
	//		adding a buffer around the opening position. This is only useful when around is not set.
	this.popup = popup;
	this.parent = parent;
	this.around = around;
	this.x = x;
	this.y = y;
	this.orient = orient;
	this.onCancel = onCancel;
	this.onClose = onClose;
	this.onExecute = onExecute;
	this.padding = padding;
}
=====*/

	// Compute the closest ancestor popup that's *not* a child of another popup.
	// Ex: For a TooltipDialog with a button that spawns a tree of menus, find the popup of the button.
	var getTopPopup = function(){
		for(var pi=stack.length-1; pi > 0 && stack[pi].parent === stack[pi-1].widget; pi--){
			/* do nothing, just trying to get right value for pi */
		}
		return stack[pi];
	};

	var wrappers=[];
	this.open = function(/*dijit.popup.__OpenArgs*/ args){
		// summary:
		//		Popup the widget at the specified position
		//
		// example:
		//		opening at the mouse position
		//		|		dijit.popup.open({popup: menuWidget, x: evt.pageX, y: evt.pageY});
		//
		// example:
		//		opening the widget as a dropdown
		//		|		dijit.popup.open({parent: this, popup: menuWidget, around: this.domNode, onClose: function(){...}});
		//
		//		Note that whatever widget called dijit.popup.open() should also listen to its own _onBlur callback
		//		(fired from _base/focus.js) to know that focus has moved somewhere else and thus the popup should be closed.

		var widget = args.popup,
			orient = args.orient || (
				dojo._isBodyLtr() ?
				{'BL':'TL', 'BR':'TR', 'TL':'BL', 'TR':'BR'} :
				{'BR':'TR', 'BL':'TL', 'TR':'BR', 'TL':'BL'}
			),
			around = args.around,
			id = (args.around && args.around.id) ? (args.around.id+"_dropdown") : ("popup_"+idGen++);

		// make wrapper div to hold widget and possibly hold iframe behind it.
		// we can't attach the iframe as a child of the widget.domNode because
		// widget.domNode might be a <table>, <ul>, etc.

		var wrapperobj = wrappers.pop(), wrapper, iframe;
		if(!wrapperobj){
			wrapper = dojo.create("div",{
				"class":"dijitPopup"
			}, dojo.body());
			dijit.setWaiRole(wrapper, "presentation");
		}else{
			// recycled a old wrapper, so that we don't need to reattach the iframe
			// which is slow even if the iframe is empty, see #10167
			wrapper = wrapperobj[0];
			iframe = wrapperobj[1];
		}

		dojo.attr(wrapper,{
			id: id,
			style:{
				zIndex: beginZIndex + stack.length,
				visibility:"hidden",
				// prevent transient scrollbar causing misalign (#5776), and initial flash in upper left (#10111)
				top: "-9999px"
			},
			dijitPopupParent: args.parent ? args.parent.id : ""
		});

		var s = widget.domNode.style;
		s.display = "";
		s.visibility = "";
		s.position = "";
		s.top = "0px";
		wrapper.appendChild(widget.domNode);

		if(!iframe){
			iframe = new dijit.BackgroundIframe(wrapper);
		}else{
			iframe.resize(wrapper)
		}

		// position the wrapper node
		var best = around ?
			dijit.placeOnScreenAroundElement(wrapper, around, orient, widget.orient ? dojo.hitch(widget, "orient") : null) :
			dijit.placeOnScreen(wrapper, args, orient == 'R' ? ['TR','BR','TL','BL'] : ['TL','BL','TR','BR'], args.padding);

		wrapper.style.visibility = "visible";
		// TODO: use effects to fade in wrapper

		var handlers = [];

		// provide default escape and tab key handling
		// (this will work for any widget, not just menu)
		handlers.push(dojo.connect(wrapper, "onkeypress", this, function(evt){
			if(evt.charOrCode == dojo.keys.ESCAPE && args.onCancel){
				dojo.stopEvent(evt);
				args.onCancel();
			}else if(evt.charOrCode === dojo.keys.TAB){
				dojo.stopEvent(evt);
				var topPopup = getTopPopup();
				if(topPopup && topPopup.onCancel){
					topPopup.onCancel();
				}
			}
		}));

		// watch for cancel/execute events on the popup and notify the caller
		// (for a menu, "execute" means clicking an item)
		if(widget.onCancel){
			handlers.push(dojo.connect(widget, "onCancel", args.onCancel));
		}

		handlers.push(dojo.connect(widget, widget.onExecute ? "onExecute" : "onChange", function(){
			var topPopup = getTopPopup();
			if(topPopup && topPopup.onExecute){
				topPopup.onExecute();
			}
		}));

		stack.push({
			wrapper: wrapper,
			iframe: iframe,
			widget: widget,
			parent: args.parent,
			onExecute: args.onExecute,
			onCancel: args.onCancel,
 			onClose: args.onClose,
			handlers: handlers
		});

		if(widget.onOpen){
			// TODO: in 2.0 standardize onShow() (used by StackContainer) and onOpen() (used here)
			widget.onOpen(best);
		}

		return best;
	};

	this.close = function(/*dijit._Widget*/ popup){
		// summary:
		//		Close specified popup and any popups that it parented

		// Basically work backwards from the top of the stack closing popups
		// until we hit the specified popup, but IIRC there was some issue where closing
		// a popup would cause others to close too.  Thus if we are trying to close B in [A,B,C]
		// closing C might close B indirectly and then the while() condition will run where stack==[A]...
		// so the while condition is constructed defensively.
		while(dojo.some(stack, function(elem){return elem.widget == popup;})){
			var top = stack.pop(),
				wrapper = top.wrapper,
				iframe = top.iframe,
				widget = top.widget,
				onClose = top.onClose;

			if(widget.onClose){
				// TODO: in 2.0 standardize onHide() (used by StackContainer) and onClose() (used here)
				widget.onClose();
			}
			dojo.forEach(top.handlers, dojo.disconnect);

			// Move the widget offscreen, unless it has already been destroyed in above onClose() etc.
			if(widget && widget.domNode){
				this.moveOffScreen(widget.domNode);
			}

			// recycle the wrapper plus iframe, so we prevent reattaching iframe everytime an popup opens
			// don't use moveOffScreen which would also reattach the wrapper to body, which causes reloading of iframe
			wrapper.style.top = "-9999px";
			wrapper.style.visibility = "hidden";
			wrappers.push([wrapper,iframe]);

			if(onClose){
				onClose();
			}
		}
	};
}();

dijit._frames = new function(){
	// summary:
	//		cache of iframes
	var queue = [];

	this.pop = function(){
		var iframe;
		if(queue.length){
			iframe = queue.pop();
			iframe.style.display="";
		}else{
			if(dojo.isIE){
				var burl = dojo.config["dojoBlankHtmlUrl"] || (dojo.moduleUrl("dojo", "resources/blank.html")+"") || "javascript:\"\"";
				var html="<iframe src='" + burl + "'"
					+ " style='position: absolute; left: 0px; top: 0px;"
					+ "z-index: -1; filter:Alpha(Opacity=\"0\");'>";
				iframe = dojo.doc.createElement(html);
			}else{
			 	iframe = dojo.create("iframe");
				iframe.src = 'javascript:""';
				iframe.className = "dijitBackgroundIframe";
				dojo.style(iframe, "opacity", 0.1);
			}
			iframe.tabIndex = -1; // Magic to prevent iframe from getting focus on tab keypress - as style didnt work.
		}
		return iframe;
	};

	this.push = function(iframe){
		iframe.style.display="none";
		queue.push(iframe);
	}
}();


dijit.BackgroundIframe = function(/* DomNode */node){
	// summary:
	//		For IE/FF z-index schenanigans. id attribute is required.
	//
	// description:
	//		new dijit.BackgroundIframe(node)
	//			Makes a background iframe as a child of node, that fills
	//			area (and position) of node

	if(!node.id){ throw new Error("no id"); }
	if(dojo.isIE || dojo.isMoz){
		var iframe = dijit._frames.pop();
		node.appendChild(iframe);
		if(dojo.isIE<7){
			this.resize(node);
			this._conn = dojo.connect(node, 'onresize', this, function(){
				this.resize(node);
			});
		}else{
			dojo.style(iframe, {
				width: '100%',
				height: '100%'
			});
		}
		this.iframe = iframe;
	}
};

dojo.extend(dijit.BackgroundIframe, {
	resize: function(node){
		// summary:
		// 		resize the iframe so its the same size as node
		// description:
		//		this function is a no-op in all browsers except
		//		IE6, which does not support 100% width/height
		//		of absolute positioned iframes
		if(this.iframe && dojo.isIE<7){
			dojo.style(this.iframe, {
				width: node.offsetWidth + 'px',
				height: node.offsetHeight + 'px'
			});
		}
	},
	destroy: function(){
		// summary:
		//		destroy the iframe
		if(this._conn){
			dojo.disconnect(this._conn);
			this._conn = null;
		}
		if(this.iframe){
			dijit._frames.push(this.iframe);
			delete this.iframe;
		}
	}
});

}

if(!dojo._hasResource["dijit._base.scroll"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.scroll"] = true;
dojo.provide("dijit._base.scroll");

dijit.scrollIntoView = function(/*DomNode*/ node, /*Object?*/ pos){
	// summary:
	//		Scroll the passed node into view, if it is not already.
	
	// don't rely on that node.scrollIntoView works just because the function is there

	try{ // catch unexpected/unrecreatable errors (#7808) since we can recover using a semi-acceptable native method
	node = dojo.byId(node);
	var doc = node.ownerDocument || dojo.doc,
		body = doc.body || dojo.body(),
		html = doc.documentElement || body.parentNode,
		isIE = dojo.isIE, isWK = dojo.isWebKit;
	// if an untested browser, then use the native method
	if((!(dojo.isMoz || isIE || isWK) || node == body || node == html) && (typeof node.scrollIntoView != "undefined")){
		node.scrollIntoView(false); // short-circuit to native if possible
		return;
	}
	var backCompat = doc.compatMode == 'BackCompat',
		clientAreaRoot = backCompat? body : html,
		scrollRoot = isWK ? body : clientAreaRoot,
		rootWidth = clientAreaRoot.clientWidth,
		rootHeight = clientAreaRoot.clientHeight,
		rtl = !dojo._isBodyLtr(),
		nodePos = pos || dojo.position(node),
		el = node.parentNode,
		isFixed = function(el){
			return ((isIE <= 6 || (isIE && backCompat))? false : (dojo.style(el, 'position').toLowerCase() == "fixed"));
		};
	if(isFixed(node)){ return; } // nothing to do
	while(el){
		if(el == body){ el = scrollRoot; }
		var elPos = dojo.position(el),
			fixedPos = isFixed(el);
		with(elPos){
			if(el == scrollRoot){
				w = rootWidth, h = rootHeight;
				if(scrollRoot == html && isIE && rtl){ x += scrollRoot.offsetWidth-w; } // IE workaround where scrollbar causes negative x
				if(x < 0 || !isIE){ x = 0; } // IE can have values > 0
				if(y < 0 || !isIE){ y = 0; }
			}else{
				var pb = dojo._getPadBorderExtents(el);
				w -= pb.w; h -= pb.h; x += pb.l; y += pb.t;
			}
			with(el){
				if(el != scrollRoot){ // body, html sizes already have the scrollbar removed
					var clientSize = clientWidth,
						scrollBarSize = w - clientSize;
					if(clientSize > 0 && scrollBarSize > 0){
						w = clientSize;
						if(isIE && rtl){ x += scrollBarSize; }
					}
					clientSize = clientHeight;
					scrollBarSize = h - clientSize;
					if(clientSize > 0 && scrollBarSize > 0){
						h = clientSize;
					}
				}
				if(fixedPos){ // bounded by viewport, not parents
					if(y < 0){
						h += y, y = 0;
					}
					if(x < 0){
						w += x, x = 0;
					}
					if(y + h > rootHeight){
						h = rootHeight - y;
					}
					if(x + w > rootWidth){
						w = rootWidth - x;
					}
				}
				// calculate overflow in all 4 directions
				var l = nodePos.x - x, // beyond left: < 0
					t = nodePos.y - Math.max(y, 0), // beyond top: < 0
					r = l + nodePos.w - w, // beyond right: > 0
					bot = t + nodePos.h - h; // beyond bottom: > 0
				if(r * l > 0){
					var s = Math[l < 0? "max" : "min"](l, r);
					nodePos.x += scrollLeft;
					scrollLeft += (isIE >= 8 && !backCompat && rtl)? -s : s;
					nodePos.x -= scrollLeft;
				}
				if(bot * t > 0){
					nodePos.y += scrollTop;
					scrollTop += Math[t < 0? "max" : "min"](t, bot);
					nodePos.y -= scrollTop;
				}
			}
		}
		el = (el != scrollRoot) && !fixedPos && el.parentNode;
	}
	}catch(error){
		console.error('scrollIntoView: ' + error);
		node.scrollIntoView(false);
	}
};

}

if(!dojo._hasResource["dijit._base.sniff"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.sniff"] = true;
// summary:
//		Applies pre-set CSS classes to the top-level HTML node, based on:
// 			- browser (ex: dj_ie)
//			- browser version (ex: dj_ie6)
//			- box model (ex: dj_contentBox)
//			- text direction (ex: dijitRtl)
//
//		In addition, browser, browser version, and box model are
//		combined with an RTL flag when browser text is RTL.  ex: dj_ie-rtl.
//
//		Simply doing a require on this module will
//		establish this CSS.  Modified version of Morris' CSS hack.

dojo.provide("dijit._base.sniff");

(function(){

	var d = dojo,
		html = d.doc.documentElement,
		ie = d.isIE,
		opera = d.isOpera,
		maj = Math.floor,
		ff = d.isFF,
		boxModel = d.boxModel.replace(/-/,''),

		classes = {
			dj_ie: ie,
			dj_ie6: maj(ie) == 6,
			dj_ie7: maj(ie) == 7,
			dj_ie8: maj(ie) == 8,
			dj_iequirks: ie && d.isQuirks,

			// NOTE: Opera not supported by dijit
			dj_opera: opera,

			dj_khtml: d.isKhtml,

			dj_webkit: d.isWebKit,
			dj_safari: d.isSafari,
			dj_chrome: d.isChrome,

			dj_gecko: d.isMozilla,
			dj_ff3: maj(ff) == 3
		}; // no dojo unsupported browsers

	classes["dj_" + boxModel] = true;

	// apply browser, browser version, and box model class names
	for(var p in classes){
		if(classes[p]){
			if(html.className){
				html.className += " " + p;
			}else{
				html.className = p;
			}
		}
	}

	// If RTL mode then add dijitRtl flag plus repeat existing classes
	// with -rtl extension
	// (unshift is to make this code run after <body> node is loaded but before parser runs)
	dojo._loaders.unshift(function(){
		if(!dojo._isBodyLtr()){
			html.className += " dijitRtl";
			for(var p in classes){
				if(classes[p]){
					html.className += " " + p + "-rtl";
				}
			}
		}
	});

})();

}

if(!dojo._hasResource["dijit._base.typematic"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.typematic"] = true;
dojo.provide("dijit._base.typematic");

dijit.typematic = {
	// summary:
	//		These functions are used to repetitively call a user specified callback
	//		method when a specific key or mouse click over a specific DOM node is
	//		held down for a specific amount of time.
	//		Only 1 such event is allowed to occur on the browser page at 1 time.

	_fireEventAndReload: function(){
		this._timer = null;
		this._callback(++this._count, this._node, this._evt);
		
		// Schedule next event, reducing the timer a little bit each iteration, bottoming-out at 10 to avoid
		// browser overload (particularly avoiding starving DOH robot so it never gets to send a mouseup)
		this._currentTimeout = Math.max(
			this._currentTimeout < 0 ? this._initialDelay :
				(this._subsequentDelay > 1 ? this._subsequentDelay : Math.round(this._currentTimeout * this._subsequentDelay)),
			10);
		this._timer = setTimeout(dojo.hitch(this, "_fireEventAndReload"), this._currentTimeout);
	},

	trigger: function(/*Event*/ evt, /* Object */ _this, /*DOMNode*/ node, /* Function */ callback, /* Object */ obj, /* Number */ subsequentDelay, /* Number */ initialDelay){
		// summary:
		//		Start a timed, repeating callback sequence.
		//		If already started, the function call is ignored.
		//		This method is not normally called by the user but can be
		//		when the normal listener code is insufficient.
		// evt:
		//		key or mouse event object to pass to the user callback
		// _this:
		//		pointer to the user's widget space.
		// node:
		//		the DOM node object to pass the the callback function
		// callback:
		//		function to call until the sequence is stopped called with 3 parameters:
		// count:
		//		integer representing number of repeated calls (0..n) with -1 indicating the iteration has stopped
		// node:
		//		the DOM node object passed in
		// evt:
		//		key or mouse event object
		// obj:
		//		user space object used to uniquely identify each typematic sequence
		// subsequentDelay:
		//		if > 1, the number of milliseconds until the 3->n events occur
		//		or else the fractional time multiplier for the next event's delay, default=0.9
		// initialDelay:
		//		the number of milliseconds until the 2nd event occurs, default=500ms
		if(obj != this._obj){
			this.stop();
			this._initialDelay = initialDelay || 500;
			this._subsequentDelay = subsequentDelay || 0.90;
			this._obj = obj;
			this._evt = evt;
			this._node = node;
			this._currentTimeout = -1;
			this._count = -1;
			this._callback = dojo.hitch(_this, callback);
			this._fireEventAndReload();
		}
	},

	stop: function(){
		// summary:
		//		Stop an ongoing timed, repeating callback sequence.
		if(this._timer){
			clearTimeout(this._timer);
			this._timer = null;
		}
		if(this._obj){
			this._callback(-1, this._node, this._evt);
			this._obj = null;
		}
	},

	addKeyListener: function(/*DOMNode*/ node, /*Object*/ keyObject, /*Object*/ _this, /*Function*/ callback, /*Number*/ subsequentDelay, /*Number*/ initialDelay){
		// summary:
		//		Start listening for a specific typematic key.
		//		See also the trigger method for other parameters.
		// keyObject:
		//		an object defining the key to listen for.
		// charOrCode:
		//		the printable character (string) or keyCode (number) to listen for.
		// keyCode:
		//		(deprecated - use charOrCode) the keyCode (number) to listen for (implies charCode = 0).
		// charCode:
		//		(deprecated - use charOrCode) the charCode (number) to listen for.
		// ctrlKey:
		//		desired ctrl key state to initiate the calback sequence:
		//			- pressed (true)
		//			- released (false)
		//			- either (unspecified)
		// altKey:
		//		same as ctrlKey but for the alt key
		// shiftKey:
		//		same as ctrlKey but for the shift key
		// returns:
		//		an array of dojo.connect handles
		if(keyObject.keyCode){
			keyObject.charOrCode = keyObject.keyCode;
			dojo.deprecated("keyCode attribute parameter for dijit.typematic.addKeyListener is deprecated. Use charOrCode instead.", "", "2.0");
		}else if(keyObject.charCode){
			keyObject.charOrCode = String.fromCharCode(keyObject.charCode);
			dojo.deprecated("charCode attribute parameter for dijit.typematic.addKeyListener is deprecated. Use charOrCode instead.", "", "2.0");
		}
		return [
			dojo.connect(node, "onkeypress", this, function(evt){
				if(evt.charOrCode == keyObject.charOrCode &&
				(keyObject.ctrlKey === undefined || keyObject.ctrlKey == evt.ctrlKey) &&
				(keyObject.altKey === undefined || keyObject.altKey == evt.altKey) &&
				(keyObject.metaKey === undefined || keyObject.metaKey == (evt.metaKey || false)) && // IE doesn't even set metaKey
				(keyObject.shiftKey === undefined || keyObject.shiftKey == evt.shiftKey)){
					dojo.stopEvent(evt);
					dijit.typematic.trigger(keyObject, _this, node, callback, keyObject, subsequentDelay, initialDelay);
				}else if(dijit.typematic._obj == keyObject){
					dijit.typematic.stop();
				}
			}),
			dojo.connect(node, "onkeyup", this, function(evt){
				if(dijit.typematic._obj == keyObject){
					dijit.typematic.stop();
				}
			})
		];
	},

	addMouseListener: function(/*DOMNode*/ node, /*Object*/ _this, /*Function*/ callback, /*Number*/ subsequentDelay, /*Number*/ initialDelay){
		// summary:
		//		Start listening for a typematic mouse click.
		//		See the trigger method for other parameters.
		// returns:
		//		an array of dojo.connect handles
		var dc = dojo.connect;
		return [
			dc(node, "mousedown", this, function(evt){
				dojo.stopEvent(evt);
				dijit.typematic.trigger(evt, _this, node, callback, node, subsequentDelay, initialDelay);
			}),
			dc(node, "mouseup", this, function(evt){
				dojo.stopEvent(evt);
				dijit.typematic.stop();
			}),
			dc(node, "mouseout", this, function(evt){
				dojo.stopEvent(evt);
				dijit.typematic.stop();
			}),
			dc(node, "mousemove", this, function(evt){
				dojo.stopEvent(evt);
			}),
			dc(node, "dblclick", this, function(evt){
				dojo.stopEvent(evt);
				if(dojo.isIE){
					dijit.typematic.trigger(evt, _this, node, callback, node, subsequentDelay, initialDelay);
					setTimeout(dojo.hitch(this, dijit.typematic.stop), 50);
				}
			})
		];
	},

	addListener: function(/*Node*/ mouseNode, /*Node*/ keyNode, /*Object*/ keyObject, /*Object*/ _this, /*Function*/ callback, /*Number*/ subsequentDelay, /*Number*/ initialDelay){
		// summary:
		//		Start listening for a specific typematic key and mouseclick.
		//		This is a thin wrapper to addKeyListener and addMouseListener.
		//		See the addMouseListener and addKeyListener methods for other parameters.
		// mouseNode:
		//		the DOM node object to listen on for mouse events.
		// keyNode:
		//		the DOM node object to listen on for key events.
		// returns:
		//		an array of dojo.connect handles
		return this.addKeyListener(keyNode, keyObject, _this, callback, subsequentDelay, initialDelay).concat(
			this.addMouseListener(mouseNode, _this, callback, subsequentDelay, initialDelay));
	}
};

}

if(!dojo._hasResource["dijit._base.wai"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base.wai"] = true;
dojo.provide("dijit._base.wai");

dijit.wai = {
	onload: function(){
		// summary:
		//		Detects if we are in high-contrast mode or not

		// This must be a named function and not an anonymous
		// function, so that the widget parsing code can make sure it
		// registers its onload function after this function.
		// DO NOT USE "this" within this function.

		// create div for testing if high contrast mode is on or images are turned off
		var div = dojo.create("div",{
			id: "a11yTestNode",
			style:{
				cssText:'border: 1px solid;'
					+ 'border-color:red green;'
					+ 'position: absolute;'
					+ 'height: 5px;'
					+ 'top: -999px;'
					+ 'background-image: url("' + (dojo.config.blankGif || dojo.moduleUrl("dojo", "resources/blank.gif")) + '");'
			}
		}, dojo.body());

		// test it
		var cs = dojo.getComputedStyle(div);
		if(cs){
			var bkImg = cs.backgroundImage;
			var needsA11y = (cs.borderTopColor == cs.borderRightColor) || (bkImg != null && (bkImg == "none" || bkImg == "url(invalid-url:)" ));
			dojo[needsA11y ? "addClass" : "removeClass"](dojo.body(), "dijit_a11y");
			if(dojo.isIE){
				div.outerHTML = "";		// prevent mixed-content warning, see http://support.microsoft.com/kb/925014
			}else{
				dojo.body().removeChild(div);
			}
		}
	}
};

// Test if computer is in high contrast mode.
// Make sure the a11y test runs first, before widgets are instantiated.
if(dojo.isIE || dojo.isMoz){	// NOTE: checking in Safari messes things up
	dojo._loaders.unshift(dijit.wai.onload);
}

dojo.mixin(dijit, {
	_XhtmlRoles: /banner|contentinfo|definition|main|navigation|search|note|secondary|seealso/,

	hasWaiRole: function(/*Element*/ elem, /*String*/ role){
		// summary:
		//		Determines if an element has a particular non-XHTML role.
		// returns:
		//		True if elem has the specific non-XHTML role attribute and false if not.
		// 		For backwards compatibility if role parameter not provided,
		// 		returns true if has non XHTML role
		var waiRole = this.getWaiRole(elem);
		return role ? (waiRole.indexOf(role) > -1) : (waiRole.length > 0);
	},

	getWaiRole: function(/*Element*/ elem){
		// summary:
		//		Gets the non-XHTML role for an element (which should be a wai role).
		// returns:
		//		The non-XHTML role of elem or an empty string if elem
		//		does not have a role.
		 return dojo.trim((dojo.attr(elem, "role") || "").replace(this._XhtmlRoles,"").replace("wairole:",""));
	},

	setWaiRole: function(/*Element*/ elem, /*String*/ role){
		// summary:
		//		Sets the role on an element.
		// description:
		//		Replace existing role attribute with new role.
		//		If elem already has an XHTML role, append this role to XHTML role
		//		and remove other ARIA roles.

		var curRole = dojo.attr(elem, "role") || "";
		if(!this._XhtmlRoles.test(curRole)){
			dojo.attr(elem, "role", role);
		}else{
			if((" "+ curRole +" ").indexOf(" " + role + " ") < 0){
				var clearXhtml = dojo.trim(curRole.replace(this._XhtmlRoles, ""));
				var cleanRole = dojo.trim(curRole.replace(clearXhtml, ""));
				dojo.attr(elem, "role", cleanRole + (cleanRole ? ' ' : '') + role);
			}
		}
	},

	removeWaiRole: function(/*Element*/ elem, /*String*/ role){
		// summary:
		//		Removes the specified non-XHTML role from an element.
		// 		Removes role attribute if no specific role provided (for backwards compat.)

		var roleValue = dojo.attr(elem, "role");
		if(!roleValue){ return; }
		if(role){
			var t = dojo.trim((" " + roleValue + " ").replace(" " + role + " ", " "));
			dojo.attr(elem, "role", t);
		}else{
			elem.removeAttribute("role");
		}
	},

	hasWaiState: function(/*Element*/ elem, /*String*/ state){
		// summary:
		//		Determines if an element has a given state.
		// description:
		//		Checks for an attribute called "aria-"+state.
		// returns:
		//		true if elem has a value for the given state and
		//		false if it does not.

		return elem.hasAttribute ? elem.hasAttribute("aria-"+state) : !!elem.getAttribute("aria-"+state);
	},

	getWaiState: function(/*Element*/ elem, /*String*/ state){
		// summary:
		//		Gets the value of a state on an element.
		// description:
		//		Checks for an attribute called "aria-"+state.
		// returns:
		//		The value of the requested state on elem
		//		or an empty string if elem has no value for state.

		return elem.getAttribute("aria-"+state) || "";
	},

	setWaiState: function(/*Element*/ elem, /*String*/ state, /*String*/ value){
		// summary:
		//		Sets a state on an element.
		// description:
		//		Sets an attribute called "aria-"+state.

		elem.setAttribute("aria-"+state, value);
	},

	removeWaiState: function(/*Element*/ elem, /*String*/ state){
		// summary:
		//		Removes a state from an element.
		// description:
		//		Sets an attribute called "aria-"+state.

		elem.removeAttribute("aria-"+state);
	}
});

}

if(!dojo._hasResource["dijit._base"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._base"] = true;
dojo.provide("dijit._base");











}

if(!dojo._hasResource["dojo.date.stamp"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.date.stamp"] = true;
dojo.provide("dojo.date.stamp");

// Methods to convert dates to or from a wire (string) format using well-known conventions

dojo.date.stamp.fromISOString = function(/*String*/formattedString, /*Number?*/defaultTime){
	//	summary:
	//		Returns a Date object given a string formatted according to a subset of the ISO-8601 standard.
	//
	//	description:
	//		Accepts a string formatted according to a profile of ISO8601 as defined by
	//		[RFC3339](http://www.ietf.org/rfc/rfc3339.txt), except that partial input is allowed.
	//		Can also process dates as specified [by the W3C](http://www.w3.org/TR/NOTE-datetime)
	//		The following combinations are valid:
	//
	//			* dates only
	//			|	* yyyy
	//			|	* yyyy-MM
	//			|	* yyyy-MM-dd
	// 			* times only, with an optional time zone appended
	//			|	* THH:mm
	//			|	* THH:mm:ss
	//			|	* THH:mm:ss.SSS
	// 			* and "datetimes" which could be any combination of the above
	//
	//		timezones may be specified as Z (for UTC) or +/- followed by a time expression HH:mm
	//		Assumes the local time zone if not specified.  Does not validate.  Improperly formatted
	//		input may return null.  Arguments which are out of bounds will be handled
	// 		by the Date constructor (e.g. January 32nd typically gets resolved to February 1st)
	//		Only years between 100 and 9999 are supported.
	//
  	//	formattedString:
	//		A string such as 2005-06-30T08:05:00-07:00 or 2005-06-30 or T08:05:00
	//
	//	defaultTime:
	//		Used for defaults for fields omitted in the formattedString.
	//		Uses 1970-01-01T00:00:00.0Z by default.

	if(!dojo.date.stamp._isoRegExp){
		dojo.date.stamp._isoRegExp =
//TODO: could be more restrictive and check for 00-59, etc.
			/^(?:(\d{4})(?:-(\d{2})(?:-(\d{2}))?)?)?(?:T(\d{2}):(\d{2})(?::(\d{2})(.\d+)?)?((?:[+-](\d{2}):(\d{2}))|Z)?)?$/;
	}

	var match = dojo.date.stamp._isoRegExp.exec(formattedString),
		result = null;

	if(match){
		match.shift();
		if(match[1]){match[1]--;} // Javascript Date months are 0-based
		if(match[6]){match[6] *= 1000;} // Javascript Date expects fractional seconds as milliseconds

		if(defaultTime){
			// mix in defaultTime.  Relatively expensive, so use || operators for the fast path of defaultTime === 0
			defaultTime = new Date(defaultTime);
			dojo.map(["FullYear", "Month", "Date", "Hours", "Minutes", "Seconds", "Milliseconds"], function(prop){
				return defaultTime["get" + prop]();
			}).forEach(function(value, index){
				if(match[index] === undefined){
					match[index] = value;
				}
			});
		}
		result = new Date(match[0]||1970, match[1]||0, match[2]||1, match[3]||0, match[4]||0, match[5]||0, match[6]||0); //TODO: UTC defaults
		if(match[0] < 100){
			result.setFullYear(match[0] || 1970);
		}

		var offset = 0,
			zoneSign = match[7] && match[7].charAt(0);
		if(zoneSign != 'Z'){
			offset = ((match[8] || 0) * 60) + (Number(match[9]) || 0);
			if(zoneSign != '-'){ offset *= -1; }
		}
		if(zoneSign){
			offset -= result.getTimezoneOffset();
		}
		if(offset){
			result.setTime(result.getTime() + offset * 60000);
		}
	}

	return result; // Date or null
}

/*=====
	dojo.date.stamp.__Options = function(){
		//	selector: String
		//		"date" or "time" for partial formatting of the Date object.
		//		Both date and time will be formatted by default.
		//	zulu: Boolean
		//		if true, UTC/GMT is used for a timezone
		//	milliseconds: Boolean
		//		if true, output milliseconds
		this.selector = selector;
		this.zulu = zulu;
		this.milliseconds = milliseconds;
	}
=====*/

dojo.date.stamp.toISOString = function(/*Date*/dateObject, /*dojo.date.stamp.__Options?*/options){
	//	summary:
	//		Format a Date object as a string according a subset of the ISO-8601 standard
	//
	//	description:
	//		When options.selector is omitted, output follows [RFC3339](http://www.ietf.org/rfc/rfc3339.txt)
	//		The local time zone is included as an offset from GMT, except when selector=='time' (time without a date)
	//		Does not check bounds.  Only years between 100 and 9999 are supported.
	//
	//	dateObject:
	//		A Date object

	var _ = function(n){ return (n < 10) ? "0" + n : n; };
	options = options || {};
	var formattedDate = [],
		getter = options.zulu ? "getUTC" : "get",
		date = "";
	if(options.selector != "time"){
		var year = dateObject[getter+"FullYear"]();
		date = ["0000".substr((year+"").length)+year, _(dateObject[getter+"Month"]()+1), _(dateObject[getter+"Date"]())].join('-');
	}
	formattedDate.push(date);
	if(options.selector != "date"){
		var time = [_(dateObject[getter+"Hours"]()), _(dateObject[getter+"Minutes"]()), _(dateObject[getter+"Seconds"]())].join(':');
		var millis = dateObject[getter+"Milliseconds"]();
		if(options.milliseconds){
			time += "."+ (millis < 100 ? "0" : "") + _(millis);
		}
		if(options.zulu){
			time += "Z";
		}else if(options.selector != "time"){
			var timezoneOffset = dateObject.getTimezoneOffset();
			var absOffset = Math.abs(timezoneOffset);
			time += (timezoneOffset > 0 ? "-" : "+") + 
				_(Math.floor(absOffset/60)) + ":" + _(absOffset%60);
		}
		formattedDate.push(time);
	}
	return formattedDate.join('T'); // String
}

}

if(!dojo._hasResource["dojo.parser"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.parser"] = true;
dojo.provide("dojo.parser");


dojo.parser = new function(){
	// summary: The Dom/Widget parsing package

	var d = dojo;
	this._attrName = d._scopeName + "Type";
	this._query = "[" + this._attrName + "]";

	function val2type(/*Object*/ value){
		// summary:
		//		Returns name of type of given value.

		if(d.isString(value)){ return "string"; }
		if(typeof value == "number"){ return "number"; }
		if(typeof value == "boolean"){ return "boolean"; }
		if(d.isFunction(value)){ return "function"; }
		if(d.isArray(value)){ return "array"; } // typeof [] == "object"
		if(value instanceof Date) { return "date"; } // assume timestamp
		if(value instanceof d._Url){ return "url"; }
		return "object";
	}

	function str2obj(/*String*/ value, /*String*/ type){
		// summary:
		//		Convert given string value to given type
		switch(type){
			case "string":
				return value;
			case "number":
				return value.length ? Number(value) : NaN;
			case "boolean":
				// for checked/disabled value might be "" or "checked".  interpret as true.
				return typeof value == "boolean" ? value : !(value.toLowerCase()=="false");
			case "function":
				if(d.isFunction(value)){
					// IE gives us a function, even when we say something like onClick="foo"
					// (in which case it gives us an invalid function "function(){ foo }"). 
					//  Therefore, convert to string
					value=value.toString();
					value=d.trim(value.substring(value.indexOf('{')+1, value.length-1));
				}
				try{
					if(value.search(/[^\w\.]+/i) != -1){
						// The user has specified some text for a function like "return x+5"
						return new Function(value);
					}else{
						// The user has specified the name of a function like "myOnClick"
						return d.getObject(value, false);
					}
				}catch(e){ return new Function(); }
			case "array":
				return value ? value.split(/\s*,\s*/) : [];
			case "date":
				switch(value){
					case "": return new Date("");	// the NaN of dates
					case "now": return new Date();	// current date
					default: return d.date.stamp.fromISOString(value);
				}
			case "url":
				return d.baseUrl + value;
			default:
				return d.fromJson(value);
		}
	}

	var instanceClasses = {
		// map from fully qualified name (like "dijit.Button") to structure like
		// { cls: dijit.Button, params: {label: "string", disabled: "boolean"} }
	};

	// Widgets like BorderContainer add properties to _Widget via dojo.extend().
	// If BorderContainer is loaded after _Widget's parameter list has been cached,
	// we need to refresh that parameter list (for _Widget and all widgets that extend _Widget).
	dojo.connect(dojo, "extend", function(){
		instanceClasses = {};
	});

	function getClassInfo(/*String*/ className){
		// className:
		//		fully qualified name (like "dijit.form.Button")
		// returns:
		//		structure like
		//			{ 
		//				cls: dijit.Button, 
		//				params: { label: "string", disabled: "boolean"}
		//			}

		if(!instanceClasses[className]){
			// get pointer to widget class
			var cls = d.getObject(className);
			if(!d.isFunction(cls)){
				throw new Error("Could not load class '" + className +
					"'. Did you spell the name correctly and use a full path, like 'dijit.form.Button'?");
			}
			var proto = cls.prototype;
	
			// get table of parameter names & types
			var params = {}, dummyClass = {};
			for(var name in proto){
				if(name.charAt(0)=="_"){ continue; } 	// skip internal properties
				if(name in dummyClass){ continue; }		// skip "constructor" and "toString"
				var defVal = proto[name];
				params[name]=val2type(defVal);
			}

			instanceClasses[className] = { cls: cls, params: params };
		}
		return instanceClasses[className];
	}

	this._functionFromScript = function(script){
		var preamble = "";
		var suffix = "";
		var argsStr = script.getAttribute("args");
		if(argsStr){
			d.forEach(argsStr.split(/\s*,\s*/), function(part, idx){
				preamble += "var "+part+" = arguments["+idx+"]; ";
			});
		}
		var withStr = script.getAttribute("with");
		if(withStr && withStr.length){
			d.forEach(withStr.split(/\s*,\s*/), function(part){
				preamble += "with("+part+"){";
				suffix += "}";
			});
		}
		return new Function(preamble+script.innerHTML+suffix);
	}

	this.instantiate = function(/* Array */nodes, /* Object? */mixin, /* Object? */args){
		// summary:
		//		Takes array of nodes, and turns them into class instances and
		//		potentially calls a layout method to allow them to connect with
		//		any children		
		// mixin: Object?
		//		An object that will be mixed in with each node in the array.
		//		Values in the mixin will override values in the node, if they
		//		exist.
		// args: Object?
		//		An object used to hold kwArgs for instantiation.
		//		Only supports 'noStart' currently.
		var thelist = [], dp = dojo.parser;
		mixin = mixin||{};
		args = args||{};
		
		d.forEach(nodes, function(node){
			if(!node){ return; }
			var type = dp._attrName in mixin?mixin[dp._attrName]:node.getAttribute(dp._attrName);
			if(!type || !type.length){ return; }
			var clsInfo = getClassInfo(type),
				clazz = clsInfo.cls,
				ps = clazz._noScript || clazz.prototype._noScript;

			// read parameters (ie, attributes).
			// clsInfo.params lists expected params like {"checked": "boolean", "n": "number"}
			var params = {},
				attributes = node.attributes;
			for(var name in clsInfo.params){
				var item = name in mixin?{value:mixin[name],specified:true}:attributes.getNamedItem(name);
				if(!item || (!item.specified && (!dojo.isIE || name.toLowerCase()!="value"))){ continue; }
				var value = item.value;
				// Deal with IE quirks for 'class' and 'style'
				switch(name){
				case "class":
					value = "className" in mixin?mixin.className:node.className;
					break;
				case "style":
					value = "style" in mixin?mixin.style:(node.style && node.style.cssText); // FIXME: Opera?
				}
				var _type = clsInfo.params[name];
				if(typeof value == "string"){
					params[name] = str2obj(value, _type);
				}else{
					params[name] = value;
				}
			}

			// Process <script type="dojo/*"> script tags
			// <script type="dojo/method" event="foo"> tags are added to params, and passed to
			// the widget on instantiation.
			// <script type="dojo/method"> tags (with no event) are executed after instantiation
			// <script type="dojo/connect" event="foo"> tags are dojo.connected after instantiation
			// note: dojo/* script tags cannot exist in self closing widgets, like <input />
			if(!ps){
				var connects = [],	// functions to connect after instantiation
					calls = [];		// functions to call after instantiation

				d.query("> script[type^='dojo/']", node).orphan().forEach(function(script){
					var event = script.getAttribute("event"),
						type = script.getAttribute("type"),
						nf = d.parser._functionFromScript(script);
					if(event){
						if(type == "dojo/connect"){
							connects.push({event: event, func: nf});
						}else{
							params[event] = nf;
						}
					}else{
						calls.push(nf);
					}
				});
			}

			var markupFactory = clazz.markupFactory || clazz.prototype && clazz.prototype.markupFactory;
			// create the instance
			var instance = markupFactory ? markupFactory(params, node, clazz) : new clazz(params, node);
			thelist.push(instance);

			// map it to the JS namespace if that makes sense
			var jsname = node.getAttribute("jsId");
			if(jsname){
				d.setObject(jsname, instance);
			}

			// process connections and startup functions
			if(!ps){
				d.forEach(connects, function(connect){
					d.connect(instance, connect.event, null, connect.func);
				});
				d.forEach(calls, function(func){
					func.call(instance);
				});
			}
		});

		// Call startup on each top level instance if it makes sense (as for
		// widgets).  Parent widgets will recursively call startup on their
		// (non-top level) children
		if(!mixin._started){
			d.forEach(thelist, function(instance){
				if(	!args.noStart && instance  && 
					instance.startup &&
					!instance._started && 
					(!instance.getParent || !instance.getParent())
				){
					instance.startup();
				}
			});
		}
		return thelist;
	};

	this.parse = function(/*DomNode?*/ rootNode, /* Object? */ args){
		// summary:
		//		Scan the DOM for class instances, and instantiate them.
		//
		// description:
		//		Search specified node (or root node) recursively for class instances,
		//		and instantiate them Searches for
		//		dojoType="qualified.class.name"
		//
		// rootNode: DomNode?
		//		A default starting root node from which to start the parsing. Can be
		//		omitted, defaulting to the entire document. If omitted, the `args`
		//		object can be passed in this place. If the `args` object has a 
		//		`rootNode` member, that is used.
		//
		// args:
		//		a kwArgs object passed along to instantiate()
		//		
		//			* noStart: Boolean?
		//				when set will prevent the parser from calling .startup()
		//				when locating the nodes. 
		//			* rootNode: DomNode?
		//				identical to the function's `rootNode` argument, though
		//				allowed to be passed in via this `args object. 
		//
		// example:
		//		Parse all widgets on a page:
		//	|		dojo.parser.parse();
		//
		// example:
		//		Parse all classes within the node with id="foo"
		//	|		dojo.parser.parse(dojo.byId(foo));
		//
		// example:
		//		Parse all classes in a page, but do not call .startup() on any 
		//		child
		//	|		dojo.parser.parse({ noStart: true })
		//
		// example:
		//		Parse all classes in a node, but do not call .startup()
		//	|		dojo.parser.parse(someNode, { noStart:true });
		//	|		// or
		// 	|		dojo.parser.parse({ noStart:true, rootNode: someNode });

		// determine the root node based on the passed arguments.
		var root;
		if(!args && rootNode && rootNode.rootNode){
			args = rootNode;
			root = args.rootNode;
		}else{
			root = rootNode;
		}

		var	list = d.query(this._query, root);
			// go build the object instances
		return this.instantiate(list, null, args); // Array

	};
}();

//Register the parser callback. It should be the first callback
//after the a11y test.

(function(){
	var parseRunner = function(){ 
		if(dojo.config.parseOnLoad){
			dojo.parser.parse(); 
		}
	};

	// FIXME: need to clobber cross-dependency!!
	if(dojo.exists("dijit.wai.onload") && (dijit.wai.onload === dojo._loaders[0])){
		dojo._loaders.splice(1, 0, parseRunner);
	}else{
		dojo._loaders.unshift(parseRunner);
	}
})();

}

if(!dojo._hasResource["dojo.string"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.string"] = true;
dojo.provide("dojo.string");

/*=====
dojo.string = { 
	// summary: String utilities for Dojo
};
=====*/

dojo.string.rep = function(/*String*/str, /*Integer*/num){
	//	summary:
	//		Efficiently replicate a string `n` times.
	//	str:
	//		the string to replicate
	//	num:
	//		number of times to replicate the string
	
	if(num <= 0 || !str){ return ""; }
	
	var buf = [];
	for(;;){
		if(num & 1){
			buf.push(str);
		}
		if(!(num >>= 1)){ break; }
		str += str;
	}
	return buf.join("");	// String
};

dojo.string.pad = function(/*String*/text, /*Integer*/size, /*String?*/ch, /*Boolean?*/end){
	//	summary:
	//		Pad a string to guarantee that it is at least `size` length by
	//		filling with the character `ch` at either the start or end of the
	//		string. Pads at the start, by default.
	//	text:
	//		the string to pad
	//	size:
	//		length to provide padding
	//	ch:
	//		character to pad, defaults to '0'
	//	end:
	//		adds padding at the end if true, otherwise pads at start
	//	example:
	//	|	// Fill the string to length 10 with "+" characters on the right.  Yields "Dojo++++++".
	//	|	dojo.string.pad("Dojo", 10, "+", true);

	if(!ch){
		ch = '0';
	}
	var out = String(text),
		pad = dojo.string.rep(ch, Math.ceil((size - out.length) / ch.length));
	return end ? out + pad : pad + out;	// String
};

dojo.string.substitute = function(	/*String*/		template, 
									/*Object|Array*/map, 
									/*Function?*/	transform, 
									/*Object?*/		thisObject){
	//	summary:
	//		Performs parameterized substitutions on a string. Throws an
	//		exception if any parameter is unmatched.
	//	template: 
	//		a string with expressions in the form `${key}` to be replaced or
	//		`${key:format}` which specifies a format function. keys are case-sensitive. 
	//	map:
	//		hash to search for substitutions
	//	transform: 
	//		a function to process all parameters before substitution takes
	//		place, e.g. mylib.encodeXML
	//	thisObject: 
	//		where to look for optional format function; default to the global
	//		namespace
	//	example:
	//		Substitutes two expressions in a string from an Array or Object
	//	|	// returns "File 'foo.html' is not found in directory '/temp'."
	//	|	// by providing substitution data in an Array
	//	|	dojo.string.substitute(
	//	|		"File '${0}' is not found in directory '${1}'.",
	//	|		["foo.html","/temp"]
	//	|	);
	//	|
	//	|	// also returns "File 'foo.html' is not found in directory '/temp'."
	//	|	// but provides substitution data in an Object structure.  Dotted
	//	|	// notation may be used to traverse the structure.
	//	|	dojo.string.substitute(
	//	|		"File '${name}' is not found in directory '${info.dir}'.",
	//	|		{ name: "foo.html", info: { dir: "/temp" } }
	//	|	);
	//	example:
	//		Use a transform function to modify the values:
	//	|	// returns "file 'foo.html' is not found in directory '/temp'."
	//	|	dojo.string.substitute(
	//	|		"${0} is not found in ${1}.",
	//	|		["foo.html","/temp"],
	//	|		function(str){
	//	|			// try to figure out the type
	//	|			var prefix = (str.charAt(0) == "/") ? "directory": "file";
	//	|			return prefix + " '" + str + "'";
	//	|		}
	//	|	);
	//	example:
	//		Use a formatter
	//	|	// returns "thinger -- howdy"
	//	|	dojo.string.substitute(
	//	|		"${0:postfix}", ["thinger"], null, {
	//	|			postfix: function(value, key){
	//	|				return value + " -- howdy";
	//	|			}
	//	|		}
	//	|	);

	thisObject = thisObject || dojo.global;
	transform = transform ? 
		dojo.hitch(thisObject, transform) : function(v){ return v; };

	return template.replace(/\$\{([^\s\:\}]+)(?:\:([^\s\:\}]+))?\}/g,
		function(match, key, format){
			var value = dojo.getObject(key, false, map);
			if(format){
				value = dojo.getObject(format, false, thisObject).call(thisObject, value, key);
			}
			return transform(value, key).toString();
		}); // String
};

/*=====
dojo.string.trim = function(str){
	//	summary:
	//		Trims whitespace from both sides of the string
	//	str: String
	//		String to be trimmed
	//	returns: String
	//		Returns the trimmed string
	//	description:
	//		This version of trim() was taken from [Steven Levithan's blog](http://blog.stevenlevithan.com/archives/faster-trim-javascript).
	//		The short yet performant version of this function is dojo.trim(),
	//		which is part of Dojo base.  Uses String.prototype.trim instead, if available.
	return "";	// String
}
=====*/

dojo.string.trim = String.prototype.trim ?
	dojo.trim : // aliasing to the native function
	function(str){
		str = str.replace(/^\s+/, '');
		for(var i = str.length - 1; i >= 0; i--){
			if(/\S/.test(str.charAt(i))){
				str = str.substring(0, i + 1);
				break;
			}
		}
		return str;
	};

}

if(!dojo._hasResource["dijit._Widget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._Widget"] = true;
dojo.provide("dijit._Widget");

dojo.require( "dijit._base" );


// This code is to assist deferring dojo.connect() calls in widgets (connecting to events on the widgets'
// DOM nodes) until someone actually needs to monitor that event.
dojo.connect(dojo, "_connect",
	function(/*dijit._Widget*/ widget, /*String*/ event){
		if(widget && dojo.isFunction(widget._onConnect)){
			widget._onConnect(event);
		}
	});

dijit._connectOnUseEventHandler = function(/*Event*/ event){};

// Keep track of where the last keydown event was, to help avoid generating
// spurious ondijitclick events when:
// 1. focus is on a <button> or <a>
// 2. user presses then releases the ENTER key
// 3. onclick handler fires and shifts focus to another node, with an ondijitclick handler
// 4. onkeyup event fires, causing the ondijitclick handler to fire
dijit._lastKeyDownNode = null;
if(dojo.isIE){
	(function(){
		var keydownCallback = function(evt){
			dijit._lastKeyDownNode = evt.srcElement;
		};
		dojo.doc.attachEvent('onkeydown', keydownCallback);
		dojo.addOnWindowUnload(function(){
			dojo.doc.detachEvent('onkeydown', keydownCallback);
		});
	})();
}else{
	dojo.doc.addEventListener('keydown', function(evt){
		dijit._lastKeyDownNode = evt.target;
	}, true);
}

(function(){

var _attrReg = {},	// cached results from getSetterAttributes
	getSetterAttributes = function(widget){
		// summary:
		//		Returns list of attributes with custom setters for specified widget
		var dc = widget.declaredClass;
		if(!_attrReg[dc]){
			var r = [],
				attrs,
				proto = widget.constructor.prototype;
			for(var fxName in proto){
				if(dojo.isFunction(proto[fxName]) && (attrs = fxName.match(/^_set([a-zA-Z]*)Attr$/)) && attrs[1]){
					r.push(attrs[1].charAt(0).toLowerCase() + attrs[1].substr(1));
				}
			}
			_attrReg[dc] = r;
		}
		return _attrReg[dc] || [];	// String[]
	};

dojo.declare("dijit._Widget", null, {
	// summary:
	//		Base class for all Dijit widgets.

	// id: [const] String
	//		A unique, opaque ID string that can be assigned by users or by the
	//		system. If the developer passes an ID which is known not to be
	//		unique, the specified ID is ignored and the system-generated ID is
	//		used instead.
	id: "",

	// lang: [const] String
	//		Rarely used.  Overrides the default Dojo locale used to render this widget,
	//		as defined by the [HTML LANG](http://www.w3.org/TR/html401/struct/dirlang.html#adef-lang) attribute.
	//		Value must be among the list of locales specified during by the Dojo bootstrap,
	//		formatted according to [RFC 3066](http://www.ietf.org/rfc/rfc3066.txt) (like en-us).
	lang: "",

	// dir: [const] String
	//		Unsupported by Dijit, but here for completeness.  Dijit only supports setting text direction on the
	//		entire document.
	//		Bi-directional support, as defined by the [HTML DIR](http://www.w3.org/TR/html401/struct/dirlang.html#adef-dir)
	//		attribute. Either left-to-right "ltr" or right-to-left "rtl".
	dir: "",

	// class: String
	//		HTML class attribute
	"class": "",

	// style: String||Object
	//		HTML style attributes as cssText string or name/value hash
	style: "",

	// title: String
	//		HTML title attribute.
	//
	//		For form widgets this specifies a tooltip to display when hovering over
	//		the widget (just like the native HTML title attribute).
	//
	//		For TitlePane or for when this widget is a child of a TabContainer, AccordionContainer,
	//		etc., it's used to specify the tab label, accordion pane title, etc.
	title: "",

	// tooltip: String
	//		When this widget's title attribute is used to for a tab label, accordion pane title, etc.,
	//		this specifies the tooltip to appear when the mouse is hovered over that text.
	tooltip: "",

	// srcNodeRef: [readonly] DomNode
	//		pointer to original DOM node
	srcNodeRef: null,

	// domNode: [readonly] DomNode
	//		This is our visible representation of the widget! Other DOM
	//		Nodes may by assigned to other properties, usually through the
	//		template system's dojoAttachPoint syntax, but the domNode
	//		property is the canonical "top level" node in widget UI.
	domNode: null,

	// containerNode: [readonly] DomNode
	//		Designates where children of the source DOM node will be placed.
	//		"Children" in this case refers to both DOM nodes and widgets.
	//		For example, for myWidget:
	//
	//		|	<div dojoType=myWidget>
	//		|		<b> here's a plain DOM node
	//		|		<span dojoType=subWidget>and a widget</span>
	//		|		<i> and another plain DOM node </i>
	//		|	</div>
	//
	//		containerNode would point to:
	//
	//		|		<b> here's a plain DOM node
	//		|		<span dojoType=subWidget>and a widget</span>
	//		|		<i> and another plain DOM node </i>
	//
	//		In templated widgets, "containerNode" is set via a
	//		dojoAttachPoint assignment.
	//
	//		containerNode must be defined for any widget that accepts innerHTML
	//		(like ContentPane or BorderContainer or even Button), and conversely
	//		is null for widgets that don't, like TextBox.
	containerNode: null,

/*=====
	// _started: Boolean
	//		startup() has completed.
	_started: false,
=====*/

	// attributeMap: [protected] Object
	//		attributeMap sets up a "binding" between attributes (aka properties)
	//		of the widget and the widget's DOM.
	//		Changes to widget attributes listed in attributeMap will be
	//		reflected into the DOM.
	//
	//		For example, calling attr('title', 'hello')
	//		on a TitlePane will automatically cause the TitlePane's DOM to update
	//		with the new title.
	//
	//		attributeMap is a hash where the key is an attribute of the widget,
	//		and the value reflects a binding to a:
	//
	//		- DOM node attribute
	// |		focus: {node: "focusNode", type: "attribute"}
	// 		Maps this.focus to this.focusNode.focus
	//
	//		- DOM node innerHTML
	//	|		title: { node: "titleNode", type: "innerHTML" }
	//		Maps this.title to this.titleNode.innerHTML
	//
	//		- DOM node innerText
	//	|		title: { node: "titleNode", type: "innerText" }
	//		Maps this.title to this.titleNode.innerText
	//
	//		- DOM node CSS class
	// |		myClass: { node: "domNode", type: "class" }
	//		Maps this.myClass to this.domNode.className
	//
	//		If the value is an array, then each element in the array matches one of the
	//		formats of the above list.
	//
	//		There are also some shorthands for backwards compatibility:
	//		- string --> { node: string, type: "attribute" }, for example:
	//	|	"focusNode" ---> { node: "focusNode", type: "attribute" }
	//		- "" --> { node: "domNode", type: "attribute" }
	attributeMap: {id:"", dir:"", lang:"", "class":"", style:"", title:""},

	// _deferredConnects: [protected] Object
	//		attributeMap addendum for event handlers that should be connected only on first use
	_deferredConnects: {
		onClick: "",
		onDblClick: "",
		onKeyDown: "",
		onKeyPress: "",
		onKeyUp: "",
		onMouseMove: "",
		onMouseDown: "",
		onMouseOut: "",
		onMouseOver: "",
		onMouseLeave: "",
		onMouseEnter: "",
		onMouseUp: ""
	},

	onClick: dijit._connectOnUseEventHandler,
	/*=====
	onClick: function(event){
		// summary:
		//		Connect to this function to receive notifications of mouse click events.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onDblClick: dijit._connectOnUseEventHandler,
	/*=====
	onDblClick: function(event){
		// summary:
		//		Connect to this function to receive notifications of mouse double click events.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onKeyDown: dijit._connectOnUseEventHandler,
	/*=====
	onKeyDown: function(event){
		// summary:
		//		Connect to this function to receive notifications of keys being pressed down.
		// event:
		//		key Event
		// tags:
		//		callback
	},
	=====*/
	onKeyPress: dijit._connectOnUseEventHandler,
	/*=====
	onKeyPress: function(event){
		// summary:
		//		Connect to this function to receive notifications of printable keys being typed.
		// event:
		//		key Event
		// tags:
		//		callback
	},
	=====*/
	onKeyUp: dijit._connectOnUseEventHandler,
	/*=====
	onKeyUp: function(event){
		// summary:
		//		Connect to this function to receive notifications of keys being released.
		// event:
		//		key Event
		// tags:
		//		callback
	},
	=====*/
	onMouseDown: dijit._connectOnUseEventHandler,
	/*=====
	onMouseDown: function(event){
		// summary:
		//		Connect to this function to receive notifications of when the mouse button is pressed down.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onMouseMove: dijit._connectOnUseEventHandler,
	/*=====
	onMouseMove: function(event){
		// summary:
		//		Connect to this function to receive notifications of when the mouse moves over nodes contained within this widget.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onMouseOut: dijit._connectOnUseEventHandler,
	/*=====
	onMouseOut: function(event){
		// summary:
		//		Connect to this function to receive notifications of when the mouse moves off of nodes contained within this widget.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onMouseOver: dijit._connectOnUseEventHandler,
	/*=====
	onMouseOver: function(event){
		// summary:
		//		Connect to this function to receive notifications of when the mouse moves onto nodes contained within this widget.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onMouseLeave: dijit._connectOnUseEventHandler,
	/*=====
	onMouseLeave: function(event){
		// summary:
		//		Connect to this function to receive notifications of when the mouse moves off of this widget.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onMouseEnter: dijit._connectOnUseEventHandler,
	/*=====
	onMouseEnter: function(event){
		// summary:
		//		Connect to this function to receive notifications of when the mouse moves onto this widget.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/
	onMouseUp: dijit._connectOnUseEventHandler,
	/*=====
	onMouseUp: function(event){
		// summary:
		//		Connect to this function to receive notifications of when the mouse button is released.
		// event:
		//		mouse Event
		// tags:
		//		callback
	},
	=====*/

	// Constants used in templates

	// _blankGif: [protected] String
	//		Path to a blank 1x1 image.
	//		Used by <img> nodes in templates that really get their image via CSS background-image.
	_blankGif: (dojo.config.blankGif || dojo.moduleUrl("dojo", "resources/blank.gif")).toString(),

	//////////// INITIALIZATION METHODS ///////////////////////////////////////

	postscript: function(/*Object?*/params, /*DomNode|String*/srcNodeRef){
		// summary:
		//		Kicks off widget instantiation.  See create() for details.
		// tags:
		//		private
		this.create(params, srcNodeRef);
	},

	create: function(/*Object?*/params, /*DomNode|String?*/srcNodeRef){
		// summary:
		//		Kick off the life-cycle of a widget
		// params:
		//		Hash of initialization parameters for widget, including
		//		scalar values (like title, duration etc.) and functions,
		//		typically callbacks like onClick.
		// srcNodeRef:
		//		If a srcNodeRef (DOM node) is specified:
		//			- use srcNodeRef.innerHTML as my contents
		//			- if this is a behavioral widget then apply behavior
		//			  to that srcNodeRef
		//			- otherwise, replace srcNodeRef with my generated DOM
		//			  tree
		// description:
		//		Create calls a number of widget methods (postMixInProperties, buildRendering, postCreate,
		//		etc.), some of which of you'll want to override. See http://docs.dojocampus.org/dijit/_Widget
		//		for a discussion of the widget creation lifecycle.
		//
		//		Of course, adventurous developers could override create entirely, but this should
		//		only be done as a last resort.
		// tags:
		//		private

		// store pointer to original DOM tree
		this.srcNodeRef = dojo.byId(srcNodeRef);

		// For garbage collection.  An array of handles returned by Widget.connect()
		// Each handle returned from Widget.connect() is an array of handles from dojo.connect()
		this._connects = [];

		// For garbage collection.  An array of handles returned by Widget.subscribe()
		// The handle returned from Widget.subscribe() is the handle returned from dojo.subscribe()
		this._subscribes = [];

		// To avoid double-connects, remove entries from _deferredConnects
		// that have been setup manually by a subclass (ex, by dojoAttachEvent).
		// If a subclass has redefined a callback (ex: onClick) then assume it's being
		// connected to manually.
		this._deferredConnects = dojo.clone(this._deferredConnects);
		for(var attr in this.attributeMap){
			delete this._deferredConnects[attr]; // can't be in both attributeMap and _deferredConnects
		}
		for(attr in this._deferredConnects){
			if(this[attr] !== dijit._connectOnUseEventHandler){
				delete this._deferredConnects[attr];	// redefined, probably dojoAttachEvent exists
			}
		}

		//mixin our passed parameters
		if(this.srcNodeRef && (typeof this.srcNodeRef.id == "string")){ this.id = this.srcNodeRef.id; }
		if(params){
			this.params = params;
			dojo.mixin(this,params);
		}
		this.postMixInProperties();

		// generate an id for the widget if one wasn't specified
		// (be sure to do this before buildRendering() because that function might
		// expect the id to be there.)
		if(!this.id){
			this.id = dijit.getUniqueId(this.declaredClass.replace(/\./g,"_"));
		}
		dijit.registry.add(this);

		this.buildRendering();

		if(this.domNode){
			// Copy attributes listed in attributeMap into the [newly created] DOM for the widget.
			this._applyAttributes();

			var source = this.srcNodeRef;
			if(source && source.parentNode){
				source.parentNode.replaceChild(this.domNode, source);
			}

			// If the developer has specified a handler as a widget parameter
			// (ex: new Button({onClick: ...})
			// then naturally need to connect from DOM node to that handler immediately,
			for(attr in this.params){
				this._onConnect(attr);
			}
		}

		if(this.domNode){
			this.domNode.setAttribute("widgetId", this.id);
		}
		this.postCreate();

		// If srcNodeRef has been processed and removed from the DOM (e.g. TemplatedWidget) then delete it to allow GC.
		if(this.srcNodeRef && !this.srcNodeRef.parentNode){
			delete this.srcNodeRef;
		}

		this._created = true;
	},

	_applyAttributes: function(){
		// summary:
		//		Step during widget creation to copy all widget attributes to the
		//		DOM as per attributeMap and _setXXXAttr functions.
		// description:
		//		Skips over blank/false attribute values, unless they were explicitly specified
		//		as parameters to the widget, since those are the default anyway,
		//		and setting tabIndex="" is different than not setting tabIndex at all.
		//
		//		It processes the attributes in the attribute map first, and then
		//		it goes through and processes the attributes for the _setXXXAttr
		//		functions that have been specified
		// tags:
		//		private
		var condAttrApply = function(attr, scope){
			if((scope.params && attr in scope.params) || scope[attr]){
				scope.attr(attr, scope[attr]);
			}
		};

		// Do the attributes in attributeMap
		for(var attr in this.attributeMap){
			condAttrApply(attr, this);
		}

		// And also any attributes with custom setters
		dojo.forEach(getSetterAttributes(this), function(a){
			if(!(a in this.attributeMap)){
				condAttrApply(a, this);
			}
		}, this);
	},

	postMixInProperties: function(){
		// summary:
		//		Called after the parameters to the widget have been read-in,
		//		but before the widget template is instantiated. Especially
		//		useful to set properties that are referenced in the widget
		//		template.
		// tags:
		//		protected
	},

	buildRendering: function(){
		// summary:
		//		Construct the UI for this widget, setting this.domNode
		// description:
		//		Most widgets will mixin `dijit._Templated`, which implements this
		//		method.
		// tags:
		//		protected
		this.domNode = this.srcNodeRef || dojo.create('div');
	},

	postCreate: function(){
		// summary:
		//		Processing after the DOM fragment is created
		// description:
		//		Called after the DOM fragment has been created, but not necessarily
		//		added to the document.  Do not include any operations which rely on
		//		node dimensions or placement.
		// tags:
		//		protected
	},

	startup: function(){
		// summary:
		//		Processing after the DOM fragment is added to the document
		// description:
		//		Called after a widget and its children have been created and added to the page,
		//		and all related widgets have finished their create() cycle, up through postCreate().
		//		This is useful for composite widgets that need to control or layout sub-widgets.
		//		Many layout widgets can use this as a wiring phase.
		this._started = true;
	},

	//////////// DESTROY FUNCTIONS ////////////////////////////////

	destroyRecursive: function(/*Boolean?*/ preserveDom){
		// summary:
		// 		Destroy this widget and its descendants
		// description:
		//		This is the generic "destructor" function that all widget users
		// 		should call to cleanly discard with a widget. Once a widget is
		// 		destroyed, it is removed from the manager object.
		// preserveDom:
		//		If true, this method will leave the original DOM structure
		//		alone of descendant Widgets. Note: This will NOT work with
		//		dijit._Templated widgets.

		this._beingDestroyed = true;
		this.destroyDescendants(preserveDom);
		this.destroy(preserveDom);
	},

	destroy: function(/*Boolean*/ preserveDom){
		// summary:
		// 		Destroy this widget, but not its descendants.
		//		This method will, however, destroy internal widgets such as those used within a template.
		// preserveDom: Boolean
		//		If true, this method will leave the original DOM structure alone.
		//		Note: This will not yet work with _Templated widgets

		this._beingDestroyed = true;
		this.uninitialize();
		var d = dojo,
			dfe = d.forEach,
			dun = d.unsubscribe;
		dfe(this._connects, function(array){
			dfe(array, d.disconnect);
		});
		dfe(this._subscribes, function(handle){
			dun(handle);
		});

		// destroy widgets created as part of template, etc.
		dfe(this._supportingWidgets || [], function(w){
			if(w.destroyRecursive){
				w.destroyRecursive();
			}else if(w.destroy){
				w.destroy();
			}
		});

		this.destroyRendering(preserveDom);
		dijit.registry.remove(this.id);
		this._destroyed = true;
	},

	destroyRendering: function(/*Boolean?*/ preserveDom){
		// summary:
		//		Destroys the DOM nodes associated with this widget
		// preserveDom:
		//		If true, this method will leave the original DOM structure alone
		//		during tear-down. Note: this will not work with _Templated
		//		widgets yet.
		// tags:
		//		protected

		if(this.bgIframe){
			this.bgIframe.destroy(preserveDom);
			delete this.bgIframe;
		}

		if(this.domNode){
			if(preserveDom){
				dojo.removeAttr(this.domNode, "widgetId");
			}else{
				dojo.destroy(this.domNode);
			}
			delete this.domNode;
		}

		if(this.srcNodeRef){
			if(!preserveDom){
				dojo.destroy(this.srcNodeRef);
			}
			delete this.srcNodeRef;
		}
	},

	destroyDescendants: function(/*Boolean?*/ preserveDom){
		// summary:
		//		Recursively destroy the children of this widget and their
		//		descendants.
		// preserveDom:
		//		If true, the preserveDom attribute is passed to all descendant
		//		widget's .destroy() method. Not for use with _Templated
		//		widgets.

		// get all direct descendants and destroy them recursively
		dojo.forEach(this.getChildren(), function(widget){
			if(widget.destroyRecursive){
				widget.destroyRecursive(preserveDom);
			}
		});
	},


	uninitialize: function(){
		// summary:
		//		Stub function. Override to implement custom widget tear-down
		//		behavior.
		// tags:
		//		protected
		return false;
	},

	////////////////// MISCELLANEOUS METHODS ///////////////////

	onFocus: function(){
		// summary:
		//		Called when the widget becomes "active" because
		//		it or a widget inside of it either has focus, or has recently
		//		been clicked.
		// tags:
		//		callback
	},

	onBlur: function(){
		// summary:
		//		Called when the widget stops being "active" because
		//		focus moved to something outside of it, or the user
		//		clicked somewhere outside of it, or the widget was
		//		hidden.
		// tags:
		//		callback
	},

	_onFocus: function(e){
		// summary:
		//		This is where widgets do processing for when they are active,
		//		such as changing CSS classes.  See onFocus() for more details.
		// tags:
		//		protected
		this.onFocus();
	},

	_onBlur: function(){
		// summary:
		//		This is where widgets do processing for when they stop being active,
		//		such as changing CSS classes.  See onBlur() for more details.
		// tags:
		//		protected
		this.onBlur();
	},

	_onConnect: function(/*String*/ event){
		// summary:
		//		Called when someone connects to one of my handlers.
		//		"Turn on" that handler if it isn't active yet.
		//
		//		This is also called for every single initialization parameter
		//		so need to do nothing for parameters like "id".
		// tags:
		//		private
		if(event in this._deferredConnects){
			var mapNode = this[this._deferredConnects[event] || 'domNode'];
			this.connect(mapNode, event.toLowerCase(), event);
			delete this._deferredConnects[event];
		}
	},

	_setClassAttr: function(/*String*/ value){
		// summary:
		//		Custom setter for the CSS "class" attribute
		// tags:
		//		protected
		var mapNode = this[this.attributeMap["class"] || 'domNode'];
		dojo.removeClass(mapNode, this["class"])
		this["class"] = value;
		dojo.addClass(mapNode, value);
	},

	_setStyleAttr: function(/*String||Object*/ value){
		// summary:
		//		Sets the style attribut of the widget according to value,
		//		which is either a hash like {height: "5px", width: "3px"}
		//		or a plain string
		// description:
		//		Determines which node to set the style on based on style setting
		//		in attributeMap.
		// tags:
		//		protected

		var mapNode = this[this.attributeMap.style || 'domNode'];

		// Note: technically we should revert any style setting made in a previous call
		// to his method, but that's difficult to keep track of.

		if(dojo.isObject(value)){
			dojo.style(mapNode, value);
		}else{
			if(mapNode.style.cssText){
				mapNode.style.cssText += "; " + value;
			}else{
				mapNode.style.cssText = value;
			}
		}

		this.style = value;
	},

	setAttribute: function(/*String*/ attr, /*anything*/ value){
		// summary:
		//		Deprecated.  Use attr() instead.
		// tags:
		//		deprecated
		dojo.deprecated(this.declaredClass+"::setAttribute() is deprecated. Use attr() instead.", "", "2.0");
		this.attr(attr, value);
	},

	_attrToDom: function(/*String*/ attr, /*String*/ value){
		// summary:
		//		Reflect a widget attribute (title, tabIndex, duration etc.) to
		//		the widget DOM, as specified in attributeMap.
		//
		// description:
		//		Also sets this["attr"] to the new value.
		//		Note some attributes like "type"
		//		cannot be processed this way as they are not mutable.
		//
		// tags:
		//		private

		var commands = this.attributeMap[attr];
		dojo.forEach(dojo.isArray(commands) ? commands : [commands], function(command){

			// Get target node and what we are doing to that node
			var mapNode = this[command.node || command || "domNode"];	// DOM node
			var type = command.type || "attribute";	// class, innerHTML, innerText, or attribute

			switch(type){
				case "attribute":
					if(dojo.isFunction(value)){ // functions execute in the context of the widget
						value = dojo.hitch(this, value);
					}

					// Get the name of the DOM node attribute; usually it's the same
					// as the name of the attribute in the widget (attr), but can be overridden.
					// Also maps handler names to lowercase, like onSubmit --> onsubmit
					var attrName = command.attribute ? command.attribute :
						(/^on[A-Z][a-zA-Z]*$/.test(attr) ? attr.toLowerCase() : attr);

					dojo.attr(mapNode, attrName, value);
					break;
				case "innerText":
					mapNode.innerHTML = "";
					mapNode.appendChild(dojo.doc.createTextNode(value));
					break;
				case "innerHTML":
					mapNode.innerHTML = value;
					break;
				case "class":
					dojo.removeClass(mapNode, this[attr]);
					dojo.addClass(mapNode, value);
					break;
			}
		}, this);
		this[attr] = value;
	},

	attr: function(/*String|Object*/name, /*Object?*/value){
		// summary:
		//		Set or get properties on a widget instance.
		//	name:
		//		The property to get or set. If an object is passed here and not
		//		a string, its keys are used as names of attributes to be set
		//		and the value of the object as values to set in the widget.
		//	value:
		//		Optional. If provided, attr() operates as a setter. If omitted,
		//		the current value of the named property is returned.
		// description:
		//		Get or set named properties on a widget. If no value is
		//		provided, the current value of the attribute is returned,
		//		potentially via a getter method. If a value is provided, then
		//		the method acts as a setter, assigning the value to the name,
		//		potentially calling any explicitly provided setters to handle
		//		the operation. For instance, if the widget has properties "foo"
		//		and "bar" and a method named "_setFooAttr", calling:
		//	|	myWidget.attr("foo", "Howdy!");
		//		would be equivalent to calling:
		//	|	widget._setFooAttr("Howdy!");
		//		while calling:
		//	|	myWidget.attr("bar", "Howdy!");
		//		would be the same as writing:
		//	|	widget.bar = "Howdy!";
		//		It also tries to copy the changes to the widget's DOM according
		//		to settings in attributeMap (see description of `dijit._Widget.attributeMap`
		//		for details)
		//		For example, calling:
		//	|	myTitlePane.attr("title", "Howdy!");
		//		will do
		//	|	myTitlePane.title = "Howdy!";
		//	|	myTitlePane.title.innerHTML = "Howdy!";
		//		It works for DOM node attributes too.  Calling
		//	|	widget.attr("disabled", true)
		//		will set the disabled attribute on the widget's focusNode,
		//		among other housekeeping for a change in disabled state.

		//	open questions:
		//		- how to handle build shortcut for attributes which want to map
		//		into DOM attributes?
		//		- what relationship should setAttribute()/attr() have to
		//		layout() calls?
		var args = arguments.length;
		if(args == 1 && !dojo.isString(name)){
			for(var x in name){ this.attr(x, name[x]); }
			return this;
		}
		var names = this._getAttrNames(name);
		if(args >= 2){ // setter
			if(this[names.s]){
				// use the explicit setter
				args = dojo._toArray(arguments, 1);
				return this[names.s].apply(this, args) || this;
			}else{
				// if param is specified as DOM node attribute, copy it
				if(name in this.attributeMap){
					this._attrToDom(name, value);
				}

				// FIXME: what about function assignments? Any way to connect() here?
				this[name] = value;
			}
			return this;
		}else{ // getter
			return this[names.g] ? this[names.g]() : this[name];
		}
	},

	_attrPairNames: {},		// shared between all widgets
	_getAttrNames: function(name){
		// summary:
		//		Helper function for Widget.attr().
		//		Caches attribute name values so we don't do the string ops every time.
		// tags:
		//		private

		var apn = this._attrPairNames;
		if(apn[name]){ return apn[name]; }
		var uc = name.charAt(0).toUpperCase() + name.substr(1);
		return (apn[name] = {
			n: name+"Node",
			s: "_set"+uc+"Attr",
			g: "_get"+uc+"Attr"
		});
	},

	toString: function(){
		// summary:
		//		Returns a string that represents the widget
		// description:
		//		When a widget is cast to a string, this method will be used to generate the
		//		output. Currently, it does not implement any sort of reversible
		//		serialization.
		return '[Widget ' + this.declaredClass + ', ' + (this.id || 'NO ID') + ']'; // String
	},

	getDescendants: function(){
		// summary:
		//		Returns all the widgets contained by this, i.e., all widgets underneath this.containerNode.
		//		This method should generally be avoided as it returns widgets declared in templates, which are
		//		supposed to be internal/hidden, but it's left here for back-compat reasons.

		return this.containerNode ? dojo.query('[widgetId]', this.containerNode).map(dijit.byNode) : []; // dijit._Widget[]
	},

	getChildren: function(){
		// summary:
		//		Returns all the widgets contained by this, i.e., all widgets underneath this.containerNode.
		//		Does not return nested widgets, nor widgets that are part of this widget's template.
		return this.containerNode ? dijit.findWidgets(this.containerNode) : []; // dijit._Widget[]
	},

	// nodesWithKeyClick: [private] String[]
	//		List of nodes that correctly handle click events via native browser support,
	//		and don't need dijit's help
	nodesWithKeyClick: ["input", "button"],

	connect: function(
			/*Object|null*/ obj,
			/*String|Function*/ event,
			/*String|Function*/ method){
		// summary:
		//		Connects specified obj/event to specified method of this object
		//		and registers for disconnect() on widget destroy.
		// description:
		//		Provide widget-specific analog to dojo.connect, except with the
		//		implicit use of this widget as the target object.
		//		This version of connect also provides a special "ondijitclick"
		//		event which triggers on a click or space or enter keyup
		// returns:
		//		A handle that can be passed to `disconnect` in order to disconnect before
		//		the widget is destroyed.
		// example:
		//	|	var btn = new dijit.form.Button();
		//	|	// when foo.bar() is called, call the listener we're going to
		//	|	// provide in the scope of btn
		//	|	btn.connect(foo, "bar", function(){
		//	|		console.debug(this.toString());
		//	|	});
		// tags:
		//		protected

		var d = dojo,
			dc = d._connect,
			handles = [];
		if(event == "ondijitclick"){
			// add key based click activation for unsupported nodes.
			// do all processing onkey up to prevent spurious clicks
			// for details see comments at top of this file where _lastKeyDownNode is defined
			if(!this.nodesWithKeyClick[obj.tagName.toLowerCase()]){
				var m = d.hitch(this, method);
				handles.push(
					dc(obj, "onkeydown", this, function(e){
						//console.log(this.id + ": onkeydown, e.target = ", e.target, ", lastKeyDownNode was ", dijit._lastKeyDownNode, ", equality is ", (e.target === dijit._lastKeyDownNode));
						if((e.keyCode == d.keys.ENTER || e.keyCode == d.keys.SPACE) &&
							!e.ctrlKey && !e.shiftKey && !e.altKey && !e.metaKey){
							// needed on IE for when focus changes between keydown and keyup - otherwise dropdown menus do not work
							dijit._lastKeyDownNode = e.target;
							d.stopEvent(e);		// stop event to prevent scrolling on space key in IE
						}
			 		}),
					dc(obj, "onkeyup", this, function(e){
						//console.log(this.id + ": onkeyup, e.target = ", e.target, ", lastKeyDownNode was ", dijit._lastKeyDownNode, ", equality is ", (e.target === dijit._lastKeyDownNode));
						if( (e.keyCode == d.keys.ENTER || e.keyCode == d.keys.SPACE) &&
							e.target === dijit._lastKeyDownNode &&
							!e.ctrlKey && !e.shiftKey && !e.altKey && !e.metaKey){
								//need reset here or have problems in FF when focus returns to trigger element after closing popup/alert
								dijit._lastKeyDownNode = null;
								return m(e);
						}
					})
				);
			}
			event = "onclick";
		}
		handles.push(dc(obj, event, this, method));

		this._connects.push(handles);
		return handles;		// _Widget.Handle
	},

	disconnect: function(/* _Widget.Handle */ handles){
		// summary:
		//		Disconnects handle created by `connect`.
		//		Also removes handle from this widget's list of connects.
		// tags:
		//		protected
		for(var i=0; i<this._connects.length; i++){
			if(this._connects[i] == handles){
				dojo.forEach(handles, dojo.disconnect);
				this._connects.splice(i, 1);
				return;
			}
		}
	},

	subscribe: function(
			/*String*/ topic,
			/*String|Function*/ method){
		// summary:
		//		Subscribes to the specified topic and calls the specified method
		//		of this object and registers for unsubscribe() on widget destroy.
		// description:
		//		Provide widget-specific analog to dojo.subscribe, except with the
		//		implicit use of this widget as the target object.
		// example:
		//	|	var btn = new dijit.form.Button();
		//	|	// when /my/topic is published, this button changes its label to
		//	|   // be the parameter of the topic.
		//	|	btn.subscribe("/my/topic", function(v){
		//	|		this.attr("label", v);
		//	|	});
		var d = dojo,
			handle = d.subscribe(topic, this, method);

		// return handles for Any widget that may need them
		this._subscribes.push(handle);
		return handle;
	},

	unsubscribe: function(/*Object*/ handle){
		// summary:
		//		Unsubscribes handle created by this.subscribe.
		//		Also removes handle from this widget's list of subscriptions
		for(var i=0; i<this._subscribes.length; i++){
			if(this._subscribes[i] == handle){
				dojo.unsubscribe(handle);
				this._subscribes.splice(i, 1);
				return;
			}
		}
	},

	isLeftToRight: function(){
		// summary:
		//		Checks the page for text direction
		// tags:
		//		protected
		return dojo._isBodyLtr(); //Boolean
	},

	isFocusable: function(){
		// summary:
		//		Return true if this widget can currently be focused
		//		and false if not
		return this.focus && (dojo.style(this.domNode, "display") != "none");
	},

	placeAt: function(/* String|DomNode|_Widget */reference, /* String?|Int? */position){
		// summary:
		//		Place this widget's domNode reference somewhere in the DOM based
		//		on standard dojo.place conventions, or passing a Widget reference that
		//		contains and addChild member.
		//
		// description:
		//		A convenience function provided in all _Widgets, providing a simple
		//		shorthand mechanism to put an existing (or newly created) Widget
		//		somewhere in the dom, and allow chaining.
		//
		// reference:
		//		The String id of a domNode, a domNode reference, or a reference to a Widget posessing
		//		an addChild method.
		//
		// position:
		//		If passed a string or domNode reference, the position argument
		//		accepts a string just as dojo.place does, one of: "first", "last",
		//		"before", or "after".
		//
		//		If passed a _Widget reference, and that widget reference has an ".addChild" method,
		//		it will be called passing this widget instance into that method, supplying the optional
		//		position index passed.
		//
		// returns:
		//		dijit._Widget
		//		Provides a useful return of the newly created dijit._Widget instance so you
		//		can "chain" this function by instantiating, placing, then saving the return value
		//		to a variable.
		//
		// example:
		// | 	// create a Button with no srcNodeRef, and place it in the body:
		// | 	var button = new dijit.form.Button({ label:"click" }).placeAt(dojo.body());
		// | 	// now, 'button' is still the widget reference to the newly created button
		// | 	dojo.connect(button, "onClick", function(e){ console.log('click'); });
		//
		// example:
		// |	// create a button out of a node with id="src" and append it to id="wrapper":
		// | 	var button = new dijit.form.Button({},"src").placeAt("wrapper");
		//
		// example:
		// |	// place a new button as the first element of some div
		// |	var button = new dijit.form.Button({ label:"click" }).placeAt("wrapper","first");
		//
		// example:
		// |	// create a contentpane and add it to a TabContainer
		// |	var tc = dijit.byId("myTabs");
		// |	new dijit.layout.ContentPane({ href:"foo.html", title:"Wow!" }).placeAt(tc)

		if(reference.declaredClass && reference.addChild){
			reference.addChild(this, position);
		}else{
			dojo.place(this.domNode, reference, position);
		}
		return this;
	},

	_onShow: function(){
		// summary:
		//		Internal method called when this widget is made visible.
		//		See `onShow` for details.
		this.onShow();
	},

	onShow: function(){
		// summary:
		//		Called when this widget becomes the selected pane in a
		//		`dijit.layout.TabContainer`, `dijit.layout.StackContainer`,
		//		`dijit.layout.AccordionContainer`, etc.
		//
		//		Also called to indicate display of a `dijit.Dialog`, `dijit.TooltipDialog`, or `dijit.TitlePane`.
		// tags:
		//		callback
	},

	onHide: function(){
		// summary:
			//		Called when another widget becomes the selected pane in a
			//		`dijit.layout.TabContainer`, `dijit.layout.StackContainer`,
			//		`dijit.layout.AccordionContainer`, etc.
			//
			//		Also called to indicate hide of a `dijit.Dialog`, `dijit.TooltipDialog`, or `dijit.TitlePane`.
			// tags:
			//		callback
	}
});

})();

}

if(!dojo._hasResource["dojo.cache"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.cache"] = true;
dojo.provide("dojo.cache");

/*=====
dojo.cache = { 
	// summary:
	// 		A way to cache string content that is fetchable via `dojo.moduleUrl`.
};
=====*/

(function(){
	var cache = {};
	dojo.cache = function(/*String||Object*/module, /*String*/url, /*String||Object?*/value){
		// summary:
		// 		A getter and setter for storing the string content associated with the
		// 		module and url arguments.
		// description:
		// 		module and url are used to call `dojo.moduleUrl()` to generate a module URL.
		// 		If value is specified, the cache value for the moduleUrl will be set to
		// 		that value. Otherwise, dojo.cache will fetch the moduleUrl and store it
		// 		in its internal cache and return that cached value for the URL. To clear
		// 		a cache value pass null for value. Since XMLHttpRequest (XHR) is used to fetch the
		// 		the URL contents, only modules on the same domain of the page can use this capability.
		// 		The build system can inline the cache values though, to allow for xdomain hosting.
		// module: String||Object
		// 		If a String, the module name to use for the base part of the URL, similar to module argument
		// 		to `dojo.moduleUrl`. If an Object, something that has a .toString() method that
		// 		generates a valid path for the cache item. For example, a dojo._Url object.
		// url: String
		// 		The rest of the path to append to the path derived from the module argument. If
		// 		module is an object, then this second argument should be the "value" argument instead.
		// value: String||Object?
		// 		If a String, the value to use in the cache for the module/url combination.
		// 		If an Object, it can have two properties: value and sanitize. The value property
		// 		should be the value to use in the cache, and sanitize can be set to true or false,
		// 		to indicate if XML declarations should be removed from the value and if the HTML
		// 		inside a body tag in the value should be extracted as the real value. The value argument
		// 		or the value property on the value argument are usually only used by the build system
		// 		as it inlines cache content.
		//	example:
		//		To ask dojo.cache to fetch content and store it in the cache (the dojo["cache"] style
		// 		of call is used to avoid an issue with the build system erroneously trying to intern
		// 		this example. To get the build system to intern your dojo.cache calls, use the
		// 		"dojo.cache" style of call):
		// 		|	//If template.html contains "<h1>Hello</h1>" that will be
		// 		|	//the value for the text variable.
		//		|	var text = dojo["cache"]("my.module", "template.html");
		//	example:
		//		To ask dojo.cache to fetch content and store it in the cache, and sanitize the input
		// 		 (the dojo["cache"] style of call is used to avoid an issue with the build system 
		// 		erroneously trying to intern this example. To get the build system to intern your
		// 		dojo.cache calls, use the "dojo.cache" style of call):
		// 		|	//If template.html contains "<html><body><h1>Hello</h1></body></html>", the
		// 		|	//text variable will contain just "<h1>Hello</h1>".
		//		|	var text = dojo["cache"]("my.module", "template.html", {sanitize: true});
		//	example:
		//		Same example as previous, but demostrates how an object can be passed in as
		//		the first argument, then the value argument can then be the second argument.
		// 		|	//If template.html contains "<html><body><h1>Hello</h1></body></html>", the
		// 		|	//text variable will contain just "<h1>Hello</h1>".
		//		|	var text = dojo["cache"](new dojo._Url("my/module/template.html"), {sanitize: true});

		//Module could be a string, or an object that has a toString() method
		//that will return a useful path. If it is an object, then the "url" argument
		//will actually be the value argument.
		if(typeof module == "string"){
			var pathObj = dojo.moduleUrl(module, url);
		}else{
			pathObj = module;
			value = url;
		}
		var key = pathObj.toString();

		var val = value;
		if(value !== undefined && !dojo.isString(value)){
			val = ("value" in value ? value.value : undefined);
		}

		var sanitize = value && value.sanitize ? true : false;

		if(val || val === null){
			//We have a value, either clear or set the cache value.
			if(val == null){
				delete cache[key];
			}else{
				val = cache[key] = sanitize ? dojo.cache._sanitize(val) : val;
			}
		}else{
			//Allow cache values to be empty strings. If key property does
			//not exist, fetch it.
			if(!(key in cache)){
				val = dojo._getText(key);
				cache[key] = sanitize ? dojo.cache._sanitize(val) : val;
			}
			val = cache[key];
		}
		return val; //String
	};

	dojo.cache._sanitize = function(/*String*/val){
		// summary: 
		//		Strips <?xml ...?> declarations so that external SVG and XML
		// 		documents can be added to a document without worry. Also, if the string
		//		is an HTML document, only the part inside the body tag is returned.
		// description:
		// 		Copied from dijit._Templated._sanitizeTemplateString.
		if(val){
			val = val.replace(/^\s*<\?xml(\s)+version=[\'\"](\d)*.(\d)*[\'\"](\s)*\?>/im, "");
			var matches = val.match(/<body[^>]*>\s*([\s\S]+)\s*<\/body>/im);
			if(matches){
				val = matches[1];
			}
		}else{
			val = "";
		}
		return val; //String
	};
})();

}

if(!dojo._hasResource["dijit._Templated"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._Templated"] = true;
dojo.provide("dijit._Templated");






dojo.declare("dijit._Templated",
	null,
	{
		// summary:
		//		Mixin for widgets that are instantiated from a template
		//

		// templateString: [protected] String
		//		A string that represents the widget template. Pre-empts the
		//		templatePath. In builds that have their strings "interned", the
		//		templatePath is converted to an inline templateString, thereby
		//		preventing a synchronous network call.
		//
		//		Use in conjunction with dojo.cache() to load from a file.
		templateString: null,

		// templatePath: [protected deprecated] String
		//		Path to template (HTML file) for this widget relative to dojo.baseUrl.
		//		Deprecated: use templateString with dojo.cache() instead.
		templatePath: null,

		// widgetsInTemplate: [protected] Boolean
		//		Should we parse the template to find widgets that might be
		//		declared in markup inside it?  False by default.
		widgetsInTemplate: false,

		// skipNodeCache: [protected] Boolean
		//		If using a cached widget template node poses issues for a
		//		particular widget class, it can set this property to ensure
		//		that its template is always re-built from a string
		_skipNodeCache: false,

		// _earlyTemplatedStartup: Boolean
		//		A fallback to preserve the 1.0 - 1.3 behavior of children in
		//		templates having their startup called before the parent widget
		//		fires postCreate. Defaults to 'false', causing child widgets to
		//		have their .startup() called immediately before a parent widget
		//		.startup(), but always after the parent .postCreate(). Set to
		//		'true' to re-enable to previous, arguably broken, behavior.
		_earlyTemplatedStartup: false,

		_stringRepl: function(tmpl){
			// summary:
			//		Does substitution of ${foo} type properties in template string
			// tags:
			//		private
			var className = this.declaredClass, _this = this;
			// Cache contains a string because we need to do property replacement
			// do the property replacement
			return dojo.string.substitute(tmpl, this, function(value, key){
				if(key.charAt(0) == '!'){ value = dojo.getObject(key.substr(1), false, _this); }
				if(typeof value == "undefined"){ throw new Error(className+" template:"+key); } // a debugging aide
				if(value == null){ return ""; }

				// Substitution keys beginning with ! will skip the transform step,
				// in case a user wishes to insert unescaped markup, e.g. ${!foo}
				return key.charAt(0) == "!" ? value :
					// Safer substitution, see heading "Attribute values" in
					// http://www.w3.org/TR/REC-html40/appendix/notes.html#h-B.3.2
					value.toString().replace(/"/g,"&quot;"); //TODO: add &amp? use encodeXML method?
			}, this);
		},

		// method over-ride
		buildRendering: function(){
			// summary:
			//		Construct the UI for this widget from a template, setting this.domNode.
			// tags:
			//		protected

			this._attachPoints = [];

			// Lookup cached version of template, and download to cache if it
			// isn't there already.  Returns either a DomNode or a string, depending on
			// whether or not the template contains ${foo} replacement parameters.
			var cached = dijit._Templated.getCachedTemplate(this.templatePath, this.templateString, this._skipNodeCache);

			var node;
			if(dojo.isString(cached)){
				node = dojo._toDom(this._stringRepl(cached));
				if(node.nodeType != 1){
					// Flag common problems such as templates with multiple top level nodes (nodeType == 11)
					throw new Error("Invalid template: " + cached);
				}
			}else{
				// if it's a node, all we have to do is clone it
				node = cached.cloneNode(true);
			}

			this.domNode = node;

			// recurse through the node, looking for, and attaching to, our
			// attachment points and events, which should be defined on the template node.
			this._attachTemplateNodes(node);

			if(this.widgetsInTemplate){
				// Make sure dojoType is used for parsing widgets in template.
				// The dojo.parser.query could be changed from multiversion support.
				var parser = dojo.parser, qry, attr;
				if(parser._query != "[dojoType]"){
					qry = parser._query;
					attr = parser._attrName;
					parser._query = "[dojoType]";
					parser._attrName = "dojoType";
				}

				// Store widgets that we need to start at a later point in time
				var cw = (this._startupWidgets = dojo.parser.parse(node, {
					noStart: !this._earlyTemplatedStartup
				}));

				// Restore the query.
				if(qry){
					parser._query = qry;
					parser._attrName = attr;
				}

				this._supportingWidgets = dijit.findWidgets(node);

				this._attachTemplateNodes(cw, function(n,p){
					return n[p];
				});
			}

			this._fillContent(this.srcNodeRef);
		},

		_fillContent: function(/*DomNode*/ source){
			// summary:
			//		Relocate source contents to templated container node.
			//		this.containerNode must be able to receive children, or exceptions will be thrown.
			// tags:
			//		protected
			var dest = this.containerNode;
			if(source && dest){
				while(source.hasChildNodes()){
					dest.appendChild(source.firstChild);
				}
			}
		},

		_attachTemplateNodes: function(rootNode, getAttrFunc){
			// summary:
			//		Iterate through the template and attach functions and nodes accordingly.
			// description:
			//		Map widget properties and functions to the handlers specified in
			//		the dom node and it's descendants. This function iterates over all
			//		nodes and looks for these properties:
			//			* dojoAttachPoint
			//			* dojoAttachEvent
			//			* waiRole
			//			* waiState
			// rootNode: DomNode|Array[Widgets]
			//		the node to search for properties. All children will be searched.
			// getAttrFunc: Function?
			//		a function which will be used to obtain property for a given
			//		DomNode/Widget
			// tags:
			//		private

			getAttrFunc = getAttrFunc || function(n,p){ return n.getAttribute(p); };

			var nodes = dojo.isArray(rootNode) ? rootNode : (rootNode.all || rootNode.getElementsByTagName("*"));
			var x = dojo.isArray(rootNode) ? 0 : -1;
			for(; x<nodes.length; x++){
				var baseNode = (x == -1) ? rootNode : nodes[x];
				if(this.widgetsInTemplate && getAttrFunc(baseNode, "dojoType")){
					continue;
				}
				// Process dojoAttachPoint
				var attachPoint = getAttrFunc(baseNode, "dojoAttachPoint");
				if(attachPoint){
					var point, points = attachPoint.split(/\s*,\s*/);
					while((point = points.shift())){
						if(dojo.isArray(this[point])){
							this[point].push(baseNode);
						}else{
							this[point]=baseNode;
						}
						this._attachPoints.push(point);
					}
				}

				// Process dojoAttachEvent
				var attachEvent = getAttrFunc(baseNode, "dojoAttachEvent");
				if(attachEvent){
					// NOTE: we want to support attributes that have the form
					// "domEvent: nativeEvent; ..."
					var event, events = attachEvent.split(/\s*,\s*/);
					var trim = dojo.trim;
					while((event = events.shift())){
						if(event){
							var thisFunc = null;
							if(event.indexOf(":") != -1){
								// oh, if only JS had tuple assignment
								var funcNameArr = event.split(":");
								event = trim(funcNameArr[0]);
								thisFunc = trim(funcNameArr[1]);
							}else{
								event = trim(event);
							}
							if(!thisFunc){
								thisFunc = event;
							}
							this.connect(baseNode, event, thisFunc);
						}
					}
				}

				// waiRole, waiState
				var role = getAttrFunc(baseNode, "waiRole");
				if(role){
					dijit.setWaiRole(baseNode, role);
				}
				var values = getAttrFunc(baseNode, "waiState");
				if(values){
					dojo.forEach(values.split(/\s*,\s*/), function(stateValue){
						if(stateValue.indexOf('-') != -1){
							var pair = stateValue.split('-');
							dijit.setWaiState(baseNode, pair[0], pair[1]);
						}
					});
				}
			}
		},

		startup: function(){
			dojo.forEach(this._startupWidgets, function(w){
				if(w && !w._started && w.startup){
					w.startup();
				}
			});
			this.inherited(arguments);
		},

		destroyRendering: function(){
			// Delete all attach points to prevent IE6 memory leaks.
			dojo.forEach(this._attachPoints, function(point){
				delete this[point];
			}, this);
			this._attachPoints = [];

			this.inherited(arguments);
		}
	}
);

// key is either templatePath or templateString; object is either string or DOM tree
dijit._Templated._templateCache = {};

dijit._Templated.getCachedTemplate = function(templatePath, templateString, alwaysUseString){
	// summary:
	//		Static method to get a template based on the templatePath or
	//		templateString key
	// templatePath: String||dojo.uri.Uri
	//		The URL to get the template from.
	// templateString: String?
	//		a string to use in lieu of fetching the template from a URL. Takes precedence
	//		over templatePath
	// returns: Mixed
	//		Either string (if there are ${} variables that need to be replaced) or just
	//		a DOM tree (if the node can be cloned directly)

	// is it already cached?
	var tmplts = dijit._Templated._templateCache;
	var key = templateString || templatePath;
	var cached = tmplts[key];
	if(cached){
		try{
			// if the cached value is an innerHTML string (no ownerDocument) or a DOM tree created within the current document, then use the current cached value
			if(!cached.ownerDocument || cached.ownerDocument == dojo.doc){
				// string or node of the same document
				return cached;
			}
		}catch(e){ /* squelch */ } // IE can throw an exception if cached.ownerDocument was reloaded
		dojo.destroy(cached);
	}

	// If necessary, load template string from template path
	if(!templateString){
		templateString = dojo.cache(templatePath, {sanitize: true});
	}
	templateString = dojo.string.trim(templateString);

	if(alwaysUseString || templateString.match(/\$\{([^\}]+)\}/g)){
		// there are variables in the template so all we can do is cache the string
		return (tmplts[key] = templateString); //String
	}else{
		// there are no variables in the template so we can cache the DOM tree
		var node = dojo._toDom(templateString);
		if(node.nodeType != 1){
			throw new Error("Invalid template: " + templateString);
		}
		return (tmplts[key] = node); //Node
	}
};

if(dojo.isIE){
	dojo.addOnWindowUnload(function(){
		var cache = dijit._Templated._templateCache;
		for(var key in cache){
			var value = cache[key];
			if(typeof value == "object"){ // value is either a string or a DOM node template
				dojo.destroy(value);
			}
			delete cache[key];
		}
	});
}

// These arguments can be specified for widgets which are used in templates.
// Since any widget can be specified as sub widgets in template, mix it
// into the base widget class.  (This is a hack, but it's effective.)
dojo.extend(dijit._Widget,{
	dojoAttachEvent: "",
	dojoAttachPoint: "",
	waiRole: "",
	waiState:""
});

}

if(!dojo._hasResource["dijit._Container"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._Container"] = true;
dojo.provide("dijit._Container");

dojo.declare("dijit._Container",
	null,
	{
		// summary:
		//		Mixin for widgets that contain a set of widget children.
		// description:
		//		Use this mixin for widgets that needs to know about and
		//		keep track of their widget children. Suitable for widgets like BorderContainer
		//		and TabContainer which contain (only) a set of child widgets.
		//
		//		It's not suitable for widgets like ContentPane
		//		which contains mixed HTML (plain DOM nodes in addition to widgets),
		//		and where contained widgets are not necessarily directly below
		//		this.containerNode.   In that case calls like addChild(node, position)
		//		wouldn't make sense.

		// isContainer: [protected] Boolean
		//		Indicates that this widget acts as a "parent" to the descendant widgets.
		//		When the parent is started it will call startup() on the child widgets.
		//		See also `isLayoutContainer`.
		isContainer: true,

		buildRendering: function(){
			this.inherited(arguments);
			if(!this.containerNode){
				// all widgets with descendants must set containerNode
	 				this.containerNode = this.domNode;
			}
		},

		addChild: function(/*dijit._Widget*/ widget, /*int?*/ insertIndex){
			// summary:
			//		Makes the given widget a child of this widget.
			// description:
			//		Inserts specified child widget's dom node as a child of this widget's
			//		container node, and possibly does other processing (such as layout).

			var refNode = this.containerNode;
			if(insertIndex && typeof insertIndex == "number"){
				var children = this.getChildren();
				if(children && children.length >= insertIndex){
					refNode = children[insertIndex-1].domNode;
					insertIndex = "after";
				}
			}
			dojo.place(widget.domNode, refNode, insertIndex);

			// If I've been started but the child widget hasn't been started,
			// start it now.  Make sure to do this after widget has been
			// inserted into the DOM tree, so it can see that it's being controlled by me,
			// so it doesn't try to size itself.
			if(this._started && !widget._started){
				widget.startup();
			}
		},

		removeChild: function(/*Widget or int*/ widget){
			// summary:
			//		Removes the passed widget instance from this widget but does
			//		not destroy it.  You can also pass in an integer indicating
			//		the index within the container to remove

			if(typeof widget == "number" && widget > 0){
				widget = this.getChildren()[widget];
			}

			if(widget && widget.domNode){
				var node = widget.domNode;
				node.parentNode.removeChild(node); // detach but don't destroy
			}
		},

		getChildren: function(){
			// summary:
			//		Returns array of children widgets.
			// description:
			//		Returns the widgets that are directly under this.containerNode.
			return dojo.query("> [widgetId]", this.containerNode).map(dijit.byNode); // Widget[]
		},

		hasChildren: function(){
			// summary:
			//		Returns true if widget has children, i.e. if this.containerNode contains something.
			return dojo.query("> [widgetId]", this.containerNode).length > 0;	// Boolean
		},

		destroyDescendants: function(/*Boolean*/ preserveDom){
			// summary:
			//      Destroys all the widgets inside this.containerNode,
			//      but not this widget itself
			dojo.forEach(this.getChildren(), function(child){ child.destroyRecursive(preserveDom); });
		},

		_getSiblingOfChild: function(/*dijit._Widget*/ child, /*int*/ dir){
			// summary:
			//		Get the next or previous widget sibling of child
			// dir:
			//		if 1, get the next sibling
			//		if -1, get the previous sibling
			// tags:
			//      private
			var node = child.domNode,
				which = (dir>0 ? "nextSibling" : "previousSibling");
			do{
				node = node[which];
			}while(node && (node.nodeType != 1 || !dijit.byNode(node)));
			return node && dijit.byNode(node);	// dijit._Widget
		},

		getIndexOfChild: function(/*dijit._Widget*/ child){
			// summary:
			//		Gets the index of the child in this container or -1 if not found
			return dojo.indexOf(this.getChildren(), child);	// int
		},

		startup: function(){
			// summary:
			//		Called after all the widgets have been instantiated and their
			//		dom nodes have been inserted somewhere under dojo.doc.body.
			//
			//		Widgets should override this method to do any initialization
			//		dependent on other widgets existing, and then call
			//		this superclass method to finish things off.
			//
			//		startup() in subclasses shouldn't do anything
			//		size related because the size of the widget hasn't been set yet.

			if(this._started){ return; }

			// Startup all children of this widget
			dojo.forEach(this.getChildren(), function(child){ child.startup(); });

			this.inherited(arguments);
		}
	}
);

}

if(!dojo._hasResource["dijit._Contained"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._Contained"] = true;
dojo.provide("dijit._Contained");

dojo.declare("dijit._Contained",
		null,
		{
			// summary:
			//		Mixin for widgets that are children of a container widget
			//
			// example:
			// | 	// make a basic custom widget that knows about it's parents
			// |	dojo.declare("my.customClass",[dijit._Widget,dijit._Contained],{});

			getParent: function(){
				// summary:
				//		Returns the parent widget of this widget, assuming the parent
				//		specifies isContainer
				var parent = dijit.getEnclosingWidget(this.domNode.parentNode);
				return parent && parent.isContainer ? parent : null;
			},

			_getSibling: function(/*String*/ which){
				// summary:
				//      Returns next or previous sibling
				// which:
				//      Either "next" or "previous"
				// tags:
				//      private
				var node = this.domNode;
				do{
					node = node[which+"Sibling"];
				}while(node && node.nodeType != 1);
				return node && dijit.byNode(node);	// dijit._Widget
			},

			getPreviousSibling: function(){
				// summary:
				//		Returns null if this is the first child of the parent,
				//		otherwise returns the next element sibling to the "left".

				return this._getSibling("previous"); // dijit._Widget
			},

			getNextSibling: function(){
				// summary:
				//		Returns null if this is the last child of the parent,
				//		otherwise returns the next element sibling to the "right".

				return this._getSibling("next"); // dijit._Widget
			},

			getIndexInParent: function(){
				// summary:
				//		Returns the index of this widget within its container parent.
				//		It returns -1 if the parent does not exist, or if the parent
				//		is not a dijit._Container

				var p = this.getParent();
				if(!p || !p.getIndexOfChild){
					return -1; // int
				}
				return p.getIndexOfChild(this); // int
			}
		}
	);


}

if(!dojo._hasResource["dijit.layout._LayoutWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.layout._LayoutWidget"] = true;
dojo.provide("dijit.layout._LayoutWidget");





dojo.declare("dijit.layout._LayoutWidget",
	[dijit._Widget, dijit._Container, dijit._Contained],
	{
		// summary:
		//		Base class for a _Container widget which is responsible for laying out its children.
		//		Widgets which mixin this code must define layout() to manage placement and sizing of the children.

		// baseClass: [protected extension] String
		//		This class name is applied to the widget's domNode
		//		and also may be used to generate names for sub nodes,
		//		for example dijitTabContainer-content.
		baseClass: "dijitLayoutContainer",

		// isLayoutContainer: [protected] Boolean
		//		Indicates that this widget is going to call resize() on its
		//		children widgets, setting their size, when they become visible.
		isLayoutContainer: true,

		postCreate: function(){
			dojo.addClass(this.domNode, "dijitContainer");
			dojo.addClass(this.domNode, this.baseClass);

			this.inherited(arguments);
		},

		startup: function(){
			// summary:
			//		Called after all the widgets have been instantiated and their
			//		dom nodes have been inserted somewhere under dojo.doc.body.
			//
			//		Widgets should override this method to do any initialization
			//		dependent on other widgets existing, and then call
			//		this superclass method to finish things off.
			//
			//		startup() in subclasses shouldn't do anything
			//		size related because the size of the widget hasn't been set yet.

			if(this._started){ return; }

			// Need to call inherited first - so that child widgets get started
			// up correctly
			this.inherited(arguments);

			// If I am a not being controlled by a parent layout widget...
			var parent = this.getParent && this.getParent()
			if(!(parent && parent.isLayoutContainer)){
				// Do recursive sizing and layout of all my descendants
				// (passing in no argument to resize means that it has to glean the size itself)
				this.resize();

				// Since my parent isn't a layout container, and my style *may be* width=height=100%
				// or something similar (either set directly or via a CSS class),
				// monitor when my size changes so that I can re-layout.
				// For browsers where I can't directly monitor when my size changes,
				// monitor when the viewport changes size, which *may* indicate a size change for me.
				this.connect(dojo.isIE ? this.domNode : dojo.global, 'onresize', function(){
					// Using function(){} closure to ensure no arguments to resize.
					this.resize();
				});
			}
		},

		resize: function(changeSize, resultSize){
			// summary:
			//		Call this to resize a widget, or after its size has changed.
			// description:
			//		Change size mode:
			//			When changeSize is specified, changes the marginBox of this widget
			//			and forces it to relayout its contents accordingly.
			//			changeSize may specify height, width, or both.
			//
			//			If resultSize is specified it indicates the size the widget will
			//			become after changeSize has been applied.
			//
			//		Notification mode:
			//			When changeSize is null, indicates that the caller has already changed
			//			the size of the widget, or perhaps it changed because the browser
			//			window was resized.  Tells widget to relayout its contents accordingly.
			//
			//			If resultSize is also specified it indicates the size the widget has
			//			become.
			//
			//		In either mode, this method also:
			//			1. Sets this._borderBox and this._contentBox to the new size of
			//				the widget.  Queries the current domNode size if necessary.
			//			2. Calls layout() to resize contents (and maybe adjust child widgets).
			//
			// changeSize: Object?
			//		Sets the widget to this margin-box size and position.
			//		May include any/all of the following properties:
			//	|	{w: int, h: int, l: int, t: int}
			//
			// resultSize: Object?
			//		The margin-box size of this widget after applying changeSize (if
			//		changeSize is specified).  If caller knows this size and
			//		passes it in, we don't need to query the browser to get the size.
			//	|	{w: int, h: int}

			var node = this.domNode;

			// set margin box size, unless it wasn't specified, in which case use current size
			if(changeSize){
				dojo.marginBox(node, changeSize);

				// set offset of the node
				if(changeSize.t){ node.style.top = changeSize.t + "px"; }
				if(changeSize.l){ node.style.left = changeSize.l + "px"; }
			}

			// If either height or width wasn't specified by the user, then query node for it.
			// But note that setting the margin box and then immediately querying dimensions may return
			// inaccurate results, so try not to depend on it.
			var mb = resultSize || {};
			dojo.mixin(mb, changeSize || {});	// changeSize overrides resultSize
			if( !("h" in mb) || !("w" in mb) ){
				mb = dojo.mixin(dojo.marginBox(node), mb);	// just use dojo.marginBox() to fill in missing values
			}

			// Compute and save the size of my border box and content box
			// (w/out calling dojo.contentBox() since that may fail if size was recently set)
			var cs = dojo.getComputedStyle(node);
			var me = dojo._getMarginExtents(node, cs);
			var be = dojo._getBorderExtents(node, cs);
			var bb = (this._borderBox = {
				w: mb.w - (me.w + be.w),
				h: mb.h - (me.h + be.h)
			});
			var pe = dojo._getPadExtents(node, cs);
			this._contentBox = {
				l: dojo._toPixelValue(node, cs.paddingLeft),
				t: dojo._toPixelValue(node, cs.paddingTop),
				w: bb.w - pe.w,
				h: bb.h - pe.h
			};

			// Callback for widget to adjust size of its children
			this.layout();
		},

		layout: function(){
			// summary:
			//		Widgets override this method to size and position their contents/children.
			//		When this is called this._contentBox is guaranteed to be set (see resize()).
			//
			//		This is called after startup(), and also when the widget's size has been
			//		changed.
			// tags:
			//		protected extension
		},

		_setupChild: function(/*dijit._Widget*/child){
			// summary:
			//		Common setup for initial children and children which are added after startup
			// tags:
			//		protected extension

			dojo.addClass(child.domNode, this.baseClass+"-child");
			if(child.baseClass){
				dojo.addClass(child.domNode, this.baseClass+"-"+child.baseClass);
			}
		},

		addChild: function(/*dijit._Widget*/ child, /*Integer?*/ insertIndex){
			// Overrides _Container.addChild() to call _setupChild()
			this.inherited(arguments);
			if(this._started){
				this._setupChild(child);
			}
		},

		removeChild: function(/*dijit._Widget*/ child){
			// Overrides _Container.removeChild() to remove class added by _setupChild()
			dojo.removeClass(child.domNode, this.baseClass+"-child");
			if(child.baseClass){
				dojo.removeClass(child.domNode, this.baseClass+"-"+child.baseClass);
			}
			this.inherited(arguments);
		}
	}
);

dijit.layout.marginBox2contentBox = function(/*DomNode*/ node, /*Object*/ mb){
	// summary:
	//		Given the margin-box size of a node, return its content box size.
	//		Functions like dojo.contentBox() but is more reliable since it doesn't have
	//		to wait for the browser to compute sizes.
	var cs = dojo.getComputedStyle(node);
	var me = dojo._getMarginExtents(node, cs);
	var pb = dojo._getPadBorderExtents(node, cs);
	return {
		l: dojo._toPixelValue(node, cs.paddingLeft),
		t: dojo._toPixelValue(node, cs.paddingTop),
		w: mb.w - (me.w + pb.w),
		h: mb.h - (me.h + pb.h)
	};
};

(function(){
	var capitalize = function(word){
		return word.substring(0,1).toUpperCase() + word.substring(1);
	};

	var size = function(widget, dim){
		// size the child
		widget.resize ? widget.resize(dim) : dojo.marginBox(widget.domNode, dim);

		// record child's size, but favor our own numbers when we have them.
		// the browser lies sometimes
		dojo.mixin(widget, dojo.marginBox(widget.domNode));
		dojo.mixin(widget, dim);
	};

	dijit.layout.layoutChildren = function(/*DomNode*/ container, /*Object*/ dim, /*Object[]*/ children){
		// summary
		//		Layout a bunch of child dom nodes within a parent dom node
		// container:
		//		parent node
		// dim:
		//		{l, t, w, h} object specifying dimensions of container into which to place children
		// children:
		//		an array like [ {domNode: foo, layoutAlign: "bottom" }, {domNode: bar, layoutAlign: "client"} ]

		// copy dim because we are going to modify it
		dim = dojo.mixin({}, dim);

		dojo.addClass(container, "dijitLayoutContainer");

		// Move "client" elements to the end of the array for layout.  a11y dictates that the author
		// needs to be able to put them in the document in tab-order, but this algorithm requires that
		// client be last.
		children = dojo.filter(children, function(item){ return item.layoutAlign != "client"; })
			.concat(dojo.filter(children, function(item){ return item.layoutAlign == "client"; }));

		// set positions/sizes
		dojo.forEach(children, function(child){
			var elm = child.domNode,
				pos = child.layoutAlign;

			// set elem to upper left corner of unused space; may move it later
			var elmStyle = elm.style;
			elmStyle.left = dim.l+"px";
			elmStyle.top = dim.t+"px";
			elmStyle.bottom = elmStyle.right = "auto";

			dojo.addClass(elm, "dijitAlign" + capitalize(pos));

			// set size && adjust record of remaining space.
			// note that setting the width of a <div> may affect its height.
			if(pos == "top" || pos == "bottom"){
				size(child, { w: dim.w });
				dim.h -= child.h;
				if(pos == "top"){
					dim.t += child.h;
				}else{
					elmStyle.top = dim.t + dim.h + "px";
				}
			}else if(pos == "left" || pos == "right"){
				size(child, { h: dim.h });
				dim.w -= child.w;
				if(pos == "left"){
					dim.l += child.w;
				}else{
					elmStyle.left = dim.l + dim.w + "px";
				}
			}else if(pos == "client"){
				size(child, dim);
			}
		});
	};

})();

}

if(!dojo._hasResource["dijit.form._FormWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form._FormWidget"] = true;
dojo.provide("dijit.form._FormWidget");




dojo.declare("dijit.form._FormWidget", [dijit._Widget, dijit._Templated],
	{
	// summary:
	//		Base class for widgets corresponding to native HTML elements such as <checkbox> or <button>,
	//		which can be children of a <form> node or a `dijit.form.Form` widget.
	//
	// description:
	//		Represents a single HTML element.
	//		All these widgets should have these attributes just like native HTML input elements.
	//		You can set them during widget construction or afterwards, via `dijit._Widget.attr`.
	//
	//		They also share some common methods.

	// baseClass: [protected] String
	//		Root CSS class of the widget (ex: dijitTextBox), used to add CSS classes of widget
	//		(ex: "dijitTextBox dijitTextBoxInvalid dijitTextBoxFocused dijitTextBoxInvalidFocused")
	//		See _setStateClass().
	baseClass: "",

	// name: String
	//		Name used when submitting form; same as "name" attribute or plain HTML elements
	name: "",

	// alt: String
	//		Corresponds to the native HTML <input> element's attribute.
	alt: "",

	// value: String
	//		Corresponds to the native HTML <input> element's attribute.
	value: "",

	// type: String
	//		Corresponds to the native HTML <input> element's attribute.
	type: "text",

	// tabIndex: Integer
	//		Order fields are traversed when user hits the tab key
	tabIndex: "0",

	// disabled: Boolean
	//		Should this widget respond to user input?
	//		In markup, this is specified as "disabled='disabled'", or just "disabled".
	disabled: false,

	// intermediateChanges: Boolean
	//		Fires onChange for each value change or only on demand
	intermediateChanges: false,

	// scrollOnFocus: Boolean
	//		On focus, should this widget scroll into view?
	scrollOnFocus: true,

	// These mixins assume that the focus node is an INPUT, as many but not all _FormWidgets are.
	attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
		value: "focusNode",
		id: "focusNode",
		tabIndex: "focusNode",
		alt: "focusNode",
		title: "focusNode"
	}),

	postMixInProperties: function(){
		// Setup name=foo string to be referenced from the template (but only if a name has been specified)
		// Unfortunately we can't use attributeMap to set the name due to IE limitations, see #8660
		this.nameAttrSetting = this.name ? ("name='" + this.name + "'") : "";
		this.inherited(arguments);
	},

	_setDisabledAttr: function(/*Boolean*/ value){
		this.disabled = value;
		dojo.attr(this.focusNode, 'disabled', value);
		if(this.valueNode){
			dojo.attr(this.valueNode, 'disabled', value);
		}
		dijit.setWaiState(this.focusNode, "disabled", value);

		if(value){
			// reset those, because after the domNode is disabled, we can no longer receive
			// mouse related events, see #4200
			this._hovering = false;
			this._active = false;
			// remove the tabIndex, especially for FF
			this.focusNode.setAttribute('tabIndex', "-1");
		}else{
			this.focusNode.setAttribute('tabIndex', this.tabIndex);
		}
		this._setStateClass();
	},

	setDisabled: function(/*Boolean*/ disabled){
		// summary:
		//		Deprecated.   Use attr('disabled', ...) instead.
		dojo.deprecated("setDisabled("+disabled+") is deprecated. Use attr('disabled',"+disabled+") instead.", "", "2.0");
		this.attr('disabled', disabled);
	},

	_onFocus: function(e){
		if(this.scrollOnFocus){
			dijit.scrollIntoView(this.domNode);
		}
		this.inherited(arguments);
	},

	_onMouse : function(/*Event*/ event){
		// summary:
		//	Sets _hovering, _active, and stateModifier properties depending on mouse state,
		//	then calls setStateClass() to set appropriate CSS classes for this.domNode.
		//
		//	To get a different CSS class for hover, send onmouseover and onmouseout events to this method.
		//	To get a different CSS class while mouse button is depressed, send onmousedown to this method.

		var mouseNode = event.currentTarget;
		if(mouseNode && mouseNode.getAttribute){
			this.stateModifier = mouseNode.getAttribute("stateModifier") || "";
		}

		if(!this.disabled){
			switch(event.type){
				case "mouseenter":
				case "mouseover":
					this._hovering = true;
					this._active = this._mouseDown;
					break;

				case "mouseout":
				case "mouseleave":
					this._hovering = false;
					this._active = false;
					break;

				case "mousedown" :
					this._active = true;
					this._mouseDown = true;
					// set a global event to handle mouseup, so it fires properly
					//	even if the cursor leaves the button
					var mouseUpConnector = this.connect(dojo.body(), "onmouseup", function(){
						// if user clicks on the button, even if the mouse is released outside of it,
						// this button should get focus (which mimics native browser buttons)
						if(this._mouseDown && this.isFocusable()){
							this.focus();
						}
						this._active = false;
						this._mouseDown = false;
						this._setStateClass();
						this.disconnect(mouseUpConnector);
					});
					break;
			}
			this._setStateClass();
		}
	},

	isFocusable: function(){
		// summary:
		//		Tells if this widget is focusable or not.   Used internally by dijit.
		// tags:
		//		protected
		return !this.disabled && !this.readOnly && this.focusNode && (dojo.style(this.domNode, "display") != "none");
	},

	focus: function(){
		// summary:
		//		Put focus on this widget
		dijit.focus(this.focusNode);
	},

	_setStateClass: function(){
		// summary:
		//		Update the visual state of the widget by setting the css classes on this.domNode
		//		(or this.stateNode if defined) by combining this.baseClass with
		//		various suffixes that represent the current widget state(s).
		//
		// description:
		//		In the case where a widget has multiple
		//		states, it sets the class based on all possible
		//	 	combinations.  For example, an invalid form widget that is being hovered
		//		will be "dijitInput dijitInputInvalid dijitInputHover dijitInputInvalidHover".
		//
		//		For complex widgets with multiple regions, there can be various hover/active states,
		//		such as "Hover" or "CloseButtonHover" (for tab buttons).
		//		This is controlled by a stateModifier="CloseButton" attribute on the close button node.
		//
		//		The widget may have one or more of the following states, determined
		//		by this.state, this.checked, this.valid, and this.selected:
		//			- Error - ValidationTextBox sets this.state to "Error" if the current input value is invalid
		//			- Checked - ex: a checkmark or a ToggleButton in a checked state, will have this.checked==true
		//			- Selected - ex: currently selected tab will have this.selected==true
		//
		//		In addition, it may have one or more of the following states,
		//		based on this.disabled and flags set in _onMouse (this._active, this._hovering, this._focused):
		//			- Disabled	- if the widget is disabled
		//			- Active		- if the mouse (or space/enter key?) is being pressed down
		//			- Focused		- if the widget has focus
		//			- Hover		- if the mouse is over the widget

		// Compute new set of classes
		var newStateClasses = this.baseClass.split(" ");

		function multiply(modifier){
			newStateClasses = newStateClasses.concat(dojo.map(newStateClasses, function(c){ return c+modifier; }), "dijit"+modifier);
		}

		if(this.checked){
			multiply("Checked");
		}
		if(this.state){
			multiply(this.state);
		}
		if(this.selected){
			multiply("Selected");
		}

		if(this.disabled){
			multiply("Disabled");
		}else if(this.readOnly){
			multiply("ReadOnly");
		}else if(this._active){
			multiply(this.stateModifier+"Active");
		}else{
			if(this._focused){
				multiply("Focused");
			}
			if(this._hovering){
				multiply(this.stateModifier+"Hover");
			}
		}

		// Remove old state classes and add new ones.
		// For performance concerns we only write into domNode.className once.
		var tn = this.stateNode || this.domNode,
			classHash = {};	// set of all classes (state and otherwise) for node

		dojo.forEach(tn.className.split(" "), function(c){ classHash[c] = true; });

		if("_stateClasses" in this){
			dojo.forEach(this._stateClasses, function(c){ delete classHash[c]; });
		}

		dojo.forEach(newStateClasses, function(c){ classHash[c] = true; });

		var newClasses = [];
		for(var c in classHash){
			newClasses.push(c);
		}
		tn.className = newClasses.join(" ");

		this._stateClasses = newStateClasses;
	},

	compare: function(/*anything*/val1, /*anything*/val2){
		// summary:
		//		Compare 2 values (as returned by attr('value') for this widget).
		// tags:
		//		protected
		if(typeof val1 == "number" && typeof val2 == "number"){
			return (isNaN(val1) && isNaN(val2)) ? 0 : val1 - val2;
		}else if(val1 > val2){
			return 1;
		}else if(val1 < val2){
			return -1;
		}else{
			return 0;
		}
	},

	onChange: function(newValue){
		// summary:
		//		Callback when this widget's value is changed.
		// tags:
		//		callback
	},

	// _onChangeActive: [private] Boolean
	//		Indicates that changes to the value should call onChange() callback.
	//		This is false during widget initialization, to avoid calling onChange()
	//		when the initial value is set.
	_onChangeActive: false,

	_handleOnChange: function(/*anything*/ newValue, /* Boolean? */ priorityChange){
		// summary:
		//		Called when the value of the widget is set.  Calls onChange() if appropriate
		// newValue:
		//		the new value
		// priorityChange:
		//		For a slider, for example, dragging the slider is priorityChange==false,
		//		but on mouse up, it's priorityChange==true.  If intermediateChanges==true,
		//		onChange is only called form priorityChange=true events.
		// tags:
		//		private
		this._lastValue = newValue;
		if(this._lastValueReported == undefined && (priorityChange === null || !this._onChangeActive)){
			// this block executes not for a change, but during initialization,
			// and is used to store away the original value (or for ToggleButton, the original checked state)
			this._resetValue = this._lastValueReported = newValue;
		}
		if((this.intermediateChanges || priorityChange || priorityChange === undefined) &&
			((typeof newValue != typeof this._lastValueReported) ||
				this.compare(newValue, this._lastValueReported) != 0)){
			this._lastValueReported = newValue;
			if(this._onChangeActive){
				if(this._onChangeHandle){
					clearTimeout(this._onChangeHandle);
				}
				// setTimout allows hidden value processing to run and
				// also the onChange handler can safely adjust focus, etc
				this._onChangeHandle = setTimeout(dojo.hitch(this,
					function(){
						this._onChangeHandle = null;
						this.onChange(newValue);
					}), 0); // try to collapse multiple onChange's fired faster than can be processed
			}
		}
	},

	create: function(){
		// Overrides _Widget.create()
		this.inherited(arguments);
		this._onChangeActive = true;
		this._setStateClass();
	},

	destroy: function(){
		if(this._onChangeHandle){ // destroy called before last onChange has fired
			clearTimeout(this._onChangeHandle);
			this.onChange(this._lastValueReported);
		}
		this.inherited(arguments);
	},

	setValue: function(/*String*/ value){
		// summary:
		//		Deprecated.   Use attr('value', ...) instead.
		dojo.deprecated("dijit.form._FormWidget:setValue("+value+") is deprecated.  Use attr('value',"+value+") instead.", "", "2.0");
		this.attr('value', value);
	},

	getValue: function(){
		// summary:
		//		Deprecated.   Use attr('value') instead.
		dojo.deprecated(this.declaredClass+"::getValue() is deprecated. Use attr('value') instead.", "", "2.0");
		return this.attr('value');
	}
});

dojo.declare("dijit.form._FormValueWidget", dijit.form._FormWidget,
{
	// summary:
	//		Base class for widgets corresponding to native HTML elements such as <input> or <select> that have user changeable values.
	// description:
	//		Each _FormValueWidget represents a single input value, and has a (possibly hidden) <input> element,
	//		to which it serializes it's input value, so that form submission (either normal submission or via FormBind?)
	//		works as expected.

	// Don't attempt to mixin the 'type', 'name' attributes here programatically -- they must be declared
	// directly in the template as read by the parser in order to function. IE is known to specifically
	// require the 'name' attribute at element creation time.   See #8484, #8660.
	// TODO: unclear what that {value: ""} is for; FormWidget.attributeMap copies value to focusNode,
	// so maybe {value: ""} is so the value *doesn't* get copied to focusNode?
	// Seems like we really want value removed from attributeMap altogether
	// (although there's no easy way to do that now)

	// readOnly: Boolean
	//		Should this widget respond to user input?
	//		In markup, this is specified as "readOnly".
	//		Similar to disabled except readOnly form values are submitted.
	readOnly: false,

	attributeMap: dojo.delegate(dijit.form._FormWidget.prototype.attributeMap, {
		value: "",
		readOnly: "focusNode"
	}),

	_setReadOnlyAttr: function(/*Boolean*/ value){
		this.readOnly = value;
		dojo.attr(this.focusNode, 'readOnly', value);
		dijit.setWaiState(this.focusNode, "readonly", value);
		this._setStateClass();
	},

	postCreate: function(){
		if(dojo.isIE){ // IE won't stop the event with keypress
			this.connect(this.focusNode || this.domNode, "onkeydown", this._onKeyDown);
		}
		// Update our reset value if it hasn't yet been set (because this.attr
		// is only called when there *is* a value
		if(this._resetValue === undefined){
			this._resetValue = this.value;
		}
	},

	_setValueAttr: function(/*anything*/ newValue, /*Boolean, optional*/ priorityChange){
		// summary:
		//		Hook so attr('value', value) works.
		// description:
		//		Sets the value of the widget.
		//		If the value has changed, then fire onChange event, unless priorityChange
		//		is specified as null (or false?)
		this.value = newValue;
		this._handleOnChange(newValue, priorityChange);
	},

	_getValueAttr: function(){
		// summary:
		//		Hook so attr('value') works.
		return this._lastValue;
	},

	undo: function(){
		// summary:
		//		Restore the value to the last value passed to onChange
		this._setValueAttr(this._lastValueReported, false);
	},

	reset: function(){
		// summary:
		//		Reset the widget's value to what it was at initialization time
		this._hasBeenBlurred = false;
		this._setValueAttr(this._resetValue, true);
	},

	_onKeyDown: function(e){
		if(e.keyCode == dojo.keys.ESCAPE && !(e.ctrlKey || e.altKey || e.metaKey)){
			var te;
			if(dojo.isIE){
				e.preventDefault(); // default behavior needs to be stopped here since keypress is too late
				te = document.createEventObject();
				te.keyCode = dojo.keys.ESCAPE;
				te.shiftKey = e.shiftKey;
				e.srcElement.fireEvent('onkeypress', te);
			}
		}
	},

	_layoutHackIE7: function(){
		// summary:
		//		Work around table sizing bugs on IE7 by forcing redraw

		if(dojo.isIE == 7){ // fix IE7 layout bug when the widget is scrolled out of sight
			var domNode = this.domNode;
			var parent = domNode.parentNode;
			var pingNode = domNode.firstChild || domNode; // target node most unlikely to have a custom filter
			var origFilter = pingNode.style.filter; // save custom filter, most likely nothing
			while(parent && parent.clientHeight == 0){ // search for parents that haven't rendered yet
				parent._disconnectHandle = this.connect(parent, "onscroll", dojo.hitch(this, function(e){
					this.disconnect(parent._disconnectHandle); // only call once
					parent.removeAttribute("_disconnectHandle"); // clean up DOM node
					pingNode.style.filter = (new Date()).getMilliseconds(); // set to anything that's unique
					setTimeout(function(){ pingNode.style.filter = origFilter }, 0); // restore custom filter, if any
				}));
				parent = parent.parentNode;
			}
		}
	}
});

}

if(!dojo._hasResource["dijit.form._FormMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.form._FormMixin"] = true;
dojo.provide("dijit.form._FormMixin");

dojo.declare("dijit.form._FormMixin", null,
	{
	// summary:
	//		Mixin for containers of form widgets (i.e. widgets that represent a single value
	//		and can be children of a <form> node or dijit.form.Form widget)
	// description:
	//		Can extract all the form widgets
	//		values and combine them into a single javascript object, or alternately
	//		take such an object and set the values for all the contained
	//		form widgets

/*=====
    // value: Object
	//		Name/value hash for each form element.
	//		If there are multiple elements w/the same name, value is an array,
	//		unless they are radio buttons in which case value is a scalar since only
	//		one can be checked at a time.
	//
	//		If the name is a dot separated list (like a.b.c.d), it's a nested structure.
	//		Only works on widget form elements.
	// example:
	//	| { name: "John Smith", interests: ["sports", "movies"] }
=====*/

	//	TODO:
	//	* Repeater
	//	* better handling for arrays.  Often form elements have names with [] like
	//	* people[3].sex (for a list of people [{name: Bill, sex: M}, ...])
	//
	//

		reset: function(){
			dojo.forEach(this.getDescendants(), function(widget){
				if(widget.reset){
					widget.reset();
				}
			});
		},

		validate: function(){
			// summary:
			//		returns if the form is valid - same as isValid - but
			//			provides a few additional (ui-specific) features.
			//			1 - it will highlight any sub-widgets that are not
			//				valid
			//			2 - it will call focus() on the first invalid
			//				sub-widget
			var didFocus = false;
			return dojo.every(dojo.map(this.getDescendants(), function(widget){
				// Need to set this so that "required" widgets get their
				// state set.
				widget._hasBeenBlurred = true;
				var valid = widget.disabled || !widget.validate || widget.validate();
				if(!valid && !didFocus){
					// Set focus of the first non-valid widget
					dijit.scrollIntoView(widget.containerNode || widget.domNode);
					widget.focus();
					didFocus = true;
				}
	 			return valid;
	 		}), function(item){ return item; });
		},

		setValues: function(val){
			dojo.deprecated(this.declaredClass+"::setValues() is deprecated. Use attr('value', val) instead.", "", "2.0");
			return this.attr('value', val);
		},
		_setValueAttr: function(/*object*/obj){
			// summary:
			//		Fill in form values from according to an Object (in the format returned by attr('value'))

			// generate map from name --> [list of widgets with that name]
			var map = { };
			dojo.forEach(this.getDescendants(), function(widget){
				if(!widget.name){ return; }
				var entry = map[widget.name] || (map[widget.name] = [] );
				entry.push(widget);
			});

			for(var name in map){
				if(!map.hasOwnProperty(name)){
					continue;
				}
				var widgets = map[name],						// array of widgets w/this name
					values = dojo.getObject(name, false, obj);	// list of values for those widgets

				if(values === undefined){
					continue;
				}
				if(!dojo.isArray(values)){
					values = [ values ];
				}
				if(typeof widgets[0].checked == 'boolean'){
					// for checkbox/radio, values is a list of which widgets should be checked
					dojo.forEach(widgets, function(w, i){
						w.attr('value', dojo.indexOf(values, w.value) != -1);
					});
				}else if(widgets[0].multiple){
					// it takes an array (e.g. multi-select)
					widgets[0].attr('value', values);
				}else{
					// otherwise, values is a list of values to be assigned sequentially to each widget
					dojo.forEach(widgets, function(w, i){
						w.attr('value', values[i]);
					});
				}
			}

			/***
			 * 	TODO: code for plain input boxes (this shouldn't run for inputs that are part of widgets)

			dojo.forEach(this.containerNode.elements, function(element){
				if(element.name == ''){return};	// like "continue"
				var namePath = element.name.split(".");
				var myObj=obj;
				var name=namePath[namePath.length-1];
				for(var j=1,len2=namePath.length;j<len2;++j){
					var p=namePath[j - 1];
					// repeater support block
					var nameA=p.split("[");
					if(nameA.length > 1){
						if(typeof(myObj[nameA[0]]) == "undefined"){
							myObj[nameA[0]]=[ ];
						} // if

						nameIndex=parseInt(nameA[1]);
						if(typeof(myObj[nameA[0]][nameIndex]) == "undefined"){
							myObj[nameA[0]][nameIndex] = { };
						}
						myObj=myObj[nameA[0]][nameIndex];
						continue;
					} // repeater support ends

					if(typeof(myObj[p]) == "undefined"){
						myObj=undefined;
						break;
					};
					myObj=myObj[p];
				}

				if(typeof(myObj) == "undefined"){
					return;		// like "continue"
				}
				if(typeof(myObj[name]) == "undefined" && this.ignoreNullValues){
					return;		// like "continue"
				}

				// TODO: widget values (just call attr('value', ...) on the widget)

				// TODO: maybe should call dojo.getNodeProp() instead
				switch(element.type){
					case "checkbox":
						element.checked = (name in myObj) &&
							dojo.some(myObj[name], function(val){ return val == element.value; });
						break;
					case "radio":
						element.checked = (name in myObj) && myObj[name] == element.value;
						break;
					case "select-multiple":
						element.selectedIndex=-1;
						dojo.forEach(element.options, function(option){
							option.selected = dojo.some(myObj[name], function(val){ return option.value == val; });
						});
						break;
					case "select-one":
						element.selectedIndex="0";
						dojo.forEach(element.options, function(option){
							option.selected = option.value == myObj[name];
						});
						break;
					case "hidden":
					case "text":
					case "textarea":
					case "password":
						element.value = myObj[name] || "";
						break;
				}
	  		});
	  		*/
		},

		getValues: function(){
			dojo.deprecated(this.declaredClass+"::getValues() is deprecated. Use attr('value') instead.", "", "2.0");
			return this.attr('value');
		},
		_getValueAttr: function(){
			// summary:
			// 		Returns Object representing form values.
			// description:
			//		Returns name/value hash for each form element.
			//		If there are multiple elements w/the same name, value is an array,
			//		unless they are radio buttons in which case value is a scalar since only
			//		one can be checked at a time.
			//
			//		If the name is a dot separated list (like a.b.c.d), creates a nested structure.
			//		Only works on widget form elements.
			// example:
			//		| { name: "John Smith", interests: ["sports", "movies"] }

			// get widget values
			var obj = { };
			dojo.forEach(this.getDescendants(), function(widget){
				var name = widget.name;
				if(!name || widget.disabled){ return; }

				// Single value widget (checkbox, radio, or plain <input> type widget
				var value = widget.attr('value');

				// Store widget's value(s) as a scalar, except for checkboxes which are automatically arrays
				if(typeof widget.checked == 'boolean'){
					if(/Radio/.test(widget.declaredClass)){
						// radio button
						if(value !== false){
							dojo.setObject(name, value, obj);
						}else{
							// give radio widgets a default of null
							value = dojo.getObject(name, false, obj);
							if(value === undefined){
								dojo.setObject(name, null, obj);
							}
						}
					}else{
						// checkbox/toggle button
						var ary=dojo.getObject(name, false, obj);
						if(!ary){
							ary=[];
							dojo.setObject(name, ary, obj);
						}
						if(value !== false){
							ary.push(value);
						}
					}
				}else{
					var prev=dojo.getObject(name, false, obj);
					if(typeof prev != "undefined"){
						if(dojo.isArray(prev)){
							prev.push(value);
						}else{
							dojo.setObject(name, [prev, value], obj);
						}
					}else{
						// unique name
						dojo.setObject(name, value, obj);
					}
				}
			});

			/***
			 * code for plain input boxes (see also dojo.formToObject, can we use that instead of this code?
			 * but it doesn't understand [] notation, presumably)
			var obj = { };
			dojo.forEach(this.containerNode.elements, function(elm){
				if(!elm.name)	{
					return;		// like "continue"
				}
				var namePath = elm.name.split(".");
				var myObj=obj;
				var name=namePath[namePath.length-1];
				for(var j=1,len2=namePath.length;j<len2;++j){
					var nameIndex = null;
					var p=namePath[j - 1];
					var nameA=p.split("[");
					if(nameA.length > 1){
						if(typeof(myObj[nameA[0]]) == "undefined"){
							myObj[nameA[0]]=[ ];
						} // if
						nameIndex=parseInt(nameA[1]);
						if(typeof(myObj[nameA[0]][nameIndex]) == "undefined"){
							myObj[nameA[0]][nameIndex] = { };
						}
					} else if(typeof(myObj[nameA[0]]) == "undefined"){
						myObj[nameA[0]] = { }
					} // if

					if(nameA.length == 1){
						myObj=myObj[nameA[0]];
					} else{
						myObj=myObj[nameA[0]][nameIndex];
					} // if
				} // for

				if((elm.type != "select-multiple" && elm.type != "checkbox" && elm.type != "radio") || (elm.type == "radio" && elm.checked)){
					if(name == name.split("[")[0]){
						myObj[name]=elm.value;
					} else{
						// can not set value when there is no name
					}
				} else if(elm.type == "checkbox" && elm.checked){
					if(typeof(myObj[name]) == 'undefined'){
						myObj[name]=[ ];
					}
					myObj[name].push(elm.value);
				} else if(elm.type == "select-multiple"){
					if(typeof(myObj[name]) == 'undefined'){
						myObj[name]=[ ];
					}
					for(var jdx=0,len3=elm.options.length; jdx<len3; ++jdx){
						if(elm.options[jdx].selected){
							myObj[name].push(elm.options[jdx].value);
						}
					}
				} // if
				name=undefined;
			}); // forEach
			***/
			return obj;
		},

		// TODO: ComboBox might need time to process a recently input value.  This should be async?
	 	isValid: function(){
	 		// summary:
	 		//		Returns true if all of the widgets are valid

	 		// This also populate this._invalidWidgets[] array with list of invalid widgets...
	 		// TODO: put that into separate function?   It's confusing to have that as a side effect
	 		// of a method named isValid().

			this._invalidWidgets = dojo.filter(this.getDescendants(), function(widget){
				return !widget.disabled && widget.isValid && !widget.isValid();
	 		});
			return !this._invalidWidgets.length;
		},


		onValidStateChange: function(isValid){
			// summary:
			//		Stub function to connect to if you want to do something
			//		(like disable/enable a submit button) when the valid
			//		state changes on the form as a whole.
		},

		_widgetChange: function(widget){
			// summary:
			//		Connected to a widget's onChange function - update our
			//		valid state, if needed.
			var isValid = this._lastValidState;
			if(!widget || this._lastValidState === undefined){
				// We have passed a null widget, or we haven't been validated
				// yet - let's re-check all our children
				// This happens when we connect (or reconnect) our children
				isValid = this.isValid();
				if(this._lastValidState === undefined){
					// Set this so that we don't fire an onValidStateChange
					// the first time
					this._lastValidState = isValid;
				}
			}else if(widget.isValid){
				this._invalidWidgets = dojo.filter(this._invalidWidgets || [], function(w){
					return (w != widget);
				}, this);
				if(!widget.isValid() && !widget.attr("disabled")){
					this._invalidWidgets.push(widget);
				}
				isValid = (this._invalidWidgets.length === 0);
			}
			if(isValid !== this._lastValidState){
				this._lastValidState = isValid;
				this.onValidStateChange(isValid);
			}
		},

		connectChildren: function(){
			// summary:
			//		Connects to the onChange function of all children to
			//		track valid state changes.  You can call this function
			//		directly, ex. in the event that you programmatically
			//		add a widget to the form *after* the form has been
			//		initialized.
			dojo.forEach(this._changeConnections, dojo.hitch(this, "disconnect"));
			var _this = this;

			// we connect to validate - so that it better reflects the states
			// of the widgets - also, we only connect if it has a validate
			// function (to avoid too many unneeded connections)
			var conns = this._changeConnections = [];
			dojo.forEach(dojo.filter(this.getDescendants(),
				function(item){ return item.validate; }
			),
			function(widget){
				// We are interested in whenever the widget is validated - or
				// whenever the disabled attribute on that widget is changed
				conns.push(_this.connect(widget, "validate",
									dojo.hitch(_this, "_widgetChange", widget)));
				conns.push(_this.connect(widget, "_setDisabledAttr",
									dojo.hitch(_this, "_widgetChange", widget)));
			});

			// Call the widget change function to update the valid state, in
			// case something is different now.
			this._widgetChange(null);
		},

		startup: function(){
			this.inherited(arguments);
			// Initialize our valid state tracking.  Needs to be done in startup
			// because it's not guaranteed that our children are initialized
			// yet.
			this._changeConnections = [];
			this.connectChildren();
		}
	});

}

if(!dojo._hasResource["dijit._DialogMixin"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit._DialogMixin"] = true;
dojo.provide("dijit._DialogMixin");

dojo.declare("dijit._DialogMixin", null,
	{
		// summary:
		//		This provides functions useful to Dialog and TooltipDialog

		attributeMap: dijit._Widget.prototype.attributeMap,

		execute: function(/*Object*/ formContents){
			// summary:
			//		Callback when the user hits the submit button.
			//		Override this method to handle Dialog execution.
			// description:
			//		After the user has pressed the submit button, the Dialog
			//		first calls onExecute() to notify the container to hide the
			//		dialog and restore focus to wherever it used to be.
			//
			//		*Then* this method is called.
			// type:
			//		callback
		},

		onCancel: function(){
			// summary:
			//	    Called when user has pressed the Dialog's cancel button, to notify container.
			// description:
			//	    Developer shouldn't override or connect to this method;
			//		it's a private communication device between the TooltipDialog
			//		and the thing that opened it (ex: `dijit.form.DropDownButton`)
			// type:
			//		protected
		},

		onExecute: function(){
			// summary:
			//	    Called when user has pressed the dialog's OK button, to notify container.
			// description:
			//	    Developer shouldn't override or connect to this method;
			//		it's a private communication device between the TooltipDialog
			//		and the thing that opened it (ex: `dijit.form.DropDownButton`)
			// type:
			//		protected
		},

		_onSubmit: function(){
			// summary:
			//		Callback when user hits submit button
			// type:
			//		protected
			this.onExecute();	// notify container that we are about to execute
			this.execute(this.attr('value'));
		},

		_getFocusItems: function(/*Node*/ dialogNode){
			// summary:
			//		Find focusable Items each time a dialog is opened,
			//		setting _firstFocusItem and _lastFocusItem
			// tags:
			//		protected

			var elems = dijit._getTabNavigable(dojo.byId(dialogNode));
			this._firstFocusItem = elems.lowest || elems.first || dialogNode;
			this._lastFocusItem = elems.last || elems.highest || this._firstFocusItem;
			if(dojo.isMoz && this._firstFocusItem.tagName.toLowerCase() == "input" &&
					dojo.getNodeProp(this._firstFocusItem, "type").toLowerCase() == "file"){
				// FF doesn't behave well when first element is input type=file, set first focusable to dialog container
				dojo.attr(dialogNode, "tabIndex", "0");
				this._firstFocusItem = dialogNode;
			}
		}
	}
);

}

if(!dojo._hasResource["dijit.DialogUnderlay"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.DialogUnderlay"] = true;
dojo.provide("dijit.DialogUnderlay");




dojo.declare(
	"dijit.DialogUnderlay",
	[dijit._Widget, dijit._Templated],
	{
		// summary:
		//		The component that blocks the screen behind a `dijit.Dialog`
		//
		// description:
		// 		A component used to block input behind a `dijit.Dialog`. Only a single
		//		instance of this widget is created by `dijit.Dialog`, and saved as
		//		a reference to be shared between all Dialogs as `dijit._underlay`
		//
		//		The underlay itself can be styled based on and id:
		//	|	#myDialog_underlay { background-color:red; }
		//
		//		In the case of `dijit.Dialog`, this id is based on the id of the Dialog,
		//		suffixed with _underlay.

		// Template has two divs; outer div is used for fade-in/fade-out, and also to hold background iframe.
		// Inner div has opacity specified in CSS file.
		templateString: "<div class='dijitDialogUnderlayWrapper'><div class='dijitDialogUnderlay' dojoAttachPoint='node'></div></div>",

		// Parameters on creation or updatable later

		// dialogId: String
		//		Id of the dialog.... DialogUnderlay's id is based on this id
		dialogId: "",

		// class: String
		//		This class name is used on the DialogUnderlay node, in addition to dijitDialogUnderlay
		"class": "",

		attributeMap: { id: "domNode" },

		_setDialogIdAttr: function(id){
			dojo.attr(this.node, "id", id + "_underlay");
		},

		_setClassAttr: function(clazz){
			this.node.className = "dijitDialogUnderlay " + clazz;
		},

		postCreate: function(){
			// summary:
			//		Append the underlay to the body
			dojo.body().appendChild(this.domNode);
		},

		layout: function(){
			// summary:
			//		Sets the background to the size of the viewport
			//
			// description:
			//		Sets the background to the size of the viewport (rather than the size
			//		of the document) since we need to cover the whole browser window, even
			//		if the document is only a few lines long.
			// tags:
			//		private

			var is = this.node.style,
				os = this.domNode.style;

			// hide the background temporarily, so that the background itself isn't
			// causing scrollbars to appear (might happen when user shrinks browser
			// window and then we are called to resize)
			os.display = "none";

			// then resize and show
			var viewport = dijit.getViewport();
			os.top = viewport.t + "px";
			os.left = viewport.l + "px";
			is.width = viewport.w + "px";
			is.height = viewport.h + "px";
			os.display = "block";
		},

		show: function(){
			// summary:
			//		Show the dialog underlay
			this.domNode.style.display = "block";
			this.layout();
			this.bgIframe = new dijit.BackgroundIframe(this.domNode);
		},

		hide: function(){
			// summary:
			//		Hides the dialog underlay
			this.bgIframe.destroy();
			this.domNode.style.display = "none";
		},

		uninitialize: function(){
			if(this.bgIframe){
				this.bgIframe.destroy();
			}
			this.inherited(arguments);
		}
	}
);

}

if(!dojo._hasResource["dijit.dijit"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.dijit"] = true;
dojo.provide("dijit.dijit");

/*=====
dijit.dijit = {
	// summary:
	//		A roll-up for common dijit methods
	// description:
	//	A rollup file for the build system including the core and common
	//	dijit files.
	//
	// example:
	// | <script type="text/javascript" src="js/dojo/dijit/dijit.js"></script>
	//
};
=====*/

// All the stuff in _base (these are the function that are guaranteed available without an explicit dojo.require)


// And some other stuff that we tend to pull in all the time anyway







}

if(!dojo._hasResource["dojo.fx.Toggler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.fx.Toggler"] = true;
dojo.provide("dojo.fx.Toggler");

dojo.declare("dojo.fx.Toggler", null, {
	// summary:
	//		A simple `dojo.Animation` toggler API.
	//
	// description:
	//		class constructor for an animation toggler. It accepts a packed
	//		set of arguments about what type of animation to use in each
	//		direction, duration, etc. All available members are mixed into 
	//		these animations from the constructor (for example, `node`, 
	//		`showDuration`, `hideDuration`). 
	//
	// example:
	//	|	var t = new dojo.fx.Toggler({
	//	|		node: "nodeId",
	//	|		showDuration: 500,
	//	|		// hideDuration will default to "200"
	//	|		showFunc: dojo.fx.wipeIn, 
	//	|		// hideFunc will default to "fadeOut"
	//	|	});
	//	|	t.show(100); // delay showing for 100ms
	//	|	// ...time passes...
	//	|	t.hide();

	// node: DomNode
	//		the node to target for the showing and hiding animations
	node: null,

	// showFunc: Function
	//		The function that returns the `dojo.Animation` to show the node
	showFunc: dojo.fadeIn,

	// hideFunc: Function	
	//		The function that returns the `dojo.Animation` to hide the node
	hideFunc: dojo.fadeOut,

	// showDuration:
	//		Time in milliseconds to run the show Animation
	showDuration: 200,

	// hideDuration:
	//		Time in milliseconds to run the hide Animation
	hideDuration: 200,

	// FIXME: need a policy for where the toggler should "be" the next
	// time show/hide are called if we're stopped somewhere in the
	// middle.
	// FIXME: also would be nice to specify individual showArgs/hideArgs mixed into
	// each animation individually. 
	// FIXME: also would be nice to have events from the animations exposed/bridged

	/*=====
	_showArgs: null,
	_showAnim: null,

	_hideArgs: null,
	_hideAnim: null,

	_isShowing: false,
	_isHiding: false,
	=====*/

	constructor: function(args){
		var _t = this;

		dojo.mixin(_t, args);
		_t.node = args.node;
		_t._showArgs = dojo.mixin({}, args);
		_t._showArgs.node = _t.node;
		_t._showArgs.duration = _t.showDuration;
		_t.showAnim = _t.showFunc(_t._showArgs);

		_t._hideArgs = dojo.mixin({}, args);
		_t._hideArgs.node = _t.node;
		_t._hideArgs.duration = _t.hideDuration;
		_t.hideAnim = _t.hideFunc(_t._hideArgs);

		dojo.connect(_t.showAnim, "beforeBegin", dojo.hitch(_t.hideAnim, "stop", true));
		dojo.connect(_t.hideAnim, "beforeBegin", dojo.hitch(_t.showAnim, "stop", true));
	},

	show: function(delay){
		// summary: Toggle the node to showing
		// delay: Integer?
		//		Ammount of time to stall playing the show animation
		return this.showAnim.play(delay || 0);
	},

	hide: function(delay){
		// summary: Toggle the node to hidden
		// delay: Integer?
		//		Ammount of time to stall playing the hide animation
		return this.hideAnim.play(delay || 0);
	}
});

}

if(!dojo._hasResource["dojo.fx"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.fx"] = true;
dojo.provide("dojo.fx");
 // FIXME: remove this back-compat require in 2.0 
/*=====
dojo.fx = {
	// summary: Effects library on top of Base animations
};
=====*/
(function(){
	
	var d = dojo, 
		_baseObj = {
			_fire: function(evt, args){
				if(this[evt]){
					this[evt].apply(this, args||[]);
				}
				return this;
			}
		};

	var _chain = function(animations){
		this._index = -1;
		this._animations = animations||[];
		this._current = this._onAnimateCtx = this._onEndCtx = null;

		this.duration = 0;
		d.forEach(this._animations, function(a){
			this.duration += a.duration;
			if(a.delay){ this.duration += a.delay; }
		}, this);
	};
	d.extend(_chain, {
		_onAnimate: function(){
			this._fire("onAnimate", arguments);
		},
		_onEnd: function(){
			d.disconnect(this._onAnimateCtx);
			d.disconnect(this._onEndCtx);
			this._onAnimateCtx = this._onEndCtx = null;
			if(this._index + 1 == this._animations.length){
				this._fire("onEnd");
			}else{
				// switch animations
				this._current = this._animations[++this._index];
				this._onAnimateCtx = d.connect(this._current, "onAnimate", this, "_onAnimate");
				this._onEndCtx = d.connect(this._current, "onEnd", this, "_onEnd");
				this._current.play(0, true);
			}
		},
		play: function(/*int?*/ delay, /*Boolean?*/ gotoStart){
			if(!this._current){ this._current = this._animations[this._index = 0]; }
			if(!gotoStart && this._current.status() == "playing"){ return this; }
			var beforeBegin = d.connect(this._current, "beforeBegin", this, function(){
					this._fire("beforeBegin");
				}),
				onBegin = d.connect(this._current, "onBegin", this, function(arg){
					this._fire("onBegin", arguments);
				}),
				onPlay = d.connect(this._current, "onPlay", this, function(arg){
					this._fire("onPlay", arguments);
					d.disconnect(beforeBegin);
					d.disconnect(onBegin);
					d.disconnect(onPlay);
				});
			if(this._onAnimateCtx){
				d.disconnect(this._onAnimateCtx);
			}
			this._onAnimateCtx = d.connect(this._current, "onAnimate", this, "_onAnimate");
			if(this._onEndCtx){
				d.disconnect(this._onEndCtx);
			}
			this._onEndCtx = d.connect(this._current, "onEnd", this, "_onEnd");
			this._current.play.apply(this._current, arguments);
			return this;
		},
		pause: function(){
			if(this._current){
				var e = d.connect(this._current, "onPause", this, function(arg){
						this._fire("onPause", arguments);
						d.disconnect(e);
					});
				this._current.pause();
			}
			return this;
		},
		gotoPercent: function(/*Decimal*/percent, /*Boolean?*/ andPlay){
			this.pause();
			var offset = this.duration * percent;
			this._current = null;
			d.some(this._animations, function(a){
				if(a.duration <= offset){
					this._current = a;
					return true;
				}
				offset -= a.duration;
				return false;
			});
			if(this._current){
				this._current.gotoPercent(offset / this._current.duration, andPlay);
			}
			return this;
		},
		stop: function(/*boolean?*/ gotoEnd){
			if(this._current){
				if(gotoEnd){
					for(; this._index + 1 < this._animations.length; ++this._index){
						this._animations[this._index].stop(true);
					}
					this._current = this._animations[this._index];
				}
				var e = d.connect(this._current, "onStop", this, function(arg){
						this._fire("onStop", arguments);
						d.disconnect(e);
					});
				this._current.stop();
			}
			return this;
		},
		status: function(){
			return this._current ? this._current.status() : "stopped";
		},
		destroy: function(){
			if(this._onAnimateCtx){ d.disconnect(this._onAnimateCtx); }
			if(this._onEndCtx){ d.disconnect(this._onEndCtx); }
		}
	});
	d.extend(_chain, _baseObj);

	dojo.fx.chain = function(/*dojo.Animation[]*/ animations){
		// summary: 
		//		Chain a list of `dojo.Animation`s to run in sequence
		//
		// description:
		//		Return a `dojo.Animation` which will play all passed
		//		`dojo.Animation` instances in sequence, firing its own
		//		synthesized events simulating a single animation. (eg:
		//		onEnd of this animation means the end of the chain, 
		//		not the individual animations within)
		//
		// example:
		//	Once `node` is faded out, fade in `otherNode`
		//	|	dojo.fx.chain([
		//	|		dojo.fadeIn({ node:node }),
		//	|		dojo.fadeOut({ node:otherNode })
		//	|	]).play();
		//
		return new _chain(animations) // dojo.Animation
	};

	var _combine = function(animations){
		this._animations = animations||[];
		this._connects = [];
		this._finished = 0;

		this.duration = 0;
		d.forEach(animations, function(a){
			var duration = a.duration;
			if(a.delay){ duration += a.delay; }
			if(this.duration < duration){ this.duration = duration; }
			this._connects.push(d.connect(a, "onEnd", this, "_onEnd"));
		}, this);
		
		this._pseudoAnimation = new d.Animation({curve: [0, 1], duration: this.duration});
		var self = this;
		d.forEach(["beforeBegin", "onBegin", "onPlay", "onAnimate", "onPause", "onStop", "onEnd"], 
			function(evt){
				self._connects.push(d.connect(self._pseudoAnimation, evt,
					function(){ self._fire(evt, arguments); }
				));
			}
		);
	};
	d.extend(_combine, {
		_doAction: function(action, args){
			d.forEach(this._animations, function(a){
				a[action].apply(a, args);
			});
			return this;
		},
		_onEnd: function(){
			if(++this._finished > this._animations.length){
				this._fire("onEnd");
			}
		},
		_call: function(action, args){
			var t = this._pseudoAnimation;
			t[action].apply(t, args);
		},
		play: function(/*int?*/ delay, /*Boolean?*/ gotoStart){
			this._finished = 0;
			this._doAction("play", arguments);
			this._call("play", arguments);
			return this;
		},
		pause: function(){
			this._doAction("pause", arguments);
			this._call("pause", arguments);
			return this;
		},
		gotoPercent: function(/*Decimal*/percent, /*Boolean?*/ andPlay){
			var ms = this.duration * percent;
			d.forEach(this._animations, function(a){
				a.gotoPercent(a.duration < ms ? 1 : (ms / a.duration), andPlay);
			});
			this._call("gotoPercent", arguments);
			return this;
		},
		stop: function(/*boolean?*/ gotoEnd){
			this._doAction("stop", arguments);
			this._call("stop", arguments);
			return this;
		},
		status: function(){
			return this._pseudoAnimation.status();
		},
		destroy: function(){
			d.forEach(this._connects, dojo.disconnect);
		}
	});
	d.extend(_combine, _baseObj);

	dojo.fx.combine = function(/*dojo.Animation[]*/ animations){
		// summary: 
		//		Combine a list of `dojo.Animation`s to run in parallel
		//
		// description:
		//		Combine an array of `dojo.Animation`s to run in parallel, 
		//		providing a new `dojo.Animation` instance encompasing each
		//		animation, firing standard animation events.
		//
		// example:
		//	Fade out `node` while fading in `otherNode` simultaneously
		//	|	dojo.fx.combine([
		//	|		dojo.fadeIn({ node:node }),
		//	|		dojo.fadeOut({ node:otherNode })
		//	|	]).play();
		//
		// example:
		//	When the longest animation ends, execute a function:
		//	|	var anim = dojo.fx.combine([
		//	|		dojo.fadeIn({ node: n, duration:700 }),
		//	|		dojo.fadeOut({ node: otherNode, duration: 300 })
		//	|	]);
		//	|	dojo.connect(anim, "onEnd", function(){
		//	|		// overall animation is done.
		//	|	});
		//	|	anim.play(); // play the animation
		//
		return new _combine(animations); // dojo.Animation
	};

	dojo.fx.wipeIn = function(/*Object*/ args){
		// summary:
		//		Expand a node to it's natural height.
		//
		// description:
		//		Returns an animation that will expand the
		//		node defined in 'args' object from it's current height to
		//		it's natural height (with no scrollbar).
		//		Node must have no margin/border/padding.
		//
		// args: Object
		//		A hash-map of standard `dojo.Animation` constructor properties
		//		(such as easing: node: duration: and so on)
		//
		// example:
		//	|	dojo.fx.wipeIn({
		//	|		node:"someId"
		//	|	}).play()
		var node = args.node = d.byId(args.node), s = node.style, o;

		var anim = d.animateProperty(d.mixin({
			properties: {
				height: {
					// wrapped in functions so we wait till the last second to query (in case value has changed)
					start: function(){
						// start at current [computed] height, but use 1px rather than 0
						// because 0 causes IE to display the whole panel
						o = s.overflow;
						s.overflow = "hidden";
						if(s.visibility == "hidden" || s.display == "none"){
							s.height = "1px";
							s.display = "";
							s.visibility = "";
							return 1;
						}else{
							var height = d.style(node, "height");
							return Math.max(height, 1);
						}
					},
					end: function(){
						return node.scrollHeight;
					}
				}
			}
		}, args));

		d.connect(anim, "onEnd", function(){ 
			s.height = "auto";
			s.overflow = o;
		});

		return anim; // dojo.Animation
	}

	dojo.fx.wipeOut = function(/*Object*/ args){
		// summary:
		//		Shrink a node to nothing and hide it. 
		//
		// description:
		//		Returns an animation that will shrink node defined in "args"
		//		from it's current height to 1px, and then hide it.
		//
		// args: Object
		//		A hash-map of standard `dojo.Animation` constructor properties
		//		(such as easing: node: duration: and so on)
		// 
		// example:
		//	|	dojo.fx.wipeOut({ node:"someId" }).play()
		
		var node = args.node = d.byId(args.node), s = node.style, o;
		
		var anim = d.animateProperty(d.mixin({
			properties: {
				height: {
					end: 1 // 0 causes IE to display the whole panel
				}
			}
		}, args));

		d.connect(anim, "beforeBegin", function(){
			o = s.overflow;
			s.overflow = "hidden";
			s.display = "";
		});
		d.connect(anim, "onEnd", function(){
			s.overflow = o;
			s.height = "auto";
			s.display = "none";
		});

		return anim; // dojo.Animation
	}

	dojo.fx.slideTo = function(/*Object*/ args){
		// summary:
		//		Slide a node to a new top/left position
		//
		// description:
		//		Returns an animation that will slide "node" 
		//		defined in args Object from its current position to
		//		the position defined by (args.left, args.top).
		//
		// args: Object
		//		A hash-map of standard `dojo.Animation` constructor properties
		//		(such as easing: node: duration: and so on). Special args members
		//		are `top` and `left`, which indicate the new position to slide to.
		//
		// example:
		//	|	dojo.fx.slideTo({ node: node, left:"40", top:"50", units:"px" }).play()

		var node = args.node = d.byId(args.node), 
			top = null, left = null;

		var init = (function(n){
			return function(){
				var cs = d.getComputedStyle(n);
				var pos = cs.position;
				top = (pos == 'absolute' ? n.offsetTop : parseInt(cs.top) || 0);
				left = (pos == 'absolute' ? n.offsetLeft : parseInt(cs.left) || 0);
				if(pos != 'absolute' && pos != 'relative'){
					var ret = d.position(n, true);
					top = ret.y;
					left = ret.x;
					n.style.position="absolute";
					n.style.top=top+"px";
					n.style.left=left+"px";
				}
			};
		})(node);
		init();

		var anim = d.animateProperty(d.mixin({
			properties: {
				top: args.top || 0,
				left: args.left || 0
			}
		}, args));
		d.connect(anim, "beforeBegin", anim, init);

		return anim; // dojo.Animation
	}

})();

}

if(!dojo._hasResource["dojo.fx.easing"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.fx.easing"] = true;
dojo.provide("dojo.fx.easing");

dojo.fx.easing = {
	// summary: 
	//		Collection of easing functions to use beyond the default 
	//		`dojo._defaultEasing` function.
	// 
	// description:
	//
	//		Easing functions are used to manipulate the iteration through
	//		an `dojo.Animation`s _Line. _Line being the properties of an Animation,
	//		and the easing function progresses through that Line determing
	//		how quickly (or slowly) it should go. Or more accurately: modify
	//		the value of the _Line based on the percentage of animation completed.
	//	
	//		All functions follow a simple naming convention of "ease type" + "when".
	//		If the name of the function ends in Out, the easing described appears
	//		towards the end of the animation. "In" means during the beginning,
	//		and InOut means both ranges of the Animation will applied, both
	//		beginning and end. 
	//
	//		One does not call the easing function directly, it must be passed to 
	//		the `easing` property of an animation.
	//
	//	example:
	//	|	
	//	|	var anim = dojo.fadeOut({
	//	|		node: 'node',	
	//	|		duration: 2000,
	//	|		//	note there is no () 
	//	|		easing: dojo.fx.easing.quadIn
	//	|	}).play();
	//
	
	linear: function(/* Decimal? */n){
		// summary: A linear easing function
		return n;
	},

	quadIn: function(/* Decimal? */n){
		return Math.pow(n, 2);
	},

	quadOut: function(/* Decimal? */n){
		return n * (n - 2) * -1;
	},

	quadInOut: function(/* Decimal? */n){
		n = n * 2;
		if(n < 1){ return Math.pow(n, 2) / 2; }
		return -1 * ((--n) * (n - 2) - 1) / 2;
	},

	cubicIn: function(/* Decimal? */n){
		return Math.pow(n, 3);
	},

	cubicOut: function(/* Decimal? */n){
		return Math.pow(n - 1, 3) + 1;
	},

	cubicInOut: function(/* Decimal? */n){
		n = n * 2;
		if(n < 1){ return Math.pow(n, 3) / 2; }
		n -= 2;
		return (Math.pow(n, 3) + 2) / 2;
	},

	quartIn: function(/* Decimal? */n){
		return Math.pow(n, 4);
	},

	quartOut: function(/* Decimal? */n){
		return -1 * (Math.pow(n - 1, 4) - 1);
	},

	quartInOut: function(/* Decimal? */n){
		n = n * 2;
		if(n < 1){ return Math.pow(n, 4) / 2; }
		n -= 2;
		return -1 / 2 * (Math.pow(n, 4) - 2);
	},

	quintIn: function(/* Decimal? */n){
		return Math.pow(n, 5);
	},

	quintOut: function(/* Decimal? */n){
		return Math.pow(n - 1, 5) + 1;
	},

	quintInOut: function(/* Decimal? */n){
		n = n * 2;
		if(n < 1){ return Math.pow(n, 5) / 2; };
		n -= 2;
		return (Math.pow(n, 5) + 2) / 2;
	},

	sineIn: function(/* Decimal? */n){
		return -1 * Math.cos(n * (Math.PI / 2)) + 1;
	},

	sineOut: function(/* Decimal? */n){
		return Math.sin(n * (Math.PI / 2));
	},

	sineInOut: function(/* Decimal? */n){
		return -1 * (Math.cos(Math.PI * n) - 1) / 2;
	},

	expoIn: function(/* Decimal? */n){
		return (n == 0) ? 0 : Math.pow(2, 10 * (n - 1));
	},

	expoOut: function(/* Decimal? */n){
		return (n == 1) ? 1 : (-1 * Math.pow(2, -10 * n) + 1);
	},

	expoInOut: function(/* Decimal? */n){
		if(n == 0){ return 0; }
		if(n == 1){ return 1; }
		n = n * 2;
		if(n < 1){ return Math.pow(2, 10 * (n - 1)) / 2; }
		--n;
		return (-1 * Math.pow(2, -10 * n) + 2) / 2;
	},

	circIn: function(/* Decimal? */n){
		return -1 * (Math.sqrt(1 - Math.pow(n, 2)) - 1);
	},

	circOut: function(/* Decimal? */n){
		n = n - 1;
		return Math.sqrt(1 - Math.pow(n, 2));
	},

	circInOut: function(/* Decimal? */n){
		n = n * 2;
		if(n < 1){ return -1 / 2 * (Math.sqrt(1 - Math.pow(n, 2)) - 1); }
		n -= 2;
		return 1 / 2 * (Math.sqrt(1 - Math.pow(n, 2)) + 1);
	},

	backIn: function(/* Decimal? */n){
		// summary: 
		//		An easing function that starts away from the target, 
		//		and quickly accelerates towards the end value.
		// 
		//		Use caution when the easing will cause values to become 
		//		negative as some properties cannot be set to negative values.
		var s = 1.70158;
		return Math.pow(n, 2) * ((s + 1) * n - s);
	},

	backOut: function(/* Decimal? */n){
		// summary: 
		//		An easing function that pops past the range briefly, and slowly comes back. 
		//
		// description:
		//		An easing function that pops past the range briefly, and slowly comes back. 
		//
		//		Use caution when the easing will cause values to become negative as some 
		//		properties cannot be set to negative values.
		
		n = n - 1;
		var s = 1.70158;
		return Math.pow(n, 2) * ((s + 1) * n + s) + 1;
	},

	backInOut: function(/* Decimal? */n){
		// summary: 
		//		An easing function combining the effects of `backIn` and `backOut`
		//
		// description:
		//		An easing function combining the effects of `backIn` and `backOut`.
		//		Use caution when the easing will cause values to become negative 
		//		as some properties cannot be set to negative values.
		var s = 1.70158 * 1.525;
		n = n * 2;
		if(n < 1){ return (Math.pow(n, 2) * ((s + 1) * n - s)) / 2; }
		n-=2;
		return (Math.pow(n, 2) * ((s + 1) * n + s) + 2) / 2;
	},

	elasticIn: function(/* Decimal? */n){
		// summary: 
		//		An easing function the elastically snaps from the start value
		//
		// description:
		//		An easing function the elastically snaps from the start value
		//	
		//		Use caution when the elasticity will cause values to become negative 
		//		as some properties cannot be set to negative values.
		if(n == 0 || n == 1){ return n; }
		var p = .3;
		var s = p / 4;
		n = n - 1;
		return -1 * Math.pow(2, 10 * n) * Math.sin((n - s) * (2 * Math.PI) / p);
	},

	elasticOut: function(/* Decimal? */n){
		// summary: 
		//		An easing function that elasticly snaps around the target value,
		//		near the end of the Animation
		//
		// description:
		//		An easing function that elasticly snaps around the target value,
		//		near the end of the Animation
		//
		//		Use caution when the elasticity will cause values to become 
		//		negative as some properties cannot be set to negative values.
		if(n==0 || n == 1){ return n; }
		var p = .3;
		var s = p / 4;
		return Math.pow(2, -10 * n) * Math.sin((n - s) * (2 * Math.PI) / p) + 1;
	},

	elasticInOut: function(/* Decimal? */n){
		// summary: 
		//		An easing function that elasticly snaps around the value, near
		//		the beginning and end of the Animation.
		//
		// description:
		//		An easing function that elasticly snaps around the value, near
		//		the beginning and end of the Animation.
		//
		//		Use caution when the elasticity will cause values to become 
		//		negative as some properties cannot be set to negative values.
		if(n == 0) return 0;
		n = n * 2;
		if(n == 2) return 1;
		var p = .3 * 1.5;
		var s = p / 4;
		if(n < 1){
			n -= 1;
			return -.5 * (Math.pow(2, 10 * n) * Math.sin((n - s) * (2 * Math.PI) / p));
		}
		n -= 1;
		return .5 * (Math.pow(2, -10 * n) * Math.sin((n - s) * (2 * Math.PI) / p)) + 1;
	},

	bounceIn: function(/* Decimal? */n){
		// summary: 
		//		An easing function that 'bounces' near the beginning of an Animation
		return (1 - dojo.fx.easing.bounceOut(1 - n)); // Decimal
	},

	bounceOut: function(/* Decimal? */n){
		// summary:
		//		An easing function that 'bounces' near the end of an Animation
		var s = 7.5625;
		var p = 2.75;
		var l; 
		if(n < (1 / p)){
			l = s * Math.pow(n, 2);
		}else if(n < (2 / p)){
			n -= (1.5 / p);
			l = s * Math.pow(n, 2) + .75;
		}else if(n < (2.5 / p)){
			n -= (2.25 / p);
			l = s * Math.pow(n, 2) + .9375;
		}else{
			n -= (2.625 / p);
			l = s * Math.pow(n, 2) + .984375;
		}
		return l;
	},

	bounceInOut: function(/* Decimal? */n){
		// summary: 
		//		An easing function that 'bounces' at the beginning and end of the Animation
		if(n < 0.5){ return dojo.fx.easing.bounceIn(n * 2) / 2; }
		return (dojo.fx.easing.bounceOut(n * 2 - 1) / 2) + 0.5; // Decimal
	}
};

}

if(!dojo._hasResource['epages.browser']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.browser'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.browser $Revision: 1.21 $

*/
dojo.provide('epages.browser');


epages.Browser = {};

(function() {
	var browser = epages.Browser;
	browser.engine = "Unknown";
	browser.version = "Unknown";
	if(window.opera) {
		browser.engine = "Presto";
		browser.version = window.opera.version();
	}else {
		var versionString = (navigator.appVersion + navigator.userAgent).toLowerCase();
		if(versionString.match("iemobile") || versionString.match("windows ce")) {
			// ie on smartphone
			browser.engine = "MSIE";
			browser.version = 6;
		}else if(versionString.match("msie")) {
			browser.engine = "MSIE";
			browser.version = (window.XDomainRequest && dojo.isIE == 7) ? 8 : dojo.isIE;
			// ...and finally some testing for IE6 with faked IE7 appVersion & userAgent
			var testNode = document.createElement("b");
			testNode.style.cssText = "max-height:1";
			if(testNode.style.cssText.match("max-height")) {browser.version = 6}
		}else if(versionString.match("webkit")) {
			browser.engine = "WebKit";
			browser.version = parseFloat(versionString.split("/")[2]) || dojo.isSafari;
			var versionMatches = versionString.match(/applewebkit\/(\d+)\.(\d+)/);
			browser.webkitversion = {};
			browser.webkitversion.major = parseInt(versionMatches[1]);
			browser.webkitversion.minor = parseInt(versionMatches[2]);
		}else if(versionString.match("gecko")) {
			browser.engine = "Gecko";
			browser.version = dojo.isFx || dojo.isFF || parseFloat(versionString.split("/").pop()) /* handling firefox versions with alternate ua */;
		}else if(versionString.match("khtml")) {
			browser.engine = "KHTML";
		}
	}
	browser.version = browser.version.toString().replace(/\./g, "_");
	(document.documentElement || document.body.parentNode).className += " " + browser.engine + " " + browser.engine + browser.version;
})();

}

if(!dojo._hasResource["epages.event"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.event"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

  epages.event $Revision: 1.11 $

*/
dojo.provide("epages.event");


epages.event.fire = function(/*Object*/DomObject,/*String*/eventType) {
	// summary: Cross browser function to throw events to dom objects.
	// description: Throws an event of the given event type to the given dom object.
	// DomObject: dom node
	// eventType: type of the event. eg. "click" or "mouseover"

		if (epages.Browser.engine == 'MSIE') {
			try {
				DomObject.fireEvent('on'+eventType);
			}catch(e) {}
		} else {
			if(eventType == 'click' ||
				eventType == 'dblclick' ||
				eventType == 'mousedown' ||
				eventType == 'mousemove' ||
				eventType == 'mouseout' ||
				eventType == 'mouseover' ||
				eventType == 'mouseup') { // create mouse events
				var newevt = document.createEvent('MouseEvents');
				newevt.initMouseEvent(eventType, true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
			} else  {										// create html events
				var newevt = document.createEvent('HTMLEvents');
				newevt.initEvent(eventType, true, true);
			}
			DomObject.dispatchEvent(newevt);
		}
};

}

if(!dojo._hasResource["epages.string"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.string"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

  epages.string $Revision: 1.16 $

*/
dojo.provide("epages.string");


epages.string = {

	escapeJavaScript: function (str) {
		return str.replace(/(["'\f\b\n\t\r])/gm, "\\$1");
	},

	escapeXml: function (str, noSingleQuotes) {
		str = str.replace(/&/gm, "&amp;").replace(/</gm, "&lt;").replace(/>/gm, "&gt;").replace(/"/gm, "&quot;");
		if (!noSingleQuotes) {
			str = str.replace(/'/gm, "&#39;");
		}
		return str;
	},

	toBoolean: function(/*String*/value) {
		if (value === undefined){
			return false;
		}
		if (typeof value == "boolean"){
			return value;
		}
		if (typeof value != "string"){
			throw new Error("Not a string value, got " + typeof(value) + "!");
		}
		return value.toLowerCase() === "true" || value == '1' ? true : false;
	},

	toInteger: function(/*String*/value,/*Boolean*/removeThousandDelimiter) {
	// summary: parse string to integer, optional remove thousandDelimiter
		if(removeThousandDelimiter) {
			value = value.replace(/\./g,'');
		}
		return parseInt( value.replace(/[^0-9\,\.]/g, "") );
	},

	toTime: function(/*String*/value, /*String*/epagesPattern) {
		if (value == ''){
			return null;
		}
		if (epagesPattern == null || epagesPattern.length == 0){
			epagesPattern = epages.vars.Locale.timeFormat;
		}
		var pattern = epages.localize.getDojoDateTimePattern(epagesPattern);
		var date = dojo.date.locale.parse(value, { selector: 'date', datePattern: pattern, timePattern: '' });
		if (date === null){
			 date = dojo.date.locale.parse(value, { selector: 'date', datePattern: 'HH:mm a', timePattern: '' });
		}
		if (date === null){
			date = dojo.date.locale.parse(value, { selector: 'date', datePattern: 'HH a', timePattern: '' });
		}
		if (date === null){
			date = dojo.date.locale.parse(value, { selector: 'date', datePattern: 'HH', timePattern: '' });
		}
		// allow entries like "24:00" which means "00:00"
		if (date === null) {
			date = dojo.date.locale.parse(value, { selector: 'date', datePattern: 'KK:mm', timePattern: '' });
		}
		if (date === null){
			 date = dojo.date.locale.parse(value, { selector: 'date', datePattern: 'KK', timePattern: '' });
		}
		return date;
	},

	cssSizeToNumber : function(/* string */ value) {
	// summary: convert css size to a number (float or integer)
		if(typeof value == "string") {
			if (value.match(/^([0-9]+)(px|pt)$/i)) {
				var n = parseInt(RegExp.$1);
				return n;
			}

			if (value.match(/^([0-9]*\.?[0-9]+)(pc|%|mm|cm|em|in|ex)$/i)) {
				var n = parseFloat(RegExp.$1);
				return n;
			}

			if (value.match(/^[0]+$/)) {
				return 0;
			}
		}
		return NaN;
	},

	// corrects a bug in IE's String.split, where IE discards all empty elements
	split: function(string, rx) {
		if (epages.Browser.engine != 'MSIE'){
			 return string.split(rx);
		}
		var unique = '';
		do {
			unique += Date.toString();
		} while(string.match(unique));
		string = string.replace(rx, '|' + unique + '|');
		var splits = string.split(unique);
		for( var i=0,iLength=splits.length ; i<iLength ; i++ ) {
			splits[i] = splits[i].replace(/^(?:\|)?(.*?)(?:\|)?$/g, function(tmp, match) { return match; } );
		}
		return splits;
	}
};

epages.string.Base64 = function () {
};

epages.string.Base64.prototype = {
	// private property
	_keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

	// public method for encoding
	encode : function (input) {
		var output = "";
		var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
		var i = 0;

		input = this._utf8_encode(input);

		if (typeof(window.btoa) == 'function') {
			return window.btoa(input);
		}

		while (i < input.length) {

			chr1 = input.charCodeAt(i++);
			chr2 = input.charCodeAt(i++);
			chr3 = input.charCodeAt(i++);

			enc1 = chr1 >> 2;
			enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
			enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
			enc4 = chr3 & 63;

			if (isNaN(chr2)) {
				enc3 = enc4 = 64;
			} else if (isNaN(chr3)) {
				enc4 = 64;
			}

			output = output +
			this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
			this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

		}

		return output;
	},

	// public method for decoding
	decode : function (input) {
		var output = "";
		var chr1, chr2, chr3;
		var enc1, enc2, enc3, enc4;
		var i = 0;

		input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

		if (typeof(window.atob) == 'function') {
			output = window.atob(input);
		} else {

			while (i < input.length) {

				enc1 = this._keyStr.indexOf(input.charAt(i++));
				enc2 = this._keyStr.indexOf(input.charAt(i++));
				enc3 = this._keyStr.indexOf(input.charAt(i++));
				enc4 = this._keyStr.indexOf(input.charAt(i++));

				chr1 = (enc1 << 2) | (enc2 >> 4);
				chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
				chr3 = ((enc3 & 3) << 6) | enc4;

				output = output + String.fromCharCode(chr1);

				if (enc3 != 64) {
					output = output + String.fromCharCode(chr2);
				}
				if (enc4 != 64) {
					output = output + String.fromCharCode(chr3);
				}

			}
		}

		output = this._utf8_decode(output);

		return output;

	},

	// private method for UTF-8 encoding
	_utf8_encode : function (string) {
		string = string.replace(/\r\n/g,"\n");
		var utftext = "";

		for (var n = 0,l=string.length; n < l; n++) {

			var c = string.charCodeAt(n);

			if (c < 128) {
				utftext += String.fromCharCode(c);
			}
			else if((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			}
			else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}

		}

		return utftext;
	},

	// private method for UTF-8 decoding
	_utf8_decode : function (utftext) {
		var string = "";
		var i = 0;
		var c = c1 = c2 = 0;

		while ( i < utftext.length ) {

			c = utftext.charCodeAt(i);

			if (c < 128) {
				string += String.fromCharCode(c);
				i++;
			}
			else if((c > 191) && (c < 224)) {
				c2 = utftext.charCodeAt(i+1);
				string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
				i += 2;
			}
			else {
				c2 = utftext.charCodeAt(i+1);
				c3 = utftext.charCodeAt(i+2);
				string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
				i += 3;
			}
		}
		return string;
	}
};

}

if(!dojo._hasResource['epages.lang.array']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.lang.array'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.lang.array $Revision: 1.34 $

*/
dojo.provide('epages.lang.array');


$A = function (/*Object?*/arrayLike, /*Boolean?*/asCopy) {
	// summary:
	//    returns a new array, same like new epages.lang.Array
	// example:
	//  | hash = $A(['value1', 'value2']);
	//  | // returns epages.lang.Array
	return new epages.lang.Array(arrayLike, asCopy);
};

epages.lang.Array = /*epages.lang.Array*/ function (/*Object?*/arrayLike, /*Boolean?*/asCopy) {
	// summary:
	//    returns a new array
	// example:
	//  | array = epages.lang.Array(['value1', 'value2']);
	//  | // returns epages.lang.Array
	if (asCopy === undefined){
		asCopy = false;
	}
	var results = [];
	if (arrayLike !== undefined) {
		if (arrayLike._data !== undefined) {
			arrayLike = arrayLike._data;
		}
		if (asCopy) {
			for (var i = 0, length = arrayLike.length; i < length; i++){
				results.push(arrayLike[i]);
			}
		} else {
			results = arrayLike;
		}
	}
	this._data  = results;
	this.length = results.length;
};

epages.lang.Array.prototype = {
	_data: undefined,
	length: 0,

	get: function (/*int*/index) {
		return this._data[index];
	},

	set: function (/*int*/index, /*mixed*/value) {
		this._data[index] = value;
	},

	insertAt: function (/*int*/index, /*mixed*/value) {
		if (!index) {
			this.unshift(value);
		} else if (index == this.length) {
			this.push(value);
		} else {
			var c = this._data;
			for(var i=this.length; i > index; i--){
				c[i] = c[i-1];
			}
			c[index] = value;
			this.length = c.length;
		}
	},

	push: function (/*arguments*/) {
		// summary:
		//    adds elements to this array
		// example:
		//  | array = new epages.lang.Array(['value1', 'value2']);
		//  | array.push('value3', 'value4');
		//  | array.push('value5');
		for (var i = 0, length = arguments.length; i < length; i++) {
			this._data.push(arguments[i]);
		}
		this.length = this._data.length;
	},

	pop: function (/*arguments*/) {
		// summary:
		//    pops the last element from this array
		// returns: 
		//    removed element
		// example:
		//  | array = new epages.lang.Array(['value1', 'value2']);
		//  | array.pop();
		//  | //returns 'value2'
		var el = this._data.pop();
		this.length = this._data.length;
		return el;
	},

	unshift: function (/*arguments*/) {
		// summary:
		//    adds elements to this array at the first position
		// example:
		//  | array = new epages.lang.Array(['value1', 'value2']);
		//  | array.unshift('value3', 'value4');
		//  | // returns ['value4', 'value3','value1', 'value2']
		for (var i = 0, length = arguments.length; i < length; i++) {
			this._data.unshift(arguments[i]);
		}
		this.length=this._data.length;
	},

	shift: function () {
		// summary:
		//    removes an elements from the beginning of this array
		// returns: 
		//    removed element
		var el = this._data.shift();
		this.length = this._data.length;
		return el;
	},

	grep: function (/*Function*/callback, /*Object?*/thisObject) {
		// summary:
		//    returns a new Array with those items from arr that match the
		//    condition implemented by callback.thisObject may be used to
		//    scope the call to callback.
		// example:
		//  | array = new epages.lang.Array([1, 2, 3, 4]);
		//  | array2 = array.grep( function(item){ return item>1; });
		//  | // returns [2, 3, 4]
		if (thisObject === undefined){
			return dojo.filter(this._data, callback); // Array
		}
		return dojo.filter(this._data, callback, thisObject); // Array
	},

	map: function (/*Function*/callback, /*Object?*/thisObject) {
		// summary:
		//    returns calls for each item of this Array the given callback function and collect the return values.
		// example:
		//  | array = new epages.lang.Array([1, 2, 3, 4]);
		//  | var newArray = array.map( function(item){ return item + 1; });
		//  | // newArray = [2,3,4,5]
		return dojo.map(this._data, callback, thisObject); //Array
	},

	each: function (/*Function*/callback, /*Object?*/thisObject) {
		// summary:
		//    returns calls for each item of this Array the given callback function.
		// example:
		//  | array = new epages.lang.Array([1, 2, 3, 4]);
		//  | var sum = 0;
		//  | array.each( function(item){ sum += item; });
		//  | // sum = 10
		dojo.map(this._data, callback, thisObject);
		return; //void
	},

	match: function (/*RegExpr*/ pattern) {
		// summary:
		//    returns a new Array with those items from arr that match the
		//    condition (matches with the given pattern).
		// example:
		//  | array = new epages.lang.Array(['Test', 'Array', 'Hash', 'epages']);
		//  | array2 = array.match(/e/);
		//  | // returns ['Test', 'epages']
		var result = [];
		for (var i = 0, length = this._data.length; i < length; i++) {
			var element = this._data[i];
			if (typeof element.match == 'function' && element.match(pattern)){
				result.push(element);
			}
		}
		return result; //Array
	},

	exists: function (/*Object*/element) {
		// summary:
		//    returns true if an item exists in the array,
		//    otherwise false.
		// example:
		//  | array = new epages.lang.Array(['Test', 'Array', 'Hash', 'epages']);
		//  | isElement = array.exists('e');
		//  | // returns false
		return (this.find(element) !== null); //boolean
	},

	find: function (/*Object*/element) {
		// summary:
		//    returns the index of the element, if it exists in the array
		// example:
		//  | array = new epages.lang.Array(['Test', 'Array', 'Hash', 'epages']);
		//  | isElement = array.find('Array');
		//  | // returns 1
		for (var i = 0, length = this._data.length; i < length; i++) {
			if (element === this._data[i]){
				return i; // integer or null
			}
		}
		return null; // integer or null
	},

	remove: function (/*integer*/index) {
		// summary:
		//    removes the element on position >index
		// example:
		//  | array = new epages.lang.Array(['Test', 'Array', 'Hash', 'epages']);
		//  | isElement = array.find('Array');
		//  | // returns 1
		this._data.splice(index, 1);
		this.length = this._data.length;
	},

	unique: function () {
		// summary:
		//    returns an (JS) array containing every element only once
		// example:
		//  | array = new epages.lang.Array(['a', 'b', 'c', 'c']);
		//  | uniqueArray = array.unique();
		//  | // returns ['a', 'b', 'c']
		var uniqueData = new epages.lang.Array();
		var i = 0;
		while (i < this._data.length) {
			if (uniqueData.find(this._data[i]) == null) {
				uniqueData.push(this._data[i]);
				i++;
			} else {
				this._data.splice(i,1);
			}
		}
		this.length = this._data.length;
	},

	equals: function(/*array|epages.lang.array*/compareArray) {
		// summary:
		//    returns true, if the given array contains the same element in the same order
		//    than this array, otherwise false.
		//    the parameter can be either a JS array or a epages.lang.Array.
		// example:
		//  | array = new epages.lang.Array(['a', 'b', 'c']);
		//  | return array.equals(['a', 'b', 'c']);
		//  | // returns true
		if (compareArray.length == this.length) {
			if (typeof compareArray._data != "undefined") {
				// compareArray seems to be a epages.lang.Array
				for( var i=0,iLength=this.length ; i<iLength ; i++ ) {
					if (this._data[i] !== compareArray._data[i]){
						return false;
					}
				}
			} else {
				// compareArray is a JS array
				for( var i=0,iLength=this.length ; i<iLength ; i++ ) {
					if (this._data[i] !== compareArray[i]){
						return false;
					}
				}
			}
			return true; //Boolean
		} else {
			// lengths differ
			return false; //Boolean
		}
	},

	merge: function(/*array|epages.lang.Array*/anotherArray) {
		var c = [];
		if (dojo.isArray(anotherArray)) {
			c = anotherArray;
		} else if(anotherArray._data !== undefined) {
			c = anotherArray._data;
		}
		for( var i=0,iLength=c.length ; i<iLength ; i++ ) {
			this._data.push(c[i]);
		}
		this.length = this._data.length;
	},

	join: function(delimiter) {
		return this._data.join(delimiter);
	},

	toString: function() {
		var a = this.map(function (v) {
			if (v === undefined){
				return 'undefined';
			}else if (v == null){
				return 'null';
			}else if (dojo.isArray(v)){
				return $A(v).toString();
			}else if (dojo.isObject(v)){
				return v.toString();
			}else{
				return '"' + epages.string.escapeJavaScript('' + v) + '"';
			}
		});
		return '[' + a.join(',') + ']';
	},

	sort: function(sortFunc) {
	  return this._data.sort(sortFunc);
	}
};

}

if(!dojo._hasResource['epages.lang.hash']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.lang.hash'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.lang.hash $Revision: 1.36 $

*/
dojo.provide('epages.lang.hash');



$H = function (/*Object*/object) {
	// summary:
	//		returns a new hash, same like new epages.lang.Hash
	// example:
	//	| hash = $H({ key1: 'value1', key2: 'value2'});
	//	| // returns epages.lang.Hash
	return new epages.lang.Hash(object);
};

epages.lang.Hash = /*epages.lang.Hash*/ function (/*Object?*/existingHash) {
	// summary:
	//		returns a new hash, makes a copy of the existing hash
	// example:
	//	|	hash1 = new epages.lang.Hash();
	//	|	// returns an empty epages.lang.Hash
	//	|	hash2 = new epages.lang.Hash({ key1: 'value1', key2: 'value2'});
	// 	|  hash3 = new epages.lang.Hash({
	// 	|		image       : 'test.png',
	// 	|		header      : 'Test',
	// 	|		description : 'long description, long description'
	// 	|	});
	//	|	hash4 = new epages.lang.Hash(hash2);
	//	|	// returns epages.lang.Hash
	this._data = new Object();
	var data = this._data;
	if (existingHash !== undefined) {
		if (typeof existingHash.each == 'function') {
			existingHash.each(function (pair) {
				data[pair.key] = pair.value;
			});
		} else {
			for (var key in existingHash){
				data[key] = existingHash[key];
			}
		}
	}
};

epages.lang.Hash.prototype = {
	_data: undefined,

	data : function () {
		return this._data;
	},

	each : function(iterator) {
		for (var key in this._data) {
			var value = this._data[key];
			var pair = [key, value];
			pair.key = key;
			pair.value = value;
			iterator(pair);
		}
	},

	flatten: function() {
		// summary:
		//		returns xml representation of this hash
		// example:
		// 	|  var hash = new epages.lang.Hash({
		// 	|		image       : 'test.png',
		// 	|		header      : 'Test'
		// 	|	});
		//	|	string = hash.flatten();
		//	|	// returns
		//	|	// <epages.lang.Hash>
		//	|	//  <element><key>image</key><value>test.png</value></element>
		//	|	//  <element><key>header</key><value>Test</value></element>
		//	|	// </epages.lang.Hash>
		var returnvalue = '';
		this.each( function(pair) {
			returnvalue += '<element><key>' + pair.key + '</key><value>' + pair.value + '</value></element>\n';
		});
		return '<epages.lang.Hash>\n' + returnvalue + '</epages.lang.Hash>\n'; //String
	},

	keys: function() {
		// summary:
		//		returns all keys of this hash
		// example:
		// 	|  var hash = new epages.lang.Hash({
		// 	|		image       : 'test.png',
		// 	|		header      : 'Test',
		// 	|		description : 'long description, long description'
		// 	|	});
		//	|	array = hash.keys();
		//	|	// returns ['image','header','description']
		var returnvalue = [];
		this.each( function(pair) {
			returnvalue.push(pair.key);
		});
		return returnvalue; //Array
	},

	values: function() {
		// summary:
		//		returns all values of this hash
		// example:
		// 	|  var hash = new epages.lang.Hash({
		// 	|		image       : 'test.png',
		// 	|		header      : 'Test',
		// 	|		description : 'long description, long description'
		// 	|	});
		//	|	array = hash.keys();
		//	|	// returns ['test.png','Test','long description, long description']
		var returnvalue = [];
		this.each( function(pair) {
			returnvalue.push(pair.value);
		});
		return returnvalue; //Array
	},

	set: function(/*String*/key, /*Object*/value) {
		// summary:
		//		adds a new element to the hash
		// example:
		// 	|  var hash = new epages.lang.Hash({
		// 	|		image       : 'test.png',
		// 	|		description : 'long description, long description'
		// 	|	});
		//	|	hash.set('header','Test');
		//	|	// same as
		// 	|  var hash2 = new epages.lang.Hash({
		// 	|		image       : 'test.png',
		// 	|		description : 'long description, long description',
		// 	|		header      : 'Test'
		// 	|	});
		this._data[key] = value;
	},

	get: function(/*String*/key) {
		// summary:
		//		returns the value of an specified element
		// example:
		// 	|  var hash = new epages.lang.Hash({
		// 	|		image       : 'test.png',
		// 	|		description : 'long description, long description'
		// 	|	});
		//	|	string = hash.get('image');
		//	|	// returns 'test.png'
		return this._data[key];
	},

	remove: function(/*String*/key) {
		// summary:
		//		removes the node with the given key
		// example:
		// 	|  var hash = new epages.lang.Hash({
		// 	|		image       : 'test.png',
		// 	|		description : 'long description, long description'
		// 	|	});
		//	|	bool = hash.remove('image');
		//	|	// returns true
		delete this._data[key];
	},

	existsKey: function(/*String*/key) {
		// summary:
		//		determines, if the given key exists
		// example:
		// 	|  var hash = new epages.lang.Hash({
		// 	|		image       : 'test.png',
		// 	|		description : 'long description, long description'
		// 	|	});
		//	|	bool = hash.existsKey('image');
		//	|	// returns true
		if(this._data[key] !== undefined){
			return true; //Boolean
		}
		// possible key exists but is undefined
		for (var existingKey in this._data) {
			if (existingKey == key){
				return true; //Boolean
			}
		}
		return false; //Boolean
	},

	existsValue: function(/*Object*/value) {
		// summary:
		//		returns, if the given value exists
		// example:
		// 	|  var hash = new epages.lang.Hash({
		// 	|		image       : 'test.png',
		// 	|		description : 'long description, long description'
		// 	|	});
		//	|	bool = hash.existsValue('test.png');
		//	|	// returns true
		return this.find(value) !== undefined;
	},

	find: function(/*Object*/value) {
		// summary:
		//		returns the key to the given value or undefined, when not found
		// example:
		// 	|  var hash = new epages.lang.Hash({
		// 	|		a: 'aa',
		// 	|		b: 'bb'
		// 	|	});
		//	|	bool = hash.find('aa');
		//	|	// returns 'a'
		for (var key in this._data) {
			if (this._data[key] === value){
				return key; //String
			}
		}
		return undefined; //undefined
	},

	toQueryString: function () {
		// summary:
		//		returns uri query string for a hash
		// example:
		//  | var hash = new epages.lang.Hash({ 'schluessel': 'value', 'enc&Schluessel':'enc&Value'});
		//	| var string = hash.toQueryString();
		//	| // returns 'schluessel=value&enc%26Schluessel=enc%26Value'
		var returnvalue = [];
		this.each( function(pair) {
			if (pair.value !== undefined && pair.value != null) {
				var encKey = encodeURIComponent(pair.key);
				if (dojo.isArray(pair.value)) {
					for( var i=0,iLength=pair.value.length ; i<iLength ; i++ ) {
						returnvalue.push(encKey + '=' + encodeURIComponent(pair.value[i]));
					}
				} else {
					returnvalue.push(encKey + '=' + encodeURIComponent(pair.value));
				}
			}
		});
		return returnvalue.join('&'); //String
	},

	toString: function () {
		// summary:
		//		returns uri query string for a hash
		// example:
		//  | var hash = new epages.lang.Hash({ 'schluessel': 'value', 'enc&Schluessel':'enc&Value'});
		//	| var string = hash.toQueryString();
		//	| // returns 'schluessel=value&enc%26Schluessel=enc%26Value'
		var returnvalue = [];
		this.each( function(pair) {
			var v = pair.value;
			if (v === undefined){
				v = 'undefined';
			}else if (v === null){
				v = 'null';
			}else if (dojo.isArrayLike(v)){
				v = $A(v).toString();
			}else if (dojo.isObject(v)){
				v = v.toString();
			}else{
				v = '"' + epages.string.escapeJavaScript('' + v) + '"';
			}

			returnvalue.push('"' + epages.string.escapeJavaScript(pair.key) + '":' + v);
		});
		return '{' + returnvalue.join(',') + '}'; //String
	}
};

}

if(!dojo._hasResource["epages.widget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

  epages.widget $Revision: 1.34 $

*/

dojo.provide("epages.widget");



 // load all on one



//dojo.require('epages.profile'); // use this to measure time for creating widgets

epages.topDojo.publish('epages/addGlobalSymbol', ['$$', window]);

if (window.restrictedParent || $$ === undefined) {
	$$ = function(widgetId) {
		for( var i=0,iLength=epages._windows.length ; i<iLength ; i++ ) {
			if (epages._windows[i].dijit != null && typeof epages._windows[i].dijit.byId == "function") {
				var widget = epages._windows[i].dijit.byId(widgetId);
				if (widget){
					return widget;
				}
			}
		}
	};
}

epages.widget.parserClasses = $H();
dojo.parser.instantiateOrg = dojo.parser.instantiate;
dojo.parser.instantiate = function(nodes) {
	var w = epages.widget.parserClasses;
	if(epages.Browser.engine != "Presto") {
		var d = dojo;
		d.forEach(nodes, function(node){
			if(!node){ return; }
			var type = node.getAttribute("dojoType");
			if((!type)||(!type.length)||w.existsKey(type)){ return; }
			w.set(type,1);
			if (!dojo.isFunction(dojo.getObject(type))) {
				console.warn('add this to you script: dojo.%s("%s");', 'require', type);
				d.require(type);
			}
		});
	}
	return this.instantiateOrg(nodes);
};

dojo.declare("epages.widget.Popup",
	[dijit._Widget],
	{
		parent: '',					// the button etc. that is displaying this popup
		around: '',					// DOM node (typically a button); place popup relative to this node.
		hideOnBlur: false,	// flag - hide popup on blur
		o: {orient: {'BR':'TR','BL':'TL'}},	// orientation parameters
		_visible:   false,	// current visibility status of popup

		show: function() {
			// summary: show popup
			var h = {
				popup: this,
				parent: this.parent,
				around: this.around
			};

			dojo.mixin(h,this.o);
			dijit.popup.open(h);
			this._visible=true;
			dijit.focus(this.domNode);
			if(epages.zIndex) {
				this.domNode.parentNode.style.zIndex=epages.zIndex;	// set z-index of wrapper div
				epages.zIndex+=1;
			}
		},

		hide: function() {
			// summary: hide popup
			dijit.popup.close(this);
		},

		toggle: function () {
			// summary: toggle visibility of popup
			if (this._visible) {
				this.hide();
			} else {
				this.show();
			}
		},

		onClose: function () {
			// summary: event function close popup
			this._visible=false;
		},

		_onBlur: function () {
			// summary: blur event function
			if (this.hideOnBlur){
				this.hide();
			}
		}
	}
);

// register window for global widget registry
epages.onIframeStart.push(function() {
	dijit.registerWin(window);
});

//remove comment if you want to measure widget creating time
/*
dijit._Widget.prototype.create_profile = dijit._Widget.prototype.create;
dijit._Widget.prototype.create = function(){
	var me = this;
	var args = arguments;
	epages.profile.takeStatistik(me.declaredClass,function(){
		me.create_profile.apply(me,args);
	});
};

window.setTimeout(function(){
	epages.profile.showStatistik();
},25000);
*/


}

if(!dojo._hasResource["epages.widget.TypedWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.TypedWidget"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.widget.TypedWidget $Revision: 1.6 $
*/
dojo.provide("epages.widget.TypedWidget");




dojo.declare("epages.widget.TypedWidget", [dijit._Widget, dijit._Templated], {
	// summary : Base class for all widgets which can select template via templateType
	_templateDirectory: undefined,
	postMixInProperties: function() {
		this.inherited("postMixInProperties", arguments);
		if (this._templateMapping !== undefined &&  this.templateType !== undefined &&  this._templateDirectory !== undefined) {
			if(this._templateMapping[this.templateType]!==undefined) {
				// check if set to widget's default using its prototype value
				if(this.templateType != this.defaultTemplateType) {
					var tempPath = '';

					// load templates from json object..
					if(typeof this._templateMapping[this.templateType] == 'object'){
						var TempObj = this._templateMapping[this.templateType];

						// ..from shrinksafed packages
						if(TempObj.templateString){
								this.templatePath   = null;
								this.templateString = TempObj.templateString;
						}

						// ..from sources
						else if(TempObj.templatePath){
							var TempTemplateString;
							dojo.xhrGet({
								url: TempObj.templatePath,
								sync: true,
								load: function(data){
									TempTemplateString = data;
								}
							});
							this.templatePath   = null;
							this.templateString = TempTemplateString;
						} else {
								console.warn('Template type: "'+ this.templateType +'" could not be loaded from json object! Use properties templatePath or templateString to declare its template file!');
						}
					}

					// backward compatibility mode: load templates from old non object format
					else {
							tempPath = this._templateDirectory;
							tempPath.path       += '/'+this._templateMapping[this.templateType];
							tempPath.uri        += '/'+this._templateMapping[this.templateType];
							this.templatePath   = tempPath;
							this.templateString = null;
					}
				}
			} else {
				console.warn('Template type: "'+ this.templateType +'" does not exist in this widget - use default. ('+this.declaredClass+')');
			}
		}
	}

});


}

if(!dojo._hasResource['epages.io.xml']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.io.xml'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.io.xml $Revision: 1.13 $

*/
dojo.provide('epages.io.xml');

epages.io.Xml = function () {}

epages.io.Xml.prototype = {

	loadSync: function (/*String*/url, /*object?*/formData) {
		// summary:
		//		returns a xml document, which was loaded via http from given url.
		// 		additional parameters will be added in the post.
		// example:
		//	|	xmlLoader = new epages.io.Xml();
		//	|	xmlDoc = xmlLoader.loadSync('http://www.mydomain.de/test.xml', { filename: "test.xml" });
		//	|	// returns XMLDocument object
		var returnData;

		// no parameters => GET
		var requestMethod = formData !== undefined ? dojo.xhrPost : dojo.xhrGet;
		requestMethod({
			url: 					url,
			handleAs:			"xml",
			sync:					true,
			preventCache: epages.constants.preventCache,
			load: 				function(data){
											returnData = data;
										},
			content:			formData
		});
		return returnData; // XMLDocument
	},

	loadAsync: function (/*String*/url, /*Function*/callback, /*object?*/formData) {
		// summary:
		//		returns a xml document, which was loaded via http from given url.
		// 		additional parameters will be added in the post.
		// example:
		//	|	xmlLoader = new epages.io.Xml();
		//	|	xmlDoc = xmlLoader.loadSync('http://www.mydomain.de/test.xml', { filename: "test.xml" });
		//	|	// returns XMLDocument object
		var requestMethod = formData !== undefined ? dojo.xhrPost : dojo.xhrGet;
		requestMethod({
			url: 					url,
			handleAs:			"xml",
			preventCache: epages.constants.preventCache,
			load: 				callback,
			content:			formData
		});
		return;
	}
}

}

if(!dojo._hasResource['epages.io.translation']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.io.translation'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.io.translation $Revision: 1.29 $

*/
dojo.provide('epages.io.translation');




epages.io.Translation = function (/*String?*/ url, /*String?*/ locale) {
		this.translation = new epages.lang.Hash();
		this.loadedFiles = new epages.lang.Array();
		if( url !== undefined){
			if(locale===undefined){
				this.load(url);
			}else{
				this.loadLocale(url, (locale!="auto") ? locale : undefined);
			}
		}
};

dojo.extend(epages.io.Translation, epages.io.Xml.prototype);
dojo.extend(epages.io.Translation, {
	translation: null,
	loadedFiles: null,
	useLocale:	false,

	load: function (/*String*/ url, /*Boolean?*/ skipError) {
		if (this.loadedFiles.exists(url)){
			return true; // Boolean
		}
		if (skipError === undefined){
			skipError = false;
		}
		var urlData = this.loadSync(url);
		this.loadedFiles.push(url);
		if (urlData === undefined) {
			if (! skipError){
				throw new Error('translation undefined');
			}
			return false; //Boolean
		}
		var tags = urlData.getElementsByTagName('Translation');
		for( var i=0,iLength=tags.length ; i<iLength ; i++ ) {
			var thisElement = tags[i];
			// is translation
			if (thisElement.nodeType == 1) {
				// ignore <notrans>
				var data = '';
				for( var j=0,jLength=thisElement.childNodes.length ; j<jLength ; j++ ) {
					var child = thisElement.childNodes[j];
					data += child.nodeName.match(/notrans/i) ? child.firstChild.data : child.data;
				}
				this.translation.set(thisElement.getAttribute('Keyword'), data);
			}
		}
		return true; //Boolean
	},

	loadLocale: function (/*String*/ url, /*String?*/ locale) {
    // summary: load translation data (of language and locale), the locale will be trans
		// url: file name without locale and extension (.xml)
		// locale: locale string (RFC 3066; eg en-us)
		if (locale === undefined){
			locale = dojo.locale;
		}

		var locParts = locale.split('-');
		var loadLanguage = this.load(url + '.' + locParts[0] + '.xml', true);
		// load locale dependend translation, later
		if (this.useLocale && locParts.length > 1){
		  this.load(url + '.' + locParts[0] + '_' + locParts[1].toUpperCase() + '.xml', true);
		}
		return loadLanguage; //Boolean
	},

	exists: function (/*String*/key) {
		return this.translation.existsKey(key) || (this != epages.io.dictionary && epages.io.dictionary.translation.existsKey(key));
	},

	get: function (/*String*/ key, /*Object?*/vars) {
		// summary:
		//		returns the value of an specified language tag.
		//		returns {key} if the language tag doesnt exist.
		// example:
		//   | var translation = new epages.io.Translation();
		//   | translation.load('translation.de.xml');
		//   |   image       : 'test.png',
		//   |   description : 'long description, long description'
		//   | });
		//   | string = translation.get('Image');
		//   | // returns 'Bild'
		var locName = this.translation.get(key);
		if(locName === undefined && this != epages.io.dictionary){
			return epages.io.dictionary.get(key, vars);
		}
		return (locName === undefined) ? '{' + key + '}' : this.replaceVars(locName, vars); // String
	},

	replaceLanguageTags: function (/*String*/ txt) {
		// summary:
		//		replace all language tags in a string
		//		returns the "translated" string
		// example:
		// 	  var translation = new epages.io.Translation(translation.de.xml');
		// 		var mystring = "<div>{Image}</div>";
		// 		mystring=this.Translation.replaceLanguageTags(mystring);
		var templateRegExp = new RegExp('{(.*?)}', 'g');
		return txt.replace( templateRegExp, dojo.hitch(this, function(match, tag) {
			return this.get(tag);
		})); // String
	},

	replaceVars: function(/*String*/ txt, /*Object?*/ vars) {
	  var varsRegExp = new RegExp('#([a-zA-Z_][a-zA-Z0-9_]*)', 'g');
		return txt.replace( varsRegExp, dojo.hitch(vars, function(match, varName) {
		  return this[varName] !== undefined ? this[varName] : match;
		})); // String
	}

});

epages.io.dictionary = new epages.io.Translation(dojo.moduleUrl('epages', "translation"),"auto");

}

if(!dojo._hasResource["epages.html"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.html"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.html $Revision: 1.21 $

*/
dojo.provide("epages.html");


dojo.mixin(epages.html, {
	getChildNodesByTagName: function(/*XMLNode*/parentNode, /*String*/childTagName) {
		// summary:
		//  Returns an array of direct children matching the childTagName tag name.
		// description:
		//  Only direct children will be returned, so this differs from getElementsByTagName().
		// example:
		//  |/*
		//  |<ul>
		//  |  <li>node 1</li>
		//  |  <li>node 2</li>
		//  |</ul>
		//  |*/
		//  |listItems = epages.com.getChildNodesByTagName(listNode, "li");
		//  |// listItems has now two children
		var returnValue = [];
		for( var i=0,iLength=parentNode.childNodes.length ; i<iLength ; i++ ) {
			var e = parentNode.childNodes[i];
			if (e.nodeName == childTagName) {
				returnValue.push(e);
			}
		}
		return returnValue; // Array
	},

	getElementsByClassName: function (/*String*/className, /*DomNode*/domNode) {
		if(domNode == null){
			domNode = dojo.body();
		}
		return dojo.query("." + className, domNode);
	},

	replaceClass: function(/*DomNode|String*/node, /*String*/newClassStr, /*String*/ oldClassStr) {
	  var regEx = new RegExp("(^|\\s+)" + oldClassStr + "($|\\s+)", "g");
	  node.className = node.className.replace(regEx, "$1" + newClassStr + "$2");
	},

	removeChildren: function(/*DomNode|String*/node) {
		while(node.firstChild){ node.removeChild(node.firstChild); }
	},

	disableHrefsAndActions: function (/* DomNode */containerNode) {
		if(containerNode == null){
			containerNode = dojo.body();
		}

		// disable links
		var aTags = containerNode.getElementsByTagName('a');
		for( var i=0,iLength=aTags.length ; i<iLength ; i++ ) {
			var tag = aTags[i];
			if(tag.getAttribute("data-ep-preview") == "show") {break;}
			tag.style.cursor='default';
			if(typeof tag.getAttribute("onclick")=="string" && (tag.getAttribute("onclick") || "").match("openWindow")) {
				tag.onclick = function(){ return false; };
			}
			dojo.connect(tag, "onclick", function(evt) {
				dojo.stopEvent(evt);
				return;
			});
			// change href
			if(tag.getAttribute("href")){
				tag.removeAttribute("href");
			}
			// change target
			if(tag.getAttribute("target")){
				tag.removeAttribute("target");
			}
		}
		// disable all forms
		var formTags = containerNode.getElementsByTagName('form');
		for( var i=0,iLength=formTags.length ; i<iLength ; i++ ) {
			formTags[i].onsubmit = function() { return false; };
		}
		// disable all form elements
		var elementList = ['input', 'button', 'select', 'option', 'a'];
		var deleteAttributes = ['onchange','onclick','onselect','onkeyup','onkeypress','onmouseup'];
		for( var j=0,jLength=elementList.length ; j<jLength ; j++ ) {
			var inputTags = containerNode.getElementsByTagName(elementList[j]);
			for( var i=0,iLength=inputTags.length ; i<iLength ; i++ ) {
				var e = inputTags[i];
				if(e.getAttribute("data-ep-preview") == "show") {break;}
				//if (e.type == 'submit') e.type = 'button';
				for( var k=0,kLength=deleteAttributes.length ; k<kLength ; k++ ) {
					var attrib = e.getAttribute(deleteAttributes[k]);

					if(attrib) {
						if((typeof attrib == "string") || (typeof attrib == "function")) {
							dojo.connect(e, deleteAttributes[k], dojo, "stopEvent");
							e.setAttribute(deleteAttributes[k], 'return false;');
						}
					}
				}
			}
		}
	},

	getHref: function (/* DomNode<a>*/linkNode) {
		// returns: real (not transformed absolutely) href content of an A-tag-domNode
		if (linkNode.outerHTML) {
			// IE
			var html = linkNode.outerHTML;
			var href = html.match(/\s*href\s*\=\s*["'](.*?)["']/i);
			if(href && href[1]){
				return href[1];
			}
			return null;
		}
		// others
		return linkNode.getAttribute("href");
	},

	isInnerEvent: function(/* Event */evt, /* DOMNode | array.DOMNode */allowedNodes) {
		// summary: usefull for blur events, that could be triggered by clicking on another dom node
		// returns: whether the given event happened outside of the allowed nodes
		if (!dojo.isArray(allowedNodes)){
			allowedNodes = [ allowedNodes ];
		}
		var target = evt.explicitOriginalTarget;
		for( var i=0,iLength=allowedNodes.length ; i<iLength ; i++ ) {
			if (dojo.isDescendant(target, allowedNodes[i])){
				return true;
			}
		}
		return false;
	},

	encodeEntity: function(string, fixBreaks) {
		if (fixBreaks == null){
			fixBreaks = false;
		}
		var rx = new RegExp("\r?\n", "g");
		var lines = epages.string.split(string, rx);
		var textnode = document.createTextNode('');
		var node = document.createElement('span');
		node.appendChild(textnode);
		for( var i=0,iLength=lines.length ; i<iLength ; i++ ) {
			textnode.nodeValue = lines[i];
			lines[i] = node.innerHTML;
		}
		return lines.join(fixBreaks ? "<br/>\n" : "\n");
	},

	decodeEntity: function(string, fixBreaks) {
		if (fixBreaks == null){
			fixBreaks = false;
		}
		var node = document.createElement('span');
		node.innerHTML = string;
		var value = node.firstChild.nodeValue;
		if (fixBreaks){
			value = value.replace(/\<br\s*\/?\>\r?\n/gi, "\n");
		}
		return value;
	},

	insertAtCursor: function(myValue, fieldId, doc) {
		if (doc === undefined){
			doc = window.document;
		}
		var myField = $(fieldId, doc);
		//IE support
		if (doc.selection) {
			myField.focus();
			sel = doc.selection.createRange();
			sel.text = myValue;
		}
		//MOZILLA/NETSCAPE support
		else if (myField.selectionStart || myField.selectionStart == '0') {
			var startPos = myField.selectionStart;
			var endPos = myField.selectionEnd;
			myField.value = myField.value.substring(0, startPos)
				+ myValue
				+ myField.value.substring(endPos, myField.value.length);
			myField.selectionStart = startPos + myValue.length;
			myField.selectionEnd = startPos + myValue.length;
		} else {
			myField.value += myValue;
		}
		
		epages.event.fire(myField,'change');
	}
});


}

if(!dojo._hasResource['epages.html.element']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.html.element'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.html.element $Revision: 1.47 $

*/
dojo.provide('epages.html.element');



epages.html.Element = function (object) {
	//summary: epages.html.Element extends standard object with missing functions
	if (object === undefined) {
		throw new Error("epages.html.Element: initialize without object");
	} else if (typeof object == "string") {
		object = $(object);
		if (object === undefined){
			throw new Error("epages.html.Element: initialize without object, unknown element id");
		}
	}
	this.object = object;
};

dojo.extend(epages.html.Element, {
	object: undefined,

	get: function () {
		//summary: getter function for value of element with special treatment for radiobox & checkbox
		if((dojo.hasClass(this.object,"Radio")|| dojo.hasClass(this.object,"Checkbox"))  && !this.object.checked){
			return '';
		}
		return this.object.value || '';
	},

	set: function(value) {
		//summary: setter function for value of element with speacial treatment for radiobox & checkbox
		var type = this.object.type;
		switch (type) {
			case 'checkbox':
			case 'radio':
				var items = this.object.form.elements;
				var name = this.object.name;
				dojo.forEach(items, function(object) {
					if (object.type == type && object.name == name && object.value == value){
						object.checked = true;
					}
				});
				break;
			default:
				this.object.value = value;
				break;
		}
	},

	connectChangeEvent: function (callback) {
		//summary: connect onchange event to element but in case of element is radio use click event
		dojo.connect(this.object, (this.object.type == 'radio' ? "onclick" : "onchange"), callback);
	},

	callOnChange: function () {
		//summary: fire onchange event for the element
		epages.event.fire(this.object,'change');
	},

	firstElement: function (nodeType, nodeName) {
		var element = undefined;
		var data = this.object.childNodes;
		for(var counter = 0,l=data.length; counter < l && element === undefined; counter++) {
			// find element, if nodeType == 1 then nodeName has to be equal
			if (nodeType != 1               && data[counter].nodeType == nodeType ||
					data[counter].nodeType == 1 && data[counter].nodeName == nodeName) {
				element = data[counter];
			}
		}
		return (element);
	},

	firstComment: function () {
		var commentElement = this.firstElement(8, 'COMMENT');
		return (commentElement === undefined ? undefined : commentElement.data);
	},

	getIframeDocument: function (iframe) {
		if (iframe === undefined && this.object.tagName.toLowerCase() == 'iframe'){
			 iframe = this.object;
		}
		if (iframe === undefined){
			return iframe;
		}
		return (iframe.contentDocument === undefined) ? iframe.contentWindow.document : iframe.contentDocument;
	},

	addClassName: function (/*string*/className) {
		dojo.addClass(this.object, className);
	},

	removeClassName: function (/*string*/className) {
		dojo.removeClass(this.object, className);
	},

	changeClassName: function (/*string*/fromClassName, /*string*/toClassName) {
	  epages.html.replaceClass(this.object, toClassName, fromClassName);
	},

	getAbsolutePosition: function(baseNode) {
	// summary: get absolute position to base node
		var doc = this.object.documentOwner || document,
			ret = dojo.coords(this.object);
		if( baseNode ){
			var base = dojo.coords(baseNode);
			ret.x -= base.x;
			ret.y -= base.y;
		}

		// EPG-18400
		//if(epages.Browser.engine != "WebKit"){
			ret.x += doc.body.scrollLeft;
			ret.y += doc.body.scrollTop;
		//}
		return ret;
	},

	getPositionToParent: function(parentNode) {
		// summary: calcualte position to the specified parent node
		// parentNode: should be an offsetParent (position: absolute or relative)
		var node = this.object;
		var x = 0, y = 0;
		var position = dojo.getComputedStyle(parentNode).position;
		if(position != "relative" && position != "absolute") {
			console.warn("parentNode should be an offsetParent (position: absolute or relative) in "+ this.delcaredClass);
		}
		var lastOffsetParent = undefined;
		while (node != undefined && parentNode !== node) {
			if(lastOffsetParent !== node.offsetParent) {			// skip offset values which are already added (jump from offsetparent to offsetparent)
				if (node.offsetLeft !== undefined && node.offsetTop !== undefined) {
					x += node.offsetLeft;
					y += node.offsetTop;
				}
				lastOffsetParent = node.offsetParent;
			}
			node = node.parentNode;
		}
		return {'x': x, 'y': y};
	},

	getRelativePosition: function() {
		// summary: calcualte position to the next parentnode with position relative|absolute
		var node = this.object;
		var x = 0, y = 0;
		var position = dojo.getComputedStyle(node).position;
		while (node != undefined && position != "relative" && position != "absolute") {
			if (node.offsetLeft !== undefined && node.offsetTop !== undefined) {
				x += node.offsetLeft;
				y += node.offsetTop;
			}
			node = node.offsetParent;
			position = dojo.getComputedStyle(node).position;
		}
		return {'x': x, 'y': y};
	},

	setCss: function(/*Object*/attributes) {
		for (var attributeName in attributes) {
			this.object.style[attributeName] = attributes[attributeName];
		}
	},

	makeWidgets: function() {
		dojo.parser.parse(this.object);
	},

	toQueryString: function() {
		return encodeURIComponent(this.object.name) + '=' + encodeURIComponent(this.get());
	},

	addEventListener: function(/*String*/eventName, /*function*/callBack, /*boolean?false*/bubbleUp) {
		// summary: cross-browser implementation of node.addEventListener from Mozilla
		if (bubbleUp == null){
			bubbleUp = false;
		}
		eventName = eventName.replace(/^on/, '');
		if (this.object.addEventListener) {
			return this.object.addEventListener(eventName, callBack, bubbleUp);
		} else if(this.object.attachEvent) {
			return this.object.attachEvent('on' + eventName, callBack);
		}
		throw new Error('element.addEventListener: could not add event listener for event ' + eventName);
	},

	removeEventListener: function(/*String*/eventName, /*function*/callBack, /*boolean?false*/bubbleUp) {
		//summary: cross-browser implementation of node.removeEventListener from Mozilla
		if (bubbleUp == null){
			bubbleUp = false;
		}
		eventName = eventName.replace(/^on/, '');
		if (this.object.removeEventListener) {
			return this.object.removeEventListener(eventName, callBack, bubbleUp);
		} else if(this.object.detachEvent) {
			return this.object.detachEvent('on' + eventName, callBack);
		}
		console.warn('element.removeEventListener: could not remove event listener for event ' + eventName + (typeof this.object.detachEvent));
		return false;
	},

	replaceChild: function(newNode, oldNode) {
		newNode = this._changeNodeDocument(newNode, oldNode.ownerDocument);
		this.object.replaceChild(newNode, oldNode);
	},

	appendChild: function(childNode) {
		childNode = this._changeNodeDocument(childNode, this.object.ownerDocument);
		this.object.appendChild(childNode);
	},

	_changeNodeDocument: function(node, newDoc) {
		// summary: in IE you can not insert a node in a document, that has been created in another document
		// so we simply clone the node in correct document by inserting its outer HTML
		if (node.ownerDocument != newDoc && node.outerHTML != null) {
			var nodeHtml = node.outerHTML;
			node = newDoc.createElement('span');
			node.outerHTML = nodeHtml;
		}
		return node;
	},


	getLabel: function() {
		// summary: this.object needs an id and there has to exist a label node for this id
		// returns: assigned label for this node
		var id = this.object.id;
		if (id == null){
			 return;
		}
		var labels = this.object.ownerDocument.getElementsByTagName('label');
		for( var i=0,iLength=labels.length ; i<iLength ; i++ ) {
			if (labels[i].htmlFor == id){
				return labels[i].innerHTML;
			}
		}
	},

	isEmpty: function(){
		//summary: check if object has methodes or properties assigned
		for(var el in this.object){
			return false;
		}
		return true;
	}
});

$E = function (/*Object*/object) {
	return new epages.html.Element(object); // epages.html.Element
};

}

if(!dojo._hasResource["epages.widget.LocalizedWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.LocalizedWidget"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.widget.LocalizedWidget $Revision: 1.21 $
*/
dojo.provide("epages.widget.LocalizedWidget");





dojo.declare("epages.widget.LocalizedWidget", [epages.widget.TypedWidget], {
	// summary:Base class for all widgets which use an additional translation file
	
	// all LocalizedWidgets share the same translation object
	translation: 			new epages.io.Translation(),
	translationName: 	null,

	constructor: function() {
		this.translation.loadLocale(this.getTranslationName());
	},

	translate: function(/*String*/key, /*Object?*/vars) {
		return this.translation.get(key, vars);
	},

	getTranslationName: function () {
		// summary: return the translation file name (without locale and .xml)
		// description: convert this.templatePath to this.translationName of translation name is null
		// example:
		//   | dojo.declare(
		//   |   "epages.cartridges.de_epages.design.Toolcollection",
		//   |   [epages.widget.LocalizedWidget], {
		//   |     widgetType  : "Toolcollection",
		//   |     templatePath: dojo.uri.dojoUri("../epages/cartridges/de_epages/design/widget/Toolcollection/Toolcollection.html"),
		//   |     translationName: dojo.uri.dojoUri("../epages/cartridges/de_epages/design/widget/templates/translation"),
		//   |     widgetsInTemplate : true
		//   | });
		// returns: translationName
		if (this.translationName == null){
			this.translationName = this.templatePath.toString().replace('.html','');
		}
		return this.translationName; //String
	},

	createNodesFromText:  function(/*String*/text){
		return dojo._toDom(this.translation.replaceLanguageTags(text));
	},


	buildRendering: function(){
		// summary:
		//    Construct the UI for this widget from a template, setting this.domNode.
    // description: 
		//    Lookup cached version of template, and download to cache if it
		//    isn't there already.  Returns either a DomNode or a string, depending on
		//    whether or not the template contains ${foo} replacement parameters.
		this._attachPoints = [];
		var cached = this.getCachedTemplate(this.templatePath, this.templateString, this._skipNodeCache, this.translation);


		var node;
		if(dojo.isString(cached)){
//##### START of epages changes #####
			var className = this.declaredClass, _this = this;
			// Cache contains a string because we need to do property replacement
			// do the property replacement
			var tstr = dojo.string.substitute(cached, this, function(value, key){
				if(key.charAt(0) == '!'){ value = _this[key.substr(1)]; }
				if(typeof value == "undefined"){ throw new Error(className+" template:"+key); } // a debugging aide
				if(!value){ return ""; }

				// Substitution keys beginning with ! will skip the transform step,
				// in case a user wishes to insert unescaped markup, e.g. ${!foo}
				return key.charAt(0) == "!" ? value :
					// Safer substitution, see heading "Attribute values" in
					// http://www.w3.org/TR/REC-html40/appendix/notes.html#h-B.3.2
					value.toString().replace(/"/g,"&quot;"); //TODO: add &amp? use encodeXML method?
			}, this);
			node = this.createNodesFromText(tstr);

//##### END of epages changes #####
		}else{
			// if it's a node, all we have to do is clone it
			node = cached.cloneNode(true);
		}

		this.domNode = node;

		// recurse through the node, looking for, and attaching to, our
		// attachment points which should be defined on the template node.
		this._attachTemplateNodes(node);

				if(this.widgetsInTemplate){
				// Make sure dojoType is used for parsing widgets in template.
				// The dojo.parser.query could be changed from multiversion support.
				var parser = dojo.parser, qry, attr;
				if(parser._query != "[dojoType]"){
					qry = parser._query;
					attr = parser._attrName;
					parser._query = "[dojoType]";
					parser._attrName = "dojoType";
				}

				// Store widgets that we need to start at a later point in time
				var cw = (this._startupWidgets = dojo.parser.parse(node, {
					noStart: !this._earlyTemplatedStartup
				}));

				// Restore the query.
				if(qry){
					parser._query = qry;
					parser._attrName = attr;
				}

				this._supportingWidgets = dijit.findWidgets(node);

				this._attachTemplateNodes(cw, function(n,p){
					return n[p];
				});
			}

		this._fillContent(this.srcNodeRef);
	},

	getCachedTemplate: function(templatePath, templateString, alwaysUseString, translation){
		// summary:
		//    static method to get a template based on the templatePath or
		//    templateString key
		// templatePath: String
		//    the URL to get the template from. dojo.uri.Uri is often passed as well.
		// templateString: String?
		//    a string to use in lieu of fetching the template from a URL
		// returns:
		//  Either string (if there are ${} variables that need to be replaced) or just
		//  a DOM tree (if the node can be cloned directly)

		// is it already cached?
		var tmplts = dijit._Templated._templateCache;
		var key = templateString || templatePath;
		var cached = tmplts[key];
		if(cached){
			return cached;
		}

		// If necessary, load template string from template path
		if(!templateString){
			templateString =dojo.cache(templatePath, {sanitize: true});
		}

		templateString = dojo.string.trim(templateString);
		if(templateString.match(/\$\{([^\}]+)\}/g) || alwaysUseString){
			// there are variables in the template so all we can do is cache the string
			return (tmplts[key] = templateString); //String
		}else{
			// there are no variables in the template so we can cache the DOM tree
			return (tmplts[key] = this.createNodesFromText(templateString)); //Node
		}
	}

});

}

if(!dojo._hasResource["epages.event.interval"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.event.interval"] = true;
dojo.provide("epages.event.interval");

epages.event.interval = {
	// summary: cross browser function to set intervals
	// description: cross browser function to set intervals without using the built in function "setInterval" (which can cause serious timing problems).
	// set: set an interval (e.g.: var myinterval = epages.event.interval.set(function(){alert("test")}, 1000);
	// clear: clear the given interval (e.g.: epages.event.interval.clear(myinterval));
	
	_container: [],
	_setIntervalSecure: function(/* string */intervalId, /* function */task, /* uinteger */delay) {
		if(this._container[intervalId] != null) {
			setTimeout(dojo.hitch(this, function(){this._setIntervalSecure(intervalId, task, delay)}), delay);
			task();
		}
	},
	
	set: function(/* function */task, /* uinteger */delay) {
		var intervalId = this._container.length;
		this._container.push(intervalId);
		setTimeout(dojo.hitch(this, function(){this._setIntervalSecure(intervalId, task, delay)}), delay);
		return intervalId;
	},
	
	clear: function(/* string */intervalId) {
		this._container[intervalId] = null;
	}
	
};

}

if(!dojo._hasResource['epages.widget.Slides']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.widget.Slides'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.widget.Slides $Revision: 1.55 $

*/
dojo.provide('epages.widget.Slides');







dojo.declare("epages.widget.Slides", [epages.widget.LocalizedWidget], {
	templateString:"<div class=\"SlideShow\">\n  <div class=\"SlideshowContainer\">\n    <div class=\"MainContainer\" dojoAttachPoint=\"mainNode\">\n      <div class=\"DescriptionContainer\" dojoAttachPoint=\"descriptionNode\"></div>\n      <div class=\"MiscContainer\" dojoAttachPoint=\"miscNode\">\n        <div class=\"MiscClipper\" dojoAttachPoint=\"miscNodeClipper\">\n          <div class=\"Counter\" dojoAttachPoint=\"countNode\"></div>\n          <div class=\"Date\" dojoAttachPoint=\"dateNode\"></div>\n        </div>\n      </div>\n      <div class=\"ImageContainer\">\n        <div class=\"ImageAligner\">\n          <table class=\"ImageTableTemplate\" dojoAttachPoint=\"imageTable\"><tr><td style=\"text-align:center;\">\n            <b></b>\n          </td></tr></table>\n        </div>\n      </div>\n      <div class=\"ControlContainer\">\n        <div class=\"ControlBar\" dojoAttachPoint=\"controlNode\"></div>\n      </div>\n    </div>\n  </div>\n</div>\n",
	imagePath:          epages.themeUrl('images'),
	translationName:    dojo.moduleUrl("epages.widget", "templates/translation"),
	loaderImagePath:    epages.themeUrl('images') + "/img_busy.gif",
	errorImagePath:     epages.themeUrl('images') + "/slideshow_img_broken_image.png",

	controlBarImages: [
		[epages.themeUrl('images') + "/slideshow_img_bg.png", epages.themeUrl('images') + "/slideshow_img_bg_small.png", epages.themeUrl('images') + "/slideshow_img_bg_smaller.png"],
		[epages.themeUrl('images') + "/slideshow_ico_l_rewind.png", epages.themeUrl('images') + "/slideshow_ico_s_rewind.png"],
		[epages.themeUrl('images') + "/slideshow_ico_l_pause.png", epages.themeUrl('images') + "/slideshow_ico_s_pause.png"],
		[epages.themeUrl('images') + "/slideshow_ico_l_play.png", epages.themeUrl('images') + "/slideshow_ico_s_play.png"],
		[epages.themeUrl('images') + "/slideshow_ico_l_overview.png", epages.themeUrl('images') + "/slideshow_ico_s_overview.png"],
		[epages.themeUrl('images') + "/slideshow_ico_l_details.png", epages.themeUrl('images') + "/slideshow_ico_s_details.png"],
		[epages.themeUrl('images') + "/slideshow_ico_l_forward.png", epages.themeUrl('images') + "/slideshow_ico_s_forward.png"]
										],

	delay:                 3500,
	protraction:           1200,
	imageWidth:            "450px",
	imageHeight:           "300px",
	tiny:                  false,
	stopped:               false,
	overview:              true,				// flag: enable / disable detailed (large) view
	imageClickOverview:    true,
	showName:              true,
	showDescription:       true,
	showControls:          true,
	showMisc:              true,
	showIndex:             0,

	_images:               undefined,
	_oldShowIndex:         0,
	_loadedIndex:          0,
	_loadedImages:         0,
	_pauseIcon:            0,
	_playIcon:             0,
	_fadeEasing:           dojo.fx.easing.quadOut,
	_overviewArea:         null,
	_overviewBackground:   null,
	_overviewImageCounter: null,
	_controlBarFadeOut:    null,
	_playerBeacon:         null,
	_hiddenDetails:        false,
	_changingImage:        true,
	_globalOverview:       true,
	_reAlignReady:         true,

	_delayExec: function(task, delay) {
		return setTimeout(dojo.hitch(this, task), delay);
	},

	_getAlphaImage: function (imageSrc, sizing) {

		var imageContainer = document.createElement("span");
		var imageHolder = document.createElement("span");

		var filterClassString = "";
		if(epages.Browser.engine == "MSIE" && imageSrc.match(".png")) {
			sizing = sizing ? "scale" : "crop";
			filterClassString = "class='AlphaImage'";
			imageHolder.style.zoom = "1";
			imageHolder.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + imageSrc + "', sizingMethod='" + sizing + "')";
		}

		var image = "<img " + filterClassString + " alt='' src='" + imageSrc + "' onerror=''/>";

		imageHolder.innerHTML = image;
		imageContainer.appendChild(imageHolder);
		imageContainer.className = "Image";

		return imageContainer;
	},

	_drawControlBar: function() {

		if(this.tiny) {
			this.controlNode.className = "ControlBarMini";
		}
		if(!this.showControls) {
			this.controlNode.style.display = "none";
		}

		var backgroundImageIndex = 0;
		if(!this.overview || !this.showDescription) {
			backgroundImageIndex = 1;
		}else if(!this.overview && !this.showDescription) {
			backgroundImageIndex = 2;
		}

		var controlBarBg = this.tiny ? document.createElement("div") : this._getAlphaImage(this.controlBarImages[0][backgroundImageIndex]);
		controlBarBg.className = "ControlBarBg";
		this.controlNode.appendChild(controlBarBg);

		if(!this.overview && this.showControls) {
			controlBarBg.parentNode.style.width = (controlBarBg.offsetWidth - (this.tiny ? 16 : 32)) + "px";
		}
		if(!this.showDescription && this.showControls) {
			controlBarBg.parentNode.style.width = (controlBarBg.offsetWidth - (this.tiny ? 16 : 32)) + "px";
		}

		var rewindIcon = this._getAlphaImage(this.controlBarImages[1][this.tiny ? 1 : 0]);
		rewindIcon.className = "SlideshowButton";
		this.controlNode.appendChild(rewindIcon);
		this.connect(rewindIcon, "onclick", "_rewindClick");

		var pauseIcon = this._getAlphaImage(this.controlBarImages[2][this.tiny ? 1 : 0]);
		pauseIcon.className = "SlideshowButton";
		if(this.stopped) {pauseIcon.style.position = "absolute";pauseIcon.style.visibility = "hidden";}
		this.controlNode.appendChild(pauseIcon);
		this.connect(pauseIcon, "onclick", "_pauseClick");
		this._pauseIcon = pauseIcon;

		var playIcon = this._getAlphaImage(this.controlBarImages[3][this.tiny ? 1 : 0]);
		playIcon.className = "SlideshowButton";
		if(!this.stopped) {playIcon.style.position = "absolute";playIcon.style.visibility = "hidden";}
		this.controlNode.appendChild(playIcon);
		this.connect(playIcon, "onclick", "_playClick");
		this._playIcon = playIcon;

		if(this.overview) {
			var overviewIcon = this._getAlphaImage(this.controlBarImages[4][this.tiny ? 1 : 0]);
			overviewIcon.className = "SlideshowButton";
			this.controlNode.appendChild(overviewIcon);
			this.connect(overviewIcon, "onclick", "_overviewClick");
		}

		if(this.showDescription) {
			var detailsIcon = this._getAlphaImage(this.controlBarImages[5][this.tiny ? 1 : 0]);
			detailsIcon.className = "SlideshowButton";
			this.controlNode.appendChild(detailsIcon);
			this.connect(detailsIcon, "onclick", "_detailsClick");
		}

		var forwardIcon = this._getAlphaImage(this.controlBarImages[6][this.tiny ? 1 : 0]);
		forwardIcon.className = "SlideshowButton";
		this.controlNode.appendChild(forwardIcon);
		this.connect(forwardIcon, "onclick", "_forwardClick");

		dojo.style(this.controlNode, "opacity", 0);

		return [rewindIcon, playIcon, pauseIcon, overviewIcon ? overviewIcon : null, detailsIcon ? detailsIcon : null, forwardIcon];
	},

	_controlBarButtonOver: function(eventObject) {
		dojo.addClass(eventObject.currentTarget, "Highlighted");
		document.onselectstart = function() { return false; };
	},

	_controlBarButtonOut: function(eventObject) {
		dojo.removeClass(eventObject.currentTarget, "Highlighted");
		dojo.removeClass(eventObject.currentTarget, "Hit");
		document.onselectstart = function() { return true; };
	},

	_controlBarButtonDown: function(eventObject) {
		dojo.addClass(eventObject.currentTarget, "Hit");
	},

	_controlBarButtonUp: function(eventObject) {
		dojo.removeClass(eventObject.currentTarget, "Hit");
	},

	_showControlBar: function() {
		clearTimeout(this._controlBarFadeOut);
		dojo.fadeIn({node: this.controlNode, duration:350, easing: this._fadeEasing}).play();
	},

	_hideControlBar: function() {
		this._controlBarFadeOut = this._delayExec(function() {
			if(this.controlNode.offsetWidth == 0) {
				dojo.style(this.controlNode, "opacity", 0);
			}else{
				dojo.fadeOut({node: this.controlNode, duration:350}).play();
			}
		}, 1000);
	},

	_drawErrorImage: function(eventObject) {
		var imgNode = eventObject.currentTarget;
		imgNode.src = this.errorImagePath;
		imgNode.parentNode.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + this.errorImagePath + "', sizingMethod='scale')";
	},

	_playClickStartTimer: function() {
		this._playIcon.style.position = "absolute";
		this._playIcon.style.visibility = "hidden";
		this._pauseIcon.style.position = "relative";
		this._pauseIcon.style.visibility = "visible";
		this._playerBeacon = epages.event.interval.set(dojo.hitch(this, this._setNextImage), this.delay);
	},

	_playClick: function() {
		this._setNextImage();
		this._playClickStartTimer();
	},

	_pauseClick: function() {
		this._pauseIcon.style.position = "absolute";
		this._pauseIcon.style.visibility = "hidden";
		this._playIcon.style.position = "relative";
		this._playIcon.style.visibility = "visible";
		epages.event.interval.clear(this._playerBeacon);
	},

	_overviewClick: function(image) {
		/* we don't want any mouse events in here */
		if(typeof(image) == "object") {
			image = null;
		}

		this._pauseClick();

		if(!this._overviewArea) {
			var overviewBackground = document.createElement("div");
			overviewBackground.className = "OverviewBackground";
			dojo.style(overviewBackground, "opacity", 0);

			dojo.addClass(dojo.body(), "OverviewAreaVisible");

			overviewBackground.innerHTML = "<div class='Background'></div>";

			var overviewArea = document.createElement("div");
			overviewArea.className = "OverviewArea";

			var info = this._images[this.showIndex];

			if(!info) {
				info = {};
				info.imageTable = this._createImageTable();
				info.imageTable.getElementsByTagName("b")[0].appendChild(this._getAlphaImage(epages.themeUrl('images') + "/plain.gif"));
				this._images.push(info);
			}else {
				this._oldShowIndex = this.showIndex;
			}

			var infoTable = this._images[this.showIndex].imageTable.cloneNode(true);

			var bNode = infoTable.getElementsByTagName("b")[0];
			bNode.innerHTML = "";
			bNode.appendChild(this._getAlphaImage(epages.themeUrl('images') + "/plain.gif"));

			overviewArea.appendChild(infoTable);

			var backgroundEventLayer = document.createElement("div");
			backgroundEventLayer.className = "BackgroundEventLayer";
			overviewArea.getElementsByTagName("td")[0].appendChild(backgroundEventLayer);

			var rewindIcon = this._getAlphaImage(epages.themeUrl("images") + "/slideshow_ico_l_rewind_overview.png");
			rewindIcon.className = "Image SlideshowButton";
			this.connect(rewindIcon, "onclick", "_setPrevImage");
			this.connect(rewindIcon, "onmouseover", "_controlBarButtonOver");
			this.connect(rewindIcon, "onmouseout", "_controlBarButtonOut");
			this.connect(rewindIcon, "onmousedown", "_controlBarButtonDown");
			this.connect(rewindIcon, "onmouseup", "_controlBarButtonUp");
			var rewindIconContainer = document.createElement("i");
			rewindIconContainer.appendChild(rewindIcon);
			rewindIconContainer.className = "OverviewRewindButton";

			var forwardIcon = this._getAlphaImage(epages.themeUrl("images") + "/slideshow_ico_l_forward_overview.png");
			forwardIcon.className = "Image SlideshowButton";
			this.connect(forwardIcon, "onclick", "_setNextImage");
			this.connect(forwardIcon, "onmouseover", "_controlBarButtonOver");
			this.connect(forwardIcon, "onmouseout", "_controlBarButtonOut");
			this.connect(forwardIcon, "onmousedown", "_controlBarButtonDown");
			this.connect(forwardIcon, "onmouseup", "_controlBarButtonUp");
			var forwardIconContainer = document.createElement("i");
			forwardIconContainer.appendChild(forwardIcon);
			forwardIconContainer.className = "OverviewForwardButton";

			var closeIcon = this._getAlphaImage(epages.themeUrl("images") + "/layer_img_closebutton.png");
			closeIcon.className = "Image SlideshowButton";
			closeIcon.style.clip = "rect(0, 40px, 20px, 0)";
			this.connect(closeIcon, "onclick", "_destroyOverview");
			this.connect(closeIcon, "onmouseover", "_controlBarButtonOver");
			this.connect(closeIcon, "onmouseout", "_controlBarButtonOut");
			var closeIconContainer = document.createElement("i");
			closeIconContainer.appendChild(closeIcon);
			closeIconContainer.className = "OverviewCloseButton";

			var overviewImageCounter = document.createElement("b");
			overviewImageCounter.className = "OverviewImageCounter";
			if(!this.showMisc) {
				overviewImageCounter.style.display = "none";
			}

			dojo.style(overviewArea, "background", "url(" + this.loaderImagePath + ") center no-repeat");
			dojo.style(overviewArea.getElementsByTagName("span")[0], "opacity", 0);

			var overviewImageSrc = info.imageLarge ? info.imageLarge : info.image;
			var overviewImage = overviewArea.getElementsByTagName("img")[0];
			overviewImage.src = image || overviewImageSrc;
			overviewImage.style.height = "auto";
			overviewImage.style.width = "auto";
			if(overviewImage.src.match(".ico") || overviewImage.src.match(".cur")) {
				overviewImage.parentNode.style.filter = "fade()";
			}else {
				//overviewImage.style.filter = "alpha(opacity=0)";
				//overviewImage.parentNode.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + overviewImage.src + "', sizingMethod='scale')";
			}
			dojo.body().appendChild(overviewBackground);
			dojo.body().appendChild(overviewArea);

			var imageLargeDuplicated = true;
			var prevImage = this._images[0];

			for( var i=0,iLength=this._images.length ; i<iLength ; i++ ) {
				if(this._images[i].imageLarge != prevImage.imageLarge) {
					imageLargeDuplicated = false;
					break;
				}else {
					prevImage = this._images[i];
				}
			}

			if(this._images.length > 1 && !image && !imageLargeDuplicated) {
				if(this.showControls) {
					overviewArea.getElementsByTagName("span")[1].appendChild(rewindIconContainer);
					overviewArea.getElementsByTagName("span")[1].appendChild(forwardIconContainer);
				}
				overviewArea.getElementsByTagName("span")[1].appendChild(overviewImageCounter);
			}
			overviewArea.getElementsByTagName("span")[1].appendChild(closeIconContainer);

			// hack to fetch image load event. the image has to be loaded to access
			// its dimensions for calculating the resulting dimensions in relation
			// to the browser window size.
			var loadImageInstance = new Image();
			loadImageInstance.onload = dojo.hitch(this, function() {
				this._delayExec(this._drawOverviewImage, 1);
			});
			loadImageInstance.src = image || overviewImageSrc;

			this.connect(overviewImage, "onerror", "_drawErrorImage");
			this.connect(backgroundEventLayer, "onclick", "_destroyOverview");

			overviewBackground.style.zoom = 1;
			dojo.style(overviewBackground, "opacity", 1);

			this._overviewBackground = overviewBackground;
			this._overviewArea = overviewArea;
			this._overviewImageCounter = overviewImageCounter;

			this._changeOverviewDimensions();

		}
	},

	_changeOverviewDimensions: function() {
		if(this._overviewArea != null) {

			var overviewImage = this._overviewArea.getElementsByTagName("img")[0];
			var windowHeight = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight;
			var windowWidth = window.innerWidth ? window.innerWidth : document.documentElement.clientWidth;

			var currentHeight = 0;

			if(windowHeight > dojo.body().offsetHeight + 10) {
				currentHeight = windowHeight;
			}else{
				currentHeight = dojo.body().offsetHeight + 10;
			}
			this._overviewBackground.style.height = currentHeight + "px";
			this._overviewArea.style.height = windowHeight + "px";

			setTimeout(dojo.hitch(this, function() {
				var absoluteWidth = this._images[this.showIndex]._overviewWidth;
				var absoluteHeight = this._images[this.showIndex]._overviewHeight;

				if(absoluteWidth && absoluteHeight && (absoluteWidth > windowWidth - 50 || absoluteHeight > windowHeight - 50)) {
					if((windowWidth / windowHeight) / (absoluteWidth / absoluteHeight) > 1) {
						overviewImage.style.height = (windowHeight - 50) + "px";
						overviewImage.style.width = "auto";
					}else {
						overviewImage.style.width = (windowWidth - 50) + "px";
						overviewImage.style.height = "auto";
					}
				}
				this._reAlignOverview();
			}), 1);

		}
	},

	_reAlignOverview: function() {
		if(this._overviewArea != null && this._reAlignReady) {
			this._reAlignReady = false;
			this._delayExec(function(){
				if(this._overviewArea != null) {
					var scrollAmount = dojo.body().pageYOffset ? dojo.body().pageYOffset : document.documentElement.scrollTop;
					dojo.fx.slideTo({
						node: this._overviewArea,
						top: scrollAmount,
						duration: 350,
						easing: this._fadeEasing
					}).play();
				}
				this._reAlignReady = true;
			}, 50);
		}
	},

	_detailsClick: function() {
		if(this._hiddenDetails) {
			this._hiddenDetails = false;
			this.descriptionNode.style.visibility = "visible";
			this.miscNode.style.visibility = "visible";
		}else{
			this._hiddenDetails = true;
			this.descriptionNode.style.visibility = "hidden";
			this.miscNode.style.visibility = "hidden";
		}
	},

	_forwardClick: function() {
		this._pauseClick();
		this._setNextImage();
	},

	_rewindClick: function() {
		this._pauseClick();
		this._setPrevImage();
	},

	_drawOverviewImage: function() {
		this._delayExec(function() {
			var overviewImage = this._overviewArea.getElementsByTagName("img")[0];

			if(!this._images[this.showIndex]._overviewWidth) {
				overviewImage.style.position = "absolute";
				this._images[this.showIndex]._overviewWidth = overviewImage.width;
				this._images[this.showIndex]._overviewHeight = overviewImage.height;
				overviewImage.style.position = "static";
			}

			if(this._images[this.showIndex]._overviewHeight < 100) {
				overviewImage.style.marginTop = (45 - this._images[this.showIndex]._overviewHeight / 2) + "px";
			}else{
				overviewImage.style.marginTop = "0";
			}

			this._changeOverviewDimensions();

			this._overviewImageCounter.innerHTML = (this.showIndex + 1) + " | " + this._images.length;

			this._overviewArea.getElementsByTagName("b")[0].style.visibility = "visible";
			dojo.style(this._overviewArea.getElementsByTagName("b")[0], "opacity", "1");
			dojo.style(this._overviewArea, "background", "");
			dojo.fadeIn({node: this._overviewArea.getElementsByTagName("span")[0], duration: this.protraction, easing: this._fadeEasing}).play();

		}, 400);
	},

	_destroyOverview: function() {
		if(this._overviewArea) {
			if(dojo.style(this._overviewArea.getElementsByTagName("span")[0], "opacity") > 0.5) {
				dojo.fadeOut({node: this._overviewArea, duration: this.protraction / 2, easing: this._fadeEasing}).play();
				this._delayExec(function() {
					if(this._overviewArea) {
						dojo.body().removeChild(this._overviewArea);
						dojo.body().removeChild(this._overviewBackground);
						delete this._overviewArea;
						delete this._overviewBackground;
						this.showIndex = this._oldShowIndex;
						delete this._oldShowIndex;

						dojo.removeClass(dojo.body(), "OverviewAreaVisible");
					}
				}, this.protraction / 2.2);
			}
		}
	},

	_checkGlobalOverview: function() {
		var isPlainImage = this._images[this.showIndex].image.match("dijit/themes/epages/images/plain.gif") || this._images[this.showIndex].image.match("transparentpixel.gif");
		if(this._globalOverview && !isPlainImage){
			this._overviewClick();
		}
	},

	_showImageDetails: function() {

		var info = this._images[this.showIndex];
		this.descriptionNode.innerHTML = info.description;
		this.dateNode.innerHTML = info.date;
		this.countNode.innerHTML = (this.showIndex + 1) + " | " + (this._images.length);

		this.miscNode.style.top = this.miscNodeClipper.offsetHeight + "px";
		this.descriptionNode.style.top = "-" + this.descriptionNode.offsetHeight + "px";

		dojo.style(this.miscNode, "opacity", 0.8);
		dojo.style(this.descriptionNode, "opacity", 0.8);

		if(this.descriptionNode.innerHTML.length > 1) {
			dojo.fx.slideTo({node: this.descriptionNode, duration: 400, easing: this._fadeEasing}).play();
		}
		dojo.fx.slideTo({node: this.miscNode, duration: 400, easing: this._fadeEasing}).play();

	},

	_hideImageDetails: function() {
		dojo.fadeOut({node: this.miscNode, duration: 200, easing: this._fadeEasing}).play();
		dojo.fadeOut({node: this.descriptionNode, duration: 200, easing: this._fadeEasing}).play();
	},

	_setNextImage: function() {
		if(this._overviewArea) {
			if(dojo.style(this._overviewArea.getElementsByTagName("span")[0], "opacity") >= 0.5) {
				this._setImage(this.showIndex > this._images.length - 2 ? 0 : this.showIndex + 1);
			}
		}else{
			this._setImage(this.showIndex > this._images.length - 2 ? 0 : this.showIndex + 1);
		}
	},

	_setPrevImage: function() {
		if(this._overviewArea) {
			if(dojo.style(this._overviewArea.getElementsByTagName("span")[0], "opacity") >= 0.5) {
				this._setImage(this.showIndex == 0 ? this._images.length - 1 : this.showIndex - 1);
			}
		}else{
			this._setImage(this.showIndex == 0 ? this._images.length - 1 : this.showIndex - 1);
		}
	},

	_setImage: function(imageIndex) {
		if(this._images[imageIndex]) {
			if(this._overviewArea) {
				if(!this._oldShowIndex) {
					this._oldShowIndex = this.showIndex;
				}

				var overviewImageContainer = this._overviewArea.getElementsByTagName("span")[0];
				var overviewImage = overviewImageContainer.getElementsByTagName("img")[0];

				dojo.style(this._overviewArea, "background", "url(" + this.loaderImagePath + ") center no-repeat");
				dojo.fadeOut({node: overviewImageContainer, duration: this.protraction, easing: this._fadeEasing}).play();

				this._delayExec(function() {
					var info = this._images[this.showIndex];
					dojo.style(overviewImageContainer, "opacity", 0);
					var overviewImageSrc = info.imageLarge || info.image;
					var overviewImage = this._overviewArea.getElementsByTagName("img")[0];
					overviewImage.src = overviewImageSrc;
					overviewImage.style.width = "auto";
					overviewImage.style.height = "auto";
					//overviewImage.style.filter = "alpha(opacity=0)";
					//overviewImage.parentNode.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + overviewImageSrc + "', sizingMethod='crop')";

					// hack to fetch image load event
					var test = new Image();
					test.onload = dojo.hitch(this, function() {
						this._delayExec(this._drawOverviewImage, 1);
					});
					test.src = overviewImageSrc;
				}, this.protraction);

			}else {
				var oldContainer = this._images[this.showIndex].imageTable.getElementsByTagName("b")[0];
				var newContainer = this._images[imageIndex].imageTable.getElementsByTagName("b")[0];

				//be sure that the slideshow stops fading when it is not visible (display:none)
				if(oldContainer.offsetWidth == 0) {
					this._pauseClick();
				}else{
					var newImage = newContainer.getElementsByTagName("img")[0];
					if(typeof(newImage) == "undefined") {
						newContainer.appendChild(this._getAlphaImage(this._images[imageIndex].image, true));
						newImage = newContainer.getElementsByTagName("img")[0];
					}
					if(typeof(newImage) != "undefined") {
						if(this._images[imageIndex].fit == "true" || this._images[imageIndex].fit == true) {
							if(newImage.offsetHeight > newImage.offsetWidth) {
								newImage.style.height = (this.mainNode.offsetHeight) + "px";
								if(newImage.offsetWidth >= this.mainNode.offsetWidth) {
									newImage.style.height = "auto";
									newImage.style.width = (this.mainNode.offsetWidth) + "px";
								}
							}else{
								newImage.style.width = (this.mainNode.offsetWidth) + "px";
								if(newImage.offsetHeight >= this.mainNode.offsetHeight) {
									newImage.style.width = "auto";
									newImage.style.height = (this.mainNode.offsetHeight) + "px";
								}
							}
						}else if(this._images[imageIndex].fit == null) {
							this._delayExec(function() {
								if(newImage.offsetHeight > newImage.offsetWidth) {
									if(newImage.offsetHeight > this.mainNode.offsetHeight) {
										newImage.style.height = (this.mainNode.offsetHeight) + "px";
										newImage.style.width = "auto";
									}
								}else{
									if(newImage.offsetWidth > this.mainNode.offsetWidth) {
										newImage.style.width = (this.mainNode.offsetWidth) + "px";
										newImage.style.height = "auto";
									}
								}
							},1);
						}
					}

					if(this.showIndex != imageIndex) {
						dojo.fadeOut({node: oldContainer, duration: this.protraction, easing: this._fadeEasing}).play();
						this._delayExec(function(){
							this._fadeOutHide(oldContainer);
						}, this.protraction);
					}

					dojo.style(newContainer, "visibility", "visible");
					dojo.fadeIn({node: newContainer, duration: this.protraction, easing: this._fadeEasing}).play();

					this._hideImageDetails();
					this._delayExec(this._showImageDetails, this.protraction / 2);
					this._images[this.showIndex].imageTable.style.zIndex = 0;
					this._images[imageIndex].imageTable.style.zIndex = 1;
				}
			}
		}
		this.showIndex = imageIndex;
	},

	_fadeOutHide: function(domNode) {
		if(dojo.style(domNode, "opacity") == 0) {
			dojo.style(domNode, "visibility", "hidden");
		}
	},

	_loadImagesSoft: function() {
		dojo.disconnect(this._images[this._loadedIndex].onloadHandle);

		if(this._images[this._loadedIndex].imageToStage) {
			this._setImage(this._images[this._loadedIndex].imageToStage);
		}else if (this._loadedIndex == this.showIndex && this._overviewArea == null) {
			this._setImage(this.showIndex);
		}

		if(this._loadedImages < this._images.length) {
			this._delayExec(this._loadImages, 1000);
		}else{
			this.mainNode.style.background = "none";
		}
	},

	_loadImages: function() {
		this._loadedImages++;

		this._loadedIndex++;
		if(this._loadedIndex >= this._images.length){
			this._loadedIndex = 0;
		}

		var info = this._images[this._loadedIndex];
		var imageTable = info.imageTable;

		this.mainNode.style.background = "transparent url(" + this.loaderImagePath + ") center no-repeat";

		imageTable.style.zIndex = 0;

		var imageHolder = imageTable.getElementsByTagName("b")[0];
		imageHolder.style.zoom = "1";
		dojo.style(imageHolder, "opacity", 0);
		dojo.style(imageHolder, "visibility", "hidden");

		if(typeof(imageHolder.getElementsByTagName("img")[0]) == "undefined") {
			imageHolder.appendChild(this._getAlphaImage(info.image, true));
		}
		var image = imageHolder.getElementsByTagName("img")[0];
		this.connect(image, "onerror", "_drawErrorImage");

		// hack to fetch image load event
		var test = new Image();
		test.onload = dojo.hitch(this,'_loadImagesSoft');
		test.src = image.src;
	},

	_createImageTable: function() {
		var imageTable = this.imageTable.cloneNode(true);
		imageTable.className = "ImageTable";
		this.imageTable.parentNode.appendChild(imageTable);
		return imageTable;
	},

	_handleKeyEvent: function(evt) {
		evt = evt ? evt: window.event;
		switch (evt.which || evt.keyCode) {
			case 27:
				this._destroyOverview();
				break;
			case 37:
				this._setPrevImage();
				break;
			case 39:
				this._setNextImage();
				break;
		}
	},

	openOverview: function(image) {
		this._overviewClick(image);
	},

	setImage: function(imageIndex) {
		this._pauseClick();
		this._setImage(imageIndex);
	},

	setNextImage: function() {
		this._setNextImage();
	},

	setPrevImage: function() {
		this._setPrevImage();
	},

	addImage: function(insObject, setImage) {
		if(insObject.image) {
			var alreadyAddedIn;
			for( var i=0,iLength=this._images.length ; i<iLength ; i++ ) {
				if(this._images[i].image == insObject.image) {
					alreadyAddedIn = i;
				}
			}
			if(!alreadyAddedIn) {
				this._images.push(insObject);
				this._images[this._images.length - 1].imageTable = this._createImageTable();
				this._images[this._images.length - 1].imageToStage = this._images.length - 1;
				this._loadImages();
			}else {
				this._setImage(alreadyAddedIn);
			}
		}
	},

	postCreate: function() {
		epages.widget.Slides.superclass.postCreate.apply(this, arguments);
		this._images = [];

		this.domNode.style.width = this.imageWidth;
		this.domNode.style.height = this.imageHeight;
		this.mainNode.parentNode.style.width =  this.imageWidth;

		if(!this.showDescription) {
			this.descriptionNode.style.display = "none";
		}
		if(!this.showMisc) {
			this.miscNode.style.display = "none";
		}

		var controlButtons = this._drawControlBar();

		for( var i=0,iLength=controlButtons.length ; i<iLength ; i++ ) {
			if(controlButtons[i]) {
				this.connect(controlButtons[i], "onmouseover", "_controlBarButtonOver");
				this.connect(controlButtons[i], "onmouseout", "_controlBarButtonOut");
				this.connect(controlButtons[i], "onmousedown", "_controlBarButtonDown");
				this.connect(controlButtons[i], "onmouseup", "_controlBarButtonUp");
			}
		}

		if(this.srcNodeRef) {
			if(this.srcNodeRef.className) {
				this.mainNode.parentNode.parentNode.className += " " + this.srcNodeRef.className;
			}
			// build images from source node
			var sourceDom = this.srcNodeRef.getElementsByTagName("ins");
			for( var i=0,iLength=sourceDom.length ; i<iLength ; i++ ) {
				var currentImageNode = {};
				currentImageNode.image = sourceDom[i].getAttribute("image") || epages.themeUrl('images') + "/plain.gif";
				currentImageNode.imageLarge = sourceDom[i].getAttribute("imageLarge");
				currentImageNode.name = sourceDom[i].getAttribute("name");
				currentImageNode.description = sourceDom[i].innerHTML;
				currentImageNode.date = sourceDom[i].getAttribute("date");
				currentImageNode.time = sourceDom[i].getAttribute("time");
				currentImageNode.fit = sourceDom[i].getAttribute("fit");

				currentImageNode.imageTable = this._createImageTable();

				this._images.push(currentImageNode);
			}
		}

		this.showIndex = new Number(this.showIndex);
		// start one before, because loadimages increment it first
		this._loadedIndex = this.showIndex - 1;
		if (this._loadedIndex == -1){
			this._loadedIndex = this._images.length;
		}

		this.connect(this.mainNode, "onmouseover", "_showControlBar");
		this.connect(this.mainNode, "onmouseout", "_hideControlBar");

		if(this.imageClickOverview && this.overview) {
			this.connect(this.miscNode.offsetHeight ? this.miscNode : this.mainNode, "onclick", "_checkGlobalOverview");
			this.connect(this.controlNode, "onmouseover", function(){ this._globalOverview = false; } );
			this.connect(this.controlNode, "onmouseout", function(){ this._globalOverview = true; } );
		}else{
			this.mainNode.style.cursor = "default";
		}

		this.connect(window, "onscroll", "_reAlignOverview");
		this.connect(window, "onresize", "_changeOverviewDimensions");
		this.connect(document, "onkeyup", "_handleKeyEvent");

		if(this._images.length > 0) {
			this._delayExec(this._loadImages, 1);
			if(!this.stopped && this._images.length > 1){
				this._delayExec(this._playClickStartTimer, 1000);
			}
		}

	}
});

}

if(!dojo._hasResource['epages.epages_scripts']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.epages_scripts'] = true;
/* ---------------------------------------------------------------------------------------------------
	 ePages 5 - epages_scripts.js $Revision: 1.23 $
	 --------------------------------------------------------------------------------------------------- */
dojo.provide('epages.epages_scripts');





/* - General Functions ------------------------------------------------------------------------------- */

window.openWindow = function (URL, windowName, features, PathToStoreFront) {
	if (PathToStoreFront === null){
		PathToStoreFront = undefined; // old fashion
	}
	if(features=="PopUp") {
		features="width=1000, height=730, toolbar=no, status=no, resizable=yes, menubar=no, location=no, scrollbars=yes";
	}
	if(features=="PopUpPrint") {
		features="width=790, height=580, toolbar=yes, status=no, resizable=yes, menubar=yes, location=no, scrollbars=yes";
	}
	if(features=="RTE" || windowName=="RTE") {
		features="width=996, height=700, toolbar=no, status=no, resizable=yes, menubar=no, location=no, scrollbars=yes";
	}
	if(features=="HelpWindow") {
		features="width=1000, height=730, toolbar=no, status=no, resizable=yes, menubar=no, location=no, scrollbars=yes";
		windowName="WWHFrame";
	 }
	if(features=="StylePreview") {
		features="width=470, height=310, toolbar=no, status=no, resizable=no, menubar=no, location=no, scrollbars=no";
		windowName="StylePreview";
	 }
	if(features=="DetailedImageView") {
		features="width=1000, height=730, toolbar=no, status=no, resizable=yes, menubar=no, location=no, scrollbars=yes";
		windowName="StylePreview";
	 }
	if(features=="CheckLink") {
		if(URL.indexOf("?") != 0) {
			if(URL.split('//').length == 1){
				URL = "http://"+URL;
			}
		} else if(PathToStoreFront!=undefined){
				URL = PathToStoreFront+URL;
		}
		features="toolbar=yes, status=yes, resizable=yes, menubar=yes, location=yes, scrollbars=yes";
	}

	if(URL != "http://") {
		var newwin=window.open(URL,windowName,features);
		if(newwin){
			newwin.focus();
		}
	}

	return newwin;
};

window.linkCorrection = function (oInputField) {
// summary: inserts http protocol if there is no protocol
	var Value=oInputField.value;
	var splittedString = Value.split('//');
	if(Value.indexOf("?") != 0) {
		if(splittedString.length == 1){
			oInputField.value ="http://"+Value;
			epages.event.fire(oInputField, "change");
		}
	}
};

window.OnCheckAll = function (form, name, checked) {
//summary: used to mark all check boxes in a list as "checked"
		var triggerNode;
		dojo.addClass(form.getElementsByTagName("tbody")[0], "HideElement");
		for( var i=0,l=form.length ; i<l ; i++ ) {
			var input = form[i];

			if(input.nodeName == 'INPUT') {
				if((input.type == 'checkbox' || input.className.match("Checkbox")) && input.name == name && !input.disabled && input.checked != checked) {
					input.checked = checked;
					// we need that for the ContentList widget (row selection)
					var widget = $$(dojo.attr(input,'widgetid') || input.id);
					if( widget ){
						widget.setChecked ? widget.setChecked(checked) : widget.attr('checked',checked);
					}
					if(checked) {
						dojo.addClass( epages.parentByTagName(input,'tr'), "RowSelected");
					}else {
						dojo.removeClass( epages.parentByTagName(input,'tr'), "RowSelected");
					}
					triggerNode = input;
					epages.event.fire( triggerNode, 'change' );
				}
			}
		}
		dojo.removeClass(form.getElementsByTagName("tbody")[0], "HideElement");
};

window.DeactivateButton = function (Button) {
// summary: function to disable an input field
// Button must be an input/button object
		if(Button.className.match("CustomButton")) {
				fakeButton = Button.getElementsByTagName("*")[0];
				fakeButton.disabled="true";
				dojo.addClass(Button, "Disabled");
		}
		else if(Button.getAttribute('widgetid')){
			$$(Button.getAttribute('widgetid')).disable();
		}
		else {
				Button.disabled="true";
				dojo.addClass(Button, "Disabled");
		}
};

window.DisableLink = function (Link) {
	// summary: function to disable a link
	if($(Link)) {
		$(Link).className += ' Opacity40';
		$(Link).href = 'javascript:void(0)';
		$(Link).style.cursor = 'default';
	}
};

window.toggleTopic = function(/* dom node */ el, /* string? */ label1, /* string? */ label2) {
	if(el.parentNode) {
		var className = el.parentNode.className;
		if(className.match("Closed")) {
			epages.html.replaceClass(el.parentNode, "Open", "Closed");
		} else {
			epages.html.replaceClass(el.parentNode, "Closed", "Open");
		}
		if(label1 && label2) {
			if(el.innerHTML == label1) {
				el.innerHTML = label2;
			} else {
				el.innerHTML = label1;
			}
		}
	}
};

window.toggleDisplay = function (elementId) {
// summary: switches the display properties of an element (specified by its id attribute)
// by changing the class name (HideElement / ShowElement)
	if ($(elementId).className != 'HideElement') {
		$(elementId).className = 'HideElement';
	} else {
		$(elementId).className = 'ShowElement';
	}
};

window.hideElement = function (elementId) {
		if(!$(elementId).className.match(/HideElement/)){
			$(elementId).className += ' HideElement';
		}
};

window.showElement = function (elementId) {
		$(elementId).className=$(elementId).className.replace(/HideElement/,"");
};

window.changeDataById = function (newdata, id) {
	myobject = $(id);
	if(myobject.firstChild) {
		myobject.firstChild.data = newdata;
	} else {
		mydata = document.createTextNode(newdata);
		myobject.appendChild(mydata);
	}
};

window.getSelectedData = function (selectElement) {
// summary: scans all option tags in a select tag to find the data of the selected item
	if(selectElement) {
		myNode= selectElement.firstChild;
		while (myNode!=null) {
			if(myNode.value==selectElement.value && myNode.value!="") {
				return myNode.firstChild.data;
			}
			myNode = myNode.nextSibling;
		}
		return "";
	}
};

window.disableFormFieldsInElement = function (ElementId) {
// summary: disables all form fields that are sub elements of a given ElementId
	userattrinputs = $(ElementId).getElementsByTagName("input");
	for( var i=0,iLength=userattrinputs.length ; i<iLength ; i++ ) {
		userattrinputs[i].disabled=true;
		if($(ElementId).parentNode.className.match("Cropper")) {
			 $(ElementId).parentNode.className += " Disabled";
		}
		if(userattrinputs[i].type != 'checkbox' && userattrinputs[i].type != 'radio') {
				if(userattrinputs[i].type == "button" || userattrinputs[i].type == "submit") {
					userattrinputs[i].parentNode.className = userattrinputs[i].parentNode.className + " Disabled";
				}else{
					userattrinputs[i].className=userattrinputs[i].className+" Disabled";
				}
		}
	}
	userattrtextareas = $(ElementId).getElementsByTagName("textarea");
	for( var i=0,iLength=userattrtextareas.length ; i<iLength ; i++ ) {
		userattrtextareas[i].disabled=true;
		if($(ElementId).parentNode.className.match("Cropper")) {
			 $(ElementId).parentNode.className += " Disabled";
		}
		userattrtextareas[i].className=userattrtextareas[i].className+" Disabled";
	}
	userattrselects = $(ElementId).getElementsByTagName("select");
	for( var i=0,iLength=userattrselects.length ; i<iLength ; i++ ) {
		userattrselects[i].disabled=true;
		if($(ElementId).parentNode.className.match("Cropper")) {
			 $(ElementId).parentNode.className += " Disabled";
		}
		userattrselects[i].className=userattrselects[i].className+" Disabled";
	}
};

window.enableFormFieldsInElement = function (ElementId) {
// summary: enables all form fields that are sub elements of a given ElementId
	userattrinputs = $(ElementId).getElementsByTagName("input");
	for( var i=0,iLength=userattrinputs.length ; i<iLength ; i++ ) {
		userattrinputs[i].disabled=false;
		if($(ElementId).parentNode.className.match("Cropper")) {
			 $(ElementId).parentNode.className = $(ElementId).parentNode.className.replace(/Disabled/g, "");
		}
		userattrinputs[i].parentNode.className=userattrinputs[i].parentNode.className.replace(/ Disabled/,"");
		userattrinputs[i].parentNode.className=userattrinputs[i].parentNode.className.replace(/Disabled/,"");
		userattrinputs[i].className=userattrinputs[i].className.replace(/ Disabled/,"");
		userattrinputs[i].className=userattrinputs[i].className.replace(/Disabled/,"");
	}
	userattrtextareas = $(ElementId).getElementsByTagName("textarea");
	for( var i=0,iLength=userattrtextareas.length ; i<iLength ; i++ ) {
		userattrtextareas[i].disabled=false;
		if($(ElementId).parentNode.className.match("Cropper")) {
			 $(ElementId).parentNode.className = $(ElementId).parentNode.className.replace(/Disabled/g, "");
		}
		userattrtextareas[i].className=userattrtextareas[i].className.replace(/ Disabled/,"");
		userattrtextareas[i].className=userattrtextareas[i].className.replace(/Disabled/,"");
	}
	userattrselects = $(ElementId).getElementsByTagName("select");
	for( var i=0,iLength=userattrselects.length ; i<iLength ; i++ ) {
		userattrselects[i].disabled=false;
		if($(ElementId).parentNode.className.match("Cropper")) {
			 $(ElementId).parentNode.className = $(ElementId).parentNode.className.replace(/Disabled/g, "");
		}
		userattrselects[i].className=userattrselects[i].className.replace(/ Disabled/,"");
		userattrselects[i].className=userattrselects[i].className.replace(/Disabled/,"");
	}
};

window.disableFormFieldById = function (ElementId) {
// summary: function to disable an input field specified by id
	var node = $(ElementId),
		widget = $$(ElementId),
		parent = node.parentNode;

	if( dojo.hasClass( parent, 'Cropper' ) ){
		dojo.addClass( parent, 'Disabled' );
	}
	if( widget ){
		widget.attr('disabled',true);
		dojo.addClass( node, 'Disabled' );
		return;
	}

	node.disabled=false;
	if( arguments.length>1 ? arguments[1] : true ){
		dojo.addClass( node, 'Disabled' );
		dojo.addClass( parent, 'Disabled' );
	}
};

window.enableFormFieldById = function (ElementId) {
// summary: function to enable an input field specified by id
	var node = $(ElementId),
		widget = $$(ElementId),
		parent = node.parentNode;

	if( dojo.hasClass( parent, 'Cropper' ) ){
		dojo.removeClass( parent, 'Disabled' );
	}
	if( widget ){
		widget.attr('disabled',false);
		dojo.removeClass( node, 'Disabled' );
		return;
	}

	node.disabled=false;
	if( arguments.length>1 ? arguments[1] : true ){
		dojo.removeClass( node, 'Disabled' );
		dojo.removeClass( parent, 'Disabled' );
	}
};

window.setValue = function (Value, TargetID) {
	$(TargetID).value = Value;
};

/* - Special Functions ------------------------------------------------------------------------------- */

window.autofillAddress = function (/*Object*/changedObject) {
// summary: this function fills out the "DisplayName" input field (name="DisplayName") automatically
// changedObject: object with the "changed" data --> CustomerGeneral.TabPage
	changedObject.form.DisplayName.value=changedObject.form.FirstName.value + ' ' + changedObject.form.LastName.value;
	if( changedObject.form.UserAlias ) {
		changedObject.form.UserAlias.value=changedObject.form.FirstName.value.slice(0,1) + changedObject.form.LastName.value;
	}
	if( changedObject.form.UserName ) {
		changedObject.form.UserName.value=changedObject.form.FirstName.value + ' ' + changedObject.form.LastName.value;
	}
};

window.SFautofillAddress = function (FirstNameId, LastNameId, DisplayNameId) {
// summary: fills out the "DisplayName" input field (name="DisplayName") automatically
	$(DisplayNameId).value=$(FirstNameId).value + ' ' + $(LastNameId).value;
};

window.showNotAllowedDialog = function(domNode, message) {
	dojo["require"]("epages.uimessagehandler");
	

	var position = $E(domNode).getAbsolutePosition();
	var screenW = document.getElementsByTagName("body")[0].clientWidth;
	var screenH = document.getElementsByTagName("body")[0].clientHeight;
	var orientation = 'top';
	var xoff = 0;
	var yoff = 0;

	if(position.x > (screenW / 2)) {
		orientation = 'right';
	}

	if(position.y > (screenH - 30)) {
		orientation = 'bottom';
		yoff = 0;
		xoff = 0;
	}

	if (orientation=='top') {
		xoff = 10;
		yoff = domNode.offsetHeight;
	}

	if(orientation == 'right' || orientation == 'left') {
		yoff = domNode.offsetHeight / 2;
	}

	dojo.publish("uimessage/show", ["", message, "Bubble", {
		typeClass: "Warning Wide",
		sizeClass: "Medium",
		x: position.x + xoff,
		y: position.y + yoff,
		orientation: orientation
	}]);
	dojo.connect(dojo.body(), "mouseup", this, function() {
		dojo.publish("uimessage/hide");
	});
};

/* - Dialog Area ------------------------------------------------------------------------------------ */
window.DialogArea = function () {
// summary: is used as constructor for an DialogArea-Object
	this.areaName = new Array();
	this.areaId = new Array();
	this.areaDisplayName = new Array();
	this.areaActivated = new Array();          // false = area disabled    ; true = area is a activated

	this.addArea = function(areaName, areaId) {
	//  this function is used to register the areas in a dialog
		this.areaName.push(areaName);
		this.areaId.push(areaId);
		if(this.addArea.arguments.length>3) {
			this.areaDisplayName.push(this.addArea.arguments[2]);
			this.areaActivated.push(this.addArea.arguments[3]);
		} else {
			this.areaDisplayName.push("");
			this.areaActivated.push(true);
		}
	};

	this.createAreaLinks = function() {
			for( var i=0,l=this.areaName.length ; i<l ; i++ ) {
					var oAreaLink;
					if(this.areaActivated[i]) {
							oAreaLink=document.createElement("a");
							oAreaLink.href="javascript:epagesDialog.toggleArea('"+this.areaName[i]+"');";
							oAreaLink.name=this.areaName[i];
							oAreaLink.id=this.areaName[i];
							oAreaLink.className="HideArea";
					} else {
							oAreaLink=document.createElement("span");
							oAreaLink.name=this.areaName[i];
							oAreaLink.id=this.areaName[i];
							oAreaLink.className="disabled";
					}
					var oLinkText=document.createTextNode(this.areaDisplayName[i]);
					oAreaLink.appendChild(oLinkText);
					$("ToggleTabpageArea").appendChild(oAreaLink);
			}
	};

	this.showArea = function(areaName) {
	// summary: used to show an Area
		areaId="";
	// search for the AreaName in the epagesDialog Object
		for( var i=0,iLength=this.areaName.length ; i<iLength ; i++ ) {
			if(this.areaName[i] == areaName){
				areaId = this.areaId[i];
			}
		}
		try {
				dojo.removeClass(document.getElementsByName(areaName)[0], "HideArea");
				dojo.addClass(document.getElementsByName(areaName)[0], "ShowArea");
		} catch(ex) {
				dojo.removeClass($(areaName), "HideArea");
				dojo.addClass($(areaName), "ShowArea");
		}
		$(areaId).className='ShowElement';
		if(dojo.isIE) {
				// workaround silly MSIE display errors (elements with position:relative are still hidden after setting them visible)
				setTimeout("$('"+areaId+"').className='ShowElement';", 10);
		}
		actualDialogArea = areaName;
	};

	this.hideArea = function(areaName) {
	// summary: used to show an Area
		areaId="";
	// search for the AreaName in the epagesDialog Object
		for( var i=0,iLength=this.areaName.length ; i<iLength ; i++ ) {
			if(this.areaName[i] == areaName){
				areaId = this.areaId[i];
			}
		}
		dojo.removeClass(document.getElementsByName(areaName)[0], "ShowArea");
		dojo.addClass(document.getElementsByName(areaName)[0], "HideArea");
		$(areaId).className='HideElement';
		actualDialogArea = "";
	};

	this.toggleArea = function(areaName) {
	//  summary: used to toggle the view of an area
	//  and to hide all unselected areas
		this.showArea(areaName);

	// loop through all dialog areas and hide them
		for( var i=0,iLength=this.areaName.length ; i<iLength ; i++ ) {
			tempName=this.areaName[i]; tempId=this.areaId[i];
			if(areaName != tempName) {
				if(this.areaActivated[i]) {
						dojo.removeClass(document.getElementsByName(tempName)[0], "ShowArea");
						dojo.addClass(document.getElementsByName(tempName)[0], "HideArea");
						$(tempId).className = 'HideElement';
				}
			}
		}
	};

	this.toggleAreaDisplay = function(areaName) {
	// summary: used to toggle the view of the specified area
	// display settings of other areas remain
		if(document.getElementsByName(areaName)[0].className.match('HideArea')) {
			this.showArea(areaName);
		} else {
			this.hideArea(areaName);
		}
	};

	this.selectArea = function(areaName) {
	// summary: used to show the selected area
	//  and to hide all the other areas
		this.showArea(areaName);
	// loop through all dialog areas and hide them
		for( var i=0,iLength=this.areaName.length ; i<iLength ; i++ ) {
			tempName=this.areaName[i]; tempId=this.areaId[i];
			if(areaName != tempName) {
				dojo.removeClass(document.getElementsByName(tempName)[0], "ShowArea");
				dojo.addClass(document.getElementsByName(tempName)[0], "HideArea");
				$(tempId).className = 'HideElement';
			}
		}
	};
};

window.appendDialogArea = function (formElement) {
	if(actualDialogArea!="") {
		formElement.action += "&DialogArea="+actualDialogArea;
	}
};

actualDialogArea = "";
epagesDialog = new DialogArea();

/* - Switch Wizard Pages ----------------------------------------------------------------------------- */
window.WizardPages = function () {
	// summary: constructor for wizard pages
	this.TabId = new Array();
	this.AreaId = new Array();

	this.addPage = function(TabId, AreaId) {
		this.TabId.push(TabId);
		this.AreaId.push(AreaId);
	};

	this.showStep = function(Index) {
	// summary: used to show the selected page of the wizard
		ActualWizardPage=Index;

		window.scrollTo(0,0);

		// change tab
		$(this.TabId[Index]).className="selected";
		$(this.TabId[Index]).getElementsByTagName("span")[0].firstChild.className="selected";
		try{$(this.TabId[Index]).getElementsByTagName("span")[0].appendChild(oHelpTopic);} catch(ex) { }
		$(this.AreaId[Index]).className="ShowElement";
		for( var i=0,iLength=this.TabId.length ; i<iLength ; i++ ) {
			if(i != Index) {
				$(this.TabId[i]).className="unselected";
				$(this.TabId[i]).getElementsByTagName("span")[0].firstChild.className="disabled";
				$(this.AreaId[i]).className = 'HideElement';
			}
		}
	};
};

ActualWizardPage = 0;
WizardPages= new WizardPages();

/* - our "lightbox" ----------------------------------------------------------------------------- */

window.showImage = function(image) {
	
	(new epages.widget.Slides).openOverview(image);
};


/* - showMore / showLess -- */

	window.showMore = function(alias, refNode) {
		// summary: wipe in hidden node / hide reference node (clicked node)if specified
		if(refNode) {
			refNode.style.display='none';
		}
		dojo.fx.wipeIn({ node: $(alias),  duration: 200}).play();
	};
	window.showLess = function(alias) {
		// summary: wipe out hidden node
		dojo.fx.wipeOut({ node: $(alias), duration: 200}).play();
	};

}

if(!dojo._hasResource['epages.lang.clipboard']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.lang.clipboard'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

  epages.lang.clipboard $Revision: 1.8 $

*/
dojo.provide('epages.lang.clipboard');


epages.lang.Clipboard = function() {
	this._hash = new epages.lang.Hash();
};

epages.lang.Clipboard.prototype = {
	_hash: undefined,
	_counter: 0,

	get: function(/*String*/key) {
		returnValue = this._hash.get("key" + key);
		return returnValue; //Object
	},

	add: function(/*Object*/value) {
		// summary:
		//		adds a value and returns its index
		// example:
		// 	| var clipboard = new epages.lang.Clipboard();
		//	| var index = clipboard.add("test");
		var addIndex = this._counter;
		this._hash.set("key" + addIndex, value);
		do {
			this._counter++;
		} while(this._hash.existsKey("key" + this._counter));
		return addIndex; //Integer
	},

	set: function(/*String*/key, /*Object*/value) {
		// summary:
		//		change the value at the specified position and returns true on success
		//		returns false if position does not exist
		// example:
		// 	| var clipboard = new epages.lang.Clipboard();
		//	| boolean = clipboard.set(5, "test");
		if (this._hash.existsKey("key" + key)) {
			this._hash.set("key" + key, value);
			return true; // Boolean
		} else {
			return false; // Boolean
		}
	}
}

}

if(!dojo._hasResource['epages.lang.hitch']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.lang.hitch'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

  epages.lang.hitch $Revision: 1.10 $

*/
dojo.provide('epages.lang.hitch');


epages.lang.hitch = function (/*Object*/o, /*function*/func, /*Array?*/parameters) {
	if (o === undefined && func === undefined && parameters === undefined) {
		// it seems to be a constructor
		return;
	} else {
		if (parameters === undefined) {
			// no given parameters ==> use default hitch function
			return dojo.hitch(o, func);
		}
		var clipboardParams = [];
		for( var i=0,iLength=parameters.length ; i<iLength ; i++ ) {
			var clipboardIndex = epages.lang.hitch.prototype.clipBoard.add(parameters[i]);
			clipboardParams.push("epages.lang.hitch.prototype.clipBoard.get(" + clipboardIndex + ")");
		}
		// find out methods name in o
		if (typeof(func) == "string") {
			var funcName = func;
		} else {
			for (member in o) {
				if (typeof o[member] == "function" &&
						o[member] == func) {
					var funcName = member;
					break;
				}
			}
		}
		var returnValue;
		if (funcName === undefined) {
			// not a member function
			returnValue = eval("dojo.hitch(o, function() { func(" + clipboardParams.join(", ") + "); });");
		} else {
			// If possible the following line should be replaced with something
			// that does a function call and provides function parameters as an array
			// or something else non-static.
			returnValue = eval("dojo.hitch(o, function() { o." + funcName + "(" + clipboardParams.join(", ") + "); });");
		}
		return returnValue;
	}
};

epages.lang.hitch.prototype = {
	clipBoard : new epages.lang.Clipboard()
};

}

if(!dojo._hasResource["dojo.date"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.date"] = true;
dojo.provide("dojo.date");

/*=====
dojo.date = {
	// summary: Date manipulation utilities
}
=====*/

dojo.date.getDaysInMonth = function(/*Date*/dateObject){
	//	summary:
	//		Returns the number of days in the month used by dateObject
	var month = dateObject.getMonth();
	var days = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
	if(month == 1 && dojo.date.isLeapYear(dateObject)){ return 29; } // Number
	return days[month]; // Number
}

dojo.date.isLeapYear = function(/*Date*/dateObject){
	//	summary:
	//		Determines if the year of the dateObject is a leap year
	//	description:
	//		Leap years are years with an additional day YYYY-02-29, where the
	//		year number is a multiple of four with the following exception: If
	//		a year is a multiple of 100, then it is only a leap year if it is
	//		also a multiple of 400. For example, 1900 was not a leap year, but
	//		2000 is one.

	var year = dateObject.getFullYear();
	return !(year%400) || (!(year%4) && !!(year%100)); // Boolean
}

// FIXME: This is not localized
dojo.date.getTimezoneName = function(/*Date*/dateObject){
	//	summary:
	//		Get the user's time zone as provided by the browser
	// dateObject:
	//		Needed because the timezone may vary with time (daylight savings)
	//	description:
	//		Try to get time zone info from toString or toLocaleString method of
	//		the Date object -- UTC offset is not a time zone.  See
	//		http://www.twinsun.com/tz/tz-link.htm Note: results may be
	//		inconsistent across browsers.

	var str = dateObject.toString(); // Start looking in toString
	var tz = ''; // The result -- return empty string if nothing found
	var match;

	// First look for something in parentheses -- fast lookup, no regex
	var pos = str.indexOf('(');
	if(pos > -1){
		tz = str.substring(++pos, str.indexOf(')'));
	}else{
		// If at first you don't succeed ...
		// If IE knows about the TZ, it appears before the year
		// Capital letters or slash before a 4-digit year 
		// at the end of string
		var pat = /([A-Z\/]+) \d{4}$/;
		if((match = str.match(pat))){
			tz = match[1];
		}else{
		// Some browsers (e.g. Safari) glue the TZ on the end
		// of toLocaleString instead of putting it in toString
			str = dateObject.toLocaleString();
			// Capital letters or slash -- end of string, 
			// after space
			pat = / ([A-Z\/]+)$/;
			if((match = str.match(pat))){
				tz = match[1];
			}
		}
	}

	// Make sure it doesn't somehow end up return AM or PM
	return (tz == 'AM' || tz == 'PM') ? '' : tz; // String
}

// Utility methods to do arithmetic calculations with Dates

dojo.date.compare = function(/*Date*/date1, /*Date?*/date2, /*String?*/portion){
	//	summary:
	//		Compare two date objects by date, time, or both.
	//	description:
	//  	Returns 0 if equal, positive if a > b, else negative.
	//	date1:
	//		Date object
	//	date2:
	//		Date object.  If not specified, the current Date is used.
	//	portion:
	//		A string indicating the "date" or "time" portion of a Date object.
	//		Compares both "date" and "time" by default.  One of the following:
	//		"date", "time", "datetime"

	// Extra step required in copy for IE - see #3112
	date1 = new Date(+date1);
	date2 = new Date(+(date2 || new Date()));

	if(portion == "date"){
		// Ignore times and compare dates.
		date1.setHours(0, 0, 0, 0);
		date2.setHours(0, 0, 0, 0);
	}else if(portion == "time"){
		// Ignore dates and compare times.
		date1.setFullYear(0, 0, 0);
		date2.setFullYear(0, 0, 0);
	}
	
	if(date1 > date2){ return 1; } // int
	if(date1 < date2){ return -1; } // int
	return 0; // int
};

dojo.date.add = function(/*Date*/date, /*String*/interval, /*int*/amount){
	//	summary:
	//		Add to a Date in intervals of different size, from milliseconds to years
	//	date: Date
	//		Date object to start with
	//	interval:
	//		A string representing the interval.  One of the following:
	//			"year", "month", "day", "hour", "minute", "second",
	//			"millisecond", "quarter", "week", "weekday"
	//	amount:
	//		How much to add to the date.

	var sum = new Date(+date); // convert to Number before copying to accomodate IE (#3112)
	var fixOvershoot = false;
	var property = "Date";

	switch(interval){
		case "day":
			break;
		case "weekday":
			//i18n FIXME: assumes Saturday/Sunday weekend, but this is not always true.  see dojo.cldr.supplemental

			// Divide the increment time span into weekspans plus leftover days
			// e.g., 8 days is one 5-day weekspan / and two leftover days
			// Can't have zero leftover days, so numbers divisible by 5 get
			// a days value of 5, and the remaining days make up the number of weeks
			var days, weeks;
			var mod = amount % 5;
			if(!mod){
				days = (amount > 0) ? 5 : -5;
				weeks = (amount > 0) ? ((amount-5)/5) : ((amount+5)/5);
			}else{
				days = mod;
				weeks = parseInt(amount/5);
			}
			// Get weekday value for orig date param
			var strt = date.getDay();
			// Orig date is Sat / positive incrementer
			// Jump over Sun
			var adj = 0;
			if(strt == 6 && amount > 0){
				adj = 1;
			}else if(strt == 0 && amount < 0){
			// Orig date is Sun / negative incrementer
			// Jump back over Sat
				adj = -1;
			}
			// Get weekday val for the new date
			var trgt = strt + days;
			// New date is on Sat or Sun
			if(trgt == 0 || trgt == 6){
				adj = (amount > 0) ? 2 : -2;
			}
			// Increment by number of weeks plus leftover days plus
			// weekend adjustments
			amount = (7 * weeks) + days + adj;
			break;
		case "year":
			property = "FullYear";
			// Keep increment/decrement from 2/29 out of March
			fixOvershoot = true;
			break;
		case "week":
			amount *= 7;
			break;
		case "quarter":
			// Naive quarter is just three months
			amount *= 3;
			// fallthrough...
		case "month":
			// Reset to last day of month if you overshoot
			fixOvershoot = true;
			property = "Month";
			break;
//		case "hour":
//		case "minute":
//		case "second":
//		case "millisecond":
		default:
			property = "UTC"+interval.charAt(0).toUpperCase() + interval.substring(1) + "s";
	}

	if(property){
		sum["set"+property](sum["get"+property]()+amount);
	}

	if(fixOvershoot && (sum.getDate() < date.getDate())){
		sum.setDate(0);
	}

	return sum; // Date
};

dojo.date.difference = function(/*Date*/date1, /*Date?*/date2, /*String?*/interval){
	//	summary:
	//		Get the difference in a specific unit of time (e.g., number of
	//		months, weeks, days, etc.) between two dates, rounded to the
	//		nearest integer.
	//	date1:
	//		Date object
	//	date2:
	//		Date object.  If not specified, the current Date is used.
	//	interval:
	//		A string representing the interval.  One of the following:
	//			"year", "month", "day", "hour", "minute", "second",
	//			"millisecond", "quarter", "week", "weekday"
	//		Defaults to "day".

	date2 = date2 || new Date();
	interval = interval || "day";
	var yearDiff = date2.getFullYear() - date1.getFullYear();
	var delta = 1; // Integer return value

	switch(interval){
		case "quarter":
			var m1 = date1.getMonth();
			var m2 = date2.getMonth();
			// Figure out which quarter the months are in
			var q1 = Math.floor(m1/3) + 1;
			var q2 = Math.floor(m2/3) + 1;
			// Add quarters for any year difference between the dates
			q2 += (yearDiff * 4);
			delta = q2 - q1;
			break;
		case "weekday":
			var days = Math.round(dojo.date.difference(date1, date2, "day"));
			var weeks = parseInt(dojo.date.difference(date1, date2, "week"));
			var mod = days % 7;

			// Even number of weeks
			if(mod == 0){
				days = weeks*5;
			}else{
				// Weeks plus spare change (< 7 days)
				var adj = 0;
				var aDay = date1.getDay();
				var bDay = date2.getDay();

				weeks = parseInt(days/7);
				mod = days % 7;
				// Mark the date advanced by the number of
				// round weeks (may be zero)
				var dtMark = new Date(date1);
				dtMark.setDate(dtMark.getDate()+(weeks*7));
				var dayMark = dtMark.getDay();

				// Spare change days -- 6 or less
				if(days > 0){
					switch(true){
						// Range starts on Sat
						case aDay == 6:
							adj = -1;
							break;
						// Range starts on Sun
						case aDay == 0:
							adj = 0;
							break;
						// Range ends on Sat
						case bDay == 6:
							adj = -1;
							break;
						// Range ends on Sun
						case bDay == 0:
							adj = -2;
							break;
						// Range contains weekend
						case (dayMark + mod) > 5:
							adj = -2;
					}
				}else if(days < 0){
					switch(true){
						// Range starts on Sat
						case aDay == 6:
							adj = 0;
							break;
						// Range starts on Sun
						case aDay == 0:
							adj = 1;
							break;
						// Range ends on Sat
						case bDay == 6:
							adj = 2;
							break;
						// Range ends on Sun
						case bDay == 0:
							adj = 1;
							break;
						// Range contains weekend
						case (dayMark + mod) < 0:
							adj = 2;
					}
				}
				days += adj;
				days -= (weeks*2);
			}
			delta = days;
			break;
		case "year":
			delta = yearDiff;
			break;
		case "month":
			delta = (date2.getMonth() - date1.getMonth()) + (yearDiff * 12);
			break;
		case "week":
			// Truncate instead of rounding
			// Don't use Math.floor -- value may be negative
			delta = parseInt(dojo.date.difference(date1, date2, "day")/7);
			break;
		case "day":
			delta /= 24;
			// fallthrough
		case "hour":
			delta /= 60;
			// fallthrough
		case "minute":
			delta /= 60;
			// fallthrough
		case "second":
			delta /= 1000;
			// fallthrough
		case "millisecond":
			delta *= date2.getTime() - date1.getTime();
	}

	// Round for fractional values and DST leaps
	return Math.round(delta); // Number (integer)
};

}

if(!dojo._hasResource["dojo.cldr.supplemental"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.cldr.supplemental"] = true;
dojo.provide("dojo.cldr.supplemental");



dojo.cldr.supplemental.getFirstDayOfWeek = function(/*String?*/locale){
// summary: Returns a zero-based index for first day of the week
// description:
//		Returns a zero-based index for first day of the week, as used by the local (Gregorian) calendar.
//		e.g. Sunday (returns 0), or Monday (returns 1)

	// from http://www.unicode.org/cldr/data/common/supplemental/supplementalData.xml:supplementalData/weekData/firstDay
	var firstDay = {/*default is 1=Monday*/
		mv:5,
		ae:6,af:6,bh:6,dj:6,dz:6,eg:6,er:6,et:6,iq:6,ir:6,jo:6,ke:6,kw:6,lb:6,ly:6,ma:6,om:6,qa:6,sa:6,
		sd:6,so:6,tn:6,ye:6,
		as:0,au:0,az:0,bw:0,ca:0,cn:0,fo:0,ge:0,gl:0,gu:0,hk:0,ie:0,il:0,is:0,jm:0,jp:0,kg:0,kr:0,la:0,
		mh:0,mo:0,mp:0,mt:0,nz:0,ph:0,pk:0,sg:0,th:0,tt:0,tw:0,um:0,us:0,uz:0,vi:0,za:0,zw:0,
		et:0,mw:0,ng:0,tj:0,
// variant. do not use?		gb:0,
		sy:4
	};

	var country = dojo.cldr.supplemental._region(locale);
	var dow = firstDay[country];
	return (dow === undefined) ? 1 : dow; /*Number*/
};

dojo.cldr.supplemental._region = function(/*String?*/locale){
	locale = dojo.i18n.normalizeLocale(locale);
	var tags = locale.split('-');
	var region = tags[1];
	if(!region){
		// IE often gives language only (#2269)
		// Arbitrary mappings of language-only locales to a country:
		region = {de:"de", en:"us", es:"es", fi:"fi", fr:"fr", he:"il", hu:"hu", it:"it",
			ja:"jp", ko:"kr", nl:"nl", pt:"br", sv:"se", zh:"cn"}[tags[0]];
	}else if(region.length == 4){
		// The ISO 3166 country code is usually in the second position, unless a
		// 4-letter script is given. See http://www.ietf.org/rfc/rfc4646.txt
		region = tags[2];
	}
	return region;
}

dojo.cldr.supplemental.getWeekend = function(/*String?*/locale){
// summary: Returns a hash containing the start and end days of the weekend
// description:
//		Returns a hash containing the start and end days of the weekend according to local custom using locale,
//		or by default in the user's locale.
//		e.g. {start:6, end:0}

	// from http://www.unicode.org/cldr/data/common/supplemental/supplementalData.xml:supplementalData/weekData/weekend{Start,End}
	var weekendStart = {/*default is 6=Saturday*/
		eg:5,il:5,sy:5,
		'in':0,
		ae:4,bh:4,dz:4,iq:4,jo:4,kw:4,lb:4,ly:4,ma:4,om:4,qa:4,sa:4,sd:4,tn:4,ye:4		
	};

	var weekendEnd = {/*default is 0=Sunday*/
		ae:5,bh:5,dz:5,iq:5,jo:5,kw:5,lb:5,ly:5,ma:5,om:5,qa:5,sa:5,sd:5,tn:5,ye:5,af:5,ir:5,
		eg:6,il:6,sy:6
	};

	var country = dojo.cldr.supplemental._region(locale);
	var start = weekendStart[country];
	var end = weekendEnd[country];
	if(start === undefined){start=6;}
	if(end === undefined){end=0;}
	return {start:start, end:end}; /*Object {start,end}*/
};

}

if(!dojo._hasResource["dojo.regexp"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.regexp"] = true;
dojo.provide("dojo.regexp");

/*=====
dojo.regexp = {
	// summary: Regular expressions and Builder resources
};
=====*/

dojo.regexp.escapeString = function(/*String*/str, /*String?*/except){
	//	summary:
	//		Adds escape sequences for special characters in regular expressions
	// except:
	//		a String with special characters to be left unescaped

	return str.replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, function(ch){
		if(except && except.indexOf(ch) != -1){
			return ch;
		}
		return "\\" + ch;
	}); // String
}

dojo.regexp.buildGroupRE = function(/*Object|Array*/arr, /*Function*/re, /*Boolean?*/nonCapture){
	//	summary:
	//		Builds a regular expression that groups subexpressions
	//	description:
	//		A utility function used by some of the RE generators. The
	//		subexpressions are constructed by the function, re, in the second
	//		parameter.  re builds one subexpression for each elem in the array
	//		a, in the first parameter. Returns a string for a regular
	//		expression that groups all the subexpressions.
	// arr:
	//		A single value or an array of values.
	// re:
	//		A function. Takes one parameter and converts it to a regular
	//		expression. 
	// nonCapture:
	//		If true, uses non-capturing match, otherwise matches are retained
	//		by regular expression. Defaults to false

	// case 1: a is a single value.
	if(!(arr instanceof Array)){
		return re(arr); // String
	}

	// case 2: a is an array
	var b = [];
	for(var i = 0; i < arr.length; i++){
		// convert each elem to a RE
		b.push(re(arr[i]));
	}

	 // join the REs as alternatives in a RE group.
	return dojo.regexp.group(b.join("|"), nonCapture); // String
}

dojo.regexp.group = function(/*String*/expression, /*Boolean?*/nonCapture){
	// summary:
	//		adds group match to expression
	// nonCapture:
	//		If true, uses non-capturing match, otherwise matches are retained
	//		by regular expression. 
	return "(" + (nonCapture ? "?:":"") + expression + ")"; // String
}

}

if(!dojo._hasResource["dojo.date.locale"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.date.locale"] = true;
dojo.provide("dojo.date.locale");

// Localization methods for Date.   Honor local customs using locale-dependent dojo.cldr data.







// Load the bundles containing localization information for
// names and formats


//NOTE: Everything in this module assumes Gregorian calendars.
// Other calendars will be implemented in separate modules.

(function(){
	// Format a pattern without literals
	function formatPattern(dateObject, bundle, options, pattern){
		return pattern.replace(/([a-z])\1*/ig, function(match){
			var s, pad,
				c = match.charAt(0),
				l = match.length,
				widthList = ["abbr", "wide", "narrow"];
			switch(c){
				case 'G':
					s = bundle[(l < 4) ? "eraAbbr" : "eraNames"][dateObject.getFullYear() < 0 ? 0 : 1];
					break;
				case 'y':
					s = dateObject.getFullYear();
					switch(l){
						case 1:
							break;
						case 2:
							if(!options.fullYear){
								s = String(s); s = s.substr(s.length - 2);
								break;
							}
							// fallthrough
						default:
							pad = true;
					}
					break;
				case 'Q':
				case 'q':
					s = Math.ceil((dateObject.getMonth()+1)/3);
//					switch(l){
//						case 1: case 2:
							pad = true;
//							break;
//						case 3: case 4: // unimplemented
//					}
					break;
				case 'M':
					var m = dateObject.getMonth();
					if(l<3){
						s = m+1; pad = true;
					}else{
						var propM = ["months", "format", widthList[l-3]].join("-");
						s = bundle[propM][m];
					}
					break;
				case 'w':
					var firstDay = 0;
					s = dojo.date.locale._getWeekOfYear(dateObject, firstDay); pad = true;
					break;
				case 'd':
					s = dateObject.getDate(); pad = true;
					break;
				case 'D':
					s = dojo.date.locale._getDayOfYear(dateObject); pad = true;
					break;
				case 'E':
					var d = dateObject.getDay();
					if(l<3){
						s = d+1; pad = true;
					}else{
						var propD = ["days", "format", widthList[l-3]].join("-");
						s = bundle[propD][d];
					}
					break;
				case 'a':
					var timePeriod = (dateObject.getHours() < 12) ? 'am' : 'pm';
					s = bundle[timePeriod];
					break;
				case 'h':
				case 'H':
				case 'K':
				case 'k':
					var h = dateObject.getHours();
					// strange choices in the date format make it impossible to write this succinctly
					switch (c){
						case 'h': // 1-12
							s = (h % 12) || 12;
							break;
						case 'H': // 0-23
							s = h;
							break;
						case 'K': // 0-11
							s = (h % 12);
							break;
						case 'k': // 1-24
							s = h || 24;
							break;
					}
					pad = true;
					break;
				case 'm':
					s = dateObject.getMinutes(); pad = true;
					break;
				case 's':
					s = dateObject.getSeconds(); pad = true;
					break;
				case 'S':
					s = Math.round(dateObject.getMilliseconds() * Math.pow(10, l-3)); pad = true;
					break;
				case 'v': // FIXME: don't know what this is. seems to be same as z?
				case 'z':
					// We only have one timezone to offer; the one from the browser
					s = dojo.date.locale._getZone(dateObject, true, options);
					if(s){break;}
					l=4;
					// fallthrough... use GMT if tz not available
				case 'Z':
					var offset = dojo.date.locale._getZone(dateObject, false, options);
					var tz = [
						(offset<=0 ? "+" : "-"),
						dojo.string.pad(Math.floor(Math.abs(offset)/60), 2),
						dojo.string.pad(Math.abs(offset)% 60, 2)
					];
					if(l==4){
						tz.splice(0, 0, "GMT");
						tz.splice(3, 0, ":");
					}
					s = tz.join("");
					break;
//				case 'Y': case 'u': case 'W': case 'F': case 'g': case 'A': case 'e':
//					console.log(match+" modifier unimplemented");
				default:
					throw new Error("dojo.date.locale.format: invalid pattern char: "+pattern);
			}
			if(pad){ s = dojo.string.pad(s, l); }
			return s;
		});
	}

/*=====
	dojo.date.locale.__FormatOptions = function(){
	//	selector: String
	//		choice of 'time','date' (default: date and time)
	//	formatLength: String
	//		choice of long, short, medium or full (plus any custom additions).  Defaults to 'short'
	//	datePattern:String
	//		override pattern with this string
	//	timePattern:String
	//		override pattern with this string
	//	am: String
	//		override strings for am in times
	//	pm: String
	//		override strings for pm in times
	//	locale: String
	//		override the locale used to determine formatting rules
	//	fullYear: Boolean
	//		(format only) use 4 digit years whenever 2 digit years are called for
	//	strict: Boolean
	//		(parse only) strict parsing, off by default
		this.selector = selector;
		this.formatLength = formatLength;
		this.datePattern = datePattern;
		this.timePattern = timePattern;
		this.am = am;
		this.pm = pm;
		this.locale = locale;
		this.fullYear = fullYear;
		this.strict = strict;
	}
=====*/

dojo.date.locale._getZone = function(/*Date*/dateObject, /*boolean*/getName, /*dojo.date.locale.__FormatOptions?*/options){
	// summary:
	//		Returns the zone (or offset) for the given date and options.  This
	//		is broken out into a separate function so that it can be overridden
	//		by timezone-aware code.
	//
	// dateObject:
	//		the date and/or time being formatted.
	//
	// getName:
	//		Whether to return the timezone string (if true), or the offset (if false)
	//
	// options:
	//		The options being used for formatting
	if(getName){
		return dojo.date.getTimezoneName(dateObject);
	}else{
		return dateObject.getTimezoneOffset();
	}
};


dojo.date.locale.format = function(/*Date*/dateObject, /*dojo.date.locale.__FormatOptions?*/options){
	// summary:
	//		Format a Date object as a String, using locale-specific settings.
	//
	// description:
	//		Create a string from a Date object using a known localized pattern.
	//		By default, this method formats both date and time from dateObject.
	//		Formatting patterns are chosen appropriate to the locale.  Different
	//		formatting lengths may be chosen, with "full" used by default.
	//		Custom patterns may be used or registered with translations using
	//		the dojo.date.locale.addCustomFormats method.
	//		Formatting patterns are implemented using [the syntax described at
	//		unicode.org](http://www.unicode.org/reports/tr35/tr35-4.html#Date_Format_Patterns)
	//
	// dateObject:
	//		the date and/or time to be formatted.  If a time only is formatted,
	//		the values in the year, month, and day fields are irrelevant.  The
	//		opposite is true when formatting only dates.

	options = options || {};

	var locale = dojo.i18n.normalizeLocale(options.locale),
		formatLength = options.formatLength || 'short',
		bundle = dojo.date.locale._getGregorianBundle(locale),
		str = [],
		sauce = dojo.hitch(this, formatPattern, dateObject, bundle, options);
	if(options.selector == "year"){
		return _processPattern(bundle["dateFormatItem-yyyy"] || "yyyy", sauce);
	}
	var pattern;
	if(options.selector != "date"){
		pattern = options.timePattern || bundle["timeFormat-"+formatLength];
		if(pattern){str.push(_processPattern(pattern, sauce));}
	}
	if(options.selector != "time"){
		pattern = options.datePattern || bundle["dateFormat-"+formatLength];
		if(pattern){str.push(_processPattern(pattern, sauce));}
	}

	return str.length == 1 ? str[0] : bundle["dateTimeFormat-"+formatLength].replace(/\{(\d+)\}/g,
		function(match, key){ return str[key]; }); // String
};

dojo.date.locale.regexp = function(/*dojo.date.locale.__FormatOptions?*/options){
	// summary:
	//		Builds the regular needed to parse a localized date

	return dojo.date.locale._parseInfo(options).regexp; // String
};

dojo.date.locale._parseInfo = function(/*dojo.date.locale.__FormatOptions?*/options){
	options = options || {};
	var locale = dojo.i18n.normalizeLocale(options.locale),
		bundle = dojo.date.locale._getGregorianBundle(locale),
		formatLength = options.formatLength || 'short',
		datePattern = options.datePattern || bundle["dateFormat-" + formatLength],
		timePattern = options.timePattern || bundle["timeFormat-" + formatLength],
		pattern;
	if(options.selector == 'date'){
		pattern = datePattern;
	}else if(options.selector == 'time'){
		pattern = timePattern;
	}else{
		pattern = bundle["dateTimeFormat-"+formatLength].replace(/\{(\d+)\}/g,
			function(match, key){ return [timePattern, datePattern][key]; });
	}

	var tokens = [],
		re = _processPattern(pattern, dojo.hitch(this, _buildDateTimeRE, tokens, bundle, options));
	return {regexp: re, tokens: tokens, bundle: bundle};
};

dojo.date.locale.parse = function(/*String*/value, /*dojo.date.locale.__FormatOptions?*/options){
	// summary:
	//		Convert a properly formatted string to a primitive Date object,
	//		using locale-specific settings.
	//
	// description:
	//		Create a Date object from a string using a known localized pattern.
	//		By default, this method parses looking for both date and time in the string.
	//		Formatting patterns are chosen appropriate to the locale.  Different
	//		formatting lengths may be chosen, with "full" used by default.
	//		Custom patterns may be used or registered with translations using
	//		the dojo.date.locale.addCustomFormats method.
	//	
	//		Formatting patterns are implemented using [the syntax described at
	//		unicode.org](http://www.unicode.org/reports/tr35/tr35-4.html#Date_Format_Patterns)
	//		When two digit years are used, a century is chosen according to a sliding 
	//		window of 80 years before and 20 years after present year, for both `yy` and `yyyy` patterns.
	//		year < 100CE requires strict mode.
	//
	// value:
	//		A string representation of a date

	var info = dojo.date.locale._parseInfo(options),
		tokens = info.tokens, bundle = info.bundle,
		re = new RegExp("^" + info.regexp + "$", info.strict ? "" : "i"),
		match = re.exec(value);

	if(!match){ return null; } // null

	var widthList = ['abbr', 'wide', 'narrow'],
		result = [1970,0,1,0,0,0,0], // will get converted to a Date at the end
		amPm = "",
		valid = dojo.every(match, function(v, i){
		if(!i){return true;}
		var token=tokens[i-1];
		var l=token.length;
		switch(token.charAt(0)){
			case 'y':
				if(l != 2 && options.strict){
					//interpret year literally, so '5' would be 5 A.D.
					result[0] = v;
				}else{
					if(v<100){
						v = Number(v);
						//choose century to apply, according to a sliding window
						//of 80 years before and 20 years after present year
						var year = '' + new Date().getFullYear(),
							century = year.substring(0, 2) * 100,
							cutoff = Math.min(Number(year.substring(2, 4)) + 20, 99),
							num = (v < cutoff) ? century + v : century - 100 + v;
						result[0] = num;
					}else{
						//we expected 2 digits and got more...
						if(options.strict){
							return false;
						}
						//interpret literally, so '150' would be 150 A.D.
						//also tolerate '1950', if 'yyyy' input passed to 'yy' format
						result[0] = v;
					}
				}
				break;
			case 'M':
				if(l>2){
					var months = bundle['months-format-' + widthList[l-3]].concat();
					if(!options.strict){
						//Tolerate abbreviating period in month part
						//Case-insensitive comparison
						v = v.replace(".","").toLowerCase();
						months = dojo.map(months, function(s){ return s.replace(".","").toLowerCase(); } );
					}
					v = dojo.indexOf(months, v);
					if(v == -1){
//						console.log("dojo.date.locale.parse: Could not parse month name: '" + v + "'.");
						return false;
					}
				}else{
					v--;
				}
				result[1] = v;
				break;
			case 'E':
			case 'e':
				var days = bundle['days-format-' + widthList[l-3]].concat();
				if(!options.strict){
					//Case-insensitive comparison
					v = v.toLowerCase();
					days = dojo.map(days, function(d){return d.toLowerCase();});
				}
				v = dojo.indexOf(days, v);
				if(v == -1){
//					console.log("dojo.date.locale.parse: Could not parse weekday name: '" + v + "'.");
					return false;
				}

				//TODO: not sure what to actually do with this input,
				//in terms of setting something on the Date obj...?
				//without more context, can't affect the actual date
				//TODO: just validate?
				break;
			case 'D':
				result[1] = 0;
				// fallthrough...
			case 'd':
				result[2] = v;
				break;
			case 'a': //am/pm
				var am = options.am || bundle.am;
				var pm = options.pm || bundle.pm;
				if(!options.strict){
					var period = /\./g;
					v = v.replace(period,'').toLowerCase();
					am = am.replace(period,'').toLowerCase();
					pm = pm.replace(period,'').toLowerCase();
				}
				if(options.strict && v != am && v != pm){
//					console.log("dojo.date.locale.parse: Could not parse am/pm part.");
					return false;
				}

				// we might not have seen the hours field yet, so store the state and apply hour change later
				amPm = (v == pm) ? 'p' : (v == am) ? 'a' : '';
				break;
			case 'K': //hour (1-24)
				if(v == 24){ v = 0; }
				// fallthrough...
			case 'h': //hour (1-12)
			case 'H': //hour (0-23)
			case 'k': //hour (0-11)
				//TODO: strict bounds checking, padding
				if(v > 23){
//					console.log("dojo.date.locale.parse: Illegal hours value");
					return false;
				}

				//in the 12-hour case, adjusting for am/pm requires the 'a' part
				//which could come before or after the hour, so we will adjust later
				result[3] = v;
				break;
			case 'm': //minutes
				result[4] = v;
				break;
			case 's': //seconds
				result[5] = v;
				break;
			case 'S': //milliseconds
				result[6] = v;
//				break;
//			case 'w':
//TODO				var firstDay = 0;
//			default:
//TODO: throw?
//				console.log("dojo.date.locale.parse: unsupported pattern char=" + token.charAt(0));
		}
		return true;
	});

	var hours = +result[3];
	if(amPm === 'p' && hours < 12){
		result[3] = hours + 12; //e.g., 3pm -> 15
	}else if(amPm === 'a' && hours == 12){
		result[3] = 0; //12am -> 0
	}

	//TODO: implement a getWeekday() method in order to test 
	//validity of input strings containing 'EEE' or 'EEEE'...

	var dateObject = new Date(result[0], result[1], result[2], result[3], result[4], result[5], result[6]); // Date
	if(options.strict){
		dateObject.setFullYear(result[0]);
	}

	// Check for overflow.  The Date() constructor normalizes things like April 32nd...
	//TODO: why isn't this done for times as well?
	var allTokens = tokens.join(""),
		dateToken = allTokens.indexOf('d') != -1,
		monthToken = allTokens.indexOf('M') != -1;

	if(!valid ||
		(monthToken && dateObject.getMonth() > result[1]) ||
		(dateToken && dateObject.getDate() > result[2])){
		return null;
	}

	// Check for underflow, due to DST shifts.  See #9366
	// This assumes a 1 hour dst shift correction at midnight
	// We could compare the timezone offset after the shift and add the difference instead.
	if((monthToken && dateObject.getMonth() < result[1]) ||
		(dateToken && dateObject.getDate() < result[2])){
		dateObject = dojo.date.add(dateObject, "hour", 1);
	}

	return dateObject; // Date
};

function _processPattern(pattern, applyPattern, applyLiteral, applyAll){
	//summary: Process a pattern with literals in it

	// Break up on single quotes, treat every other one as a literal, except '' which becomes '
	var identity = function(x){return x;};
	applyPattern = applyPattern || identity;
	applyLiteral = applyLiteral || identity;
	applyAll = applyAll || identity;

	//split on single quotes (which escape literals in date format strings) 
	//but preserve escaped single quotes (e.g., o''clock)
	var chunks = pattern.match(/(''|[^'])+/g),
		literal = pattern.charAt(0) == "'";

	dojo.forEach(chunks, function(chunk, i){
		if(!chunk){
			chunks[i]='';
		}else{
			chunks[i]=(literal ? applyLiteral : applyPattern)(chunk);
			literal = !literal;
		}
	});
	return applyAll(chunks.join(''));
}

function _buildDateTimeRE(tokens, bundle, options, pattern){
	pattern = dojo.regexp.escapeString(pattern);
	if(!options.strict){ pattern = pattern.replace(" a", " ?a"); } // kludge to tolerate no space before am/pm
	return pattern.replace(/([a-z])\1*/ig, function(match){
		// Build a simple regexp.  Avoid captures, which would ruin the tokens list
		var s,
			c = match.charAt(0),
			l = match.length,
			p2 = '', p3 = '';
		if(options.strict){
			if(l > 1){ p2 = '0' + '{'+(l-1)+'}'; }
			if(l > 2){ p3 = '0' + '{'+(l-2)+'}'; }
		}else{
			p2 = '0?'; p3 = '0{0,2}';
		}
		switch(c){
			case 'y':
				s = '\\d{2,4}';
				break;
			case 'M':
				s = (l>2) ? '\\S+?' : p2+'[1-9]|1[0-2]';
				break;
			case 'D':
				s = p2+'[1-9]|'+p3+'[1-9][0-9]|[12][0-9][0-9]|3[0-5][0-9]|36[0-6]';
				break;
			case 'd':
				s = '[12]\\d|'+p2+'[1-9]|3[01]';
				break;
			case 'w':
				s = p2+'[1-9]|[1-4][0-9]|5[0-3]';
				break;
		    case 'E':
				s = '\\S+';
				break;
			case 'h': //hour (1-12)
				s = p2+'[1-9]|1[0-2]';
				break;
			case 'k': //hour (0-11)
				s = p2+'\\d|1[01]';
				break;
			case 'H': //hour (0-23)
				s = p2+'\\d|1\\d|2[0-3]';
				break;
			case 'K': //hour (1-24)
				s = p2+'[1-9]|1\\d|2[0-4]';
				break;
			case 'm':
			case 's':
				s = '[0-5]\\d';
				break;
			case 'S':
				s = '\\d{'+l+'}';
				break;
			case 'a':
				var am = options.am || bundle.am || 'AM';
				var pm = options.pm || bundle.pm || 'PM';
				if(options.strict){
					s = am + '|' + pm;
				}else{
					s = am + '|' + pm;
					if(am != am.toLowerCase()){ s += '|' + am.toLowerCase(); }
					if(pm != pm.toLowerCase()){ s += '|' + pm.toLowerCase(); }
					if(s.indexOf('.') != -1){ s += '|' + s.replace(/\./g, ""); }
				}
				s = s.replace(/\./g, "\\.");
				break;
			default:
			// case 'v':
			// case 'z':
			// case 'Z':
				s = ".*";
//				console.log("parse of date format, pattern=" + pattern);
		}

		if(tokens){ tokens.push(match); }

		return "(" + s + ")"; // add capture
	}).replace(/[\xa0 ]/g, "[\\s\\xa0]"); // normalize whitespace.  Need explicit handling of \xa0 for IE.
}
})();

(function(){
var _customFormats = [];
dojo.date.locale.addCustomFormats = function(/*String*/packageName, /*String*/bundleName){
	// summary:
	//		Add a reference to a bundle containing localized custom formats to be
	//		used by date/time formatting and parsing routines.
	//
	// description:
	//		The user may add custom localized formats where the bundle has properties following the
	//		same naming convention used by dojo.cldr: `dateFormat-xxxx` / `timeFormat-xxxx`
	//		The pattern string should match the format used by the CLDR.
	//		See dojo.date.locale.format() for details.
	//		The resources must be loaded by dojo.requireLocalization() prior to use

	_customFormats.push({pkg:packageName,name:bundleName});
};

dojo.date.locale._getGregorianBundle = function(/*String*/locale){
	var gregorian = {};
	dojo.forEach(_customFormats, function(desc){
		var bundle = dojo.i18n.getLocalization(desc.pkg, desc.name, locale);
		gregorian = dojo.mixin(gregorian, bundle);
	}, this);
	return gregorian; /*Object*/
};
})();

dojo.date.locale.addCustomFormats("dojo.cldr","gregorian");

dojo.date.locale.getNames = function(/*String*/item, /*String*/type, /*String?*/context, /*String?*/locale){
	// summary:
	//		Used to get localized strings from dojo.cldr for day or month names.
	//
	// item:
	//	'months' || 'days'
	// type:
	//	'wide' || 'narrow' || 'abbr' (e.g. "Monday", "Mon", or "M" respectively, in English)
	// context:
	//	'standAlone' || 'format' (default)
	// locale:
	//	override locale used to find the names

	var label,
		lookup = dojo.date.locale._getGregorianBundle(locale),
		props = [item, context, type];
	if(context == 'standAlone'){
		var key = props.join('-');
		label = lookup[key];
		// Fall back to 'format' flavor of name
		if(label[0] == 1){ label = undefined; } // kludge, in the absense of real aliasing support in dojo.cldr
	}
	props[1] = 'format';

	// return by copy so changes won't be made accidentally to the in-memory model
	return (label || lookup[props.join('-')]).concat(); /*Array*/
};

dojo.date.locale.isWeekend = function(/*Date?*/dateObject, /*String?*/locale){
	// summary:
	//	Determines if the date falls on a weekend, according to local custom.

	var weekend = dojo.cldr.supplemental.getWeekend(locale),
		day = (dateObject || new Date()).getDay();
	if(weekend.end < weekend.start){
		weekend.end += 7;
		if(day < weekend.start){ day += 7; }
	}
	return day >= weekend.start && day <= weekend.end; // Boolean
};

// These are used only by format and strftime.  Do they need to be public?  Which module should they go in?

dojo.date.locale._getDayOfYear = function(/*Date*/dateObject){
	// summary: gets the day of the year as represented by dateObject
	return dojo.date.difference(new Date(dateObject.getFullYear(), 0, 1, dateObject.getHours()), dateObject) + 1; // Number
};

dojo.date.locale._getWeekOfYear = function(/*Date*/dateObject, /*Number*/firstDayOfWeek){
	if(arguments.length == 1){ firstDayOfWeek = 0; } // Sunday

	var firstDayOfYear = new Date(dateObject.getFullYear(), 0, 1).getDay(),
		adj = (firstDayOfYear - firstDayOfWeek + 7) % 7,
		week = Math.floor((dojo.date.locale._getDayOfYear(dateObject) + adj - 1) / 7);

	// if year starts on the specified day, start counting weeks at 1
	if(firstDayOfYear == firstDayOfWeek){ week++; }

	return week; // Number
};

}

if(!dojo._hasResource["epages.localize"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.localize"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.localize $Revision: 1.22 $

*/
dojo.provide("epages.localize");








(function(){

epages.localize = {
	// summary: formats a number by using formatting chars from the user's locale
	formatNumber: function(/*Float*/value, /*Integer?*/decimalDigits) {
		var negativeString = (value < 0) ? '-' : '';
		var valueAbs = Math.abs(value);

		if (decimalDigits == null){
			decimalDigits = 2;
		}
		var precision = Math.pow(10, decimalDigits);
		var intPart = Math.floor(Math.round(valueAbs * precision) / precision);
		var ratPart = Math.round(Math.abs(valueAbs - intPart) * precision);
		if (ratPart != 0) {
			return negativeString +intPart + epages.vars.Locale.decimalSep + ratPart;
		} else {
			return negativeString+intPart;
		}
	},

	formatBytes: function(bytes, decimalDigits) {
		if (decimalDigits == null){
			decimalDigits = 2;
		}
		var unit = "Byte";
		if (bytes >= 1073741824) {
			// GB
			bytes /= 1073741824;
			unit = "GB";
		} else if (bytes >= 1048576) {
			// MB
			bytes /= 1048576;
			unit = "MB";
		} else if (bytes >= 1024) {
			// kB
			bytes /= 1024;
			unit = "kB";
		}
		return epages.localize.formatNumber(bytes, decimalDigits) + " " + unit;
	},

  // assign epages pattern elements to dojo pattern elements
  // see http://www.unicode.org/reports/tr35/tr35-4.html#Date_Format_Patterns for more
  // information
  // IMPORTANT! Only patterns that are supported by epages (existing Locales) are defined
	_patternCache: $H(),
	_patternMap: {
	  // -- YEAR -- //
 		// full year, 2007
		'%{ce_year}': 'yyyy',
 		// short year, 2 digits: 07
		'%y': 'yy',

		// -- MONTH -- //
 		// localized full month name: Oktober
		'%B': 'MMMM',
 		// localized month abbreviation: Okt
		'%b': 'MMM',
 		// month, 2 digits: 05 (may)
		'%m': 'MM',
 		// month, 5
		'%{month}': 'M',

		// -- DAY -- //
		// day, 2 digits, leading zero: '07'
		'%d': 'dd',
		// day, 2 digits, leading zero: '07'
		'%{day}': 'd',
 		// localized day name: Montag
		'%A': 'EEEE',

		// -- HOUR -- //
 		// hour, 24h, 2 digits, leading zero: '09'
		'%H': 'HH',
 		// hour, 24h
		'%{hour}': 'H',
 		// hour, 12h
		'%{hour_12}': 'h',

		// -- MINUTE -- //
 		// minutes, 2 digits, leading zero: '05'
		'%M': 'mm',

		// -- SECOND -- //
		// seconds, 2 digits, leading zero: '05'
		'%S': 'ss',

		// -- SPECIAL -- //
 		// AM or PM, upper case: AM
		'%p': 'a',
 		// time zone, '+0100'
    	'%{time_zone_long_name}': 'ZZ'
	},


	getDojoDateTimePattern: function(epagesPattern) {
		// summary: converts an epages date pattern to a Dojo date pattern.
	  // note: this function does not support all declared specifiers
		if (epagesPattern == null){
			epagesPattern = epages.vars.Locale.dateFormat;
		}
		if (this._patternCache.existsKey(epagesPattern)){
			return this._patternCache.get(epagesPattern); //String
		}
	  var dojoPattern = epagesPattern;
		// relace elements in string with values
		var elementPatterns = $A($A($H(epages.localize._patternMap).keys()).sort(function(a, b) { return b.length - a.length; }));

		elementPatterns.each(function(element) {
		  var rx = new RegExp(element, 'g');
		  dojoPattern = dojoPattern.replace(rx, function() {
		    return epages.localize._patternMap[element];
		  });
		});
		return dojoPattern; //String
	},

	formatDateTime: function(/*Date*/date, /*String?*/epagesPattern) {
	  // summary: replaces the pattern specifiers with real values
		if (date == null){
			return '';
		}
		if (epagesPattern == null){
			epagesPattern = epages.vars.Locale.dateFormat;
		}
		var d = dojo.date.locale.format(date, {
		  datePattern: this.getDojoDateTimePattern(epagesPattern),
		  timePattern: ' '
		});
		// trim last to chars --> spaces
		return d.substring(0, d.length - 2);
	},

	parseDateTime: function (/*String*/ dateString, /*String*/ epagesPattern) {
		if (epagesPattern == null){
			epagesPattern = epages.vars.Locale.dateFormat;
		}
		return dojo.date.locale.parse('~ ' + dateString, {
			selector: 'timeOnly',
			timePattern: this.getDojoDateTimePattern(epagesPattern),
			datePattern: '~'
		});
	},

	parseNumber: function(/*String*/ numberString){
		var thousandExp = new RegExp( dojo.regexp.escapeString(epages.vars.Locale.thousandSep), 'g' ),
			decimalExp = new RegExp( dojo.regexp.escapeString(epages.vars.Locale.decimalSep), 'g' );

		return parseFloat( numberString.replace(thousandExp,'').replace(decimalExp,'.') );
	},
	getFormat: function(type) {
		var ret = _format[type];

		if( !ret ){
			switch(type){
				case 'date':
					ret = _format[type] = epages.localize.getDojoDateTimePattern( epages.vars.Locale.dateFormat );
				break;
				case 'datetime':
					ret = _format[type] = epages.localize.getDojoDateTimePattern( epages.vars.Locale.datetimeFormat );
				break;
				case 'time':
					ret = _format[type] = epages.localize.getDojoDateTimePattern( epages.vars.Locale.timeFormat );
				break;
				case 'number':
					ret = _format[type] = dojo.regexp.escapeString('-? ?[0-9'+_separator.thousand+']+['+_separator.decimal+']?[0-9]*', '([]{}+?*)');
				break;
				case 'money':
					ret = _format[type] = dojo.regexp.escapeString('(['+_separator.money+']? ?-? ?[0-9'+_separator.thousand+']{1,}['+_separator.decimal+']?[0-9]{0,2}|-? ?[0-9'+_separator.thousand+']{1,}['+_separator.decimal+']?[0-9]{0,2} ?['+_separator.money+']?)', '([|]{}?)')
				break;
			}
		}

		return ret;
	},
	getPattern: function(type) {
		var ret = _pattern[type];

		if( !ret ){
			switch(type){

				case 'date':
				case 'datetime':
				case 'time':
				case 'month':
				case 'week':
					ret = _pattern[type] = dojo.date.locale.regexp({ selector:'date',	datePattern: this.getFormat(type),		timePattern:'' })
				break;
				case 'number':
					ret = _pattern[type] = dojo.regexp.escapeString('-? ?[0-9'+epages.vars.Locale.thousandSep+']+['+epages.vars.Locale.decimalSep+']?[0-9]*', '([]{}+?*)');
				break;
				case 'money':
					ret = _pattern[type] = dojo.regexp.escapeString('(['+epages.vars.Locale.moneySymbol||''+']? ?-? ?[0-9'+epages.vars.Locale.thousandSep+']{1,}['+epages.vars.Locale.decimalSep+']?[0-9]{0,2}|-? ?[0-9'+epages.vars.Locale.thousandSep+']{1,}['+epages.vars.Locale.decimalSep+']?[0-9]{0,2} ?['+epages.vars.Locale.moneySymbol||''+']?)', '([|]{}?)')
				break;
			}
		}

		return ret;
	},
	getSeparator: function(type) {
		return _separator[type];
	},
	date2obj: function( input , type ) {
		return dojo.date.locale.parse(
					input,
					{
						selector: 		'date',
						datePattern: 	_format[type],
						timePattern: 	''
					}
				);
	},
	obj2date: function( input , type ) {
		return dojo.date.locale.format(
					input,
					{
						selector: 		'date',
						datePattern: 	_format[type],
						timePattern: 	''
					}
				);
	},
	date2unix: function( input , type ) {
		var ret = epages.localize.date2obj( input , type );
		return ret ? ( ret.getTime() / 1000 ) : null;
	},
	unix2date: function( input , type ) {
		return epages.localize.obj2date( new Date(input*1000) , type );
	},
	str2number: function( input ) {
		var ret = parseFloat(
						(input+'')
							.replace( new RegExp( dojo.regexp.escapeString('[^0-9-' +epages.vars.Locale.decimalSep + ']', '^([]{})$'), 'g') , '' )
							.replace( new RegExp( dojo.regexp.escapeString('[' + epages.vars.Locale.decimalSep + ']', 	'^([]{})$'), 'g') , '.' )
					);

		return isNaN(ret) ? null : ret;
	},
	number2str: function( input ) {
		return (input+'').replace( /\./g , _separator.decimal );
	}
};

// private vars for use in epages.localize
var _format = {
		month:			'MM (yyyy)',
		week:			'w (yyyy)'
	},
	_pattern = {
		space: 			'\ \n\r\t\
',
		alpha: 			'A-Za-z',
		digit: 			'0-9',
		email:			dojo.regexp.escapeString('[A-Za-z0-9._-]{1,}@[A-Za-z0-9._-]{2,}[A-Za-z]{2,4}', '([]{})'),
		url: 			'([A-Z]:\\[^/:\*\?<>\|]+\.\w{2,6})|(\\{2}[^/:\*\?<>\|]+\.\w{2,6})',
		tel: 			'[0-9\/\+\-\.\ ]{0,}',
		integer:		'-?[0-9]*'
	};

})();

}

if(!dojo._hasResource['epages.io.json']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.io.json'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.io.Json $Revision: 1.24 $

*/
dojo.provide('epages.io.json');

epages.io.Json = function () {};
dojo.extend(epages.io.Json, {

	defaultErrorCallback: function(error,args) {
  	var response = args.xhr.status == 404 ? {} : dojo.fromJson(args.xhr.responseText);
    console.warn('epages.io.Json: error in request');

		if (response.Errors !== undefined) {
			dojo.publish("epages/interfaceerror", [{
				code:	    response.Errors[0].Reason,
				message:  response.Errors[0].Message,
				guid:     response.Errors[0].GUID,
				vars:     {
	          				url:		  args.url,
	          				status:	  args.xhr.status,
	          				response: response
	          		  }
			}]);
		}
	},

	loadSync: function (/*String*/url, /*object?*/formData, /*Function?*/errorCallback, /*Boolean*/preventCache) {
		// summary:
		//		returns a javascript object, which was loaded via http from given url.
		// 		additional parameters will be added in the post.
		// example:
		//		JsonLoader = new epages.io.Json();
		//		Answer = JsonLoader.loadSync('http://www.mydomain.de/test.Json', { filename: "test.Json" });
		//		// returns JsonDocument object
		var returnData;
		var requestMethod = formData !== undefined ? dojo.xhrPost : dojo.xhrGet;
		var _this = this;
		var opt = {
			url: 						url,
			sync: 					true,
			preventCache:		preventCache !== undefined ? preventCache : epages.constants.preventCache,
			error:					function(error,args) {
												returnData = {
													'error': {
														error: error,
														args: args,
														data: dojo.fromJson(args.xhr.responseText)
													}
												};
												if (errorCallback != null){
													errorCallback({'error':[error,args]});
												}else{
													_this.defaultErrorCallback(error,args);
												}
											},
			load: 					function(data, evt){
												var result = dojo.fromJson(data);
												if(result.Errors){
													returnData = {
														'error': {
															data: result
														}
													};
												}
												else{
													returnData = { 'data': dojo.fromJson(data) };
												}
											}
		};
		// test cases doesnt allow posts
		if(url.match('\.(js|json)$')) {
			requestMethod = dojo.xhrGet;
		} else {
			dojo.mixin(opt, {
				headers:	{ Accept: 'text/x-json' },
				content:	formData
			});
		}
		requestMethod(opt);
		return returnData; /*Object*/
	},

	loadAsync: function (/*String*/url, /*Function*/callback, /*object?*/formData, /*Function?*/errorCallback) {
		// summary:
		//		loads a document via http from given url.
		//		the function doesnt wait for the result.
		//		if the result is available the callback function is called with the data.
		// example:
		//		JsonLoader = new epages.io.Json();
		//		JsonDoc = JsonLoader.loadAsync('http://www.mydomain.de/test.Json', function (data) { /* do what you want */ });
		//		// returns JsonDocument object
		var requestMethod = formData !== undefined ? dojo.xhrPost : dojo.xhrGet;
		var _this = this;
		var opt = {
			url: 			url,
			error:		function(error,args) {
									var c = errorCallback || callback;
									var response = dojo.fromJson(args.xhr.responseText);
									if (c) {
										c({
											'error': [ error, args ],
											'data': (typeof response == "object") ? dojo.fromJson(args.xhr.responseText) : {}
										});
									} else {
										_this.defaultErrorCallback(error,args);
									}
								},
			load: 		function(data, ioArgs) {
									if (callback != null){
										var result = dojo.fromJson(data);
										if(result.Errors){
											callback({
												'error': {
													data: result
												}
											});
										} else {
											callback({
												'data': result,
												'ioArgs': ioArgs
											});
										}
									}
								}
		};
		// test cases doesnt allow posts
		if(url.match('\.(js|json)$')) {
			requestMethod = dojo.xhrGet;
		} else {
			dojo.mixin(opt, {
				headers:	{ Accept: 'text/x-json' },
				content:	formData
			});
		}
		requestMethod(opt);
		return;
	}
});

}

if(!dojo._hasResource["epages.storage"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.storage"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.storage $Revision: 1.12 $
*/

dojo.provide("epages.storage");



(function(dj){
		  
	var trim = function(string) {
			return (string+'').replace(/[\ \r\n\t]*(.*)[\ \r\n\t]*/,"$1");
		};	
	
	var storageId = function( name ) {
			return 'SiteID::'+epages.vars.SiteID+'::'+name;
		},
		domain = 			'; domain=' + document.domain,
		path = 				'; path=/',
		
		isLocalStorage = 	window.localStorage && window.localStorage.setItem ? true : false,
		isSessionStorage = 	window.sessionStorage && window.sessionStorage.setItem ? true : false,
		
		setCookie = function(name, value, expires) {
			if( typeof expires == 'number' ) {
				var date = new Date();
					date.setDate( expires );
				expires = '; expires=' + date.toUTCString();
			}
			else{
				expires = '';
			}
			document.cookie = [name, '=', dj.toJson(value), expires, path, domain].join('');
			return value;
		},
		
		getCookie = function(name) {
			var value = null;
			if (document.cookie && document.cookie != '') {
				var cookies = document.cookie.split(';');
				for (var i = 0; i < cookies.length; i++) {
					var cookie = trim(cookies[i]);
					// Does this cookie string begin with the name we want?
					if (cookie.substring(0, name.length + 1) == (name + '=')) { 
						value = dj.fromJson(cookie.substring(name.length + 1));
						break;
					}
				}
			}
			return value;
		},
		
		removeCookie = function( name ) {
			return setCookie( name, null, -365);
		},
		
		clearCookie = function( prefix ) {
			if (document.cookie && document.cookie != '') {
				var cookies = document.cookie.split(';');
				for (var i = 0; i < cookies.length; i++) {
					var cookie = trim(cookies[i]);
					if( cookie.match(new RegExp('^'+prefix,'g')) ) {
						removeCookie( cookie.substr(0,cookie.indexOf('=')) ) 
					}
				}
			}
			return null;
		};
		
	//simulate the storage fallback:
	//isLocalStorage = false;
	//isSessionStorage = false;
		
	
	dj.mixin(epages,{
		localStorage: {
			setItem: function( name, value ) {
				return isLocalStorage ? window.localStorage.setItem( storageId(name), dj.toJson(value) ) : setCookie( 'localStorage::'+storageId(name), value, 365 );
			},
			getItem: function( name ) {
				if( isSessionStorage ) {
					var ret = window.localStorage.getItem( storageId(name) );
					return ret ? dj.fromJson( ret ) : ret;
				}
				else {
					return  getCookie( 'localStorage::'+storageId(name) );
				}
			},
			removeItem: function( name ) {
				return isLocalStorage ? window.localStorage.removeItem( storageId(name) ) : removeCookie( 'localStorage::'+storageId(name) );
			},
			clear: function( name ) {
				return isLocalStorage ? window.localStorage.clear() : clearCookie('localStorage::'+siteId());
			}
		},
		sessionStorage: {
			setItem: function( name, value ) {
				return isSessionStorage ? window.sessionStorage.setItem( storageId(name), dj.toJson(value) ) : setCookie( 'sessionStorage::'+storageId(name), value );
			},
			getItem: function( name ) {
				if( isSessionStorage ) {
					var ret = window.sessionStorage.getItem( storageId(name) );
					return ret ? dj.fromJson( ret ) : ret;
				}
				else {
					return  getCookie( 'sessionStorage::'+storageId(name) );
				}
			},
			removeItem: function( name ) {
				return isSessionStorage ? window.sessionStorage.removeItem( storageId(name) ) : removeCookie( 'sessionStorage::'+storageId(name) );
			},
			clear: function( name ) {
				return isSessionStorage ? window.sessionStorage.clear() : clearCookie('sessionStorage::'+siteId());
			}
		}
	});

})(dojo);

}

if(!dojo._hasResource["epages.loaderani"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.loaderani"] = true;
/*
	Copyright (c) 2006-2010, ePages GmbH
	All Rights Reserved.

  epages.loaderani $Revision: 1.7 $

*/
dojo.provide("epages.loaderani");

epages.loaderani = {

	// summary: shows a loading animation
	// example:
	// | //	to create an animation:
  // | window.aniNode = epages.loaderani.create({width:16, height:16, left:0, top:0, zIndex:1});
  // | //	or
  // | window.aniNode = epages.loaderani.create();
  // | // to remove that animation:
  // | epages.loaderani.destroy(window.aniNode);

	defaultWidth: 50,
	defaultHeight: 50,
	defaultLeft: -9999,
	defaultTop: -9999,
	defaultZIndex: 1
}


epages.loaderani.create = function(/* object */ dimensions, /* dom Node ?*/ domNode) {
// summary: moves the loader animation to the right position
// description:
// animation has to be inside the DOM with id LoaderAniNode already
// dimensions
// | width - integer
// | height - integer
// | top - integer
// | left - integer
// | zIndex - integer
	dimensions = dimensions || {};
	dimensions.width = dimensions.width || this.defaultWidth;
	dimensions.height = dimensions.height || this.defaultHeight;
	dimensions.left = dimensions.left || this.defaultLeft;
	dimensions.top = dimensions.top || this.defaultTop;
	dimensions.zIndex = dimensions.zIndex || this.defaultZIndex;
	var LoaderAniNode = $('LoaderAniNode'); //find existing animation
	if(LoaderAniNode) {
		LoaderAniNode.style.left = dimensions.left + "px";
		LoaderAniNode.style.top = dimensions.top + "px";
		LoaderAniNode.style.zIndex = dimensions.zIndex;
		if(LoaderAniNode.getElementsByTagName("object") && LoaderAniNode.getElementsByTagName("object")[0]) {
			LoaderAniNode.getElementsByTagName("object")[0].width = dimensions.width;
			LoaderAniNode.getElementsByTagName("object")[0].height = dimensions.height;
		}
	}
	return LoaderAniNode;
};

epages.loaderani.destroy = function(aniNode) {
// summary: moves the loader animation out of the visible area
		var LoaderAniNode = $('LoaderAniNode');
		if(LoaderAniNode){
			LoaderAniNode.style.left = "-9999px";
			LoaderAniNode.style.top = "-9999px";
		}
};

}

if(!dojo._hasResource["epages.event.interactionrestrictor"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.event.interactionrestrictor"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.event.interactionrestrictor $Revision: 1.8 $

*/
dojo.provide("epages.event.interactionrestrictor");



epages.event.interactionRestrictor = function(/*Object?*/ position) {
	// summary: busylayer for a specific dom element
	// position: specifies an alternative position where the overlay is displayed 
	// example:
	//  | dojo.publish("interactionRestrictor/suspend", ["layerId", domNode, (hideLayer)]);
	//  | dojo.publish("interactionRestrictor/permit", ["layerId"]);

	dojo.subscribe("interactionRestrictor/suspend", function(layerId, domNode, hideLayer,position) {
		if(!$(layerId) && domNode && domNode.offsetWidth) {
			dojo.body().className += " SuspendUserInteraction";
			var suspendAnimation = document.createElement("div");
			if(!position){
				var suspendPosition = new epages.html.Element(domNode).getAbsolutePosition(dojo.body());
				var position = {
					Width  : domNode.offsetWidth,
					Height : domNode.offsetHeight,
					Left   : suspendPosition.x,
					Top    : suspendPosition.y
				}
			}
			suspendAnimation.id = layerId;
			suspendAnimation.className = "SuspendUserInteractionAnimation";
			suspendAnimation.style.width = position.Width + "px";
			suspendAnimation.style.height = position.Height + "px";
			suspendAnimation.style.left = position.Left + "px";
			suspendAnimation.style.top = position.Top + "px";
			suspendAnimation.style.zIndex = 11000;
			if(hideLayer) {
				dojo.addClass(suspendAnimation, "SuspendUserInteractionHidden");
			}else if(domNode.offsetHeight > 0) {
				suspendAnimation.loaderani = epages.loaderani.create({width:16,height:16,top:(position.Top + position.Height / 2 - 8),left:(position.Left + position.Width / 2 - 8),zIndex:11001});
			}
			dojo.body().appendChild(suspendAnimation);
		}
	});
	dojo.subscribe("interactionRestrictor/permit", function(layerId) {
		if($(layerId)) {
			dojo.removeClass(dojo.body(), "SuspendUserInteraction");
			epages.loaderani.destroy($(layerId).loaderani);
			dojo.body().removeChild($(layerId));
		}
	});
};

new epages.event.interactionRestrictor;

}

if(!dojo._hasResource['epages.mimetype']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.mimetype'] = true;
/*
 * @charset			utf-8		(ÄÖÜ äöü ß)
 *
 * Copyright (c) 2006-2010, epages GmbH
 * All Rights Reservedojo.
 * epages.mimetype $Revision: 1.8 $
 */

dojo.provide('epages.mimetype');

(function(dojo) {

	dojo.declare('epages.Mimetype',null,{
	// summary: 		mimetype and filetype handling
	// description: 	privat class
	// TODO:			improve this class and make it to a public class
	//					by preserving the epages.mimetype API

		/*
		 * private
		 */
		 _MIMETYPE_MAP: {
			// image
			'image/png':																	['png' ],
			'image/jpeg':																	['jpe', 'jpeg', 'jpg' ],
			'image/gif':																	['gif' ],
			'image/bmp':																	['bmp' ],
			'image/vnd.microsoft.icon':														['ico' ],
			'image/tiff':																	['tif', 'tif' ],
			'image/svg+xml':																['svg', 'svgz' ],
			'image/x-win-bitmap':															['cur' ],
			// audio/video
			'audio/basic':																	['au'],
			'audio/mpeg':																	['mp3' ],
			'audio/mp4a-latm':																['m4p', 'm4b', 'm4a' ],
			'audio/x-wav':																	['wav' ],
			'audio/ogg':																	['ogg', 'oga', 'spx' ],
			'audio/flac':																	['flac' ],
			'audio/x-ms-wma':																['wma' ],
			'audio/x-pn-realaudio':															['ra','ram' ],
			'application/vnd.rn-realmedia':													['rm' ],
			'video/ogg':																	['ogv' ],
			'video/mp4':																	['mp4' ],
			'video/mpeg':																	['mpe', 'mpg', 'mpeg', 'mpga' ],
			'video/quicktime':																['qt', 'mov' ],
			'video/x-msvideo':																['avi' ],
			'video/x-flv':																	['flv' ],
			'video/x-ms-wmv':																['wmv'],
			// web
			'text/plain':																	['txt' ],
			'text/html':																	['htm', 'html', 'shtml', 'php', 'php4' ],
			'text/css':																		['css' ],
			'text/x-actionscript':															['as'],
			'application/javascript':														['js' ],
			'application/json':																['json' ],
			'application/xml':																['xml', 'plist' ],
			'application/x-shockwave-flash':												['swf' ],
			// archives
			'application/zip':																['zip' ],
			'application/gzip':																['gz' ],
			'application/x-tar':															['tar' ],
			'application/x-rar-compressed':													['rar' ],
			'application/x-msdownload':														['exe', 'msi' ],
			'application/vnd.ms-cab-compressed':											['cab' ],
			// adobe
			'application/pdf':																['pdf' ],
			'image/vnd.adobe.photoshop':													['psd' ],
			'application/postscript':														['ai', 'eps', 'ps' ],
			// ms office
			'application/msword':															['doc' ],
			'application/x-dot':															['dot' ],
			'application/rtf':																['rtf' ],
			'application/vnd.ms-excel':														['xls','xla' ],
			'application/vnd.ms-powerpoint':												['ppt' ],
			'application/vnd.openxmlformats-officedocument.wordprocessingml.document': 		['docx'],
			'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet':			['xlsx'],
			//
			'application/x-director':														['cdr']
		},

		_MIMETYPE_GROUPS: {
			'*/*':				['*/*' ],
			'icon/*':			['image/vnd.microsoft.icon', 'image/x-win-bitmap' ],
			'image/*':			['image/png', 'image/jpeg', 'image/gif' ],
			'document/*':		['application/pdf', 'application/msword', 'application/vnd.ms-excel', 'application/rtf', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' ],
			'audio/*':			['audio/mpeg', 'audio/x-ms-wma', 'audio/ogg', 'audio/flac', 'audio/x-ms-wma' ],
			'video/*':			['video/x-msvideo', 'video/mp4', 'video/mpeg', 'video/x-ms-wmv', 'video/x-flv' ]
		},

		_MIMETYPE_PREVIEWABLE: 	['image/png', 'image/jpeg', 'image/gif', 'image/vnd.microsoft.icon' ],

		_ICON_MAP: {
			'ico_l_image':		['image/png','image/jpeg','image/gif','image/bmp','image/vnd.microsoft.icon','image/tiff','image/svg+xml','image/x-win-bitmap'],
			'ico_xl_box':		[this._UNKNOW,'text/x-actionscript','audio/basic','audio/x-wav','audio/mpeg','audio/x-ms-wma','audio/ogg','audio/flac','application/msword','application/x-dot','application/vnd.ms-excel','application/vnd.ms-powerpoint','text/plain','text/css','application/javascript','application/json','application/xml'],
			'ico_xl_file_avi':	['video/x-msvideo','video/mpeg','video/mp4'],
			'ico_xl_file_wmv':	['video/x-ms-wmv'],
			'ico_xl_file_swf':	['video/x-flv','application/x-shockwave-flash'],
			'ico_xl_file_mov':	['video/quicktime','video/ogg'],
			'ico_xl_file_rm':	['application/vnd.rn-realmedia'],
			'ico_xl_file_ram':	['audio/x-pn-realaudio'],
			'ico_xl_file_dcr':	['application/x-director'],
			'ico_xl_file_pdf':	['application/pdf'],
			'ico_xl_file_htm':	['text/html'],
			'ico_m_folder':		['application/zip','application/x-rar-compressed','application/gzip','application/x-tar']
		},

		_UNKNOW: 'application/octet-stream',

		_mimes: null,

		/*
		 * public
		 */

		/*
		 * init instance
		 */
		constructor: function( mime ) {
			this.setMime( mime || this._UNKNOW )
		},

		/*
		 * methods
		 */
		setBySuffix: function( suffix ) {
			suffix = suffix.toLowerCase();
			this._mime = this._UNKNOW;

			var map = this._MIMETYPE_MAP;

			for( var i in map ) {
				if( dojo.indexOf(map[i], suffix)>=0 ) {
					this._mime = i;
					break;
				}
			};

			return this;
		},

		setMime: function( mime ) {
			this._mime = mime;
			return this;
		},

		getMime: function() {
			return this._mime;
		},

		mimesByGroup: function( group ) {
			return this._MIMETYPE_GROUPS[group];
		},

		isGroup: function( group ) {
			var mimesGroup = this._MIMETYPE_GROUPS[group];

			if( group=='*/*' ) {
				return true;
			}
			else if(!mimesGroup) {
				return false;
			}
			else {
				if( dojo.indexOf(mimesGroup, this._mime)>=0 ) {
					return true;
				}
			}

			return false;
		},

		isPreviewable: function() {
			var prev = this._MIMETYPE_PREVIEWABLE;

			if( dojo.indexOf(prev, this._mime)>=0 ) {
				return true;
			}

			return false;
		},

		getIcon: function() {

			var map = this._ICON_MAP;
			for( var i in map ) {
				if( dojo.indexOf(map[i], this._mime)>=0 ) {
					return i;
				}
			}

			return 'ico_xl_box';
		}

	});

	var _mimetype = new epages.Mimetype();

	epages.mimetype = {
		mimeBySuffix: function( suffix ) {
		// summary: get mimetypeby suffix
			return _mimetype.setBySuffix( suffix );
		},
		isPreviewable: function( mime ) {
		// summary: to check is the givn mimetype previewable
			return _mimetype.setMime( mime ).isPreviewable();
		},
		isGroup: function( mime , group ) {
		// summary: to check is the givn mimetype in a mimetype group
			return _mimetype.setMime( mime ).isGroup( group );
		},
		getGroup: function( group ) {
		// summary: return a group of mimetypes
			return _mimetype._MIMETYPE_GROUPS[group] || ['*/*'];
		},
		isGroupBySuffix: function( suffix , group ) {
		// summary: to check is the givn fileSuffix in a mimetype group
			return _mimetype.setBySuffix( suffix ).isGroup( group );
		},
		getIcon: function( mime ) {
		// summary: returns a SpriteIconClass by the givn mimetype
			return _mimetype.setMime( mime ).getIcon();
		}
	};

})(dojo);

}

if(!dojo._hasResource['epages.html.form']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.html.form'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.html.element $Revision: 1.12 $

*/
dojo.provide('epages.html.form');



epages.html.Form = function (object) {
	if (object === undefined) {
		console.warn('epages.html.Form: initialize without object.');
		// raise error for callback
		var name = object.className;
	}
	this.object = object;
};

dojo.extend(epages.html.Form, {
	object: undefined,

	get: function () {
		var content = $H();
		for( var i=0,iLength=this.object.elements.length ; i<iLength ; i++ ){
			var elm = this.object.elements[i];
			if (elm.getAttribute('ep_form') != 'false') {
				var name = elm.name;
				var value = content.get(name);
				if (value === undefined){
					value = [];
				}
				value.push($E(elm).get());
				content.set(name, value);
			}
		}
		return content;
	},

	set: function (content,callOnChange) {
		if(callOnChange === undefined){
			callOnChange = true;
		}
		if (dojo.isString(content)){
			content = $H(dojo.fromJson(content));
		}

		for( var i=0,iLength=this.object.elements.length ; i<iLength ; i++ ){
			var elm = this.object.elements[i];
			var name = elm.name;
			var value = content.get(name);
			if(value != '' && value != undefined && elm.getAttribute('widgetid') && (dojo.hasClass(elm,'Radio') || dojo.hasClass(elm,'Checkbox'))){
				$$(elm.getAttribute('widgetid')).setChecked(true);
			}
			if (value !== undefined) {
				var hlm = $E(elm);
				hlm.set(value.shift());
				if(callOnChange){
					hlm.callOnChange();
				}
				content.set(name, value);
			}
		}
	},

	toString: function() {
		return this.get().toString();
	}

});

}

if(!dojo._hasResource["epages.widget.Form"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Form"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.widget.Form $Revision: 1.11 $

*/

dojo.provide("epages.widget.Form");


dojo.declare("epages.widget.Form", [dijit._Widget], {
		// summary:
		//					widget linked to the <form/> html element
		//					to enhance the functionality of that particular node

	submitButtons: 	[], 		// array of all submit buttons found inside of the form element on startup
									// you can push your dynamically built button in here hence it will be registered
	
	_formName: 		null,
	_elems:			null,
	_submits:		null,
	_invalides:		null,

	_onSubmit: function() {
		for( var i=0,iLength=this.submitButtons.length ; i<iLength ; i++ ) {
			this.submitButtons[i].disabled = true;
		}
	},

	postCreate: function() {
		this.inherited("postCreate", arguments);
		
		this._elems = {};
		this._submits = {};
		this._invalides = {};
		
		//this.submitButtons = dojo.query("[type=submit]", this.domNode);
		
		//this.connect(this.domNode, "submit", "_onSubmit");
		
		// for new formElements Widgets
		this._formName = dojo.attr( this.domNode , 'name' );
		this.connect(this.domNode, 'submit', this.validate);
	},
	
	validate: function(event) {
		var elems = this._elems;
		var error = false;
		
		for( var i in elems ) {
			error = elems[i].validate() ? error : true;
		};
		
		if( error && event ) {
			event.preventDefault();
			console.log('error')
		}
		return !error;
	},
	
	addElem: function( instance ) {
		if( instance.attr('type')=='submit' ) {
			this._submits[instance.id] = instance;
		}
		this._elems[instance.id] = instance;
	},
	
	removeElem: function( id ) {
		if( this._elems[id] ) {
			delete( this._elems[id] );
		}
		if( this._submits[id] ) {
			delete( this._submits[id] );
		}
	},
	
	change: function() {
		var elems = this._elems;
		var error = false;
		for( var i in elems ) {
			error = elems[i].attr('valide') ? error : true;
		}
		
		var elems = this._submits;
		for( var i in elems ) {
			elems[i].attr('disabled',error);
		}
	},
	
	destroy: function() {
		this.inherited('destroy', arguments);
		
		var elems = this._elems;
		
		for( var i in elems ) {
			elems[i].destroy();
		}
	}
})

}

if(!dojo._hasResource['epages.widget.FormElements']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.widget.FormElements'] = true;
/*
	Copyright (c) 2010, ePages GmbH
	All Rights Reserved.

	epages.widget.FormElements $Revision: 1.21 $

*/

dojo.provide('epages.widget.FormElements');












(function(dj){

	var windowFormWdgt = new epages.widget.Form( {}, document.createElement('form') );

	dj.declare('epages.widget.FormBase', [dijit._Widget], {

	// VARS
		wrapNode		: null,				// node of wrap which wrapped the domNode
		formNode		: null,				// node of parent form
		_type				: 'text',			// type of formElement
		_attr				: {},					// attributes of formElement
		_handles		: null,				// array of handles which will connect on this._connectHandles

		_translation	: epages.io.dictionary.translation,


	// CREATE
		postCreate: function(){
			this.inherited('postCreate', arguments);

			this._attr = {};
			this._handles = {};
			this._connects = {};
			// get type
			if( this.domNode.nodeName.match(/^(TEXTAREA|SELECT)$/) ){
				this._attr.type = this.domNode.nodeName.toLowerCase();
			}
			else {
				this._attr.type = dj.attr(this.domNode,'type');
			}
			if( this._attr.type == 'datetime-local' ){
				this._attr.type = 'datetime';
			}
			if( !this._attr.type ){
				var match = (this.domNode.outerHTML).match(/[<\s]{1}type="?([A-Za-z]+)"?[>\s\/]{1}/);
				this._attr.type = match ? match[1] : 'text';
			}

			// get attributes
			var ATTR = ['autofocus','form','formaction','formmethod','formnovalidate','id','required','pattern','min','max','name','accept','checked','disabled','list','maxlength','multiple','placeholder','step','value'];

			for( var i=0,l=ATTR.length ; i<l ; i++ ){
				var name = ATTR[i];
				var value = dj.attr(this.domNode,name);
				// there is a bug in dojo.attr => use native javascript for this attribute
				if( name == 'multiple' ){
					value = this.domNode.getAttribute('multiple') === 'true' ? true : false;
				}
				// parse min, max & step to number
				if( name.match(/^(max|min|step)$/) ){
					value = epages.localize.str2number(value);
					if( value !== null ){
						this._attr[name] = value;
					}
				}
				// is defined
				else if( value !== undefined ){
					this._attr[name] = value;
				}
			}
			this._attr.id = this.id;
			this._attr.valide = dj.hasClass(this.domNode,'DialogError') ? false : true;

			// replace domNode for type compatibility
			if( this._attr.type.match(/^(color|date|datetime|email|month|number|search|tel|time|url|week)$/) ){
				var node = dj.clone(this.domNode);
				if( !(epages.Browser.engine == 'MSIE' && epages.Browser.version <= 8) ){
					dj.attr( node , 'type' , 'text' );
				}
				dj.place( node , this.domNode , 'after' );
				node.parentNode.removeChild(this.domNode);
				this.domNode = node;
			}

			// if element hidden by style copy to wrap node
			var style = '';
			var originalStyle = this.domNode.getAttribute('style') || '';
			if(originalStyle !== '') {
				// Start IE Hack
				if( typeof originalStyle === 'object' ){
					var ret = [];
					for( var i in originalStyle ){
						ret.push( i + ":" + name[i] );
					}
					originalStyle = ret.join(';');
				}
				// End IE Hack
				originalStyle.replace(/(display:\s*[a-z]+\s*;?|visibility:\s*[a-z]+\s*;?)/gi, function(str,a){
					style = style+a;
					return "";
				});
			}

			// wrap domNode
			this.wrapNode = dj.create('label',{
				'class': 'EpForm ' + this._attr.type.substr(0,1).toUpperCase() + this._attr.type.substr(1) + ' ' + dj.attr(this.domNode,'class'),
				'style': style
			},this.domNode,'after');
			this.wrapNode.appendChild(this.domNode);

				if(dj.query('form.ep-js').length){
					return;
				}

				// set formWidget
				var formNode = (this._attr.form ? dj.query('form[name='+this._attr.form+']') : [this.domNode.form])[0];
				if( !formNode ){
					this.formWdgt = windowFormWdgt;
				}
				else{
					this.formWdgt = $$( dj.attr(formNode,'widgetid') );
					if( !this.formWdgt ){
						this.formWdgt = new epages.widget.Form( {}, formNode );
					}
				}

				// fix to disable validation by browser
				dj.removeAttr( this.domNode, 'formmethod' );
				dj.removeAttr( this.domNode, 'formaction' );
				dj.removeAttr( this.domNode, 'max' );
				dj.removeAttr( this.domNode, 'min' );
				dj.removeAttr( this.domNode, 'pattern' );
				dj.removeAttr( this.domNode, 'required' );
				dj.removeAttr( this.domNode, 'step' );

				// add this formElement to his form
				this.formWdgt.addElem( this );

				this.addHandle( 'domNode.focus', this.domNode, 'focus', function() {
					dj.addClass(this.domNode,'Active');
					dj.addClass(this.wrapNode,'Active');
				});
				this.addHandle( 'domNode.blur', this.domNode, 'blur', function() {
					dj.removeClass(this.domNode,'Active');
					dj.removeClass(this.wrapNode,'Active');
				});

				if( this._attr.type.match(/^(checkbox|radio)$/) ){
					this.attr( 'startupValue', this._attr.checked ? this._attr.value : '' );
				}
				else{
					this.attr( 'startupValue', this._attr.value );
				}

				// set focus
				if( this._attr.autofocus == true ){
					this._domNode.focus();
				}

				// set the id also
				this.domNode.setAttribute( 'id', this.id );

		},

		// init the readonly and disbaled status
		postAfterCreate: function(){
			this.attr( 'readonly', this._attr.readonly || false );
			this.attr( 'disabled', this._attr.disabled || false );
		},

		// METHODS
		style: function( node, name, value ){
			if( !node.nodeName && !this[node] ){
				value = name;
				name = node;
				node = this.domNode;
			}
			node = node.nodeName || this[node];

			if( typeof name == 'object' ){
				dj.style( node, name );
				return this;
			}
			else if( value == undefined ){
				return dj.style( node, name );
			}
			else{
				dj.style( node, name, value );
				return this;
			}
		},
		attr: function( name, value ){
			if( typeof name == 'object' ){
				for( var i in name ){
					this.attr( i, name[i] );
				}
				return this;
			}
			else {
				var methodName = '_attr'+name.substr(0,1).toUpperCase()+name.substr(1);
				if( value === undefined ){
					return this[methodName] ? this[methodName]() : this._attr[name];
				}
				else {
					return this._attr[name] = this[methodName] ? this[methodName](value) : value;
				}
			}
		},
		_attrMin: function( value ){
			return value ? epages.localize.str2number(value) : this._attr.min;
		},
		_attrMax: function( value ){
			return value ? epages.localize.str2number(value) : this._attr.max;
		},
		_attrStep: function( value ){
			return value ? epages.localize.str2number(value) : this._attr.step;
		},
		_attrType: function( value ){
			// value will be ignored, type can not modify
			return this._attr.type;
		},
		// set/get formElement multiple status
		_attrValue: function( value ){
			if( value ){
				this.domNode.setAttribute('value', value);
				return value;
			}
			else {
				return this._attr.value || '';
			}
		},
		// set/get formElement disabled status
		_attrForm: function( value ){
			if( value || value == '' ){
				var formNodeList;
				if( value == '' ){
					formNodeList = [this.domNodeForm];
				}
				else {
					formNodeList = dj.query('form[name='+value+']') || [];
				}
				if( formNodeList[0] ){
					this.formWdgt.removeElem( this.id );
					this.formWdgt = $$( dj.attr(formNodeList[0], 'widgetid') );
					if( !formWdgt ){
						this.formWdgt = windowFormWdgt;
						this.formWdgt.addElem( this );
					}
					this._attr.form = value;
				}
				return this._attr.form || '';
			}
			else {
				return this._attr.form;
			}
		},
		// set/get formElement disabled status
		_attrDisabled: function( bool ){
			if( bool === true ){
				dj.attr( this.domNode , 'disabled' , true );
				dj.addClass( this.wrapNode , 'Disabled' );

				this._disconnectHandles();
				return bool;
			}
			else if( bool === false ){
				dj.removeAttr( this.domNode , 'disabled' );
				dj.removeClass( this.wrapNode , 'Disabled' );

				if( !this._attr.readonly ){
					this._disconnectHandles();
					this._connectHandles();
				}
				return bool;
			}
			else {
				return this._attr.disabled || false;
			}
		},
		// set/get formElement readonly status
		_attrReadonly: function( bool ){
			if( bool === true ){
				dj.attr( this.domNode , 'readonly', true );
				dj.addClass( this.wrapNode , 'Readonly' );

				this._disconnectHandles();
				return bool;
			}
			else if( bool === false )  {
				dj.removeAttr( this.domNode , 'readonly' );
				dj.removeClass( this.wrapNode , 'Readonly' );

				if( !this.attr('disabled') ){
					this._disconnectHandles();
					this._connectHandles();
				}
				return bool;
			}
			else {
				return this._attr.readonly || false;
			}
		},
		// add handle with id
		addHandle: function( id, node, event, fn  ) {
			if( this._connects[id] ) {
				this.removeHandle( id );
			}
			this._handles[id] = [ typeof node === 'string' ? this[node] : node, event, fn ];

			return this;
		},
		// remove handle by id
		removeHandle: function( id ) {
			if( this._connects[id] ) {
				dj.disconnect( this._connects[id] );
			}
			//delete( this._handles[id] );

			return this;
		},
		// connect handle by id
		connectHandle: function( id ) {
			if( this._connects[id] ) {
				this.removeHandle( id );
			}
			if( this._handles[id] ) {
				var _handle = this._handles[id];
				this._connects[id] = dj.connect( _handle[0], _handle[1], this, _handle[2] );
			}
			return this;
		},
		// disconnect handles by id
		disconnectHandle: function( id ) {
			dj.disconnect( this._connects[id] );

			return this;
		},
		// connect all handles
		_connectHandles: function(){
			var _handles = this._handles;
			for( var i in _handles ){
				this.connectHandle( i );
			}
		},
		// disconnect all handles
		_disconnectHandles: function(){
			var _handles = this._handles;
			for( var i in _handles ){
				this.disconnectHandle( i );
			}
		},
		// replace pseudo pattern with regexp pattern
		_replacePattern: function(){
			if( this._attr.pattern ){
				this._attr.pattern = this._attr.pattern.replace(/(\[\:[a-z\-]+\:\])/,function( t, s ){
					return epages.localize.getPattern( s.substr(2,s.length-4) );
				} );
			}
		},
		// validate formElement
		validate: function(){
			var valide = true;

			if( !this.attr('formnovalidate') ){
				valide = this._validate();
				var maxL = Math.min( this.attr('maxlength') || epages.vars.MaxTextLength, epages.vars.MaxTextLength );
				valide =  maxL && maxL<(dj.attr(this.domNode,'value')+'').length ? false : valide;
				if( valide ){
					dj.removeClass( this.domNode , 'DialogError' );
					dj.removeClass( this.wrapNode , 'DialogError' );
				}
				else {
					dj.addClass( this.domNode , 'DialogError' );
					dj.addClass( this.wrapNode , 'DialogError' );
				}
				this.attr('valide', valide ? true : false );
				this.formWdgt.change();
			}
			else {
				this.attr('valide', valide ? true : false );
			}

			if( dj.attr( this.domNode,'value') !=  this.attr('startupValue') ){
				dj.addClass( this.domNode, 'Changed' );
				dj.addClass( this.wrapNode, 'Changed' );
			}
			else{
				dj.removeClass( this.domNode, 'Changed' );
				dj.removeClass( this.wrapNode, 'Changed' );
			}

			return valide;
		},
		// placeholder for validate function
		_validate: function(){
			return true;
		},
		// destroy a widget
		destroy: function(){
			this.inherited('destroy',arguments);

			this._disconnectHandles();
			this.formWdgt.removeElem( this.id );
		}

	});


	// WIDGET FormButton
	dj.declare('epages.widget.FormButton', [epages.widget.FormBase], {

	// CREATE
		postCreate: function(){
			this.inherited('postCreate', arguments);

			this.postAfterCreate();
		}

	});


	// WIDGET FormFile
	dj.declare('epages.widget.FormFile', [epages.widget.FormBase], {

		buttonNode: 		null,
		_domNode:				null,
		_handlesIndex: 	null,

		// CREATE
		postCreate: function(){
			this.inherited('postCreate', arguments);

			this.buttonNode = dj.create('span',{
			  'class':''
			},this.domNode,'after');

			this.buttonNode.innerHTML = this._translation.get( this._attr.multiple ? 'FileUploadMultiple' : 'FileUploadSingle');

			this.postAfterCreate();
		},

		// METHODS
		// set/get formElement multiple status
		_attrAccept: function( value ){
			if( value ){
				this.domNode.setAttribute('accept',value);
				return value;
			}
			else {
				return this._attr.accept || '';
			}
		},
		// set/get formElement multiple status
		_attrMultiple: function( bool ){
			if( bool === true ){
				this.domNode.setAttribute('multiple',true);
				return bool;
			}
			else if( bool === false ){
				this.domNode.removeAttribute('multiple');
				return bool;
			}
			else {
				return this._attr.multiple || false;
			}
		},

		_attrAccept: function( value ){
			if( value ){
				var instance = new epages.Mimetype();
				this._attr.accept = value.replace(/([A-Za-z]+\/\*)/,dj.hitch(this,function( string, found ){
					var mimes = instance.mimesByGroup( found );
					if( mimes ) {
						return mimes.join(',');
					}
					else {
						return '';
					}
				}));
				dj.attr( this.domNode, 'accept', this._attr.accept );
				return this._attr.accept;
			}
			else {
				return this._attr.accept;
			}
		},

		// set/get formElement value
		_attrValue: function( value ){
			if( value == '' ){
				this._disconnectHandles();

				var arr = [];
				for( var i=0,iLength=this._handles.length ; i<iLength ; i++ ){
					if( this._handles[i][0] == this.domNode ) {
						arr.push(i);
					}
				}

				this._domNode = this.domNode;
				if( epages.Browser.engine == "Gecko"){
					this.domNode.setAttribute('value','');
				}
				else{
					this.domNode = dj.place( this.domNode.cloneNode(), this._domNode, 'replace' );
					var node = dj.clone(this.domNode);
				}

				for( var i in this._handles ) {
					if( this._handles[i][0] == this._domNode ) {
						this._handles[i][0] = this.domNode;
					}
				}

				for( var i=0,iLength=arr.length ; i<iLength ; i++ ){
					this._handles[arr[i]][0] = this.domNode;
				}

				this._connectHandles();
			}
			else {
				return this._attr.value || '';
			}
		}

	});


// WIDGET FormFileUploder
	dj.declare('epages.widget.FormFileUploader', [epages.widget.FormFile], {

		_uploader:		null,

	// CREATE
		postCreate: function(){
			this.inherited('postCreate', arguments);

			this.addHandle( 'domNode.change.fileUploader', this.domNode, 'change', this._change  );
			this.addHandle( 'domNode.click.fileUploader', this.domNode, 'click', this._click  );

			this.attr({
				'sendaction':	dj.attr(this.domNode,'sendaction'),
				'deleteaction':	dj.attr(this.domNode,'deleteaction'),
				'finishaction':	dj.attr(this.domNode,'finishaction')
			});

			this.formWdgt.removeElem( this.id );

			this.postAfterCreate();
		},

	// METHODS
		// open the uploader if attr uploader is true
		_click:	function( event ){
			if( !this._uploader ){
				this._createUploader();
				this._uploader.hide();
			}
			else {
				event.preventDefault();
				this._uploader.show();
			}
		},
		// open the uploader if attr uploader is true
		_change: function(){
			if( !this._uploader ){
				this._createUploader();
			}
			this._uploader.show();
			this.attr('value', '');
			this._uploader.externalInput( this._domNode );
		},

		_createUploader: function(){
			dj.require('epages.widget.Uploader');

			this._uploader = new epages.widget.Uploader({
				options:{
					id: 						this.attr('id'),
					multiple : 			this.attr('multiple'),
					accept : 				this.attr('accept') || '*/*',
					sendaction : 		this.attr('sendaction'),
					deleteaction : 	this.attr('deleteaction'),
					finishaction : 	this.attr('finishaction')
				}
			}, dj.create('div'));
		}
	});


// WIDGET FormSelect
	dj.declare('epages.widget.FormSelect', [epages.widget.FormBase], {

	// CREATE
		postCreate: function(){
			this.inherited('postCreate', arguments);

			this.addHandle( 'domNode.change.select', this.domNode, 'change', this.validate  );

			this.postAfterCreate();
		},

	// METHODS
		// set/get formElement required status (required cann't be true for type select
		_attrRequired: function(){
			this._attr.required = false;
			return false;
		}
	});


// WIDGET FormText
	dj.declare('epages.widget.FormText', [epages.widget.FormBase], {

	// CREATE
		postCreate: function(){
			this.inherited('postCreate', arguments);

			this.addHandle( 'domNode.keyup.text', this.domNode 		, 'keyup' 	, this.validate );
			this.addHandle( 'domNode.blur.text',  this.domNode 		, 'blur' 		, this.validate );

			if( this.domNode.getAttribute("emptyValue") ){
				var domNode = this.domNode;
				var value = dj.attr( domNode, 'value' );
				var emptyValue = dj.attr( domNode, 'emptyValue' );

				if( !value || value == emptyValue ){
					dj.attr( domNode, 'value', emptyValue );
					dj.addClass( domNode, 'EmptyValue' );
				}

				dojo.connect( this.formWdgt.domNode, "submit", function() {
					domNode.value = domNode.value.replace(domNode.getAttribute('emptyValue'), '');
					dojo.removeClass(domNode, "EmptyValue");
				});
				this.addHandle( 'domNode.focus2.text', domNode, "focus", function() {
					domNode.value = domNode.value.replace(domNode.getAttribute('emptyValue'), '');
					dojo.removeClass(domNode, "EmptyValue");
				});
				this.addHandle( 'domNode.blur2.text', domNode, "blur", function() {
					if(domNode.value == "") {
						dojo.addClass(domNode, "EmptyValue");
						domNode.value = domNode.getAttribute("emptyValue");
					}
				});
	   }

			// replace domNode for type compatibility
			if( this._attr.type.match(/^(email|tel|url)$/) ){
				this._attr.pattern = epages.localize.getPattern( this._attr.type );
			}

			// handle mandatory
			if( dj.hasClass( this.domNode, 'Mandatory' ) && !dj.attr( this.domNode, 'value' ) ){
				dj.addClass( this.domNode, 'Unfilled' );
			}

			this.postAfterCreate();
		},

	// METHODS
		_validate: function(){
			var value = dj.attr( this.domNode , 'value' );
			var valide = false;
			if( value == '' && !this._attr.required ){
				valide = true;
			}
			if( value == '' && this._attr.required ){
				valide = false;
			}
			else if( this._attr.pattern && value.match(new RegExp('^'+this._attr.pattern+'$')) ){
				valide = true;
			}
			else if( !this._attr.pattern ){
				valide = true;
			}
			if( dj.hasClass( this.domNode, 'Mandatory' ) && !dj.attr( this.domNode, 'value' ) ){
				dj.addClass( this.domNode, 'Unfilled' );
			}
			else{
				dj.removeClass( this.domNode, 'Unfilled' );
			}
			return valide;
		}
	});


// WIDGET FormCheck
	dj.declare('epages.widget.FormCheck', [epages.widget.FormBase], {

	// CREATE
		postCreate: function(){
			this.inherited('postCreate', arguments);

			this.addHandle( 'domNode.change.check', this.domNode, 'change', this._change );
			if( epages.Browser.engine == 'MSIE' ){
				this.addHandle( 'domNode.click.check', this.domNode, 'click', this._ieChangeFix );
			}

			if( !this.domNode.value && !this.domNode.defaultValue ){
				this.domNode.defaultValue = "on";
			}

			this.attr( 'checked', this._attr.checked ? true : false );
			this.postAfterCreate();
		},

	// METHODS
		// set/get formElement checked status
		_attrChecked: function(bool){
			if(bool === true){
				if( this._attr.type == 'radio' ){
					var radios = this._getRadios();
					for( var i=0,l=radios.length ; i<l ; i++ ){
						radios[i].attr( 'checked', false );
						dojo.removeClass(radios[i].domNode,'DialogError');
						dojo.removeClass(radios[i].wrapNode,'DialogError');
					}
				}
				dj.attr( this.domNode, 'checked', true );
				dj.addClass( this.wrapNode, 'Checked' );
				return bool;
			}
			else if(bool === false){
				dj.attr( this.domNode, 'checked', false );
				dj.removeClass( this.wrapNode, 'Checked' );
				return bool;
			}
			else {
				return this._attr.checked;
			}
		},
		// a fix for the IE to fire the change action instantly
		_ieChangeFix: function(){
			this.domNode.blur();
		},
		// handle the change
		_change: function(){
			this.attr( 'checked', dj.attr( this.domNode , 'checked' ) ? true : false );
			this.validate();
		},
		// found all radio element with same name in this form and outside of this form which added to this form by the form attribute
		_getRadios: function(){
			var domNodeName = dj.attr(this.domNode,'name');
			var formNodeName = dj.attr(this.formWdgt.domNode,'name');

			var inForm;
			var exForm;
			if( this.formWdgt === windowFormWdgt ){
				inForm = dj.query('input[type=radio][name='+domNodeName+']',this.domNode.ownerDocument);
				exForm = [];
			}
			else{
				inForm = dj.query('input[type=radio][name='+domNodeName+']',this.formWdgt.domNode);
				exForm = dj.query('input[type=radio][name='+domNodeName+'][form='+formNodeName+']',document.body);
			}

			var radios = inForm.concat(exForm);
			var required = this.attr('required');

			var ret = [];
			for( var i=0,l=radios.length ; i<l ; i++ ){
				var wdgt = $$( dj.attr(radios[i],'widgetid') );
				if( wdgt ){
					ret.push( wdgt );
					required = wdgt.attr('required') || required;
					wdgt.attr('valide',true);
				}
			}
			this.attr('required',required);

			return ret;
		},

		_validate: function(){

			var value = dj.attr( this.domNode , 'value' );
			var valide = false;
			if( this._attr.type == 'checkbox' && ( (dj.attr(this.domNode,'checked') && this._attr.required) || !this._attr.required ) ){
				valide = true;
			}

			if( this._attr.type == 'radio' ){
				var radios = this._getRadios();
			}

			if( this._attr.type == 'radio' && ( (this.attr('checked') && this.attr('required')) || !this.attr('required') ) ){
				valide = true;
			}
			else if( this._attr.type == 'radio' ){
				for( var i=0,l=radios.length ; i<l ; i++ ){
					valide = radios[i].attr('checked') || valide;
				}
			}
			return valide;
		}

	});


// WIDGET FormNumber
	dj.declare('epages.widget.FormNumber', [epages.widget.FormBase], {

		stepUpNode: 			null,			// node of the step up button
		stepDownNode: 		null,			// node of the step down button

		_stepCount:				null,			// counter of intervals
		_stepSpeed: 			null,			// interval time
		_stepInterval: 		null,			// interval of step action

	// CREATE
		postCreate: function(){
			this.inherited('postCreate', arguments);

			this._replacePattern();

			this.stepUpNode = dj.create('a',{
					'href':'javascript:;',
					'class':'StepUp'
				});

			this.stepDownNode = dj.create('a',{
					'href':'javascript:;',
					'class':'StepDown'
				});

			this.wrapNode.appendChild(this.stepUpNode);
			this.wrapNode.appendChild(this.stepDownNode);

			this.addHandle( 'domNode.keyup.number',          this.domNode 			, 'keyup' 			, this.validate  );
			this.addHandle( 'domNode.blur.number',           this.domNode 			, 'blur' 				, this.validate  );

			this.addHandle( 'stepUpNode.mousedown.number',   this.stepUpNode 		, 'mousedown' 	, function(event){ event.preventDefault(); this._stepStart(+1); }  );
			this.addHandle( 'stepUpNode.mouseup.number',     this.stepUpNode 		, 'mouseup'   	, this._stepStop  );
			this.addHandle( 'stepUpNode.mouseout.number',    this.stepUpNode 		, 'mouseout'  	, this._stepStop  );

			this.addHandle( 'stepDownNode.mousedown.number', this.stepDownNode 	, 'mousedown' 	, function(event){ event.preventDefault(); this._stepStart(-1); }  );
			this.addHandle( 'stepDownNode.mouseup.number',   this.stepDownNode 	, 'mouseup' 		, this._stepStop  );
			this.addHandle( 'stepDownNode.mouseout.number',  this.stepDownNode 	, 'mouseout' 		, this._stepStop  );

			// set pattern
			this._attr.pattern = this._attr.pattern || epages.localize.getPattern( 'number' );

			this.postAfterCreate();
		},

	// METHODS
		// handle the step
		_stepAction: function( inc ){
			this._stepCount++;
			this._stepSpeedHandle( inc );

			var value = dj.attr( this.domNode , 'value' );
			var ret;
			var step = inc * (this._attr.step || 1);
			var attrMin = this._attr.min;
			var attrMax = this._attr.max;


			ret = epages.localize.str2number(value);
			ret = ret!==null ? ret : 0;
			var i = (ret+'').indexOf('.');
			var l = i>=0 ? (ret+'').substr(i+1).length : 0;
			ret = ret+step;
			ret = (attrMin && attrMin > ret.toFixed(l)) ? attrMin : (attrMax && attrMax < ret.toFixed(l)) ? attrMax : ret.toFixed(l);
			ret = epages.localize.number2str( ret );
			dj.attr( this.domNode , 'value' , ret );
		},
		// start the step action
		_stepStart: function( inc ){
			this._stepCount = 0;
			this._stepSpeed = 250;

			this._stepAction(inc);
			this._stepInterval = window.setInterval( dj.hitch(this,function(){
				this._stepAction(inc);
			}), this._stepSpeed );
		},
		// stop the step action
		_stepStop: function(){
			window.clearInterval( this._stepInterval );
			epages.event.fire(this.domNode,'blur');
		},
		// handle the speed of the step action
		_stepSpeedHandle: function( inc ){
			if( dj.indexOf([10,30,50],this._stepCount)>=0 ){
				this._stepSpeed = this._stepSpeed / 2;
				window.clearInterval( this._stepInterval );
				this._stepInterval = window.setInterval( dj.hitch(this,function(){
					this._stepAction(inc);
				}), this._stepSpeed );
			}
		},

		_validate: function(){
			var value = dj.attr( this.domNode , 'value' );
			var valide = false;

			if( value=='' && !this._attr.required ){
				valide = true;
			}
			else if( value.match(new RegExp('^'+this._attr.pattern+'$')) ){
				var val = epages.localize.str2number(value);
				var attrMin = this._attr.min;
				var attrMax = this._attr.max;
				valide = (attrMin && attrMin > val) ? false : (attrMax && attrMax < val) ? false : true;

			}
			return valide;
		}

	});


// WIDGET FormDate
	dj.declare('epages.widget.FormDate', [epages.widget.FormNumber], {

	// CREATE
		postCreate: function(){
			this.inherited('postCreate', arguments);

			// set pattern by type
			this._attr.pattern = epages.localize.getPattern( this._attr.type );
		},

	// METHODS
		_stepAction: function( inc ){
			this._stepCount++;
			this._stepSpeedHandle( inc );

			var value = dj.attr( this.domNode , 'value' );
			var ret;
			var attrStep = this._attr.step || 1;
			var attrMin = this._attr.min;
			var attrMax = this._attr.max;

			var dateObj = epages.localize.date2obj( value , this._attr.type ) || new Date();
			switch( this._attr.type ){
				case 'datetime':
					dateObj.setHours( dateObj.getHours() + (inc * attrStep) );
				break;
				case 'month':
					dateObj.setMonth( dateObj.getMonth() + (inc * attrStep) );
				break;
				case 'time':
					dateObj.setHours( dateObj.getHours() + (inc * attrStep) );
				break;
				case 'week':
					dateObj.setDate( dateObj.getDate() + (inc * attrStep * 7) );
				break;
				case 'date':
				default:
					dateObj.setDate( dateObj.getDate() + (inc * attrStep) );
				break;
			}
			var dateTime = dateObj.getTime()/1000;
				dateTime = (attrMin && attrMin > dateTime) ? attrMin : (attrMax && attrMax < dateTime) ? attrMax : dateTime;

			dateObj.setTime( dateTime*1000 );

			ret = epages.localize.obj2date( dateObj , this._attr.type );

			dj.attr( this.domNode , 'value' , ret );
		},

		_validate: function(){
			var value = dj.attr( this.domNode , 'value' );
			var valide = false;

			if( value=='' && !this._attr.required ){
				valide = true;
			}
			else if( value.match(new RegExp('^'+this._attr.pattern+'$')) ){
				var dateTime = epages.localize.date2obj( value , this._attr.type ).getTime()/1000;
				var attrMin = this._attr.min;
				var attrMax = this._attr.max;

				valide = (attrMin && attrMin > dateTime) ? false : (attrMax && attrMax < dateTime) ? false : true;

			}
			return valide;
		}

	});

})(dojo);

}

if(!dojo._hasResource["epages.widget.FormElement"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.FormElement"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.widget.FormElement $Revision: 1.22 $

*/

dojo.provide("epages.widget.FormElement");


(function(dj){

	epages.changeInputType = function( node, type ){
			var _node = dj.clone(node);
				dj.attr( _node , 'type' , type );
				dj.attr( _node , 'value' , node.value );
				dj.place( _node , node , 'after' );
				_node.parentNode.removeChild(node);
			return _node;
		};

	epages.widget.FormElement = function( options, domNode ){
		this.destroy();

		var nodeName = domNode.nodeName.toLowerCase(),
			nodeType,
			widget;

		if( nodeName == 'select' ){
			widget = new epages.widget.FormSelect(options,domNode);
		}
		else if( nodeName == 'textarea' ){
			widget = new epages.widget.FormText(options,domNode);
		}
		else{
			if( dojo.hasClass( domNode, 'Checkbox' ) ){
				domNode = domNode.type != 'checkbox' ? epages.changeInputType( domNode, 'checkbox' ) : domNode;
				widget = new epages.widget.FormCheck(options,domNode);
			}
			else if( dojo.hasClass( domNode, 'Radio' ) ){
				domNode = domNode.type != 'radio' ? epages.changeInputType( domNode, 'radio' ) : domNode;
				widget = new epages.widget.FormCheck(options,domNode);
			}

			nodeType = domNode.getAttribute('type');

			if( /^(file)$/i.test(nodeType) ){
				widget = new epages.widget.FormFile(options,domNode);
			}
			else if( /^(text|password)$/i.test(nodeType) ){
				widget = new epages.widget.FormText(options,domNode);
			}
		}

		if( widget ){

			widget.elementNode = widget.domNode;
			widget.setValue = function( val ) {
				return this.attr( 'value', val );
			}

			widget.setStartUpValue = function( val ) {
				this.attr( 'startupValue', val );
				this.validate();

				return this;
			}

			widget.getValue = function() {
				return this.attr( 'value' );
			}

			widget.isChecked = function() {
				return this.attr( 'checked' );
			}

			widget.setChecked = function( val ){
				return this.attr( 'checked', val );
			}

			return widget;
		}
	};
	epages.widget.FormElement.prototype = new dijit._Widget();

})(dojo);

}

if(!dojo._hasResource['epages.template']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.template'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.template $Revision: 1.20 $

*/
dojo.provide('epages.template');




$TMPL = /*epages.Template*/function (/*string*/template,/*hash*/ vars, /*boolean?*/ encodeVars, /*boolean?*/ enableRegExVars) {
	if(encodeVars === undefined){
		encodeVars=true;
	}
	if(enableRegExVars === undefined){	// default reg ex vars are allowed
		enableRegExVars=true;
	}

	return new epages.Template({
		template: template,
		vars: vars,
		encodeVars: encodeVars,
		enableRegExVars : enableRegExVars
	});
};

epages.Template = function(options) {
	this.setOptions(options);

	// get Template from DOM
	if (this.options.template === undefined && this.options.templateDom != undefined) {
		if (typeof this.options.templateDom != 'object'){
			this.options.templateDom = $(this.options.templateDom);
		}
		this.options.template = $E(this.options.templateDom).firstComment();
	}
};

epages.Template.prototype = {
	options : undefined,

	setOptions: function(options) {
		this.options = {
			encodeVars  : true,
			enableRegExVars: false,
			templateDom : undefined,
			template    : undefined,
			vars        : undefined,
			addTemplate : true
		};
		dojo.mixin(this.options, options);
	},

	setTemplate: function (template) {
		this.options.template = template;
	},

	encodeXml: function(string) {
		if (string !== undefined) {
			if (typeof string == "number"){
				string = string.toString();
			}
			string = string
				.replace(/&/g,"&amp;")     // qoute &
				.replace(/"/g,"&quot;")    // qoute "
				.replace(/>/g,"&gt;")      // qoute >
				.replace(/</g,"&lt;");     // qoute <
		}
		return string;
	},

	maskRegExVars: function(string) {
		if (string !== undefined) {
			if (typeof string == "number"){
				string = string.toString();
			}
			if (typeof string == "string"){
				string = string.replace(/\$/g, "\\$");     // mask $
			}
		}
		return string;
	},

	unmaskRegExVars: function(string) {
		if (string !== undefined) {
			if (typeof string == "number"){
				string = string.toString();
			}
			if (typeof string == "string"){
				string = string.replace(/\\\$/g, "$");     // unmask $
			}
		}
		return string;
	},

	processHash: function(vars) {
		// declare some vars for iterator function
		if (vars.each === undefined){
			vars = $H(vars);
		}
		var template=this.options.template;
		if (template === undefined) {
			console.warn('epages.Template: template is empty');
			return '';
		}

		var me=this;
		// insert hash vars into template
		var iterator= function(pair) {
			var tempValue = pair.value;
			var encValue = me.options.encodeVars ? me.encodeXml(tempValue) : tempValue;
			// insert string
			encValue = me.options.enableRegExVars ? encValue : me.maskRegExVars(encValue);

			var templateRegExp = new RegExp('\\(%' + pair.key + '%\\)', "g" );
			template = template.replace( templateRegExp, encValue );
			template = me.options.enableRegExVars ? template : me.unmaskRegExVars(template);
		};
		// call iterator for each key/value pair
		vars.each(iterator);
		return template;
	},

	processLoop: function(loop) {
		var content = '';
		var me=this;
		loop.each(function (el) {
			content += me.processHash(el);
		});
		return content;
	},

	generateOutput: function () {
		return this.processHash(this.options.vars);
	},

	insertTemplate: function (element) {
		if (!this.options.addTemplate){
			return;
		}
		var comment = document.createElement("COMMENT");
		comment.data = this.options.template;
		// element.insertAdjacentElement("afterBegin",comment);
		if (element.firstChild === undefined){
			element.insertChild(comment);
		}else{
			element.insertBefore(comment, element.firstChild);
		}
		return;
	},

	insertLoop: function (loop, targetDom) {
		if (targetDom === undefined){
			targetDom = this.options.templateDom;
		}
		if (typeof this.options.targetDom != 'object'){
			targetDom = $(targetDom);
		}
		targetDom.innerHTML = this.processLoop(loop);
		this.insertTemplate(targetDom);
	},

	insert: function(targetDom) {
		if (targetDom === undefined){
			targetDom = this.options.templateDom;
		}
		if (typeof this.options.targetDom != 'object'){
			targetDom = $(targetDom);
		}
		targetDom.innerHTML = this.generateOutput();
		this.processTemplate(targetDom);
	}
};

}

if(!dojo._hasResource["dojo.html"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.html"] = true;
dojo.provide("dojo.html");

// the parser might be needed..
 

(function(){ // private scope, sort of a namespace

	// idCounter is incremented with each instantiation to allow asignment of a unique id for tracking, logging purposes
	var idCounter = 0, 
		d = dojo;
	
	dojo.html._secureForInnerHtml = function(/*String*/ cont){
		// summary:
		//		removes !DOCTYPE and title elements from the html string.
		// 
		//		khtml is picky about dom faults, you can't attach a style or <title> node as child of body
		//		must go into head, so we need to cut out those tags
		//	cont:
		//		An html string for insertion into the dom
		//	
		return cont.replace(/(?:\s*<!DOCTYPE\s[^>]+>|<title[^>]*>[\s\S]*?<\/title>)/ig, ""); // String
	};

/*====
	dojo.html._emptyNode = function(node){
		// summary:
		//		removes all child nodes from the given node
		//	node: DOMNode
		//		the parent element
	};
=====*/
	dojo.html._emptyNode = dojo.empty;

	dojo.html._setNodeContent = function(/* DomNode */ node, /* String|DomNode|NodeList */ cont){
		// summary:
		//		inserts the given content into the given node
		//	node:
		//		the parent element
		//	content:
		//		the content to be set on the parent element. 
		//		This can be an html string, a node reference or a NodeList, dojo.NodeList, Array or other enumerable list of nodes
		
		// always empty
		d.empty(node);

		if(cont) {
			if(typeof cont == "string") {
				cont = d._toDom(cont, node.ownerDocument);
			}
			if(!cont.nodeType && d.isArrayLike(cont)) {
				// handle as enumerable, but it may shrink as we enumerate it
				for(var startlen=cont.length, i=0; i<cont.length; i=startlen==cont.length ? i+1 : 0) {
					d.place( cont[i], node, "last");
				}
			} else {
				// pass nodes, documentFragments and unknowns through to dojo.place
				d.place(cont, node, "last");
			}
		}

		// return DomNode
		return node;
	};

	// we wrap up the content-setting operation in a object
	dojo.declare("dojo.html._ContentSetter", null, 
		{
			// node: DomNode|String
			//		An node which will be the parent element that we set content into
			node: "",

			// content: String|DomNode|DomNode[]
			//		The content to be placed in the node. Can be an HTML string, a node reference, or a enumerable list of nodes
			content: "",
			
			// id: String?
			//		Usually only used internally, and auto-generated with each instance 
			id: "",

			// cleanContent: Boolean
			//		Should the content be treated as a full html document, 
			//		and the real content stripped of <html>, <body> wrapper before injection
			cleanContent: false,
			
			// extractContent: Boolean
			//		Should the content be treated as a full html document, and the real content stripped of <html>, <body> wrapper before injection
			extractContent: false,

			// parseContent: Boolean
			//		Should the node by passed to the parser after the new content is set
			parseContent: false,
			
			// lifecyle methods
			constructor: function(/* Object */params, /* String|DomNode */node){
				//	summary:
				//		Provides a configurable, extensible object to wrap the setting on content on a node
				//		call the set() method to actually set the content..
 
				// the original params are mixed directly into the instance "this"
				dojo.mixin(this, params || {});

				// give precedence to params.node vs. the node argument
				// and ensure its a node, not an id string
				node = this.node = dojo.byId( this.node || node );
	
				if(!this.id){
					this.id = [
						"Setter",
						(node) ? node.id || node.tagName : "", 
						idCounter++
					].join("_");
				}

				if(! (this.node || node)){
					new Error(this.declaredClass + ": no node provided to " + this.id);
				}
			},
			set: function(/* String|DomNode|NodeList? */ cont, /* Object? */ params){
				// summary:
				//		front-end to the set-content sequence 
				//	cont:
				//		An html string, node or enumerable list of nodes for insertion into the dom
				//		If not provided, the object's content property will be used
				if(undefined !== cont){
					this.content = cont;
				}
				// in the re-use scenario, set needs to be able to mixin new configuration
				if(params){
					this._mixin(params);
				}

				this.onBegin();
				this.setContent();
				this.onEnd();

				return this.node;
			},
			setContent: function(){
				// summary:
				//		sets the content on the node 

				var node = this.node; 
				if(!node) {
					console.error("setContent given no node");
				}
				try{
					node = dojo.html._setNodeContent(node, this.content);
				}catch(e){
					// check if a domfault occurs when we are appending this.errorMessage
					// like for instance if domNode is a UL and we try append a DIV
	
					// FIXME: need to allow the user to provide a content error message string
					var errMess = this.onContentError(e); 
					try{
						node.innerHTML = errMess;
					}catch(e){
						console.error('Fatal ' + this.declaredClass + '.setContent could not change content due to '+e.message, e);
					}
				}
				// always put back the node for the next method
				this.node = node; // DomNode
			},
			
			empty: function() {
				// summary
				//	cleanly empty out existing content

				// destroy any widgets from a previous run
				// NOTE: if you dont want this you'll need to empty 
				// the parseResults array property yourself to avoid bad things happenning
				if(this.parseResults && this.parseResults.length) {
					dojo.forEach(this.parseResults, function(w) {
						if(w.destroy){
							w.destroy();
						}
					});
					delete this.parseResults;
				}
				// this is fast, but if you know its already empty or safe, you could 
				// override empty to skip this step
				dojo.html._emptyNode(this.node);
			},
	
			onBegin: function(){
				// summary
				//		Called after instantiation, but before set(); 
				//		It allows modification of any of the object properties 
				//		- including the node and content provided - before the set operation actually takes place
				//		This default implementation checks for cleanContent and extractContent flags to 
				//		optionally pre-process html string content
				var cont = this.content;
	
				if(dojo.isString(cont)){
					if(this.cleanContent){
						cont = dojo.html._secureForInnerHtml(cont);
					}
  
					if(this.extractContent){
						var match = cont.match(/<body[^>]*>\s*([\s\S]+)\s*<\/body>/im);
						if(match){ cont = match[1]; }
					}
				}

				// clean out the node and any cruft associated with it - like widgets
				this.empty();
				
				this.content = cont;
				return this.node; /* DomNode */
			},
	
			onEnd: function(){
				// summary
				//		Called after set(), when the new content has been pushed into the node
				//		It provides an opportunity for post-processing before handing back the node to the caller
				//		This default implementation checks a parseContent flag to optionally run the dojo parser over the new content
				if(this.parseContent){
					// populates this.parseResults if you need those..
					this._parse();
				}
				return this.node; /* DomNode */
			},
	
			tearDown: function(){
				// summary
				//		manually reset the Setter instance if its being re-used for example for another set()
				// description
				//		tearDown() is not called automatically. 
				//		In normal use, the Setter instance properties are simply allowed to fall out of scope
				//		but the tearDown method can be called to explicitly reset this instance.
				delete this.parseResults; 
				delete this.node; 
				delete this.content; 
			},
  
			onContentError: function(err){
				return "Error occured setting content: " + err; 
			},
			
			_mixin: function(params){
				// mix properties/methods into the instance
				// TODO: the intention with tearDown is to put the Setter's state 
				// back to that of the original constructor (vs. deleting/resetting everything regardless of ctor params)
				// so we could do something here to move the original properties aside for later restoration
				var empty = {}, key;
				for(key in params){
					if(key in empty){ continue; }
					// TODO: here's our opportunity to mask the properties we dont consider configurable/overridable
					// .. but history shows we'll almost always guess wrong
					this[key] = params[key]; 
				}
			},
			_parse: function(){
				// summary: 
				//		runs the dojo parser over the node contents, storing any results in this.parseResults
				//		Any errors resulting from parsing are passed to _onError for handling

				var rootNode = this.node;
				try{
					// store the results (widgets, whatever) for potential retrieval
					this.parseResults = dojo.parser.parse(rootNode, true);
				}catch(e){
					this._onError('Content', e, "Error parsing in _ContentSetter#"+this.id);
				}
			},
  
			_onError: function(type, err, consoleText){
				// summary:
				//		shows user the string that is returned by on[type]Error
				//		overide/implement on[type]Error and return your own string to customize
				var errText = this['on' + type + 'Error'].call(this, err);
				if(consoleText){
					console.error(consoleText, err);
				}else if(errText){ // a empty string won't change current content
					dojo.html._setNodeContent(this.node, errText, true);
				}
			}
	}); // end dojo.declare()

	dojo.html.set = function(/* DomNode */ node, /* String|DomNode|NodeList */ cont, /* Object? */ params){
			// summary:
			//		inserts (replaces) the given content into the given node. dojo.place(cont, node, "only")
			//		may be a better choice for simple HTML insertion.
			// description:
			//		Unless you need to use the params capabilities of this method, you should use
			//		dojo.place(cont, node, "only"). dojo.place() has more robust support for injecting
			//		an HTML string into the DOM, but it only handles inserting an HTML string as DOM
			//		elements, or inserting a DOM node. dojo.place does not handle NodeList insertions
			//		or the other capabilities as defined by the params object for this method.
			//	node:
			//		the parent element that will receive the content
			//	cont:
			//		the content to be set on the parent element. 
			//		This can be an html string, a node reference or a NodeList, dojo.NodeList, Array or other enumerable list of nodes
			//	params: 
			//		Optional flags/properties to configure the content-setting. See dojo.html._ContentSetter
			//	example:
			//		A safe string/node/nodelist content replacement/injection with hooks for extension
			//		Example Usage: 
			//		dojo.html.set(node, "some string"); 
			//		dojo.html.set(node, contentNode, {options}); 
			//		dojo.html.set(node, myNode.childNodes, {options}); 
		if(undefined == cont){
			console.warn("dojo.html.set: no cont argument provided, using empty string");
			cont = "";
		}	
		if(!params){
			// simple and fast
			return dojo.html._setNodeContent(node, cont, true);
		}else{ 
			// more options but slower
			// note the arguments are reversed in order, to match the convention for instantiation via the parser
			var op = new dojo.html._ContentSetter(dojo.mixin( 
					params, 
					{ content: cont, node: node } 
			));
			return op.set();
		}
	};
})();

}

if(!dojo._hasResource["dijit.layout.ContentPane"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.layout.ContentPane"] = true;
dojo.provide("dijit.layout.ContentPane");



	// for dijit.layout.marginBox2contentBox()






dojo.declare(
	"dijit.layout.ContentPane", dijit._Widget,
{
	// summary:
	//		A widget that acts as a container for mixed HTML and widgets, and includes an Ajax interface
	// description:
	//		A widget that can be used as a stand alone widget
	//		or as a base class for other widgets.
	//
	//		Handles replacement of document fragment using either external uri or javascript
	//		generated markup or DOM content, instantiating widgets within that content.
	//		Don't confuse it with an iframe, it only needs/wants document fragments.
	//		It's useful as a child of LayoutContainer, SplitContainer, or TabContainer.
	//		But note that those classes can contain any widget as a child.
	// example:
	//		Some quick samples:
	//		To change the innerHTML use .attr('content', '<b>new content</b>')
	//
	//		Or you can send it a NodeList, .attr('content', dojo.query('div [class=selected]', userSelection))
	//		please note that the nodes in NodeList will copied, not moved
	//
	//		To do a ajax update use .attr('href', url)

	// href: String
	//		The href of the content that displays now.
	//		Set this at construction if you want to load data externally when the
	//		pane is shown.  (Set preload=true to load it immediately.)
	//		Changing href after creation doesn't have any effect; use attr('href', ...);
	href: "",

/*=====
	// content: String || DomNode || NodeList || dijit._Widget
	//		The innerHTML of the ContentPane.
	//		Note that the initialization parameter / argument to attr("content", ...)
	//		can be a String, DomNode, Nodelist, or _Widget.
	content: "",
=====*/

	// extractContent: Boolean
	//		Extract visible content from inside of <body> .... </body>.
	//		I.e., strip <html> and <head> (and it's contents) from the href
	extractContent: false,

	// parseOnLoad: Boolean
	//		Parse content and create the widgets, if any.
	parseOnLoad: true,

	// preventCache: Boolean
	//		Prevent caching of data from href's by appending a timestamp to the href.
	preventCache: false,

	// preload: Boolean
	//		Force load of data on initialization even if pane is hidden.
	preload: false,

	// refreshOnShow: Boolean
	//		Refresh (re-download) content when pane goes from hidden to shown
	refreshOnShow: false,

	// loadingMessage: String
	//		Message that shows while downloading
	loadingMessage: "<span class='dijitContentPaneLoading'>${loadingState}</span>",

	// errorMessage: String
	//		Message that shows if an error occurs
	errorMessage: "<span class='dijitContentPaneError'>${errorState}</span>",

	// isLoaded: [readonly] Boolean
	//		True if the ContentPane has data in it, either specified
	//		during initialization (via href or inline content), or set
	//		via attr('content', ...) / attr('href', ...)
	//
	//		False if it doesn't have any content, or if ContentPane is
	//		still in the process of downloading href.
	isLoaded: false,

	baseClass: "dijitContentPane",

	// doLayout: Boolean
	//		- false - don't adjust size of children
	//		- true - if there is a single visible child widget, set it's size to
	//				however big the ContentPane is
	doLayout: true,

	// ioArgs: Object
	//		Parameters to pass to xhrGet() request, for example:
	// |	<div dojoType="dijit.layout.ContentPane" href="./bar" ioArgs="{timeout: 500}">
	ioArgs: {},

	// isContainer: [protected] Boolean
	//		Indicates that this widget acts as a "parent" to the descendant widgets.
	//		When the parent is started it will call startup() on the child widgets.
	//		See also `isLayoutContainer`.
	isContainer: true,

	// isLayoutContainer: [protected] Boolean
	//		Indicates that this widget will call resize() on it's child widgets
	//		when they become visible.
	isLayoutContainer: true,

	// onLoadDeferred: [readonly] dojo.Deferred
	//		This is the `dojo.Deferred` returned by attr('href', ...) and refresh().
	//		Calling onLoadDeferred.addCallback() or addErrback() registers your
	//		callback to be called only once, when the prior attr('href', ...) call or
	//		the initial href parameter to the constructor finishes loading.
	//
	//		This is different than an onLoad() handler which gets called any time any href is loaded.
	onLoadDeferred: null,

	// Override _Widget's attributeMap because we don't want the title attribute (used to specify
	// tab labels) to be copied to ContentPane.domNode... otherwise a tooltip shows up over the
	// entire pane.
	attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
		title: []
	}),

	postMixInProperties: function(){
		this.inherited(arguments);
		var messages = dojo.i18n.getLocalization("dijit", "loading", this.lang);
		this.loadingMessage = dojo.string.substitute(this.loadingMessage, messages);
		this.errorMessage = dojo.string.substitute(this.errorMessage, messages);

		// Detect if we were initialized with data
		if(!this.href && this.srcNodeRef && this.srcNodeRef.innerHTML){
			this.isLoaded = true;
		}
	},

	buildRendering: function(){
		// Overrides Widget.buildRendering().
		// Since we have no template we need to set this.containerNode ourselves.
		// For subclasses of ContentPane do have a template, does nothing.
		this.inherited(arguments);
		if(!this.containerNode){
			// make getDescendants() work
			this.containerNode = this.domNode;
		}
	},

	postCreate: function(){
		// remove the title attribute so it doesn't show up when hovering
		// over a node
		this.domNode.title = "";

		if(!dojo.attr(this.domNode,"role")){
			dijit.setWaiRole(this.domNode, "group");
		}

		dojo.addClass(this.domNode, this.baseClass);
	},

	startup: function(){
		// summary:
		//		See `dijit.layout._LayoutWidget.startup` for description.
		//		Although ContentPane doesn't extend _LayoutWidget, it does implement
		//		the same API.
		if(this._started){ return; }

		var parent = dijit._Contained.prototype.getParent.call(this);
		this._childOfLayoutWidget = parent && parent.isLayoutContainer;

		// I need to call resize() on my child/children (when I become visible), unless
		// I'm the child of a layout widget in which case my parent will call resize() on me and I'll do it then.
		this._needLayout = !this._childOfLayoutWidget;

		if(this.isLoaded){
			dojo.forEach(this.getChildren(), function(child){
				child.startup();
			});
		}

		if(this._isShown() || this.preload){
			this._onShow();
		}

		this.inherited(arguments);
	},

	_checkIfSingleChild: function(){
		// summary:
		//		Test if we have exactly one visible widget as a child,
		//		and if so assume that we are a container for that widget,
		//		and should propogate startup() and resize() calls to it.
		//		Skips over things like data stores since they aren't visible.

		var childNodes = dojo.query("> *", this.containerNode).filter(function(node){
				return node.tagName !== "SCRIPT"; // or a regexp for hidden elements like script|area|map|etc..
			}),
			childWidgetNodes = childNodes.filter(function(node){
				return dojo.hasAttr(node, "dojoType") || dojo.hasAttr(node, "widgetId");
			}),
			candidateWidgets = dojo.filter(childWidgetNodes.map(dijit.byNode), function(widget){
				return widget && widget.domNode && widget.resize;
			});

		if(
			// all child nodes are widgets
			childNodes.length == childWidgetNodes.length &&

			// all but one are invisible (like dojo.data)
			candidateWidgets.length == 1
		){
			this._singleChild = candidateWidgets[0];
		}else{
			delete this._singleChild;
		}

		// So we can set overflow: hidden to avoid a safari bug w/scrollbars showing up (#9449)
		dojo.toggleClass(this.containerNode, this.baseClass + "SingleChild", !!this._singleChild);
	},

	setHref: function(/*String|Uri*/ href){
		// summary:
		//		Deprecated.   Use attr('href', ...) instead.
		dojo.deprecated("dijit.layout.ContentPane.setHref() is deprecated. Use attr('href', ...) instead.", "", "2.0");
		return this.attr("href", href);
	},
	_setHrefAttr: function(/*String|Uri*/ href){
		// summary:
		//		Hook so attr("href", ...) works.
		// description:
		//		Reset the (external defined) content of this pane and replace with new url
		//		Note: It delays the download until widget is shown if preload is false.
		//	href:
		//		url to the page you want to get, must be within the same domain as your mainpage

		// Cancel any in-flight requests (an attr('href') will cancel any in-flight attr('href', ...))
		this.cancel();

		this.onLoadDeferred = new dojo.Deferred(dojo.hitch(this, "cancel"));

		this.href = href;

		// _setHrefAttr() is called during creation and by the user, after creation.
		// only in the second case do we actually load the URL; otherwise it's done in startup()
		if(this._created && (this.preload || this._isShown())){
			this._load();
		}else{
			// Set flag to indicate that href needs to be loaded the next time the
			// ContentPane is made visible
			this._hrefChanged = true;
		}

		return this.onLoadDeferred;		// dojo.Deferred
	},

	setContent: function(/*String|DomNode|Nodelist*/data){
		// summary:
		//		Deprecated.   Use attr('content', ...) instead.
		dojo.deprecated("dijit.layout.ContentPane.setContent() is deprecated.  Use attr('content', ...) instead.", "", "2.0");
		this.attr("content", data);
	},
	_setContentAttr: function(/*String|DomNode|Nodelist*/data){
		// summary:
		//		Hook to make attr("content", ...) work.
		//		Replaces old content with data content, include style classes from old content
		//	data:
		//		the new Content may be String, DomNode or NodeList
		//
		//		if data is a NodeList (or an array of nodes) nodes are copied
		//		so you can import nodes from another document implicitly

		// clear href so we can't run refresh and clear content
		// refresh should only work if we downloaded the content
		this.href = "";

		// Cancel any in-flight requests (an attr('content') will cancel any in-flight attr('href', ...))
		this.cancel();

		// Even though user is just setting content directly, still need to define an onLoadDeferred
		// because the _onLoadHandler() handler is still getting called from setContent()
		this.onLoadDeferred = new dojo.Deferred(dojo.hitch(this, "cancel"));

		this._setContent(data || "");

		this._isDownloaded = false; // mark that content is from a attr('content') not an attr('href')

		return this.onLoadDeferred; 	// dojo.Deferred
	},
	_getContentAttr: function(){
		// summary:
		//		Hook to make attr("content") work
		return this.containerNode.innerHTML;
	},

	cancel: function(){
		// summary:
		//		Cancels an in-flight download of content
		if(this._xhrDfd && (this._xhrDfd.fired == -1)){
			this._xhrDfd.cancel();
		}
		delete this._xhrDfd; // garbage collect

		this.onLoadDeferred = null;
	},

	uninitialize: function(){
		if(this._beingDestroyed){
			this.cancel();
		}
		this.inherited(arguments);
	},

	destroyRecursive: function(/*Boolean*/ preserveDom){
		// summary:
		//		Destroy the ContentPane and its contents

		// if we have multiple controllers destroying us, bail after the first
		if(this._beingDestroyed){
			return;
		}
		this.inherited(arguments);
	},

	resize: function(changeSize, resultSize){
		// summary:
		//		See `dijit.layout._LayoutWidget.resize` for description.
		//		Although ContentPane doesn't extend _LayoutWidget, it does implement
		//		the same API.

		// For the TabContainer --> BorderContainer --> ContentPane case, _onShow() is
		// never called, so resize() is our trigger to do the initial href download.
		if(!this._wasShown){
			this._onShow();
		}

		this._resizeCalled = true;

		// Set margin box size, unless it wasn't specified, in which case use current size.
		if(changeSize){
			dojo.marginBox(this.domNode, changeSize);
		}

		// Compute content box size of containerNode in case we [later] need to size our single child.
		var cn = this.containerNode;
		if(cn === this.domNode){
			// If changeSize or resultSize was passed to this method and this.containerNode ==
			// this.domNode then we can compute the content-box size without querying the node,
			// which is more reliable (similar to LayoutWidget.resize) (see for example #9449).
			var mb = resultSize || {};
			dojo.mixin(mb, changeSize || {}); // changeSize overrides resultSize
			if(!("h" in mb) || !("w" in mb)){
				mb = dojo.mixin(dojo.marginBox(cn), mb); // just use dojo.marginBox() to fill in missing values
			}
			this._contentBox = dijit.layout.marginBox2contentBox(cn, mb);
		}else{
			this._contentBox = dojo.contentBox(cn);
		}

		// Make my children layout, or size my single child widget
		this._layoutChildren();
	},

	_isShown: function(){
		// summary:
		//		Returns true if the content is currently shown.
		// description:
		//		If I am a child of a layout widget then it actually returns true if I've ever been visible,
		//		not whether I'm currently visible, since that's much faster than tracing up the DOM/widget
		//		tree every call, and at least solves the performance problem on page load by deferring loading
		//		hidden ContentPanes until they are first shown

		if(this._childOfLayoutWidget){
			// If we are TitlePane, etc - we return that only *IF* we've been resized
			if(this._resizeCalled && "open" in this){
				return this.open;
			}
			return this._resizeCalled;
		}else if("open" in this){
			return this.open;		// for TitlePane, etc.
		}else{
			// TODO: with _childOfLayoutWidget check maybe this branch no longer necessary?
			var node = this.domNode;
			return (node.style.display != 'none') && (node.style.visibility != 'hidden') && !dojo.hasClass(node, "dijitHidden");
		}
	},

	_onShow: function(){
		// summary:
		//		Called when the ContentPane is made visible
		// description:
		//		For a plain ContentPane, this is called on initialization, from startup().
		//		If the ContentPane is a hidden pane of a TabContainer etc., then it's
		//		called whenever the pane is made visible.
		//
		//		Does necessary processing, including href download and layout/resize of
		//		child widget(s)

		if(this.href){
			if(!this._xhrDfd && // if there's an href that isn't already being loaded
				(!this.isLoaded || this._hrefChanged || this.refreshOnShow)
			){
				this.refresh();
			}
		}else{
			// If we are the child of a layout widget then the layout widget will call resize() on
			// us, and then we will size our child/children.   Otherwise, we need to do it now.
			if(!this._childOfLayoutWidget && this._needLayout){
				// If a layout has been scheduled for when we become visible, do it now
				this._layoutChildren();
			}
		}

		this.inherited(arguments);

		// Need to keep track of whether ContentPane has been shown (which is different than
		// whether or not it's currently visible).
		this._wasShown = true;
	},

	refresh: function(){
		// summary:
		//		[Re]download contents of href and display
		// description:
		//		1. cancels any currently in-flight requests
		//		2. posts "loading..." message
		//		3. sends XHR to download new data

		// Cancel possible prior in-flight request
		this.cancel();

		this.onLoadDeferred = new dojo.Deferred(dojo.hitch(this, "cancel"));
		this._load();
		return this.onLoadDeferred;
	},

	_load: function(){
		// summary:
		//		Load/reload the href specified in this.href

		// display loading message
		this._setContent(this.onDownloadStart(), true);

		var self = this;
		var getArgs = {
			preventCache: (this.preventCache || this.refreshOnShow),
			url: this.href,
			handleAs: "text"
		};
		if(dojo.isObject(this.ioArgs)){
			dojo.mixin(getArgs, this.ioArgs);
		}

		var hand = (this._xhrDfd = (this.ioMethod || dojo.xhrGet)(getArgs));

		hand.addCallback(function(html){
			try{
				self._isDownloaded = true;
				self._setContent(html, false);
				self.onDownloadEnd();
			}catch(err){
				self._onError('Content', err); // onContentError
			}
			delete self._xhrDfd;
			return html;
		});

		hand.addErrback(function(err){
			if(!hand.canceled){
				// show error message in the pane
				self._onError('Download', err); // onDownloadError
			}
			delete self._xhrDfd;
			return err;
		});

		// Remove flag saying that a load is needed
		delete this._hrefChanged;
	},

	_onLoadHandler: function(data){
		// summary:
		//		This is called whenever new content is being loaded
		this.isLoaded = true;
		try{
			this.onLoadDeferred.callback(data);
			this.onLoad(data);
		}catch(e){
			console.error('Error '+this.widgetId+' running custom onLoad code: ' + e.message);
		}
	},

	_onUnloadHandler: function(){
		// summary:
		//		This is called whenever the content is being unloaded
		this.isLoaded = false;
		try{
			this.onUnload();
		}catch(e){
			console.error('Error '+this.widgetId+' running custom onUnload code: ' + e.message);
		}
	},

	destroyDescendants: function(){
		// summary:
		//		Destroy all the widgets inside the ContentPane and empty containerNode

		// Make sure we call onUnload (but only when the ContentPane has real content)
		if(this.isLoaded){
			this._onUnloadHandler();
		}

		// Even if this.isLoaded == false there might still be a "Loading..." message
		// to erase, so continue...

		// For historical reasons we need to delete all widgets under this.containerNode,
		// even ones that the user has created manually.
		var setter = this._contentSetter;
		dojo.forEach(this.getChildren(), function(widget){
			if(widget.destroyRecursive){
				widget.destroyRecursive();
			}
		});
		if(setter){
			// Most of the widgets in setter.parseResults have already been destroyed, but
			// things like Menu that have been moved to <body> haven't yet
			dojo.forEach(setter.parseResults, function(widget){
				if(widget.destroyRecursive && widget.domNode && widget.domNode.parentNode == dojo.body()){
					widget.destroyRecursive();
				}
			});
			delete setter.parseResults;
		}

		// And then clear away all the DOM nodes
		dojo.html._emptyNode(this.containerNode);

		// Delete any state information we have about current contents
		delete this._singleChild;
	},

	_setContent: function(cont, isFakeContent){
		// summary:
		//		Insert the content into the container node

		// first get rid of child widgets
		this.destroyDescendants();

		// dojo.html.set will take care of the rest of the details
		// we provide an override for the error handling to ensure the widget gets the errors
		// configure the setter instance with only the relevant widget instance properties
		// NOTE: unless we hook into attr, or provide property setters for each property,
		// we need to re-configure the ContentSetter with each use
		var setter = this._contentSetter;
		if(! (setter && setter instanceof dojo.html._ContentSetter)){
			setter = this._contentSetter = new dojo.html._ContentSetter({
				node: this.containerNode,
				_onError: dojo.hitch(this, this._onError),
				onContentError: dojo.hitch(this, function(e){
					// fires if a domfault occurs when we are appending this.errorMessage
					// like for instance if domNode is a UL and we try append a DIV
					var errMess = this.onContentError(e);
					try{
						this.containerNode.innerHTML = errMess;
					}catch(e){
						console.error('Fatal '+this.id+' could not change content due to '+e.message, e);
					}
				})/*,
				_onError */
			});
		};

		var setterParams = dojo.mixin({
			cleanContent: this.cleanContent,
			extractContent: this.extractContent,
			parseContent: this.parseOnLoad
		}, this._contentSetterParams || {});

		dojo.mixin(setter, setterParams);

		setter.set( (dojo.isObject(cont) && cont.domNode) ? cont.domNode : cont );

		// setter params must be pulled afresh from the ContentPane each time
		delete this._contentSetterParams;

		if(!isFakeContent){
			// Startup each top level child widget (and they will start their children, recursively)
			dojo.forEach(this.getChildren(), function(child){
				// The parser has already called startup on all widgets *without* a getParent() method
				if(!this.parseOnLoad || child.getParent){
					child.startup();
				}
			}, this);

			// Call resize() on each of my child layout widgets,
			// or resize() on my single child layout widget...
			// either now (if I'm currently visible)
			// or when I become visible
			this._scheduleLayout();

			this._onLoadHandler(cont);
		}
	},

	_onError: function(type, err, consoleText){
		this.onLoadDeferred.errback(err);

		// shows user the string that is returned by on[type]Error
		// overide on[type]Error and return your own string to customize
		var errText = this['on' + type + 'Error'].call(this, err);
		if(consoleText){
			console.error(consoleText, err);
		}else if(errText){// a empty string won't change current content
			this._setContent(errText, true);
		}
	},

	_scheduleLayout: function(){
		// summary:
		//		Call resize() on each of my child layout widgets, either now
		//		(if I'm currently visible) or when I become visible
		if(this._isShown()){
			this._layoutChildren();
		}else{
			this._needLayout = true;
		}
	},

	_layoutChildren: function(){
		// summary:
		//		Since I am a Container widget, each of my children expects me to
		//		call resize() or layout() on them.
		// description:
		//		Should be called on initialization and also whenever we get new content
		//		(from an href, or from attr('content', ...))... but deferred until
		//		the ContentPane is visible

		if(this.doLayout){
			this._checkIfSingleChild();
		}

		if(this._singleChild && this._singleChild.resize){
			var cb = this._contentBox || dojo.contentBox(this.containerNode);

			// note: if widget has padding this._contentBox will have l and t set,
			// but don't pass them to resize() or it will doubly-offset the child
			this._singleChild.resize({w: cb.w, h: cb.h});
		}else{
			// All my child widgets are independently sized (rather than matching my size),
			// but I still need to call resize() on each child to make it layout.
			dojo.forEach(this.getChildren(), function(widget){
				if(widget.resize){
					widget.resize();
				}
			});
		}
		delete this._needLayout;
	},

	// EVENT's, should be overide-able
	onLoad: function(data){
		// summary:
		//		Event hook, is called after everything is loaded and widgetified
		// tags:
		//		callback
	},

	onUnload: function(){
		// summary:
		//		Event hook, is called before old content is cleared
		// tags:
		//		callback
	},

	onDownloadStart: function(){
		// summary:
		//		Called before download starts.
		// description:
		//		The string returned by this function will be the html
		//		that tells the user we are loading something.
		//		Override with your own function if you want to change text.
		// tags:
		//		extension
		return this.loadingMessage;
	},

	onContentError: function(/*Error*/ error){
		// summary:
		//		Called on DOM faults, require faults etc. in content.
		//
		//		In order to display an error message in the pane, return
		//		the error message from this method, as an HTML string.
		//
		//		By default (if this method is not overriden), it returns
		//		nothing, so the error message is just printed to the console.
		// tags:
		//		extension
	},

	onDownloadError: function(/*Error*/ error){
		// summary:
		//		Called when download error occurs.
		//
		//		In order to display an error message in the pane, return
		//		the error message from this method, as an HTML string.
		//
		//		Default behavior (if this method is not overriden) is to display
		//		the error message inside the pane.
		// tags:
		//		extension
		return this.errorMessage;
	},

	onDownloadEnd: function(){
		// summary:
		//		Called when download is finished.
		// tags:
		//		callback
	}
});

}

if(!dojo._hasResource["dojox.html._base"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.html._base"] = true;
/*
	Status: dont know where this will all live exactly
	Need to pull in the implementation of the various helper methods
	Some can be static method, others maybe methods of the ContentSetter (?)
	
	Gut the ContentPane, replace its _setContent with our own call to dojox.html.set()
	

*/

dojo.provide("dojox.html._base");

 

(function() {

	if(dojo.isIE){
		var alphaImageLoader = /(AlphaImageLoader\([^)]*?src=(['"]))(?![a-z]+:|\/)([^\r\n;}]+?)(\2[^)]*\)\s*[;}]?)/g;
	}

	// css at-rules must be set before any css declarations according to CSS spec
	// match:
	// @import 'http://dojotoolkit.org/dojo.css';
	// @import 'you/never/thought/' print;
	// @import url("it/would/work") tv, screen;
	// @import url(/did/you/now.css);
	// but not:
	// @namespace dojo "http://dojotoolkit.org/dojo.css"; /* namespace URL should always be a absolute URI */
	// @charset 'utf-8';
	// @media print{ #menuRoot {display:none;} }
		
	// we adjust all paths that dont start on '/' or contains ':'
	//(?![a-z]+:|\/)

	var cssPaths = /(?:(?:@import\s*(['"])(?![a-z]+:|\/)([^\r\n;{]+?)\1)|url\(\s*(['"]?)(?![a-z]+:|\/)([^\r\n;]+?)\3\s*\))([a-z, \s]*[;}]?)/g;

	var adjustCssPaths = dojox.html._adjustCssPaths = function(cssUrl, cssText){
		//	summary:
		//		adjusts relative paths in cssText to be relative to cssUrl
		//		a path is considered relative if it doesn't start with '/' and not contains ':'
		//	description:
		//		Say we fetch a HTML page from level1/page.html
		//		It has some inline CSS:
		//			@import "css/page.css" tv, screen;
		//			...
		//			background-image: url(images/aplhaimage.png);
		//
		//		as we fetched this HTML and therefore this CSS
		//		from level1/page.html, these paths needs to be adjusted to:
		//			@import 'level1/css/page.css' tv, screen;
		//			...
		//			background-image: url(level1/images/alphaimage.png);
		//		
		//		In IE it will also adjust relative paths in AlphaImageLoader()
		//			filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='images/alphaimage.png');
		//		will be adjusted to:
		//			filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='level1/images/alphaimage.png');
		//
		//		Please note that any relative paths in AlphaImageLoader in external css files wont work, as
		//		the paths in AlphaImageLoader is MUST be declared relative to the HTML page,
		//		not relative to the CSS file that declares it

		if(!cssText || !cssUrl){ return; }

		// support the ImageAlphaFilter if it exists, most people use it in IE 6 for transparent PNGs
		// We are NOT going to kill it in IE 7 just because the PNGs work there. Somebody might have
		// other uses for it.
		// If user want to disable css filter in IE6  he/she should
		// unset filter in a declaration that just IE 6 doesn't understands
		// like * > .myselector { filter:none; }
		if(alphaImageLoader){
			cssText = cssText.replace(alphaImageLoader, function(ignore, pre, delim, url, post){
				return pre + (new dojo._Url(cssUrl, './'+url).toString()) + post;
			});
		}

		return cssText.replace(cssPaths, function(ignore, delimStr, strUrl, delimUrl, urlUrl, media){
			if(strUrl){
				return '@import "' + (new dojo._Url(cssUrl, './'+strUrl).toString()) + '"' + media;
			}else{
				return 'url(' + (new dojo._Url(cssUrl, './'+urlUrl).toString()) + ')' + media;
			}
		});
	};

	// attributepaths one tag can have multiple paths, example:
	// <input src="..." style="url(..)"/> or <a style="url(..)" href="..">
	// <img style='filter:progid...AlphaImageLoader(src="noticeTheSrcHereRunsThroughHtmlSrc")' src="img">
	var htmlAttrPaths = /(<[a-z][a-z0-9]*\s[^>]*)(?:(href|src)=(['"]?)([^>]*?)\3|style=(['"]?)([^>]*?)\5)([^>]*>)/gi;

	var adjustHtmlPaths = dojox.html._adjustHtmlPaths = function(htmlUrl, cont){
		var url = htmlUrl || "./";

		return cont.replace(htmlAttrPaths,
			function(tag, start, name, delim, relUrl, delim2, cssText, end){
				return start + (name ?
							(name + '=' + delim + (new dojo._Url(url, relUrl).toString()) + delim)
						: ('style=' + delim2 + adjustCssPaths(url, cssText) + delim2)
				) + end;
			}
		);
	};
	
	var snarfStyles = dojox.html._snarfStyles = function	(/*String*/cssUrl, /*String*/cont, /*Array*/styles){
		/****************  cut out all <style> and <link rel="stylesheet" href=".."> **************/
		// also return any attributes from this tag (might be a media attribute)
		// if cssUrl is set it will adjust paths accordingly
		styles.attributes = [];

		return cont.replace(/(?:<style([^>]*)>([\s\S]*?)<\/style>|<link\s+(?=[^>]*rel=['"]?stylesheet)([^>]*?href=(['"])([^>]*?)\4[^>\/]*)\/?>)/gi,
			function(ignore, styleAttr, cssText, linkAttr, delim, href){
				// trim attribute
				var i, attr = (styleAttr||linkAttr||"").replace(/^\s*([\s\S]*?)\s*$/i, "$1"); 
				if(cssText){
					i = styles.push(cssUrl ? adjustCssPaths(cssUrl, cssText) : cssText);
				}else{
					i = styles.push('@import "' + href + '";');
					attr = attr.replace(/\s*(?:rel|href)=(['"])?[^\s]*\1\s*/gi, ""); // remove rel=... and href=...
				}
				if(attr){
					attr = attr.split(/\s+/);// split on both "\n", "\t", " " etc
					var atObj = {}, tmp;
					for(var j = 0, e = attr.length; j < e; j++){
						tmp = attr[j].split('='); // split name='value'
						atObj[tmp[0]] = tmp[1].replace(/^\s*['"]?([\s\S]*?)['"]?\s*$/, "$1"); // trim and remove ''
					}
					styles.attributes[i - 1] = atObj;
				}
				return ""; // squelsh the <style> or <link>
			}
		);
	};

	var snarfScripts = dojox.html._snarfScripts = function(cont, byRef){
		// summary
		//		strips out script tags from cont
		// invoke with 
		//	byRef = {errBack:function(){/*add your download error code here*/, downloadRemote: true(default false)}}
		//	byRef will have {code: 'jscode'} when this scope leaves
		byRef.code = "";

		//Update script tags nested in comments so that the script tag collector doesn't pick
		//them up.
		cont = cont.replace(/<[!][-][-](.|\s){5,}?[-][-]>/g,
			function(comment){
				return comment.replace(/<(\/?)script\b([^>]|\s)*\>/ig,"&lt;$1Script$2&gt;");
			}
		);

		function download(src){
			if(byRef.downloadRemote){
				// console.debug('downloading',src);
				//Fix up src, in case there were entity character encodings in it.
				//Probably only need to worry about a subset.
				src = src.replace(/&([a-z0-9#]+);/g, function(m, name) {
					switch(name) {
						case "amp"	: return "&";
						case "gt"	: return ">";
						case "lt"	: return "<";
						default:
							return name.charAt(0)=="#" ? String.fromCharCode(name.substring(1)) : "&"+name+";";
					}
				});
				dojo.xhrGet({
					url: src,
					sync: true,
					load: function(code){
						byRef.code += code+";";
					},
					error: byRef.errBack
				});
			}
		}
		
		// match <script>, <script type="text/..., but not <script type="dojo(/method)...
		return cont.replace(/<script\s*(?![^>]*type=['"]?(?:dojo\/|text\/html\b))(?:[^>]*?(?:src=(['"]?)([^>]*?)\1[^>]*)?)*>([\s\S]*?)<\/script>/gi,
			function(ignore, delim, src, code){
				if(src){
					download(src);
				}else{
					byRef.code += code;
				}
				return "";
			}
		);
	}; 
	
	var evalInGlobal = dojox.html.evalInGlobal = function(code, appendNode){
		// we do our own eval here as dojo.eval doesn't eval in global crossbrowser
		// This work X browser but but it relies on a DOM
		// plus it doesn't return anything, thats unrelevant here but not for dojo core
		appendNode = appendNode || dojo.doc.body;
		var n = appendNode.ownerDocument.createElement('script');
		n.type = "text/javascript";
		appendNode.appendChild(n);
		n.text = code; // DOM 1 says this should work
	};

	dojo.declare("dojox.html._ContentSetter", [dojo.html._ContentSetter], {
		// adjustPaths: Boolean
		//		Adjust relative paths in html string content to point to this page
		//		Only useful if you grab content from a another folder than the current one
		adjustPaths: false,
		referencePath: ".",
		renderStyles: false, 

		executeScripts: false,
		scriptHasHooks: false,
		scriptHookReplacement: null,
		
		_renderStyles: function(styles){
			// insert css from content into document head
			this._styleNodes = [];
			var st, att, cssText, doc = this.node.ownerDocument;
			var head = doc.getElementsByTagName('head')[0];

			for(var i = 0, e = styles.length; i < e; i++){
				cssText = styles[i]; att = styles.attributes[i];
				st = doc.createElement('style');
				st.setAttribute("type", "text/css"); // this is required in CSS spec!

				for(var x in att){
					st.setAttribute(x, att[x]);
				}

				this._styleNodes.push(st);
				head.appendChild(st); // must insert into DOM before setting cssText

				if(st.styleSheet){ // IE
					st.styleSheet.cssText = cssText;
				}else{ // w3c
					st.appendChild(doc.createTextNode(cssText));
				}
			}
		}, 

		empty: function() {
			this.inherited("empty", arguments);
			
			// empty out the styles array from any previous use
			this._styles = [];
		}, 
		
		onBegin: function() {
			// summary
			//		Called after instantiation, but before set(); 
			//		It allows modification of any of the object properties - including the node and content 
			//		provided - before the set operation actually takes place
			//		This implementation extends that of dojo.html._ContentSetter 
			//		to add handling for adjustPaths, renderStyles on the html string content before it is set
			this.inherited("onBegin", arguments);
			
			var cont = this.content, 
				node = this.node; 
				
			var styles = this._styles;// init vars

			if(dojo.isString(cont)){
				if(this.adjustPaths && this.referencePath){
					cont = adjustHtmlPaths(this.referencePath, cont);
				}

				if(this.renderStyles || this.cleanContent){
					cont = snarfStyles(this.referencePath, cont, styles);
				}

				// because of a bug in IE, script tags that is first in html hierarchy doesnt make it into the DOM 
				//	when content is innerHTML'ed, so we can't use dojo.query to retrieve scripts from DOM
				if(this.executeScripts){
					var _t = this; 
					var byRef = {
						downloadRemote: true,
						errBack:function(e){
							_t._onError.call(_t, 'Exec', 'Error downloading remote script in "'+_t.id+'"', e);
						}
					};
					cont = snarfScripts(cont, byRef);
					this._code = byRef.code;
				}
			}
			this.content = cont;
		},
		
		onEnd: function() {
			// summary
			//		Called after set(), when the new content has been pushed into the node
			//		It provides an opportunity for post-processing before handing back the node to the caller
			//		This implementation extends that of dojo.html._ContentSetter
			
			var code = this._code, 
				styles = this._styles;
				
			// clear old stylenodes from the DOM
			// these were added by the last set call
			// (in other words, if you dont keep and reuse the ContentSetter for a particular node
			// .. you'll have no practical way to do this)
			if(this._styleNodes && this._styleNodes.length){
				while(this._styleNodes.length){
					dojo.destroy(this._styleNodes.pop());
				}
			}
			// render new style nodes
			if(this.renderStyles && styles && styles.length){
				this._renderStyles(styles);
			}

			if(this.executeScripts && code){
				if(this.cleanContent){
					// clean JS from html comments and other crap that browser
					// parser takes care of in a normal page load
					code = code.replace(/(<!--|(?:\/\/)?-->|<!\[CDATA\[|\]\]>)/g, '');
				}
				if(this.scriptHasHooks){
					// replace _container_ with this.scriptHookReplace()
					// the scriptHookReplacement can be a string 
					// or a function, which when invoked returns the string you want to substitute in
					code = code.replace(/_container_(?!\s*=[^=])/g, this.scriptHookReplacement);
				}
				try{
					evalInGlobal(code, this.node);
				}catch(e){
					this._onError('Exec', 'Error eval script in '+this.id+', '+e.message, e);
				}
			}
			this.inherited("onEnd", arguments);
		},
		tearDown: function() {
			this.inherited(arguments);
			delete this._styles;
			// only tear down -or another set() - will explicitly throw away the
			// references to the style nodes we added
			if(this._styleNodes && this._styleNodes.length){
				while(this._styleNodes.length){
					dojo.destroy(this._styleNodes.pop());
				}
			}
			delete this._styleNodes; 
			// reset the defaults from the prototype
			dojo.mixin(this, dojo.getObject(this.declaredClass).prototype);
		}
		
	});
	
	dojox.html.set = function(/* DomNode */ node, /* String|DomNode|NodeList */ cont, /* Object? */ params){
		// TODO: add all the other options
			// summary:
			//		inserts (replaces) the given content into the given node
			//	node:
			//		the parent element that will receive the content
			//	cont:
			//		the content to be set on the parent element. 
			//		This can be an html string, a node reference or a NodeList, dojo.NodeList, Array or other enumerable list of nodes
			//	params: 
			//		Optional flags/properties to configure the content-setting. See dojo.html._ContentSetter
			//	example:
			//		A safe string/node/nodelist content replacement/injection with hooks for extension
			//		Example Usage: 
			//		dojo.html.set(node, "some string"); 
			//		dojo.html.set(node, contentNode, {options}); 
			//		dojo.html.set(node, myNode.childNodes, {options}); 
	 
		if(!params){
			// simple and fast
			return dojo.html._setNodeContent(node, cont, true);
		}else{ 
			// more options but slower
			var op = new dojox.html._ContentSetter(dojo.mixin( 
					params, 
					{ content: cont, node: node } 
			));
			return op.set();
		}
	};
	
})();

}

if(!dojo._hasResource["dojox.layout.ContentPane"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.layout.ContentPane"] = true;
dojo.provide("dojox.layout.ContentPane");


 

dojo.declare("dojox.layout.ContentPane", dijit.layout.ContentPane, {
	// summary:
	//		An extended version of dijit.layout.ContentPane.
	//		Supports infile scripts and external ones declared by <script src=''
	//		relative path adjustments (content fetched from a different folder)
	//		<style> and <link rel='stylesheet' href='..'> tags,
	//		css paths inside cssText is adjusted (if you set adjustPaths = true)
	//
	//		NOTE that dojo.require in script in the fetched file isn't recommended
	//		Many widgets need to be required at page load to work properly

	// adjustPaths: Boolean
	//		Adjust relative paths in html string content to point to this page.
	//		Only useful if you grab content from a another folder then the current one
	adjustPaths: false,

	// cleanContent: Boolean
	//	summary:
	//		cleans content to make it less likely to generate DOM/JS errors.
	//	description:
	//		useful if you send ContentPane a complete page, instead of a html fragment
	//		scans for 
	//
	//			* title Node, remove
	//			* DOCTYPE tag, remove
	cleanContent: false,

	// renderStyles: Boolean
	//		trigger/load styles in the content
	renderStyles: false,

	// executeScripts: Boolean
	//		Execute (eval) scripts that is found in the content
	executeScripts: true,

	// scriptHasHooks: Boolean
	//		replace keyword '_container_' in scripts with 'dijit.byId(this.id)'
	// NOTE this name might change in the near future
	scriptHasHooks: false,

	/*======
	// ioMethod: dojo.xhrGet|dojo.xhrPost
	//		reference to the method that should grab the content
	ioMethod: dojo.xhrGet,
	
	// ioArgs: Object
	//		makes it possible to add custom args to xhrGet, like ioArgs.headers['X-myHeader'] = 'true'
	ioArgs: {},
	======*/

	constructor: function(){
		// init per instance properties, initializer doesn't work here because how things is hooked up in dijit._Widget
		this.ioArgs = {};
		this.ioMethod = dojo.xhrGet;
	},

	onExecError: function(e){
		// summary:
		//		event callback, called on script error or on java handler error
		//		overide and return your own html string if you want a some text 
		//		displayed within the ContentPane
	},

	_setContent: function(cont){
		// override dijit.layout.ContentPane._setContent, to enable path adjustments
		
		var setter = this._contentSetter; 
		if(! (setter && setter instanceof dojox.html._ContentSetter)) {
			setter = this._contentSetter = new dojox.html._ContentSetter({
				node: this.containerNode,
				_onError: dojo.hitch(this, this._onError),
				onContentError: dojo.hitch(this, function(e){
					// fires if a domfault occurs when we are appending this.errorMessage
					// like for instance if domNode is a UL and we try append a DIV
					var errMess = this.onContentError(e);
					try{
						this.containerNode.innerHTML = errMess;
					}catch(e){
						console.error('Fatal '+this.id+' could not change content due to '+e.message, e);
					}
				})/*,
				_onError */
			});
		};

		// stash the params for the contentSetter to allow inheritance to work for _setContent
		this._contentSetterParams = {
			adjustPaths: Boolean(this.adjustPaths && (this.href||this.referencePath)),
			referencePath: this.href || this.referencePath,
			renderStyles: this.renderStyles,
			executeScripts: this.executeScripts,
			scriptHasHooks: this.scriptHasHooks,
			scriptHookReplacement: "dijit.byId('"+this.id+"')"
		};

		this.inherited("_setContent", arguments);
	}
	// could put back _renderStyles by wrapping/aliasing dojox.html._ContentSetter.prototype._renderStyles
});

}

if(!dojo._hasResource["dijit.TooltipDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.TooltipDialog"] = true;
dojo.provide("dijit.TooltipDialog");






dojo.declare(
		"dijit.TooltipDialog",
		[dijit.layout.ContentPane, dijit._Templated, dijit.form._FormMixin, dijit._DialogMixin],
		{
			// summary:
			//		Pops up a dialog that appears like a Tooltip

			// title: String
			// 		Description of tooltip dialog (required for a11y)
			title: "",

			// doLayout: [protected] Boolean
			//		Don't change this parameter from the default value.
			//		This ContentPane parameter doesn't make sense for TooltipDialog, since TooltipDialog
			//		is never a child of a layout container, nor can you specify the size of
			//		TooltipDialog in order to control the size of an inner widget.
			doLayout: false,

			// autofocus: Boolean
			// 		A Toggle to modify the default focus behavior of a Dialog, which
			// 		is to focus on the first dialog element after opening the dialog.
			//		False will disable autofocusing. Default: true
			autofocus: true,

			// baseClass: [protected] String
			//		The root className to use for the various states of this widget
			baseClass: "dijitTooltipDialog",

			// _firstFocusItem: [private] [readonly] DomNode
			//		The pointer to the first focusable node in the dialog.
			//		Set by `dijit._DialogMixin._getFocusItems`.
			_firstFocusItem: null,

			// _lastFocusItem: [private] [readonly] DomNode
			//		The pointer to which node has focus prior to our dialog.
			//		Set by `dijit._DialogMixin._getFocusItems`.
			_lastFocusItem: null,

			templateString: dojo.cache("dijit", "templates/TooltipDialog.html", "<div waiRole=\"presentation\">\n\t<div class=\"dijitTooltipContainer\" waiRole=\"presentation\">\n\t\t<div class =\"dijitTooltipContents dijitTooltipFocusNode\" dojoAttachPoint=\"containerNode\" tabindex=\"-1\" waiRole=\"dialog\"></div>\n\t</div>\n\t<div class=\"dijitTooltipConnector\" waiRole=\"presentation\"></div>\n</div>\n"),

			postCreate: function(){
				this.inherited(arguments);
				this.connect(this.containerNode, "onkeypress", "_onKey");
				this.containerNode.title = this.title;
			},

			orient: function(/*DomNode*/ node, /*String*/ aroundCorner, /*String*/ corner){
				// summary:
				//		Configure widget to be displayed in given position relative to the button.
				//		This is called from the dijit.popup code, and should not be called
				//		directly.
				// tags:
				//		protected
				var c = this._currentOrientClass;
				if(c){
					dojo.removeClass(this.domNode, c);
				}
				c = "dijitTooltipAB"+(corner.charAt(1) == 'L'?"Left":"Right")+" dijitTooltip"+(corner.charAt(0) == 'T' ? "Below" : "Above");
				dojo.addClass(this.domNode, c);
				this._currentOrientClass = c;
			},

			onOpen: function(/*Object*/ pos){
				// summary:
				//		Called when dialog is displayed.
				//		This is called from the dijit.popup code, and should not be called directly.
				// tags:
				//		protected

				this.orient(this.domNode,pos.aroundCorner, pos.corner);
				this._onShow(); // lazy load trigger

				if(this.autofocus){
					this._getFocusItems(this.containerNode);
					dijit.focus(this._firstFocusItem);
				}
			},

			onClose: function(){
				// summary:
				//		Called when dialog is hidden.
				//		This is called from the dijit.popup code, and should not be called directly.
				// tags:
				//		protected
				this.onHide();
			},

			_onKey: function(/*Event*/ evt){
				// summary:
				//		Handler for keyboard events
				// description:
				//		Keep keyboard focus in dialog; close dialog on escape key
				// tags:
				//		private

				var node = evt.target;
				var dk = dojo.keys;
				if(evt.charOrCode === dk.TAB){
					this._getFocusItems(this.containerNode);
				}
				var singleFocusItem = (this._firstFocusItem == this._lastFocusItem);
				if(evt.charOrCode == dk.ESCAPE){
					// Use setTimeout to avoid crash on IE, see #10396.
					setTimeout(dojo.hitch(this, "onCancel"), 0);
					dojo.stopEvent(evt);
				}else if(node == this._firstFocusItem && evt.shiftKey && evt.charOrCode === dk.TAB){
					if(!singleFocusItem){
						dijit.focus(this._lastFocusItem); // send focus to last item in dialog
					}
					dojo.stopEvent(evt);
				}else if(node == this._lastFocusItem && evt.charOrCode === dk.TAB && !evt.shiftKey){
					if(!singleFocusItem){
						dijit.focus(this._firstFocusItem); // send focus to first item in dialog
					}
					dojo.stopEvent(evt);
				}else if(evt.charOrCode === dk.TAB){
					// we want the browser's default tab handling to move focus
					// but we don't want the tab to propagate upwards
					evt.stopPropagation();
				}
			}
		}
	);

}

if(!dojo._hasResource["dijit.Dialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.Dialog"] = true;
dojo.provide("dijit.Dialog");













/*=====
dijit._underlay = function(kwArgs){
	// summary:
	//		A shared instance of a `dijit.DialogUnderlay`
	//
	// description:
	//		A shared instance of a `dijit.DialogUnderlay` created and
	//		used by `dijit.Dialog`, though never created until some Dialog
	//		or subclass thereof is shown.
};
=====*/

dojo.declare(
	"dijit._DialogBase",
	[dijit._Templated, dijit.form._FormMixin, dijit._DialogMixin],
	{
		// summary:
		//		A modal dialog Widget
		//
		// description:
		//		Pops up a modal dialog window, blocking access to the screen
		//		and also graying out the screen Dialog is extended from
		//		ContentPane so it supports all the same parameters (href, etc.)
		//
		// example:
		// |	<div dojoType="dijit.Dialog" href="test.html"></div>
		//
		// example:
		// |	var foo = new dijit.Dialog({ title: "test dialog", content: "test content" };
		// |	dojo.body().appendChild(foo.domNode);
		// |	foo.startup();

		templateString: dojo.cache("dijit", "templates/Dialog.html", "<div class=\"dijitDialog\" tabindex=\"-1\" waiRole=\"dialog\" waiState=\"labelledby-${id}_title\">\n\t<div dojoAttachPoint=\"titleBar\" class=\"dijitDialogTitleBar\">\n\t<span dojoAttachPoint=\"titleNode\" class=\"dijitDialogTitle\" id=\"${id}_title\"></span>\n\t<span dojoAttachPoint=\"closeButtonNode\" class=\"dijitDialogCloseIcon\" dojoAttachEvent=\"onclick: onCancel, onmouseenter: _onCloseEnter, onmouseleave: _onCloseLeave\" title=\"${buttonCancel}\">\n\t\t<span dojoAttachPoint=\"closeText\" class=\"closeText\" title=\"${buttonCancel}\">x</span>\n\t</span>\n\t</div>\n\t\t<div dojoAttachPoint=\"containerNode\" class=\"dijitDialogPaneContent\"></div>\n</div>\n"),

		attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
			title: [
				{ node: "titleNode", type: "innerHTML" },
				{ node: "titleBar", type: "attribute" }
			],
			"aria-describedby":""
		}),

		// open: Boolean
		//		True if Dialog is currently displayed on screen.
		open: false,

		// duration: Integer
		//		The time in milliseconds it takes the dialog to fade in and out
		duration: dijit.defaultDuration,

		// refocus: Boolean
		// 		A Toggle to modify the default focus behavior of a Dialog, which
		// 		is to re-focus the element which had focus before being opened.
		//		False will disable refocusing. Default: true
		refocus: true,

		// autofocus: Boolean
		// 		A Toggle to modify the default focus behavior of a Dialog, which
		// 		is to focus on the first dialog element after opening the dialog.
		//		False will disable autofocusing. Default: true
		autofocus: true,

		// _firstFocusItem: [private] [readonly] DomNode
		//		The pointer to the first focusable node in the dialog.
		//		Set by `dijit._DialogMixin._getFocusItems`.
		_firstFocusItem: null,

		// _lastFocusItem: [private] [readonly] DomNode
		//		The pointer to which node has focus prior to our dialog.
		//		Set by `dijit._DialogMixin._getFocusItems`.
		_lastFocusItem: null,

		// doLayout: [protected] Boolean
		//		Don't change this parameter from the default value.
		//		This ContentPane parameter doesn't make sense for Dialog, since Dialog
		//		is never a child of a layout container, nor can you specify the size of
		//		Dialog in order to control the size of an inner widget.
		doLayout: false,

		// draggable: Boolean
		//		Toggles the moveable aspect of the Dialog. If true, Dialog
		//		can be dragged by it's title. If false it will remain centered
		//		in the viewport.
		draggable: true,

		//aria-describedby: String
		//		Allows the user to add an aria-describedby attribute onto the dialog.   The value should
		//		be the id of the container element of text that describes the dialog purpose (usually
		//		the first text in the dialog).
		//		<div dojoType="dijit.Dialog" aria-describedby="intro" .....>
		//			<div id="intro">Introductory text</div>
		//			<div>rest of dialog contents</div>
		//		</div>
		"aria-describedby":"",

		postMixInProperties: function(){
			var _nlsResources = dojo.i18n.getLocalization("dijit", "common");
			dojo.mixin(this, _nlsResources);
			this.inherited(arguments);
		},

		postCreate: function(){
			dojo.style(this.domNode, {
				display: "none",
				position:"absolute"
			});
			dojo.body().appendChild(this.domNode);

			this.inherited(arguments);

			this.connect(this, "onExecute", "hide");
			this.connect(this, "onCancel", "hide");
			this._modalconnects = [];
		},

		onLoad: function(){
			// summary:
			//		Called when data has been loaded from an href.
			//		Unlike most other callbacks, this function can be connected to (via `dojo.connect`)
			//		but should *not* be overriden.
			// tags:
			//		callback

			// when href is specified we need to reposition the dialog after the data is loaded
			this._position();
			this.inherited(arguments);
		},

		_endDrag: function(e){
			// summary:
			//		Called after dragging the Dialog. Saves the position of the dialog in the viewport.
			// tags:
			//		private
			if(e && e.node && e.node === this.domNode){
				this._relativePosition = dojo.position(e.node);
			}
		},

		_setup: function(){
			// summary:
			//		Stuff we need to do before showing the Dialog for the first
			//		time (but we defer it until right beforehand, for
			//		performance reasons).
			// tags:
			//		private

			var node = this.domNode;

			if(this.titleBar && this.draggable){
				this._moveable = (dojo.isIE == 6) ?
					new dojo.dnd.TimedMoveable(node, { handle: this.titleBar }) :	// prevent overload, see #5285
					new dojo.dnd.Moveable(node, { handle: this.titleBar, timeout: 0 });
				dojo.subscribe("/dnd/move/stop",this,"_endDrag");
			}else{
				dojo.addClass(node,"dijitDialogFixed");
			}

			this.underlayAttrs = {
				dialogId: this.id,
				"class": dojo.map(this["class"].split(/\s/), function(s){ return s+"_underlay"; }).join(" ")
			};

			this._fadeIn = dojo.fadeIn({
				node: node,
				duration: this.duration,
				beforeBegin: dojo.hitch(this, function(){
					var underlay = dijit._underlay;
					if(!underlay){
						underlay = dijit._underlay = new dijit.DialogUnderlay(this.underlayAttrs);
					}else{
						underlay.attr(this.underlayAttrs);
					}

					var zIndex = 400 + dijit._dialogStack.length*2;
					dojo.style(dijit._underlay.domNode, 'zIndex', zIndex);
					dojo.style(this.domNode, 'zIndex', zIndex + 1);
					underlay.show();
				}),
				onEnd: dojo.hitch(this, function(){
					if(this.autofocus){
						// find focusable Items each time dialog is shown since if dialog contains a widget the
						// first focusable items can change
						this._getFocusItems(this.domNode);
						dijit.focus(this._firstFocusItem);
					}
				})
			 });

			this._fadeOut = dojo.fadeOut({
				node: node,
				duration: this.duration,
				onEnd: dojo.hitch(this, function(){
					node.style.display = "none";

					// Restore the previous dialog in the stack, or if this is the only dialog
					// then restore to original page
					var ds = dijit._dialogStack;
					if(ds.length == 0){
						dijit._underlay.hide();
					}else{
						dojo.style(dijit._underlay.domNode, 'zIndex', 400 + ds.length*2);
						dijit._underlay.attr(ds[ds.length-1].underlayAttrs);
					}

					// Restore focus to wherever it was before this dialog was displayed
					if(this.refocus){
						var focus = this._savedFocus;

						// If we are returning control to a previous dialog but for some reason
						// that dialog didn't have a focused field, set focus to first focusable item.
						// This situation could happen if two dialogs appeared at nearly the same time,
						// since a dialog doesn't set it's focus until the fade-in is finished.
						if(ds.length > 0){
							var pd = ds[ds.length-1];
							if(!dojo.isDescendant(focus.node, pd.domNode)){
								pd._getFocusItems(pd.domNode);
								focus = pd._firstFocusItem;
							}
						}

						dijit.focus(focus);
					}
				})
			 });
		},

		uninitialize: function(){
			var wasPlaying = false;
			if(this._fadeIn && this._fadeIn.status() == "playing"){
				wasPlaying = true;
				this._fadeIn.stop();
			}
			if(this._fadeOut && this._fadeOut.status() == "playing"){
				wasPlaying = true;
				this._fadeOut.stop();
			}
			if(this.open || wasPlaying){
				dijit._underlay.hide();
			}
			if(this._moveable){
				this._moveable.destroy();
			}
			this.inherited(arguments);
		},

		_size: function(){
			// summary:
			// 		If necessary, shrink dialog contents so dialog fits in viewport
			// tags:
			//		private

			this._checkIfSingleChild();

			// If we resized the dialog contents earlier, reset them back to original size, so
			// that if the user later increases the viewport size, the dialog can display w/out a scrollbar.
			// Need to do this before the dojo.marginBox(this.domNode) call below.
			if(this._singleChild){
				if(this._singleChildOriginalStyle){
					this._singleChild.domNode.style.cssText = this._singleChildOriginalStyle;
				}
				delete this._singleChildOriginalStyle;
			}else{
				dojo.style(this.containerNode, {
					width:"auto",
					height:"auto"
				});
			}

			var mb = dojo.marginBox(this.domNode);
			var viewport = dijit.getViewport();
			if(mb.w >= viewport.w || mb.h >= viewport.h){
				// Reduce size of dialog contents so that dialog fits in viewport

				var w = Math.min(mb.w, Math.floor(viewport.w * 0.75)),
					h = Math.min(mb.h, Math.floor(viewport.h * 0.75));

				if(this._singleChild && this._singleChild.resize){
					this._singleChildOriginalStyle = this._singleChild.domNode.style.cssText;
					this._singleChild.resize({w: w, h: h});
				}else{
					dojo.style(this.containerNode, {
						width: w + "px",
						height: h + "px",
						overflow: "auto",
						position: "relative"	// workaround IE bug moving scrollbar or dragging dialog
					});
				}
			}else{
				if(this._singleChild && this._singleChild.resize){
					this._singleChild.resize();
				}
			}
		},

		_position: function(){
			// summary:
			//		Position modal dialog in the viewport. If no relative offset
			//		in the viewport has been determined (by dragging, for instance),
			//		center the node. Otherwise, use the Dialog's stored relative offset,
			//		and position the node to top: left: values based on the viewport.
			// tags:
			//		private
			if(!dojo.hasClass(dojo.body(),"dojoMove")){
				var node = this.domNode,
					viewport = dijit.getViewport(),
					p = this._relativePosition,
					bb = p ? null : dojo._getBorderBox(node),
					l = Math.floor(viewport.l + (p ? p.x : (viewport.w - bb.w) / 2)),
					t = Math.floor(viewport.t + (p ? p.y : (viewport.h - bb.h) / 2))
				;
				dojo.style(node,{
					left: l + "px",
					top: t + "px"
				});
			}
		},

		_onKey: function(/*Event*/ evt){
			// return if a jQuery or a CKE dialog is open
			// otherwise it is impossible to type something
			if(jQuery(evt.target).is(".ui-dialog *") || jQuery(evt.target).is('div[aria-labelledby^=cke_dialog] *')){
				return;
			}

			// summary:
			//		Handles the keyboard events for accessibility reasons
			// tags:
			//		private

			var ds = dijit._dialogStack;
			if(ds[ds.length-1] != this){
				// console.debug(this.id + ': skipping because', this, 'is not the active dialog');
				return;
			}

			if(evt.charOrCode){
				var dk = dojo.keys;
				var node = evt.target;
				if(evt.charOrCode === dk.TAB){
					this._getFocusItems(this.domNode);
				}
				var singleFocusItem = (this._firstFocusItem == this._lastFocusItem);
				// see if we are shift-tabbing from first focusable item on dialog
				if(node == this._firstFocusItem && evt.shiftKey && evt.charOrCode === dk.TAB){
					if(!singleFocusItem){
						dijit.focus(this._lastFocusItem); // send focus to last item in dialog
					}
					dojo.stopEvent(evt);
				}else if(node == this._lastFocusItem && evt.charOrCode === dk.TAB && !evt.shiftKey){
					if(!singleFocusItem){
						dijit.focus(this._firstFocusItem); // send focus to first item in dialog
					}
					dojo.stopEvent(evt);
				}else{
					// see if the key is for the dialog
					while(node){
					//	if(node == this.domNode || dojo.hasClass(node, "dijitPopup"))){
						if(node == this.domNode || dojo.hasClass(node, "dijitPopup") || dojo.hasClass(node, "ep-uiColorpicker-dialog")){ // enable interaction in ePages jQuery Colorpicker also
							if(evt.charOrCode == dk.ESCAPE){
								this.onCancel();
							}else{
								return; // just let it go
							}
						}
						node = node.parentNode;
					}
					// this key is for the disabled document window
					if(evt.charOrCode !== dk.TAB){ // allow tabbing into the dialog for a11y
						dojo.stopEvent(evt);
					// opera won't tab to a div
					}else if(!dojo.isOpera){
						try{
							this._firstFocusItem.focus();
						}catch(e){ /*squelch*/ }
					}
				}
			}
		},

		show: function(){
			// summary:
			//		Display the dialog
			if(this.open){ return; }

			// first time we show the dialog, there's some initialization stuff to do
			if(!this._alreadyInitialized){
				this._setup();
				this._alreadyInitialized=true;
			}

			if(this._fadeOut.status() == "playing"){
				this._fadeOut.stop();
			}

			this._modalconnects.push(dojo.connect(window, "onscroll", this, "layout"));
			this._modalconnects.push(dojo.connect(window, "onresize", this, function(){
				// IE gives spurious resize events and can actually get stuck
				// in an infinite loop if we don't ignore them
				var viewport = dijit.getViewport();
				if(!this._oldViewport ||
						viewport.h != this._oldViewport.h ||
						viewport.w != this._oldViewport.w){
					this.layout();
					this._oldViewport = viewport;
				}
			}));
			this._modalconnects.push(dojo.connect(dojo.doc.documentElement, "onkeypress", this, "_onKey"));

			dojo.style(this.domNode, {
				opacity:0,
				display:""
			});

			this.open = true;
			this._onShow(); // lazy load trigger

			this._size();
			this._position();
			dijit._dialogStack.push(this);
			this._fadeIn.play();

			this._savedFocus = dijit.getFocus(this);
		},

		hide: function(){
			// summary:
			//		Hide the dialog

			// if we haven't been initialized yet then we aren't showing and we can just return
			// or if we aren't the active dialog, don't allow us to close yet
			var ds = dijit._dialogStack;
			if(!this._alreadyInitialized || this != ds[ds.length-1]){
				return;
			}

			if(this._fadeIn.status() == "playing"){
				this._fadeIn.stop();
			}

			// throw away current active dialog from stack -- making the previous dialog or the node on the original page active
			ds.pop();

			this._fadeOut.play();

			if(this._scrollConnected){
				this._scrollConnected = false;
			}
			dojo.forEach(this._modalconnects, dojo.disconnect);
			this._modalconnects = [];

			if(this._relativePosition){
				delete this._relativePosition;
			}
			this.open = false;

			this.onHide();
		},

		layout: function(){
			// summary:
			//		Position the Dialog and the underlay
			// tags:
			//		private
			if(this.domNode.style.display != "none"){
				if(dijit._underlay){	// avoid race condition during show()
					dijit._underlay.layout();
				}
				this._position();
			}
		},

		destroy: function(){
			dojo.forEach(this._modalconnects, dojo.disconnect);
			if(this.refocus && this.open){
				setTimeout(dojo.hitch(dijit,"focus",this._savedFocus), 25);
			}
			this.inherited(arguments);
		},

		_onCloseEnter: function(){
			// summary:
			//		Called when user hovers over close icon
			// tags:
			//		private
			dojo.addClass(this.closeButtonNode, "dijitDialogCloseIcon-hover");
		},

		_onCloseLeave: function(){
			// summary:
			//		Called when user stops hovering over close icon
			// tags:
			//		private
			dojo.removeClass(this.closeButtonNode, "dijitDialogCloseIcon-hover");
		}
	}
);

dojo.declare(
	"dijit.Dialog",
	[dijit.layout.ContentPane, dijit._DialogBase],
	{}
);

// Stack of currenctly displayed dialogs, layered on top of each other
dijit._dialogStack = [];

// For back-compat.  TODO: remove in 2.0


}

if(!dojo._hasResource['epages.io.text']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.io.text'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

  epages.io.Text $Revision: 1.7 $

*/
dojo.provide('epages.io.text');

epages.io.Text = function (/*String*/url) {
	// summary:
	//		Loads text data from url and set the received text data to the target object.
	// example:
	// 	  epages.io.Text('http://www.mydomain.de/header.text', $(header));
	if (url === undefined){
		return;
	}
	return this.load(url);
};

epages.io.Text.prototype = {
	load: function (/*String*/url) {
		// summary:
		//		Loads text data from url and set the received text data to the target object.
		// example:
		// 	  textLoader = new epages.io.Text();
		//		textLoader.load('http://www.mydomain.de/header.text', $(header));
		var targetObject = {};
	  dojo.xhrGet({
	    url:  url,
	    sync: true,
	    load: function(data, evt){
	      targetObject.text = data;
	    },
	    handleAs: "text"
	  });
	  return targetObject.text; //String
	},

	test: function(/*epages.Test*/eTest) {
		// summary:
		//		test this package
		// example:
		// 	  var package = new epages.io.Text();
		//		boolean = package.test(eTest);
		//		// returns true if all test are successfully
		eTest.setPlanned(2);
		eTest.ok(1, 'loaded');

		var text = this.load('htmlTest.inc');
		eTest.ok(text == 'Header loaded successfully.', 'load header');

		// closing async test
		return eTest.planned == eTest.correct ? true : false; //Boolean
	}
};

}

if(!dojo._hasResource["epages.widget.Button"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Button"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.widget.Button $Revision: 1.47 $

*/
dojo.provide("epages.widget.Button");




epages.widget.ButtonChangeForms = []; // global array of all buttons

dojo.declare(
	"epages.widget.Button",
	[dijit._Widget], {


		name:    '', // String - name of button
		button:  '', // String - execute|batch|confirm|submit
		'class': '', // String - additional class parameter for outer div element
		onclick: '', // function - execute this string on click
		value:   '', // String - label of button
		disabled:'', // String - disable button like submit
		active:  '', // String - enable active class on startup
		iconSrc: '', // String - path to any icon image
		submit:  '', // String - do submit on click
		triggerClass: '',
		disableOnClick: '',
		buttonContainerNode: undefined,// DomNode - always the original input element wich is wrapped by buttonContainerNode

		_returnFalse: "", // return false handle container

		_removeEventList: undefined,
		_onClickEvents: undefined,

		postCreate: function() {
			this.inherited('postCreate', arguments);

			var el = this.domNode;

			var type;
			var triggerClass = '';
			if (dojo.hasClass(el, 'RunButton')) {
				type = 'batch';
			}else if (dojo.hasClass(el, 'SaveButton')){
				type = 'submit';
			}else if (dojo.hasClass(el, 'DeleteButton')){
				type = 'confirm';
			}else if (dojo.hasClass(el, 'CancelButton')){
				type = 'confirm';
			}else if (dojo.hasClass(el, 'ExtraButton')){
				type = 'execute';
				triggerClass="ExtraButtonTrigger";
			}else if (dojo.hasClass(el, 'SearchButton')){
				type = 'execute';
			}else {
				type = 'confirm';
			}
			this.button = type;

			var submit = '';
			if (el.type == 'image' ||el.type == 'submit') {
				submit = 'true';
			}

			var disabled = '';
			/*if (el.disabled) {
				disabled = 'true';
			}*/
			if (el.getAttribute("triggerClass") != null && el.getAttribute("triggerClass") != '') {
				triggerClass = el.getAttribute("triggerClass");
			}

			this.triggerClass = triggerClass;
			this.disabled = disabled;
			this.submit = submit;

			//create outer element
			var buttonContainerNode = document.createElement("span");

			//export all classes to new button tag
			buttonContainerNode.setAttribute((document.all ? "className" : "class"), this["class"]);
			if (!dojo.hasClass(buttonContainerNode, 'Button')) {
				dojo.addClass(buttonContainerNode, 'Button');
			}
			dojo.addClass(buttonContainerNode, 'EnableHover');

			//insert button at the right place
			this.domNode.parentNode.insertBefore(buttonContainerNode, this.domNode);

			//transform old input into new button
			this.domNode.setAttribute((document.all ? "className" : "class"), "ButtonContainer");
			buttonContainerNode.appendChild(this.domNode);

			// is a submit button ?
			this.submit = this.submit != '' || this.button == 'submit';

			// disableOnClick - default settings for undefined
			if(this.disableOnClick == "" && (this.domNode.type == "submit" || this.domNode.href)){
				this.disableOnClick = true;
			}

			// disableOnClick - to bool
			this.disableOnClick = epages.string.toBoolean(this.disableOnClick);

			// is disabled ?
			//this.disabled = this.disabled != '' || this.button == 'submit';
			if (this.disabled) {
				this.domNode.disabled = true;
				this._returnFalse = dojo.connect(this.domNode, "click", this, function(){ return false; });
				dojo.addClass(buttonContainerNode, 'Disabled');
			}

			// is active on startup
			if (this.active!='') {
				dojo.addClass(buttonContainerNode, 'Active');
			}

			// insert icon if an image url exists
			if (this.iconSrc) {
				var buttonIconContainer = document.createElement("span");

				if(this.onclick) {
					buttonIconContainer.onclick = this.onclick;
				}
				if(this.onmousedown) {
					buttonIconContainer.onmousedown = this.onmousedown;
				}
				if(this.onmouseup) {
					buttonIconContainer.onmouseup = this.onmouseup;
				}
				if(this.onmouseover) {
					buttonIconContainer.onmouseover = this.onmouseover;
				}

				buttonIconContainer.form = this.domNode.form;
				buttonIconContainer.className = "ButtonIconContainer";
				//buttonIconContainer.style.background = "url(" + this.iconSrc + ") no-repeat center";

				buttonIconContainer.innerHTML = "<i class='Sprite " + this.iconSrc + "'></i>";

				buttonContainerNode.insertBefore(buttonIconContainer, this.domNode);
				dojo.addClass(this.domNode, "ButtonIconPadding");
			}

			// add events to trigger activation of buttons
			this.form = this.domNode.form;
			this._removeEventList = []; // remove events later if button is enabled
			this._onClickEvents = []; // event list for click, enable or disable

			if (this.button == 'execute' || this.button == 'submit' || this.button == 'batch' ) {
				var inputs = this.form.elements;
				// filter triggerClass or remove NoButtonTrigger
				if (this.triggerClass != '') {
					inputs = dojo.filter(inputs, function (el) { return dojo.hasClass(el, this.triggerClass); }, this);
				} else {
					inputs = dojo.filter(inputs, function (el) { return ( !dojo.hasClass(el, 'NoButtonTrigger') && !dojo.attr( el, 'formnovalidate' ) ) ? true : false; });
				}
				// filter BatchTrigger
				if (this.button == 'batch') {
					inputs = dojo.filter(inputs, function (el) { return dojo.hasClass(el, 'RunButtonTrigger'); });
				} else {
					inputs = dojo.filter(inputs, function (el) { return !dojo.hasClass(el, 'RunButtonTrigger'); });
				}

				// add change events to enable buttons
				this.registerInputs(inputs);
			}
			// buttonContainerNode as widget property
			this.buttonContainerNode = buttonContainerNode;

			// register on click
			if (!this.disabled) {
				this._registerEvents();
			}

			this.enable();
		},

		registerInput: function(el) {
			var it=el.type;
			if (it == "hidden" || it == "text" || it == "password" || it == "file" || it == "textarea") {
				this._removeEventList.push(dojo.connect(el, 'keydown', this, '_OnKeyPressInput')); // fastest activation
				this._removeEventList.push(dojo.connect(el, 'change', this, '_OnKeyPressInput')); // need for other javascripts
				this._removeEventList.push(dojo.connect(el, 'paste',  this, '_OnKeyPressInput')); // need for paste with mouse (right context menu)
				this._removeEventList.push(dojo.connect(el, 'blur', this, '_OnKeyPressInput')); // need for select old entry from browser history
			} else if (it == "checkbox" || it == "radio") {
				this._removeEventList.push(dojo.connect(el, 'click', this, '_OnKeyPressInput'));
				this._removeEventList.push(dojo.connect(el, 'keypress', this, '_OnKeyPressInput'));
				this._removeEventList.push(dojo.connect(el, 'change', this, '_OnKeyPressInput'));
			} else if (el.tagName == "SELECT") {
				this._removeEventList.push(dojo.connect(el, 'change', this, '_OnKeyPressInput'));
			}
		},

		registerInputs: function(inputs){
			dojo.forEach(inputs, function (el) {
				this.registerInput(el);
			}, this);
		},

		_OnKeyPressInput: function (evt) {
			if(!this.domNode.parentNode.className.match("Active")) {
				var t = evt.target;
				if(t.className.match("DialogError") || (evt.type =='blur' && (t.type == 'text' || t.type == 'textarea') && t.defaultValue === t.value)){
					return;
				}

				if(epages.vars.activeButton) {
					dojo.removeClass(epages.vars.activeButton, "Active");
				}
				epages.vars.activeButton = this.domNode.parentNode;

				dojo.addClass(this.domNode.parentNode, 'Active');
				dojo.removeClass(this.domNode.parentNode, 'Disabled');

				if (this.disabled){
					this.enable();
				}

				if (this.button == 'submit') {
					if (!document.title.match(/\*$/)){
						document.title+="*";
					}
					epages.widget.ButtonChangeForms.push(this.form);
				}
			}
		},

		_OnClick: function (evt) {
			if(!this.disabled && this.disableOnClick) {
				dojo.publish("interactionRestrictor/suspend", ["interactionRestrictorFor_" + this.id, this.domNode.parentNode, true]);
				/* prevent double click */
				setTimeout(dojo.hitch(this, function(){ this.disable(); }), 20);

/*				if( this.button != 'submit' && this.button != 'confirm' ){ */
					setTimeout(dojo.hitch(this, function() {
						this.enable();
						dojo.removeClass(this.domNode.parentNode, 'Active');
						dojo.publish("interactionRestrictor/permit", ["interactionRestrictorFor_" + this.id]);
					}), 2000);
/*				} */
			}
			if (this.button == 'confirm' || this.button == 'submit') {
				epages.widget.ButtonChangeForms = [];
			} else if (this.button != 'batch'){
				var formNode = this.form;
				epages.widget.ButtonChangeForms = dojo.filter(epages.widget.ButtonChangeForms, function (el) {
					return el != formNode;
				});
			}
		},


		_OnMouseDown: function() {
		  //summary: emulates the ":active" pseudoclass in the MSIE
			dojo.addClass(this.domNode.parentNode, 'ButtonClicked');
			dojo.addClass(this.domNode, 'ButtonContainerClicked');
		},

		_OnMouseUp: function() {
			dojo.removeClass(this.domNode.parentNode, 'ButtonClicked');
			dojo.removeClass(this.domNode, 'ButtonContainerClicked');
		},

		_registerEvents: function () {
			this._onClickEvents.push(dojo.connect(this.domNode,'click', this, '_OnClick'));
			this._onClickEvents.push(dojo.connect(this.domNode,'mousedown', this, '_OnMouseDown'));
			this._onClickEvents.push(dojo.connect(this.domNode,'mouseup', this, '_OnMouseUp'));
			this._onClickEvents.push(dojo.connect(this.domNode,'mouseout', this, '_OnMouseUp'));
		},

		enable: function () {
				this.disabled = false;
				this.domNode.disabled = false;
				dojo.disconnect(this._returnFalse);

				// switch classes
				dojo.addClass(this.domNode.parentNode, 'Active');
				dojo.removeClass(this.domNode.parentNode, 'Disabled');
				if(this._onClickEvents.length == 0) {
					this._registerEvents();
				}
		},

		disable: function () {
			this.disabled = true;
			this.domNode.disabled = true;

			dojo.disconnect(this._returnFalse);
			this._returnFalse = dojo.connect(this.domNode, "click", this, function(){ return false; });

			// switch classes
			dojo.removeClass(this.domNode.parentNode, 'Active');
			dojo.addClass(this.domNode.parentNode, 'Disabled');

			// unregister events
			dojo.forEach(this._onClickEvents, dojo.disconnect);
			this._onClickEvents = [];
		},

		disableIfEmpty: function (value) {
			if (value == ""){
				this.disable();
			}else{
				this.enable();
			}
		},

		hide: function() {
			dojo.addClass(this.buttonContainerNode, "HideElement");
		},

		show: function() {
			dojo.removeClass(this.buttonContainerNode, "HideElement");
		}
	}
);

epages.onUnloadFunctions.push(function() {
	return epages.widget.ButtonChangeForms.length > 0;
});

epages.widget.TransformButtons = function (domNode) {
	dojo.forEach(dojo.query('.Button', domNode), function (el) {
		if (el.tagName != 'INPUT' || el.type == 'hidden'){
			return;
		}

		var type;
		var triggerClass = '';
		if (dojo.hasClass(el, 'RunButton')) {
			type = 'batch';
		}else if (dojo.hasClass(el, 'SaveButton')){
			type = 'submit';
		}else if (dojo.hasClass(el, 'DeleteButton')){
			type = 'confirm';
		}else if (dojo.hasClass(el, 'CancelButton')){
			type = 'confirm';
		}else if (dojo.hasClass(el, 'ExtraButton')){
			type = 'execute';
			triggerClass="ExtraButtonTrigger";
		}else if (dojo.hasClass(el, 'SearchButton')){
			type = 'execute';
		}else {
			type = 'confirm';
		}


		var submit = '';
		if (el.type == 'image' ||el.type == 'submit') {
			submit = 'true';
		}
		var disabled = '';
		if (el.disabled) {
			disabled = 'true';
		}
		if (el.getAttribute("triggerClass") != null && el.getAttribute("triggerClass") != '') {
			triggerClass = el.getAttribute("triggerClass");
		}
		new epages.widget.Button({
			button:  type,
			name:    el.name,
			value:   el.value,
			'class': el.className,
			onclick: el.onclick,
			iconSrc: el.getAttribute("iconsrc"),
			submit:  submit,
			disabled: disabled,
			triggerClass: triggerClass
			 }, el);
	});
};

// convert old buttons
dojo.addOnLoad(function () {
	//epages.widget.TransformButtons(dojo.body());
});

}

if(!dojo._hasResource["epages.widget.Modaldialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Modaldialog"] = true;
dojo.provide("epages.widget.Modaldialog");





dojo["require"]('dijit.Dialog'); //change require syntax to keep it here after shrinksafe





dojo.declare(
	"epages.widget.Modaldialog",
	[dijit.Dialog, epages.widget.LocalizedWidget],
	{

		/**
		 * public properties
		 */
		buttons: undefined,
		options: undefined,
		duration: epages.Browser.engine=="MSIE" ? 10 : 150,
		title: '',
		'class' : '',
		/**
		 * private properties
		 */
		_contentWidget: null,
		_contentPane: null,
		_events: null,
		_tabEvents: null,
		_tabs: undefined,
		_currentTab: undefined,
		_iframe: null,
		_doc: null,

		/**
		 * dojo widget properties
		 */
		translationName       : dojo.moduleUrl('epages.widget', "templates/translation"),
		imagePath             : epages.themeUrl('images'),
		buttonTemplateString  : '<span class="Button EnableHover (%Class%)" (%buttonId%)><span class="ButtonContainer">(%Label%)</span></span>',
		tabTemplateString     : '<div class="Tab"><div>(%Label%)</div></div>',
		innerTemplatePath     : null,
		widgetsInTemplate     : true,
		templateString: dojo.cache("epages.widget", "templates/Modaldialog.html", "<div class=\"dijitDialog ModalDialog\" style=\"display:none\">\n  <div dojoAttachPoint=\"titleBar\" class=\"dijitDialogTitleBar\" tabindex=\"0\" waiRole=\"dialog\">\n    <span dojoAttachPoint=\"titleNode\" class=\"dijitDialogTitle\">${title}</span>\n    <span dojoAttachPoint=\"closeButtonNode\" class=\"dijitDialogCloseIcon EnableHover\" dojoAttachEvent=\"onclick: onCancel\">\n      <span dojoAttachPoint=\"closeText\" class=\"closeText\">x</span>\n    </span>\n  </div>\n  <div dojoAttachPoint=\"tabBarNode\" class=\"TabBar\" style=\"display:none\"></div>\n  <div dojoAttachPoint=\"layerContentNode\" class=\"LayerContent Border White\">\n    <div dojoAttachPoint=\"containerNode\" class=\"dijitDialogPaneContent ${options.containerClass}\"><!-- //innerTemplate// --></div>\n  </div>\n  <div dojoAttachPoint=\"innerButtonBarNode\" class=\"LayerInnerButtonBar\" style=\"display:none\"></div>\n  <div dojoAttachPoint=\"buttonBarNode\" class=\"LayerButtonBar\" style=\"display:none\"></div>\n</div>\n"),

		clearFloatNode        : undefined,

		buildRendering: function() {
			// summary:
			//    replaces the placeholder in the base template with the template from innerTemplateString,
			//    so this works like an include and you don't have to rewrite the whole template in sub-
			//    classes.
			if (this.innerTemplatePath != null) {
				this.templateString = dijit._Templated.getCachedTemplate(this.templatePath, this.templateString, true);
				var innerTemplateString = dijit._Templated.getCachedTemplate(this.innerTemplatePath, null, true);
				this.templateString = this.templateString.replace('<!-- //innerTemplate// -->', innerTemplateString);
				this.templatePath = '';
			}
			this.inherited("buildRendering", arguments);
		},

		postMixInProperties: function() {
			var options = {containerClass: ''};
			dojo.mixin(options, this.options);
			this.options = options;
			dijit.Dialog.prototype.postMixInProperties.apply(this, arguments);
			this.inherited("postMixInProperties", arguments);
		},

		postCreate: function() {
			this._doc = this.domNode.ownerDocument;
			//call postCreate of dijit.dialog because this.inherited only references to the last parent class
			dijit.Dialog.prototype.postCreate.apply(this, arguments);
			this.inherited("postCreate", arguments);
			if(this.buttons===undefined){
				this.buttons=[];
			}
			if(this.tabs===undefined){
				this.tabs=[];
			}
			if(this.options===undefined){
				this.options={};
			}
			this._createContent(this.options);
			this._createButtons(this.buttons);
			this._createTabs();
			dojo.addClass(this.domNode, this['class']);
			dojo.subscribe(this.id+"/executeAction",dojo.hitch(this,this.executeAction));
		},
		executeAction : function(/*String*/ functionName,/*anything...*/additionalParams){
			// summary: executes the specified function with the passed arguments
			// example: dojo.publish(id/executeAction,[disableButton,startButton])
			// functionName: function name to call and every following
			// additionalParams: parameters will be pushed as parameter to the called function
			if(this[functionName] && dojo.isFunction(this[functionName])){
				var params = [];
				dojo.forEach(arguments,function(el,i){
					if(i!=0){
						params.push(el);
					}
				});
				epages.lang.hitch(this,functionName,params)();
			}
		},

		destroyRendering: function() {
			this.hide();
			this.inherited("destroyRendering", arguments);
		},

		hide: function() {
			this.inherited("hide", arguments);
			if(epages.Browser.engine=="MSIE") { // layer display corrections
				this.domNode.style.width="auto";
			}
			dojo.publish(this.id+'/hide',[{dialog: this}]);
		},

		show: function() {
			this.inherited("show", arguments);
			if(epages.Browser.engine=="MSIE") { // layer display corrections
				this.domNode.style.width=this.domNode.offsetWidth+"px";
			}
			//set zIndex to epages.vars.ZIndex
			if(this.domNode && epages.zIndex){
				this.domNode.style.zIndex = epages.zIndex;
			}
			if(this._underlay){
				this._underlay.domNode.style.zIndex = this.domNode.style.zIndex-1;
			}
			if(epages.zIndex){
				epages.zIndex+=2;
			}
			//disconnect scrollevent from dialog, because there is no parameter in dojo dialog to achive this
			for(var i = 0, iLength = this._modalconnects.length; i < iLength; i++){
				var currentEventHandle = this._modalconnects[i];
				if( currentEventHandle.length && currentEventHandle[1] &&  currentEventHandle[1] == 'onscroll'){
					dojo.disconnect(currentEventHandle);
				}
			}
			//check if there is enough space to see the close button
			var popupTop = parseInt(this.domNode.style.top);
			var popupLeft = parseInt(this.domNode.style.left);
			if(popupTop < 0){
				this.domNode.style.top = "0px";
			}
			if(popupLeft < 0){
				this.domNode.style.left = "";
				this.domNode.style.right = "0px";
			}
			else {
				this.domNode.style.right = "";
			}
			//remove dragging
			if(this._moveable){
				this._moveable.destroy();
			}
			// manual focus handling : focus first input
			if(!this.autofocus) {
				var inputs = dojo.query('input', this.containerNode);
				if(inputs && inputs.length > 0) {
					inputs[0].focus();
				}
			}
			// trigger resize to adjust CKEditor dimensions
			jq(window).trigger('resize');

			dojo.publish(this.id+'/show',[{dialog: this}]);
		},

		close: function() {
			this.hide();
			window.setTimeout(dojo.hitch(this,function(){
				this._destroyContent();
				this._destroyButtons();
			}),this.duration);
		},

		setupContent: function(/*Object*/ opt) {
		// summary: setup new content (destorys old content contentarea, tabs, buttons)
		// opt: {
		//  content - string / domNode / widget object (strings may contain widgets e.g. <div dojoType="epages.widget.Tooltip"></div>)
		//  buttons - array with buttons e.g. [{label: 'Cancel',onclick: function() {this._modalDialogWidget.hide();}]}
		//  width - integer or string - width of content area
		//  height - integer or string - height of content area
		//  scroll - string - possible values: 'y', 'x', 'scroll', 'hidden'
		//  title - string - text in titlebar
		//  translationName - string (url) specify translation file to translate language tags in title attribute
		//  url - load content via url
		//  destroyWidgetOnClose - boolean - option to destroy widgets after closing the content widget (also after setting up new content)
		// }
			this._destroyTabs();
			this._destroyContent();
			this._destroyButtons();

			if (opt.buttons){
				this.setupButtons(opt.buttons);
			}
			this._createContent(opt);
			this._createTabs();
		},

		setupButtons: function (buttons) {
			this._destroyButtons();
			this._createButtons(buttons);
		},


		setTitle: function(title) {
			this.titleNode.innerHTML = title;
		},

/**
* widget button/ display functions
*/

		hideInnerButtonBar : function() {
			this.innerButtonBarNode.style.display ='none';
		},

		showInnerButtonBar : function() {
			this.innerButtonBarNode.style.display ='';
		},

		disableButton : function(/* string|DomNode*/ but) {
		// summary: disables specified button
			if(dojo.isString(but)){
				var buttons = dojo.query("[buttonid="+but+"]", this.domNode );
				if(buttons){
					buttons = buttons[0];
				}
			} else {
				var buttons = but;
			}
			if(buttons) {
				dojo.removeClass(buttons, "Active");
				dojo.addClass(buttons, "Disabled");
				buttons.disabled=true;
			}

			dojo.forEach(this._events, function(evtmap) {
				if(evtmap.button.domNode == buttons) {
					dojo.disconnect(evtmap.event);
				}
			});

		},

		enableButton : function(/* string */ buttonId) {
		// summary: enables specified button
			var buttonData = undefined;
			dojo.forEach(this.buttons, function (button) {
				if(button.buttonId == buttonId) {
					buttonData = button;
				}
			});

			if(buttonData && buttonData.domNode.disabled == true) {
				buttonData.domNode.disabled=false;
				if(buttonData.cssClass) {
					dojo.addClass(buttonData.domNode, buttonData.cssClass );
				}
				dojo.removeClass(buttonData.domNode, "Disabled");
				dojo.forEach(this._events, function(evtmap) {
					if(evtmap.button.buttonId == buttonId) {
						evtmap.event = dojo.connect(buttonData.domNode, "onclick", buttonData, "onclick");
					}
				});
			}
		},

		_createContent: function(/*Object*/ opt) {
			if(opt){
				dojo.mixin(this.options, opt);
			}

			var translation = undefined;
			if(this.options.translationName) {
				translation = new epages.io.Translation(this.options.translationName,"auto");
				if(this.options.title){
					this.options.title = translation.replaceLanguageTags(this.options.title);
				}
			}
			if (this.options.title){
				this.setTitle(this.options.title);
			}
			// set Layout
			switch(this.options.scroll){
				case "y":
					this.containerNode.style.overflowY='scroll';
					break;
				case "x":
					this.containerNode.style.overflowX='scroll';
					break;
				case "scroll":
					this.containerNode.style.overflow='scroll';
					break;
				case "hidden":
					this.containerNode.style.overflow='hidden';
					break;
				default:
					this.containerNode.style.overflow='auto';
					break;
			}
			if (this.options.width) {
				if (typeof this.options.width == 'number') {
					this.layerContentNode.style.width=this.options.width+"px";
				} else {
					this.layerContentNode.style.width=this.options.width;
				}
			} else {
				this.containerNode.style.width="auto";
				this.layerContentNode.style.width="auto";
			}
			if (this.options.height) {
				if (typeof this.options.height == 'number') {
					this.containerNode.style.height=this.options.height+"px";
				} else {
					this.containerNode.style.height=this.options.height;
				}
			} else {
				this.containerNode.style.height="auto";
			}
			if (this.options.url != null) {
				// url, use contentPane
				if (this._contentPane == null) {
					// contentPane does not exist -> create it
					this._contentPane = new dojox.layout.ContentPane({
						// url of content
						href: this.options.url,
						// wait for download to finish
						preload: true,
						// extract content from body tag
						extractContent: false,
						// adjust relative paths
						adjustPaths: true,
						// set content on download end to avoid resizing problem <-- does not work
						ioMethod: function(args) {
							var result = dojo.xhrGet(args);
							if(translation){
								result.addCallback(function(html){
										return translation.replaceLanguageTags(html);
								});
							}
							return result;
						},
						onLoad: dojo.hitch(this, function() {
							//Timeout necessary for IE
							window.setTimeout(dojo.hitch(this,function(){
							this.containerNode.appendChild(this._contentPane.domNode);
							// call event function
							if (this.options && this.options.onLoad && typeof this.options.onLoad == 'function'){
								this.options.onLoad();
							}
							this.layout();
							this.show();
							this._createTabs();
							dojo.publish(this.id+'/onLoadContentPane',[{dialog: this}]);
						}),10);
						})
					});
					this._contentPane.refresh();
				} else {
					this._contentPane.setHref(this.options.url);
				}
			} else {
				if(typeof this.options.content == "object") {
					// content, string, nodes or widgets
					if(this.options.content.domNode) { // widget
						this.containerNode.appendChild(this.options.content.domNode);
						this._contentWidget=this.options.content;
					} else {                           // dom node
						this.containerNode.appendChild(this.options.content);
					}
				} else if(typeof this.options.content == "string") {
					this.containerNode.innerHTML=this.options.content;  // html string
					var scripts = this.containerNode.getElementsByTagName('script');
					var win = this._doc.parentWindow ? this._doc.parentWindow : this._doc.defaultView;
					for( var i=0,iLength=scripts.length ; i<iLength ; i++ ) {
						if (scripts[i].childNodes.length > 0) {
							// Mozilla
							// Fix for bug https://bugzilla.mozilla.org/show_bug.cgi?id=194231: only 4K string in array element
							var evalString = "";
							for( var j=0,jLength=scripts[i].childNodes.length ; j<jLength ; j++ ) {
								evalString += scripts[i].childNodes[j].nodeValue;
							}
							win.eval(evalString);
						} else {
							// IE
							win.eval(scripts[i].innerHTML);
						}
					}
					win.dojo.parser.parse(this.containerNode); // build widgets
					//epages.widget.TransformButtons(this.containerNode);
				}
			}
			dojo.publish(this.id+'/change',[{dialog: this}]);
		},

		_destroyContent: function() {
			this.options.scroll=undefined;
			this.options.width=undefined;
			this.options.height=undefined;
			this.options.title=undefined;
			this.options.url=undefined;

			if(this.titleNode.firstChild){
				this.titleNode.firstChild.data=" ";
			}
			this.containerNode.style.overflow='auto';
			this.containerNode.style.overflowX='auto';
			this.containerNode.style.overflowY='auto';
			this.containerNode.style.width="auto";
			this.layerContentNode.style.width="auto";
			this.containerNode.style.height="auto";
			this.innerButtonBarNode.style.display="none";
			this.tabBarNode.style.display="none";

			// remove containerNode children

			epages.html.removeChildren(this.containerNode);

			if(typeof this.options.content == "object" && this.options.destroyWidgetOnClose){
				this.options.content.destroy();   // destroy widget
			}
			this._contentWidget = null;
			this.options.content = "";
		},

		_createButtons: function(/* Object[] */ buttons) {
		// summary: create modal dialog buttons
		// buttons:
		// [{
		//   label: '{Delete}',
		//   cssClass: 'Active',
		//   buttonId: 'delete',
		//   hideOnShow: 'false',
		//   isDisabled: 'false',
		//   onclick: function() {
		//     me.deleteNavigationElement();
		//     this._modalDialogWidget.hide();
		//   }
		//  },{
		//    label: '{Cancel}',
		//    onclick: function() { this._modalDialogWidget.hide(); }
		// }]
			if(buttons.length){
				this.innerButtonBarNode.style.display="";
			}
			this.buttons = [];
			this._events = [];
			dojo.forEach(buttons, function (button) {
				button.domNode=[];
				var tmplProcessor=new epages.Template({
					template: this.buttonTemplateString,
					vars    : {
						'Label': button.label,
						'Class': button.cssClass ? button.cssClass : '',
						'buttonId': (button.buttonId) ? 'buttonid='+button.buttonId+' ' : ''
					}
				});
				var buttonNode= this.createNodesFromText(tmplProcessor.generateOutput());
				this.innerButtonBarNode.appendChild(buttonNode);
				button.domNode=buttonNode;
				dojo.mixin(button, {_modalDialogWidget: this, _contentWidget: this._contentWidget});
				this._events.push({ event: dojo.connect(button.domNode, "onclick", button, "onclick"), button : button});
				this.buttons.push(button);
				if(button.isDisabled == 'true'){
					this.disableButton(buttonNode);
				}
			}, this);
			this.clearFloatNode = document.createElement("div");
			this.clearFloatNode.className="ClearBoth";
			this.innerButtonBarNode.appendChild(this.clearFloatNode);
		},

		_destroyButtons: function () {
			dojo.forEach(this._events, function(evtmap) {
				dojo.disconnect(evtmap.event);
			});
			dojo.forEach(this.buttons, function (button) {
				button.domNode.parentNode.removeChild(button.domNode);
				button.domNode = undefined;
			});
			this._events = null;
			delete this._events;			// delete var
			this.buttons=[];
			if(this.clearFloatNode !== undefined && this.clearFloatNode.parentNode != null) {
				this.clearFloatNode.parentNode.removeChild(this.clearFloatNode);
				this.clearFloatNode = undefined;
			}
		},

		_createTabs: function() {
		// summary: creates tabs by looking for dom nodes with css class "TabPage"
		// description: tab labels ar specified by attribute ep_label of the dom node
			var tabs = epages.html.getElementsByClassName('TabPage',this.containerNode);
			if(tabs.length && tabs.length > 1){
				this.tabBarNode.style.display="";
				dojo.addClass(this.tabBarNode, "Visible");
				this._tabs = [];
				this._tabEvents = [];
				dojo.forEach(tabs, function (domNode) {
					var tab = {
						domNode : [],
						changeNode: domNode
					};
					var tmplProcessor = new epages.Template({
						template: this.tabTemplateString,
						vars    : {
							'Label': domNode.getAttribute('ep_label')
						}
					});
					var tabNode = this.createNodesFromText(tmplProcessor.generateOutput());
					this.tabBarNode.appendChild(tabNode);
					tab.domNode = tabNode;
					//dojo.mixin(tab, {_modalDialogWidget: this, _contentWidget: this._contentWidget});
					this._tabEvents.push(dojo.connect(tab.domNode, "onclick", this, "_onTabClick"));
					tab.changeNode.style.display = 'none';
					this._tabs.push(tab);
				}, this);
				//activate first tab
				this._tabs[0].changeNode.style.display = '';
				dojo.addClass(this._tabs[0].domNode, 'Active');
				this._currentTab = this._tabs[0];
			} else {
				dojo.removeClass(this.tabBarNode, "Visible");
			}
		},

		_destroyTabs: function () {
			dojo.forEach(this._tabEvents, dojo.disconnect);
			dojo.forEach(this._tabs, function (tab) {
				tab.domNode.parentNode.removeChild(tab.domNode);
				tab.domNode = undefined;
				tab.changeNode = undefined;
			});
			this._tabs=[];
			this._currentTab = undefined;
		},

		_onTabClick: function(evt){
			var targetTab = evt.currentTarget;
			var tab = undefined;
			for( var i=0,iLength=this._tabs.length ; i<iLength ; i++ ){
				if(targetTab == this._tabs[i].domNode){
					tab = this._tabs[i];
				}
			}
			if(tab){
				if(this._currentTab){
					dojo.removeClass(this._currentTab.domNode,'Active');
					this._currentTab.changeNode.style.display = 'none';
				}
				tab.changeNode.style.display = '';
				dojo.addClass(tab.domNode, 'Active');
				this._currentTab = tab;
				dojo.publish(this.id+"/tabChange",[tab.changeNode]);
			}
		}
	}
);

}

if(!dojo._hasResource["epages.widget.Tooltip"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Tooltip"] = true;
/*
	Copyright (c) 2006-2010, ePages GmbH
	All Rights Reserved.

	epages.widget.tooltip $Revision: 1.29 $
*/
dojo.provide("epages.widget.Tooltip");


dojo.declare("epages.widget.Tooltip", [dijit._Widget, dijit._Templated], {

		/**
		 * public properties
		 */
		disabledBodyClickHide : false,
		tooltipLayerFrame     : undefined,
		tooltipAreaId         : '',
		tooltipArea           : undefined,
		tooltipNode           : undefined,
		interactive           : '',	// String - Is the user able to use the content of the tooltip? i.e. if there's links in the tooltip text
		tooltipShowDelay      : 0,
		tooltipHideDelay      : 0,
		currentYPosition      : 0,
		currentXPosition      : 0,
		hideDelay             : null,
		fadeDelay             : null,
		showDelay             : null,
		bgcolor               : '',
		forceOrientation      : '',	// String - B - bottom, T - top , L - left, R - right (combinations are possible e.g BR)
		target                : "default",
		findAreaMethod        : "",

		/**
		 * private properties
		 */
		_findAreaMethodMapping: {
			'default'           : 'parentNode',
			'previous'          : 'previousSibling',
			'next'              : 'nextSibling'
		},													// Object - which node should be used to connect to the tooltip activation events (mouseover-area)
		_doc                  :	null,				// DomNode - owner document, i.e. to calculate the widget position
		_bodyConnect          : undefined,	// to store event connect to document's body, i.e. for hiding the tooltip when clicked somewhere else on the page
		_windowConnect        : undefined,	// to store event connect to the window for capturing keypress events

		/**
		 * dojo widget properties
		 */
		templateString        : '<div class="Tooltip"><div dojoAttachPoint="containerNode"></div></div>',


		/**
		 * dojo lifecycle methods
		 */
		postCreate: function() {
			// summary: widget lifecycle postCreate handler
			// description:
			//		Initializes widget parameters and find dom element for displaying the tooltip widget
			//		(see _findAreaMethodMapping values). Then create dom elements for the tooltip bubble
			//		and connect the keyboard/mouse event handlers.
			this.inherited("postCreate", arguments);
			this.tooltipNode = this.domNode;
			// catch tooltip area node
			var tooltipArea = undefined;
			if(this.tooltipArea) {
				tooltipArea = this.tooltipArea;
			}
			else if(this.tooltipAreaId!="") {
				tooltipArea= $(this.tooltipAreaId);
			}
			else {
				var findAreaMethod = this._findAreaMethodMapping[this.findAreaMethod || this.target];
				tooltipArea = this.domNode[findAreaMethod];
				if(tooltipArea.nodeType!= 1) {
					if(findAreaMethod == 'previousSibling') {
						tooltipArea=tooltipArea.previousSibling; // skip spaces
					}
					if(findAreaMethod == 'nextSibling') {
						tooltipArea=tooltipArea.nextSibling;     // skip spaces
					}
				}
			}

			if(this.bgcolor !=''){
				this.domNode.style.backgroundColor = this.bgcolor;
			}

			if(!tooltipArea || tooltipArea.nodeType!=1 ){
				console.warn('TooltipArea not found by using find method "'+this.findAreaMethod+'" in '+this.declaredClass);
			} else {
				this.tooltipArea = tooltipArea;
				this._doc = this.tooltipArea.ownerDocument;
				this.tooltipIsInteractive = epages.string.toBoolean(this.interactive);
				this.tooltipShowDelay = 600;
				this.tooltipHideDelay = this.tooltipIsInteractive ? 1400 : 400;
				this.tooltipLayerFrame = this._doc.createElement("div");
				this.tooltipShadow = this._doc.createElement("div");
				dojo.style(this.tooltipNode, "opacity", 0);

				this._bodyConnect = dojo.connect(dojo.body(),"onmouseup",this, "onBodyClick");
				this._windowConnect = dojo.connect(window,"onkeypress", this,"onKeypress");
				this.connect(this.tooltipArea, "onmousemove", "onElementMove");
				this.connect(this.tooltipArea, "onmouseover", "onElementOver");
				this.connect(this.tooltipArea, "onmouseout", "onElementOut");
				this.connect(this.tooltipArea, "onmousedown", "onElementClick");
				if(this.tooltipIsInteractive) {
					this.connect(this.tooltipNode, "onmouseover", "onTooltipOver");
					this.connect(this.tooltipNode, "onmouseout", "onTooltipOut");
				}
			}
		},

		destroy: function(){
			// summary: widget lifecycle destroy handler
			// description:
			//		Disconnect event handlers to body and window of the widget-containing document.
			this.inherited("destroy", arguments);
			dojo.disconnect(this._bodyConnect);
			dojo.disconnect(this._windowConnect);
		},


		/**
		 * public methods
		 */
		setContent: function(/* string */ html) {
			this.containerNode.innerHTML=html;
			this.setPosition();
		},

		isActive: function() {
			// summary: Is the tooltip dom node visible?
			// returns:  false if zero opacity, otherwise true
			return dojo.style(this.tooltipNode, "opacity") == 0? false : true;
		},

		setPosition: function() {
			// summary: Move the tooltip
			// description:
			//		Depending on the orientation mode set by the forceOrientation variable move the tooltip
			//		domNode to the position determined by currentYPosition and currentXPosition. This depends
			//		on the document parenting the tooltip node as well as possible window scroll bars.
			var forceRight  = (this.forceOrientation.match('R')) ? true : false;
			var forceLeft   = (this.forceOrientation.match('L')) ? true : false;
			var forceBottom = (this.forceOrientation.match('B')) ? true : false;
			var forceTop    = (this.forceOrientation.match('T')) ? true : false;

			// horizontal position
			var docWidth = epages.Browser.engine == "WebKit" ? this._doc.body.clientWidth : this._doc.documentElement.clientWidth;
			var rightSideX = this.tooltipNode.offsetWidth + this.currentXPosition + 16 + 3 - (this._doc.documentElement.scrollLeft || this._doc.body.scrollLeft);	// 16px = dist. from mouse ; 3px = shadow iframe
			if((rightSideX > docWidth && ! forceRight) || forceLeft) {
				var x = this.currentXPosition - this.tooltipNode.offsetWidth;
				if(forceLeft){
					x-=16;
				}
				if(x < 0){
					x=0;
				}
				this.tooltipNode.style.left = x + "px";			// layer > left align
			} else {
				var x = this.currentXPosition;
				if(forceRight){
					x+=16;
				}
				this.tooltipNode.style.left = x + "px";			// layer > right align
			}

			// vertical position
			var docHeight = epages.Browser.engine == "WebKit" ? this._doc.body.clientHeight : this._doc.documentElement.clientHeight;
			var bottomSideX = this.tooltipNode.offsetHeight + this.currentYPosition + 16 + 3 - (this._doc.documentElement.scrollTop || this._doc.body.scrollTop);
			if((bottomSideX > docHeight && ! forceBottom) || forceTop) { // 16px = dist. from mouse ; 3px = shadow iframe
				var y = this.currentYPosition - this.tooltipNode.offsetHeight - 16;
				if(y < 0){
					y=0;
				}
				this.tooltipNode.style.top =  y + "px";														// layer > top align
			}else{
				this.tooltipNode.style.top = this.currentYPosition + 16 + "px";		// layer > bottom align
			}
			this.tooltipLayerFrame.style.width = this.tooltipNode.offsetWidth + 2 + "px";
			this.tooltipLayerFrame.style.height = this.tooltipNode.offsetHeight + 2 + "px";
		},

		show: function(/* int */ x, /* int */ y) {
			// summary: Set position & display the Tooltip
			// description:
			//		Update the tooltip position and triggers the display of the tooltip.
			this.currentXPosition = x;
			this.currentYPosition = y;
			this.showTooltip();
		},

		showTooltip: function() {
			// summary: Display the Tooltip
			// description:
			//		Hide the tooltip dom node before changing it. Then attach the layout classes and move the
			//		tooltip frame to front. Finally attach the tooltip node to the dom tree and display it.
			dojo.addClass(this.tooltipNode, "HideElement");
			if(!this.rendered){
				dojo.addClass(this.tooltipNode, "Tooltip");
				dojo.addClass(this.tooltipShadow, "TooltipShadow");
				dojo.addClass(this.tooltipLayerFrame, "LayerIframe");
				if(!this.tooltipIsInteractive) {
					this.tooltipLayerFrame.style.zIndex = "1";
					this.tooltipNode.style.MozUserSelect = 'none';
				}
				this.tooltipNode.appendChild(this.tooltipLayerFrame); // overlay
				this.tooltipNode.appendChild(this.tooltipShadow);
				this._doc.getElementsByTagName("body")[0].appendChild(this.tooltipNode);
				this.rendered = true;
			}

			var _this = this;

			if( this.fadeAction ) {
				this.fadeAction.stop();
			}

			this.fadeAction = dojo.fadeIn({
				node: this.tooltipNode,
				duration:200,
				beforeBegin: function() {
					_this.tooltipNode.style.display = "block";
					_this.setPosition();
					dojo.removeClass(_this.tooltipNode, "HideElement");
				}
			});
			this.fadeAction.play();
		},

		hide: function() {
			// summary: Hide the Tooltip
			// description:
			//		After a fade, hide the tooltip.
			var _this = this;
			if( this.fadeAction ) {
				this.fadeAction.stop();
			}

			this.fadeAction = dojo.fadeOut({
				node:this.tooltipNode,
				duration: 200,
				onEnd: function() {
					_this.tooltipNode.style.display = "none";
				}
			});
			this.fadeAction.play();
		},


		/**
		 * Event handlers
		 */
		onElementMove: function(mouseEvent) {
			if(!mouseEvent){
				var mouseEvent = window.event;
			}
			this.currentYPosition = mouseEvent.clientY + (this._doc.documentElement.scrollTop || this._doc.body.scrollTop);
			this.currentXPosition = mouseEvent.clientX + (this._doc.documentElement.scrollLeft || this._doc.body.scrollLeft);
		},
		onElementOver: function() {
			this.disabledBodyClickHide = true;
			this._resetTimeouts();
			if(!this.isActive()) {
				this.showDelay = this._delayExec(this.showTooltip, this.tooltipShowDelay);
			}
		},
		onElementOut: function() {
			this._resetTimeouts();
			this.fadeDelay = this._delayExec(this.hide, this.tooltipHideDelay);
			this.disabledBodyClickHide = false;
		},
		onElementClick: function() {
			this.disabledBodyClickHide = true;
			if(!this.isActive()) {
				this._resetTimeouts();
				this.showTooltip();
			}
		},
		onTooltipOver: function() {
			this.disabledBodyClickHide = true;
			this._resetTimeouts();
		},
		onTooltipOut: function() {
			this.disabledBodyClickHide = false;
			this.onElementOut();
		},
		onBodyClick: function() {
			if(!this.disabledBodyClickHide && this.isActive()) {
				this._resetTimeouts();
				this.hide();
			}
		},
		onKeypress: function(evt) {
			if(evt.keyCode == dojo.keys.ESCAPE) {
				this._resetTimeouts();
				this.hide();
			}
		},


		/**
		 * private methods
		 */
		_delayExec: function(task, delay) {
			return setTimeout(dojo.hitch(this, task), delay);
		},
		_resetTimeouts: function() {
			clearTimeout(this.hideDelay);
			clearTimeout(this.fadeDelay);
			clearTimeout(this.showDelay);
		}

	}
);

}

if(!dojo._hasResource["dojox.fx._base"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.fx._base"] = true;
dojo.provide("dojox.fx._base");
// summary: Experimental and extended Animations beyond Dojo Core / Base functionality. 
//	Provides advanced Lines, Animations, and convenience aliases.
 

dojo.mixin(dojox.fx, {

	// anim: Function
	//	Alias of `dojo.anim` - the shorthand `dojo.animateProperty` with auto-play
	anim: dojo.anim,

	// animateProperty: Function
	//	Alias of `dojo.animateProperty` - animate any CSS property
	animateProperty: dojo.animateProperty,

	// fadeTo: Function 
	//		Fade an element from an opacity to an opacity.
	//		Omit `start:` property to detect. `end:` property is required.
	//		Ultimately an alias to `dojo._fade`
	fadeTo: dojo._fade,

	// fadeIn: Function
	//	Alias of `dojo.fadeIn` - Fade a node in.
	fadeIn: dojo.fadeIn,
	
	// fadeOut: Function
	//	Alias of `dojo.fadeOut` - Fades a node out.
	fadeOut: dojo.fadeOut,

	// combine: Function
	//	Alias of `dojo.fx.combine` - Run an array of animations in parallel
	combine: dojo.fx.combine,

	// chain: Function
	//	Alias of `dojo.fx.chain` - Run an array of animations in sequence
	chain: dojo.fx.chain,

	// slideTo: Function
	//	Alias of `dojo.fx.slideTo` - Slide a node to a defined top/left coordinate
	slideTo: dojo.fx.slideTo,

	// wipeIn: Function
	//	Alias of `dojo.fx.wipeIn` - Wipe a node to visible
	wipeIn: dojo.fx.wipeIn,

	// wipeOut: Function
	//	Alias of `dojo.fx.wipeOut` - Wipe a node to non-visible
	wipeOut: dojo.fx.wipeOut

});

dojox.fx.sizeTo = function(/* Object */args){
	// summary: 
	//		Creates an animation that will size a node
	//
	// description:
	//		Returns an animation that will size the target node
	//		defined in args Object about it's center to
	//		a width and height defined by (args.width, args.height), 
	//		supporting an optional method: chain||combine mixin
	//		(defaults to chain).	
	//
	//	- works best on absolutely or relatively positioned elements
	//	
	// example:
	//	|	// size #myNode to 400px x 200px over 1 second
	//	|	dojo.fx.sizeTo({
	//	|		node:'myNode',
	//	|		duration: 1000,
	//	|		width: 400,
	//	|		height: 200,
	//	|		method: "combine"
	//	|	}).play();
	//

	var node = args.node = dojo.byId(args.node),
		abs = "absolute";

	var method = args.method || "chain"; 
	if(!args.duration){ args.duration = 500; } // default duration needed
	if(method == "chain"){ args.duration = Math.floor(args.duration / 2); } 
	
	var top, newTop, left, newLeft, width, height = null;

	var init = (function(n){
		return function(){
			var cs = dojo.getComputedStyle(n),
				pos = cs.position,
				w = cs.width,
				h = cs.height
			;
			
			top = (pos == abs ? n.offsetTop : parseInt(cs.top) || 0);
			left = (pos == abs ? n.offsetLeft : parseInt(cs.left) || 0);
			width = (w == "auto" ? 0 : parseInt(w));
			height = (h == "auto" ? 0 : parseInt(h));
			
			newLeft = left - Math.floor((args.width - width) / 2); 
			newTop = top - Math.floor((args.height - height) / 2); 

			if(pos != abs && pos != 'relative'){
				var ret = dojo.coords(n, true);
				top = ret.y;
				left = ret.x;
				n.style.position = abs;
				n.style.top = top + "px";
				n.style.left = left + "px";
			}
		}
	})(node);

	var anim1 = dojo.animateProperty(dojo.mixin({
		properties: {
			height: function(){
				init();
				return { end: args.height || 0, start: height };
			},
			top: function(){
				return { start: top, end: newTop };
			}
		}
	}, args));
	var anim2 = dojo.animateProperty(dojo.mixin({
		properties: {
			width: function(){
				return { start: width, end: args.width || 0 }
			},
			left: function(){
				return { start: left, end: newLeft }
			}
		}
	}, args));

	var anim = dojo.fx[(args.method == "combine" ? "combine" : "chain")]([anim1, anim2]);
	return anim; // dojo.Animation

};

dojox.fx.slideBy = function(/* Object */args){
	// summary: 
	//		Returns an animation to slide a node by a defined offset.
	//
	// description:
	//		Returns an animation that will slide a node (args.node) from it's
	//		current position to it's current posision plus the numbers defined
	//		in args.top and args.left. standard dojo.fx mixin's apply. 
	//	
	// example:
	//	|	// slide domNode 50px down, and 22px left
	//	|	dojox.fx.slideBy({ 
	//	|		node: domNode, duration:400, 
	//	|		top: 50, left: -22 
	//	|	}).play();

	var node = args.node = dojo.byId(args.node),
		top, left;

	var init = (function(n){
		return function(){
			var cs = dojo.getComputedStyle(n);
			var pos = cs.position;
			top = (pos == 'absolute' ? n.offsetTop : parseInt(cs.top) || 0);
			left = (pos == 'absolute' ? n.offsetLeft : parseInt(cs.left) || 0);
			if(pos != 'absolute' && pos != 'relative'){
				var ret = dojo.coords(n, true);
				top = ret.y;
				left = ret.x;
				n.style.position = "absolute";
				n.style.top = top + "px";
				n.style.left = left + "px";
			}
		}
	})(node);
	init();
	
	var _anim = dojo.animateProperty(dojo.mixin({
		properties: {
			// FIXME: is there a way to update the _Line after creation?
			// null start values allow chaining to work, animateProperty will
			// determine them for us (except in ie6? -- ugh)
			top: top + (args.top || 0),
			left: left + (args.left || 0) 
		}
	}, args));
	dojo.connect(_anim, "beforeBegin", _anim, init);
	return _anim; // dojo.Animation
};

dojox.fx.crossFade = function(/* Object */args){
	// summary: 
	//		Returns an animation cross fading two element simultaneously
	// 
	// args:
	//	args.nodes: Array - two element array of domNodes, or id's
	//
	//	all other standard animation args mixins apply. args.node ignored.
	//

	// simple check for which node is visible, maybe too simple?
	var node1 = args.nodes[0] = dojo.byId(args.nodes[0]),
		op1 = dojo.style(node1,"opacity"),
		node2 = args.nodes[1] = dojo.byId(args.nodes[1]),
		op2 = dojo.style(node2, "opacity")
	;
	
	var _anim = dojo.fx.combine([
		dojo[(op1 == 0 ? "fadeIn" : "fadeOut")](dojo.mixin({
			node: node1
		},args)),
		dojo[(op1 == 0 ? "fadeOut" : "fadeIn")](dojo.mixin({
			node: node2
		},args))
	]);
	return _anim; // dojo.Animation
};

dojox.fx.highlight = function(/*Object*/ args){
	// summary: 
	//		Highlight a node
	//
	// description:
	//		Returns an animation that sets the node background to args.color
	//		then gradually fades back the original node background color
	//	
	// example:
	//	|	dojox.fx.highlight({ node:"foo" }).play(); 

	var node = args.node = dojo.byId(args.node);

	args.duration = args.duration || 400;
	
	// Assign default color light yellow
	var startColor = args.color || '#ffff99',
		endColor = dojo.style(node, "backgroundColor")
	;

	// safari "fix"
	// safari reports rgba(0, 0, 0, 0) (black) as transparent color, while
	// other browsers return "transparent", rendered as white by default by
	// dojo.Color; now dojo.Color maps "transparent" to
	// djConfig.transparentColor ([r, g, b]), if present; so we can use
	// the color behind the effect node
	if(endColor == "rgba(0, 0, 0, 0)"){
		endColor = "transparent";
	}

	var anim = dojo.animateProperty(dojo.mixin({
		properties: {
			backgroundColor: { start: startColor, end: endColor }
		}
	}, args));

	if(endColor == "transparent"){
		dojo.connect(anim, "onEnd", anim, function(){
			node.style.backgroundColor = endColor;
		});
	}

	return anim; // dojo.Animation
};

 
dojox.fx.wipeTo = function(/*Object*/ args){
	// summary:
	//		Animate a node wiping to a specific width or height
	//	
	// description:
	//		Returns an animation that will expand the
	//		node defined in 'args' object from it's current to
	//		the height or width value given by the args object.
	//
	//		default to height:, so leave height null and specify width:
	//		to wipeTo a width. note: this may be deprecated by a 
	//
	//		Note that the final value should not include
	//		units and should be an integer.  Thus a valid args object
	//		would look something like this:
	//
	//		|	dojox.fx.wipeTo({ node: "nodeId", height: 200 }).play();
	//
	//		Node must have no margin/border/padding, so put another
	//		node inside your target node for additional styling.

	args.node = dojo.byId(args.node);
	var node = args.node, s = node.style;

	var dir = (args.width ? "width" : "height"),
		endVal = args[dir],
		props = {}
	;

	props[dir] = {
		// wrapped in functions so we wait till the last second to query (in case value has changed)
		start: function(){
			// start at current [computed] height, but use 1px rather than 0
			// because 0 causes IE to display the whole panel
			s.overflow = "hidden";
			if(s.visibility == "hidden" || s.display == "none"){
				s[dir] = "1px";
				s.display = "";
				s.visibility = "";
				return 1;
			}else{
				var now = dojo.style(node,dir);
				return Math.max(now, 1);
			}
		},
		end: endVal
	};

	var anim = dojo.animateProperty(dojo.mixin({ properties: props }, args));
	return anim; // dojo.Animation
};

}

if(!dojo._hasResource["dojox.fx"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojox.fx"] = true;
dojo.provide("dojox.fx");

 

}

if(!dojo._hasResource["epages.widget.Message"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Message"] = true;
dojo.provide("epages.widget.Message");




dojo.declare("epages.widget.Message",
	[dijit._Widget,dijit._Templated],
	{
		/**
		 * public properties
		 */
		headline: "",
		message: "",
		sizeClass: "Small",
		typeClass: "Info",
		borderClass: "",
		loderAniNode : undefined,

		/**
		 * dojo widget properties
		 */
		templateString:"<div class=\"Message ${sizeClass} ${typeClass} ${borderClass}\">\n  <div class=\"Headline\" dojoAttachPoint=\"headlineNode\">${headline}</div>\n  <div class=\"MessageDetails\" dojoAttachPoint=\"messageNode\">${message}</div>\n</div>\n",

		show: function() {
			this.domNode.style.display="block";
		},

		hide: function() {
			this.domNode.style.display="none";
		},

		postCreate: function() {
			this.inherited("postCreate", arguments);
			this.setupContent({
				headline: this.headline,
				message: this.message,
				sizeClass: this.sizeClass,
				typeClass: this.typeClass,
				borderClass: this.borderClass
			});
		},

		setupContent: function(/*Object*/opt) {
		// summary: set up new content / change content
		// opt: {
		//        headline - sting
		//        message - string
		//        sizeClass - string: Small, Medium, Large
		//        typeClass - string: Error, Warning, Notification, Question, Tip, Confirmation
		//        borderClass - string -> your css class
		//      }

			if(opt.headline !== undefined && opt.headline!="") {
				this.headline=opt.headline;
				this.headlineNode.innerHTML=opt.headline;
				this.headlineNode.style.display="";
			} else
				this.headlineNode.style.display="none";

			if(opt.message !== undefined && opt.message!="") {
				this.message=opt.message;
				this.messageNode.innerHTML=opt.message;
				this.messageNode.style.display="";
				dojo.parser.parse(this.messageNode);
			} else
				this.messageNode.style.display="none";

			if(opt.sizeClass !== undefined) {
				epages.html.replaceClass(this.domNode, opt.sizeClass, this.sizeClass);
				this.sizeClass = opt.sizeClass;
			}
			if(opt.typeClass !== undefined) {
				epages.html.replaceClass(this.domNode, opt.typeClass, this.typeClass);
				this.typeClass = opt.typeClass;

				if(this.loderAniNode !== undefined && opt.typeClass != "Loader") {
					epages.loaderani.destroy(this.loderAniNode);
				}
				if(opt.typeClass == "Loader") {
					var lani_options = {
						top: 14,
						left: 14,
						width: 24,
						height: 24
					}
					this.domNode.style.position="relative";
					this.loderAniNode = epages.loaderani.create(lani_options, this.domNode);
				}
			}

			if(opt.borderClass !== undefined) {
				epages.html.replaceClass(this.domNode, opt.borderClass, this.borderClass);
				this.borderClass = opt.borderClass;
			}
		}
	}
);

}

if(!dojo._hasResource["epages.widget.Bubble"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Bubble"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.
*/
dojo.provide("epages.widget.Bubble");



dojo.declare("epages.widget.Bubble", [dijit._Widget, dijit._Templated],	{
		optionsstring   : "",              // string - setup options as string
		options         : undefined,       // object - setup options (see setupContent for more)
		typeClass       : "",              // string - (Additional css class e.g. Wide)

		/* widget properties */
		templateString:"<div class=\"Bubble ${typeClass}\">\n  <div class=\"LayerOverIframe\" dojoAttachPoint=\"layerOverIframeNode\">\n    <div class=\"BubbleLayer\">\n      <div class=\"BubbleClose\" dojoAttachPoint=\"closeNode\"></div>\n      <div dojoAttachPoint=\"containerNode\"></div>\n    </div>\n    <div class=\"BubbleFoot\"></div>\n  </div>\n</div>\n",

		/* widget life cycle */
		postMixInProperties: function() {
			this.inherited("postMixInProperties", arguments);
			// prepare settings
			if(this.options===undefined){
				this.options = { content: '' };
			}

			var optFromString = (this.optionsstring != "" ) ? dojo.fromJson(this.optionsstring) : undefined;
			if(optFromString) {
				dojo.mixin(this.options, optFromString);
			}
		},

		postCreate: function() {
			this.inherited("postCreate", arguments);
			this.setupContent(this.options);
			// events
			this.connect(this.closeNode, 'onclick', 'hide');
			this.connect(window, "onkeypress", "onKeypress");
			this.connect(window, "onresize", "hide");
			this.connect(document.body, "onkeypress", "onKeypress");
		},

		/* public methods */

		setupContent: function(/*Object*/opt) {
			// summary: setup bubble content
			// opt:{
			//       content     - widget, string
			//       x           - integer
			//       y           - integer
			//       typeClass   - string (Additional css class e.g. Wide)
			//       orientation - string -> specifies the location of the bubble arrow (left right bottom top-right)
			//     }

			// mix in options
			if(opt) {
				dojo.mixin(this.options, opt);
			}

			// remove old nodes
			while(this.containerNode.firstChild){
				this.containerNode.removeChild(this.containerNode.firstChild);
			}

			// set content
			if(this.options.content) {
				if(typeof this.options.content == "object" && this.options.content.domNode != undefined) {
					// is widget
					this.containerNode.appendChild(this.options.content.domNode);
				} else if(typeof this.options.content == "string") {
					// is string
					this.containerNode.innerHTML = this.options.content;
				} else if (typeof this.options.content == "object" && this.options.content.nodeType){
					this.containerNode.appendChild(this.options.content);
				} else {
					console.warn('Bubble.setupContent needs a domnode a widget or a string as content.');
				}
			}

			var xOffset = 0;
			var yOffset = 0;

			if(this.options.orientation=="" || this.options.orientation=="top") {
				dojo.removeClass(this.domNode, "Left");
				dojo.removeClass(this.domNode, "Right");
				dojo.removeClass(this.domNode, "TopRight");
				dojo.removeClass(this.domNode, "Bottom");
			}

			if(this.options.orientation == "top-right") {
				var typeClass = this.options.typeClass;

				if(typeClass && typeClass.match("Wide")) {
					xOffset = -330;
				} else {
					xOffset = -230;
				}

				dojo.addClass(this.domNode, "TopRight");
				dojo.removeClass(this.domNode, "Left");
				dojo.removeClass(this.domNode, "Bottom");
				dojo.removeClass(this.domNode, "Right");
			}

			if(this.options.orientation == "right") {
				var typeClass = this.options.typeClass;

				if(typeClass && typeClass.match("Wide")) {
					xOffset = -380;
				} else {
					xOffset = -280;
				}

				yOffset = -24;
				dojo.addClass(this.domNode, "Right");
				dojo.removeClass(this.domNode, "Left");
				dojo.removeClass(this.domNode, "Bottom");
				dojo.removeClass(this.domNode, "TopRight");
			}

			if(this.options.orientation == "left") {
				yOffset = -24;
				dojo.addClass(this.domNode, "Left");
				dojo.removeClass(this.domNode, "Right");
				dojo.removeClass(this.domNode, "Bottom");
				dojo.removeClass(this.domNode, "TopRight");
			}

			if(this.options.orientation == "bottom" ) {
				dojo.addClass(this.domNode, "Bottom");
				dojo.removeClass(this.domNode, "Left");
				dojo.removeClass(this.domNode, "Right");
				dojo.removeClass(this.domNode, "TopRight");
			}

			// set position
			if(this.options.x !== undefined && this.options.y !== undefined) {
				$E(this.domNode).setCss({
					'left': 		(this.options.x + xOffset) + 'px',
					'top': 			(this.options.y + yOffset) + 'px',
					'zIndex': 	99998
				});
			}
			// replace css class
			if(this.options.typeClass !== undefined) {
				dojo.removeClass(this.domNode, this.typeClass);
				dojo.addClass(this.domNode, this.options.typeClass);
				this.typeClass = this.options.typeClass;
			}
		},

		show: function() {
		// summary: function to show the bubble
			if(this.options.orientation == "bottom") {
				this.domNode.style.visibility = 'hidden';
				this.domNode.style.display = 'block';
					var curHeight = this.layerOverIframeNode.offsetHeight || this.layerOverIframe.clientHeight;
					$E(this.domNode).setCss({
						'top': (this.options.y - curHeight) + 'px',
						visibility: 'visible'
					});
			} else {
				this.domNode.style.display = 'block';
			}
		},

		hide: function() {
		// summary: function to hide the bubble
			this.domNode.style.display = 'none';
		},

		/* events */
		onKeypress: function(evt) {
		// summary: keypress event controller
			if(evt.keyCode == dojo.keys.ESCAPE) {
				this.hide();
			}
		}
	}
);

}

if(!dojo._hasResource["epages.uimessagehandler"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.uimessagehandler"] = true;
dojo.provide("epages.uimessagehandler");








dojo.mixin( epages.uimessagehandler, {
	template :'<div id="busyMessageLayer" style="position: absolute; left:0px; top:0px; height: 100%; width: 100%; z-index: 100000; overflow: auto; display: none;">' +
						'<div id="busyMessageUnderlay" class="ui-widget-overlay"  style="position: absolute; left:0px; top:0px; height: 100%; width: 100%; z-index: 99999;" ></div>' +
						'<div id="busyMessageBox" style="position: relative; left:0px; top:300px; z-index: 100000; max-width: 200px; overflow: visible; margin: auto;">' +
						'<div class="Layer"><div id="busyMessagePropertyContainer" class="PropertyContainer" style="height:45px;padding-top:1px;"><div id="busyMessage"></div>' +
						'</div></div><div class="LayerFooter"><div class="PropertyContainer"></div></div></div></div>',
	fadeOutBusyLayer: function(duration) {

		dojo.fx.combine([
			dojo.fadeOut({
				node:$('busyMessageLayer'),
				onEnd: function() {
					$('busyMessageLayer').style.display='none';
					if(document.all) {
						dojo.body().parentNode.style.overflow = "auto";
					}
				},
				duration: duration ? duration : 1000
			})
		]).play();
	},
	rePositionBusy: function() {
		if($("busyMessageLayer")) {
			$("busyMessageLayer").style.top = (window.pageYOffset || document.getElementsByTagName("html")[0].scrollTop) + "px";
		}
	},
	errorsToString : function(errors) {
		var errorMessage = '';
		for(var el in errors) {
			if(errors[el].Message != "") {
				errorMessage += errors[el].Message+"<br />";
			} else {
				var t = epages.io.dictionary.get(errors[el].Reason);
				if(t === undefined){
					t=errors[el].Reason;
				}
				errorMessage += t+"<br />";
			}
		}
		return errorMessage;
	}
});

dojo.subscribe("uimessage/show", function(/* String */headline, /* String */message, /* String */ type, /* Object */ opt) {
/*
	headline -> string
	message  -> string
	type     -> string: Bubble, Dialog, Insert
	options  -> object

options type: Bubble
	* x          -> number
	* y	  	     -> number
	* typeClass  -> string: Error, Warning, Notification, Question, Tip
	* sizeClass  -> string: Large, Medium, Small
	* attachNode -> dom node (bubble will be attached as childnode) (optional)

options type: Insert
	* targetNode -> DOM object
	* typeClass  -> string: Error, Warning, Notification, Question, Tip, Confirmation
	* sizeClass  -> string: Large, Medium, Small

options type: Dialog
	* titleBar   -> string
	* typeClass  -> string: Error, Warning, Notification, Question, Tip, Confirmation
	* sizeClass  -> string: Large, Medium, Small
	* buttons    -> array: see ModalDialog widget
	* width      -> number: width of dialog
*/

	var sizeClass = (opt.sizeClass !== undefined) ? opt.sizeClass : "Large";
	var typeClass = (opt.typeClass !== undefined) ? opt.typeClass : "Warning";

	// hide old dialog / bubble
	if($$('uimessage_dialog')){ $$('uimessage_dialog').hide(); }
	if($$('uimessage_bubble')){ $$('uimessage_bubble').hide(); }

	var messageWidget = $$('uimessage_insert');

	if(messageWidget === undefined) {
		messageWidget = new epages.widget.Message({
			id: "uimessage_insert",
			headline: (headline !== undefined) ? headline : "",
			message:   message,
			sizeClass: sizeClass,
			typeClass: typeClass,
			borderClass: (type=='Insert') ? "WithBorder" : ""
		});
	} else {
		messageWidget.hide();
		messageWidget.setupContent({
			headline: headline,
			message: message,
			sizeClass: sizeClass,
			typeClass: typeClass,
			borderClass: (type=='Insert') ? "WithBorder" : ""
		});
	}
	messageWidget.show();
	switch(type) {
		case "Bubble":
			var bubbleWidget = $$('uimessage_bubble');
			var attachNode = opt.attachNode || document.body;
			// if not given, determine x and y by element
			if ((opt.x == null || opt.y == null) && opt.element != null) {
				var absPos = $E(opt.element).getAbsolutePosition(opt.baseNode);
				opt.x = opt.x || (absPos.x + opt.element.offsetWidth / 2);
				opt.y = opt.y || (absPos.y + opt.element.offsetHeight);
			}
			if(bubbleWidget === undefined) {
				
				bubbleWidget = new epages.widget.Bubble({
					id: "uimessage_bubble",
					options:{
						x : opt.x,
						y : opt.y,
						typeClass: typeClass,
						content: messageWidget,
						orientation: opt.orientation
					}
				});
				attachNode.appendChild(bubbleWidget.domNode);
			} else {
				bubbleWidget.setupContent({
					x : opt.x,
					y : opt.y,
					typeClass: typeClass,
					content: messageWidget,
					orientation: opt.orientation
				});
				attachNode.appendChild(bubbleWidget.domNode);
			}
			bubbleWidget.show();
			break;
		case "Insert":
			if(opt.targetNode !== undefined) {
				opt.targetNode.appendChild($$('uimessage_insert').domNode);
			} else {
				console.warn("uimessage/show: opt.targetNode is undefined");
			}
			break;
		default:
			var buttons = opt.buttons;
			if (buttons === undefined) {
					var translation = epages.io.dictionary.translation;
					buttons = typeClass == 'Confirmation' ?
					[{
						label: translation.get('Yes'),
						onclick: function() {
							this._modalDialogWidget.hide();
							if (typeof opt.onYes == 'function'){
								opt.onYes();
							}
						}
					},{
						label: translation.get('No'),
						onclick: function() {
							this._modalDialogWidget.hide();
							if (typeof opt.onNo == 'function'){
								opt.onNo();
							}
						}
					}] :
					[{
						label: translation.get('Close'),
						onclick: function() { this._modalDialogWidget.hide(); }
					}];
			}
			var title= opt.titleBar;
			if (title === undefined) {
				title = epages.io.dictionary.translation.get(typeClass);
			}

			var uid = $$('uimessage_dialog');
			if(uid === undefined) {
				
				uid = new epages.widget.Modaldialog({
					id: "uimessage_dialog",
					options:{
						title : title,
						width : (opt.width) ? opt.width : 450,
						content: messageWidget
					},
					buttons: buttons
				});
				document.body.appendChild(uid.domNode);
			} else {
				uid.containerNode.appendChild(messageWidget.domNode);
				uid.setupContent({
					title: title,
					width : 450,
					content: messageWidget,
					buttons: buttons
				});
			}
			uid.show();
			break;
	}
});

dojo.subscribe("uimessage/hide", function(opt) {
	if($$('uimessage_dialog')){ $$('uimessage_dialog').hide(); }
	if($$('uimessage_bubble')){ $$('uimessage_bubble').hide(); }
	if($$('uimessage_insert')){ $$('uimessage_insert').hide(); }
});

dojo.subscribe("uimessage/startBusy", function(/* * */ owner, /* ?HTML String */ message, /* ?url */ iconUrl) {

	epages.uimessagehandler.busyLayerOwner = owner;
	epages.vars.BusyLayerActive = true;
	if(message === undefined){
		var translation = epages.io.dictionary.translation;
		message = translation.get('PleaseWait');
	}

	var bodyNode = document.getElementsByTagName("body")[0];

	if(document.all) {
		bodyNode.parentNode.style.overflow = "hidden";
	}

	var busyUnderlay=$('busyMessageLayer');
	if(busyUnderlay == null) {
		busyUnderlay= document.createElement("div");
		busyUnderlay.innerHTML = epages.uimessagehandler.template;
		bodyNode.appendChild(busyUnderlay.firstChild);
		busyUnderlay=busyUnderlay.firstChild;
	}
	$('busyMessageLayer').style.display='';
	dojo.style($('busyMessageLayer'), "opacity", 1);

	if($('busyMessage').getElementsByTagName("div")[0]) {
		$('busyMessage').removeChild($('busyMessage').getElementsByTagName("div")[0]);
	}
	var container = document.createElement("div");
	container.innerHTML = message;
	$('busyMessage').appendChild(container);

	if(iconUrl) {
		$('busyMessage').style.backgroundImage="url(" + iconUrl + ")";
		if($('busyMessage').style.filter) {
		}
		$('busyMessage').style.backgroundRepeat="no-repeat";
		$('busyMessage').style.minHeight="40px";
		$("busyMessagePropertyContainer").style.height = "58px";
	}else {
		$("busyMessagePropertyContainer").style.height = "48px";
	}

	epages.uimessagehandler.rePositionBusy();


});

dojo.subscribe("uimessage/showErrors", function(/* String */headline, /* String */titlebar, /* Object */ errors) {
	var errorMessage = epages.uimessagehandler.errorsToString(errors);

	dojo.publish("uimessage/show", [headline, errorMessage, "Dialog" , {
		titleBar  : titlebar,
		typeClass : "Error"
	}]);
});

dojo.subscribe("uimessage/showErrorBubble", function(/* String */headline, /* String */attachNode, /* Object */ errors, /* string ?*/ typeClass) {
	var tc = (typeClass) ? typeClass : "Error";
	var errorMessage = epages.uimessagehandler.errorsToString(errors);
	var pos = $E(attachNode).getAbsolutePosition();
	dojo.publish("uimessage/show", [headline, errorMessage, "Bubble" , {
		typeClass : tc,
		sizeClass : "Small",
		x: pos.x,
		y: pos.y + attachNode.clientHeight + 4
	}]);
});

dojo.subscribe("uimessage/changeBusy", function(owner, message) {
	if(epages.uimessagehandler.busyLayerOwner == owner && top.$("busyMessage")) {
		if(epages.Browser.engine == "MSIE") {
			$('busyMessage').style.display = "inline-block";
		}
		if($('busyMessage').getElementsByTagName("div")[0]) {
			$('busyMessage').removeChild($('busyMessage').getElementsByTagName("div")[0]);
		}
		var container = document.createElement("div");
		container.innerHTML = message;
		$('busyMessage').appendChild(container);
		if(epages.Browser.engine == "MSIE") {
			$('busyMessage').style.display = "block";
		}
	}
});

dojo.subscribe("uimessage/stopBusy", function(owner, timeout, duration) {
	if(epages.uimessagehandler.busyLayerOwner == owner) {
		if(timeout) {
			window.setTimeout(function() {
				epages.vars.BusyLayerActive = false;
				epages.uimessagehandler.fadeOutBusyLayer(duration);
				}, timeout);
		}else {
			epages.vars.BusyLayerActive = false;
			epages.uimessagehandler.fadeOutBusyLayer(duration);
		}
	}
});

dojo.connect(window, "scroll", this, epages.uimessagehandler.rePositionBusy);

}

if(!dojo._hasResource['epages.validate.date']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.validate.date'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.validate.date $Revision: 1.10 $

*/

dojo.provide('epages.validate.date');




epages.validate.date.isTime = function(/*String*/timeString, /*String*/epagesPattern) {
	if (timeString == ''){
		return 'NO_VALUE';
	}
	var date;
	try {
		date = epages.string.toTime(timeString, epagesPattern);
	} catch (ex) {
		console.dir(ex);
		return 'INVALID_TIME';
	}
	// comment.translate:INVALID_TIME
	if (date === null){
		return 'INVALID_TIME';
	}
	return true;
};

epages.validate.date.isDate = function(/*String*/dateString, /*String*/epagesPattern) {
	if (dateString == ''){
		return 'NO_VALUE';
	}
	if (epagesPattern == null || epagesPattern.length == 0){
		epagesPattern = epages.vars.Locale.dateFormat;
	}
	var pattern = epages.localize.getDojoDateTimePattern(epagesPattern);
	try {
		var date = dojo.date.locale.parse(dateString, { selector: 'date', datePattern: pattern, timePattern: '' });
	} catch (ex) {
		return 'INVALID_DATE';
	}
	if (date === null){
		return 'INVALID_DATE';
	}
	return true;
};

epages.validate.date.isDateTime = function(/*String*/datetimeString, /*String*/epagesPattern) {
	if (datetimeString == ''){
		return 'NO_VALUE';
	}
	if (epagesPattern == null || epagesPattern.length == 0){
		epagesPattern = epages.vars.Locale.datetimeFormat;
	}
	var pattern = epages.localize.getDojoDateTimePattern(epagesPattern);
	try {
		var date = dojo.date.locale.parse(datetimeString, { selector: 'date', datePattern: pattern, timePattern: '' });
	} catch (ex) {
		return 'INVALID_DATETIME';
	}
	if (date === null){
		return 'INVALID_DATETIME';
	}
	return true;
};

}

if(!dojo._hasResource["epages.widget.Timespinner"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Timespinner"] = true;
dojo.provide("epages.widget.Timespinner");








dojo.declare(
	"epages.widget.Timespinner",
	[epages.widget.LocalizedWidget],
	{

		/**
		 * public properties
		 */
		templateString:"<span class=\"TimeSpinner EnableHover\">\n  <span class=\"Time\">\n    ${label} <input name=\"${name}\" type=\"text\" dojoAttachPoint=\"timeNode\" dojoAttachEvent=\"onkeyup:_onKeyUp, onchange:_onChange\" value=\"${value}\" />\n  </span>\n  <span class=\"ButtonWrapper\"><span class=\"TimeSpinnerButton\">\n      <span dojoAttachPoint=\"upNode\"   class=\"TimeSpinnerUpArrow EnableHover\"></span>\n      <span dojoAttachPoint=\"downNode\" class=\"TimeSpinnerDownArrow EnableHover\"></span>\n  </span></span>\n</span>\n",
		translationName : dojo.moduleUrl('epages', "translation"),

		delta:          5, // Integer - increment is 5 minutes by default
		value:          "",
		label:          "",
		name:           "",
		displayPattern: epages.vars.Locale.timeFormat     || "%H:%M", // String - epages time pattern
		emptyValueAllowed: true,
		initId: '',

		/**
		 * private
		 */
		_spinTimeout:           null, // timeout that holds the spinning function repetition (hold-down mouse key)
		_spinCounter:           0,    // counts the spins by the held-down mouse key to determine spinning speed
		_delta:                 0,    // this.delta in millisecs
		_spinIntervalFunction:  null, // function reference of the spinning function

		postMixInProperties: function() {
			if (typeof this.delta == 'string'){
				this.delta = new Number(this.delta);
			}
			if (this.delta<=0){
				this.delta = this.prototype.delta;
			}
			this._delta = this.delta * 60000; // calculate private delta, from mins to millisec
			this.emptyValueAllowed = epages.string.toBoolean(this.emptyValueAllowed);
		},

		postCreate: function() {
			// set initial value
			if (this.value != '') {
				var date = this.value;
				this.value = null;
				this.setValue(date);
			} else if (! this.emptyValueAllowed){
				// default is noon
				var date = new Date();
				date.setTime(43200000 + date.getTimezoneOffset() * 60000);
				this.value = null;
				this.setValue(date);
			} else {
				this.value = null;
			}

			this.connect(this.timeNode,   'focus', 'onFocus');
			this.connect(this.timeNode,   'blur', 'onBlur');

			// round time to closest possible position
			this.connect(this.upNode,   'mouseup', 'onMouseUp');
			this.connect(this.downNode, 'mouseup', 'onMouseUp');
			this.connect(this.upNode,   'mouseout', 'onMouseUp');
			this.connect(this.downNode, 'mouseout', 'onMouseUp');
			this.connect(this.upNode,   'mousedown', 'onMouseDown');
			this.connect(this.downNode, 'mousedown', 'onMouseDown');
		},

		onFocus: function() {
			dojo.addClass(this.domNode, "Focus");
		},

		onBlur: function() {
			dojo.removeClass(this.domNode, "Focus");
		},

		getValue: function() {
			// summary:
			//    returns the value as a date object, day is 1970-01-01
			return this.value;
		},

		setValue: function(/*Date*/date, /* booleab */ skipDisplay) {
			// summary:
			//    sets the time of Date into inputNode value and the internal property

			if (date === undefined){
				date = new Date();
			}
			else if (typeof date == "string") {
				date = epages.string.toTime(date, this.displayPattern);
				if(this.value) {	// fill up year, month, day
					date.setFullYear(this.value.getFullYear());
					date.setMonth(this.value.getMonth());
					date.setDate(this.value.getDate());
				}
			}
			if(!this.value || dojo.date.compare(date, this.value)){
				this.value = new Date(date);
				if(! skipDisplay){
					this.timeNode.value = epages.localize.formatDateTime(date, this.displayPattern);
				}
			}
			dojo.removeClass(this.timeNode, "DialogError");
			dojo.publish("uimessage/hide", []);
			dojo.publish(this.id + '/onChange', [date]);
		},

		onMouseDown: function(evt) {
			// summary:
			//    handle mousedowns on the spinner arrows
			var direction;
			if (evt.target == this.upNode) {
				direction = 1;
			} else if(evt.target == this.downNode) {
				direction = -1;
			} else {
				return;
			}
			this._spinIntervalFunction = dojo.hitch(this, function() {
				var speed = this._spinCounter > 5 ? this._spinCounter > 25 ? 25 : 55 : 200;
				this.spin(direction);
				this._spinCounter++;
				window.clearTimeout(this._spinTimeout);
				this._spinTimeout = undefined;
				this._spinTimeout = window.setTimeout(this._spinIntervalFunction, speed);
			});
			this._spinIntervalFunction();
		},

		onMouseUp: function() {
			// summary:
			//    stop spinning
			if(this._spinCounter){
				epages.event.fire(this.timeNode, 'change');
			}
			this._spinCounter = 0;
			window.clearTimeout(this._spinTimeout);
		},

		spin: function(direction) {
			// summary:
			//    spin the value by delta
			// direction: 
			//   | if > 0, spin up
			//   | if < 0, spin down
			//   | if = 0, do nothing

			// only spin, if date and direction are valid
			if (direction == 0){
				return;
			}
			var isValueChanged = false;

			if (this.value == null && this.timeNode.value != '') {
				var w = $$(this.initId);
				if (w) {
					this.value = w.value;
					isValueChanged = true;
				}
			}
			if (this.value == null && this.initId != '') {
				var w = $$(this.initId);
				if (w) {
					this.value = w.value;
					isValueChanged = true;
				}
			}
			if (this.value == null) {
				this.value = dojo.date.locale.parse('0', { selector: 'date', datePattern: 'HH', timePattern: '' });
				isValueChanged = true;
			}
			var date = new Date(this.value);
			if (isValueChanged){
				this.value=null;
			}else{ // set time via UTC in millisec - ensure that direction is either 1 or -1
				date.setTime(this.value.getTime() + this._delta * (direction / Math.abs(direction)));
			}

			this.setValue(date);
		},

		_onKeyUp: function(evt) {
			var newValue = evt.target.value;
			var isValid = epages.validate.date.isTime(newValue, this.displayPattern);
			if(isValid === true) {
				this.setValue(newValue, true);
			} else if(isValid == "NO_VALUE" && this.emptyValueAllowed) {
				dojo.removeClass(this.timeNode, "DialogError");
				dojo.publish("uimessage/hide", []);
				this.value = null;
			} else {
				dojo.addClass(this.timeNode, "DialogError");
			}
		},

		_onChange: function(evt) {
			//set 'px' as default-unit
			var newValue = evt.target.value;
			var isValid = epages.validate.date.isTime(newValue, this.displayPattern);

			var position=$E(this.timeNode).getRelativePosition();

			if(isValid != true && ! (isValid == "NO_VALUE" && this.emptyValueAllowed)) {
				//display Error-Box-Widget
				dojo.publish("uimessage/show", ["", this.translation.get(isValid), "Bubble", {
					typeClass: "Warning",
					sizeClass: "Small",
					x: position.x,
					y: position.y + this.timeNode.clientHeight + 4,
					attachNode: this.domNode.parentNode
				}]);
			}
		}
	}
);

}

if(!dojo._hasResource["dijit.Calendar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.Calendar"] = true;
dojo.provide("dijit.Calendar");








dojo.declare(
	"dijit.Calendar",
	[dijit._Widget, dijit._Templated],
	{
		// summary:
		//		A simple GUI for choosing a date in the context of a monthly calendar.
		//
		// description:
		//		A simple GUI for choosing a date in the context of a monthly calendar.
		//		This widget can't be used in a form because it doesn't serialize the date to an
		//		`<input>` field.  For a form element, use dijit.form.DateTextBox instead.
		//
		//		Note that the parser takes all dates attributes passed in the
		//		[RFC 3339 format](http://www.faqs.org/rfcs/rfc3339.html), e.g. `2005-06-30T08:05:00-07:00`
		//		so that they are serializable and locale-independent.
		//
		// example:
		//	|	var calendar = new dijit.Calendar({}, dojo.byId("calendarNode"));
		//
		// example:
		//	|	<div dojoType="dijit.Calendar"></div>

		templateString: dojo.cache("dijit", "templates/Calendar.html", "<table cellspacing=\"0\" cellpadding=\"0\" class=\"dijitCalendarContainer\" role=\"grid\" dojoAttachEvent=\"onkeypress: _onKeyPress\">\n\t<thead>\n\t\t<tr class=\"dijitReset dijitCalendarMonthContainer\" valign=\"top\">\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"decrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarDecrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"decreaseArrowNode\" class=\"dijitA11ySideArrow\">-</span>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' colspan=\"5\">\n\t\t\t\t<div class=\"dijitVisible\">\n\t\t\t\t\t<div class=\"dijitPopup dijitMenu dijitMenuPassive dijitHidden\" dojoAttachPoint=\"monthDropDown\" dojoAttachEvent=\"onmouseup: _onMonthSelect, onmouseover: _onMenuHover, onmouseout: _onMenuHover\">\n\t\t\t\t\t\t<div class=\"dijitCalendarMonthLabelTemplate dijitCalendarMonthLabel\"></div>\n\t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelSpacer\" class=\"dijitSpacer\"></div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelNode\" class=\"dijitCalendarMonthLabel dijitInline dijitVisible\" dojoAttachEvent=\"onmousedown: _onMonthToggle\"></div>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"incrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarIncrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"increaseArrowNode\" class=\"dijitA11ySideArrow\">+</span>\n\t\t\t</th>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<th class=\"dijitReset dijitCalendarDayLabelTemplate\" role=\"columnheader\"><span class=\"dijitCalendarDayLabel\"></span></th>\n\t\t</tr>\n\t</thead>\n\t<tbody dojoAttachEvent=\"onclick: _onDayClick, onmouseover: _onDayMouseOver, onmouseout: _onDayMouseOut\" class=\"dijitReset dijitCalendarBodyContainer\">\n\t\t<tr class=\"dijitReset dijitCalendarWeekTemplate\" role=\"row\">\n\t\t\t<td class=\"dijitReset dijitCalendarDateTemplate\" role=\"gridcell\"><span class=\"dijitCalendarDateLabel\"></span></td>\n\t\t</tr>\n\t</tbody>\n\t<tfoot class=\"dijitReset dijitCalendarYearContainer\">\n\t\t<tr>\n\t\t\t<td class='dijitReset' valign=\"top\" colspan=\"7\">\n\t\t\t\t<h3 class=\"dijitCalendarYearLabel\">\n\t\t\t\t\t<span dojoAttachPoint=\"previousYearLabelNode\" class=\"dijitInline dijitCalendarPreviousYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"currentYearLabelNode\" class=\"dijitInline dijitCalendarSelectedYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"nextYearLabelNode\" class=\"dijitInline dijitCalendarNextYear\"></span>\n\t\t\t\t</h3>\n\t\t\t</td>\n\t\t</tr>\n\t</tfoot>\n</table>\n"),

		// value: Date
		//		The currently selected Date
		value: new Date(),

		// datePackage: String
		//		JavaScript namespace to find Calendar routines.  Uses Gregorian Calendar routines
		//		at dojo.date by default.
		datePackage: "dojo.date",

		// dayWidth: String
		//		How to represent the days of the week in the calendar header. See dojo.date.locale
		dayWidth: "narrow",

		// tabIndex: Integer
		//		Order fields are traversed when user hits the tab key
		tabIndex: "0",

		attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
			tabIndex: "domNode"
 		}),

		setValue: function(/*Date*/ value){
			// summary:
			//      Deprecated.   Used attr('value', ...) instead.
			// tags:
			//      deprecated
			dojo.deprecated("dijit.Calendar:setValue() is deprecated.  Use attr('value', ...) instead.", "", "2.0");
			this.attr('value', value);
		},

		_getValueAttr: function(){
			// summary:
			//		Support getter attr('value')
			var value = new this.dateClassObj(this.value);
			value.setHours(0, 0, 0, 0); // return midnight, local time for back-compat

			// If daylight savings pushes midnight to the previous date, fix the Date
			// object to point at 1am so it will represent the correct day. See #9366
			if(value.getDate() < this.value.getDate()){
				value = this.dateFuncObj.add(value, "hour", 1);
			}
			return value;
		},

		_setValueAttr: function(/*Date*/ value){
			// summary:
			//		Support setter attr("value", ...)
			// description:
			// 		Set the current date and update the UI.  If the date is disabled, the value will
			//		not change, but the display will change to the corresponding month.
			// tags:
			//      protected
			if(!this.value || this.dateFuncObj.compare(value, this.value)){
				value = new this.dateClassObj(value);
				value.setHours(1); // to avoid issues when DST shift occurs at midnight, see #8521, #9366
				this.displayMonth = new this.dateClassObj(value);
				if(!this.isDisabledDate(value, this.lang)){
					this.value = value;
					this.onChange(this.attr('value'));
				}
				dojo.attr(this.domNode, "aria-label",
					this.dateLocaleModule.format(value,
						{selector:"date", formatLength:"full"}));
				this._populateGrid();
			}
		},

		_setText: function(node, text){
			// summary:
			//		This just sets the content of node to the specified text.
			//		Can't do "node.innerHTML=text" because of an IE bug w/tables, see #3434.
			// tags:
			//      private
			while(node.firstChild){
				node.removeChild(node.firstChild);
			}
			node.appendChild(dojo.doc.createTextNode(text));
		},

		_populateGrid: function(){
			// summary:
			//      Fills in the calendar grid with each day (1-31)
			// tags:
			//      private
			var month = this.displayMonth;
			month.setDate(1);
			var firstDay = month.getDay(),
				daysInMonth = this.dateFuncObj.getDaysInMonth(month),
				daysInPreviousMonth = this.dateFuncObj.getDaysInMonth(this.dateFuncObj.add(month, "month", -1)),
				today = new this.dateClassObj(),
				dayOffset = dojo.cldr.supplemental.getFirstDayOfWeek(this.lang);
			if(dayOffset > firstDay){ dayOffset -= 7; }

			// Iterate through dates in the calendar and fill in date numbers and style info
			dojo.query(".dijitCalendarDateTemplate", this.domNode).forEach(function(template, i){
				i += dayOffset;
				var date = new this.dateClassObj(month),
					number, clazz = "dijitCalendar", adj = 0;

				if(i < firstDay){
					number = daysInPreviousMonth - firstDay + i + 1;
					adj = -1;
					clazz += "Previous";
				}else if(i >= (firstDay + daysInMonth)){
					number = i - firstDay - daysInMonth + 1;
					adj = 1;
					clazz += "Next";
				}else{
					number = i - firstDay + 1;
					clazz += "Current";
				}

				if(adj){
					date = this.dateFuncObj.add(date, "month", adj);
				}
				date.setDate(number);

				if(!this.dateFuncObj.compare(date, today, "date")){
					clazz = "dijitCalendarCurrentDate " + clazz;
				}

				if(this._isSelectedDate(date, this.lang)){
					clazz = "dijitCalendarSelectedDate " + clazz;
				}

				if(this.isDisabledDate(date, this.lang)){
					clazz = "dijitCalendarDisabledDate " + clazz;
				}

				var clazz2 = this.getClassForDate(date, this.lang);
				if(clazz2){
					clazz = clazz2 + " " + clazz;
				}

				template.className = clazz + "Month dijitCalendarDateTemplate";
				template.dijitDateValue = date.valueOf();
				var label = dojo.query(".dijitCalendarDateLabel", template)[0],
					text = date.getDateLocalized ? date.getDateLocalized(this.lang) : date.getDate();
				this._setText(label, text);
			}, this);

			// Fill in localized month name
			var monthNames = this.dateLocaleModule.getNames('months', 'wide', 'standAlone', this.lang);
			this._setText(this.monthLabelNode, monthNames[month.getMonth()]);

			// Fill in localized prev/current/next years
			var y = month.getFullYear() - 1;
			var d = new this.dateClassObj();
			dojo.forEach(["previous", "current", "next"], function(name){
				d.setFullYear(y++);
				this._setText(this[name+"YearLabelNode"],
					this.dateLocaleModule.format(d, {selector:'year', locale:this.lang}));
			}, this);

			// Set up repeating mouse behavior
			var _this = this;
			var typematic = function(nodeProp, dateProp, adj){
//FIXME: leaks (collects) listeners if populateGrid is called multiple times.  Do this once?
				_this._connects.push(
					dijit.typematic.addMouseListener(_this[nodeProp], _this, function(count){
						if(count >= 0){ _this._adjustDisplay(dateProp, adj); }
					}, 0.8, 500)
				);
			};
			typematic("incrementMonth", "month", 1);
			typematic("decrementMonth", "month", -1);
			typematic("nextYearLabelNode", "year", 1);
			typematic("previousYearLabelNode", "year", -1);
		},

		goToToday: function(){
			// summary:
			//      Sets calendar's value to today's date
			this.attr('value', this.dateClassObj());
		},

		constructor: function(/*Object*/args){
			var dateClass = (args.datePackage && (args.datePackage != "dojo.date"))? args.datePackage + ".Date" : "Date";
			this.dateClassObj = dojo.getObject(dateClass, false);
			this.datePackage = args.datePackage || this.datePackage;
			this.dateFuncObj = dojo.getObject(this.datePackage, false);
			this.dateLocaleModule = dojo.getObject(this.datePackage + ".locale", false);
		},

		postMixInProperties: function(){
			// parser.instantiate sometimes passes in NaN for IE.  Use default value in prototype instead.
			if(isNaN(this.value)){ delete this.value; }
			this.inherited(arguments);
		},

		postCreate: function(){
			this.inherited(arguments);
			dojo.setSelectable(this.domNode, false);

			var cloneClass = dojo.hitch(this, function(clazz, n){
				var template = dojo.query(clazz, this.domNode)[0];
	 			for(var i=0; i<n; i++){
					template.parentNode.appendChild(template.cloneNode(true));
				}
			});

			// clone the day label and calendar day templates 6 times to make 7 columns
			cloneClass(".dijitCalendarDayLabelTemplate", 6);
			cloneClass(".dijitCalendarDateTemplate", 6);

			// now make 6 week rows
			cloneClass(".dijitCalendarWeekTemplate", 5);

			// insert localized day names in the header
			var dayNames = this.dateLocaleModule.getNames('days', this.dayWidth, 'standAlone', this.lang);
			var dayOffset = dojo.cldr.supplemental.getFirstDayOfWeek(this.lang);
			dojo.query(".dijitCalendarDayLabel", this.domNode).forEach(function(label, i){
				this._setText(label, dayNames[(i + dayOffset) % 7]);
			}, this);

			// Fill in spacer/month dropdown element with all the month names (invisible) so that the maximum width will affect layout
			var monthNames = this.dateLocaleModule.getNames('months', 'wide', 'standAlone', this.lang);
			cloneClass(".dijitCalendarMonthLabelTemplate", monthNames.length-1);
			dojo.query(".dijitCalendarMonthLabelTemplate", this.domNode).forEach(function(node, i){
				dojo.attr(node, "month", i);
				this._setText(node, monthNames[i]);
				dojo.place(node.cloneNode(true), this.monthLabelSpacer);
			}, this);

			var value = this.value;
			this.value = null;
			this.attr('value', new this.dateClassObj(value));
		},

		_onMenuHover: function(e){
			dojo.stopEvent(e);
			dojo.toggleClass(e.target, "dijitMenuItemHover");
		},

		_adjustDisplay: function(/*String*/ part, /*int*/ amount){
			// summary:
			//      Moves calendar forwards or backwards by months or years
			// part:
			//      "month" or "year"
			// amount:
			//      Number of months or years
			// tags:
			//      private
			this.displayMonth = this.dateFuncObj.add(this.displayMonth, part, amount);
			this._populateGrid();
		},

		_onMonthToggle: function(/*Event*/ evt){
			// summary:
			//      Handler for when user triggers or dismisses the month list
			// tags:
			//      protected
			dojo.stopEvent(evt);

			if(evt.type == "mousedown"){
				var coords = dojo.position(this.monthLabelNode);
//				coords.y -= dojo.position(this.domNode, true).y;
				// Size the dropdown's width to match the label in the widget
				// so that they are horizontally aligned
				var dim = {
					width: coords.w + "px",
					top: -this.displayMonth.getMonth() * coords.h + "px"
				};
				if((dojo.isIE && dojo.isQuirks) || dojo.isIE < 7){
					dim.left = -coords.w/2 + "px";
				}
				dojo.style(this.monthDropDown, dim);
				this._popupHandler = this.connect(document, "onmouseup", "_onMonthToggle");
			}else{
				this.disconnect(this._popupHandler);
				delete this._popupHandler;
			}

			dojo.toggleClass(this.monthDropDown, "dijitHidden");
			dojo.toggleClass(this.monthLabelNode, "dijitVisible");
		},

		_onMonthSelect: function(/*Event*/ evt){
			// summary:
			//      Handler for when user selects a month from a list
			// tags:
			//      protected
			this._onMonthToggle(evt);
			this.displayMonth.setMonth(dojo.attr(evt.target, "month"));
			this._populateGrid();
		},

		_onDayClick: function(/*Event*/ evt){
			// summary:
			//      Handler for day clicks, selects the date if appropriate
			// tags:
			//      protected
			dojo.stopEvent(evt);
			for(var node = evt.target; node && !node.dijitDateValue; node = node.parentNode);
			if(node && !dojo.hasClass(node, "dijitCalendarDisabledDate")){
				this.attr('value', node.dijitDateValue);
				this.onValueSelected(this.attr('value'));
			}
		},

		_onDayMouseOver: function(/*Event*/ evt){
			// summary:
			//      Handler for mouse over events on days, sets up hovered style
			// tags:
			//      protected
			var node = evt.target;
			if(node && (node.dijitDateValue || node == this.previousYearLabelNode || node == this.nextYearLabelNode) ){
				dojo.addClass(node, "dijitCalendarHoveredDate");
				this._currentNode = node;
			}
		},

		_onDayMouseOut: function(/*Event*/ evt){
			// summary:
			//      Handler for mouse out events on days, clears hovered style
			// tags:
			//      protected
			if(!this._currentNode){ return; }
			for(var node = evt.relatedTarget; node;){
				if(node == this._currentNode){ return; }
				try{
					node = node.parentNode;
				}catch(x){
					node = null;
				}
			}
			dojo.removeClass(this._currentNode, "dijitCalendarHoveredDate");
			this._currentNode = null;
		},

//TODO: use typematic
//TODO: skip disabled dates without ending up in a loop
//TODO: could optimize by avoiding populate grid when month does not change
		_onKeyPress: function(/*Event*/evt){
			// summary:
			//		Provides keyboard navigation of calendar
			// tags:
			//		protected
			var dk = dojo.keys,
				increment = -1,
				interval,
				newValue = this.value;
			switch(evt.keyCode){
				case dk.RIGHT_ARROW:
					increment = 1;
					//fallthrough...
				case dk.LEFT_ARROW:
					interval = "day";
					if(!this.isLeftToRight()){ increment *= -1; }
					break;
				case dk.DOWN_ARROW:
					increment = 1;
					//fallthrough...
				case dk.UP_ARROW:
					interval = "week";
					break;
				case dk.PAGE_DOWN:
					increment = 1;
					//fallthrough...
				case dk.PAGE_UP:
					interval = evt.ctrlKey ? "year" : "month";
					break;
				case dk.END:
					// go to the next month
					newValue = this.dateFuncObj.add(newValue, "month", 1);
					// subtract a day from the result when we're done
					interval = "day";
					//fallthrough...
				case dk.HOME:
					newValue = new Date(newValue).setDate(1);
					break;
				case dk.ENTER:
					this.onValueSelected(this.attr('value'));
					break;
				case dk.ESCAPE:
					//TODO
				default:
					return;
			}
			dojo.stopEvent(evt);

			if(interval){
				newValue = this.dateFuncObj.add(newValue, interval, increment);
			}

			this.attr("value", newValue);
		},

		onValueSelected: function(/*Date*/ date){
			// summary:
			//		Notification that a date cell was selected.  It may be the same as the previous value.
			// description:
			//      Used by `dijit.form._DateTimeTextBox` (and thus `dijit.form.DateTextBox`)
			//      to get notification when the user has clicked a date.
			// tags:
			//      protected
		},

		onChange: function(/*Date*/ date){
			// summary:
			//		Called only when the selected date has changed
		},

		_isSelectedDate: function(/*Date*/ dateObject, /*String?*/ locale){
			// summary:
			//		Extension point so developers can subclass Calendar to
			//		support multiple (concurrently) selected dates
			// tags:
			//		protected extension
			return !this.dateFuncObj.compare(dateObject, this.value, "date")
		},

		isDisabledDate: function(/*Date*/ dateObject, /*String?*/ locale){
			// summary:
			//		May be overridden to disable certain dates in the calendar e.g. `isDisabledDate=dojo.date.locale.isWeekend`
			// tags:
			//      extension
/*=====
			return false; // Boolean
=====*/
		},

		getClassForDate: function(/*Date*/ dateObject, /*String?*/ locale){
			// summary:
			//		May be overridden to return CSS classes to associate with the date entry for the given dateObject,
			//		for example to indicate a holiday in specified locale.
			// tags:
			//      extension

/*=====
			return ""; // String
=====*/
		}
	}
);

}

if(!dojo._hasResource['epages.lang.date']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.lang.date'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

  epages.lang.date $Revision: 1.6 $

*/
dojo.provide('epages.lang.date');



epages.lang.date.getWeekOfYear = function(/*Date*/dateObject, /*Number*/firstDayOfWeek, /*Number*/minDaysFirstWeek){
	if(firstDayOfWeek   === undefined){ firstDayOfWeek   = epages.vars.Locale.firstDayOfWeek;   }
	if(minDaysFirstWeek === undefined){ minDaysFirstWeek = epages.vars.Locale.minDaysFirstWeek; }

	var calc = function(date) {
		var c = new Date(date.getFullYear(), 0, 1).getDay();
		if(c==0 && firstDayOfWeek == 1){
			c = 7;
		}

		// need number 7 on monday or sunday for first full week
		var week = Math.floor((dojo.date.locale._getDayOfYear(date) + c - 1 - firstDayOfWeek) / 7);
		if (minDaysFirstWeek == 1 || minDaysFirstWeek == 7 && c == firstDayOfWeek) {
			week++;
		}
		else if (minDaysFirstWeek == 4) {
			var g = c - firstDayOfWeek;
			if (g < 4) { week++; }
		}
		return week;
	};
	var result = calc(dateObject);
	if(result < 1) { // is last week of last year
		result = calc(new Date(dateObject.getFullYear() - 1, 11,31));
	}
	if(result >= 53) { // may be first week of next year
		var newyear = calc(new Date(dateObject.getFullYear() + 1, 0, 1));
		result = newyear == 0 ? result : newyear;
	}
	return result; // Number
};

}

if(!dojo._hasResource["epages.widget.Calendar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Calendar"] = true;
dojo.provide("epages.widget.Calendar");






dojo.declare("epages.widget.Calendar", [dijit.Calendar], {
		/**
		 * public properties
		 */
		firstAvailableDate : null,
		lastAvailableDate  : null,

		/**
		 * private properties
		 */
		templateType       : "default",
		defaultTemplateType: "default", // read-only!
		templateString:"<table cellspacing=\"0\" cellpadding=\"0\" class=\"dijitCalendarContainer\" role=\"grid\" dojoAttachEvent=\"onkeypress: _onKeyPress\">\n\t<thead>\n\t\t<tr class=\"dijitReset dijitCalendarMonthContainer\" valign=\"top\">\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"decrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarDecrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"decreaseArrowNode\" class=\"dijitA11ySideArrow\">-</span>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' colspan=\"5\">\n\t\t\t\t<div class=\"dijitVisible\">\n\t\t\t\t\t<div class=\"dijitPopup dijitMenu dijitMenuPassive dijitHidden\" dojoAttachPoint=\"monthDropDown\" dojoAttachEvent=\"onmouseup: _onMonthSelect, onmouseover: _onMenuHover, onmouseout: _onMenuHover\">\n\t\t\t\t\t\t<div class=\"dijitCalendarMonthLabelTemplate dijitCalendarMonthLabel\"></div>\n\t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelSpacer\" class=\"dijitSpacer\"></div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelNode\" class=\"dijitCalendarMonthLabel dijitInline dijitVisible\" dojoAttachEvent=\"onmousedown: _onMonthToggle\"></div>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"incrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarIncrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"increaseArrowNode\" class=\"dijitA11ySideArrow\">+</span>\n\t\t\t</th>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<th class=\"dijitReset dijitCalendarDayLabelTemplate\" role=\"columnheader\"><span class=\"dijitCalendarDayLabel\"></span></th>\n\t\t</tr>\n\t</thead>\n\t<tbody dojoAttachEvent=\"onclick: _onDayClick, onmouseover: _onDayMouseOver, onmouseout: _onDayMouseOut\" class=\"dijitReset dijitCalendarBodyContainer\">\n\t\t<tr class=\"dijitReset dijitCalendarWeekTemplate\" role=\"row\">\n\t\t\t<td class=\"dijitReset dijitCalendarDateTemplate\" role=\"gridcell\"><span class=\"dijitCalendarDateLabel\"></span></td>\n\t\t</tr>\n\t</tbody>\n\t<tfoot class=\"dijitReset dijitCalendarYearContainer\">\n\t\t<tr>\n\t\t\t<td class='dijitReset' valign=\"top\" colspan=\"7\">\n\t\t\t\t<h3 class=\"dijitCalendarYearLabel\">\n\t\t\t\t\t<span dojoAttachPoint=\"previousYearLabelNode\" class=\"dijitInline dijitCalendarPreviousYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"currentYearLabelNode\" class=\"dijitInline dijitCalendarSelectedYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"nextYearLabelNode\" class=\"dijitInline dijitCalendarNextYear\"></span>\n\t\t\t\t</h3>\n\t\t\t</td>\n\t\t</tr>\n\t</tfoot>\n</table>\n", // need template for weeknumber
		_templateDirectory : dojo.moduleUrl("epages.widget", "templates"),
		widgetsInTemplate : true,
		_templateMapping : {
			'default' : {templateString:"<table cellspacing=\"0\" cellpadding=\"0\" class=\"dijitCalendarContainer\" role=\"grid\" dojoAttachEvent=\"onkeypress: _onKeyPress\">\n\t<thead>\n\t\t<tr class=\"dijitReset dijitCalendarMonthContainer\" valign=\"top\">\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"decrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarDecrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"decreaseArrowNode\" class=\"dijitA11ySideArrow\">-</span>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' colspan=\"5\">\n\t\t\t\t<div class=\"dijitVisible\">\n\t\t\t\t\t<div class=\"dijitPopup dijitMenu dijitMenuPassive dijitHidden\" dojoAttachPoint=\"monthDropDown\" dojoAttachEvent=\"onmouseup: _onMonthSelect, onmouseover: _onMenuHover, onmouseout: _onMenuHover\">\n\t\t\t\t\t\t<div class=\"dijitCalendarMonthLabelTemplate dijitCalendarMonthLabel\"></div>\n\t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelSpacer\" class=\"dijitSpacer\"></div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelNode\" class=\"dijitCalendarMonthLabel dijitInline dijitVisible\" dojoAttachEvent=\"onmousedown: _onMonthToggle\"></div>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"incrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarIncrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"increaseArrowNode\" class=\"dijitA11ySideArrow\">+</span>\n\t\t\t</th>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<th class=\"dijitReset dijitCalendarDayLabelTemplate\" role=\"columnheader\"><span class=\"dijitCalendarDayLabel\"></span></th>\n\t\t</tr>\n\t</thead>\n\t<tbody dojoAttachEvent=\"onclick: _onDayClick, onmouseover: _onDayMouseOver, onmouseout: _onDayMouseOut\" class=\"dijitReset dijitCalendarBodyContainer\">\n\t\t<tr class=\"dijitReset dijitCalendarWeekTemplate\" role=\"row\">\n\t\t\t<td class=\"dijitReset dijitCalendarDateTemplate\" role=\"gridcell\"><span class=\"dijitCalendarDateLabel\"></span></td>\n\t\t</tr>\n\t</tbody>\n\t<tfoot class=\"dijitReset dijitCalendarYearContainer\">\n\t\t<tr>\n\t\t\t<td class='dijitReset' valign=\"top\" colspan=\"7\">\n\t\t\t\t<h3 class=\"dijitCalendarYearLabel\">\n\t\t\t\t\t<span dojoAttachPoint=\"previousYearLabelNode\" class=\"dijitInline dijitCalendarPreviousYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"currentYearLabelNode\" class=\"dijitInline dijitCalendarSelectedYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"nextYearLabelNode\" class=\"dijitInline dijitCalendarNextYear\"></span>\n\t\t\t\t</h3>\n\t\t\t</td>\n\t\t</tr>\n\t</tfoot>\n</table>\n"},
			'flat'    : {templateString:"<div class=\"Calendar Flat dijitCalendarContainer\"><div class=\"InnerContainer\">\n\t<div>\n\t\t<div class=\"dijitReset dijitCalendarMonthContainer\"><div class=\"MonthSelection\">\n\t\t\t<div class='dijitReset' dojoAttachPoint=\"decrementMonth\">\n\t\t\t\t<span class=\"dijitInline dijitCalendarIncrementControl dijitCalendarDecrease\"><span dojoAttachPoint=\"decreaseArrowNode\" class=\"dijitA11ySideArrow dijitCalendarIncrementControl dijitCalendarDecreaseInner\">-</span></span>\n\t\t\t</div>\n\t\t\t<div class='dijitReset'>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelSpacer\" class=\"dijitCalendarMonthLabelSpacer\"></div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelNode\" class=\"dijitCalendarMonth\"></div>\n\t\t\t</div>\n\t\t\t<div class='dijitReset' dojoAttachPoint=\"incrementMonth\">\n\t\t\t\t<div class=\"dijitInline dijitCalendarIncrementControl dijitCalendarIncrease\"><span dojoAttachPoint=\"increaseArrowNode\" class=\"dijitA11ySideArrow dijitCalendarIncrementControl dijitCalendarIncreaseInner\">+</span></div>\n\t\t\t</div>\n\t\t</div></div>\n\t\t<div class=\"DayLabelHead\">\n\t\t\t<div class=\"dijitReset dijitCalendarWeekLabelTemplate\"><span class=\"dijitCalendarWeekLabel\"></span></div>\n\t\t\t<div class=\"dijitReset dijitCalendarDayLabelTemplate\"><span class=\"dijitCalendarDayLabel\"></span></div>\n\t\t</div>\n\t</div>\n\t<div dojoAttachEvent=\"onclick: _onDayClick\" class=\"dijitReset dijitCalendarBodyContainer\">\n\t\t<div class=\"dijitReset dijitCalendarWeekTemplate\">\n\t\t\t<div class=\"dijitReset dijitCalendarWeekTemplate\"><span class=\"dijitCalendarWeekLabel\"></span></div>\n\t\t\t<div class=\"dijitReset dijitCalendarDateTemplate\"><span class=\"dijitCalendarDateLabel\"></span></div>\n\t\t</div>\n\t</div>\n\t<div class=\"dijitReset dijitCalendarYearContainer\">\n\t\t<div>\n\t\t\t<div class='dijitReset' >\n\t\t\t\t<h3 class=\"dijitCalendarYearLabel\">\n\t\t\t\t\t<span dojoAttachPoint=\"previousYearLabelNode\" class=\"dijitInline dijitCalendarPreviousYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"currentYearLabelNode\" class=\"dijitInline dijitCalendarSelectedYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"nextYearLabelNode\" class=\"dijitInline dijitCalendarNextYear\"></span>\n\t\t\t\t</h3>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t<div class=\"HideElement dijitCalendarMonthLabelTemplate\"></div>\n\t<div class=\"Bottom\"></div>\n</div></div>\n\n"}
		},
		_yearTip: '',

		postMixInProperties: function() {
			this.inherited("postMixInProperties", arguments);
			if (this._templateMapping !== undefined &&  this.templateType !== undefined &&  this._templateDirectory !== undefined) {
				if(this._templateMapping[this.templateType]!==undefined) {
					// check if set to widget's default using its prototype value
					if(this.templateType != this.defaultTemplateType) {
						var tempPath = '';

							// load templates from json object..
							if(typeof this._templateMapping[this.templateType] == 'object'){
								var TempObj = this._templateMapping[this.templateType];

								// ..from shrinksafed packages
								if(TempObj.templateString){
										this.templatePath   = null;
										this.templateString = TempObj.templateString;
								}

								// ..from sources
								else if(TempObj.templatePath){
									var TempTemplateString;
									dojo.xhrGet({
										url: TempObj.templatePath,
										sync: true,
										load: function(data){
											TempTemplateString = data;
										}
									});
									this.templatePath   = null;
									this.templateString = TempTemplateString;
								} else {
										console.warn('Template type: "'+ this.templateType +'" could not be loaded from json object! Use properties templatePath or templateString to declare its template file!');
								}
							}

					}
				} else {
					console.warn('Template type: "'+ this.templateType +'" does not exist in this widget - use default. ('+this.declaredClass+')');
				}
			}
			this._dictionary = new epages.io.Translation(dojo.moduleUrl('epages.widget', "templates/translation"), "auto");
			this._yearTip = this._dictionary.get('YearTip');


		},

		postCreate: function() {
			var d = this.value;
			this.inherited("postCreate", arguments);
			this.attr('value',null);
			this.attr('value',d);

		},

		_populateGrid: function(){
			epages.widget.Calendar.superclass._populateGrid.apply(this);
			dojo.query(".dijitCalendarWeekLabel", this.domNode).forEach(function(label, i) {
				if (i) {
					var node = label.parentNode.nextSibling;
					while (node != null && node.nodeName == '#text'){
						node = node.nextSibling;
					}
					this._setText(label, epages.lang.date.getWeekOfYear(new Date(node.dijitDateValue), dojo.cldr.supplemental.getFirstDayOfWeek(this.lang)));
				}
			}, this);
		},

		_dateNode: function (node) {
			while(node && !node.dijitDateValue){ node = node.parentNode; }
			return node;
		},

		// disallow clicks on calendar weeks
		_onDayClick: function(/*Event*/evt){
			var node = evt.target;
			if(dojo.hasClass(node, "dijitCalendarDateLabel")) {
				epages.widget.Calendar.superclass._onDayClick.apply(this, arguments);
			} else {
				dojo.stopEvent(evt);
			}
		},

		isDisabledDate: function(/*Date*/ date, /*String?*/ locale) {
			date.setHours(0,0,0,0);
			// check if a date is between a the available period
			return (this.lastAvailableDate && date > this.lastAvailableDate) ||
						 (this.firstAvailableDate && date < this.firstAvailableDate);
		}
});

}

if(!dojo._hasResource["epages.widget.Datetimeinput"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Datetimeinput"] = true;
dojo.provide("epages.widget.Datetimeinput");








dojo.declare(
	"epages.widget.Datetimeinput",
	[dijit._Widget, dijit._Templated],
	{
		templateString:"<span style=\"white-space:nowrap\" class=\"Datetimeinput\" >\n  <input type=\"text\" dojoAttachPoint=\"textBoxNode\" class=\"${class}\" style=\"${style}\" name=\"${name}\" autocomplete=\"off\" />\n  <img class=\"ButtonNode\" dojoAttachPoint=\"buttonNode\"\n        alt=\"${title}\" title=\"${title}\"\n        src=\"${image}\" />\n  <div style=\"display:none\" dojoAttachPoint=\"popupNode\" class=\"CalendarAndTimer\">\n    <div class=\"Layer\">\n      <div class=\"LayerTitleBar\">\n        <div class=\"LayerCloseButton EnableHover\" dojoAttachEvent=\"onclick: closePopup\"></div>\n      </div>\n      <div class=\"ContentContainer\">\n        <div class=\"CalendarNode\" dojoAttachPoint=\"calendarNode\"></div>\n        <div class=\"TimerWrapper\" dojoAttachPoint=\"timerNode\"></div>\n        <div style=\"clear:both\"></div>\n      </div>\n    </div>\n  </div>\n </span>\n",
		dojoPattern:        '',
		pattern:            '',
		popupclass:         '',
		'style':            '',
		name:               '',
		textId:             '', // String - id for text node
		value:              '',
		selector:           'date',// String - can be: "date", "time" or "datetime"
		calendar:           null, // dojo._Widjet - insert other calender as parameter
		timer:              null, // dojo._Widjet - insert other time selector as parameter
		hideOnBlur:         true, // Boolean - hide calendar/time on cick outside
		imagePath:          epages.themeUrl('images'),
		image:              '',
		title:              '',
		onchange:           'void(0)',
		firstAvailableDate: '',
		lastAvailableDate:  '',
		disabled:           '',
		textBoxWidget:      undefined, // epages.widget.FormElement -
		textBoxNode:        undefined, // DomNode - dom node of textBoxWidget

		_isChangeInput: 		false, // Boolean - dont not change input field if user makes on input
		// assign selectors to formats
		_formats: {
			'date':     			'dateFormat',
			'time':     			'timeFormat',
			'datetime': 			'datetimeFormat',
			'iso':						'iso'
		},
		_titles: {
			'date':     			'SelectDate',
			'time':     			'SelectTime',
			'datetime': 			'SelectDatetime'
		},
		_formatError: false,
		_ep_connects: undefined, // [] - saved connections


		/* widget life cycle */

		postMixInProperties: function() {
			this.inherited("postMixInProperties", arguments);

			this._ep_connects =[];
			
			// save the original value
			this.originalValue = this.value;

			if(this._formats[this.selector] == 'iso'){
				this.value = epages.localize.parseDateTime(this.value, '%y-%m-%d');
				this.pattern = this.pattern || epages.vars.Locale[this._formats['dateFormat']];
			}
			else{
				this.pattern = this.pattern || epages.vars.Locale[this._formats[this.selector]];
			}
			
			var parsedValue = null;
			if (typeof(this.value) == "string" && this.value != ''){
				parsedValue = epages.localize.parseDateTime(this.value, this.pattern);
			}
			else{
				this.value = null;
			}
			if( parsedValue==null && this.originalValue ){
				this._formatError = true;
			}
			else{
				this.value = parsedValue;
			}
			//if (typeof(this.value) == "string") this.value = this.value == '' ? null : epages.localize.parseDateTime(this.value, this.pattern);
			var fileType = (epages.Browser.engine == "MSIE" && epages.Browser.version=="6" ) ? "gif" : "png";
			if (this.image == ''){
				this.image = this.imagePath + (this.selector == 'time' ? '/ico_s_clock.'+fileType : '/ico_s_calendar.'+fileType);
			}
			if (this.title == ''){
				this.title = epages.io.dictionary.get(this._titles[this.selector]);
			}
			if (this.firstAvailableDate){
				this.firstAvailableDate = epages.localize.parseDateTime(this.firstAvailableDate, this.pattern);
			}
			if (this.lastAvailableDate){
				this.lastAvailableDate = epages.localize.parseDateTime(this.lastAvailableDate, this.pattern);
			}

			this.disabled = this.disabled.toLowerCase();
			this.disabled = (this.disabled =="true" || this.disabled =="disabled" || this.disabled == "1") ? true : false;

		},

		postCreate: function() {
			this.inherited("postCreate", arguments);

			// parse date value and provide to text box and calendar

			this.textBoxWidget = new epages.widget.FormElement({}, this.textBoxNode);
			this.textBoxWidget.attr('pattern', epages.localize.getPattern(this.selector||'datetime'));
			this.textBoxNode = this.textBoxWidget.elementNode;
			if(this.disabled) {
				this.disable();
			}

			this.textBoxNode.value = this.textBoxNode.defaultValue = this.originalValue;
			
			if( this._formatError ){
				// turn red if not empty and formaterror
				dojo.addClass(this.textBoxNode, 'DialogError');
			}
			if (this.textId != ''){
				this.textBoxNode.id = this.textId;
			}
			this._ep_connects.push(dojo.connect(this.buttonNode,  "click",  this, 'toggleCalendar'));
			this._ep_connects.push(dojo.connect(this.textBoxNode, "keyup",  this, "onValueInput"));
			this._ep_connects.push(dojo.connect(this.textBoxNode, "change", this, "onValueInput"));
			this.textBoxNode.onchange = dojo.hitch(this, function() { eval(this.onchange); });
		},

		destroy : function() {
			// detach events
			var connects = this._ep_connects;
			for(var c in connects) {
				dojo.disconnect(connects[c]);
				delete this._ep_connects[c];
			}

			// destroy inner widgets
			if(this.timer) {
				this.timer.destroy();
			}
			if(this.calendar) {
				this.calendar.destroy();
			}
			if(this.popup) {
				this.popup.destroy();
			}
			if(this.textBoxWidget) {
				this.textBoxWidget.destroy();
			}
			this.inherited("destroy", arguments);
		},

		/* public: setter / getter */

		setValueInBox: function(date, startupUpdate) {
			if (date) {
				this.value = new Date(date);
				if (!this._isChangeInput) {
					this.textBoxNode.value = epages.localize.formatDateTime(date, this.pattern);
					if(startupUpdate) {
						this.textBoxNode.startupValue = this.textBoxNode.value;
					}
					dojo.removeClass(this.textBoxNode, 'DialogError');
				}
			} else {
				this.value = undefined;
				this.textBoxNode.value = '';
			}
			dojo.publish(this.id + '/change', [this.value, this.textBoxNode.value]);
			// inform search/submit button
			if(!this._isChangeInput){
				epages.event.fire(this.textBoxNode,'change');
			}
		},

		setValue: function(date) {
			if(date === undefined || date === null || date == ''){
				this.setValueInBox(undefined);
			}else{
				this.value = typeof(date) == 'string' ? epages.localize.parseDateTime(date, this.pattern) :  new Date(date);
				this.onTimeChange(this.value);
			}
		},

		disable: function() {
		// summary: disable inputfield and button
			this.textBoxNode.disabled="disabled";
			dojo.addClass(this.buttonNode , "Opacity30");
			this.disabled = true;
		},

		enable: function() {
		// summary: enable inputfield and button
			this.textBoxNode.disabled="";
			dojo.removeClass(this.buttonNode , "Opacity30");
			this.disabled = false;
		},

		/* private */

		_createCalendar: function() {
			// summary: create calendar widget
			if( this.value == null ){
				this.value = this.firstStartDate ? this.firstStartDate : new Date();
				if(this.calendar && this.calendar.value && dojo.date.compare(this.calendar.value, this.value, "date")){
					this.value = this.calendar.value;
				}
			}
			if(this.selector != 'date') {
				if (this.timer == null) {
					
					this.timer = new epages.widget.Timespinner({ value: this.value }, this.timerNode);
					if(this.selector != "datetime") {
						this.timer.domNode.style.border = "0";
					}
				} else {
					this.timer.setValue(this.value);
					this.timerNode.parentNode.replaceChild(this.timer.domNode, this.timerNode);
				}
				dojo.subscribe(this.timer.id + '/onChange', this, 'onTimeChange');
			}
			if(this.selector != 'time') {
				if (this.calendar == null) {
					
					this.calendar = new epages.widget.Calendar({
						value: this.value,
						timer: this.timer,
						firstAvailableDate: this.firstAvailableDate,
						lastAvailableDate: this.lastAvailableDate
					}, this.calendarNode);
				} else {
					if (this.calendar.setValue === undefined && typeof this.calendar == 'function') {
						this.calendar = this.calendar();
					}
					this.calendar.attr('value',this.value);
					this.calendarNode.parentNode.replaceChild(this.calendar.domNode, this.calendarNode);
				}
				this.calendar.onValueSelected = dojo.hitch(this, 'onCalendarChange');
			}
			this.popup = new epages.widget.Popup({
				parent:     this.buttonNode,
				around:     this.buttonNode,
				hideOnBlur: this.hideOnBlur,
				'class':    this['popupclass']
			}, this.popupNode);
			this.attr('value',this.value);
		},

		/* event functions */

		toggleCalendar: function() {
			if(!this.disabled) {
				if (this.popup == null){
					this._createCalendar();
				}
				if (this.value === undefined) {
					// set calendar to current date, but dont change input field
					this._isChangeInput = true;
					var newDate = this.firstStartDate ? this.firstStartDate : new Date();
					this.calendar.attr('value',newDate);
					this._isChangeInput = false;
				}
				this.popup.toggle();
			}
		},

		onCalendarChange: function(date) {
			if(this.value === undefined){
				var newDate = this.firstStartDate ? this.firstStartDate : new Date();
				this.value = newDate;
			}
			date.setHours(this.value.getHours(),this.value.getMinutes(),this.value.getSeconds());
			if (this.timer != null){
				this.timer.attr('value',date);
				this.setValueInBox(this.timer.getValue());
			}
			else{
				this.setValueInBox(date);
			}
			if (this.selector == 'date'){
				this.popup.hide();
			}
			this.textBoxWidget.validate();
		},

		onTimeChange: function(date) {
			//var date = new Date(this.value.getFullYear(), this.value.getMonth(), this.value.getDate(), date.getHours(),date.getMinutes(),date.getSeconds());
			if (this.calendar != null) {
				this.value = new Date(date); // set time for onCalendarChange
				if (typeof this.calendar.setValue == 'function') { // calendar loaded
					this.onCalendarChange(date);
					//this.calendar.attr('value',date); // calls onCalendarChange
				} else {
						this.setValueInBox(date);
				}
			} else {
				this.setValueInBox(date);
			}
		},

		onValueInput: function(evt) {
			this._isChangeInput = true;
			var value = this.textBoxNode.value;
			var date = value =='' ? null : epages.localize.parseDateTime(value, this.pattern);
			if (value =='' ||  date != null ) {
				this.attr('value',date);
				dojo.removeClass(this.textBoxNode, 'DialogError');
			} else {
				dojo.addClass(this.textBoxNode, 'DialogError');
			}
			this._isChangeInput = false;
		},

		closePopup: function() {
			this.popup.hide();
		}
	}
);

}

if(!dojo._hasResource['epages.templated']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.templated'] = true;
/*
 * Copyright (c) 2006-2007, ePages GmbH
 * All Rights Reserved.
 *
 * epages.templated.js
 * epages.templated $Revision: 1.3 $
 */

dojo.provide('epages.templated');




(function(dj){

	dj.declare('epages.Templated',null,{
	
		_translator: 			new epages.io.Translation(),	// translation handler
		_templatesCache:		null,							// hash of cached templates
		templates:				null,							// hash of templates
		
		constructor: function() {
			this.templates = 		this.templates		|| {};
			this._templatesCache = 	this._templatesCache|| {};
		},
		
		loadLocale: function( /*string*/url, /*string|boolean?*/locale ) {
			// summary: load translation data
				// url: 					src url of the dictionary file (without locale and extension ".xml")
				// locale: 		[string]	(RFC 3066; eg en-us) 
				//				[boolean] 	locale=default and set skipError
				//				[?] 		locale=default and skipError=false
			var type = typeof locale;
			if( type==='boolean' ) {
				this._translator.load( url, locale );
			}
			else if( type==='string' ) {
				this._translator.loadLocale( url, locale );
			}
		},
		
		loadTemplate: function( /*string*/url, /*string*/name ) {
			// summary: load template file
				// url: 					moduleUrl of the template file
				// name: 					name to store the template
			this.templates[name] = dijit._Templated.getCachedTemplate( url, null, false );
		},
		
		addTemplate: function( /*string*/template, /*string*/name ) {
			// summary: load template file
				// template: 				string of the template
				// name: 					name to store the template
			this.templates[name] = template;
		},
		
		getTemplate: function( /*string*/name, /*boolean*/noCache ) {
			// summary: get a localized template as domNode with attachpoints
				// name: 					name of the stored template
				// noCache: 				true = new translate and trim
			if( this.templates[name] ) {
				if( !this._templatesCache[name] || !noCache ) {
					this._templatesCache[name] = this._translator.replaceLanguageTags( this.templates[name].replace(/[\ \r\n\t]*(.*)[\ \r\n\t]*/,function(string,$1){return $1;}) );
				}
				
				var container = document.createElement('div');
					container.innerHTML = this._templatesCache[name];
					
				var ret = {};
				
				var widgets = dojo.parser.parse(container);
				
				for( var i=0,iLength=widgets.length ; i<iLength ; i++ ) {
					ret[widgets[i].id] = widgets[i].domNode;
				}
				
				ret.domNode = container.childNodes[0];
				
				dj.query('*[dojoAttachpoint]',container).forEach(function(node,i){
					ret[dj.attr(node,'dojoAttachpoint')] = node;
					dj.removeAttr( node, 'dojoAttachpoint' );
				});
				
				
				return this._templatesCache[name] = ret;
			}
		}
	
	});

})(dojo);

}

if(!dojo._hasResource["dojo.DeferredList"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.DeferredList"] = true;
dojo.provide("dojo.DeferredList");
dojo.declare("dojo.DeferredList", dojo.Deferred, {
	constructor: function(/*Array*/ list, /*Boolean?*/ fireOnOneCallback, /*Boolean?*/ fireOnOneErrback, /*Boolean?*/ consumeErrors, /*Function?*/ canceller){
		// summary:
		//		Provides event handling for a group of Deferred objects.
		// description:
		//		DeferredList takes an array of existing deferreds and returns a new deferred of its own
		//		this new deferred will typically have its callback fired when all of the deferreds in
		//		the given list have fired their own deferreds.  The parameters `fireOnOneCallback` and
		//		fireOnOneErrback, will fire before all the deferreds as appropriate
		//
		//	list:
		//		The list of deferreds to be synchronizied with this DeferredList
		//	fireOnOneCallback:
		//		Will cause the DeferredLists callback to be fired as soon as any
		//		of the deferreds in its list have been fired instead of waiting until
		//		the entire list has finished
		//	fireonOneErrback:
		//		Will cause the errback to fire upon any of the deferreds errback
		//	canceller:
		//		A deferred canceller function, see dojo.Deferred
		this.list = list;
		this.resultList = new Array(this.list.length);

		// Deferred init
		this.chain = [];
		this.id = this._nextId();
		this.fired = -1;
		this.paused = 0;
		this.results = [null, null];
		this.canceller = canceller;
		this.silentlyCancelled = false;

		if(this.list.length === 0 && !fireOnOneCallback){
			this.callback(this.resultList);
		}

		this.finishedCount = 0;
		this.fireOnOneCallback = fireOnOneCallback;
		this.fireOnOneErrback = fireOnOneErrback;
		this.consumeErrors = consumeErrors;

		dojo.forEach(this.list, function(d, index){
			d.addCallback(this, function(r){ this._cbDeferred(index, true, r); return r; });
			d.addErrback(this, function(r){ this._cbDeferred(index, false, r); return r; });
		}, this);
	},

	_cbDeferred: function(index, succeeded, result){
		// summary:
		//	The DeferredLists' callback handler

		this.resultList[index] = [succeeded, result]; this.finishedCount += 1;
		if(this.fired !== 0){
			if(succeeded && this.fireOnOneCallback){
				this.callback([index, result]);
			}else if(!succeeded && this.fireOnOneErrback){
				this.errback(result);
			}else if(this.finishedCount == this.list.length){
				this.callback(this.resultList);
			}
		}
		if(!succeeded && this.consumeErrors){
			result = null;
		}
		return result;
	},

	gatherResults: function(deferredList){
		// summary:	
		//	Gathers the results of the deferreds for packaging
		//	as the parameters to the Deferred Lists' callback

		var d = new dojo.DeferredList(deferredList, false, true, false);
		d.addCallback(function(results){
			var ret = [];
			dojo.forEach(results, function(result){
				ret.push(result[1]);
			});
			return ret;
		});
		return d;
	}
});

}

if(!dojo._hasResource["dojo.cookie"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dojo.cookie"] = true;
dojo.provide("dojo.cookie");



/*=====
dojo.__cookieProps = function(){
	//	expires: Date|String|Number?
	//		If a number, the number of days from today at which the cookie
	//		will expire. If a date, the date past which the cookie will expire.
	//		If expires is in the past, the cookie will be deleted.
	//		If expires is omitted or is 0, the cookie will expire when the browser closes. << FIXME: 0 seems to disappear right away? FF3.
	//	path: String?
	//		The path to use for the cookie.
	//	domain: String?
	//		The domain to use for the cookie.
	//	secure: Boolean?
	//		Whether to only send the cookie on secure connections
	this.expires = expires;
	this.path = path;
	this.domain = domain;
	this.secure = secure;
}
=====*/


dojo.cookie = function(/*String*/name, /*String?*/value, /*dojo.__cookieProps?*/props){
	//	summary: 
	//		Get or set a cookie.
	//	description:
	// 		If one argument is passed, returns the value of the cookie
	// 		For two or more arguments, acts as a setter.
	//	name:
	//		Name of the cookie
	//	value:
	//		Value for the cookie
	//	props: 
	//		Properties for the cookie
	//	example:
	//		set a cookie with the JSON-serialized contents of an object which
	//		will expire 5 days from now:
	//	|	dojo.cookie("configObj", dojo.toJson(config), { expires: 5 });
	//	
	//	example:
	//		de-serialize a cookie back into a JavaScript object:
	//	|	var config = dojo.fromJson(dojo.cookie("configObj"));
	//	
	//	example:
	//		delete a cookie:
	//	|	dojo.cookie("configObj", null, {expires: -1});
	var c = document.cookie;
	if(arguments.length == 1){
		var matches = c.match(new RegExp("(?:^|; )" + dojo.regexp.escapeString(name) + "=([^;]*)"));
		return matches ? decodeURIComponent(matches[1]) : undefined; // String or undefined
	}else{
		props = props || {};
// FIXME: expires=0 seems to disappear right away, not on close? (FF3)  Change docs?
		var exp = props.expires;
		if(typeof exp == "number"){ 
			var d = new Date();
			d.setTime(d.getTime() + exp*24*60*60*1000);
			exp = props.expires = d;
		}
		if(exp && exp.toUTCString){ props.expires = exp.toUTCString(); }

		value = encodeURIComponent(value);
		var updatedCookie = name + "=" + value, propName;
		for(propName in props){
			updatedCookie += "; " + propName;
			var propValue = props[propName];
			if(propValue !== true){ updatedCookie += "=" + propValue; }
		}
		document.cookie = updatedCookie;
	}
};

dojo.cookie.isSupported = function(){
	//	summary:
	//		Use to determine if the current browser supports cookies or not.
	//		
	//		Returns true if user allows cookies.
	//		Returns false if user doesn't allow cookies.

	if(!("cookieEnabled" in navigator)){
		this("__djCookieTest__", "CookiesAllowed");
		navigator.cookieEnabled = this("__djCookieTest__") == "CookiesAllowed";
		if(navigator.cookieEnabled){
			this("__djCookieTest__", "", {expires: -1});
		}
	}
	return navigator.cookieEnabled;
};

}

if(!dojo._hasResource["dijit.tree.TreeStoreModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.tree.TreeStoreModel"] = true;
dojo.provide("dijit.tree.TreeStoreModel");

dojo.declare(
		"dijit.tree.TreeStoreModel",
		null,
	{
		// summary:
		//		Implements dijit.Tree.model connecting to a store with a single
		//		root item.  Any methods passed into the constructor will override
		//		the ones defined here.

		// store: dojo.data.Store
		//		Underlying store
		store: null,

		// childrenAttrs: String[]
		//		One or more attribute names (attributes in the dojo.data item) that specify that item's children
		childrenAttrs: ["children"],

		// newItemIdAttr: String
		//		Name of attribute in the Object passed to newItem() that specifies the id.
		//
		//		If newItemIdAttr is set then it's used when newItem() is called to see if an
		//		item with the same id already exists, and if so just links to the old item
		//		(so that the old item ends up with two parents).
		//
		//		Setting this to null or "" will make every drop create a new item.
		newItemIdAttr: "id",

		// labelAttr: String
		//		If specified, get label for tree node from this attribute, rather
		//		than by calling store.getLabel()
		labelAttr: "",

	 	// root: [readonly] dojo.data.Item
		//		Pointer to the root item (read only, not a parameter)
		root: null,

		// query: anything
		//		Specifies datastore query to return the root item for the tree.
		//		Must only return a single item.   Alternately can just pass in pointer
		//		to root item.
		// example:
		//	|	{id:'ROOT'}
		query: null,

		// deferItemLoadingUntilExpand: Boolean
		//		Setting this to true will cause the TreeStoreModel to defer calling loadItem on nodes
		// 		until they are expanded. This allows for lazying loading where only one
		//		loadItem (and generally one network call, consequently) per expansion
		// 		(rather than one for each child).
		// 		This relies on partial loading of the children items; each children item of a
		// 		fully loaded item should contain the label and info about having children.
		deferItemLoadingUntilExpand: false,

		constructor: function(/* Object */ args){
			// summary:
			//		Passed the arguments listed above (store, etc)
			// tags:
			//		private

			dojo.mixin(this, args);

			this.connects = [];

			var store = this.store;
			if(!store.getFeatures()['dojo.data.api.Identity']){
				throw new Error("dijit.Tree: store must support dojo.data.Identity");
			}

			// if the store supports Notification, subscribe to the notification events
			if(store.getFeatures()['dojo.data.api.Notification']){
				this.connects = this.connects.concat([
					dojo.connect(store, "onNew", this, "onNewItem"),
					dojo.connect(store, "onDelete", this, "onDeleteItem"),
					dojo.connect(store, "onSet", this, "onSetItem")
				]);
			}
		},

		destroy: function(){
			dojo.forEach(this.connects, dojo.disconnect);
			// TODO: should cancel any in-progress processing of getRoot(), getChildren()
		},

		// =======================================================================
		// Methods for traversing hierarchy

		getRoot: function(onItem, onError){
			// summary:
			//		Calls onItem with the root item for the tree, possibly a fabricated item.
			//		Calls onError on error.
			if(this.root){
				onItem(this.root);
			}else{
				this.store.fetch({
					query: this.query,
					onComplete: dojo.hitch(this, function(items){
						if(items.length != 1){
							throw new Error(this.declaredClass + ": query " + dojo.toJson(this.query) + " returned " + items.length +
							 	" items, but must return exactly one item");
						}
						this.root = items[0];
						onItem(this.root);
					}),
					onError: onError
				});
			}
		},

		mayHaveChildren: function(/*dojo.data.Item*/ item){
			// summary:
			//		Tells if an item has or may have children.  Implementing logic here
			//		avoids showing +/- expando icon for nodes that we know don't have children.
			//		(For efficiency reasons we may not want to check if an element actually
			//		has children until user clicks the expando node)
			return dojo.some(this.childrenAttrs, function(attr){
				return this.store.hasAttribute(item, attr);
			}, this);
		},

		getChildren: function(/*dojo.data.Item*/ parentItem, /*function(items)*/ onComplete, /*function*/ onError){
			// summary:
			// 		Calls onComplete() with array of child items of given parent item, all loaded.

			var store = this.store;
			if(!store.isItemLoaded(parentItem)){
				// The parent is not loaded yet, we must be in deferItemLoadingUntilExpand
				// mode, so we will load it and just return the children (without loading each
				// child item)
				var getChildren = dojo.hitch(this, arguments.callee);
				store.loadItem({
					item: parentItem,
					onItem: function(parentItem){
						getChildren(parentItem, onComplete, onError);
					},
					onError: onError
				});
				return;
			}
			// get children of specified item
			var childItems = [];
			for(var i=0; i<this.childrenAttrs.length; i++){
				var vals = store.getValues(parentItem, this.childrenAttrs[i]);
				childItems = childItems.concat(vals);
			}

			// count how many items need to be loaded
			var _waitCount = 0;
			if(!this.deferItemLoadingUntilExpand){
				dojo.forEach(childItems, function(item){ if(!store.isItemLoaded(item)){ _waitCount++; } });
			}

			if(_waitCount == 0){
				// all items are already loaded (or we aren't loading them).  proceed...
				onComplete(childItems);
			}else{
				// still waiting for some or all of the items to load
				var onItem = function onItem(item){
					if(--_waitCount == 0){
						// all nodes have been loaded, send them to the tree
						onComplete(childItems);
					}
				}
				dojo.forEach(childItems, function(item){
					if(!store.isItemLoaded(item)){
						store.loadItem({
							item: item,
							onItem: onItem,
							onError: onError
						});
					}
				});
			}
		},

		// =======================================================================
		// Inspecting items

		isItem: function(/* anything */ something){
			return this.store.isItem(something);	// Boolean
		},

		fetchItemByIdentity: function(/* object */ keywordArgs){
			this.store.fetchItemByIdentity(keywordArgs);
		},

		getIdentity: function(/* item */ item){
			return this.store.getIdentity(item);	// Object
		},

		getLabel: function(/*dojo.data.Item*/ item){
			// summary:
			//		Get the label for an item
			if(this.labelAttr){
				return this.store.getValue(item,this.labelAttr);	// String
			}else{
				return this.store.getLabel(item);	// String
			}
		},

		// =======================================================================
		// Write interface

		newItem: function(/* dojo.dnd.Item */ args, /*Item*/ parent, /*int?*/ insertIndex){
			// summary:
			//		Creates a new item.   See `dojo.data.api.Write` for details on args.
			//		Used in drag & drop when item from external source dropped onto tree.
			// description:
			//		Developers will need to override this method if new items get added
			//		to parents with multiple children attributes, in order to define which
			//		children attribute points to the new item.

			var pInfo = {parent: parent, attribute: this.childrenAttrs[0], insertIndex: insertIndex};

			if(this.newItemIdAttr && args[this.newItemIdAttr]){
				// Maybe there's already a corresponding item in the store; if so, reuse it.
				this.fetchItemByIdentity({identity: args[this.newItemIdAttr], scope: this, onItem: function(item){
					if(item){
						// There's already a matching item in store, use it
						this.pasteItem(item, null, parent, true, insertIndex);
					}else{
						// Create new item in the tree, based on the drag source.
						this.store.newItem(args, pInfo);
					}
				}});
			}else{
				// [as far as we know] there is no id so we must assume this is a new item
				this.store.newItem(args, pInfo);
			}
		},

		pasteItem: function(/*Item*/ childItem, /*Item*/ oldParentItem, /*Item*/ newParentItem, /*Boolean*/ bCopy, /*int?*/ insertIndex){
			// summary:
			//		Move or copy an item from one parent item to another.
			//		Used in drag & drop
			var store = this.store,
				parentAttr = this.childrenAttrs[0];	// name of "children" attr in parent item

			// remove child from source item, and record the attribute that child occurred in
			if(oldParentItem){
				dojo.forEach(this.childrenAttrs, function(attr){
					if(store.containsValue(oldParentItem, attr, childItem)){
						if(!bCopy){
							var values = dojo.filter(store.getValues(oldParentItem, attr), function(x){
								return x != childItem;
							});
							store.setValues(oldParentItem, attr, values);
						}
						parentAttr = attr;
					}
				});
			}

			// modify target item's children attribute to include this item
			if(newParentItem){
				if(typeof insertIndex == "number"){
					var childItems = store.getValues(newParentItem, parentAttr);
					childItems.splice(insertIndex, 0, childItem);
					store.setValues(newParentItem, parentAttr, childItems);
				}else{
				store.setValues(newParentItem, parentAttr,
					store.getValues(newParentItem, parentAttr).concat(childItem));
			}
			}
		},

		// =======================================================================
		// Callbacks

		onChange: function(/*dojo.data.Item*/ item){
			// summary:
			//		Callback whenever an item has changed, so that Tree
			//		can update the label, icon, etc.   Note that changes
			//		to an item's children or parent(s) will trigger an
			//		onChildrenChange() so you can ignore those changes here.
			// tags:
			//		callback
		},

		onChildrenChange: function(/*dojo.data.Item*/ parent, /*dojo.data.Item[]*/ newChildrenList){
			// summary:
			//		Callback to do notifications about new, updated, or deleted items.
			// tags:
			//		callback
		},

		onDelete: function(/*dojo.data.Item*/ parent, /*dojo.data.Item[]*/ newChildrenList){
			// summary:
			//		Callback when an item has been deleted.
			// description:
			//		Note that there will also be an onChildrenChange() callback for the parent
			//		of this item.
			// tags:
			//		callback
		},

		// =======================================================================
		// Events from data store

		onNewItem: function(/* dojo.data.Item */ item, /* Object */ parentInfo){
			// summary:
			//		Handler for when new items appear in the store, either from a drop operation
			//		or some other way.   Updates the tree view (if necessary).
			// description:
			//		If the new item is a child of an existing item,
			//		calls onChildrenChange() with the new list of children
			//		for that existing item.
			//
			// tags:
			//		extension

			// We only care about the new item if it has a parent that corresponds to a TreeNode
			// we are currently displaying
			if(!parentInfo){
				return;
			}

			// Call onChildrenChange() on parent (ie, existing) item with new list of children
			// In the common case, the new list of children is simply parentInfo.newValue or
			// [ parentInfo.newValue ], although if items in the store has multiple
			// child attributes (see `childrenAttr`), then it's a superset of parentInfo.newValue,
			// so call getChildren() to be sure to get right answer.
			this.getChildren(parentInfo.item, dojo.hitch(this, function(children){
				this.onChildrenChange(parentInfo.item, children);
			}));
		},

		onDeleteItem: function(/*Object*/ item){
			// summary:
			//		Handler for delete notifications from underlying store
			this.onDelete(item);
		},

		onSetItem: function(/* item */ item,
						/* attribute-name-string */ attribute,
						/* object | array */ oldValue,
						/* object | array */ newValue){
			// summary:
			//		Updates the tree view according to changes in the data store.
			// description:
			//		Handles updates to an item's children by calling onChildrenChange(), and
			//		other updates to an item by calling onChange().
			//
			//		See `onNewItem` for more details on handling updates to an item's children.
			// tags:
			//		extension

			if(dojo.indexOf(this.childrenAttrs, attribute) != -1){
				// item's children list changed
				this.getChildren(item, dojo.hitch(this, function(children){
					// See comments in onNewItem() about calling getChildren()
					this.onChildrenChange(item, children);
				}));
			}else{
				// item's label/icon/etc. changed.
				this.onChange(item);
			}
		}
	});



}

if(!dojo._hasResource["dijit.tree.ForestStoreModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.tree.ForestStoreModel"] = true;
dojo.provide("dijit.tree.ForestStoreModel");



dojo.declare("dijit.tree.ForestStoreModel", dijit.tree.TreeStoreModel, {
	// summary:
	//		Interface between Tree and a dojo.store that doesn't have a root item,
	//		i.e. has multiple "top level" items.
	//
	// description
	//		Use this class to wrap a dojo.store, making all the items matching the specified query
	//		appear as children of a fabricated "root item".  If no query is specified then all the
	//		items returned by fetch() on the underlying store become children of the root item.
	//		It allows dijit.Tree to assume a single root item, even if the store doesn't have one.

	// Parameters to constructor

	// rootId: String
	//		ID of fabricated root item
	rootId: "$root$",

	// rootLabel: String
	//		Label of fabricated root item
	rootLabel: "ROOT",

	// query: String
	//		Specifies the set of children of the root item.
	// example:
	//	|	{type:'continent'}
	query: null,

	// End of parameters to constructor

	constructor: function(params){
		// summary:
		//		Sets up variables, etc.
		// tags:
		//		private

		// Make dummy root item
		this.root = {
			store: this,
			root: true,
			id: params.rootId,
			label: params.rootLabel,
			children: params.rootChildren	// optional param
		};
	},

	// =======================================================================
	// Methods for traversing hierarchy

	mayHaveChildren: function(/*dojo.data.Item*/ item){
		// summary:
		//		Tells if an item has or may have children.  Implementing logic here
		//		avoids showing +/- expando icon for nodes that we know don't have children.
		//		(For efficiency reasons we may not want to check if an element actually
		//		has children until user clicks the expando node)
		// tags:
		//		extension
		return item === this.root || this.inherited(arguments);
	},

	getChildren: function(/*dojo.data.Item*/ parentItem, /*function(items)*/ callback, /*function*/ onError){
		// summary:
		// 		Calls onComplete() with array of child items of given parent item, all loaded.
		if(parentItem === this.root){
			if(this.root.children){
				// already loaded, just return
				callback(this.root.children);
			}else{
				this.store.fetch({
					query: this.query,
					onComplete: dojo.hitch(this, function(items){
						this.root.children = items;
						callback(items);
					}),
					onError: onError
				});
			}
		}else{
			this.inherited(arguments);
		}
	},

	// =======================================================================
	// Inspecting items

	isItem: function(/* anything */ something){
		return (something === this.root) ? true : this.inherited(arguments);
	},

	fetchItemByIdentity: function(/* object */ keywordArgs){
		if(keywordArgs.identity == this.root.id){
			var scope = keywordArgs.scope?keywordArgs.scope:dojo.global;
			if(keywordArgs.onItem){
				keywordArgs.onItem.call(scope, this.root);
			}
		}else{
			this.inherited(arguments);
		}
	},

	getIdentity: function(/* item */ item){
		return (item === this.root) ? this.root.id : this.inherited(arguments);
	},

	getLabel: function(/* item */ item){
		return	(item === this.root) ? this.root.label : this.inherited(arguments);
	},

	// =======================================================================
	// Write interface

	newItem: function(/* dojo.dnd.Item */ args, /*Item*/ parent, /*int?*/ insertIndex){
		// summary:
		//		Creates a new item.   See dojo.data.api.Write for details on args.
		//		Used in drag & drop when item from external source dropped onto tree.
		if(parent === this.root){
			this.onNewRootItem(args);
			return this.store.newItem(args);
		}else{
			return this.inherited(arguments);
		}
	},

	onNewRootItem: function(args){
		// summary:
		//		User can override this method to modify a new element that's being
		//		added to the root of the tree, for example to add a flag like root=true
	},

	pasteItem: function(/*Item*/ childItem, /*Item*/ oldParentItem, /*Item*/ newParentItem, /*Boolean*/ bCopy, /*int?*/ insertIndex){
		// summary:
		//		Move or copy an item from one parent item to another.
		//		Used in drag & drop
		if(oldParentItem === this.root){
			if(!bCopy){
				// It's onLeaveRoot()'s responsibility to modify the item so it no longer matches
				// this.query... thus triggering an onChildrenChange() event to notify the Tree
				// that this element is no longer a child of the root node
				this.onLeaveRoot(childItem);
			}
		}
		dijit.tree.TreeStoreModel.prototype.pasteItem.call(this, childItem,
			oldParentItem === this.root ? null : oldParentItem,
			newParentItem === this.root ? null : newParentItem,
			bCopy,
			insertIndex
		);
		if(newParentItem === this.root){
			// It's onAddToRoot()'s responsibility to modify the item so it matches
			// this.query... thus triggering an onChildrenChange() event to notify the Tree
			// that this element is now a child of the root node
			this.onAddToRoot(childItem);
		}
	},

	// =======================================================================
	// Handling for top level children

	onAddToRoot: function(/* item */ item){
		// summary:
		//		Called when item added to root of tree; user must override this method
		//		to modify the item so that it matches the query for top level items
		// example:
		//	|	store.setValue(item, "root", true);
		// tags:
		//		extension
		console.log(this, ": item ", item, " added to root");
	},

	onLeaveRoot: function(/* item */ item){
		// summary:
		//		Called when item removed from root of tree; user must override this method
		//		to modify the item so it doesn't match the query for top level items
		// example:
		// 	|	store.unsetAttribute(item, "root");
		// tags:
		//		extension
		console.log(this, ": item ", item, " removed from root");
	},

	// =======================================================================
	// Events from data store

	_requeryTop: function(){
		// reruns the query for the children of the root node,
		// sending out an onSet notification if those children have changed
		var oldChildren = this.root.children || [];
		this.store.fetch({
			query: this.query,
			onComplete: dojo.hitch(this, function(newChildren){
				this.root.children = newChildren;

				// If the list of children or the order of children has changed...
				if(oldChildren.length != newChildren.length ||
					dojo.some(oldChildren, function(item, idx){ return newChildren[idx] != item;})){
					this.onChildrenChange(this.root, newChildren);
				}
			})
		});
	},

	onNewItem: function(/* dojo.data.Item */ item, /* Object */ parentInfo){
		// summary:
		//		Handler for when new items appear in the store.  Developers should override this
		//		method to be more efficient based on their app/data.
		// description:
		//		Note that the default implementation requeries the top level items every time
		//		a new item is created, since any new item could be a top level item (even in
		//		addition to being a child of another item, since items can have multiple parents).
		//
		//		Developers can override this function to do something more efficient if they can
		//		detect which items are possible top level items (based on the item and the
		//		parentInfo parameters).  Often all top level items have parentInfo==null, but
		//		that will depend on which store you use and what your data is like.
		// tags:
		//		extension
		this._requeryTop();

		this.inherited(arguments);
	},

	onDeleteItem: function(/*Object*/ item){
		// summary:
		//		Handler for delete notifications from underlying store

		// check if this was a child of root, and if so send notification that root's children
		// have changed
		if(dojo.indexOf(this.root.children, item) != -1){
			this._requeryTop();
		}

		this.inherited(arguments);
	}
});



}

if(!dojo._hasResource["dijit.Tree"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["dijit.Tree"] = true;
dojo.provide("dijit.Tree");










dojo.declare(
	"dijit._TreeNode",
	[dijit._Widget, dijit._Templated, dijit._Container, dijit._Contained],
{
	// summary:
	//		Single node within a tree.   This class is used internally
	//		by Tree and should not be accessed directly.
	// tags:
	//		private

	// item: dojo.data.Item
	//		the dojo.data entry this tree represents
	item: null,

	// isTreeNode: [protected] Boolean
	//		Indicates that this is a TreeNode.   Used by `dijit.Tree` only,
	//		should not be accessed directly.
	isTreeNode: true,

	// label: String
	//		Text of this tree node
	label: "",

	// isExpandable: [private] Boolean
	//		This node has children, so show the expando node (+ sign)
	isExpandable: null,

	// isExpanded: [readonly] Boolean
	//		This node is currently expanded (ie, opened)
	isExpanded: false,

	// state: [private] String
	//		Dynamic loading-related stuff.
	//		When an empty folder node appears, it is "UNCHECKED" first,
	//		then after dojo.data query it becomes "LOADING" and, finally "LOADED"
	state: "UNCHECKED",

	templateString: dojo.cache("dijit", "templates/TreeNode.html", "<div class=\"dijitTreeNode\" waiRole=\"presentation\"\n\t><div dojoAttachPoint=\"rowNode\" class=\"dijitTreeRow\" waiRole=\"presentation\" dojoAttachEvent=\"onmouseenter:_onMouseEnter, onmouseleave:_onMouseLeave, onclick:_onClick, ondblclick:_onDblClick\"\n\t\t><img src=\"${_blankGif}\" alt=\"\" dojoAttachPoint=\"expandoNode\" class=\"dijitTreeExpando\" waiRole=\"presentation\"\n\t\t><span dojoAttachPoint=\"expandoNodeText\" class=\"dijitExpandoText\" waiRole=\"presentation\"\n\t\t></span\n\t\t><span dojoAttachPoint=\"contentNode\"\n\t\t\tclass=\"dijitTreeContent\" waiRole=\"presentation\">\n\t\t\t<img src=\"${_blankGif}\" alt=\"\" dojoAttachPoint=\"iconNode\" class=\"dijitTreeIcon\" waiRole=\"presentation\"\n\t\t\t><span dojoAttachPoint=\"labelNode\" class=\"dijitTreeLabel\" wairole=\"treeitem\" tabindex=\"-1\" waiState=\"selected-false\" dojoAttachEvent=\"onfocus:_onLabelFocus, onblur:_onLabelBlur\"></span>\n\t\t</span\n\t></div>\n\t<div dojoAttachPoint=\"containerNode\" class=\"dijitTreeContainer\" waiRole=\"presentation\" style=\"display: none;\"></div>\n</div>\n"),

	attributeMap: dojo.delegate(dijit._Widget.prototype.attributeMap, {
		label: {node: "labelNode", type: "innerText"},
		tooltip: {node: "rowNode", type: "attribute", attribute: "title"}
	}),

	postCreate: function(){
		// set expand icon for leaf
		this._setExpando();

		// set icon and label class based on item
		this._updateItemClasses(this.item);

		if(this.isExpandable){
			dijit.setWaiState(this.labelNode, "expanded", this.isExpanded);
		}
	},

	_setIndentAttr: function(indent){
		// summary:
		//		Tell this node how many levels it should be indented
		// description:
		//		0 for top level nodes, 1 for their children, 2 for their
		//		grandchildren, etc.
		this.indent = indent;

		// Math.max() is to prevent negative padding on hidden root node (when indent == -1)
		var pixels = (Math.max(indent, 0) * this.tree._nodePixelIndent) + "px";

		dojo.style(this.domNode, "backgroundPosition",	pixels + " 0px");
		dojo.style(this.rowNode, dojo._isBodyLtr() ? "paddingLeft" : "paddingRight", pixels);

		dojo.forEach(this.getChildren(), function(child){
			child.attr("indent", indent+1);
		});
	},

	markProcessing: function(){
		// summary:
		//		Visually denote that tree is loading data, etc.
		// tags:
		//		private
		this.state = "LOADING";
		this._setExpando(true);
	},

	unmarkProcessing: function(){
		// summary:
		//		Clear markup from markProcessing() call
		// tags:
		//		private
		this._setExpando(false);
	},

	_updateItemClasses: function(item){
		// summary:
		//		Set appropriate CSS classes for icon and label dom node
		//		(used to allow for item updates to change respective CSS)
		// tags:
		//		private
		var tree = this.tree, model = tree.model;
		if(tree._v10Compat && item === model.root){
			// For back-compat with 1.0, need to use null to specify root item (TODO: remove in 2.0)
			item = null;
		}
		this._applyClassAndStyle(item, "icon", "Icon");
		this._applyClassAndStyle(item, "label", "Label");
		this._applyClassAndStyle(item, "row", "Row");
	},

	_applyClassAndStyle: function(item, lower, upper){
		// summary:
		//		Set the appropriate CSS classes and styles for labels, icons and rows.
		//
		// item:
		//		The data item.
		//
		// lower:
		//		The lower case attribute to use, e.g. 'icon', 'label' or 'row'.
		//
		// upper:
		//		The upper case attribute to use, e.g. 'Icon', 'Label' or 'Row'.
		//
		// tags:
		//		private

		var clsName = "_" + lower + "Class";
		var nodeName = lower + "Node";

		if(this[clsName]){
			dojo.removeClass(this[nodeName], this[clsName]);
 		}
		this[clsName] = this.tree["get" + upper + "Class"](item, this.isExpanded);
		if(this[clsName]){
			dojo.addClass(this[nodeName], this[clsName]);
 		}
		dojo.style(this[nodeName], this.tree["get" + upper + "Style"](item, this.isExpanded) || {});
 	},

	_updateLayout: function(){
		// summary:
		//		Set appropriate CSS classes for this.domNode
		// tags:
		//		private
		var parent = this.getParent();
		if(!parent || parent.rowNode.style.display == "none"){
			/* if we are hiding the root node then make every first level child look like a root node */
			dojo.addClass(this.domNode, "dijitTreeIsRoot");
		}else{
			dojo.toggleClass(this.domNode, "dijitTreeIsLast", !this.getNextSibling());
		}
	},

	_setExpando: function(/*Boolean*/ processing){
		// summary:
		//		Set the right image for the expando node
		// tags:
		//		private

		var styles = ["dijitTreeExpandoLoading", "dijitTreeExpandoOpened",
						"dijitTreeExpandoClosed", "dijitTreeExpandoLeaf"],
			_a11yStates = ["*","-","+","*"],
			idx = processing ? 0 : (this.isExpandable ?	(this.isExpanded ? 1 : 2) : 3);

		// apply the appropriate class to the expando node
		dojo.removeClass(this.expandoNode, styles);
		dojo.addClass(this.expandoNode, styles[idx]);

		// provide a non-image based indicator for images-off mode
		this.expandoNodeText.innerHTML = _a11yStates[idx];

	},

	expand: function(){
		// summary:
		//		Show my children
		// returns:
		//		Deferred that fires when expansion is complete

		// If there's already an expand in progress or we are already expanded, just return
		if(this._expandDeferred){
			return this._expandDeferred;		// dojo.Deferred
		}

		// cancel in progress collapse operation
		this._wipeOut && this._wipeOut.stop();

		// All the state information for when a node is expanded, maybe this should be
		// set when the animation completes instead
		this.isExpanded = true;
		dijit.setWaiState(this.labelNode, "expanded", "true");
		dijit.setWaiRole(this.containerNode, "group");
		dojo.addClass(this.contentNode,'dijitTreeContentExpanded');
		this._setExpando();
		this._updateItemClasses(this.item);
		if(this == this.tree.rootNode){
			dijit.setWaiState(this.tree.domNode, "expanded", "true");
		}

		var def,
			wipeIn = dojo.fx.wipeIn({
				node: this.containerNode, duration: dijit.defaultDuration,
				onEnd: function(){
					def.callback(true);
				}
			});

		// Deferred that fires when expand is complete
		def = (this._expandDeferred = new dojo.Deferred(function(){
			// Canceller
			wipeIn.stop();
		}));

		wipeIn.play();

		return def;		// dojo.Deferred
	},

	collapse: function(){
		// summary:
		//		Collapse this node (if it's expanded)

		if(!this.isExpanded){ return; }

		// cancel in progress expand operation
		if(this._expandDeferred){
			this._expandDeferred.cancel();
			delete this._expandDeferred;
		}

		this.isExpanded = false;
		dijit.setWaiState(this.labelNode, "expanded", "false");
		if(this == this.tree.rootNode){
			dijit.setWaiState(this.tree.domNode, "expanded", "false");
		}
		dojo.removeClass(this.contentNode,'dijitTreeContentExpanded');
		this._setExpando();
		this._updateItemClasses(this.item);

		if(!this._wipeOut){
			this._wipeOut = dojo.fx.wipeOut({
				node: this.containerNode, duration: dijit.defaultDuration
			});
		}
		this._wipeOut.play();
	},

	// indent: Integer
	//		Levels from this node to the root node
	indent: 0,

	setChildItems: function(/* Object[] */ items){
		// summary:
		//		Sets the child items of this node, removing/adding nodes
		//		from current children to match specified items[] array.
		//		Also, if this.persist == true, expands any children that were previously
		// 		opened.
		// returns:
		//		Deferred object that fires after all previously opened children
		//		have been expanded again (or fires instantly if there are no such children).

		var tree = this.tree,
			model = tree.model,
			defs = [];	// list of deferreds that need to fire before I am complete


		// Orphan all my existing children.
		// If items contains some of the same items as before then we will reattach them.
		// Don't call this.removeChild() because that will collapse the tree etc.
		this.getChildren().forEach(function(child){
			dijit._Container.prototype.removeChild.call(this, child);
		}, this);

		this.state = "LOADED";

		if(items && items.length > 0){
			this.isExpandable = true;

			// Create _TreeNode widget for each specified tree node, unless one already
			// exists and isn't being used (presumably it's from a DnD move and was recently
			// released
			dojo.forEach(items, function(item){
				var id = model.getIdentity(item),
					existingNodes = tree._itemNodesMap[id],
					node;
				if(existingNodes){
					for(var i=0;i<existingNodes.length;i++){
						if(existingNodes[i] && !existingNodes[i].getParent()){
							node = existingNodes[i];
							node.attr('indent', this.indent+1);
							break;
						}
					}
				}
				if(!node){
					node = this.tree._createTreeNode({
							item: item,
							tree: tree,
							isExpandable: model.mayHaveChildren(item),
							label: tree.getLabel(item),
							tooltip: tree.getTooltip(item),
							indent: this.indent + 1
						});
					if(existingNodes){
						existingNodes.push(node);
					}else{
						tree._itemNodesMap[id] = [node];
					}
				}
				this.addChild(node);

				// If node was previously opened then open it again now (this may trigger
				// more data store accesses, recursively)
				if(this.tree.autoExpand || this.tree._state(item)){
					defs.push(tree._expandNode(node));
				}
			}, this);

			// note that updateLayout() needs to be called on each child after
			// _all_ the children exist
			dojo.forEach(this.getChildren(), function(child, idx){
				child._updateLayout();
			});
		}else{
			this.isExpandable=false;
		}

		if(this._setExpando){
			// change expando to/from dot or + icon, as appropriate
			this._setExpando(false);
		}

		// On initial tree show, make the selected TreeNode as either the root node of the tree,
		// or the first child, if the root node is hidden
		if(this == tree.rootNode){
			var fc = this.tree.showRoot ? this : this.getChildren()[0];
			if(fc){
				fc.setSelected(true);
				tree.lastFocused = fc;
			}else{
				// fallback: no nodes in tree so focus on Tree <div> itself
				tree.domNode.setAttribute("tabIndex", "0");
			}
		}

		return new dojo.DeferredList(defs);	// dojo.Deferred
	},

	removeChild: function(/* treeNode */ node){
		this.inherited(arguments);

		var children = this.getChildren();
		if(children.length == 0){
			this.isExpandable = false;
			this.collapse();
		}

		dojo.forEach(children, function(child){
				child._updateLayout();
		});
	},

	makeExpandable: function(){
		// summary:
		//		if this node wasn't already showing the expando node,
		//		turn it into one and call _setExpando()

		// TODO: hmm this isn't called from anywhere, maybe should remove it for 2.0

		this.isExpandable = true;
		this._setExpando(false);
	},

	_onLabelFocus: function(evt){
		// summary:
		//		Called when this node is focused (possibly programatically)
		// tags:
		//		private
		dojo.addClass(this.labelNode, "dijitTreeLabelFocused");
		this.tree._onNodeFocus(this);
	},

	_onLabelBlur: function(evt){
		// summary:
		//		Called when focus was moved away from this node, either to
		//		another TreeNode or away from the Tree entirely.
		//		Note that we aren't using _onFocus/_onBlur builtin to dijit
		//		because _onBlur() isn't called when focus is moved to my child TreeNode.
		// tags:
		//		private
		dojo.removeClass(this.labelNode, "dijitTreeLabelFocused");
	},

	setSelected: function(/*Boolean*/ selected){
		// summary:
		//		A Tree has a (single) currently selected node.
		//		Mark that this node is/isn't that currently selected node.
		// description:
		//		In particular, setting a node as selected involves setting tabIndex
		//		so that when user tabs to the tree, focus will go to that node (only).
		var labelNode = this.labelNode;
		labelNode.setAttribute("tabIndex", selected ? "0" : "-1");
		dijit.setWaiState(labelNode, "selected", selected);
		dojo.toggleClass(this.rowNode, "dijitTreeNodeSelected", selected);
	},

	_onClick: function(evt){
		// summary:
		//		Handler for onclick event on a node
		// tags:
		//		private
		this.tree._onClick(this, evt);
	},
	_onDblClick: function(evt){
		// summary:
		//		Handler for ondblclick event on a node
		// tags:
		//		private
		this.tree._onDblClick(this, evt);
	},

	_onMouseEnter: function(evt){
		// summary:
		//		Handler for onmouseenter event on a node
		// tags:
		//		private
		dojo.addClass(this.rowNode, "dijitTreeNodeHover");
		this.tree._onNodeMouseEnter(this, evt);
	},

	_onMouseLeave: function(evt){
		// summary:
		//		Handler for onmouseenter event on a node
		// tags:
		//		private
		dojo.removeClass(this.rowNode, "dijitTreeNodeHover");
		this.tree._onNodeMouseLeave(this, evt);
	}
});

dojo.declare(
	"dijit.Tree",
	[dijit._Widget, dijit._Templated],
{
	// summary:
	//		This widget displays hierarchical data from a store.

	// store: [deprecated] String||dojo.data.Store
	//		Deprecated.  Use "model" parameter instead.
	//		The store to get data to display in the tree.
	store: null,

	// model: dijit.Tree.model
	//		Interface to read tree data, get notifications of changes to tree data,
	//		and for handling drop operations (i.e drag and drop onto the tree)
	model: null,

	// query: [deprecated] anything
	//		Deprecated.  User should specify query to the model directly instead.
	//		Specifies datastore query to return the root item or top items for the tree.
	query: null,

	// label: [deprecated] String
	//		Deprecated.  Use dijit.tree.ForestStoreModel directly instead.
	//		Used in conjunction with query parameter.
	//		If a query is specified (rather than a root node id), and a label is also specified,
	//		then a fake root node is created and displayed, with this label.
	label: "",

	// showRoot: [const] Boolean
	//		Should the root node be displayed, or hidden?
	showRoot: true,

	// childrenAttr: [deprecated] String[]
	//		Deprecated.   This information should be specified in the model.
	//		One ore more attributes that holds children of a tree node
	childrenAttr: ["children"],

	// path: String[] or Item[]
	//		Full path from rootNode to selected node expressed as array of items or array of ids.
	path: [],

	// selectedItem: [readonly] Item
	//		The currently selected item in this tree.
	//		This property can only be set (via attr('selectedItem', ...)) when that item is already
	//		visible in the tree.   (I.e. the tree has already been expanded to show that node.)
	//		Should generally use `path` attribute to set the selected item instead.
	selectedItem: null,

	// openOnClick: Boolean
	//		If true, clicking a folder node's label will open it, rather than calling onClick()
	openOnClick: false,

	// openOnDblClick: Boolean
	//		If true, double-clicking a folder node's label will open it, rather than calling onDblClick()
	openOnDblClick: false,

	templateString: dojo.cache("dijit", "templates/Tree.html", "<div class=\"dijitTree dijitTreeContainer\" waiRole=\"tree\"\n\tdojoAttachEvent=\"onkeypress:_onKeyPress\">\n\t<div class=\"dijitInline dijitTreeIndent\" style=\"position: absolute; top: -9999px\" dojoAttachPoint=\"indentDetector\"></div>\n</div>\n"),

	// persist: Boolean
	//		Enables/disables use of cookies for state saving.
	persist: true,

	// autoExpand: Boolean
	//		Fully expand the tree on load.   Overrides `persist`
	autoExpand: false,

	// dndController: [protected] String
	//		Class name to use as as the dnd controller.  Specifying this class enables DnD.
	//		Generally you should specify this as "dijit.tree.dndSource".
	dndController: null,

	// parameters to pull off of the tree and pass on to the dndController as its params
	dndParams: ["onDndDrop","itemCreator","onDndCancel","checkAcceptance", "checkItemAcceptance", "dragThreshold", "betweenThreshold"],

	//declare the above items so they can be pulled from the tree's markup

	// onDndDrop: [protected] Function
	//		Parameter to dndController, see `dijit.tree.dndSource.onDndDrop`.
	//		Generally this doesn't need to be set.
	onDndDrop: null,

	/*=====
	itemCreator: function(nodes, target, source){
		// summary:
		//		Returns objects passed to `Tree.model.newItem()` based on DnD nodes
		//		dropped onto the tree.   Developer must override this method to enable
		// 		dropping from external sources onto this Tree, unless the Tree.model's items
		//		happen to look like {id: 123, name: "Apple" } with no other attributes.
		// description:
		//		For each node in nodes[], which came from source, create a hash of name/value
		//		pairs to be passed to Tree.model.newItem().  Returns array of those hashes.
		// nodes: DomNode[]
		//		The DOMNodes dragged from the source container
		// target: DomNode
		//		The target TreeNode.rowNode
		// source: dojo.dnd.Source
		//		The source container the nodes were dragged from, perhaps another Tree or a plain dojo.dnd.Source
		// returns: Object[]
		//		Array of name/value hashes for each new item to be added to the Tree, like:
		// |	[
		// |		{ id: 123, label: "apple", foo: "bar" },
		// |		{ id: 456, label: "pear", zaz: "bam" }
		// |	]
		// tags:
		//		extension
		return [{}];
	},
	=====*/
	itemCreator: null,

	// onDndCancel: [protected] Function
	//		Parameter to dndController, see `dijit.tree.dndSource.onDndCancel`.
	//		Generally this doesn't need to be set.
	onDndCancel: null,

/*=====
	checkAcceptance: function(source, nodes){
		// summary:
		//		Checks if the Tree itself can accept nodes from this source
		// source: dijit.tree._dndSource
		//		The source which provides items
		// nodes: DOMNode[]
		//		Array of DOM nodes corresponding to nodes being dropped, dijitTreeRow nodes if
		//		source is a dijit.Tree.
		// tags:
		//		extension
		return true;	// Boolean
	},
=====*/
	checkAcceptance: null,

/*=====
	checkItemAcceptance: function(target, source, position){
		// summary:
		//		Stub function to be overridden if one wants to check for the ability to drop at the node/item level
		// description:
		//		In the base case, this is called to check if target can become a child of source.
		//		When betweenThreshold is set, position="before" or "after" means that we
		//		are asking if the source node can be dropped before/after the target node.
		// target: DOMNode
		//		The dijitTreeRoot DOM node inside of the TreeNode that we are dropping on to
		//		Use dijit.getEnclosingWidget(target) to get the TreeNode.
		// source: dijit.tree.dndSource
		//		The (set of) nodes we are dropping
		// position: String
		//		"over", "before", or "after"
		// tags:
		//		extension
		return true;	// Boolean
	},
=====*/
	checkItemAcceptance: null,

	// dragThreshold: Integer
	//		Number of pixels mouse moves before it's considered the start of a drag operation
	dragThreshold: 5,

	// betweenThreshold: Integer
	//		Set to a positive value to allow drag and drop "between" nodes.
	//
	//		If during DnD mouse is over a (target) node but less than betweenThreshold
	//		pixels from the bottom edge, dropping the the dragged node will make it
	//		the next sibling of the target node, rather than the child.
	//
	//		Similarly, if mouse is over a target node but less that betweenThreshold
	//		pixels from the top edge, dropping the dragged node will make it
	//		the target node's previous sibling rather than the target node's child.
	betweenThreshold: 0,

	// _nodePixelIndent: Integer
	//		Number of pixels to indent tree nodes (relative to parent node).
	//		Default is 19 but can be overridden by setting CSS class dijitTreeIndent
	//		and calling resize() or startup() on tree after it's in the DOM.
	_nodePixelIndent: 19,

	_publish: function(/*String*/ topicName, /*Object*/ message){
		// summary:
		//		Publish a message for this widget/topic
		dojo.publish(this.id, [dojo.mixin({tree: this, event: topicName}, message || {})]);
	},

	postMixInProperties: function(){
		this.tree = this;

		this._itemNodesMap={};

		if(!this.cookieName){
			this.cookieName = this.id + "SaveStateCookie";
		}

		this._loadDeferred = new dojo.Deferred();

		this.inherited(arguments);
	},

	postCreate: function(){
		this._initState();

		// Create glue between store and Tree, if not specified directly by user
		if(!this.model){
			this._store2model();
		}

		// monitor changes to items
		this.connect(this.model, "onChange", "_onItemChange");
		this.connect(this.model, "onChildrenChange", "_onItemChildrenChange");
		this.connect(this.model, "onDelete", "_onItemDelete");

		this._load();

		this.inherited(arguments);

		if(this.dndController){
			if(dojo.isString(this.dndController)){
				this.dndController = dojo.getObject(this.dndController);
			}
			var params={};
			for(var i=0; i<this.dndParams.length;i++){
				if(this[this.dndParams[i]]){
					params[this.dndParams[i]] = this[this.dndParams[i]];
				}
			}
			this.dndController = new this.dndController(this, params);
		}
	},

	_store2model: function(){
		// summary:
		//		User specified a store&query rather than model, so create model from store/query
		this._v10Compat = true;
		dojo.deprecated("Tree: from version 2.0, should specify a model object rather than a store/query");

		var modelParams = {
			id: this.id + "_ForestStoreModel",
			store: this.store,
			query: this.query,
			childrenAttrs: this.childrenAttr
		};

		// Only override the model's mayHaveChildren() method if the user has specified an override
		if(this.params.mayHaveChildren){
			modelParams.mayHaveChildren = dojo.hitch(this, "mayHaveChildren");
		}

		if(this.params.getItemChildren){
			modelParams.getChildren = dojo.hitch(this, function(item, onComplete, onError){
				this.getItemChildren((this._v10Compat && item === this.model.root) ? null : item, onComplete, onError);
			});
		}
		this.model = new dijit.tree.ForestStoreModel(modelParams);

		// For backwards compatibility, the visibility of the root node is controlled by
		// whether or not the user has specified a label
		this.showRoot = Boolean(this.label);
	},

	onLoad: function(){
		// summary:
		//		Called when tree finishes loading and expanding.
		// description:
		//		If persist == true the loading may encompass many levels of fetches
		//		from the data store, each asynchronous.   Waits for all to finish.
		// tags:
		//		callback
	},

	_load: function(){
		// summary:
		//		Initial load of the tree.
		//		Load root node (possibly hidden) and it's children.
		this.model.getRoot(
			dojo.hitch(this, function(item){
				var rn = (this.rootNode = this.tree._createTreeNode({
					item: item,
					tree: this,
					isExpandable: true,
					label: this.label || this.getLabel(item),
					indent: this.showRoot ? 0 : -1
				}));
				if(!this.showRoot){
					rn.rowNode.style.display="none";
				}
				this.domNode.appendChild(rn.domNode);
				var identity = this.model.getIdentity(item);
				if(this._itemNodesMap[identity]){
					this._itemNodesMap[identity].push(rn);
				}else{
					this._itemNodesMap[identity] = [rn];
				}

				rn._updateLayout();		// sets "dijitTreeIsRoot" CSS classname

				// load top level children and then fire onLoad() event
				this._expandNode(rn).addCallback(dojo.hitch(this, function(){
					this._loadDeferred.callback(true);
					this.onLoad();
				}));
			}),
			function(err){
				console.error(this, ": error loading root: ", err);
			}
		);
	},

	getNodesByItem: function(/*dojo.data.Item or id*/ item){
		// summary:
		//		Returns all tree nodes that refer to an item
		// returns:
		//		Array of tree nodes that refer to passed item

		if(!item){ return []; }
		var identity = dojo.isString(item) ? item : this.model.getIdentity(item);
		// return a copy so widget don't get messed up by changes to returned array
		return [].concat(this._itemNodesMap[identity]);
	},

	_setSelectedItemAttr: function(/*dojo.data.Item or id*/ item){
		// summary:
		//		Select a tree node related to passed item.
		//		WARNING: if model use multi-parented items or desired tree node isn't already loaded
		//		behavior is not granted. Use 'path' attr instead for full support.
		var oldValue = this.attr("selectedItem");
		var identity = (!item || dojo.isString(item)) ? item : this.model.getIdentity(item);
		if(identity == oldValue ? this.model.getIdentity(oldValue) : null){ return; }
		var nodes = this._itemNodesMap[identity];
		if(nodes && nodes.length){
			//select the first item
			this.focusNode(nodes[0]);
		}else if(this.lastFocused){
			// Select none so deselect current
			this.lastFocused.setSelected(false);
			this.lastFocused = null;
		}
	},

	_getSelectedItemAttr: function(){
		// summary:
		//		Return item related to selected tree node.
		return this.lastFocused && this.lastFocused.item;
	},

	_setPathAttr: function(/*Item[] || String[]*/ path){
		// summary:
		//		Select the tree node identified by passed path.
		// path:
		//		Array of items or item id's

		if(!path || !path.length){ return; }

		// If this is called during initialization, defer running until Tree has finished loading
		this._loadDeferred.addCallback(dojo.hitch(this, function(){
			if(!this.rootNode){
				console.debug("!this.rootNode");
				return;
			}
			if(path[0] !== this.rootNode.item && (dojo.isString(path[0]) && path[0] != this.model.getIdentity(this.rootNode.item))){
				console.error(this, ":path[0] doesn't match this.rootNode.item.  Maybe you are using the wrong tree.");
				return;
			}
			path.shift();

			var node = this.rootNode;

			function advance(){
				// summary:
				// 		Called when "node" has completed loading and expanding.   Pop the next item from the path
				//		(which must be a child of "node") and advance to it, and then recurse.

				// Set item and identity to next item in path (node is pointing to the item that was popped
				// from the path _last_ time.
				var item = path.shift(),
					identity = dojo.isString(item) ? item : this.model.getIdentity(item);

				// Change "node" from previous item in path to the item we just popped from path
				dojo.some(this._itemNodesMap[identity], function(n){
					if(n.getParent() == node){
						node = n;
						return true;
					}
					return false;
				});

				if(path.length){
					// Need to do more expanding
					this._expandNode(node).addCallback(dojo.hitch(this, advance));
				}else{
					// Final destination node, select it
					if(this.lastFocused != node){
						this.focusNode(node);
					}
				}
			}

			this._expandNode(node).addCallback(dojo.hitch(this, advance));
		}));
	},

	_getPathAttr: function(){
		// summary:
		//		Return an array of items that is the path to selected tree node.
		if(!this.lastFocused){ return; }
		var res = [];
		var treeNode = this.lastFocused;
		while(treeNode && treeNode !== this.rootNode){
			res.unshift(treeNode.item);
			treeNode = treeNode.getParent();
		}
		res.unshift(this.rootNode.item);
		return res;
	},

	////////////// Data store related functions //////////////////////
	// These just get passed to the model; they are here for back-compat

	mayHaveChildren: function(/*dojo.data.Item*/ item){
		// summary:
		//		Deprecated.   This should be specified on the model itself.
		//
		//		Overridable function to tell if an item has or may have children.
		//		Controls whether or not +/- expando icon is shown.
		//		(For efficiency reasons we may not want to check if an element actually
		//		has children until user clicks the expando node)
		// tags:
		//		deprecated
	},

	getItemChildren: function(/*dojo.data.Item*/ parentItem, /*function(items)*/ onComplete){
		// summary:
		//		Deprecated.   This should be specified on the model itself.
		//
		// 		Overridable function that return array of child items of given parent item,
		//		or if parentItem==null then return top items in tree
		// tags:
		//		deprecated
	},

	///////////////////////////////////////////////////////
	// Functions for converting an item to a TreeNode
	getLabel: function(/*dojo.data.Item*/ item){
		// summary:
		//		Overridable function to get the label for a tree node (given the item)
		// tags:
		//		extension
		return this.model.getLabel(item);	// String
	},

	getIconClass: function(/*dojo.data.Item*/ item, /*Boolean*/ opened){
		// summary:
		//		Overridable function to return CSS class name to display icon
		// tags:
		//		extension
		return (!item || this.model.mayHaveChildren(item)) ? (opened ? "dijitFolderOpened" : "dijitFolderClosed") : "dijitLeaf"
	},

	getLabelClass: function(/*dojo.data.Item*/ item, /*Boolean*/ opened){
		// summary:
		//		Overridable function to return CSS class name to display label
		// tags:
		//		extension
	},

	getRowClass: function(/*dojo.data.Item*/ item, /*Boolean*/ opened){
		// summary:
		//		Overridable function to return CSS class name to display row
		// tags:
		//		extension
	},

	getIconStyle: function(/*dojo.data.Item*/ item, /*Boolean*/ opened){
		// summary:
		//		Overridable function to return CSS styles to display icon
		// returns:
		//		Object suitable for input to dojo.style() like {backgroundImage: "url(...)"}
		// tags:
		//		extension
	},

	getLabelStyle: function(/*dojo.data.Item*/ item, /*Boolean*/ opened){
		// summary:
		//		Overridable function to return CSS styles to display label
		// returns:
		//		Object suitable for input to dojo.style() like {color: "red", background: "green"}
		// tags:
		//		extension
	},

	getRowStyle: function(/*dojo.data.Item*/ item, /*Boolean*/ opened){
		// summary:
		//		Overridable function to return CSS styles to display row
		// returns:
		//		Object suitable for input to dojo.style() like {background-color: "#bbb"}
		// tags:
		//		extension
	},

	getTooltip: function(/*dojo.data.Item*/ item){
		// summary:
		//		Overridable function to get the tooltip for a tree node (given the item)
		// tags:
		//		extension
		return "";	// String
	},

	/////////// Keyboard and Mouse handlers ////////////////////

	_onKeyPress: function(/*Event*/ e){
		// summary:
		//		Translates keypress events into commands for the controller
		if(e.altKey){ return; }
		var dk = dojo.keys;
		var treeNode = dijit.getEnclosingWidget(e.target);
		if(!treeNode){ return; }

		var key = e.charOrCode;
		if(typeof key == "string"){	// handle printables (letter navigation)
			// Check for key navigation.
			if(!e.altKey && !e.ctrlKey && !e.shiftKey && !e.metaKey){
				this._onLetterKeyNav( { node: treeNode, key: key.toLowerCase() } );
				dojo.stopEvent(e);
			}
		}else{	// handle non-printables (arrow keys)
			// clear record of recent printables (being saved for multi-char letter navigation),
			// because "a", down-arrow, "b" shouldn't search for "ab"
			if(this._curSearch){
				clearTimeout(this._curSearch.timer);
				delete this._curSearch;
			}

			var map = this._keyHandlerMap;
			if(!map){
				// setup table mapping keys to events
				map = {};
				map[dk.ENTER]="_onEnterKey";
				map[this.isLeftToRight() ? dk.LEFT_ARROW : dk.RIGHT_ARROW]="_onLeftArrow";
				map[this.isLeftToRight() ? dk.RIGHT_ARROW : dk.LEFT_ARROW]="_onRightArrow";
				map[dk.UP_ARROW]="_onUpArrow";
				map[dk.DOWN_ARROW]="_onDownArrow";
				map[dk.HOME]="_onHomeKey";
				map[dk.END]="_onEndKey";
				this._keyHandlerMap = map;
			}
			if(this._keyHandlerMap[key]){
				this[this._keyHandlerMap[key]]( { node: treeNode, item: treeNode.item, evt: e } );
				dojo.stopEvent(e);
			}
		}
	},

	_onEnterKey: function(/*Object*/ message, /*Event*/ evt){
		this._publish("execute", { item: message.item, node: message.node } );
		this.onClick(message.item, message.node, evt);
	},

	_onDownArrow: function(/*Object*/ message){
		// summary:
		//		down arrow pressed; get next visible node, set focus there
		var node = this._getNextNode(message.node);
		if(node && node.isTreeNode){
			this.focusNode(node);
		}
	},

	_onUpArrow: function(/*Object*/ message){
		// summary:
		//		Up arrow pressed; move to previous visible node

		var node = message.node;

		// if younger siblings
		var previousSibling = node.getPreviousSibling();
		if(previousSibling){
			node = previousSibling;
			// if the previous node is expanded, dive in deep
			while(node.isExpandable && node.isExpanded && node.hasChildren()){
				// move to the last child
				var children = node.getChildren();
				node = children[children.length-1];
			}
		}else{
			// if this is the first child, return the parent
			// unless the parent is the root of a tree with a hidden root
			var parent = node.getParent();
			if(!(!this.showRoot && parent === this.rootNode)){
				node = parent;
			}
		}

		if(node && node.isTreeNode){
			this.focusNode(node);
		}
	},

	_onRightArrow: function(/*Object*/ message){
		// summary:
		//		Right arrow pressed; go to child node
		var node = message.node;

		// if not expanded, expand, else move to 1st child
		if(node.isExpandable && !node.isExpanded){
			this._expandNode(node);
		}else if(node.hasChildren()){
			node = node.getChildren()[0];
			if(node && node.isTreeNode){
				this.focusNode(node);
			}
		}
	},

	_onLeftArrow: function(/*Object*/ message){
		// summary:
		//		Left arrow pressed.
		//		If not collapsed, collapse, else move to parent.

		var node = message.node;

		if(node.isExpandable && node.isExpanded){
			this._collapseNode(node);
		}else{
			var parent = node.getParent();
			if(parent && parent.isTreeNode && !(!this.showRoot && parent === this.rootNode)){
				this.focusNode(parent);
			}
		}
	},

	_onHomeKey: function(){
		// summary:
		//		Home key pressed; get first visible node, and set focus there
		var node = this._getRootOrFirstNode();
		if(node){
			this.focusNode(node);
		}
	},

	_onEndKey: function(/*Object*/ message){
		// summary:
		//		End key pressed; go to last visible node.

		var node = this.rootNode;
		while(node.isExpanded){
			var c = node.getChildren();
			node = c[c.length - 1];
		}

		if(node && node.isTreeNode){
			this.focusNode(node);
		}
	},

	// multiCharSearchDuration: Number
	//		If multiple characters are typed where each keystroke happens within
	//		multiCharSearchDuration of the previous keystroke,
	//		search for nodes matching all the keystrokes.
	//
	//		For example, typing "ab" will search for entries starting with
	//		"ab" unless the delay between "a" and "b" is greater than multiCharSearchDuration.
	multiCharSearchDuration: 250,

	_onLetterKeyNav: function(message){
		// summary:
		//		Called when user presses a prinatable key; search for node starting with recently typed letters.
		// message: Object
		//		Like { node: TreeNode, key: 'a' } where key is the key the user pressed.

		// Branch depending on whether this key starts a new search, or modifies an existing search
		var cs = this._curSearch;
		if(cs){
			// We are continuing a search.  Ex: user has pressed 'a', and now has pressed
			// 'b', so we want to search for nodes starting w/"ab".
			cs.pattern = cs.pattern + message.key;
			clearTimeout(cs.timer);
		}else{
			// We are starting a new search
			cs = this._curSearch = {
					pattern: message.key,
					startNode: message.node
			};
		}

		// set/reset timer to forget recent keystrokes
		var self = this;
		cs.timer = setTimeout(function(){
			delete self._curSearch;
		}, this.multiCharSearchDuration);

		// Navigate to TreeNode matching keystrokes [entered so far].
		var node = cs.startNode;
		do{
			node = this._getNextNode(node);
			//check for last node, jump to first node if necessary
			if(!node){
				node = this._getRootOrFirstNode();
			}
		}while(node !== cs.startNode && (node.label.toLowerCase().substr(0, cs.pattern.length) != cs.pattern));
		if(node && node.isTreeNode){
			// no need to set focus if back where we started
			if(node !== cs.startNode){
				this.focusNode(node);
			}
		}
	},

	_onClick: function(/*TreeNode*/ nodeWidget, /*Event*/ e){
		// summary:
		//		Translates click events into commands for the controller to process

		var domElement = e.target;

		if( (this.openOnClick && nodeWidget.isExpandable) ||
			(domElement == nodeWidget.expandoNode || domElement == nodeWidget.expandoNodeText) ){
			// expando node was clicked, or label of a folder node was clicked; open it
			if(nodeWidget.isExpandable){
				this._onExpandoClick({node:nodeWidget});
			}
		}else{
			this._publish("execute", { item: nodeWidget.item, node: nodeWidget, evt: e } );
			this.onClick(nodeWidget.item, nodeWidget, e);
			this.focusNode(nodeWidget);
		}
		dojo.stopEvent(e);
	},
	_onDblClick: function(/*TreeNode*/ nodeWidget, /*Event*/ e){
		// summary:
		//		Translates double-click events into commands for the controller to process

		var domElement = e.target;

		if( (this.openOnDblClick && nodeWidget.isExpandable) ||
			(domElement == nodeWidget.expandoNode || domElement == nodeWidget.expandoNodeText) ){
			// expando node was clicked, or label of a folder node was clicked; open it
			if(nodeWidget.isExpandable){
				this._onExpandoClick({node:nodeWidget});
			}
		}else{
			this._publish("execute", { item: nodeWidget.item, node: nodeWidget, evt: e } );
			this.onDblClick(nodeWidget.item, nodeWidget, e);
			this.focusNode(nodeWidget);
		}
		dojo.stopEvent(e);
	},

	_onExpandoClick: function(/*Object*/ message){
		// summary:
		//		User clicked the +/- icon; expand or collapse my children.
		var node = message.node;

		// If we are collapsing, we might be hiding the currently focused node.
		// Also, clicking the expando node might have erased focus from the current node.
		// For simplicity's sake just focus on the node with the expando.
		this.focusNode(node);

		if(node.isExpanded){
			this._collapseNode(node);
		}else{
			this._expandNode(node);
		}
	},

	onClick: function(/* dojo.data */ item, /*TreeNode*/ node, /*Event*/ evt){
		// summary:
		//		Callback when a tree node is clicked
		// tags:
		//		callback
	},
	onDblClick: function(/* dojo.data */ item, /*TreeNode*/ node, /*Event*/ evt){
		// summary:
		//		Callback when a tree node is double-clicked
		// tags:
		//		callback
	},
	onOpen: function(/* dojo.data */ item, /*TreeNode*/ node){
		// summary:
		//		Callback when a node is opened
		// tags:
		//		callback
	},
	onClose: function(/* dojo.data */ item, /*TreeNode*/ node){
		// summary:
		//		Callback when a node is closed
		// tags:
		//		callback
	},

	_getNextNode: function(node){
		// summary:
		//		Get next visible node

		if(node.isExpandable && node.isExpanded && node.hasChildren()){
			// if this is an expanded node, get the first child
			return node.getChildren()[0];		// _TreeNode
		}else{
			// find a parent node with a sibling
			while(node && node.isTreeNode){
				var returnNode = node.getNextSibling();
				if(returnNode){
					return returnNode;		// _TreeNode
				}
				node = node.getParent();
			}
			return null;
		}
	},

	_getRootOrFirstNode: function(){
		// summary:
		//		Get first visible node
		return this.showRoot ? this.rootNode : this.rootNode.getChildren()[0];
	},

	_collapseNode: function(/*_TreeNode*/ node){
		// summary:
		//		Called when the user has requested to collapse the node

		if(node._expandNodeDeferred){
			delete node._expandNodeDeferred;
		}

		if(node.isExpandable){
			if(node.state == "LOADING"){
				// ignore clicks while we are in the process of loading data
				return;
			}

			node.collapse();
			this.onClose(node.item, node);

			if(node.item){
				this._state(node.item,false);
				this._saveState();
			}
		}
	},

	_expandNode: function(/*_TreeNode*/ node, /*Boolean?*/ recursive){
		// summary:
		//		Called when the user has requested to expand the node
		// recursive:
		//		Internal flag used when _expandNode() calls itself, don't set.
		// returns:
		//		Deferred that fires when the node is loaded and opened and (if persist=true) all it's descendants
		//		that were previously opened too

		if(node._expandNodeDeferred && !recursive){
			// there's already an expand in progress (or completed), so just return
			return node._expandNodeDeferred;	// dojo.Deferred
		}

		var model = this.model,
			item = node.item,
			_this = this;

		switch(node.state){
			case "UNCHECKED":
				// need to load all the children, and then expand
				node.markProcessing();

				// Setup deferred to signal when the load and expand are finished.
				// Save that deferred in this._expandDeferred as a flag that operation is in progress.
				var def = (node._expandNodeDeferred = new dojo.Deferred());

				// Get the children
				model.getChildren(
					item,
					function(items){
						node.unmarkProcessing();

						// Display the children and also start expanding any children that were previously expanded
						// (if this.persist == true).   The returned Deferred will fire when those expansions finish.
						var scid = node.setChildItems(items);

						// Call _expandNode() again but this time it will just to do the animation (default branch).
						// The returned Deferred will fire when the animation completes.
						// TODO: seems like I can avoid recursion and just use a deferred to sequence the events?
						var ed = _this._expandNode(node, true);

						// After the above two tasks (setChildItems() and recursive _expandNode()) finish,
						// signal that I am done.
						scid.addCallback(function(){
							ed.addCallback(function(){
								def.callback();
							})
						});
					},
					function(err){
						console.error(_this, ": error loading root children: ", err);
					}
				);
				break;

			default:	// "LOADED"
				// data is already loaded; just expand node
				def = (node._expandNodeDeferred = node.expand());

				this.onOpen(node.item, node);

				if(item){
					this._state(item, true);
					this._saveState();
				}
		}

		return def;	// dojo.Deferred
	},

	////////////////// Miscellaneous functions ////////////////

	focusNode: function(/* _tree.Node */ node){
		// summary:
		//		Focus on the specified node (which must be visible)
		// tags:
		//		protected

		// set focus so that the label will be voiced using screen readers
		dijit.focus(node.labelNode);
	},

	_onNodeFocus: function(/*dijit._Widget*/ node){
		// summary:
		//		Called when a TreeNode gets focus, either by user clicking
		//		it, or programatically by arrow key handling code.
		// description:
		//		It marks that the current node is the selected one, and the previously
		//		selected node no longer is.

		if(node){
			if(node != this.lastFocused && this.lastFocused && !this.lastFocused._destroyed){
				// mark that the previously selected node is no longer the selected one
				this.lastFocused.setSelected(false);
			}

			// mark that the new node is the currently selected one
			node.setSelected(true);
			this.lastFocused = node;
		}
	},

	_onNodeMouseEnter: function(/*dijit._Widget*/ node){
		// summary:
		//		Called when mouse is over a node (onmouseenter event)
	},

	_onNodeMouseLeave: function(/*dijit._Widget*/ node){
		// summary:
		//		Called when mouse is over a node (onmouseenter event)
	},

	//////////////// Events from the model //////////////////////////

	_onItemChange: function(/*Item*/ item){
		// summary:
		//		Processes notification of a change to an item's scalar values like label
		var model = this.model,
			identity = model.getIdentity(item),
			nodes = this._itemNodesMap[identity];

		if(nodes){
			var self = this;
			dojo.forEach(nodes,function(node){
				node.attr({
					label: self.getLabel(item),
					tooltip: self.getTooltip(item)
				});
				node._updateItemClasses(item);
			});
		}
	},

	_onItemChildrenChange: function(/*dojo.data.Item*/ parent, /*dojo.data.Item[]*/ newChildrenList){
		// summary:
		//		Processes notification of a change to an item's children
		var model = this.model,
			identity = model.getIdentity(parent),
			parentNodes = this._itemNodesMap[identity];

		if(parentNodes){
			dojo.forEach(parentNodes,function(parentNode){
				parentNode.setChildItems(newChildrenList);
			});
		}
	},

	_onItemDelete: function(/*Item*/ item){
		// summary:
		//		Processes notification of a deletion of an item
		var model = this.model,
			identity = model.getIdentity(item),
			nodes = this._itemNodesMap[identity];

		if(nodes){
			dojo.forEach(nodes,function(node){
				var parent = node.getParent();
				if(parent){
					// if node has not already been orphaned from a _onSetItem(parent, "children", ..) call...
					parent.removeChild(node);
				}
				node.destroyRecursive();
			});
			delete this._itemNodesMap[identity];
		}
	},

	/////////////// Miscellaneous funcs

	_initState: function(){
		// summary:
		//		Load in which nodes should be opened automatically
		if(this.persist){
			var cookie = dojo.cookie(this.cookieName);
			this._openedItemIds = {};
			if(cookie){
				dojo.forEach(cookie.split(','), function(item){
					this._openedItemIds[item] = true;
				}, this);
			}
		}
	},
	_state: function(item,expanded){
		// summary:
		//		Query or set expanded state for an item,
		if(!this.persist){
			return false;
		}
		var id=this.model.getIdentity(item);
		if(arguments.length === 1){
			return this._openedItemIds[id];
		}
		if(expanded){
			this._openedItemIds[id] = true;
		}else{
			delete this._openedItemIds[id];
		}
	},
	_saveState: function(){
		// summary:
		//		Create and save a cookie with the currently expanded nodes identifiers
		if(!this.persist){
			return;
		}
		var ary = [];
		for(var id in this._openedItemIds){
			ary.push(id);
		}
		dojo.cookie(this.cookieName, ary.join(","), {expires:365});
	},

	destroy: function(){
		if(this._curSearch){
			clearTimeout(this._curSearch.timer);
			delete this._curSearch;
		}
		if(this.rootNode){
			this.rootNode.destroyRecursive();
		}
		if(this.dndController && !dojo.isString(this.dndController)){
			this.dndController.destroy();
		}
		this.rootNode = null;
		this.inherited(arguments);
	},

	destroyRecursive: function(){
		// A tree is treated as a leaf, not as a node with children (like a grid),
		// but defining destroyRecursive for back-compat.
		this.destroy();
	},

	resize: function(changeSize){
		if(changeSize){
			dojo.marginBox(this.domNode, changeSize);
			dojo.style(this.domNode, "overflow", "auto");	// for scrollbars
		}

		// The only JS sizing involved w/tree is the indentation, which is specified
		// in CSS and read in through this dummy indentDetector node (tree must be
		// visible and attached to the DOM to read this)
		this._nodePixelIndent = dojo.marginBox(this.tree.indentDetector).w;

		if(this.tree.rootNode){
			// If tree has already loaded, then reset indent for all the nodes
			this.tree.rootNode.attr('indent', this.showRoot ? 0 : -1);
		}
	},

	_createTreeNode: function(/*Object*/ args){
		// summary:
		//		creates a TreeNode
		// description:
		//		Developers can override this method to define their own TreeNode class;
		//		However it will probably be removed in a future release in favor of a way
		//		of just specifying a widget for the label, rather than one that contains
		//		the children too.
		return new dijit._TreeNode(args);
	}
});

// For back-compat.  TODO: remove in 2.0



}

if(!dojo._hasResource['epages.validate.string']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.validate.string'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.validate.string $Revision: 1.4 $

*/
dojo.provide('epages.validate.string');

epages.validate.string.isXMLAttribute = function(attributeName) {
	if (attributeName == ''){
		return false;
	}

	// reference http://www.w3.org/TR/REC-xml/#NT-Name
	var XML_SYNTAX_BaseChar      = "[\u0041-\u005A\u0061-\u007A\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u00FF\u0100-\u0131\u0134-\u013E\u0141-\u0148\u014A-\u017E\u0180-\u01C3\u01CD-\u01F0\u01F4-\u01F5\u01FA-\u0217\u0250-\u02A8\u02BB-\u02C1\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03CE\u03D0-\u03D6\u03DA\u03DC\u03DE\u03E0\u03E2-\u03F3\u0401-\u040C\u040E-\u044F\u0451-\u045C\u045E-\u0481\u0490-\u04C4\u04C7-\u04C8\u04CB-\u04CC\u04D0-\u04EB\u04EE-\u04F5\u04F8-\u04F9\u0531-\u0556\u0559\u0561-\u0586\u05D0-\u05EA\u05F0-\u05F2\u0621-\u063A\u0641-\u064A\u0671-\u06B7\u06BA-\u06BE\u06C0-\u06CE\u06D0-\u06D3\u06D5\u06E5-\u06E6\u0905-\u0939\u093D\u0958-\u0961\u0985-\u098C\u098F-\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09DC-\u09DD\u09DF-\u09E1\u09F0-\u09F1\u0A05-\u0A0A\u0A0F-\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32-\u0A33\u0A35-\u0A36\u0A38-\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8B\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2-\u0AB3\u0AB5-\u0AB9\u0ABD\u0AE0\u0B05-\u0B0C\u0B0F-\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32-\u0B33\u0B36-\u0B39\u0B3D\u0B5C-\u0B5D\u0B5F-\u0B61\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99-\u0B9A\u0B9C\u0B9E-\u0B9F\u0BA3-\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB5\u0BB7-\u0BB9\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C60-\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CDE\u0CE0-\u0CE1\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D28\u0D2A-\u0D39\u0D60-\u0D61\u0E01-\u0E2E\u0E30\u0E32-\u0E33\u0E40-\u0E45\u0E81-\u0E82\u0E84\u0E87-\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA-\u0EAB\u0EAD-\u0EAE\u0EB0\u0EB2-\u0EB3\u0EBD\u0EC0-\u0EC4\u0F40-\u0F47\u0F49-\u0F69\u10A0-\u10C5\u10D0-\u10F6\u1100\u1102-\u1103\u1105-\u1107\u1109\u110B-\u110C\u110E-\u1112\u113C\u113E\u1140\u114C\u114E\u1150\u1154-\u1155\u1159\u115F-\u1161\u1163\u1165\u1167\u1169\u116D-\u116E\u1172-\u1173\u1175\u119E\u11A8\u11AB\u11AE-\u11AF\u11B7-\u11B8\u11BA\u11BC-\u11C2\u11EB\u11F0\u11F9\u1E00-\u1E9B\u1EA0-\u1EF9\u1F00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2126\u212A-\u212B\u212E\u2180-\u2182\u3041-\u3094\u30A1-\u30FA\u3105-\u312C\uAC00-\uD7A3]";
	var XML_SYNTAX_Ideographic   = "[\u4E00-\u9FA5\u3007\u3021-\u3029]";
	var XML_SYNTAX_CombiningChar = "[\u0300-\u0345\u0360-\u0361\u0483-\u0486\u0591-\u05A1\u05A3-\u05B9\u05BB-\u05BD\u05BF\u05C1-\u05C2\u05C4\u064B-\u0652\u0670\u06D6-\u06DC\u06DD-\u06DF\u06E0-\u06E4\u06E7-\u06E8\u06EA-\u06ED\u0901-\u0903\u093C\u093E-\u094C\u094D\u0951-\u0954\u0962-\u0963\u0981-\u0983\u09BC\u09BE\u09BF\u09C0-\u09C4\u09C7-\u09C8\u09CB-\u09CD\u09D7\u09E2-\u09E3\u0A02\u0A3C\u0A3E\u0A3F\u0A40-\u0A42\u0A47-\u0A48\u0A4B-\u0A4D\u0A70-\u0A71\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0B01-\u0B03\u0B3C\u0B3E-\u0B43\u0B47-\u0B48\u0B4B-\u0B4D\u0B56-\u0B57\u0B82-\u0B83\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0C01-\u0C03\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55-\u0C56\u0C82-\u0C83\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5-\u0CD6\u0D02-\u0D03\u0D3E-\u0D43\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0EB1\u0EB4-\u0EB9\u0EBB-\u0EBC\u0EC8-\u0ECD\u0F18-\u0F19\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86-\u0F8B\u0F90-\u0F95\u0F97\u0F99-\u0FAD\u0FB1-\u0FB7\u0FB9\u20D0-\u20DC\u20E1\u302A-\u302F\u3099\u309A]";
	var XML_SYNTAX_Digit         = "[\u0030-\u0039\u0660-\u0669\u06F0-\u06F9\u0966-\u096F\u09E6-\u09EF\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0BE7-\u0BEF\u0C66-\u0C6F\u0CE6-\u0CEF\u0D66-\u0D6F\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F29]";
	var XML_SYNTAX_Extender      = "[\u00B7\u02D0\u02D1\u0387\u0640\u0E46\u0EC6\u3005\u3031-\u3035\u309D-\u309E\u30FC-\u30FE]";
	var XML_SYNTAX_Letter        = XML_SYNTAX_BaseChar + "|" + XML_SYNTAX_Ideographic;
	var XML_SYNTAX_NameChar      = XML_SYNTAX_Letter + "|" + XML_SYNTAX_Digit + "|[-._:]|" + XML_SYNTAX_CombiningChar + "|" + XML_SYNTAX_Extender;
	var XML_SYNTAX_Name          = "^(" + XML_SYNTAX_Letter + "|[_:])" + "(" + XML_SYNTAX_NameChar + ")*$";

	return attributeName.match( new RegExp( XML_SYNTAX_Name ) ) ? true : false;
};
epages.validate.string.filterInvalidChars = function(/*string*/ insertString){
	// summary: removes invalid chars from given string
   // description: function removes invalid chars or combination of chars from given string
   // remove all backslashes can cause errors on the server
   // example:
   //    var result = epages.validate.string.filterInvalidChars('Affe/\Ente');
   // returns:  Affe/Ente
	var regExpString = /%5C/gi;
	insertString = encodeURIComponent(insertString);
	var returnString = insertString.replace(regExpString,'');
	returnString = decodeURIComponent(returnString);
	return returnString;
};

}

if(!dojo._hasResource['epages.widget.NumberSpinner']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.widget.NumberSpinner'] = true;
/*
	Copyright (c) 2006-2009, ePages GmbH
	All Rights Reserved.
*/
dojo.provide('epages.widget.NumberSpinner');






dojo.declare("epages.widget.NumberSpinner",
	[dijit._Widget,dijit._Templated], {

/**
 * public properties
 */
	name         : "",
	value        : "",				// String - parameter start value
	minValue     : "0",				// String - parameter minimal value, no spinning under this value
	maxValue     : Number.MAX_VALUE.toString(),				// String - parameter maximal value, no spinning upper this value
	delta        : "0",				// String - parameter for counting steps
	trimInterval : "false",		// String - trim value to next interval step
	unit         : "",				// String - parameter for number devices
/**
 * private
 */
	_spinTimeout:           null, // windowTimoutHandle  timeout that holds the spinning function repetition (hold-down mouse key)
	_spinCounter:           0,    // Integer - counts the spins by the held-down mouse key to determine spinning speed
	_spinIntervalFunction:  null, // function - reference of the spinning function

/**
 * widget properties
 */
	templateString:"<span class=\"NumberSpinner EnableHover\">\n\n  <span class=\"InputFieldContainer\">\n    <input dojoAttachPoint=\"fakeNode\" type=\"text\" class=\"FakedInput\" unselectable=\"on\" />\n    <span dojoAttachPoint=\"containerNode\" class=\"Container\">\n      <input dojoAttachPoint=\"inputNode\" type=\"text\" class=\"RealInput\" value=\"${value}\" name=\"${name}\" />\n      <span dojoAttachPoint=\"unitNode\" class=\"InputFieldUnit\" unselectable=\"on\" style=\"display:none\">${unit}</span>\n    </span>\n  </span>\n\n  <span class=\"ButtonWrapper\">\n    <span class=\"NumberSpinnerButton\">\n      <span dojoAttachPoint=\"upNode\"   class=\"NumberSpinnerUpArrow EnableHover\"></span>\n      <span dojoAttachPoint=\"downNode\" class=\"NumberSpinnerDownArrow EnableHover\"></span>\n    </span>\n  </span>\n</span>\n\n\n",

	postCreate : function() {
		this.inherited("postCreate", arguments);
		// variables to fade in and out the number devices
		var borderWidth = this.fakeNode.clientLeft; 		// set var to element left border
		var left = borderWidth+40;											// set var from left (border + 40px)
		var borderHeight = this.fakeNode.clientTop;			// set var to element top border
		this.containerNode.style.top=borderHeight+"px";	// set top border to element
		this.unitNode.style.left=left+"px";							// set distance from left
		// show element with css, if set the variable
		if(this.unit != "") {
			this.unitNode.style.display="";
		}
		// calculate the fake input element width
		var width = this.unitNode.clientWidth + 40;
		this.fakeNode.style.width=width+"px"; // set input container width if unit is displayed

		// button user functions
		this.connect(this.inputNode, 'onkeyup', 'onKeyUp');

		// round time to closest possible position
		this.connect(this.upNode,   'mouseup', 'onMouseUp');
		this.connect(this.downNode, 'mouseup', 'onMouseUp');
		this.connect(this.upNode,   'mouseout', 'onMouseUp');
		this.connect(this.downNode, 'mouseout', 'onMouseUp');
		this.connect(this.upNode,   'mousedown', 'onMouseDown');
		this.connect(this.downNode, 'mousedown', 'onMouseDown');

		this.value = epages.localize.parseNumber(this.value);
		this.minValue = epages.localize.parseNumber(this.minValue);
		this.maxValue = epages.localize.parseNumber(this.maxValue);
		this.delta = epages.localize.parseNumber(this.delta);

		if(isNaN(this.value)) {
			console.warn("Value is not a Number in "+this.declaredClass);
		}

		if(isNaN(this.minValue)) {
			console.warn("minValue is not a Number in "+this.declaredClass);
		}

		if(isNaN(this.maxValue)) {
			console.warn("maxValue is not a Number in "+this.declaredClass);
		}

		if(this.value < this.minValue) {
			this.value = this.minValue ;
			this.updateInputNode();
			console.warn("value is smaller than minValue "+this.declaredClass);
		}

		if(this.value > this.maxValue) {
			this.value = this.maxValue ;
			this.updateInputNode();
			console.warn("value is larger than maxValue "+this.declaredClass);
		}

		this.trimInterval = epages.string.toBoolean(this.trimInterval);
	},

	updateInputNode : function() {
		this.inputNode.value = epages.localize.formatNumber(this.value);
	},

	spin : function(/* integer */ direction) {
		// summary:
		//    spin the value by delta
		// direction: 
		//   | if > 0, spin up
		//   | if < 0, spin down
		//   | if = 0, do nothing

		// only spin, if number and direction are valid
			if (direction == 0){
				return;
			}

			if (direction > 0) {
				if(this.trimInterval) {
					// add and trim delta to interval
					var value = this.value + this.delta;
					var factor = Math.round((value-this.minValue)/this.delta);
					this.value = this.minValue+factor*this.delta;
				} else {
					// just add delta
					this.value = this.value + this.delta;
				}
				if (this.value > this.maxValue ) {
						this.value = this.maxValue;
				}  // endif check maxValue
			} else if (direction < 0) {
					if(this.trimInterval) {
						// substract and trim delta to interval
						var value = this.value - this.delta;
						var factor = Math.round((value-this.minValue)/this.delta);
						this.value = this.minValue+factor*this.delta;
					} else {
						// just substract delta from value
							this.value = this.value - this.delta;
					} // endif trim to interval

					if (this.value < this.minValue ) {
							this.value = this.minValue;
					}  // endif check minValue
			}
			this.updateInputNode();
	},

	onMouseDown: function(evt) {
		// summary:
		//    handle mousedowns on the spinner arrows
		var direction;
		if (evt.target == this.upNode) {
			direction = 1;
		} else if(evt.target == this.downNode) {
			direction = -1;
		} else {
			return;
		}
		this._spinIntervalFunction = dojo.hitch(this, function() {
			var speed = this._spinCounter > 5 ? this._spinCounter > 25 ? 25 : 55 : 200;
			this.spin(direction);
			this._spinCounter++;
			window.clearTimeout(this._spinTimeout);
			this._spinTimeout = undefined;
			this._spinTimeout = window.setTimeout(this._spinIntervalFunction, speed);
		});
		this._spinIntervalFunction();
	},

	onMouseUp: function() {
		// summary:
		//    stop spinning
		if(this._spinCounter){
			epages.event.fire(this.inputNode, 'change');
		}
		this._spinCounter = 0;
		window.clearTimeout(this._spinTimeout);
	},

	valueUp : function(){
		// summary: Count inputNode value up
		this.spin(1);
	},

	valueDown : function() {
		this.spin(-1);
	},

	onKeyUp : function() {
		// summary: pass input value changes to widget value on keyup
		var value = epages.localize.parseNumber(this.inputNode.value);
		if(isNaN(value)) {
			console.warn("Value is not a Number in onKeyup in "+this.declaredClass);
		} else {
			this.value = value;
		}
	}

});


}

if(!dojo._hasResource["epages.widget.CoverFlow"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.CoverFlow"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.widget.CoverFlow $Revision: 1.5 $

*/
dojo.provide("epages.widget.CoverFlow");



dojo.declare("epages.widget.CoverFlow", [dijit._Widget], {

	imageData: [], /* public array for ExternalInterface access */
	coverFlowModuleSrc: dojo.moduleUrl('epages.widget', "templates/CoverFlow.swf"), // + "?" + String(Math.floor(Math.random()*9999)),

	_titleAttr: null,
	_currentWidth: 0,

	_buildCoverFlow: function() {
		this.srcNodeRef.title = this._titleAttr;
		this.srcNodeRef.innerHTML = "<object name='" + this.id + "_flash' id='" + this.id + "_flash' type='application/x-shockwave-flash' data='" + this.coverFlowModuleSrc + "'><param name='movie' value='" + this.coverFlowModuleSrc + "'/><param name='allowscriptaccess' value='always'/><param name='wmode' value='transparent'/></object>";
	},

	constructor: function() {
		this.imageData = [];
	},

	postMixInProperties: function() {
		var sourceNodes = dojo.query("a", this.srcNodeRef);
		for( var i=0,iLength=sourceNodes.length ; i<iLength ; i++ ) {
			var imageNode = sourceNodes[i].getElementsByTagName("img")[0];
			this.imageData.push([
				imageNode.getAttribute("src"),
				imageNode.getAttribute("longdesc"),
				epages.vars.BaseUrl + sourceNodes[i].getAttribute("href"),
				epages.vars.BaseUrl + sourceNodes[i].getAttribute("href2"),
				(imageNode.getAttribute("ismap") ? true : false)
			]);
		}
		dojo.addClass(this.srcNodeRef, "HideElement");
	},

	postCreate: function() {
		this._titleAttr = this.srcNodeRef.title;
		setTimeout(dojo.hitch(this, function() {
			if(epages.Browser.flashVersion > 9) {
				if(this.imageData.length > 1) {
					this._buildCoverFlow();
					dojo.addClass(this.srcNodeRef, "Flashed");
					dojo.removeClass(this.srcNodeRef, "HideElement");
					this._currentWidth = this.srcNodeRef.offsetWidth;
					setInterval(dojo.hitch(this, function() {
						if(this._currentWidth != this.domNode.offsetWidth) {
							this._currentWidth = this.domNode.offsetWidth;
							this._buildCoverFlow();
						}
					}), 200);
				}else {
					dojo.removeClass(this.srcNodeRef, "HideElement");
					this.srcNodeRef.style.textAlign = "center";
					this.srcNodeRef.style.overflow = "hidden";
				}
			}else {
				dojo.removeClass(this.srcNodeRef, "HideElement");
			}
		}), 1);
	}

});

}

if(!dojo._hasResource['epages.widget.Slider']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.widget.Slider'] = true;
/*
	Copyright (c) 2006-2008, ePages GmbH
	All Rights Reserved.

	epages.widget.Slider $Revision: 1.12 $

*/
dojo.provide('epages.widget.Slider');



dojo.declare("epages.widget.Slider", [dijit._Widget,dijit._Templated], {
	timerLeft         : null,
	timerRight        : null,
	slideSpeed        : 0,
	currentWidth      : 0,   // Integer - total width of the container that holds all images
	menuWidth         : 0,   // Integer - width of the visible part of the slider
	currentMoveState  : '',  // String - current State of Animation, left, right or empty
	maxSpeed          : 15,  // Integer - max Speed of Animation on the End of the Slider increase to speed up Slider
	totalOffsetLeft   : 0,   // Integer - total Offset of the Slider to the left side of the browser

	templateString:"<div class=\"ImageSlide\">\n  <div dojoAttachPoint=\"crossSlide\"><nobr dojoAttachPoint=\"containerNode\"></nobr></div>\n</div>\n",

	postCreate: function() {
		this.inherited("postCreate", arguments);
		// summary: standard init routine
		// description: Link needed events to appropriate functions
		// 		and set all global variables needed in other functions.
		//		Also hide the horizontal fallback scrollbar and revise
		//		the height of the main element.
		//
		//		An Image Slide frame must look like this:
		//		...and YES, every char has a purpose!
		//		E. g. to ensure a fallback alternative for
		//		people without javascript.
		//		for a detailed example look at the SliderTest.html
		// example:
		//	|	<div dojoType="epages.widget.Slider" maxSpeed="50" class="ImageSlide">
		//	|		<nobr style="width:50px"> //total Width of Container width of picture * number of pictures
		//	|		      <a href="#go">
		//	|		        <img src="pic1.gif"/>
		//	|		      </a>
		//	|		      <a href="#go">
		//	|		        <img src="pic2.gif"/>
		//	|		      </a>
		//	|		      <a href="#go">
		//	|		        <img src="pic3.gif"/>
		//	|		      </a>
		//	|					...
		//	|		    </nobr>
		//	|	</div>
		this.connect(window, 'onresize', '_arrangeResizedDocument');
		this.domNode.style.overflow = 'hidden';
		this.domNode.style.height = this.crossSlide.offsetHeight+'px';
		this.menuWidth = this.domNode.offsetWidth;
		var crossSlideWidth = (this.crossSlide.style.width != "") ? parseInt(this.crossSlide.style.width) : 0;
		this.currentWidth = this.crossSlide.offsetWidth? this.crossSlide.offsetWidth : crossSlideWidth;
		this.crossSlide.style.left = 0;
		this.totalOffsetLeft = this.domNode.offsetLeft;
		this._appendEvents();
	},

	_appendEvents: function() {
		this.connect(this.domNode,'onmousemove', '_doMotion');
		this.connect(this.domNode,'onmouseout', '_stopMotion');
	},

	_updateAfterEvent: function() {
		// summary: update the image slide line
		// description: We must force the css engine of some browsers
		//    to refresh the style on the whole image slide.
		//    Otherwise the styles will not be updated and e. g.
		//    the :hover class misfires for all prior invisible images.
		// example:
		//  |  _updateAfterEvent();
		this.domNode.style.clear = 'both';
		this.domNode.style.clear = 'none';
	},

	_moveLeft: function() {
		// summary: move the image line inside the container to the left
		// description: First we check if it is necessary to move the
		//		image line and if "yes" we move it as long the cursor indicates
		//    that it should move. To not confuse other functions we state
		//		that we are currently really moving it to the left. MOVE!
		// example:
		//  | _moveLeft();
		this.currentMoveState = 'left';
		if(parseInt(this.crossSlide.style.left) > (this.menuWidth - this.currentWidth)){
			this.crossSlide.style.left = parseInt(this.crossSlide.style.left) - this.slideSpeed + 'px';
		}
		this.timerLeft = setTimeout(epages.lang.hitch(this, this._moveLeft), 10);
	},

	_moveRight: function(){
		// summary: move the image line inside the container to the rights
		// description: First we check if it is necessary to move the
		//		image line and if "yes" we move it as long the cursor indicates
		//    that it should move. To not confuse other functions we state
		//		that we are currently really moving it to the right. MOVE!
		// example:
		//  | _moveRight();
		this.currentMoveState = 'right';
		if(parseInt(this.crossSlide.style.left) < 0){
			this.crossSlide.style.left = parseInt(this.crossSlide.style.left) + this.slideSpeed + 'px';
		}
		this.timerRight = setTimeout(epages.lang.hitch(this, this._moveRight), 10);
	},

	_doMotion: function(/*Object?*/ mouseEvent){
		// summary: the heart of our sliding effect
		// description: It does all the stuff like calculating the speed of
		//		the image slide, observing the cursor for new motions and
		//		initiating the move[...]() functions.
		// example:
		//  | mynode.onmousemove = function(mouseEvent){
		//  |   _doMotion(mouseEvent);
		//  |   _updateAfterEvent();
		//  | }
		var mouseXPoint = mouseEvent.clientX;
		var currentYPosition = mouseEvent.clientX - this.totalOffsetLeft;
		var edgeBound = (this.menuWidth / 2);
		if (currentYPosition > edgeBound){
			this.slideSpeed = (currentYPosition - edgeBound) / this.menuWidth / 2 * this.maxSpeed;
			clearTimeout(this.timerRight);
			if (this.currentMoveState != 'left'){
				this._moveLeft();
			}
		} else if (currentYPosition < edgeBound){
			this.slideSpeed = (edgeBound - currentYPosition) / this.menuWidth / 2 * this.maxSpeed;;
			clearTimeout(this.timerLeft);
			if (this.currentMoveState != 'right'){
			this._moveRight();
			}
		}else{
			this.slideSpeed = 0;
		}
	},

	_stopMotion: function(/*Object?*/ mouseEvent){
		// summary: stops all slide motions
		// description: If called with a mouse position where the slide
		//    should be stopped - we have to immediately clear all
		//		active timeouts that would call the move[...] functions.
		//		Furthermore we state that there is no motion active anymore.
		// example:
		//  | mynode.onmouseout = function(mouseEvent){
		//  |   _stopMotion(mouseEvent);
		//  |   _updateAfterEvent();
		//  | }
		if ((window.event && !this.domNode.contains(event.toElement)) || (mouseEvent && mouseEvent.currentTarget && mouseEvent.currentTarget!= mouseEvent.relatedTarget && !this._checkNode(mouseEvent.currentTarget, mouseEvent.relatedTarget))){
			clearTimeout(this.timerLeft);
			clearTimeout(this.timerRight);
			this.currentMoveState = "";
		}
	},

	_checkNode: function(/*Object?*/ currentTarget, /*Object?*/ relatedTarget) {
		// summary: check if we are in the right element
		// description: Naturally there is one browser that behaves unintentional.
		//		This time nearly all browsers fail. Without this routine
		//		Firefox would refer the mousemove event to every single image
		//		(the motion would only start if the cursor points an image).
		//		Netscape would inherit the mousemove event to the whole
		//		document body and the Internet Explorer would produce sensless
		//		error messages because it does not know the attribute.
		// example:
		//  |  var canIPleaseKillTheTimout = _checkNode(currentTarget, relatedTarget);
		if (relatedTarget !== null){
			while (relatedTarget.parentNode){
				relatedTarget = relatedTarget.parentNode;
				if (relatedTarget == currentTarget){
					return true; // Boolean
				}
			}
		}
	},

	_arrangeResizedDocument: function() {
		// summary: adjust the whole thing on window resizing
		// description: We have to resize and realign the slide
		//		if the size of the browser window changes.
		// example:
		//  | window.onresize = _arrangeResizedDocument;
		this.menuWidth = this.domNode.offsetWidth;
		this.crossSlide.style.left = this.menuWidth - this.currentWidth + 'px';
	}
});

}

if(!dojo._hasResource["epages.widget.Timeselector"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Timeselector"] = true;
dojo.provide("epages.widget.Timeselector");




dojo.declare(
	"epages.widget.Timeselector",
	[dijit._Widget, dijit._Templated],
	{

		/**
		 * public properties
		 */
		templateString:"<div class=\"Timeselector\">\n  <div class=\"Date\" dojoAttachPoint=\"dateNode\">\n\n  </div>\n  <div class=\"TimesContainer\" dojoAttachPoint=\"timesContainerNode\">\n    <div class=\"Times\" dojoAttachpoint=\"timesNode\">\n    </div>\n  </div>\n</div>\n",
		delta:     '5', // String - increment is 5 minutes by default
		value:     '',

		_selected: undefined,

		valuePattern:   epages.vars.Locale.datetimeFormat || "%d.%m.%y %H:%M", // String - epages datetime pattern
		displayPattern: epages.vars.Locale.timeFormat     || "%H:%M", // String - epages time pattern

		postMixInProperties: function() {
			// create dojo datetime pattern
			if (typeof this.value == 'string'){
				this.value = epages.localize.parseDateTime(this.value, this.valuePattern);
			}
			if (typeof this.delta == 'string'){
				this.delta = new Number(this.delta);
			}
			if (this.delta<=0){
				this.delta=30;
			}
		},

		postCreate: function() {
			this.inherited('postCreate', arguments);
			var date = this.value;
			this.value = null;
			this.setValue('value',date);
		},

		getValue: function() {
			// summary:
			//    returns the value as a date object, day is 1970-01-01
			return this.value;
		},

		setValue: function(/*Date*/date) {
			if (date === undefined){
				date = new Date();
			}else if (typeof date == "string"){
				date = epages.localize.parseDateTime(date, this.valuePattern);
			}

			if(!this.value || dojo.date.compare(date, this.value)){
				this.value = new Date(date);
				this.fillTimes(date);
				this.domNode.value = date == null ? undefined : date.valueOf();
			}
			if(this.value){
				this.dateNode.innerHTML = epages.localize.formatDateTime(this.value);
			}
		},

		fillTimes: function (date) {
			// summary: fill new options
			var date = new Date(this.value);
			date.setHours(0,0,0,0);
			this.dateNode.innerHTML = epages.localize.formatDateTime(date);
			var end = dojo.date.add(date, 'day', 1);
			var dates = [];
			while (date<end) {
				dates.push(date);
				date = dojo.date.add(date,'minute',this.delta);
			}
			this.setTimes(dates);
		},

		setTimes: function (opts) {
			this.dateNode.innerHTML = epages.localize.formatDateTime(this.value);
			var node = this.timesNode;
			// remove children
			while(node.firstChild){ node.removeChild(node.firstChild); }
			// add new options
			var lastCompare = undefined;
			var selected = false;
			var alternate = 0;
			dojo.forEach(opts, function (date) {
				o=document.createElement("div");
				o.innerHTML = epages.localize.formatDateTime(date, this.displayPattern);
				o.setAttribute('value',date.valueOf());
				if (!dojo.date.compare(this.value, date)){
					dojo.addClass(o,'Selected');
					this._selected = o;
					selected = true;
				}
				if(lastCompare == 1 && dojo.date.compare(this.value, date) == -1){
					dojo.addClass(o,'Selected');
					this._selected = o;
					this.value = date;
					selected = true;
				}
				lastCompare = dojo.date.compare(this.value, date);
				if(alternate){
					dojo.addClass(o,'Alternate');
				}
				node.appendChild(o);
				this.connect(o,'onclick', 'onChange');
				alternate=1-alternate;
			}, this);
			if(selected == false && lastCompare){
				if(lastCompare == 1){
					node.lastChild.selected = true;
					dojo.addClass(node.lastChild,'Selected');
					this._selected = node.lastChild;
					this.value = opts[opts.length-1];
				}
				else{
					dojo.addClass(node.firstChild,'Selected');
					this._selected = node.firstChild;
					node.firstChild.selected = true;
					this.value = opts[0];
				}
			}
		},

		onChange: function (evt) {
			var target = evt.currentTarget;
			dojo.removeClass(this._selected,'Selected');
			dojo.addClass(target,'Selected');
			this._selected = target;
			this.value = new Date(Number(target.getAttribute('value')));
			dojo.publish(this.id + '/onChange', [this.value]);
		}
	}
);

}

if(!dojo._hasResource['epages.widget.FormElementHint']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.widget.FormElementHint'] = true;
/*
	Copyright (c) 2006-2010, ePages GmbH
	All Rights Reserved.

	epages.html.formelementhin $Revision: 1.8 $
*/
dojo.provide('epages.widget.FormElementHint');


dojo.declare("epages.widget.FormElementHint", [dijit._Widget], {

		/**
		 * public properties
		 */
		description             : "",	// String - the description text used as innerHTML for the hint

		/**
		 * private properties
		 */
		_formDescriptionLayer   : null, // DomNode - stores the layer dom element for the hint shape

		/**
		 * dojo lifecycle methods
		 */
		postCreate: function() {
			// summary: widget lifecycle postCreate handler
			// description:
			//		Determines the position of the widget's dom element and creates a hint layer element
			//		containing the description text. Event handlers for showing and hiding the hint
			//		are connected as well.
			var elementPosition = new epages.html.Element(this.domNode).getAbsolutePosition(dojo.body());
			this._formDescriptionLayer = document.createElement("div");
			var layerShadow = document.createElement("div");
			layerShadow.className = "TooltipShadow";

			with(this._formDescriptionLayer) {
				innerHTML = this.description;
				className = "Tooltip HideElement Wide";
				onselectstart = function() {
					return false;
				};
				style.MozUserSelect = "none";
				style.WebkitUserSelect = "ignore";
				style.left = (elementPosition.x + this.domNode.offsetWidth + 2) + "px";
				style.top = elementPosition.y + "px";
				appendChild(layerShadow);
			}
			dojo.style(this._formDescriptionLayer, "opacity", 0);

			dojo.body().appendChild(this._formDescriptionLayer);

			this.connect(this.domNode, "onfocus", "_showDescription");
			this.connect(this.domNode, "onblur",  "_hideDescription");

		},

		/**
		 * private methods
		 */
		_showDescription: function() {
			// summary: Show hint with the description text
			// description:
			//		Fade-turn the description layer visible
			var layer = this._formDescriptionLayer;
			layer.className = layer.className.replace(/HideElement/, "");
			if(layer.offsetWidth > 300) {
				layer.style.width = "300px";
			}
			dojo.fadeIn({node: layer, duration:200}).play();
		},

		_hideDescription: function() {
			// summary: Hide hint with the description text
			// description:
			//		Fade-turn the description layer invisible
			var layer = this._formDescriptionLayer;
			dojo.fadeOut({
				node: layer,
				duration:200
			}).play();
			setTimeout(function() {
				layer.className += " HideElement";
			}, 200);
		}
	}
);

}


dojo.i18n._preloadLocalizations("epages.nls.ep_sf", ["ROOT","ca","da","de","en","es","fi","fr","it","nl","no","pt","ro","ru","sv","xx"]);
